#pragma GCC optimize("O3")
#pragma GCC target("avx,avx2,sse4,sse4.1,sse4.2")

#include <bits/extc++.h>
using namespace std;
using namespace __gnu_cxx;
using namespace __gnu_pbds;

#define fast ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define sfor(i, l, r) for (int i = l; i <= r; ++i)
#define bfor(i, r, l) for (int i = r; i >= l; --i)
#define all(a) a.begin(), a.end()
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using vi = vector<int>;
using oset = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

const int R = (1 << 19), INF = 1e9 + 10;

struct Node {
    int mn = INF, dec = 0;
};

vector<Node> t(R * 2);

void Push(int v) {
    if (t[v].dec != 0) {
        t[v * 2].mn -= t[v].dec;
        t[v * 2].dec += t[v].dec;
        t[v * 2 + 1].mn -= t[v].dec;
        t[v * 2 + 1].dec += t[v].dec;
        t[v].dec = 0;
    }
}

void Set(int i, int x, int v = 1, int l = 0, int r = R) {
    if (r - l == 1) {
        t[v].mn = x;
        return;
    }
    Push(v);
    int m = (l + r) / 2;
    if (i < m)
        Set(i, x, v * 2, l, m);
    else
        Set(i, x, v * 2 + 1, m, r);
    t[v].mn = min(t[v * 2].mn, t[v * 2 + 1].mn);
}

void Dec(int dl, int dr, int x, int v = 1, int l = 0, int r = R) {
    if (dl >= r || l >= dr)
        return;
    if (dl <= l && r <= dr) {
        t[v].mn -= x;
        t[v].dec += x;
        return;
    }
    Push(v);
    int m = (l + r) / 2;
    Dec(dl, dr, x, v * 2, l, m);
    Dec(dl, dr, x, v * 2 + 1, m, r);
    t[v].mn = min(t[v * 2].mn, t[v * 2 + 1].mn);
}

int Find(int v = 1, int l = 0, int r = R) {
    if (r - l == 1)
        return l;
    Push(v);
    int m = (l + r) / 2;
    if (t[v * 2].mn == 0)
        return Find(v * 2, l, m);
    else
        return Find(v * 2 + 1, m, r);
}

vector<vi> gr;
vi up, bup, h;

void Dfs(int u = 0, int x = 0) {
    h[u] = x;
    for (int v: gr[u])
        Dfs(v, x + 1);
}

void BuildUp(int m) {
    sfor(i, 0, m - 1) {
        if (h[up[i]] - h[bup[up[i]]] == h[bup[up[i]]] - h[bup[bup[up[i]]]])
            bup[i] = bup[bup[up[i]]];
        else
            bup[i] = up[i];
    }
}

int Lca(int u, int v) {
    if (h[u] > h[v])
        swap(u, v);
    while (h[v] > h[u]) {
        if (h[bup[v]] >= h[u])
            v = bup[v];
        else
            v = up[v];
    }
    if (u == v)
        return u;
    while (up[u] != up[v]) {
        if (bup[u] != bup[v]) {
            u = bup[u];
            v = bup[v];
        }
        else {
            u = up[u];
            v = up[v];
        }
    }
    return up[u];
}

vi ft;

void Add(int i, int x) {
    for (int j = i; j < (int)ft.size(); j |= j + 1)
        ft[j] += x;
}

int Sum(int i) {
    int res = 0;
    for (int j = i; j >= 0; j = (j & (j + 1)) - 1)
        res += ft[j];
    return res;
}

int main() {
    fast;
    int n;
    cin >> n;
    ft.assign(n, 0);
    vi a(n), aa(n);
    vector<pii> r(n);
    vector<pii> g;
    vector<vi> l(n + 1);
    sfor(i, 0, n - 1) {
        cin >> a[i];
        aa[a[i] - 1] = i;
    }
    int cx = 0;
    for (int i: aa) {
        g.emplace_back(cx, cx - Sum(i));
        r[i] = g.back();
        Add(i, 1);
        ++cx;
    }
    int q;
    cin >> q;
    vector<pii> a1(q), a2(q);
    sfor(i, 0, q - 1) {
        cin >> a1[i].first >> a1[i].second >> a2[i].first >> a2[i].second;
        g.push_back(a1[i]);
        g.push_back(a2[i]);
    }
    stable_sort(all(g));
    int m = unique(all(g)) - g.begin();
    while (g.size() > m)
        g.pop_back();
    up.resize(m);
    bup.resize(m);
    up[0] = bup[0] = 0;
    gr.resize(m);
    h.resize(m);
    for (auto [x, y]: g)
        l[x].push_back(y);
    sfor(i, 1, n) {
        if (!l[i].empty())
            Set(i, i - l[i].back());
    }
    int p = 0;
    while (t[1].mn == 0) {
        int i = Find(), x = l[i].back(), np = lower_bound(all(g), make_pair(i, l[i].back())) - g.begin();
        up[np] = p;
        gr[p].push_back(np);
        p = np;
        l[i].pop_back();
        if (!l[i].empty())
            Set(i, x - l[i].back());
        else
            Set(i, INF);
    }
    sfor(i, 0, n - 1) {
        p = lower_bound(all(g), r[i]) - g.begin();
        Dec(a[i], n + 1, 1);
        while (t[1].mn == 0) {
            int j = Find(), x = l[j].back(), np = lower_bound(all(g), make_pair(j, l[j].back())) - g.begin();
            up[np] = p;
            gr[p].push_back(np);
            p = np;
            l[j].pop_back();
            if (!l[j].empty())
                Set(j, x - l[j].back());
            else
                Set(j, INF);
        }
    }
    Dfs();
    BuildUp(m);
    sfor(i, 0, q - 1) {
        int u = lower_bound(all(g), a1[i]) - g.begin(), v = lower_bound(all(g), a2[i]) - g.begin(), lca = Lca(u, v);
        cout << g[lca].first << ' ' << g[lca].second << '\n';
    }
}
