#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
using ll = long long;

struct point {
    ll x, y;

    point() {}
    
    point(ll x_, ll y_): x(x_), y(y_) {}

    bool operator<(point pt) const {
        return x < pt.x || (x == pt.x && y < pt.y);
    }
};

const int MAXN = 1e5 + 123;
point pt[MAXN];

ll solve_1(int n, ll w, ll h) {
    sort(pt, pt + n);
    ll len = 0;
    ll px = 0;
    ll ans = 0;
    for (int i = 0; i < n; ++i) {
        ans += (pt[i].x - px) * len;
        len = max(len, h - pt[i].y);
        px = pt[i].x;
    }
    return ans + (w - px) * len;
}

signed main() {
    int k;
    cin >> k;
    vector<int> v(k);
    for (int i = 0; i < k; ++i)
        cin >> v[i];
    int t;
    cin >> t;
    while (t--) {
        int n;
        ll w, h;
        cin >> n >> w >> h;
        for (int i = 0; i < n; ++i)
            cin >> pt[i].x >> pt[i].y;
        if (k == 1) {
            cout << solve_1(n, w, h) << '\n';
        }
    }

}
