#ifdef DEBUG
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>

#ifndef DEBUG
#define assert(...) (static_cast<bool>(__VA_ARGS__) ? (void)0 : abort());
#endif

using namespace std;

using ll = long long;
using vi = vector<ll>;
using ii = pair<ll, ll>;
using vii = vector<ii>;
using vvi = vector<vi>;
using vvii = vector<vii>;
using vsi = vector<set<ll>>;
using vc = vector<char>;
using vvc = vector<vc>;
using vb = vector<bool>;
using vvb = vector<vb>;

template<class T, class Y>
istream &operator>>(istream &s, pair<T, Y> &p) {
  return s >> p.first >> p.second;
}

template<class T>
istream &operator>>(istream &s, vector<T> &v) {
  for (auto &e : v) s >> e;
  return s;
}

template<class T>
ostream &operator<<(ostream &s, const vector<T> &v) {
  for (const auto &e : v) s << e << ' ';
  return s;
}

void solve();

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  cout.setf(ios::fixed);
  cout.precision(30);

  ll t = 1;
  cin >> t;
  while (t--)
    solve();
}

// ------------

vi p;
vvi gr;

struct data_t {
  ll mincost{}, mincnt{};
  set<tuple<ll, ll, ll>> prices{}; // cost, node, cnt;
};

vi c;
vii lr;
vi ans;

vector<data_t> result;
bool impossible = false;

void dfs(ll v) {
  data_t d{};

  for (auto u : gr[v]) {
    dfs(u);
    if (impossible) return;
    d.mincost += result[u].mincost;
    d.mincnt += result[u].mincnt;
    d.prices.insert(result[u].prices.begin(), result[u].prices.end());
  }

  if (d.mincnt > lr[v].second) {
    impossible = true;
    return;
  }

  d.prices.insert({c[v], v, 1e10});

  while (d.mincnt < lr[v].first and not d.prices.empty()) {
    auto[cost, node, count] = *d.prices.begin();
    d.prices.erase(d.prices.begin());
    if (d.mincnt + count <= lr[v].first) {
      d.mincnt += count;
      d.mincost += cost * count;
      ans[node] += count;
      count = 0;
    } else {
      ll diff = lr[v].first - d.mincnt;
      d.mincnt += diff;
      d.mincost += cost * diff;
      count -= diff;
      ans[node] += diff;
    }
    if (count > 0) {
      d.prices.insert({cost, node, count});
    }
  }

  assert(not d.prices.empty());

  ll maxcnt = lr[v].second - d.mincnt;
  data_t data2;
  while (maxcnt > 0 and not d.prices.empty()) {
    auto[cost, node, count] = *d.prices.begin();
    d.prices.erase(d.prices.begin());
    if (count <= maxcnt) {
      data2.prices.insert({cost, node, count});
      maxcnt -= count;
    } else {
      data2.prices.insert({cost, node, maxcnt});
      maxcnt = 0;
    }
  }
  d.prices = move(data2.prices);

  result[v] = d;
}

void solve() {
  ll n;
  cin >> n;
  p.clear();
  gr.clear();
  p.resize(n);
  gr.resize(n);
  for (int i = 1; i < n; ++i) {
    ll x;
    cin >> x;
    --x;
    p[i] = x;
    gr[x].push_back(i);
  }

  c.clear();
  lr.clear();
  c.resize(n);
  lr.resize(n);
  cin >> c;
  cin >> lr;

  result.clear();
  result.resize(n);

  ans.clear();
  ans.resize(n);

  impossible = false;

  dfs(0);

  if (impossible) {
    cout << -1 << endl;
    return;
  }

  cout << result[0].mincost << endl;
  cout << ans << endl;
}

/*

1
5
1 1 2 3
5 4 3 2 1
5 5
2 2
2 2
1 100
1 10000

*/