#ifdef DEBUG
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>

#ifndef DEBUG
#define assert(...) (static_cast<bool>(__VA_ARGS__) ? (void)0 : abort());
#endif

using namespace std;

using ll = long long;
using vi = vector<ll>;
using ii = pair<ll, ll>;
using vii = vector<ii>;
using vvi = vector<vi>;
using vvii = vector<vii>;
using vsi = vector<set<ll>>;
using vc = vector<char>;
using vvc = vector<vc>;
using vb = vector<bool>;
using vvb = vector<vb>;

template<class T, class Y>
istream &operator>>(istream &s, pair<T, Y> &p) {
  return s >> p.first >> p.second;
}

template<class T>
istream &operator>>(istream &s, vector<T> &v) {
  for (auto &e : v) s >> e;
  return s;
}

template<class T>
ostream &operator<<(ostream &s, const vector<T> &v) {
  for (const auto &e : v) s << e << ' ';
  return s;
}

void solve1();
void solve23();

ll K;
vi PERM;

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  cout.setf(ios::fixed);
  cout.precision(30);

  cin >> K;
  PERM.resize(K);
  cin >> PERM;

  ll test;
  if (PERM == vi{1}) test = 1;
  else if (PERM == vi{1, 2}) test = 23;

  ll t = 1;
  cin >> t;
  while (t--) {
    if (test == 1) solve1();
    else if (test == 23) solve23();
    else abort();
  }
}

// ------------

void solve1() {
  ll n, w, h;
  cin >> n >> w >> h;
  vii pts(n);
  cin >> pts;
  sort(pts.begin(), pts.end());
  ll s = 0;
  ll miny = h;
  for (auto[x, y] : pts) {
    if (y >= miny) continue;
    s += (miny - y) * (w - x);
    miny = y;
  }

  cout << s << endl;
}

void solve23() {
  ll n, w, h;
  cin >> n >> w >> h;
  vii pts(n);
  cin >> pts;
  sort(pts.begin(), pts.end(), [](ii a, ii b) -> bool {
    if (a.second != b.second) return a.second < b.second;
    return a.first < b.first;
  });

  while (pts.size() > 17) pts.pop_back();

  ll ans = 0;

  for (ll mask = 0; mask < (1ll << pts.size()); ++mask) {
    ll x1 = 0, x2 = w;
    ll s = 0;
    for (int i = 0; i < pts.size(); ++i) {
      auto[x, y] = pts[i];
      if ((1ll << i) & mask) {
        // ###...
        if (x <= x1) continue;
        s += (x - x1) * (h - y);
      } else {
        // ...###
        if (x >= x2) continue;
        s += (x2 - x) * (h - y);
      }
    }
    ans = max(ans, s);
  }

  cout << ans << endl;
}