#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <iomanip>
#include <assert.h>
#include <cmath>

using namespace std;

using ll = long long;
using ld = long double;

#define all(x) begin(x), end(x)
#define rall(x) rbegin(x), rend(x)

const int mod = 1e9 + 7;
const int N = 3010;

vector<int> g[N];
ll c[N];
int cnt[N];
int p[N];
int l[N];
int r[N];
ll dp[N];
ll cost[N];
set<pair<ll, int>> s[N];


ll dfs1(int v, int u)
{
	if (v == u)
	{
		return r[v] - dp[v];
	}

	return min(r[v] - dp[v], dfs1(p[v], u));
}

void dfs2(int v, int u, ll x)
{
	dp[v] += x;
	if (v != u)
	{
		dfs2(p[v], u, x);
	}
}

void dfs(int v, int p = -1)
{
	for (auto& u : g[v])
	{
		if (u != p)
		{
			dfs(u, v);
			dp[v] += dp[u];
			cost[v] += cost[u];

			if (s[v].size() < s[u].size())
				s[v].swap(s[u]);

			for (auto& x : s[u])
				s[v].insert(x);

			s[u].clear();
		}
	}

	s[v].insert({ c[v], v });

	//cout << v << '\n';

	while (dp[v] < l[v])
	{
		auto [co, u] = *(s[v].begin());
		auto can = dfs1(u, v);
		if (can <= 0)
		{
			s[v].erase({ co, u });
		}
		else
		{
			can = min(can, l[v] - dp[v]);
			dfs2(u, v, can);
			cost[v] += can * co;
			cnt[u] += can;
		}
	}

}

void solve()
{
	int n;
	cin >> n;

	for (int i = 1; i < n; i++)
	{
		cin >> p[i];
		p[i]--;
		g[p[i]].push_back(i);
		g[i].push_back(p[i]);
	}
	
	for (int i = 0; i < n; i++)
	{
		cin >> c[i];
	}

	for (int i = 0; i < n; i++)
	{
		cin >> l[i] >> r[i];
		dp[i] = 0;
		cnt[i] = 0;
	}

	dfs(0);
	s[0].clear();

	for (int v = 0; v < n; v++)
	{
		g[v].clear();
	}

	for (int v = 0; v < n; v++)
	{
		if (dp[v] < l[v] || dp[v] > r[v])
		{
			cout << "-1\n";
			return;
		}
	}

	cout << cost[0] << '\n';
	for (int v = 0; v < n; v++)
	{
		cout << cnt[v] << " ";
	}
	cout << '\n';
}

signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int t = 1;
	cin >> t;

	while (t--)
	{
		solve();
	}

	return 0;
}
