/*
 * author: WeetHet
 */
#include <bits/stdc++.h>

using namespace std;

#define rep(i, a, b) for (int (i) = (a); (i) < (b); (i)++)
#define all(x) begin(x), end(x)
#define sz(x) (int)size(x)
using ll = long long;
using vi = vector<int>;
using pii = pair<int, int>;

template<typename T, typename U>
bool ckmin(T &a, const U &b) {
    return a > b && (a = b, true);
}

template<typename T, typename U>
bool ckmax(T &a, const U &b) {
    return a < b && (a = b, true);
}

constexpr int N = 1e7;
int n;
vector<vi> g(N);
vi rot(N), p(N), fup(N), h(N);

void build() {
    int x = 0, y = 0;
    rep(i, 0, n) {
        int nx = 0, ny = 0;
        if (rot[i]) {
            nx = x + 1, ny = y;
        } else {
            nx = x + 1, ny = y + 1;
        }

        if (g[n * x + y].empty() || g[n * x + y].back() != (n * nx + ny))
            g[n * x + y].push_back(n * nx + ny), p[n * nx + ny] = n * x + y;
        tie(x, y) = {nx, ny};
    }
}

void add_leaf(int v) {
    h[v] = h[p[v]] + 1;
    if (h[fup[p[v]]] - h[p[v]] == h[fup[fup[p[v]]]] - h[fup[p[v]]]) {
        fup[v] = fup[fup[p[v]]];
    } else {
        fup[v] = p[v];
    }
}

void dfs(int v) {
    for (auto u: g[v]) {
        if (u == p[v]) continue;
        add_leaf(u);
        dfs(u);
    }
}

int la(int v, int k) {
    k = min(k, h[v]);

    while (k > 0) {
        if (h[v] - h[fup[v]] <= k) k -= h[v] - h[fup[v]], v = fup[v];
        else v = p[v], k -= 1;
    }
    return v;
}

int lca(int v, int u) {
    if (h[v] < h[u]) swap(v, u);
    v = la(v, h[v] - h[u]);

    while (v != u) {
        if (fup[v] != fup[u]) {
            v = fup[v], u = fup[u];
        } else {
            v = p[v], u = p[u];
        }
    }
    return (v == u? v: p[v]);
}

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    cin.exceptions(ios::failbit);

    cin >> n;

    build();
    rep(i, 0, n) {
        int a;
        cin >> a;

        rot[a - 1] ^= 1;
        build();
    }
    dfs(0);
//    cerr << la(12, 2) << '\n';

    int q;
    cin >> q;
    while (q--) {
        int x, y, a, b;
        cin >> x >> y >> a >> b;
        int ans = lca(x * n + y, a * n + b);
        cout << ans / n << ' ' << ans % n << '\n';
    }
}