/*
 * author: WeetHet
 */
#include <bits/stdc++.h>
#include <bits/extc++.h>

using namespace std;
using namespace __gnu_pbds;

#define int  ll

#define rep(i, a, b) for (int (i) = (a); (i) < (b); (i)++)
#define all(x) begin(x), end(x)
#define sz(x) (int)size(x)
using ll = long long;
using vi = vector<int>;
using pii = pair<int, int>;
using ordered_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;


template<typename T, typename U>
bool ckmin(T &a, const U &b) {
    return a > b && (a = b, true);
}

template<typename T, typename U>
bool ckmax(T &a, const U &b) {
    return a < b && (a = b, true);
}

struct node {
    int val = 0, cnt = 0, d = 0, l = -1, r = -1;
    int ch[2] = {-1, -1};

    void init(int _l, int _r) {
        l = _l, r = _r, cnt = r - l;
    }
};

constexpr int LIM = 5e6;
vector<node> mem(LIM);
int nxt = 0;

int newNode() {
    mem[nxt] = node{};
    return nxt++;
}

void clearMem() {
    nxt = 0;
}

node& go(node& v, int c) {
    if (v.ch[c] == -1) {
        int mid = v.l + (v.r - v.l) / 2;
        v.ch[c] = newNode();
        mem[v.ch[c]].init(c ? mid : v.l, c ? v.r : mid);
    }
    return mem[v.ch[c]];
}

void apply(node& v, int value) {
    v.val += value;
    if (v.r - v.l > 1) v.d += value;
}

pii unite(node a, node b) {
    if (a.val == b.val) {
        return {a.val, a.cnt + b.cnt};
    }
    if (a.val > b.val) swap(a, b);
    return {a.val, a.cnt};
}

pii unite(pii a, pii b) {
    if (a.first == b.first) {
        return {a.first, a.second + b.second};
    }
    if (a.first > b.first) swap(a, b);
    return a;
}

void push(node& v) {
    if (v.d == 0) return;

    apply(go(v, 0), v.d);
    apply(go(v, 1), v.d);
}

void modify(node& v, int l, int r, int value) {
    push(v);
    if (max(v.l, l) >= min(v.r, r)) return;

    if (l <= v.l && v.r <= r) {
        apply(v, value);
        return;
    }

    modify(go(v, 0), l, r, value);
    modify(go(v, 1), l, r, value);
    tie(v.val, v.cnt) = unite(go(v, 0), go(v, 1));
}

pii query(node& v, int l, int r) {
    push(v);

    if (max(v.l, l) >= min(v.r, r)) return {INT_MAX, 0};

    if (l <= v.l && v.r <= r) {
        return {v.val, v.cnt};
    }

    return unite(query(go(v, 0), l, r), query(go(v, 1), l, r));
}

struct event {
    int x, y1, y2;
    int type;

    bool operator<(const event &rhs) const {
        return tie(x, type, y1, y2) < tie(rhs.x, rhs.type, rhs.y1, rhs.y2);
    }
};

int n, w, h;
set<event> ev;

ll f() {
    clearMem();
    newNode();
    mem[0].init(0, h);

    ll ans = 0;
    int prx = 0;
    for (auto e: ev) {
        pii now = query(mem[0], 0, h);
        ans += 1LL * (h - (now.first == 0? now.second: 0)) * (e.x - prx);

        if (e.type == -1) {
            modify(mem[0], e.y1, e.y2, -1);
        } else {
            modify(mem[0], e.y1, e.y2, 1);
        }
        prx = e.x;
    }
    return ans;
}

vi can;

void solve() {
    ev.clear();
    cin >> n >> w >> h;
    rep(i, 0, n) {
        int x, y;
        cin >> x >> y;
        ev.insert({x, y, h, 1});
        ev.insert({w, y, h, -1});
    }

    cout << f() << '\n';
}

int32_t main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    cin.exceptions(ios::failbit);

    int k;
    cin >> k;
    assert(k == 1);
    rep(i, 0, k) {
        int x;
        cin >> x;
        can.push_back(x);
    }

    int T;
    cin >> T;
    while (T--) solve();
}