#include <iostream>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <set>
#include <map>

using namespace std;
#define int long long
const int MX = 1e10;
vector<int> tree;

int getsum(int x, int v = 1, int l = 0, int r = (int) tree.size() / 4) {
    if (l >= x)
        return 0;
    if (r <= x)
        return tree[v];
    int mid = (l + r) >> 1;
    return getsum(x, v + v, l, mid) + getsum(x, v + v + 1, mid, r);
}

void add(int x, int v = 1, int l = 0, int r = (int) tree.size() / 4) {
    if (l > x || r <= x)
        return;
    tree[v]++;
    if (l + 1 == r)
        return;
    int mid = (l + r) >> 1;
    add(x, v + v, l, mid);
    add(x, v + v + 1, mid, r);
}

signed main() {
    int n;
    cin >> n;
    vector<int> a(n);
    tree.resize(4 * n + 12);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<int> now(n + 1);
    for (int i = 0; i < n; ++i) {
        int sum = getsum(a[i]);
        add(a[i]);
        now[a[i]] = a[i] - sum - 1;
    }
    int q;
    cin >> q;
    while (q--) {
        int r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;
        while (r1 != r2 || c1 != c2) {
            if (r1 > r2) {
                if (c1 > now[r1])
                    c1--;
                r1--;
            } else {
                if (c2 > now[r2])
                    c2--;
                r2--;
            }
        }
        cout << r1 << " " << c1 << endl;
    }
}