#include <iostream>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <set>
#include <map>
#include <cmath>

using namespace std;
#define int long long
const int MX = 1e10;

vector<int> tree2;

void upd(int x, int data, int v = 1, int l = 0, int r = (int) tree2.size() / 4) {
    if (l > x || r <= x)
        return;
    tree2[v] += data;
    if (l + 1 == r)
        return;
    int mid = (l + r) >> 1;
    upd(x, data, v + v, l, mid);
    upd(x, data, v + v + 1, mid, r);
}

int getpos(int x, int v = 1, int l = 0, int r = (int) tree2.size() / 4) {
    if (l + 1 == r)
        return l;
    int mid = (l + r) >> 1;
    if (tree2[v + v] >= x)
        return getpos(x, v + v, l, mid);
    return getpos(x - tree2[v + v], v + v + 1, mid, r);
}

vector<int> tree;

int getsum(int x, int v = 1, int l = 0, int r = (int) tree.size() / 4) {
    if (l >= x)
        return 0;
    if (r <= x)
        return tree[v];
    int mid = (l + r) >> 1;
    return getsum(x, v + v, l, mid) + getsum(x, v + v + 1, mid, r);
}

void add(int x, int v = 1, int l = 0, int r = (int) tree.size() / 4) {
    if (l > x || r <= x)
        return;
    tree[v]++;
    if (l + 1 == r)
        return;
    int mid = (l + r) >> 1;
    add(x, v + v, l, mid);
    add(x, v + v + 1, mid, r);
}

signed main() {
    int n;
    cin >> n;
    vector<int> a(n);
    tree.resize(4 * n + 12);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<int> now(n + 1);
    for (int i = 0; i < n; ++i) {
        int sum = getsum(a[i]);
        add(a[i]);
        now[a[i]] = a[i] - sum - 1;
    }
    int q;
    cin >> q;
    vector<pair<int, int> > zap, zapnew, ans(q);
    vector<vector<int> > rem(n + 1);
    int ind = 0;
    for (int test = 0; test < q; ++test) {
        int r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;
        zap.push_back({r1, c1});
        zap.push_back({r2, c2});
        rem[r1].push_back(ind * 2);
        rem[r2].push_back(ind * 2 + 1);
        ind++;
    }
    zapnew = zap;
    tree2.resize(4 * n + 4);
    for (int i = 0; i < n + 1; ++i)
        upd(i, 1);
    for (int row = n; row >= 0; --row) {
        for (auto u: rem[row]) {
            int x = zap[u].second;
            zapnew[u] = {n, getpos(x + 1)};
        }
        if (row > 0)
            upd(getpos(now[row] + 1), -1);
    }
    for (int test = 0; test < q; test++) {
        int f = test + test, s = test + test + 1;
        int r1 = zapnew[f].first, r2 = zapnew[s].first, c1 = zapnew[f].second, c2 = zapnew[s].second;
        while (r1 != r2 || c1 != c2) {
            if (r1 > r2) {
                if (c1 > now[r1])
                    c1--;
                r1--;
            } else {
                if (c2 > now[r2])
                    c2--;
                r2--;
            }
        }
        if (r1 > zap[f].first)
            ans[test] = zap[f];
        else if (r1 > zap[s].first)
            ans[test] = zap[s];
        else
            ans[test] = {r1, c1};
    }
    for (auto u: ans)
        cout << u.first << " " << u.second << "\n";
}