#include <bits/stdc++.h>
using namespace std;
int n;
vector<vector<int>> g;
vector<bool> a;

void dfsBuild(int r, int c) {
    if (r == n) { return; }
    if ((g[r][c] & (1 << a[r])) == 0) {
        g[r][c] |= (1 << a[r]);
    }
    dfsBuild(r + 1, c + a[r]);
}

vector<vector<int>> tin, tout;
vector<vector<vector<pair<int, int>>>> up;
int LOG, tt = 0;

void dfsLca(int r, int c) {
    //cerr << "r: " << r << ", c: " << c << '\n';
    tin[r][c] = tt; ++tt;
    for (int i = 1; i <= 2; ++i) {
        if ((g[r][c] & i) == 0) { continue; }
        int newr = r + 1, newc = c + i - 1;
        up[newr][newc][0] = {r, c};
        for (int j = 1; j <= LOG; ++j) {
            up[newr][newc][j] = up[up[newr][newc][j - 1].first][up[newr][newc][j - 1].second][j - 1];
        }
        dfsLca(newr, newc);
    }
    tout[r][c] = tt; ++tt;
}

bool isParent(const pair<int, int>& p1, const pair<int, int>& p2) {
    //is v parent of u?
    return tin[p1.first][p1.second] <= tin[p2.first][p2.second] && tout[p1.first][p1.second] >= tout[p2.first][p2.second];
}

pair<int, int> getLca(pair<int, int> p1, pair<int, int> p2) {
    if (isParent(p1, p2)) {
        return p1;
    }
    if (isParent(p2, p1)) {
        return p2;
    }
    for (int j = LOG; j >= 0; --j) {
        if (!isParent(up[p1.first][p1.second][j], p2)) {
            p1 = up[p1.first][p1.second][j];
        }
    }
    return up[p1.first][p1.second][0];
}

void solve() {
    cin >> n;
    g.resize(n + 1, vector<int>(n + 1));
    a.resize(n, true);
    dfsBuild(0, 0);
    for (int i = 0; i < n; ++i) {
        int pos;
        cin >> pos; --pos;
        a[pos] = false;
        dfsBuild(0, 0);
    }
    LOG = 32 - __builtin_clz(n);
    //cerr << LOG << '\n';
    up.resize(n + 1, vector<vector<pair<int, int>>>(n + 1, vector<pair<int, int>>(LOG + 1)));
    tin.resize(n + 1, vector<int>(n + 1));
    tout.resize(n + 1, vector<int>(n + 1));
    dfsLca(0, 0);
    int q;
    cin >> q;
    while (q--) {
        pair<int, int> p1, p2;
        cin >> p1.first >> p1.second >> p2.first >> p2.second;
        pair<int, int> p = getLca(p1, p2);
        cout << p.first << ' ' << p.second << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve();

    return 0;
}
