#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
using ll = long long;

void relax(int i, int j, vector<int> p, vector<vector<ll>>& d) {
    sort(p.begin() + i, p.begin() + j + 1);
    int n = p.size();
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            d[p[j]][p[i]] = d[p[i]][p[j]] = max(d[p[i]][p[j]], 0LL + j - i);
        }
    }
}

void solve() {
    int n;
    cin >> n;
    vector<int> p(n);
    vector<vector<ll>> d(n, vector<ll>(n, 0));
    for (int i = 0; i < n; ++i) {
        cin >> p[i];
        --p[i];
    }
    for (int i = 0; i < n; ++i) {
        for (int j = i; j < n; ++j) {
            relax(i, j, p, d);
        }
    }
    ll ans = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            ans += d[i][j];
        }
    }
    cout << ans << '\n';
}

int main() {
    solve();
    return 0;
}
