#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
using ll = long long;
using vi = vector<int>;

void relax(const vector<int>& p, vector<int>& miny, vector<int>& maxy) {
    vi c;
    c.assign(p.begin(), p.end());
    int n = p.size();
    for (int i = 0, cur; i < n; ++i) {
        cur = i;
        while (0 <= cur - 1 && c[cur - 1] > c[cur]) {
            swap(c[cur], c[cur - 1]);
            --cur;
            miny[c[cur]] = min(miny[c[cur]], cur);
        }
    }
    c.assign(p.begin(), p.end());
    for (int i = n - 1, cur; i >= 0; --i) {
        cur = i;
        while (cur + 1 < n && c[cur] > c[cur + 1]) {
            swap(c[cur], c[cur + 1]);
            ++cur;
            maxy[c[cur]] = max(maxy[c[cur]], cur);
        }
    }
}

void solve() {
    int n;
    cin >> n;
    vector<int> p(n), miny(n, n - 1), maxy(n, 0);
    vector<vector<int>> d(n, vector<int>(n, 0));
    for (int i = 0; i < n; ++i) {
        cin >> p[i];
        --p[i];
        miny[p[i]] = maxy[p[i]] = i;
    }
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            d[j][i] = d[i][j] = j - i;
        }
    }
    relax(p, miny, maxy);
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            d[p[j]][p[i]] = d[p[i]][p[j]] = max(d[p[i]][p[j]], j - miny[p[i]]);
            d[p[j]][p[i]] = d[p[i]][p[j]] = max(d[p[i]][p[j]], maxy[p[j]] - i);
        }
    }
    ll ans = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            ans += d[i][j];
        }
    }
    cout << ans << '\n';
}

int main() {
    solve();
    return 0;
}
