#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
using ll = long long;
using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;

const int MAXR = 7; // todo
const ll INFL = 2e18;

void relax(vl& res, vi& from, const vl& a, const vl& b) {
    for (int i = 0; i <= MAXR; ++i) {
        if (a[i] == INFL) {
            continue;
        }
        for (int j = 0; i + j <= MAXR; ++j) {
            if (b[j] == INFL) {
                continue;
            }
            if (a[i] + b[j] < res[i + j]) {
                res[i + j] = a[i] + b[j];
                from[i + j] = j;
            }
        }
    }
}

void relax2(vl& res, vi& from, const vl& dp, int c) {
    for (int i = 0; i <= MAXR; ++i) {
        for (int j = 0; j + i <= MAXR; ++j) {
            if (res[i + j] > dp[j] + c * 1LL * i) {
                res[i + j] = dp[j] + c * 1LL * i;
                from[i + j] = i;
            }
        }
    }
}

void dfs(int v, vvi& ch, const vi& c, const vi& l, const vi& r, vvvl& dp, vvvi& from) {
    if (ch[v].empty()) {
        for (int i = l[v]; i <= r[v]; ++i) {
            dp[0][v][i] = i * 1LL * c[v];
        }
        return;
    }

    for (int i : ch[v]) {
        dfs(i, ch, c, l, r, dp, from);
    }

    int to = ch[v][0], prev;
    dp[1][to] = dp[0][to];
    for (int i = 0; i <= MAXR; ++i) {
        from[1][to][i] = i;
    }
    for (int i = 1; i < (int)ch[v].size(); ++i) {
        to = ch[v][i];
        prev = ch[v][i - 1];
        relax(dp[1][to], from[1][to], dp[1][prev], dp[0][to]);
    }
    relax2(dp[0][v], from[0][v], dp[1][ch[v].back()], c[v]);
    for (int i = 0; i < l[v]; ++i) {
        dp[0][v][i] = INFL;
    }
    for (int i = r[v] + 1; i <= MAXR; ++i) {
        dp[0][v][i] = INFL;
    }
}

void f(int v, int a, const vvi& ch, const vi& c, vvvl& dp, vvvi& from, vi& b) {
    if (ch[v].empty()) {
        b[v] = a;
        return;
    }

    b[v] = from[0][v][a];
    a -= b[v];
    for (int i = (int)ch[v].size() - 1; i >= 0; --i) {
        int to = ch[v][i];
        f(to, from[1][to][a], ch, c, dp, from, b);
        a -= from[1][to][a];
    }
}

void solve() {
    int n;
    cin >> n;
    vi p(n, -1), c(n), l(n), r(n);
    vvi ch(n);
    vvvl dp(2, vvl(n, vl(MAXR + 1, INFL)));
    vvvi from(2, vvi(n, vi(MAXR + 1, -1)));
    for (int i = 1; i < n; ++i) {
        cin >> p[i];
        --p[i];
        ch[p[i]].push_back(i);
    }
    for (int i = 0; i < n; ++i) {
        cin >> c[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> l[i] >> r[i];
    }
    dfs(0, ch, c, l, r, dp, from);

    auto it = min_element(dp[0][0].begin(), dp[0][0].end());
    ll ans = *it;
    if (ans == INFL) {
        cout << -1 << '\n';
        return;
    }
    cout << ans << '\n';
    vi b(n, -1);
    f(0, it - dp[0][0].begin(), ch, c, dp, from, b);
    for (int i : b) {
        cout << i << ' ';
    }
    cout << '\n';
}

int main() {
    int t;
    cin >> t;
    for (; t; --t) {
        solve();
    }
    return 0;
}
