#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
using ll = long long;
using vi = vector<int>;
using vvi = vector<vi>;
using vl = vector<ll>;
using vvl = vector<vl>;

const ll INFL = 2e18;

ostream& operator<<(ostream& out, const vi& v) {
    for (int i : v) {
        out << i << ' ';
    }
    return out;
}

struct point {
    int x, y;

    point() = default;
    point(int x, int y) : x(x), y(y) {}
    bool operator<(const point& other) const {
        if (x == other.x) {
            return y < other.y;
        }
        return x > other.x;
    }
};

istream& operator>>(istream& in, point& p) {
    in >> p.x >> p.y;
    return in;
}

ostream& operator<<(ostream& out, const point& p) {
    out << p.x << ' ' << p.y;
    return out;
}

ostream& operator<<(ostream& out, const vector<point>& v) {
    for (const point& i : v) {
        out << i << '\n';
    }
    return out;
}

void solve(const int k, const vi& dir) {
    int n, w, h;
    cin >> n >> w >> h;
    vector<point> p(n);
    for (int i = 0; i < n; ++i) {
        cin >> p[i];
    }

    sort(p.begin(), p.end());
    vi miny(n, h);
    miny[n - 1] = p[n - 1].y;
    for (int i = n - 2; i >= 0; --i) {
        miny[i] = min(miny[i + 1], p[i].y);
    }
    int prevx = w;
    ll s = 0;
    for (int i = 0; i < n; ++i) {
        if (p[i].y == miny[i]) {
            s += (prevx - p[i].x) * 1LL * (h - p[i].y);
            prevx = p[i].x;
        }
        while (i + 1 < n && p[i].x == p[i + 1].x) {
            ++i;
        }
    }
    cout << s << '\n';
}

int main() {
    int k;
    cin >> k;
    vector<int> dir(k);
    for (int i = 0; i < k; ++i) {
        cin >> dir[i];
    }
    int t;
    cin >> t;
    for (; t; --t) {
        solve(k, dir);
    }
    return 0;
}
