#include <iostream>
#include <algorithm>

const int maxN = 3010;

int n, p[maxN], ans[maxN + 1][maxN + 1], f[maxN + 1];
long long cur;

void update(int i, int x) {
	for (; i <= maxN; i |= (i + 1))
		f[i] += x;
}

int get(int i) {
	int res = 0;
	for (; i >= 0; i = (i & (i + 1)) - 1)
		res += f[i];
	return res;
}

int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(0);
	std::cout.tie(0);
	std::cin >> n;
	for (int i = 0; i < n; i++)
		std::cin >> p[i];
	for (int i = 2; i <= n; i++)
		for (int j = 1; j < i; j++)
			ans[i][j] = i - j;
	for (int i = 1; i < n; i++) {
		for (int j = 0; j < i; j++) {
			int temp = get(p[j]);
			int i1 = p[i], i2 = p[j];
			if (i1 < i2)
				std::swap(i1, i2);
			ans[i1][i2] = std::max(ans[i1][i2], i - temp);
			update(p[j], 1);
		}
		for (int j = 0; j < i; j++)
			update(p[j], -1);
	}
	for (int i = n - 2; i >= 0; i--) {
		for (int j = n - 1; j > i; j--) {
			int temp = j + get(p[j]);
			int i1 = p[i], i2 = p[j];
			if (i1 < i2)
				std::swap(i1, i2);
			ans[i1][i2] = std::max(ans[i1][i2], temp - i);
			update(p[j], 1);
		}
		for (int j = i + 1; j < n; j++)
			update(p[j], -1);
	}
	for (int i = 2; i <= n; i++)
		for (int j = 1; j < i; j++)
			cur += ans[i][j];
	std::cout << cur;
	return 0;
}