#include <iostream>
#include <algorithm>
#include <vector>

const int maxN = 1e5;

struct Point {
	int x, y;
	friend std::istream& operator>>(std::istream& is, Point& p) {
		is >> p.x >> p.y;
		return is;
	}
	bool operator<(const Point& other) const {
		return x < other.x || (x == other.x && y < other.y);
	}
} p[maxN];

int k, t, n, w, h;
long long ans;
std::vector<Point> ch;

int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(0);
	std::cout.tie(0);
	std::cin >> k;
	for (int i = 0; i < k; i++)
		std::cin >> k;
	std::cin >> t;
	while (t--) {
		std::cin >> n >> w >> h;
		for (int i = 0; i < n; i++)
			std::cin >> p[i];
		std::sort(p, p + n);
		ch.clear();
		for (int i = 0; i < n; i++)
			if (ch.empty() || ch.back().y > p[i].y)
				ch.push_back(p[i]);
		n = ch.size();
		ans = 1LL * (w - ch[0].x) * (h - ch[0].y);
		for (int i = 1; i < n; i++)
			ans += 1LL * (w - ch[i].x) * (ch[i - 1].y - ch[i].y);
		std::cout << ans << "\n";
	}
	return 0;
}