#include <iostream>
#include <algorithm>
#include <vector>

const int maxN = 1e5;

struct Point {
	int x, y;
	friend std::istream& operator>>(std::istream& is, Point& p) {
		is >> p.x >> p.y;
		return is;
	}
	bool operator<(const Point& other) const {
		return x < other.x || (x == other.x && y < other.y);
	}
} p[maxN];

int k, t, n, w, h, l, r;
long long ans, cur;
std::vector<Point> ch;

bool cmp(const Point& p1, const Point& p2) {
	return p1.y < p2.y || (p1.y == p2.y && p1.x < p2.x);
}

int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(0);
	std::cout.tie(0);
	std::cin >> k;
	for (int i = k - 1; i >= 0; i--)
		std::cin >> k;
	if (k == 1) {
		std::cin >> t;
		while (t--) {
			std::cin >> n >> w >> h;
			for (int i = 0; i < n; i++)
				std::cin >> p[i];
			std::sort(p, p + n);
			ch.clear();
			for (int i = 0; i < n; i++)
				if (ch.empty() || ch.back().y > p[i].y)
					ch.push_back(p[i]);
			n = ch.size();
			ans = 1LL * (w - ch[0].x) * (h - ch[0].y);
			for (int i = 1; i < n; i++)
				ans += 1LL * (w - ch[i].x) * (ch[i - 1].y - ch[i].y);
			std::cout << ans << "\n";
		}
	}
	else {
		std::cin >> t;
		while (t--) {
			std::cin >> n >> w >> h;
			for (int i = 0; i < n; i++)
				std::cin >> p[i];
			std::sort(p, p + n, cmp);
			if (n == 1) {
				std::cout << 1LL * std::max(p[0].x, w - p[0].x) * (h - p[0].y) << "\n";
				continue;
			}
			l = ans = cur = 0;
			r = w;
			for (int i = 0; i + 1 < n; i++)
				if (p[i].y == p[i + 1].y || p[i].x <= l || r <= p[i].x) {
					ans = std::max(ans, cur + 1LL * (r - l) * (h - p[i].y));
					break;
				}
				else if (r - p[i].x == p[i].x - l) {
					ans = std::max(ans, cur + 1LL * (r - l) * (h - p[i + 1].y) + 1LL * (r - p[i].x) * (p[i + 1].y - p[i].y));
					break;
				}
				else if (r - p[i].x > p[i].x - l) {
					if (p[i + 1].x >= p[i].x) {
						ans = std::max(ans, cur + 1LL * (r - l) * (h - p[i + 1].y) + 1LL * (r - p[i].x) * (p[i + 1].y - p[i].y));
						break;
					}
					ans = std::max(ans, cur + 1LL * (r - l) * (h - p[i + 1].y) + 1LL * (p[i].x - l) * (p[i + 1].y - p[i].y));
					cur += 1LL * (r - p[i].x) * (h - p[i].y);
					r = p[i].x;
				}
				else {
					if (p[i + 1].x <= p[i].x) {
						ans = std::max(ans, cur + 1LL * (r - l) * (h - p[i + 1].y) + 1LL * (p[i].x - l) * (p[i + 1].y - p[i].y));
						break;
					}
					ans = std::max(ans, cur + 1LL * (r - l) * (h - p[i + 1].y) + 1LL * (r - p[i].x) * (p[i + 1].y - p[i].y));
					cur += 1LL * (p[i].x - l) * (h - p[i].y);
					l = p[i].x;
				}
			std::cout << ans << "\n";
		}
	}
	return 0;
}