#include <bits/stdc++.h>

#define int uint16_t

using namespace std;

template<typename T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &i: a) {
        is >> i;
    }
    return is;
}

template<typename T>
ostream &operator<<(ostream &is, vector<T> &a) {
    for (auto &i: a) {
        is << i << ' ';
    }
    return is;
}

const int N = 3001;
const int lg = 25;


set<pair<int, int>> g[N][N];
pair<int, int> up[N][N][lg];
vector<vector<int32_t>> tin, tout;

int32_t ti;


void dfs(int vr, int vc, int pr, int pc) {
    tin[vr][vc] = ti++;
    for (auto[ur, uc]: g[vr][vc]) {
        if (ur == pr && uc == pc) {
            continue;
        } else {
            up[ur][uc][0] = {vr, vc};
            dfs(ur, uc, vr, vc);
        }
    }
    tout[vr][vc] = ti++;
}

bool is_parent(int vr, int vc, int ur, int uc) {
    if (tin[vr][vc] <= tin[ur][uc] && tout[ur][uc] <= tout[vr][vc]) {
        return true;
    }
    return false;
}

pair<int, int> lca(int vr, int vc, int ur, int uc) {
    if (is_parent(vr, vc, ur, uc)) {
        return {vr, vc};
    }
    if (is_parent(ur, uc, vr, vc)) {
        return {ur, uc};
    }
    for (int16_t i = lg - 1; i >= 0; --i) {
        auto val = up[vr][vc][i];
        if (!is_parent(val.first, val.second, ur, uc)) {
            vr = val.first;
            vc = val.second;
        }
    }
    return up[vr][vc][0];
}

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    cin >> a;
    if (n < 2500){
        tin.resize(n + 1);
        tout.resize(n + 1);
//    g.resize(n + 1);
//    up.resize(n + 1);
//
        for (int i = 0; i < n + 1; ++i) {
//        g[i].resize(i + 1);
//        up[i].resize(i + 1, vector<pair<int, int>>(lg));
            tin[i].resize(i + 1);
            tout[i].resize(i + 1);
        }
    }

    vector<int> l(n);
    int r = 0, c = 0;
    for (int i = 0; i < n; ++i) {
        if (l[i]) {
            g[r][c].insert({r + 1, c});
            g[r + 1][c].insert({r, c});
            r++;
        } else {
            g[r][c].insert({r + 1, c + 1});
            g[r + 1][c + 1].insert({r, c});
            r++;
            c++;
        }
    }
    for (int j = 0; j < n; ++j) {
        r = 0, c = 0;
        l[a[j] - 1] = 1;
        for (int i = 0; i < n; ++i) {
            if (l[i]) {
                g[r][c].insert({r + 1, c});
                g[r + 1][c].insert({r, c});
                r++;
            } else {
                g[r][c].insert({r + 1, c + 1});
                g[r + 1][c + 1].insert({r, c});
                r++;
                c++;
            }
        }
    }


    dfs(0, 0, 0, 0);
    for (int i = 1; i < lg; ++i) {
        for (int j = 0; j < n + 1; ++j) {
            for (int k = 0; k <= j; ++k) {
                up[j][k][i] = up[up[j][k][i - 1].first][up[j][k][i - 1].second][i - 1];
            }
        }
    }

    int q;
    cin >> q;
    while (q--) {
        int vr, vc, ur, uc;
        cin >> vr >> vc;
        cin >> ur >> uc;
        auto ans = lca(vr, vc, ur, uc);
        cout << ans.first << ' ' << ans.second << '\n';
    }
}

int32_t main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(false);
    cout.setf(ios::fixed);
    cout.precision(10);

    solve();
    return 0;
}
