#include <bits/stdc++.h>
#define int long long
using namespace std;

struct segtree {
    int size = 1;
    struct node{
        int val = 0;
        int add = 0;
    };
    vector<node> tree;

    void push(int x){
        tree[x * 2 + 1].add += tree[x].add;
        tree[x * 2 + 2].add += tree[x].add;
        tree[x * 2 + 1].val += tree[x].add;
        tree[x * 2 + 2].val += tree[x].add;
        tree[x].add = 0;
    }

    segtree(int n) {
        while (size < n) size *= 2;
        tree.resize(size * 2 - 1);
    }
    segtree() = default;

    void add(int l, int r, int val, int x = 0, int lx = 0, int rx = INT32_MAX) {
        rx = std::min(rx, size);

        if (l <= lx && rx <= r) {
            tree[x].val += val;
            tree[x].add += val;
            return;
        }
        if (l >= rx || lx >= r) {
            return;
        }

        push(x);
        add(l, r, val, x * 2 + 1, lx, (lx + rx) / 2);
        add(l, r, val, x * 2 + 2,(lx + rx) / 2, rx);
        tree[x].val = min(tree[x * 2 + 1].val, tree[x * 2 + 2].val);
    }

    int get_min(int l, int r, int x = 0, int lx = 0, int rx = INT32_MAX) {
        rx = std::min(rx, size);

        if (l <= lx && rx <= r) {
            return tree[x].val;
        }
        if (l >= rx || lx >= r) {
            return INT32_MAX;
        }

        push(x);
        return min(
                get_min(l, r, x * 2 + 1, lx, (lx + rx) / 2),
                get_min(l, r, x * 2 + 2, (lx + rx) / 2, rx)
                );
    }
};


struct solve {
    vector<vector<int>> g;
    vector<int> l, r, c, b, a, p;

    vector<int> sz;
    vector<int> head;
    vector<int> et;
    vector<int> index;
    segtree st;

    void set_sz(int u) {
        sz[u] = 1;
        for (int v : g[u]) {
            set_sz(v);
            sz[u] += sz[v];
        }

        for (int i = 0; i < (int)g[u].size(); i++) {
            int& f = g[u][0];
            int& s = g[u][i];
            if (sz[f] < sz[s]) swap(f, s);
        }
    }

    void set_et(int u) {
        index[u] = (int)et.size();
        et.push_back(u);

        for (int v : g[u]) {
            if (v == g[u].front()) {
                head[v] = head[u];
            }
            else {
                head[v] = v;
            }
            set_et(v);
        }
    }
    void init(int n) {
        sz.resize(n + 1);
        head.resize(n + 1);
        index.resize(n + 1);
        et.reserve(n + 1);
        st = segtree(n + 1);
        head[1] = 1;
        set_et(1);
        set_sz(1);
        for (int u = 1; u <= n; u++) {
            st.add(index[u], index[u] + 1, r[u]);
        }


    }

    int min_path(int u) {
        int res = INT32_MAX;
        while (u) {
            res = min(res, st.get_min(index[head[u]], index[u] + 1));
            u = p[head[u]];
        }
        return res;
    }

    void add_path(int u, int val) {
        while (u) {
            st.add(index[head[u]], index[u] + 1, val);
            u = p[head[u]];
        }
    }

    vector<deque<int>> A;

    bool dfs(int u) {
        if (g[u].empty()) {
            int res = min_path(u);
            if (res < l[u]) {
                return false;
            }
            else {
                A[u].push_back(u);
                b[u] += l[u];
                add_path(u, -l[u]);
                return true;
            }
        }

        A[u].push_back(u);
        for (int v : g[u]) {
            bool res = dfs(v);
            if (!res) return false;
            deque<int> B;
            merge(A[u].begin(), A[u].end(), A[v].begin(), A[v].end(), back_inserter(B), [&](int u, int v){return c[u] < c[v];});
            swap(A[u], B);
        }

        a[u] = r[u] - st.get_min(index[u], index[u] + 1);

        if (a[u] < l[u]) {
            int cnt = l[u] - a[u];

            while (cnt) {
                int v = A[u].front();
                int res = min_path(v);
                if (res == 0) {
                    A[u].pop_front();
                    continue;
                }
                int push = min(res, cnt);
                cnt -= push;
                add_path(v, -push);
                b[v] += push;
            }
        }
        return true;
    }

    solve() {
        int n; cin >> n;
        g.resize(n + 1);
        p.resize(n + 1);
        l.resize(n + 1);
        r.resize(n + 1);
        c.resize(n + 1);
        b.resize(n + 1);
        a.resize(n + 1);
        A.resize(n + 1);

        for (int u = 2; u <= n; u++) {
            int v; cin >> v;
            p[u] = v;
            g[v].push_back(u);
        }

        for (int u = 1; u <= n; u++) {
            cin >> c[u];
        }

        for (int u = 1; u <= n; u++) {
            cin >> l[u] >> r[u];
        }

        init(n);
        bool res = dfs(1);
        if (!res) {
            cout << -1 << "\n";
        }
        else {
            int ans = 0;
            for (int i = 1; i <= n; i++) {
                ans += b[i] * c[i];
            }
            cout << ans << "\n";
            for (int i = 1; i <= n; i++) {
                cout << b[i] << " ";
            }
            cout << "\n";
        }
    }
};

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t; cin >> t;
    while (t--) solve();
    return 0;
}