#include<iostream>
#include<vector>
#include<string>
#include<algorithm>
#include<set>
#include<map>
#include<unordered_map>
#include<cmath>
#include<random>

#define int long long

using namespace std;
const int MAXN = 2e5, inf = 1e18;
bool check;
vector<vector<int>> g;
vector<int> used, c, L, R, eu, tin, tout, tree, add, cnt, sz, pr, near, now;
int N;

void build(int v, int tl, int tr)
{
    if (tl == tr)
    {
        tree[v] = R[eu[tl]];
        return;
    }
    int tm = (tl+tr)/2;
    build(2*v, tl, tm);
    build(2*v+1, tm+1, tr);
    tree[v] = min(tree[2*v], tree[2*v+1]);
}

void push(int v, int tl, int tr)
{
    if (tl == tr)
    {
        tree[v] += add[v];
        add[v] = 0;
        return;
    }
    add[2*v] += add[v];
    add[2*v+1] += add[v];
    tree[v] += add[v];
    add[v] = 0;
}

void update(int v, int l, int r, int val, int tl, int tr)
{
    push(v, tl, tr);
    if (l > tr || r < tl)
    {
        return;
    }
    if (l <= tl && tr <= r)
    {
        add[v] -= val;
        push(v, tl, tr);
        return;
    }
    int tm = (tl+tr)/2;
    update(2*v, l, r, val, tl, tm);
    update(2*v+1, l, r, val, tm+1, tr);
    tree[v] = min(tree[2*v], tree[2*v+1]);
}

int get_min(int v, int l, int r, int tl, int tr)
{
    if (l > tr || r < tl)
    {
        return inf;
    }
    if (l <= tl && tr <= r)
    {
        return tree[v];
    }
    int tm = (tl+tr)/2;
    return min(get_min(2*v, l, r, tl, tm), get_min(2*v+1, l, r, tm+1, tr));
}

int dfs_check(int u)
{
    used[u] = 1;
    int nl = 0;
    bool IsLeaf = true;
    for (auto v : g[u])
    {
        if (!used[v])
        {
            IsLeaf = false;
            nl += dfs_check(v);
        }
    }
    if (!IsLeaf)
    {
        if (nl > R[u])
        {
            check = false;
        }
    }
    return max(nl, L[u]);
}

bool cmp(int a, int b)
{
    return sz[a] > sz[b];
}

int sz_calc(int u)
{
    used[u] = 1;
    sz[u] = 1;
    for (auto v : g[u])
    {
        if (!used[v])
        {
            sz[u] += sz_calc(v);
        }
    }
    return sz[u];
}

void hld_precalc(int u, bool IsRoot)
{
    used[u] = 1;
    sort(g[u].begin(), g[u].end(), cmp);
    if (IsRoot)
    {
        near[u] = u;
    }
    else
    {
        near[u] = near[pr[u]];
    }
    for (int i = 0; i<(int)g[u].size(); ++i)
    {
        if (!used[g[u][i]])
        {
            if (i == 0)
            {
                hld_precalc(g[u][i], false);
            }
            else
            {
                hld_precalc(g[u][i], true);
            }
        }
    }
}

void euler(int u)
{
    used[u] = 1;
    tin[u] = (int)eu.size();
    eu.push_back(u);
    for (auto v : g[u])
    {
        if (!used[v])
        {
            euler(v);
        }
    }
    tout[u] = (int)eu.size();
    eu.push_back(u);
}

int dfs(int u, set<pair<int, int>> &st)
{
    //cout << u << endl;
    used[u] = 1;
    int sum = 0;
    set<pair<int, int>> st2;
    for (auto v : g[u])
    {
        if (!used[v])
        {
            sum += dfs(v, st2);
            for (auto elem : st2)
            {
                st.insert(elem);
            }
            st2.clear();
        }
    }
    st.insert({c[u], u});
    if (sum >= L[u])
    {
        //cout << u << " " << sum << '\n';
        return sum;
    }
    int d = L[u]-sum;
    while (d)
    {
        auto [wt, v] = *st.begin();
        //cout << u << " " << v << endl;
        st.erase(st.begin());
        int k = inf, v2 = v;
        while (v2 != 0)
        {
            k = min(k, now[v2]);
            v2 = pr[v2];
        }
        k = min(k, now[v2]);
        if (k > d)
        {
            cnt[v] += d;
            v2 = v;
            while (v2 != 0)
            {
                now[v2] -= d;
                v2 = pr[v2];
            }
            now[v2] -= d;
            st.insert({wt, v});
            d = 0;
        }
        else
        {
            cnt[v] += k;
            v2 = v;
            while (v2 != 0)
            {
                now[v2] -= k;
                v2 = pr[v2];
            }
            now[v2] -= k;
            d -= k;
        }
    }
    //cout << u << " " << L[u] << '\n';
    return L[u];
}

void solve()
{
    int n;
    cin >> n;
    g.resize(0);
    g.resize(n);
    used.resize(n);
    for (int i = 0; i<n; ++i)
    {
        used[i] = 0;
    }
    c.resize(n);
    L.resize(n);
    R.resize(n);
    tin.resize(n);
    tout.resize(n);
    cnt.resize(n);
    eu.resize(0);
    tree.resize(0);
    add.resize(0);
    sz.resize(n);
    near.resize(n);
    pr.resize(n);
    now.resize(n);
    pr[0] = -1;
    for (int i = 0; i<n; ++i)
    {
        cnt[i] = 0;
    }
    for (int u = 1; u<n; ++u)
    {
        int v;
        cin >> v;
        pr[u] = v-1;
        g[v-1].push_back(u);
    }
    for (int i = 0; i<n; ++i)
    {
        cin >> c[i];
    }
    for (int i = 0; i<n; ++i)
    {
        cin >> L[i] >> R[i];
        now[i] = R[i];
    }
    check = true;
    dfs_check(0);
    if (!check)
    {
        cout << -1 << '\n';
        return;
    }
    for (int i = 0; i<n; ++i)
    {
        used[i] = 0;
    }
    set<pair<int, int>> st;
    dfs(0, st);
    int res = 0;
    for (int i = 0; i<n; ++i)
    {
        res += cnt[i]*c[i];
    }
    cout << res << '\n';
    for (auto elem : cnt)
    {
        cout << elem << " ";
    }
    cout << '\n';
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--)
    {
        solve();
    }
    return 0;
}
