#include<iostream>
#include<vector>
#include<string>
#include<algorithm>
#include<set>
#include<map>
#include<unordered_map>
#include<cmath>
#include<random>

#define int long long

using namespace std;
const int MAXN = 2e5, inf = 1e18;
bool check;
vector<vector<int>> g;
vector<int> used, c, L, R, eu, tin, tout, tree, add, cnt;
int res, N;

void single_update(int v, int pos, int val, int tl, int tr)
{
    if (pos > tr || pos < tl)
    {
        return;
    }
    if (pos == tl && tr == pos)
    {
        tree[v] = val;
        return;
    }
    int tm = (tl+tr)/2;
    single_update(2*v, pos, val, tl, tm);
    single_update(2*v+1, pos, val, tm+1, tr);
}

void upd(int v, int l, int r, int mn, int tl, int tr)
{
    if (l > tr || r < tl)
    {
        return;
    }
    if (l <= tl && tr <= r)
    {
        add[v] = min(add[v], mn);
        return;
    }
    int tm = (tl+tr)/2;
    upd(2*v, l, r, mn, tl, tm);
    upd(2*v+1, l, r, mn, tm+1, tr);
}

pair<int, int> get_val(int v, int pos, int tl, int tr, int mn, int d)
{
    if (pos > tr || pos < tl)
    {
        return {inf, inf};
    }
    mn = min(mn, add[v]);
    if (pos == tl && tr == pos)
    {
        return {tree[v], mn};
    }
    int tm = (tl+tr)/2;
    pair<int, int> val1 = get_val(2*v, pos, tl, tm, mn, d), val2 = get_val(2*v+1, pos, tm+1, tr, mn, d), val;
    if (val1.first == inf)
    {
        val = val2;
    }
    else
    {
        val = val1;
    }
    add[v] = add[v] - min(min(val.first, val.second), d);
    return val;
}

int dfs_check(int u)
{
    tin[u] = (int)eu.size();
    eu.push_back(u);
    used[u] = 1;
    int nl = 0;
    bool IsLeaf = true;
    for (auto v : g[u])
    {
        if (!used[v])
        {
            IsLeaf = false;
            nl += dfs_check(v);
        }
    }
    if (!IsLeaf)
    {
        //cout << u << " " << nl << " " << nr << '\n';
        if (nl > R[u])
        {
            check = false;
        }
    }
    tout[u] = (int)eu.size();
    eu.push_back(u);
    return max(nl, L[u]);
}

int dfs(int u, set<pair<int, int>> &st)
{
    used[u] = 1;
    int sum = 0;
    for (auto v : g[u])
    {
        if (!used[v])
        {
            set<pair<int, int>> st2;
            sum += dfs(v, st2);
            for (auto elem : st2)
            {
                st.insert(elem);
            }
        }
    }
    int d = max((long long)0, L[u]-sum);
    st.insert({c[u], u});
    single_update(1, tin[u], R[u]-sum, 0, N-1);
    upd(1, tin[u], tout[u], R[u]-sum, 0, N-1);
    sum += d;
    while (d)
    {
        auto [wt, v] = *st.begin();
        st.erase(st.begin());
        pair<int, int> val = get_val(1, tin[v], 0, N-1, inf, d);
        if (min(val.first, val.second) > d)
        {
            cnt[v] += d;
            st.insert({wt, v});
            single_update(1, tin[v], min(val.first, val.second)-d, 0, N-1);
            res += wt*d;
            d = 0;
        }
        else
        {
            cnt[v] += min(val.first, val.second);
            d -= min(val.first, val.second);
            res += wt*min(val.first, val.second);
        }
    }
    return sum;
}

void solve()
{
    int n;
    cin >> n;
    g.resize(0);
    g.resize(n);
    used.resize(n);
    for (int i = 0; i<n; ++i)
    {
        used[i] = 0;
    }
    c.resize(n);
    L.resize(n);
    R.resize(n);
    tin.resize(n);
    tout.resize(n);
    cnt.resize(n);
    eu.resize(0);
    for (int i = 0; i<n; ++i)
    {
        cnt[i] = 0;
    }
    for (int u = 1; u<n; ++u)
    {
        int v;
        cin >> v;
        g[u].push_back(v-1);
        g[v-1].push_back(u);
    }
    for (int i = 0; i<n; ++i)
    {
        cin >> c[i];
    }
    for (int i = 0; i<n; ++i)
    {
        cin >> L[i] >> R[i];
    }
    check = true;
    dfs_check(0);
    if (!check)
    {
        cout << -1 << '\n';
        return;
    }
    for (int i = 0; i<n; ++i)
    {
        used[i] = 0;
    }
    N = (int)eu.size();
    tree.resize(0);
    tree.resize(4*N);
    add.resize(0);
    add.resize(4*N, inf);
    res = 0;
    set<pair<int, int>> st;
    dfs(0, st);
    cout << res << '\n';
    for (int i = 0; i<n; ++i)
    {
        cout << cnt[i] << " ";
    }
    cout << '\n';
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--)
    {
        solve();
    }
    return 0;
}
