#include<bits/stdc++.h>

using namespace std;

#define int long long
#define pb push_back
#define ld long double
#define ll __int128

const int N = 1e5 + 10, INF = 1e18;
vector<int> c(N), g[N], l(N), r(N), par(N), used(N), cnt(N), sz(N), tin(N), head(N);
vector<set<pair<int,int>>> st(N);
bool bad = 0;
int ans = 0, cntt = 0, n;

struct SegTree {
    vector<int> t, add;
    void build(int n) {
        t.clear();
        add.clear();
        t.resize(4 * n);
        add.resize(4 * n);
    }
    void inc(int v, int val) {
        t[v] += val;
        add[v] += val;
    }
    void push(int v) {
        inc(v * 2, add[v]);
        inc(v * 2 + 1, add[v]);
        add[v] = 0;
    }
    void update(int v, int tl, int tr, int l, int r, int val) {
        if (l > r) return;
        if (tl == l && tr == r) {
            inc(v, val);
            return;
        }
        push(v);
        int tm = (tl + tr) / 2;
        update(2 * v, tl, tm, l, min(r, tm), val), update(2 * v + 1, tm + 1, tr, max(l, tm + 1), r, val);
        t[v] = min(t[v * 2], t[v * 2 + 1]);
    }
    int get(int v, int tl, int tr, int l, int r) {
        if (l > r) return INF;
        if (tl == l && tr == r) {
            return t[v];
        }
        push(v);
        int tm = (tl + tr) / 2;
        return min(get(2 * v, tl, tm, l, min(r, tm)), get(2 * v + 1, tm + 1, tr, max(l, tm + 1), r));
    }
} t;

int get_val(int v) {
    int mn = INF;
    while (v != -1) {
        mn = min(mn, t.get(1, 0, n - 1, tin[head[v]], tin[v]));
        v = par[head[v]];
    }
    return mn;
}

void add(int v, int val) {
    while (v != -1) {
        t.update(1, 0, n - 1, tin[head[v]], tin[v], -val);
        v = par[head[v]];
    }
}

void zhfs(int v, int p) {
    par[v] = p;
    sz[v] = 1;
    for (auto to : g[v]) {
        if (to != p) {
            zhfs(to, v);
            sz[v] += sz[to];
        }
    }
    sort(g[v].begin(), g[v].end(), [&](int i, int j){return sz[i] > sz[j];});
}

void build(int v, int p) {
    tin[v] = cntt++;
    for (auto to : g[v]) {
        if (to == g[v][0]) {
            head[to] = head[v];
        } else {
            head[to] = to;
        }
        build(to, v);
    }
}

void dfs(int v, int p) {
    int bst = -1;
    for (auto to : g[v]) {
        if (to != p) {
            dfs(to, v);
            if (bst == -1 || st[to].size() > st[bst].size()) {
                bst = to;
            }
        }
    }
    if (bst != -1) {
        swap(st[v], st[bst]);
        for (auto to : g[v]) {
            if (to != p && to != bst) {
                for (auto val : st[to]) {
                    st[v].insert(val);
                }
            }
        }
    }
    st[v].insert({c[v], v});
    int have = r[v] - t.get(1, 0, n - 1, tin[v], tin[v]);
    if (have >= l[v]) return;
    int need = l[v] - have;
    while (need > 0) {
        if (st[v].size() == 0) {
            bad = 1;
            break;
        }
        int vert = st[v].begin()->second;
        int u = vert;
        int mn = get_val(u);
        if (mn < need) {
            u = vert;
            ans += mn * c[u];
            cnt[u] += mn;
            used[u] = 1;
            add(u, mn);
            need -= mn;
            st[v].erase({c[vert], vert});
        } else {
            u = vert;
            cnt[u] += need;
            ans += need * c[u];
            add(u, need);
            need = 0;
        }
    }
}

void solve() {
    cin >> n;
    bad = 0;
    ans = 0;
    t.build(n);
    cntt = 0;
    for (int i = 0; i < n; i++) {
        g[i].clear();
        used[i] = 0;
        cnt[i] = 0;
        st[i].clear();
    }
    for (int i = 1; i < n; i++) {
        int p;
        cin >> p;
        p--;
        g[p].pb(i);
    }
    for (int i = 0; i < n; i++) {
        cin >> c[i];
    }
    vector<int> can(n);
    for (int i = 0; i < n; i++) {
        cin >> l[i] >> r[i];
        can[i] = r[i];
    }
    zhfs(0, -1);
    build(0, -1);
    for (int i = 0; i < n; i++) {
        t.update(1, 0, n - 1, tin[i], tin[i], can[i]);
    }
    dfs(0, -1);
    if (bad) {
        cout << -1 << endl;
        return;
    }
    cout << ans << endl;
    for (int i = 0; i < n; i++) {
        cout << cnt[i] << ' ';
    }
    cout << endl;
}

signed main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
