#include <bits/stdc++.h>
#define int long long

using namespace std;

const int maxn = 1e5;

struct node{
    int d, x;
};

node tt[5 * maxn];

vector <int> euler_path;
int n;

vector <int> g[maxn];
int c[maxn], l[maxn], r[maxn], s[maxn];
int an[maxn], ind[maxn], par[maxn];
int e[maxn], pt[maxn];
set < pair <int, int> > q[maxn];

void build(int i, int tl, int tr) {
    if (tl + 1 == tr) {
        tt[i] = {0, r[euler_path[tl]] - l[euler_path[tl]]};
        return;
    }
    int tm = (tl + tr) / 2;
    build(2 * i + 1, tl, tm);
    build(2 * i + 2, tm, tr);
    tt[i].d = 0;
    tt[i].x = min(tt[2 * i + 1].x, tt[2 * i + 2].x);
}

void push(int i, int tl, int tr) {
    tt[i].x += tt[i].d;
    if (tl + 1 != tr) {
        tt[2 * i + 1].d += tt[i].d;
        tt[2 * i + 2].d += tt[i].d;
    }
    tt[i].d = 0;
}

void update(int i) {
    tt[i].x = min(tt[2 * i + 1].x + tt[2 * i + 1].d, tt[2 * i + 2].x + tt[2 * i + 2].d);
}

void add(int i, int tl, int tr, int ql, int qr, int x) {
    push(i, tl, tr);
    if (tr <= ql || qr <= tl) {
        return;
    }
    if (ql <= tl && tr <= qr) {
        tt[i].d += x;
        return;
    }
    int tm = (tl + tr) / 2;
    add(2 * i + 1, tl, tm, ql, qr, x);
    add(2 * i + 2, tm, tr, ql, qr, x);
    update(i);
}

int get_min(int i, int tl, int tr, int ql, int qr) {
    push(i, tl, tr);
    if (tr <= ql || qr <= tl) {
        return 1e9 + 1;
    }
    if (ql <= tl && tr <= qr) {
        return tt[i].x;
    }
    int tm = (tl + tr) / 2;
    return min(get_min(2 * i + 1, tl, tm, ql, qr), get_min(2 * i + 2, tm, tr, ql, qr));
}

void set_real_lr(int v) {
    int mi = 0; s[v] = 1;
    for (auto u : g[v]) {
        set_real_lr(u);
        mi += l[u];
        s[v] += s[u];
    }
    l[v] = max(mi, l[v]);
}

void create_euler(int v, int p) {
    euler_path.push_back(v);
    pt[v] = p;
    int ma = 0, id = 0;
    for (auto u : g[v]) {
        if (s[u] > ma) {
            ma = s[u];
            id = u;
        }
    }
    if (ma > 0) {
        create_euler(id, p);
    }
    for (auto u : g[v]) {
        if (id != u) {
            create_euler(u, u);
        }
    }
}

void calc(int v) {
    int mas = 1, sl = 0;
    for (auto u : g[v]) {
        calc(u);
        if (q[ind[u]].size() > mas) {
            mas = q[ind[u]].size();
            ind[v] = ind[u];
        }
        sl += l[u];
    }
    if (ind[v] != v) {
        q[ind[v]].insert(*q[v].begin());
    }
    for (auto u : g[v]) {
        if (ind[u] != ind[v]) {
            for (auto el : q[ind[u]]) {
                q[ind[v]].insert(el);
            }
        }
    }
    while (sl < l[v]) {
        int u = (*q[ind[v]].begin()).second;

        if (u == v) {
            an[v] += (l[v] - sl);
            sl = l[v];
            continue;
        }
        int mid = 1e9 + 1, cu = u;
        while (u != v) {
            mid = min(mid, get_min(0, 0, n, max(e[v] + 1, e[pt[u]]), e[u] + 1));
            if (e[v] + 1 > e[pt[u]]) {
                u = v;
            } else {
                u = par[pt[u]];
            }
        }
        if (mid <= l[v] - sl) {
            sl += mid;
            u = cu;
            while (u != v) {
                add(0, 0, n, max(e[v] + 1, e[pt[u]]), e[u] + 1, -mid);
                if (e[v] + 1 > e[pt[u]]) {
                    u = v;
                } else {
                    u = par[pt[u]];
                }
            }
            an[cu] += mid;
            q[ind[v]].erase(q[ind[v]].begin());
        } else {
            u = cu;
            while (u != v) {
                add(0, 0, n, max(e[v] + 1, e[pt[u]]), e[u] + 1, sl - l[v]);
                if (e[v] + 1 > e[pt[u]]) {
                    u = v;
                } else {
                    u = par[pt[u]];
                }
            }
            an[cu] += (l[v] - sl);
            sl = l[v];
        }
    }
}

void solve() {
    cin >> n;
    euler_path.clear();
    for (int i = 0; i < n; ++i) {
        g[i].clear();
        an[i] = 0; ind[i] = i;
        q[i].clear();
    }
    par[0] = -1;
    for (int i = 1; i < n; ++i) {
        int p; cin >> p;
        g[p - 1].push_back(i);
        par[i] = p - 1;
    }
    for (int i = 0; i < n; ++i) {
        cin >> c[i];
        q[i].insert({c[i], i});
    }
    for (int i = 0; i < n; ++i) {
        cin >> l[i] >> r[i];
    }
    set_real_lr(0);
    for (int i = 0; i < n; ++i) {
        if (l[i] > r[i]) {
            cout << -1 << "\n";
            return;
        }
    }
    create_euler(0, 0);
    for (int i = 0; i < n; ++i) {
        e[euler_path[i]] = i;
    }
    build(0, 0, n);
    calc(0);
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        ans += c[i] * an[i];
    }
    cout << ans << "\n";
    for (int i = 0; i < n; ++i) {
        cout << an[i] << ' ';
    }
    cout << "\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    int t; cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
