// A.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <math.h>
#include <set>
#include <tuple>

using namespace std;

#pragma GCC optimize("Ofast,no-stack-protector,tune=native")
#pragma GCC optimize("O2")
#pragma GCC optimize("avx,avx2,sse,see2,sse3,sse3,ssse3")
#pragma GCC optimize("unroll-loops,fast-math,section-anchors")

typedef long long ll;
typedef pair<ll, ll> pii;

#define X first
#define Y second
#define All(t) (t).begin(), (t).end()
#define triple tuple<int, int, int>

vector<vector<int>> tin, tout;
vector<vector<vector<pii>>> gr;
int timer = 0;

void dfs(pii v) {
	tin[v.X][v.Y] = timer++;
	for (auto u : gr[v.X][v.Y]) {
		dfs(u);
	}
	tout[v.X][v.Y] = timer++;
}

bool ancestor(pii a, pii b) {
	return tin[a.X][a.Y] <= tin[b.X][b.Y] && tout[a.X][a.Y] >= tout[b.X][b.Y];
}

void solve() {
	int q, pos, n;
	cin >> n;
	vector<vector<pii>> p(n + 1, vector<pii>(n + 1, {-1, -1}));
	vector<int> go(n, 0);
	gr.assign(n + 1, vector<vector<pii>>(n+1));
	tin.assign(n + 1, vector<int>(n+1));
	tout.assign(n + 1, vector<int>(n + 1));
	int r = 0, c = 0;
	for (auto dir : go) {
		if (dir == 0) {
			if (p[r + 1][c + 1].X == -1)
				p[r + 1][c + 1] = { r, c };
			r++, c++;
		}
		else {
			if (p[r + 1][c].X == -1)
				p[r + 1][c] = { r, c };
			r++;
		}
	}
	for (int i = 0; i < n; i++) {
		cin >> pos;
		pos--;
		go[pos] = 1;
		int r = 0, c = 0;
		for (auto dir : go) {
			if (dir == 0) {
				if (p[r + 1][c + 1].X == -1)
					p[r + 1][c + 1] = { r, c };
				r++, c++;
			}
			else {
				if(p[r+1][c].X == -1)
					p[r + 1][c] = { r, c };
				r++;
			}
		}
	}
	for (int r = 0; r <= n; r++) {
		for (int c = 0; c <= r; c++) {
			pii pr = p[r][c];
			if (pr.X == -1) continue;
			gr[pr.X][pr.Y].push_back({ r, c });
		}
	}
	dfs({ 0, 0 });
	int r1, c1, r2, c2;
	cin >> q;
	for (int _ = 0; _ < q; _++) {
		cin >> r1 >> c1 >> r2 >> c2;
		pii v = { r1, c1 };
		pii u = { r2, c2 };
		while (!ancestor(v, u)) {
			v = p[v.X][v.Y];
		}
		cout << v.X << ' ' << v.Y << '\n';
	}
}

signed main()
{
	ios::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);

	solve();
}