#include <iostream>
#include <vector>
#include <algorithm>


using namespace std;
using ll = long long;


struct mst {
    vector<vector<int>> vertices;
    vector<int> arr;
    int arr_size;
    int vertices_size;


    mst(int arr0_size, vector<int> arr0) {
        arr_size = 1;
        vertices_size = 2;
        while (arr0_size > arr_size) {
            arr_size *= 2;
            vertices_size += arr_size;
        }
        arr.resize(arr_size, 0);
        for (int i = 0; i < arr0_size; ++i) {
            arr[i] = arr0[i];
        }
        vertices.resize(vertices_size);
        build(1, 0, arr_size);
    }


    void build(int vertex, int l, int r) {
        if (r -l == 1) {
            vertices[vertex].push_back(arr[l]);
        } else {
            int ext = (r + l) / 2;
            build(vertex * 2, l, ext);
            build(vertex * 2 + 1, ext, r);
            int ind = 0;
            int jnd = 0;
            while (ind < r - ext && jnd < r - ext) {
                if (vertices[vertex * 2][ind] < vertices[vertex * 2 + 1][jnd]) {
                    vertices[vertex].push_back(vertices[vertex * 2][ind]);
                    ++ind;
                } else {
                    vertices[vertex].push_back(vertices[vertex * 2 + 1][jnd]);
                    ++jnd;
                }
            }
            while (ind < r - ext) {
                vertices[vertex].push_back(vertices[vertex * 2][ind]);
                ++ind;
            }
            while (jnd < r - ext) {
                vertices[vertex].push_back(vertices[vertex * 2 + 1][jnd]);
                ++jnd;
            }
        }
    }


    int get(int vertex, int l, int r, int l_now, int r_now, int num, int f) {
        if (r_now <= l || r <= l_now) {
            return 0;
        }
        if (l_now >= l && r_now <= r) {
            if (f < 0) {
                return r_now - l_now - (vertices[vertex].end() - lower_bound(vertices[vertex].begin(), vertices[vertex].end(), num));
            } else {
                return vertices[vertex].end() - upper_bound(vertices[vertex].begin(), vertices[vertex].end(), num);
            }
        }
        int ext = (r_now + l_now) / 2;
        return get(vertex * 2, l, r, l_now, ext, num, f) + get(vertex * 2 + 1, l, r, ext, r_now, num, f);
    }

};


int main() {
    int num_of_p;
    cin >> num_of_p;
    vector<int> p(num_of_p);
    for (int i = 0; i < num_of_p; ++i) {
        cin >> p[i];
    }
    ll ans = 0;
    mst st(num_of_p, p);
    for (int i = 0; i < num_of_p; ++i) {
        for (int j = i + 1; j < num_of_p; ++j) {
            ll ext = max(p[i], p[j]) - min(p[i], p[j]);
            ll more = st.get(1,  0, i, 0, st.arr_size, p[i], 1);
            ll  less = st.get(1,j + 1, num_of_p, 0, st.arr_size, p[j], -1);
            ext = max(ext, max(less, more) + j - i);
            ans += ext;
        }
    }
    cout << ans << "\n";
    return 0;
}
