#include <iostream>
#include <vector>
#include <map>


using namespace std;


int t = 0;


void DFS(pair<int, int> vertex, map<pair<int, int>, vector<pair<int, int>>> &graph, map<pair<int, int>, pair<int, int>> &time) {
    time[vertex].first = t;
    ++t;
    for (auto kid : graph[vertex]) {
        if (time.find(kid) == time.end()) {
            DFS(kid, graph, time);
        }
    }
    time[vertex].second = t;
    ++t;
}


int main() {
    int num_of_levels;
    cin >> num_of_levels;
    vector<int> l(num_of_levels);
    for (int i = 0; i < num_of_levels; ++i) {
        cin >> l[i];
    }
    map<pair<int, int>, vector<pair<int, int>>> graph;
    vector<int> ext(num_of_levels, 1);
    for (int i = 0; i < num_of_levels + 1; ++i) {
        pair<int, int> now = {0, 0};
        for (int j = 0; j < num_of_levels; ++j) {
            graph[now].push_back({now.first + 1, now.second + ext[j]});
            graph[{now.first + 1, now.second + ext[j]}].push_back(now);
            now = {now.first + 1, now.second + ext[j]};
        }
        if (i != num_of_levels) {
            ext[l[i] - 1] = 0;
        }
    }
    map<pair<int, int>, pair<int, int>> time;
    DFS({0, 0}, graph, time);
    int num_of_reqs;
    cin >> num_of_reqs;
    for (int i = 0; i < num_of_reqs; ++i) {
        int l1, r1, l2, r2;
        cin >> l1 >> r1 >> l2 >> r2;
        pair<int, int> ans{-1, -1};
        for (auto kid : graph) {
            if (time[kid.first].first <= time[{l1, r1}].first && time[kid.first].second >= time[{l1, r1}].second && time[kid.first].first <= time[{l2, r2}].first && time[kid.first].second >= time[{l2, r2}].second) {
                if (kid.first.first > ans.first) {
                    ans = kid.first;
                }
            }
        }
        cout << ans.first << " " << ans.second << "\n";
    }
    return 0;
}
