#include <iostream>
#include <vector>
#include <map>


using namespace std;


int t = 0;


void DFS(pair<int, int> vertex, vector<vector<pair<int, int>>> &graph, vector<pair<int, int>> &time, vector<vector<int>> &num) {
    time[num[vertex.first][vertex.second]].first = t;
    ++t;
    for (auto kid : graph[num[vertex.first][vertex.second]]) {
        if (time[num[kid.first][kid.second]].first == -1) {
            DFS(kid, graph, time, num);
        }
    }
    time[num[vertex.first][vertex.second]].second = t;
    ++t;
}


int main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios::sync_with_stdio(false);
    int num_of_levels;
    cin >> num_of_levels;
    vector<int> l(num_of_levels);
    for (int i = 0; i < num_of_levels; ++i) {
        cin >> l[i];
    }
    vector<vector<int>> num(num_of_levels + 1, vector<int> (num_of_levels + 1));
    int c = 0;
    for (int i = 0; i < num_of_levels + 1; ++i) {
        for (int j = 0; j <= i; ++j) {
            num[i][j] = c;
            ++c;
        }
    }
    vector<vector<pair<int, int>>> graph(c);
    vector<int> ext(num_of_levels, 1);
    for (int i = 0; i < num_of_levels + 1; ++i) {
        pair<int, int> now = {0, 0};
        for (int j = 0; j < num_of_levels; ++j) {
            graph[num[now.first][now.second]].push_back({now.first + 1, now.second + ext[j]});
            graph[num[now.first + 1][now.second + ext[j]]].push_back(now);
            now = {now.first + 1, now.second + ext[j]};
        }
        if (i != num_of_levels) {
            ext[l[i] - 1] = 0;
        }
    }
    vector<pair<int, int>> time(c, {-1, -1});
    DFS({0, 0}, graph, time, num);
    int num_of_reqs;
    cin >> num_of_reqs;
    for (int i = 0; i < num_of_reqs; ++i) {
        int l1, r1, l2, r2;
        cin >> l1 >> r1 >> l2 >> r2;
        pair<int, int> ans{-1, -1};
        for (int x = 0; x < num_of_levels + 1; ++x) {
            for (int y = 0; y <= x; ++y) {
                if (time[num[x][y]].first <= time[num[l1][r1]].first && time[num[x][y]].second >= time[num[l1][r1]].second &&
                    time[num[x][y]].first <= time[num[l2][r2]].first && time[num[x][y]].second >= time[num[l2][r2]].second) {
                    if (x > ans.first) {
                        ans = {x, y};
                    }
                }
            }
        }
        cout << ans.first << " " << ans.second << "\n";
    }
    return 0;
}
