#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>

using namespace std;
typedef long long ll;

struct el {
	ll c, cnt;
	int v;
	el() = default;
	el(ll a, int b, ll d) {
		c = a;
		v = b;
		cnt = d;
	}
	bool operator<(el b) const {
		return c < b.c;
	}
};

vector<vector<int>>g;
vector<multiset<el>>els;
vector<ll>c, b, sum, l, r;
bool stop = false;

bool comp(int a, int b) {
	return els[a].size() < els[b].size();
}

ll dfs(int v = 0) {
	ll sumwait = 0;
	for (auto u : g[v]) {
		sumwait += dfs(u);
		sum[v] += sum[u];
		if (stop)
			return -1;
	}
	if (sum[v] > r[v]) {
		stop = true;
		return -1;
	}
	if (g[v].size() > 0) {
		sort(g[v].rbegin(), g[v].rend(), comp);
		els[v].swap(els[g[v][0]]);
		for (int i = 1; i < g[v].size(); i++)
			for (auto x : els[g[v][i]])
				els[v].insert(x);
	}
	auto it = els[v].upper_bound(el(c[v], -1, -1));
	while (it != els[v].end())
		sumwait -= it->cnt, it = els[v].erase(it);
	auto it2 = els[v].begin();
	while (it2 != els[v].end() && sum[v] < l[v]) {
		ll can = min(it2->cnt, l[v] - sum[v]);
		sum[v] += can;
		b[it2->v] += can;
		sumwait -= can;
		if (can < it2->cnt) {
			ll c = it2->c, cnt = it2->cnt, V = it2->v;
			els[v].erase(it2);
			els[v].insert(el(c, V, cnt - can));
			break;
		}
		else {
			it2 = els[v].erase(it2);
		}
	}
	if (sum[v] < l[v])
		b[v] += l[v] - sum[v], sum[v] = l[v];
	ll h = r[v] - sum[v];
	if (sumwait < h) {
		ll d = h - sumwait;
		els[v].insert(el(c[v], v, d));
		sumwait += d;
	}
	else {
		while (sumwait > h) {
			auto it3 = --els[v].end();
			el x = *it3;
			ll del = min(sumwait - h, x.cnt);
			els[v].erase(it3);
			sumwait -= del;
			if (x.cnt > del)
				x.cnt -= del, els[v].insert(x);
		}
	}
	return sumwait;
}

void solve(int n) {
	c.resize(n);
	g.resize(n);
	l.resize(n), r.resize(n);
	b.resize(n);
	sum.resize(n);
	els.resize(n);
	for (int i = 1; i < n; i++) {
		int pr; cin >> pr;
		pr--;
		g[pr].push_back(i);
	}
	for (int i = 0; i < n; i++) {
		cin >> c[i];
	}
	for (int i = 0; i < n; i++) {
		cin >> l[i] >> r[i];
	}
	dfs();
	if (stop) {
		cout << "-1\n";
	}
	else {
		ll cost = 0;
		for (int i = 0; i < n; i++)
			cost += b[i] * c[i];
		cout << cost << '\n';
		for (int i = 0; i < n; i++) {
			cout << b[i] << ' ';
		}
		cout << '\n';
	}
	stop = false;
	g.clear();
	c.clear();
	l.clear();
	r.clear();
	b.clear();
	sum.clear();
	els.clear();
}

int main() {
	cin.tie(0);
	ios_base::sync_with_stdio(0);
	int t = 1;
	cin >> t;
	while (t--) {
		int n;
		cin >> n;
		solve(n);
	}
	return 0;
}