#include <bits/stdc++.h>

using namespace std;

const int maxn = 3000 * 3000;
const int inf = 1e9;

struct node {
    int mn, i;
    node(int _mn = 0, int _i = 0) {
        mn = _mn;
        i = _i;
    }
};

node merge(node a, node b) {
    return (a.mn < b.mn ? a : b);
}

vector<node> t;

void build(vector<pair<int, int>> &b, int v, int l, int r) {
    if (l == r - 1) {
        if (l < b.size()) {
            t[v].i = b[l].first;
            t[v].mn = b[l].second;
        } else {
            t[v].mn = inf;
            t[v].i = inf;
        }
        return;
    }
    int m = (l + r) / 2;
    build(b, 2 * v, l, m);
    build(b, 2 * v + 1, m, r);
    t[v] = merge(t[2 * v], t[2 * v + 1]);
}

node get(int tl, int tr, int v, int l, int r) {
    if (tl >= r || l >= tr)
        return {inf, inf};
    if (l >= tl && r <= tr) {
        return t[v];
    }
    int m = (l + r) / 2;
    return merge(get(tl, tr, 2 * v, l, m), get(tl, tr, 2 * v + 1, m, r));
}

int number = 1;
map<pair<int, int>, int> mp;
map<int, pair<int, int>> rev;
vector<vector<int>> gr;

void make_run(vector<int> &v) {
    pair<int, int> p = {0, 0};
    int cur = mp[p];
    int n = v.size();

    for (int i = 0; i < n; ++i) {
        p.first++;
        p.second += v[i];
        if (mp[p] == 0) {
            rev[number] = p;
            mp[p] = number++;
            gr.push_back({});
        }
        gr[cur].push_back(mp[p]);
        cur = mp[p];
    }
}


vector<int> tin;
vector<int> tout;
int timer = 0;
vector<pair<int, int>> order;
void dfs_t(int v) {
    tin[v] = timer++;

    for (auto &x : gr[v]) {
        dfs_t(x);
        order.push_back({v, tin[v]});
    }

    tout[v] = timer++;
    order.push_back({v, tin[v]});
}

bool is_par(int u, int v) {
    return (tin[u] <= tin[v] && tout[u] >= tout[v]);
}


int find(int u, int v, int c = 0) {
    for (auto &x : gr[c]) {
        if (is_par(x, u) && is_par(x, v))
            return find(u, v, x);
    }
    return c;
}

signed main() {
    int n; cin >> n;
    gr.push_back({});
    rev[0] = {0, 0};
    vector<int> a(n);
    for (auto &x : a)
        cin >> x;


    vector<int> add(n, 1);


    make_run(add);

    for (int i = 0; i < n; ++i) {
        add[a[i] - 1] = 0;
        make_run(add);
    }

    for (auto &x : gr) {
        sort(x.begin(), x.end());
        x.resize(unique(x.begin(), x.end()) - x.begin());
    }
    tin.resize(number);
    tout.resize(number);
    dfs_t(0);

    t.resize(4 * order.size());

    build(order, 1, 0, order.size());


//    for (auto &x : mp) {
//        cout << "{ " << x.first.first << ", " << x.first.second << " }: " << x.second << '\n';
//    }

//    for (auto &x : gr) {
//        for (auto &y : x) {
//            cout << y << ' ';
//        }
//        cout << '\n';
//    }

//    for (int i = 0; i < number; ++i) {
//        cout << i << ' ' << tin[i] << ' ' << tout[i] << '\n';
//    }

    vector<int> f(number);
    vector<int> lst(number);

    for (int i = order.size() - 1; i > -1; --i) {
        f[order[i].first] = i;
    }
    for (int i = 0; i < order.size(); ++i) {
        lst[order[i].first] = i;
    }




    int q; cin >> q;
    while (q--) {
        int r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;

        int v = mp[{r1, c1}];
        int u = mp[{r2, c2}];

        int uv = get(min(f[u], f[v]), max(lst[v], lst[u]), 1, 0, order.size()).i;
        cout << rev[uv].first << ' ' << rev[uv].second << '\n';
    }
}