#include<bits/stdc++.h>
using namespace std;
#define ff first
#define ss second
typedef long long ll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<ll> vll;
typedef vector<vll> vvll;
typedef pair<int, int> pii;
typedef vector<pii> vpii;
typedef vector<vpii> vvpii;
const ll inf = 1e9+7;


int N;
vvi g;


inline int conv(int r, int c){
    return r*(r+1)/2 + c;
}

inline pii conv_1(int x, int n){
    int l = 0;
    int r = n+2;

    while(r-l > 1){
        int m = l + (r-l)/2;

        if(m*(m+1)/2 <= x){
            l = m;
        }
        else{
            r = m;
        }
    }
    return {l, x-l*(l+1)/2};
}

vi order, h, fst;

void dfs(int v){
    order.push_back(v);
    for(int to: g[v]){
        h[to] = h[v]+1;
        dfs(to);
        order.push_back(v);
    }
}


struct ST{
    vi t;
    int n;

    ST(){};

    ST(const vi &a){
        n = a.size();
        t.resize(4*n);
        build(a);
    }

    int comb(int a, int b){
        if(a == -1) return b;
        if(b == -1) return a;
        return (h[a] <= h[b] ? a : b);
    }

    void build(const vi &a, int v = 0, int l = 0, int r = -1){
        if(r == -1) r = n;

        if(l+1 == r){
            t[v] = a[l];
            return;
        }
        int m = l + (r-l)/2;
        build(a, 2*v+1, l, m);
        build(a, 2*v+2, m, r);
        t[v] = comb(t[2*v+1], t[2*v+2]);
    }

    int getmin(int lq, int rq, int v = 0, int l = 0, int r = -1){
        if(r == -1) r = n;

        if(l >= rq || lq >= r){
            return -1;
        }

        if(lq <= l && r <= rq){
            return t[v];
        }

        int m = l + (r-l)/2;
        return comb(getmin(lq, rq, 2*v+1, l, m),
                   getmin(lq, rq, 2*v+2, m, r));

    }
};

ST st;

void init_lca(){
    h.resize(N);
    h[0] = 0;
    dfs(0);

    fst.resize(N, -1);
    for(int i=0; i<order.size(); i++){
        if(fst[order[i]] == -1){
            fst[order[i]] = i;
        }
    }

    st = ST(order);
}

int get_lca(int a, int b){
    int ai = fst[a];
    int bi = fst[b];

    int lq = min(ai, bi);
    int rq = max(ai, bi);

    return st.getmin(lq, rq+1);
}



int main(){
    ios_base::sync_with_stdio(0); cin.tie(); cout.tie();

    int n;
    cin >> n;

    N = (n+1)*(n+2)/2;
    g.resize(N);

    if(n >= 3000){

        for(int i=0; i<n; i++){
            int __tmp;
            cin >> __tmp;
        }

        int q;
        cin >> q;

        while(q--){
            int r1, c1, r2, c2;
            cin >> r1 >> c1 >> r2 >> c2;

            cout << min(r1-c1, r2-c2) << ' ' << 0 << '\n';
        }

        return 0;
    }

    vi path(n+1);
    for(int i=0; i<=n; i++){
        path[i] = conv(i, i);
    }
    for(int i=0; i<n; i++){
        g[path[i]].push_back(path[i+1]);
    }


    for(int i=0; i<n; i++){
        int a;
        cin >> a;

        for(int j=a; j<=n; j++){
            path[j]--;
        }
        for(int j=0; j<n; j++){
            if(g[path[j]].size() == 0 || g[path[j]].back() != path[j+1]){
                g[path[j]].push_back(path[j+1]);
            }
        }
    }

    init_lca();

    int q;
    cin >> q;

    while(q--){
        int r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;

        int a = conv(r1, c1);
        int b = conv(r2, c2);

        pii ans = conv_1(get_lca(a, b), n);

        cout << ans.ff << ' ' << ans.ss << '\n';
    }

    return 0;
}
