#include <bits/extc++.h>

using namespace std;
using namespace __gnu_pbds;
#define int long long
const int maxn = 3e5;

struct fenwick {
    int f[maxn];

    int get(int i) {
        int ans = 0;
        while (i >= 0) {
            ans += f[i];
            i = (i & (i + 1)) - 1;
        }
        return ans;
    }

    void upd(int i, int val) {
        while (i < maxn) {
            f[i] += val;
            i = (i | (i + 1));
        }
    }
};

const int inf = 2e9;
fenwick f;
int timer = 0;
int tin[maxn];
int tout[maxn];
int minBuy[maxn];
int maxBuy[maxn];
pair<int, int> bord[maxn], bord0[maxn];
int all;
int sz[maxn];

void dfs0(int v, vector<vector<int>> &g) {
    minBuy[v] = 0;
    for (int u : g[v]) {
        dfs0(u, g);
        minBuy[v] += bord[u].second;
    }
    minBuy[v] = max(0ll, bord[v].first - minBuy[v]);
}

void dfs(int v, vector<vector<int>> &g, int c, int need) {
    need = max(need, bord[v].first);
    c = min(c, bord[v].second);
    maxBuy[v] = min(need, c);
    tin[v] = timer++;
    for (int u : g[v]) {
        dfs(u, g, c, need);
    }
    tout[v] = timer++;
}

void dfs2(int v, vector<vector<int>> &g) {
    for (int u : g[v]) {
        dfs2(u, g);
        sz[v] += sz[u];
    }
}

void solve() {
    int n;
    cin >> n;
    vector<vector<int>> g(n);
    vector<int> par(n, -1);
    for (int i = 1; i < n; ++i) {
        int p;
        cin >> p;
        --p;
        par[i] = p;
        g[p].push_back(i);
    }
    vector<pair<int, int>> f;
    for (int i = 0; i < n; ++i) {
        int c;
        cin >> c;
        f.push_back({ c, i });
    }
    for (int i = 0; i < n; ++i) {
        cin >> bord[i].first >> bord[i].second;
        bord0[i] = bord[i];
    }
    int ans = 0;
    vector<int> answ(n, 0);
    dfs0(0, g);
    all = 0;
    for (int i = 0; i < n; ++i) {
        all += minBuy[i];
    }
    for (int i = 0; i < n; ++i) {
        answ[i] = minBuy[i];
        int v = i;
        int t = answ[i];
        while (v != -1) {
            bord[v].first = max(0ll, bord[v].first - t);
            bord[v].second = max(0ll, bord[v].second - t);
            v = par[v];
        }
    }
    sort(f.begin(), f.end());
    for (auto [x, v]: f) {
        dfs(0, g, inf, 0);
        answ[v] += maxBuy[v];
        ans += x * maxBuy[v];
        int t = maxBuy[v];
        while (v != -1) {
            bord[v].first = max(0ll, bord[v].first - t);
            bord[v].second = max(0ll, bord[v].second - t);
            v = par[v];
        }
    }
    for (int i = 0; i < n; ++i) {
        sz[i] = answ[i];
    }
    dfs2(0, g);
    for (int i = 0; i < n; ++i) {
        if (sz[i] < bord0[i].first || sz[i] > bord0[i].second) {
            cout << -1 << '\n';
            return;
        }
    }
    cout << ans << '\n';
    for (int i : answ) {
        cout << i << ' ';
    }
    cout << '\n';
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}
/*
 * 1
3
1 1
3 1 2
5 7
 1 2
2 4
 */