#include <bits/extc++.h>

using namespace std;
using namespace __gnu_pbds;

const int maxc = 3e7;

const int maxn = 5e5 + 10;
int ls[maxc];
int rs[maxc];
int sum[maxc];
const int inf = 1e9;
int id = 1;
vector<int> roots;

int newNode(int x) {
    sum[id] = x;
    return id++;
}

int cpy(int v) {
    ls[id] = ls[v];
    rs[id] = rs[v];
    sum[id] = sum[v];
    return id++;
}

void upd(int i, int l, int r, int qi, int val) {
    if (l + 1 == r) {
        sum[i] = val;
        return;
    }
    int m = (l + r) / 2;
    if (qi < m) {
        ls[i] = cpy(ls[i]);
        upd(ls[i], l, m, qi, val);
    } else {
        rs[i] = cpy(rs[i]);
        upd(rs[i], m, r, qi, val);
    }
    sum[i] = sum[ls[i]] + sum[rs[i]];
}

int upd(int v, int n, int qi, int val) {
    v = cpy(v);
    upd(v, 0, n, qi, val);
    return v;
}

int get(int v, int l, int r, int ql, int qr) {
    if (qr <= l || r <= ql) {
        return 0;
    }
    if (ql <= l && r <= qr) {
        return sum[v];
    }
    int m = (l + r) / 2;
    return get(ls[v], l, m, ql, qr) + get(rs[v], m, r, ql, qr);
}

void build(int i, int l, int r) {
    if (l + 1 == r) {
        return;
    }
    int m = (l + r) / 2;
    ls[i] = newNode(m - l);
    rs[i] = newNode(r - m);
    build(ls[i], l, m);
    build(rs[i], m, r);
}

int findFirst(int r, int c, int n) {
    int lb = -1, rb = n;
    while (lb + 1 < rb) {
        int m = (lb + rb) / 2;
        if (get(roots[m], 0, n, 0, r) > c) {
            lb = m;
        } else {
            rb = m;
        }
    }
    return rb;
}

int findLast(int r, int c, int n) {
    int lb = 0, rb = n + 1;
    while (lb + 1 < rb) {
        int m = (lb + rb) / 2;
        if (get(roots[m], 0, n, 0, r) >= c) {
            lb = m;
        } else {
            rb = m;
        }
    }
    return lb;
}

int st[20][maxn];
int logg[maxn];

int get(int l, int r) {
    int ln = logg[r - l + 1];
    return min(st[ln][l], st[ln][r - (1 << ln) + 1]);
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    vector<int> a(n);
    for (int& i : a) {
        cin >> i;
        --i;
    }
    for (int i = 0; i < n; ++i) {
        st[0][i] = a[i];
    }
    logg[1] = 0;
    for (int i = 2; i < maxn; ++i) {
        logg[i] = logg[i / 2] + 1;
    }
    for (int j = 1; j < 20; ++j) {
        for (int i = 0; i + (1 << j) <= n; ++i) {
            st[j][i] = min(st[j - 1][i], st[j - 1][i + (1 << (j - 1))]);
        }
    }
    roots.resize(n + 1);
    roots[0] = newNode(n);
    build(1, 0, n);
    for (int i = 1; i <= n; ++i) {
        roots[i] = upd(roots[i - 1], n, a[i - 1], 0);
    }
    auto dist = [&] (int l, int r) {
        if (l > r) swap(l, r);
        if (l == r) return inf;
        return get(l, r - 1);
    };
    int q;
    cin >> q;
    while (q--) {
        int r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;
        int a = findFirst(r1, c1, n);
        int b = findLast(r1, c1, n);
        int c = findFirst(r2, c2, n);
        int d = findLast(r2, c2, n);
        int ans = max({
           dist(a, c), dist(a, d), dist(b, c), dist(b, d)
        });
        ans = min(ans, min(r1, r2));
        cout << ans << ' ' << get(roots[a], 0, n, 0, ans) << '\n';
    }
}
/*
 * 1
3
1 1
3 1 2
5 7
 1 2
2 4
 */