#include <bits/stdc++.h>
using namespace std;

istream& operator >> (istream& in, vector<int>& a) {
    for (int i = 0; i < a.size(); ++i)
        in >> a[i];
    return in;
}

struct Vertex {
    int v;
    long long  price, l, r;
    long long res, b;
    Vertex():v(-1), price(0), l(0), r(-1), res(0), b(0) {}
};

vector<Vertex> vert;

struct cmp {
    bool operator () (const pair<int, int>& p1, const pair<int, int>& p2) const {
        int i = p1.first, j = p2.first;
        if (vert[i].price != vert[j].price)
            return vert[i].price < vert[j].price;
        if (p1.second != p2.second)
            return p1.second < p2.second;
        return i < j;
    }
};

void merge_(set<pair<int, int>, cmp>& a, set<pair<int, int>, cmp>& b) {
    if (a.size() < b.size())
        swap(a, b);
    while (!b.empty()) {
        a.insert(*b.begin());
        b.erase(b.begin());
    }
}


set<pair<int, int>, cmp> dfs(int v, vector<vector<int>>& g) {
    set<pair<int, int>, cmp> cur;
    long long a = 0;
    for (auto u :g[v]) {
        set<pair<int, int>, cmp> su = dfs(u, g);
        merge_(cur, su);
        a += vert[u].res;
        if (vert[u].b == -1) {
            vert[v].b = -1;
            cur.clear();
            return cur;
        }
    }
    if (a > vert[v].r) {
        vert[v].b = -1;
        cur.clear();
        return cur;
    }
    cur.insert(make_pair(v, vert[v].r));
    while (a < vert[v].l) {
        pair<int, int> p = *cur.begin();
        cur.erase(cur.begin());
        int buy = min((long long)p.second, vert[v].l - a);
        if (buy < p.second) {
            cur.insert(make_pair(p.first, p.second - buy));
        }
        vert[p.first].b += buy;
        a += buy;
    }
    set<pair<int, int>, cmp> ans;
    int left = vert[v].r - a;
    for (pair<int, int> p :cur) {
        if (p.second >= left) {
            ans.insert(make_pair(p.first, left));
            break;
        }
        else {
            ans.insert(p);
            left -= p.second;
        }
    }
    cur.clear();
    vert[v].res = a;
    return ans;
}

int main()
{
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    //freopen("Bin.txt", "r", stdin);
    //freopen("Bout.txt", "w", stdout);
    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        vector<vector<int>> g(n);
        for (int i = 1; i < n; ++i) {
            int p;
            cin >> p;
            g[p - 1].push_back(i);
        }
        vert.clear();
        vert.resize(n);
        for (int i = 0; i < n; ++i) {
            vert[i].v = i;
            cin >> vert[i].price;
        }
        for (int i = 0; i < n; ++i) {
            cin >> vert[i].l >> vert[i].r;
        }
        dfs(0, g);
        long long res = 0;
        vector<long long> b;
        bool f = true;
        for (int i = 0; i < n; ++i) {
            if (vert[i].b == -1) {
                f = false;
                break;
            }
            res += vert[i].price * vert[i].b;
            b.push_back(vert[i].b);
        }
        if (f) {
            cout << res << '\n';
            for (int e :b)
                cout << e << ' ';
            cout << '\n';
        }
        else {
            cout << "-1\n";
        }
    }
}
