#include <iostream>
#include <map>
#include <string>
#include <cmath>
#include <deque>
#include <queue>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

const ll INF = 1e18;
const ld PI = acos(-1);
const ld EPS = 1e-9;
const ll MOD = 1000000000 + 7;

vector<ll> l, r;
vector<vector<ll>> g;
vector<ll> p;
vector<ll> c;
vector<ll> sm;
vector<ll> b;
bool ok = 1;

ll get(ll v, ll to) {
	ll res = r[v]  - sm[v];
	while (v != to) {
		v = p[v];
		res = min(res, r[v] - sm[v]);
	}
	return res;
}

void upd(ll v, ll to, ll x) {
	b[v] += x;
	sm[v] += x;
	while (v != to) {
		v = p[v];
		sm[v] += x;
	}
}

pair<ll, ll> dfs(ll v) {
	pair<ll, ll> mn = { c[v], v };
	for (ll i : g[v]) {
		pair<ll, ll> mnl = dfs(i);
		if (mnl.first < mn.first) mn = mnl;
		sm[v] += sm[i];
	}
	if (sm[v] < l[v]) {
		b[mn.second] += l[v] - sm[v];
		sm[v] = l[v];
	}
	if (sm[v] > r[v] || sm[v] < l[v]) ok = 0;
	return mn;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	ll t;
	cin >> t;
	while (t--) {
		ll n;
		cin >> n;
		l.assign(n + 1, 0);
		r.assign(n + 1, 0);
		g.assign(n + 1, vector<ll>(0));
		c.assign(n + 1, 0);
		sm.assign(n + 1, 0);
		b.assign(n + 1, 0);
		p.assign(n + 1, 0);
		for (ll i = 2; i <= n; i++) {
			cin >> p[i];
			g[p[i]].push_back(i);
		}
		for (ll i = 1; i <= n; i++) cin >> c[i];
		for (ll i = 1; i <= n; i++) cin >> l[i] >> r[i];
		dfs(1);
		if (ok) {
			ll ans = 0;
			vector<ll> ans1(n + 1);
			for (ll i = 1; i <= n; i++) {
				ll x = b[i];
				ans1[i] = x;
				ans += x * c[i];
			}
			cout << ans << "\n";
			for (ll i = 1; i <= n; i++) cout << ans1[i] << " ";
			cout << "\n";
		}
		else {
			cout << "-1\n";
		}
	}
	return 0;
}