#include <iostream>
#include <map>
#include <string>
#include <cmath>
#include <deque>
#include <queue>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

const ll INF = 1e18;
const ld PI = acos(-1);
const ld EPS = 1e-9;
const ll MOD = 1000000000 + 7;

struct Point {
	ll x, y;
	Point() :x(0), y(0) {};
	Point(ll _x, ll _y) : x(_x), y(_y) {};
	Point operator+(const Point& other) const {
		return Point(x + other.x, y + other.y);
	}
	Point operator-() {
		return Point(-x, -y);
	}
	bool operator==(const Point& other) const {
		bool b = (other.x == x && other.y == y);
		return b;
	}
	void print() const {
		cout << x << " " << y;
	}
	void input() {
		cin >> x >> y;
	}
};

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	ll n;
	cin >> n;
	vector<ll> a(n);
	for (ll i = 0; i < n; i++) {
		cin >> a[i];
	}
	ll q;
	cin >> q;
	while (q--) {
		Point a, b;
		a.input();
		b.input();
		if (a.x > b.x) swap(a, b);
		if (a.x - a.y == b.x - b.y) a.print();
		else {
			Point p = Point(min(a.x - a.y, b.x - b.y), 0);
			p.print();
		}
		cout << "\n";
	}
	return 0;
}