#include <bits/stdc++.h>
#define sz(n) (int)n.size()

using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 1e9 + 7;
struct fenwick {
    int n;
    vector<int> t;
    explicit fenwick(int _n) {
        n = _n;
        t.resize(n);
    }
    void upd(int p) {
        for (int i = p; i < n; i |= (i + 1)) {
            t[i]++;
        }
    }
    int get(int p) {
        int ans = 0;
        for (int i = p; i >= 0; i = (i & (i + 1)) - 1) {
            ans += t[i];
        }
        return ans;
    }
};
void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    vector<int> up(n), less(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    fenwick f(n);
    for (int i = 0; i < n; i++) {
        up[i] = i - f.get(a[i] - 1);
        f.upd(a[i]);
    }
    fenwick f2(n);
    for (int i = n - 1; i >= 0; i--) {
        less[i] = f2.get(a[i] - 1);
        f2.upd(a[i]);
    }
    ll ans = 0;
    for (int i = 0; i < n - 1; i++) {
        for (int j = i + 1; j < n; j++) {
            ans += max({abs(a[j] - a[i]), j - i + up[i], j - i + less[j]});
        }
    }
    cout << ans << '\n';
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);cin.tie(nullptr);
#endif
    solve();
    return 0;
}