//
// Created by roi on 26.03.2022.
//

#include <iostream>
#include <vector>
#include <algorithm>
#include <fstream>
#include <set>
#include <cassert>
#include <unordered_set>

using namespace std;
using ll = long long;

#define int long long

const ll INF = 1e17;
const int maxr = 1024;

vector<vector<int>> g;
vector<int> c, l, r, d;
vector<vector<ll>> dp;

void clearr(int v){
    for (int i = 0; i < l[v]; ++i) {
        dp[v][i] = INF;
    }
    for (int i = r[v] + 1; i < maxr; ++i) {
        dp[v][i] = INF;
    }
}

void dfs(int v){
    for (int u : g[v]){
        dfs(u);
    }
    int m = g[v].size();
    vector<int> pointer(m);
    for (int i = 0; i < m; ++i) {
        pointer[i] = l[g[v][i]];
    }
    ll sum_of_pointers = 0;
    for (int i = 0; i < m; ++i) {
        sum_of_pointers += pointer[i];
    }
    for (int i = 0; i < min(sum_of_pointers, maxr); ++i){
        dp[v][i] = INF;
    }
    if (sum_of_pointers > maxr){
        clearr(v);
        return;
    }
    set<pair<ll, int>> st;
    for (int i = 0; i < m; ++i) {
        st.insert({dp[g[v][i]][pointer[i] + 1] - dp[g[v][i]][pointer[i]], i});
    }
    st.insert({c[v], -1});

    for (int i = 0; i < m; ++i) {
        dp[v][sum_of_pointers] += dp[g[v][i]][l[g[v][i]]];
    }
    while (sum_of_pointers < maxr - 1){
        int ind = (*st.begin()).second;
        if (ind == -1){
            dp[v][sum_of_pointers + 1] = dp[v][sum_of_pointers] + c[v];
            sum_of_pointers++;
            continue;
        }
        dp[v][sum_of_pointers + 1] = dp[v][sum_of_pointers] + (*st.begin()).first;
        sum_of_pointers++;
        st.erase(st.begin());
        pointer[ind]++;
        st.insert({dp[g[v][ind]][pointer[ind] + 1] - dp[g[v][ind]][pointer[ind]], ind});
    }
    clearr(v);
}

void get(int v, ll cnt){
    int m = g[v].size();
    vector<int> pointer(m);
    for (int i = 0; i < m; ++i) {
        pointer[i] = l[g[v][i]];
    }
    int sum_of_pointers = 0;
    for (int i = 0; i < m; ++i) {
        sum_of_pointers += pointer[i];
    }
    set<pair<ll, int>> st;
    for (int i = 0; i < m; ++i) {
        st.insert({dp[g[v][i]][pointer[i] + 1] - dp[g[v][i]][pointer[i]], i});
    }
    st.insert({c[v], -1});
    if (sum_of_pointers > maxr){
        return;
    }
    if (sum_of_pointers == cnt){
        d[v] = 0;
        for (int i = 0; i < m; ++i) {
            get(g[v][i], pointer[i]);
        }
        return;
    }
    int cnt_in_me = 0;
    while (sum_of_pointers < maxr - 1){
        int ind = (*st.begin()).second;
        if (ind == -1){
            cnt_in_me++;
        } else {
            st.erase(st.begin());
            pointer[ind]++;
            st.insert({dp[g[v][ind]][pointer[ind] + 1] - dp[g[v][ind]][pointer[ind]], ind});
        }
        sum_of_pointers++;
        if (sum_of_pointers == cnt){
            d[v] = cnt_in_me;
            for (int i = 0; i < m; ++i) {
                get(g[v][i], pointer[i]);
            }
            return;
        }
    }
}

signed main(){
#ifdef LOCAL
    ifstream cin("B.in");
#endif
    int t;
    cin >> t;
    while (t--){
        int n;
        cin >> n;
        g.resize(0);
        g.resize(n);
        for (int i = 0; i < n - 1; ++i) {
            int p;
            cin >> p; --p;
            g[p].push_back(i + 1);
        }
        c.resize(n);
        d.assign(n, 0);
        l.resize(n);
        r.resize(n);
        for (int i = 0; i < n; ++i) {
            cin >> c[i];
        }
        for (int i = 0; i < n; ++i) {
            cin >> l[i] >> r[i];
        }
        dp.assign(n, vector<ll>(maxr, 0));
        dfs(0);
        long long mn = dp[0][l[0]];
        for (int i = l[0]; i <= r[0]; ++i){
            mn = min(dp[0][i], mn);
        }
        if (mn >= INF){
            cout << -1 << endl;
            continue;
        }
        cout << mn << endl;
        int mn_ind = 0;
        for (int i = l[0]; i <= r[0]; ++i) {
            if (dp[0][i] == mn){
                mn_ind = i;
                break;
            }
        }
        get(0, mn_ind);
        long long sum = 0;
        bool f = false;
        for (int i = 0; i < n; ++i) {
            sum += d[i] * c[i];
            if (d[i] < l[i] || d[i] > r[i]){
                f = true;
            }
            cout << d[i] << ' ';
        }
        assert(sum == mn);
        if (sum != mn || f) {
            sum /= (sum - sum);
        }
        cout << endl;
    }

}