//
// Created by roi on 26.03.2022.
//

#include <iostream>
#include <vector>
#include <algorithm>
#include <fstream>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>

using namespace std;
using ll = long long;
const int LOG = 15;
//const int sss = 16777216;
const int sss = 9050000;

int ha(pair<int, int> a = {0, 0}){
    return a.first * 10000 + a.second;
}


unordered_set<int> mp[sss];
int p[sss];

void add(vector<bool> v, int n){
    pair<int, int> now = {0, 0};
    for (int i = 0; i < n; ++i) {
        pair<int, int> nnow = now;
        if (v[i]){
            nnow.first++;
        } else{
            nnow.first++;
            nnow.second++;
        }
        mp[ha(now)].insert(ha(nnow));
        p[ha(nnow)] = ha(now);
        now = nnow;
    }
}

int tin[sss];
int tout[sss];
int h[sss];
int timer = 0;

void dfs(int v, int he){
    tin[v] = timer;
    timer++;
    h[v] = he;
    for (auto u: mp[v]) {
        dfs(u, he + 1);
    }
    tout[v] = timer;
}

bool is_parent(int u, int v){
    // is u a parent of v
    return tin[u] <= tin[v] && tout[v] <= tout[u];
}

int bin_up[sss][LOG];

void prepare(int n){
    vector<pair<int, int>> all_v;
    all_v.reserve((n + 1) * n / 2);
    for (int j = 0; j < n + 1; ++j) {
        for (int i = j; i < n + 1; ++i) {
            all_v.push_back({i, j});
        }
    }
    int m = all_v.size();
    for (int i = 0; i < m; ++i) {
        bin_up[ha(all_v[i])][0] = p[ha(all_v[i])];
    }
    for (int log = 1; log < LOG; ++log) {
        for (int i = 0; i < m; ++i) {
            bin_up[ha(all_v[i])][log] = bin_up[bin_up[ha(all_v[i])][log - 1]][log - 1];
        }
    }
}

int up_h(int v, int x){
    for (int log = LOG - 1; log >= 0; --log){
        if ((1 << log) <= x){
            x -= (1 << log);
            v = bin_up[v][log];
        }
    }
    return v;
}

int lca(int a, int b){
    if (is_parent(a, b)){
        return a;
    }
    if (is_parent(b, a)){
        return b;
    }
    if (h[a] > h[b]){
        swap(a, b);
    }
    b = up_h(b, h[b] - h[a]);
    for (int log = LOG - 1; log >= 0; --log){
        int x = bin_up[a][log];
        int y = bin_up[b][log];
        if (x != y){
            a = x;
            b = y;
        }
    }
    return p[a];
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    ifstream cin("C.in");
#endif
    int n;
    cin >> n;
    int size = (4096) * (4096);
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        a[i]--;
    }
    vector<bool> v(n, false);
    add(v, n);
    for (int i = 0; i < n; ++i) {
        v[a[i]] = true;
        add(v, n);
    }
    dfs(ha({0, 0}), 0);
    prepare(n);
    int q;
    cin >> q;
    for (int i = 0; i < q; ++i) {
        pair<int, int> a;
        pair<int, int> b;
        cin >> a.first >> a.second;
        cin >> b.first >> b.second;
        auto c = lca(ha(a), ha(b));
        cout << c / 10000 << ' ' << c % 10000 << '\n';
    }
}