#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <numeric>
#include <iomanip>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <cassert>

#define endl '\n'
#define int long long
#define float long double

using namespace std;

template<class T> int ckmin(T &a, const T &b) {
  if (b < a) {
    a = b;
    return 1;
  }
  return 0;
}

template<class T> int ckmax(T &a, const T &b) {
  if (b > a) {
    a = b;
    return 1;
  }
  return 0;
}

struct Tree {
  int n;
  vector<pair<int, int>> t;
  Tree();
  Tree(const vector<pair<int, int>> &a);
  pair<int, int> query(int l, int r);
};

Tree::Tree() {}

Tree::Tree(const vector<pair<int, int>> &a) {
  n = (int) a.size();
  t.resize(n << 1);
  for (int i = 0; i < n; ++i) {
    t[n + i] = a[i];
  }
  for (int i = n - 1; i >= 1; --i) {
    t[i] = min(t[i << 1], t[i << 1 | 1]);
  }
}

pair<int, int> Tree::query(int l, int r) {
  pair<int, int> ans((int) 1e18, (int) 1e18);
  for (l += n, r += n; l < r; l >>= 1, r >>= 1) {
    if (l & 1) {
      ckmin(ans, t[l++]);
    }
    if (r & 1) {
      ckmin(ans, t[--r]);
    }
  }
  return ans;
}

void solve() {
  int n;
  cin >> n;
  vector<int> a(n);
  for (int i = 0; i < n; ++i) {
    cin >> a[i];
    --a[i];
  }
  vector<vector<int>> tin(n + 1, vector<int>(n + 1, (int) 1e18));
  vector<vector<int>> tout(n + 1, vector<int>(n + 1));
  int timer = 0;
  for (int i = 0; i <= n; ++i) {
    tin[i][i] = timer++;
  }
  vector<int> b(n, 1);
  vector<pair<int, int>> c;
  for (int i = 0, j = n, k = n; i < n; ++i) {
    for (; j > a[i];) {
      tout[j][k] = timer++;
      --j;
      k -= b[j];
    }
    c.emplace_back(j, k);
    b[a[i]] = 0;
    for (; j < n;) {
      k += b[j];
      ++j;
      tin[j][k] = timer++;
    }
  }
  for (int i = n; i >= 0; --i) {
    tout[i][0] = timer++;
  }
  int m;
  cin >> m;
  for (int i = 0; i < m; ++i) {
    int r1, c1, r2, c2;
    cin >> r1 >> c1 >> r2 >> c2;
    if (tin[r1][c1] > tin[r2][c2]) {
      swap(r1, r2);
      swap(c1, c2);
    }
    pair<int, int> e(-1ll, -1ll);
    if (tin[r1][c1] <= tin[r2][c2] && tout[r2][c2] <= tout[r1][c1]) {
      cout << r1 << " " << c1 << endl;
      continue;
    }
    int cnt = 0;
    int l = n, r = n;
    for (int j = 0; j < n; ++j) {
      cnt += a[j] < r1;
      if (cnt == r1 - c1) {
        ckmin(l, j);
      }
      if (cnt > r1 - c1) {
        ckmin(r, j);
      }
    }
    assert(r != n);
    if (l == n) {
      tie(r1, c1) = c[r];
    } else {
      tie(r1, c1) = max(c[l], c[r]);
    }
    for (const pair<int, int> &f : c) {
      if (tin[f.first][f.second] <= tin[r1][c1] && tout[r1][c1] <= tout[f.first][f.second] && tin[f.first][f.second] <= tin[r2][c2] && tout[r2][c2] <= tout[f.first][f.second]) {
        ckmax(e, f);
      }
    }
    cout << e.first << " " << e.second << endl;
  }
}

int32_t main() {
#ifndef LOCAL
  ios_base::sync_with_stdio(false);
  cout.tie(nullptr);
  cin.tie(nullptr);
#endif
  int t = 1;
  // cin >> t;
  while (t--) {
    solve();
  }
  return 0;
}
