
#pragma GCC optimize("Ofast")


#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <cstdlib>
#include <ctime>
#include <random>
#include <cassert>
#include <array>
#include <string>
#include <set>
#include <map>


using namespace std;


#define ll long long
#define ld long double
#define flt double
#define pb push_back
#define emb emplace_back
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define nlpt nullptr
#define prcs cout << fixed << setprecision(20)


const ll inf = 1e17;


mt19937 rnd(123123);


struct SGT_MN {
	int n;
	vector<ll> t;

	void build(vector<int>& a) {
		n = 1;
		while (n < a.size()) {
			n *= 2;
		}
		t.resize(n + n);
		for (int i = 0; i < a.size(); ++i) {
			t[i + n] = a[i];
		}
		for (int i = n - 1; i > 0; --i) {
			t[i] = min(t[i + i], t[i + i + 1]);
		}
	}


	ll get(int l, int r) {
l += n;
r += n;
ll res = inf;
while (l < r) {
	if (l & 1) {
		res = min(res, t[l]);
		++l;
	}
	if (r & 1) {
		--r;
		res = min(res, t[r]);
	}
	l /= 2;
	r /= 2;
}
return res;
	}
};


struct SGT {
	int n;
	vector<vector<int>> t;


	void build(vector<int>& a) {
		n = 1;
		while (n < a.size()) {
			n *= 2;
		}
		t.resize(n + n);
		for (int i = 0; i < a.size(); ++i) {
			t[i + n].clear();
			t[i + n].push_back(a[i]);
		}
		for (int i = n - 1; i > 0; --i) {
			t[i].resize(t[i + i].size() + t[i + i + 1].size());
			merge(all(t[i + i]), all(t[i + i + 1]), t[i].begin());
		}
	}


	int get_smlr(int l, int r, int x) {
		l += n;
		r += n;
		int res = 0;
		while (l < r) {
			if (l & 1) {
				res += lower_bound(all(t[l]), x) - t[l].begin();
				++l;
			}
			if (r & 1) {
				--r;
				res += lower_bound(all(t[r]), x) - t[r].begin();
			}
			l /= 2;
			r /= 2;
		}
		return res;
	}


	int get_frst(int x, int cnt) {
		if (cnt == 0) {
			return 0;
		}
		int v = 1;
		while (v < n) {
			int c = lower_bound(all(t[v + v]), x) - t[v + v].begin();
			if (c < cnt) {
				cnt -= c;
				v = v + v + 1;
			}
			else {
				v = v + v;
			}
		}
		return v - n + 1;
	}
};




struct node {
	typedef node* pnode;

	int sm = 0;
	pnode l = nlpt;
	pnode r = nlpt;

	void push() {
		if (l == nlpt) {
			l = new node();
		}
		if (r == nlpt) {
			r = new node();
		}
	}

	int lsm() {
		if (l == nlpt) {
			return 0;
		}
		return l->sm;
	}
};

typedef node* pnode;


pnode add(pnode u, int tl, int tr, int i) {
	pnode v = new node(*u);
	v->sm += 1;
	if (tl == tr) {
		return v;
	}
	int tm = (tl + tr) / 2;
	v->push();
	if (i <= tm) {
		v->l = add(v->l, tl, tm, i);
	}
	else {
		v->r = add(v->r, tm + 1, tr, i);
	}
	return v;
}


int get(pnode v, int tl, int tr, int l, int r) {
	if (v == nlpt || tr < l || r < tl) {
		return 0;
	}
	if (l <= tl && tr <= r) {
		return v->sm;
	}
	int tm = (tl + tr) / 2;
	return get(v->l, tl, tm, l, r) + get(v->r, tm + 1, tr, l, r);
}


int get_frst(pnode v, int tl, int tr, int c) {
	if (tl == tr) {
		return tl;
	}
	int lsm = v->lsm();
	int tm = (tl + tr) / 2;
	if (lsm >= c) {
		return get_frst(v->l, tl, tm, c);
	}
	else {
		return get_frst(v->r, tm + 1, tr, c - lsm);
	}
}


int n;
vector<int> a;
SGT sgt;
SGT_MN sgtmn;
vector<pnode> s;


void build_s() {
	s.resize(n + 1);
	pnode rt = new node();
	s[0] = rt;
	vector<int> p(n);
	for (int i = 0; i < n; ++i) {
		p[a[i]] = i;
	}
	for (int i = 0; i < n; ++i) {
		rt = add(rt, 0, n - 1, p[i]);
		s[i + 1] = rt;
	}
}


int get_tm(int r, int c) {
	if (r == c) {
		return 0;
	}
	return get_frst(s[r], 0, n - 1, r - c) + 1;
	return sgt.get_frst(r, r - c);
	int cnt = 0;
	for (int i = 0; i < n; ++i) {
		if (cnt == r - c) {
			return i;
		}
		if (a[i] < r) {
			cnt += 1;
		}
	}
	return n;
}


int get_smlr(int tm, int r) {
	return get(s[r], 0, n - 1, 0, tm - 1);
}


int32_t main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin >> n;
	a.resize(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		--a[i];
	}
	build_s();
	sgt.build(a);
	sgtmn.build(a);
	int q;
	cin >> q;
	for (int i = 0; i < q; ++i) {
		int r1, c1, r2, c2;
		cin >> r1 >> c1 >> r2 >> c2;
		int tm1 = get_tm(r1, c1);
		int tm2 = get_tm(r2, c2);
		ll ansr = min(r1, r2);
		ansr = min(ansr, sgtmn.get(min(tm1, tm2), max(tm1, tm2)));
		int ansc = ansr - get_smlr(tm1, ansr);//  sgt.get_smlr(0, tm1, ansr);
		cout << ansr << " " << ansc << "\n";
	}
	return 0;
}

/*

3
2 3 1
1
3 3 3 0


*/