#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <cstdlib>
#include <ctime>
#include <random>
#include <cassert>
#include <array>
#include <string>
#include <set>
#include <map>


using namespace std;


#define int long long
#define ll long long
#define ld long double
#define flt double
#define pb push_back
#define emb emplace_back
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define nlpt nullptr
#define prcs cout << fixed << setprecision(20)
#define len(a) (int)(a.size())


mt19937 rnd(123123);


const ll inf = 1e17;


int k;
vector<int> dr;
vector<pair<ll, ll>> a;
int n;
ll w, h;


struct SGT {
	int n;
	vector<pair<ll, int>> t;


	void build(vector<pair<ll, ll>>& a) {
		n = 1;
		while (n < len(a)) {
			n *= 2;
		}
		t.resize(n + n);
		for (int i = 0; i < len(a); ++i) {
			t[i + n] = make_pair(a[i].second, i);
		}
		for (int i = n - 1; i > 0; --i) {
			t[i] = min(t[i + i], t[i + i + 1]);
		}
	}


	pair<ll, int> get(int l, int r) {
		l += n;
		r += n;
		pair<ll, int> res = make_pair(inf, -1);
		while (l < r) {
			if (l & 1) {
				res = min(res, t[l]);
				++l;
			}
			if (r & 1) {
				--r;
				res = min(res, t[r]);
			}
			l /= 2;
			r /= 2;
		}
		return res;
	}
};



SGT sgt;
vector<int> x, y;


ll solve1() {
	sort(all(a));
	vector<pair<ll, ll>> st;
	st.emplace_back(0, h);
	ll sm = 0;
	for (auto [x, y] : a) {
		ll ly = st.back().second;
		if (ly > y) {
			st.push_back(make_pair(x, y));
			sm += (w - x) * (ly - y);
		}
	}
	return sm;
}


ll solve2(int l, int r, ll x1, ll x2, ll y1, ll y2) {
	if (l > r) {
		return 0;
	}
	auto [mny, mni] = sgt.get(l, r + 1);
	if (mny >= y2) {
		return 0;
	}
	ll dx = x[mni];
	int mni1 = min((int)(upper_bound(all(x), dx) - x.begin()), r + 1);
	ll mny1 = min(y2, sgt.get(mni + 1, r + 1).first);
	ll mny2 = min(y2, min(sgt.get(l, mni).first, sgt.get(mni + 1, mni1).first));
	return max(solve2(l, mni - 1, x1, dx, y1, mny1) + (y2 - mny1) * (dx - x1) + (y2 - mny) * (x2 - dx),
		solve2(mni + 1, r, dx, x2, y1, mny2) + (y2 - mny2) * (x2 - dx) + (y2 - mny) * (dx - x1));
}


ll solve2() {
	sort(all(a));
	sgt.build(a);
	x.resize(n);
	y.resize(n);
	for (int i = 0; i < n; ++i) {
		x[i] = a[i].first;
		y[i] = a[i].second;
	}
	return solve2(0, n - 1, 0, w, 0, h);
}


int32_t main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin >> k;
	dr.resize(k);
	for (int i = 0; i < k; ++i) {
		cin >> dr[i];
	}
	int t;
	cin >> t;
	if (dr == vector<int>({ 1 })) {
		while (t--) {
			cin >> n >> w >> h;
			a.resize(n);
			for (int i = 0; i < n; ++i) {
				cin >> a[i].first >> a[i].second;
			}
			cout << solve1() << "\n";
		}
	}
	else if (dr == vector<int>({1, 2})) {
		while (t--) {
			cin >> n >> w >> h;
			a.resize(n);
			for (int i = 0; i < n; ++i) {
				cin >> a[i].first >> a[i].second;
			}
			cout << solve2() << "\n";
		}
	}
	return 0;
}