#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;
using namespace std;

struct Fenwick {
    int n;
    vector <int> tree;

    Fenwick (int n): n(n), tree(n) {}

    void add(int r, int dt) {
        for (; r < n; r |= (r + 1))
            tree[r] += dt;
    }

    int sum(int r) {
        int result = 0;
        for (; r >= 0; r = (r & (r + 1)) - 1)
            result += tree[r];
        return result;
    }

    int sum(int l, int r) {
        return sum(r) - sum(l - 1);
    }
};

void solve() {
    int n;
    cin >> n;

    vector <int> p(n);
    for (int &x: p) cin >> x;

    vector <int> lmao(n);
    Fenwick tree0(n + 1), tree1(n + 1);
    for (int i = 0; i < n; i++) {
        lmao[i] = tree0.sum(p[i] - 1);
        tree0.add(p[i], 1);
    }

    ll answer = 0;
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            int x1 = tree1.sum(p[i] + 1, n);
            int x2 = tree0.sum(p[j] - 1) - lmao[j];
            int x3 = tree0.sum(min(p[i], p[j]) + 1, max(p[i], p[j]) - 1);


            int best = max({
                           j - i + max(x1, x2),
                           x3 + 1
            });

            answer += best;
        }

        tree1.add(p[i], 1);
    }

    cout << answer << '\n';
}

signed main() {
    cin.tie(NULL);
    ios_base::sync_with_stdio(false);

    #ifdef local
    freopen("input.txt", "r", stdin);
    #endif // local

    solve();
}
