#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;
using namespace std;

const int LOGN = 13;

int get_index(int r, int c) {
    return r * (r + 1) / 2 + c;
}

void dfs(vector <vector <bool>> &route, vector <bool> &visited, vector <vector <int>> &jumps, vector <int> &tin, vector <int> &tout, int r, int c, int p, int &t) {
    int index = get_index(r, c);
    if (visited[index]) return;

    tin[index] = t++;
    jumps[index][0] = p;
    for (int k = 1; k < LOGN; k++)
        jumps[index][k] = jumps[jumps[index][k - 1]][k -1];

    visited[index] = true;

    for (int k = 0; k < 2; k++) {
        if (route[index][k]) {
            dfs(route, visited, jumps, tin, tout, r + 1, c + k, index, t);
        }
    }

    tout[index] = t++;
}

bool is_ancestor(vector <int> &tin, vector <int> &tout, int u, int v) {
    return tin[u] < tin[v] && tout[u] > tout[v];
}

int get_lca(vector <vector <int>> &jumps, vector <int> &tin, vector <int> &tout, int u, int v) {
    if (u == v)
        return u;

    if (is_ancestor(tin, tout, u, v))
        return u;

    if (is_ancestor(tin, tout, v, u))
        return v;

    for (int k = LOGN - 1; k >= 0; k--) {
        if (!is_ancestor(tin, tout, jumps[u][k], v)) {
            u = jumps[u][k];
        }
    }

    return jumps[u][0];
}

void solve() {
    int n;
    cin >> n;

    vector <int> a(n);
    for (int &x: a) cin >> x, x--;

    int total = (n + 1) * (n + 2) / 2;
    vector <bool> mv(n, 1);
    vector <vector <bool>> route(total, vector <bool> (2));

    vector <pair <int, int>> index2rc(total);
    for (int r = 0; r <= n; r++)
        for (int c = 0; c < r + 1; c++)
            index2rc[get_index(r, c)] = {r, c};

    for (int i = 0; i < n + 1; i++) {
        int r = 0, c = 0;

        while (r < n) {
            int index = get_index(r, c);
            route[index][mv[r]] = true;
            c += mv[r];
            r++;
        }

        if (i < n) mv[a[i]] = 0;
    }

    int t = 0;
    vector <bool> visited(total);
    vector <int> tin(total), tout(total);
    vector <vector <int>> jumps(total, vector <int> (LOGN));
    dfs(route, visited, jumps, tin, tout, 0, 0, 0, t);

    int q;
    cin >> q;

    int r1, c1, r2, c2;
    while (q--) {
        cin >> r1 >> c1 >> r2 >> c2;

        int i = get_index(r1, c1);
        int j = get_index(r2, c2);

        int lca = get_lca(jumps, tin, tout, i, j);
        auto [r, c] = index2rc[lca];
        cout << r << ' ' << c << '\n';
    }
}

signed main() {
    cin.tie(NULL);
    ios_base::sync_with_stdio(false);

    #ifdef local
    freopen("input.txt", "r", stdin);
    #endif // local

    solve();
}
