#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;
using namespace std;

const int MAXN = 4600000;
const int LOGN = 13;

int jumps[LOGN][MAXN];
int tin[MAXN], tout[MAXN];
vector <bool> visited(MAXN);
vector <vector <bool>> route(2, vector <bool> (MAXN));

int get_index(int r, int c) {
    return r * (r + 1) / 2 + c;
}

set <pair <int, int>> seen;
void dfs(int r, int c, int p, int &t) {
    int index = get_index(r, c);

    tin[index] = t++;
    jumps[0][index] = p;
    for (int k = 1; k < LOGN; k++)
        jumps[k][index] = jumps[k - 1][jumps[k - 1][index]];

    visited[index] = true;

    for (int k = 0; k < 2; k++) {
        if (route[k][index]) {
            int next_index = get_index(r + 1, c + k);
            if (visited[next_index]) continue;
            dfs(r + 1, c + k, index, t);
        }
    }

    tout[index] = t++;
}

bool is_ancestor(int u, int v) {
    return tin[u] < tin[v] && tout[u] > tout[v];
}

int get_lca(int u, int v) {
    if (u == v)
        return u;

    if (is_ancestor(u, v))
        return u;

    if (is_ancestor(v, u))
        return v;

    for (int k = LOGN - 1; k >= 0; k--) {
        if (!is_ancestor(jumps[k][u], v)) {
            u = jumps[k][u];
        }
    }

    return jumps[0][u];
}

void solve() {
    int n;
    cin >> n;

    vector <int> a(n);
    for (int &x: a) cin >> x, x--;

    vector <bool> mv(n, 1);
    vector <pair <int, int>> index2rc(MAXN);
    for (int r = 0; r <= n; r++)
        for (int c = 0; c < r + 1; c++)
            index2rc[get_index(r, c)] = {r, c};

    for (int i = 0; i < n + 1; i++) {
        int r = 0, c = 0;

        while (r < n) {
            int index = get_index(r, c);
            route[mv[r]][index] = true;
            c += mv[r];
            r++;
        }

        if (i < n) mv[a[i]] = 0;
    }

    int t = 0;
    for (int i =0 ; i < MAXN; i++)
        visited[i] = false;

    dfs(0, 0, 0, t);

    int q;
    cin >> q;

    int r1, c1, r2, c2;
    while (q--) {
        cin >> r1 >> c1 >> r2 >> c2;

        int i = get_index(r1, c1);
        int j = get_index(r2, c2);

        int lca = get_lca(i, j);
        auto [r, c] = index2rc[lca];
        cout << r << ' ' << c << '\n';
    }
}

signed main() {
    cin.tie(NULL);
    ios_base::sync_with_stdio(false);

    #ifdef local
    freopen("input.txt", "r", stdin);
    #endif // local

    solve();
}
