#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <queue>
#include <string>
#include <cassert>

using namespace std;

const int MAXN = 3000 + 7;

vector <pair <int, int>> g[MAXN][MAXN];
bool l[MAXN][MAXN];
bool r[MAXN][MAXN];
int a[MAXN];

int kek[MAXN];

void build(int x, int y, int id, int n) {
	if (id == n)
		return;
	if (kek[id] == 0) {
		if (!r[x][y]) {
			g[x][y].push_back({ x + 1, y + 1 });
			r[x][y] = true;
		}
		build(x + 1, y + 1, id + 1, n);
	}
	else {
		if (!l[x][y]) {
			g[x][y].push_back({ x + 1, y });
			l[x][y] = true;
		}
		build(x + 1, y, id + 1, n);
	}
}

const int MAXNt = (1 << 24);
int st[2 * MAXNt];

int sta[MAXN][MAXN];
int dep[MAXN][MAXN];

vector <pair <int, int>> et;
vector <int> deps;

void dfs(int x, int y, int prevx = -1, int prevy = -1) {
	if (prevx == -1)
		dep[x][y] = 0;
	else
		dep[x][y] = dep[prevx][prevy] + 1;
	sta[x][y] = (int)et.size();
	et.push_back({ x, y });
	deps.push_back(dep[x][y]);
	for (auto to : g[x][y])
		dfs(to.first, to.second, x, y);
}

void build(int tl = 0, int tr = MAXNt - 1, int v = 1) {
	if (tl > tr)
		return;
	if (tl == tr) {
		if (tl < (int)deps.size())
			st[v] = tl;
		else
			st[v] = -1;
		return;
	}
	int mid = (tl + tr) / 2;
	build(tl, mid, 2 * v);
	build(mid + 1, tr, 2 * v + 1);
	if (st[2 * v] == -1)
		st[v] = st[2 * v + 1];
	else if (st[2 * v + 1] == -1)
		st[v] = st[2 * v];
	else if (deps[st[2 * v]] > deps[st[2 * v + 1]])
		st[v] = st[2 * v];
	else
		st[v] = st[2 * v + 1];
}

int get_min(int l, int r) {
	if (l > r)
		swap(l, r);
	int vr = r + MAXNt;
	int vl = l + MAXNt;
	int res = -1;
	while (vl <= vr) {
		if (vl & 1) {
			if (res == -1 || deps[st[vl]] > deps[res])
				res = st[vl];
			vl++;
		}
		if (vl <= vr && (vr & 1) == 0) {
			if (res == -1 || deps[st[vr]] > deps[res])
				res = st[vr];
			vr--;
		}
		vl /= 2;
		vr /= 2;
	}
	return res;
}

void solve() {
	int n;
	cin >> n;
	for (int i = 0; i < n; i++)
		kek[i] = 0;
	build(0, 0, 0, n);
	for (int i = 0; i < n; i++)
		cin >> a[i];
	for (int i = 0; i < n; i++) {
		kek[a[i] - 1] = 1;
		build(0, 0, 0, n);
	}
	dfs(0, 0);
	int q;
	cin >> q;
	for (int i = 0; i < q; i++) {
		int vx, vy, ux, uy;
		cin >> vx >> vy >> ux >> uy;
		auto lc = get_min(sta[vx][vy], sta[ux][uy]);
		cout << et[lc].first << " " << et[lc].second << "\n";
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int tests = 1;
//	cin >> tests;
	for (int test = 1; test <= tests; test++) {
		solve();
	}
}