#include <bits/stdc++.h>

using namespace std;

#define int long long
#define vc vector
#define pii pair <int, int>
#define forn(i, n) for (int i = 0; i < n; ++i)
#define sz(a) (int)a.size()
#define pb push_back

const int maxn = 1e5, inf = 1e9 + 7;

using tt = set <pii>;

int c[maxn], l[maxn], r[maxn], is = 1;
vc <int> g[maxn];
tt dp[maxn];
int ans[maxn];

void merge (tt &a, tt &b) {
    if (sz(a) < sz(b))
        a.swap(b);
    for (auto &it : b)
        a.insert(it);
}

int all = 0;

struct fw {
    vc <int> t;
    int n;
    fw (int n = 0): n(n) {
        resize(n);
    }
    void resize (int n) {
        this->n = n;
        t.assign(n + 1, 0);
    }
    void upd (int i, int x) {
        for (++i; i <= n; i += i & -i)
            t[i] += x;
    }
    int sum (int i) {
        int res = 0;
        for (++i; i > 0; i -= i & -i)
            res += t[i];
        return res;
    }
    int get (int l, int r) {
        return sum(r - 1) - sum(l - 1);
    }
};

struct segtree {
    vc <int> t, a;
    int n;
    segtree (int n = 0, vc <int> a = {}): n(n) {
        if (n != 0) resize(n, a);
    }
    void resize (int n, vc <int> a) {
        this->n = n;
        this->a = a;
        t.assign(n * 4, 0);
        build(1, 0, n);
    }
    void build (int v, int tl, int tr) {
        if (tr - tl == 1) {
            t[v] = a[tl];
            return;
        }
        int tm = (tl + tr) / 2;
        build(v * 2, tl, tm);
        build(v * 2 + 1, tm, tr);
        t[v] = min(t[v * 2], t[v * 2 + 1]);
    }
    void upd (int v, int tl, int tr, int i, int x) {
        if (tr - tl == 1) {
            t[v] -= x;
            return;
        }
        int tm = (tl + tr) / 2;
        if (i < tm) upd(v * 2, tl, tm, i, x);
        else upd(v * 2 + 1, tm, tr, i, x);
        t[v] = min(t[v * 2], t[v * 2 + 1]);
    }
    void upd (int i, int x) {
        upd(1, 0, n, i, x);
    }
    int sum (int v, int tl, int tr, int l, int r) {
        if (r <= l) return inf;
        if (tr <= l || r <= tl) return inf;
        if (l <= tl && tr <= r) return t[v];
        int tm = (tl + tr) / 2;
        return min(sum(v * 2, tl, tm, l, r), sum(v * 2 + 1, tm, tr, l, r));
    }
    int sum (int l, int r) {
        return sum(1, 0, n, l, r);
    }
};

int timer = 0;
int tin[maxn], tout[maxn], h[maxn], start[maxn];
fw tree;
segtree tree2;

void euler (int u, int p = -1) {
    tin[u] = timer++;
    for (int v: g[u]) if (v != p) {
        h[v] = h[u] + 1;
        euler(v, u);
    }
    tout[u] = timer;
}

int res (int u) {
    return tree.get(tin[u], tout[u]);
}

int right (int u) {
    return min(tree2.sum(0, start[h[u]]), r[u]);
}

void dfs (int u, int p = -1) {
    for (int v: g[u]) {
        if (v == p) continue;
        if (l[v] > r[u]) {
            is = 0;
            return;
        }
        dfs(v, u);
        if (!is) return;
        merge(dp[u], dp[v]);
    }
    if (res(u) > right(u)) {
        is = 0;
        return;
    }
    dp[u].insert({c[u], u});
    while (res(u) < l[u]) {
        int j = dp[u].begin()->second;
        int need = min(l[u] - res(u), right(j) - res(j));
        tree.upd(tin[j], need);
        // tree2.upd(tin[j], need);
        if (res(u) < l[u]) dp[u].erase(dp[u].begin());
    }
}

void solve () {
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        g[i].clear();
        dp[i].clear();
        ans[i] = tin[i] = tout[i] = c[i] = l[i] = r[i] = ans[i] = 0;
    }
    is = 1;
    timer = 0;
    all = 0;
    for (int i = 1; i < n; ++i) {
        int v;
        cin >> v; --v;
        g[i].pb(v);
        g[v].pb(i);
    }
    forn (i, n) cin >> c[i];
    forn (i, n) cin >> l[i] >> r[i];
    euler(0);
    vc <pii> q;
    forn (i, n) q.pb({h[i], i});
    sort(q.begin(), q.end());
    vc <int> tmp;
    for (int i = 0; i < n; ++i) {
        if (i == 0 || q[i].first != q[i - 1].first) {
            start[q[i].first] = i;
        }
        tmp.pb(r[q[i].second]);
    }
    start[q.back().first + 1] = n;
    tree.resize(n);
    tree2.resize(n, tmp);
    dfs(0);
    if (!is) {
        cout << "-1\n";
        return;
    }
    forn (i, n) {
        ans[i] = tree.get(tin[i], tin[i] + 1);
        all += ans[i] * c[i];
        if (res(i) < l[i] || res(i) > r[i]) {
            cout << "-1\n";
            return;
        }
    }
    cout << all << '\n';
    for (int i = 0; i < n; ++i) cout << ans[i] << ' ';
    cout << '\n';
}

signed main () {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int t = 1;
    cin >> t;
    while(t--)solve();
}
/*
1
3
1 2
2 1 1
152 152
151 151
150 150
 */