#include <bits/stdc++.h>

using namespace std;

#define int long long
#define vc vector
#define pii pair <int, int>
#define forn(i, n) for (int i = 0; i < n; ++i)
#define sz(a) (int)a.size()
#define pb push_back

const int maxn = 1e5, inf = 1e9 + 7;

using tt = set <pii>;

int c[maxn], l[maxn], r[maxn], pr[maxn], rt[maxn], is = 1;
vc <int> g[maxn];
tt dp[maxn];
int ans[maxn];

void merge (tt &a, tt &b) {
    if (sz(a) < sz(b))
        a.swap(b);
    for (auto &it : b)
        a.insert(it);
}

int all = 0;

struct fw {
    vc <int> t;
    int n;
    fw (int n = 0): n(n) {
        resize(n);
    }
    void resize (int n) {
        this->n = n;
        t.assign(n + 1, 0);
    }
    void upd (int i, int x) {
        for (++i; i <= n; i += i & -i)
            t[i] += x;
    }
    int sum (int i) {
        int res = 0;
        for (++i; i > 0; i -= i & -i)
            res += t[i];
        return res;
    }
    int get (int l, int r) {
        return sum(r - 1) - sum(l - 1);
    }
};

int timer = 0;
int tin[maxn], sizes[maxn], tout[maxn], h[maxn], start[maxn], head[maxn], n;
struct node {
    int mn = inf, md = 0;
} t[maxn * 4];
fw tree;

void go (int u, int p = -1) {
    sizes[u] = 1;
    int j = -1;
    for (int i = 0; i < sz(g[u]); ++i) {
        int v = g[u][i];
        if (v == p) continue;
        go(v, u);
        sizes[u] += sizes[v];
        if (j == -1 || sizes[v] > sizes[g[u][j]])
            j = i;
    }
    if (j != -1)
        swap(g[u][0], g[u][j]);
}

void push (int v, int tl, int tr) {
    if (t[v].md == 0) return;
    if (tr - tl > 1) {
        t[v * 2].md += t[v].md;
        t[v * 2 + 1].md += t[v].md;
    }
    t[v].mn += t[v].md;
    t[v].md = 0;
}

void apply (int v) {t[v].mn = min(t[v * 2].mn, t[v * 2 + 1].mn);}

void build (int v, int tl, int tr) {
    if (tr - tl == 1) {
        t[v].mn = r[tin[tl]];
        t[v].md = 0;
        return;
    }
    int tm = (tl + tr) / 2;
    build(v * 2, tl, tm);
    build(v * 2 + 1, tm, tr);
    apply(v);
}

void upd (int v, int tl, int tr, int l, int r, int x) {
    push(v, tl, tr);
    if (tr <= l || r <= tl) return;
    if (l <= tl && tr <= r) {
        t[v].md = x;
        push(v, tl, tr);
        return;
    }
    int tm = (tl + tr) / 2;
    upd(v * 2, tl, tm, l, r, x);
    upd(v * 2 + 1, tm, tr, l, r, x);
    apply(v);
}

int get (int v, int tl, int tr, int l, int r) {
    push(v, tl, tr);
    if (tr <= l || r <= tl) return inf;
    if (l <= tl && tr <= r) return t[v].mn;
    int tm = (tl + tr) / 2;
    return min(get(v * 2, tl, tm, l, r), get(v * 2 + 1, tm, tr, l, r));
}

void euler (int u, int lst = 0, int p = -1) {
    tin[u] = timer++;
    pr[u] = p;
    head[u] = lst;
    for (int v: g[u]) {
        if (v != p) {
            h[v] = h[u] + 1;
            if (v != g[u][0]) {
                euler(v, v, u);
            } else {
                euler(v, lst, u);
            }
        }
    }
    tout[u] = timer;
}

int res (int u) {
    return rt[u] - get(1, 0, n, tin[u], tin[u] + 1);
}

int right (int u) {
    int res = inf;
    while (u != -1) {
        res = min(res, get(1, 0, n, tin[head[u]], tin[u] + 1));
        u = pr[head[u]];
    }
    return res;
}

void upd (int u, int x) {
    while (u != -1) {
        upd(1, 0, n, tin[head[u]], tin[u] + 1, x);
        u = pr[head[u]];
    }
}

void dfs (int u, int p = -1) {
    for (int v: g[u]) {
        if (v == p) continue;
        dfs(v, u);
        if (!is) return;
        merge(dp[u], dp[v]);
    }
    if (right(u) < 0) {
        is = 0;
        return;
    }
    dp[u].insert({c[u], u});
    while (!dp[u].empty() && res(u) < l[u]) {
        int j = dp[u].begin()->second;
        int need = min(l[u] - res(u), right(j));
        tree.upd(tin[j], need);
        upd(j, -need);
        if (res(u) < l[u]) dp[u].erase(dp[u].begin());
    }
    if (l[u] > res(u)) {
        is = 0;
        return;
    }
}

void solve () {
    cin >> n;
    for (int i = 0; i < n; ++i) {
        g[i].clear();
        dp[i].clear();
        ans[i] = tin[i] = tout[i] = c[i] = l[i] = r[i] = ans[i] = 0;
    }
    is = 1;
    timer = 0;
    all = 0;
    for (int i = 1; i < n; ++i) {
        int v;
        cin >> v; --v;
        g[i].pb(v);
        g[v].pb(i);
    }
    forn (i, n) cin >> c[i];
    forn (i, n) cin >> l[i] >> r[i], rt[i] = r[i];
    go(0);
    euler(0);
    tree.resize(n);
    build(1, 0, n);
    dfs(0);
    if (!is) {
        cout << "-1\n";
        return;
    }
    forn (i, n) {
        ans[i] = tree.get(tin[i], tin[i] + 1);
        all += ans[i] * c[i];
    }
    cout << all << '\n';
    for (int i = 0; i < n; ++i) cout << ans[i] << ' ';
    cout << '\n';
}

signed main () {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int t = 1;
    cin >> t;
    while(t--)solve();
}
/*
NEED TO WRITE HLD, ok.

1
5
1 1 2 2
5 4 3 2 1
2 3
1 2
0 1
0 1
1 2
 */