#include <bits/stdc++.h>

using namespace std;
//#define int long long

const int N = 100005;

vector<int> gr[N];
int pred[N];
int n;

int tree[2 * N];
int want_p[2 * N];


void push(int x, int l, int r) {
    tree[x] += want_p[x];
    if (r - l > 1) {
        int mid = (l + r) / 2;
        want_p[x + 1] += want_p[x];
        want_p[x + 2 * (mid - l)] += want_p[x];
    }
    want_p[x] = 0;
}

void add(int l, int r, int el, int lx = 0, int rx = n, int x = 0) {
    push(x, lx, rx);
    if (l <= lx and rx <= r) {
        want_p[x] += el;
        push(x, lx, rx);
        return;
    }
    if (lx >= r or l >= rx) return;
    int mid = (lx + rx) / 2;
    add(l, r, el, lx, mid, x + 1);
    add(l, r, el, mid, rx, x + 2 * (mid - lx));
    tree[x] = min(tree[x + 1], tree[x + 2 * (mid - lx)]);
}

int get(int l, int r, int lx = 0, int rx = n, int x = 0) {
    push(x, lx, rx);
    if (l <= lx and rx <= r) {
        return tree[x];
    }
    if (lx >= r or l >= rx) {
        return 1e9 + 7;
    }
    int mid = (lx + rx) / 2;
    int ans = min(get(l, r, lx, mid, x + 1), get(l, r, mid, rx, x + 2 * (mid - lx)));
    tree[x] = min(tree[x + 1], tree[x + 2 * (mid - lx)]);
    return ans;
}


int sz[N];

void init_sz(int u) {
    sz[u] = 1;
    for (auto c: gr[u]) {
        init_sz(c);
        sz[u] += sz[c];
    }
}

int hs[N];
int link_gl[N];
int tin[N], tout[N];
int timer = 0;

void build_hld(int u, int gl, int h) {
    hs[u] = h;
    link_gl[u] = gl;
    tin[u] = timer;
    timer++;
    sort(gr[u].begin(), gr[u].end(), [&](int a, int b) {
        return sz[a] > sz[b];
    });
    if (gr[u].empty()) return;
    build_hld(gr[u][0], gl, h + 1);
    for (int i = 1; i < gr[u].size(); ++i) {
        build_hld(gr[u][i], gr[u][i], h + 1);
    }
    tout[u] = timer;
}


pair<int, int> vec[N];

int summ[N];
int ans[N];
int cost[N];
bool fl = false;
long long res = 0;

int ost[N];

int min_on_path(int u, int v) {
    int minn = get(tin[v], tin[v] + 1);
    while (hs[u] > hs[v]) {

        if (hs[link_gl[u]] <= hs[v]) {
            minn = min(minn, get(tin[link_gl[u]], tin[u] + 1));
            u = pred[link_gl[u]];
        }else {
            minn = min(minn, get(tin[u], tin[u] + 1));
            u = pred[u];
        }

    }
    return minn;
}

void add_on_path(int u, int v, int el) {
    add(tin[v], tin[v] + 1, -el);
    while (hs[u] > hs[v]) {
        if (hs[link_gl[u]] > hs[v]) {
            add(tin[link_gl[u]], tin[u] + 1, -el);
            u = pred[link_gl[u]];
        } else {
            add(tin[v] + 1, tin[u] + 1, -el);
            u = v;
        }
    }
}

set<pair<int, int>> dfs(int u) {
    set<pair<int, int>> st;
    st.insert({cost[u], u});
    ost[u] = vec[u].second;
    add(tin[u], tin[u] + 1, vec[u].second);


    for (auto c: gr[u]) {
        set<pair<int, int>> st2 = dfs(c);
        if (st2.size() < st.size()) {
            for (auto c2: st2) st.insert(c2);
        } else {
            for (auto c2: st) st2.insert(c2);
            st.swap(st2);
        }
        summ[u] += summ[c];
    }
    add(tin[u], tin[u] + 1, -summ[u]);
    ost[u] -= summ[u];
    if (summ[u] > vec[u].second) fl = true;
    if (summ[u] >= vec[u].first) return st;
    while (summ[u] < vec[u].first) {
        if (st.empty()) {
            fl = true;
            return st;
        }
        pair<int, int> now = *st.begin();
        int can = vec[u].first - summ[u];
        int v = now.second;
        can = min(can, min_on_path(v, u));

        if (can == 0) {
            st.erase(now);
            continue;
        }
        v = now.second;
        ans[v] += can;
        res += (long long) cost[v] * can;
        summ[u] += can;
        add_on_path(v, u, can);
    }
    return st;

}

void solve() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    cin >> n;
    fl = false;
    res = 0;
    timer = 0;
    for (int i = 0; i < n; ++i) {
        gr[i].clear();
        ans[i] = 0;
        summ[i] = 0;
    }

    for (int i = 0; i < 2 * n; ++i) {
        tree[i] = 0;
        want_p[i] = 0;
    }

    for (int i = 1; i < n; ++i) {
        int a;
        cin >> a;
        a--;
        gr[a].push_back(i);
        pred[i] = a;
    }
    for (int i = 0; i < n; ++i) {
        cin >> cost[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> vec[i].first >> vec[i].second;
    }
    init_sz(0);
    build_hld(0, 0, 0);

    dfs(0);

    if (fl) {
        cout << "-1\n";
        return;
    }
    cout << res << "\n";
    for (int i = 0; i < n; ++i) {
        cout << ans[i] << " ";
    }
    cout << "\n";


}

signed main() {

    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
