#include <iostream>
#include <algorithm>
#include <vector>
#include <tuple>
#include <deque>
#include <cassert>
#include <set>
#include <map>

using namespace std;
typedef long long ll;
#define endl '\n'

int n, q;
int a[500010]; //level change
int qu[500010][4];
int cross[500010];

int fenw[500010];

inline void add(int i, int v)
{
	for (; i <= n; i = i | (i + 1)) fenw[i] += v;
}

inline int gt(int i)
{
	int ans = 0;
	for (; i >= 0; i = ((i + 1) & i) - 1) ans += fenw[i];
	return ans;
}

pair <int, int> up(pair <int, int> u)
{
	assert(u.first > 0);
	if (u.second > cross[u.first - 1]) u.second--;
	u.first--;
	return u;
}

vector <int> inter[500010];
vector <pair <int, int>> all;
map <pair <int, int>, int> conv;

vector <int> str;

inline int get(int i)
{
	return str[i];
}

inline void change(int i, int v)
{
	str[i] = v;
}

inline void insert(int i, int v)
{
	str.insert(str.begin() + i, v);
}

const int N = 300010 * 3;
const int LOG = 20;
int p[N];
vector <int> g[N];
int bu[LOG][N];

int tin[N];
int tout[N];
int timer = 0;

void dfs(int u)
{
	tin[u] = timer++;
	for (auto v : g[u]) if(v != u) dfs(v);
	tout[u] = timer++;
}

int isup(int u, int v)
{
	return tin[u] <= tin[v] && tout[u] >= tout[v];
}

int lca(int u, int v)
{
	if (isup(u, v)) return u;
	if (isup(v, u)) return v;

	for (int i = LOG - 1; i >= 0; --i)
	{
		if (!isup(bu[i][u], v)) u = bu[i][u];
	}
	u = bu[0][u];
	return u;
}

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	cin >> n;

	for (int i = 1; i <= n; ++i)
	{
		cin >> a[i];
		--a[i];
	}

	cin >> q;
	for (int i = 1; i <= q; ++i)
	{
		for (int j = 0; j < 4; ++j)
		{
			cin >> qu[i][j];
		}
	}

	for (int i = 1; i <= n; ++i)
	{
		cross[a[i]] = a[i] - gt(a[i]);
		add(a[i], 1);

		inter[a[i]].push_back(cross[a[i]]);
	}

	for (int i = 1; i <= q; ++i)
	{
		inter[qu[i][0]].push_back(qu[i][1]);
		inter[qu[i][2]].push_back(qu[i][3]);
	}

	for (int i = 0; i <= n; ++i)
	{
		sort(inter[i].begin(), inter[i].end());
		inter[i].resize(unique(inter[i].begin(), inter[i].end()) - inter[i].begin());

		for (auto j : inter[i]) all.push_back({ i, j });
	}

	sort(all.begin(), all.end());
	for (int i = 0; i < all.size(); ++i) conv[all[i]] = i;

	str = { conv[{0, 0}] };
	for (int i = 0; i <= n; ++i)
	{
		for (auto y : inter[i])
		{
			int u = conv[{i, y}];
			p[u] = get(y);
			g[p[u]].push_back(u);

			change(y, u);
		}
		if (i < n) insert(cross[i], conv[{i, cross[i]}]);
	}

	int m = all.size();

	for (int i = 0; i < LOG; ++i)
	{
		for (int j = 0; j < m; ++j)
		{
			bu[i][j] = (i == 0 ? p[j] : bu[i - 1][bu[i - 1][j]]);
		}
	}

	dfs(0);

	for (int i = 1; i <= q; ++i)
	{
		int u = conv[{qu[i][0], qu[i][1]}], v = conv[{qu[i][2], qu[i][3]}];
		int z = lca(u, v);
		auto ans = all[z];
		cout << ans.first << ' ' << ans.second << '\n';
	}


	return 0;
}