#include <iostream>
#include <vector>
#include <algorithm>
#include <math.h>
#include <set>
#include <deque>

using ll = long long;

#define typen pair<pair<ll, ll>,ll>
#define endl '\n';

using namespace std;

vector<ll> sumMn;
vector<ll> needAdd;
vector<ll> vertCost;
vector<ll> vertL;
vector<ll> vertR;
vector<ll> vertCnt;
vector<vector<int>> nums;
ll resSum = 0;
bool stop = false;
 
void impossible() {
	if (!stop)
		cout << -1 << endl;
	stop = true;
}

void dfs_sum(ll v, ll par) {
	sumMn[v] = (ll)0;
	for (ll i = 0; i < (ll)nums[v].size(); i++)
	{
		ll nxt = nums[v][i];
		if (nxt == par)continue;
		dfs_sum(nxt, v);
		sumMn[v] += sumMn[nxt];
	}
	needAdd[v] = max((ll)0, vertL[v] - sumMn[v]);
	sumMn[v] = max(sumMn[v], vertL[v]);
	if (sumMn[v] > vertR[v])
		impossible();
}

void choose(typen& a,ll quan = -1) {
	if (quan == -1)
		quan = a.first.second;
	a.first.second -= quan;
	vertCnt[a.second] += quan;
	resSum += quan * a.first.first;
}

void dfs(ll v,ll par,set<typen>& retur) {
	set<typen> res;
	for (ll i = 0; i < nums[v].size(); i++)
	{
		ll nxt = nums[v][i];
		if (nxt == par)continue;
		set<typen> now;
		dfs(nxt, v, now);
		if (res.size() < now.size())swap(res, now);
		for (auto& lk : now)
			res.insert(lk);
	}
	ll cntLeft = needAdd[v];
	while (true)
	{
		typen resb;
		if (0 != res.size())
			resb = *res.begin();
		else break;
		if (0 == res.size()|| resb.first.first>vertCost[v]) {
			//if (cntLeft > vertR[v])
			//	impossible();
			//else {
				resSum += vertCost[v] * cntLeft;
				vertCnt[v] += cntLeft;
			//}
			break;
		}
		if (cntLeft < resb.first.second) {
			choose(resb, cntLeft);
			if (0 != res.size())
				res.erase(res.begin());
			else break;
			res.insert(resb);
			break;
		}
		else {
			cntLeft -= resb.first.second;
			choose(resb);
			if (0 != res.size())
				res.erase(res.begin());
			else break;
		}
	}
	res.insert({ { vertCost[v],vertR[v] },v });


	ll resSetSum = 0;
	for (auto& i : res)
		resSetSum += i.first.second;

	while (resSetSum > vertR[v])
	{
		ll d = resSetSum - vertR[v];
		if (res.size() == 0) 
			break;
		auto beg = *res.rbegin();
		if (beg.first.second < d) {
			resSetSum -= beg.first.second;
			if (0 != res.size())
				res.erase(--res.end());
			else break;
		}
		else {
			if (0 != res.size())
				res.erase(--res.end());
			else break;
			resSetSum -= d;
			beg.first.second -= d;
			res.insert(beg);
		}
	}

	retur = res;
}


int32_t main()
{
	cin.tie(0);
	cout.tie(0);
	ios_base::sync_with_stdio(false);
	ll t;
	cin >> t;
	for (ll k = 0; k < t; k++)
	{
		ll n;
		cin >> n;

		stop = false;
		resSum = 0;
		nums = vector<vector<int>>(n);
		sumMn = vector<ll>(n);
		vertCost = vector<ll>(n);
		needAdd = vector<ll>(n);
		vertL = vector<ll>(n);
		vertR = vector<ll>(n);
		vertCnt = vector<ll>(n, 0);

		for (ll i = 1; i < n; i++)
		{
			ll b;
			cin >> b;
			b--;
			ll a = i;
			nums[a].push_back(b);
			nums[b].push_back(a);
		}

		for (ll i = 0; i < n; i++)
			cin >> vertCost[i];
		for (ll i = 0; i < n; i++) {
			cin >> vertL[i];
			cin >> vertR[i];
		}

		dfs_sum(0, -1);
		if (stop)continue;
		for (ll i = 0; i < n; i++)
		{
			vertL[i] -= sumMn[i];
			vertR[i] -= sumMn[i];
		}
		set<typen> tests;
		dfs(0, -1,tests);

		if (stop)continue;

		cout << resSum << endl;
		for (ll i = 0; i < n; i++)
			cout << vertCnt[i] << " ";
		cout << endl;
	}
	
}
