#pragma GCC optimize("Ofast", "no-stack-protector")

#include <bits/stdc++.h>
#define endl "\n"
#define ll long long
//#define int long long
#define pii pair<int, int>
#define X first
#define Y second
#define all(a) a.begin(), a.end()
#define fast ios::sync_with_stdio(0);cin.tie(0);cout.tie(0);
using namespace std;

template<typename T>
bool rmax (T& a, T b) {
    if (a < b) {
        a = b;
        return 1;
    }
    return 0;
}

template<typename T>
bool rmin (T& a, T b) {
    if (a > b) {
        a = b;
        return 1;
    }
    return 0;
}

template<typename T>
istream& operator >> (istream& in, vector<T>& a) {
    for (auto &it : a)
        in >> it;

    return in;
}

template<typename T>
ostream& operator << (ostream& in, vector<T>& a) {
    for (auto &it : a)
        in << it << ' ';

    return in;
}

const int MAXN = 9e6;

unordered_map<int, pii> ret;
vector<int> adj[MAXN];
vector<int> up[28];
vector<int> depth;
vector<bool> used;
vector<int> par;

void dfs (int v, int d = 0) {
    used[v] = 1;
    depth[v] = d;

    for (auto &it : adj[v]) {
        if (!used[it]) {
            dfs(it, d + 1);
            par[it] = v;
        }
    }
}

void precalc (int n) {
    depth.resize(n);
    used.assign(n, 0);
    par.assign(n, 0);

    dfs(0);

    for (int i = 0; i < 28; i++)
        up[i].resize(n);

    for (int i = 0; i < n; i++) {
        up[0][i] = par[i];
    }

    for (int pow = 1; pow < 28; pow++) {
        for (int i = 0; i < n; i++) {
            up[pow][i] = up[pow - 1][up[pow - 1][i]];
        }
    }
}

int get_lca (int v, int u) {
    if (depth[v] < depth[u])
        swap(v, u);

    int k = depth[v] - depth[u];

    for (int i = 27; i >= 0; i--) {
        if (k & (1 << i)) {
            v = up[i][v];
        }
    }

    if (v == u)
        return v;

    for (int i = 27; i >= 0; i--) {
        if (up[i][v] != up[i][u]) {
            v = up[i][v];
            u = up[i][u];
        }
    }
    return up[0][u];
}

int hash_pair (pii a) {
    int num = a.X * (a.X + 1) / 2;
    return num + a.Y;
}

vector<int> num;
void make_down () {
    int x = 0;
    int y = 0;
    pii prev = {x, y};
    for (auto &it : num) {
        x++;
        if (it == 1) {
            y++;
        }

        pii ns = {x, y};
        adj[hash_pair(prev)].push_back(hash_pair(ns));
        prev = ns;
    }
}


void solve () {
    int n;
    cin >> n;

    int id = 0;

    for (int r = 0; r <= n; r++) {
        for (int c = 0; c <= r; c++) {
            ret[hash_pair({r, c})] = {r, c};
            rmax(id, hash_pair({r, c}));
        }
    }

    num.assign(n, 1);

    make_down();

    for (int i = 0; i < n; i++) {
        int f;
        cin >> f;
        --f;

        num[f] = 0;
        make_down();
    }

    precalc(id + 1);

    int q;
    cin >> q;

    while (q--) {
        int r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;

        int u = hash_pair({r1, c1});
        int v = hash_pair({r2, c2});

        int f = get_lca(u, v);
        pii a = ret[f];

        cout << a.X << ' ' << a.Y << endl;
    }

}

signed main () {
    fast;

#if defined(LOCAL_CLION)
    freopen("../input.txt", "r", stdin);
#elif defined(LOCAL)
    freopen("./input.txt", "r", stdin);
#endif

    int t = 1;
//    cin >> t;

    while (t--)
        solve();
}