#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <iomanip>
#include <bitset>
#include <random>
#include <queue>
#pragma GCC optimase("Ofast")

#define ll long long
#define ld long double
//#define int ll

using namespace std;

const int N = (1 << 12);

int tree[N * 2];

void build(int v = 1, int l = 0, int r = N) {
	if (r - l == 1) {
		tree[v] = 0;
		return;
	}
	int md = (l + r) / 2;
	build(v * 2, l, md);
	build(v * 2 + 1, md, r);
	tree[v] = 0;
}

void add(int ind, int x, int v = 1, int l = 0, int r = N) {
	if (r <= ind || l > ind) return;
	if (r - l == 1) {
		tree[v] = x;
		return;
	}
	int md = (l + r) / 2;
	add(ind, x, v * 2, l, md);
	add(ind, x, v * 2 + 1, md, r);
	tree[v] = tree[v * 2] + tree[v * 2 + 1];
}

int get(int l1, int r1, int v = 1, int l = 0, int r = N) {
	if (l1 >= r || l >= r1) return 0;
	if (r <= r1 && l >= l1) {
		return tree[v];
	}
	int md = (l + r) / 2;
	return get(l1, r1, v * 2, l, md) + get(l1, r1, v * 2 + 1, md, r);
}

signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int n;
	cin >> n;
	ll ans = 0;
	vector<int>a(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}
	vector<vector<int>>matr(n, vector<int>(n));
	for (int i = 0; i < n; ++i) {
		for (int j = i + 1; j < n; ++j) {
			matr[i][j] = abs(a[j] - a[i]);
		}
	}
	for (int i = 0; i < n; ++i) {
		build();
		vector<pair<int, int>>c;
		for (int j = i + 1; j < n; ++j) {
			c.push_back({ a[j], j });
		}
		sort(c.begin(), c.end());
		reverse(c.begin(), c.end());
		for (int j = 0; j < c.size(); ++j) {
			int cnt = get(c[j].second, n);
			matr[i][c[j].second] = max(matr[i][c[j].second], n - cnt - 1 - i);
			add(c[j].second, 1);
		}
	}
	for (int i = 0; i < n; ++i) {
		build();
		vector<pair<int, int>>c;
		for (int j = 0; j < i; ++j) {
			c.push_back({ a[j], j });
		}
		sort(c.begin(), c.end());
		for (int j = 0; j < c.size(); ++j) {
			int cnt = get(0, c[j].second);
			matr[c[j].second][i] = max(matr[c[j].second][i], i - cnt);
			add(c[j].second, 1);
		}
	}
	for (int i = 0; i < n; ++i) {
		for (int j = i + 1; j < n; ++j) {
			ans += matr[i][j];
		}
	}
	cout << ans;
}
