#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC target("avx,avx2")

#include <iostream>
#include <vector>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <algorithm>
#include <iomanip>
#include <numeric>
#include <cassert>
#include <climits>

using namespace std;

#ifndef DESPAIR_101
#define cerr if (false) cerr
#endif

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

template<class A>
void print(A x) {
	cerr << x;
}
template<class A, class B>
void print(pair<A, B> x) {
	cerr << "(" << x.first << ' ' << x.second << ")";
}
template<class A>
void print(vector<A> x) {
	for (A el : x) {
		print(el);
		cerr << ' ';
	}
	cerr << '\n';
}
template<class A>
void print(set<A> x) {
	for (A el : x) {
		print(el);
		cerr << ' ';
	}
	cerr << '\n';
}
template<class A>
void print(unordered_set<A> x) {
	for (A el : x) {
		print(el);
		cerr << ' ';
	}
	cerr << '\n';
}
template<class A, class B>
void print(map<A, B> x) {
	for (A el : x) {
		print(el);
		cerr << ' ';
	}
	cerr << '\n';
}
template<class A, class B>
void print(unordered_map<A, B> x) {
	for (A el : x) {
		print(el);
		cerr << ' ';
	}
	cerr << '\n';
}

#define int ll
#define sz(x) int(x.size())
#define dbg(x) cerr << #x << ":\n "; print(x); cerr << "\n";

int k;

void solve() {
	int n, w, h;
	cin >> n >> w >> h;

	vector<pair<int, int>> p(n);
	for (int i = 0; i < n; ++i) {
		cin >> p[i].first >> p[i].second;
		p[i].first = w - p[i].first, p[i].second = h - p[i].second;
	}

	sort(p.begin(), p.end());
	
	vector<pair<int, int>> st;
	for (int i = 0; i < n; ++i) {
		while (!st.empty() && p[i].second >= st.back().second) st.pop_back();
		st.push_back(p[i]);
	}

	ll ans = st[0].first * st[0].second;
	for (int i = 1; i < sz(st); ++i) {
		ans += st[i].second * (st[i].first - st[i - 1].first);
	}

	cout << ans << '\n';
}

signed main() {
	cin.tie(nullptr);
	ios::sync_with_stdio(false);
	
	cin >> k;

	int c;
	cin >> c;

	int te = 1;
	cin >> te;

	for (int t = 1; t <= te; ++t) {
		cerr << "_____Test #" << t << "_____\n";
		solve();
	}
}