#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC target("avx,avx2")

#include <iostream>
#include <vector>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <algorithm>
#include <iomanip>
#include <numeric>
#include <cassert>
#include <climits>

using namespace std;

#ifndef DESPAIR_101
#define cerr if (false) cerr
#endif

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

template<class A>
void print(A x) {
	cerr << x;
}
template<class A, class B>
void print(pair<A, B> x) {
	cerr << "(" << x.first << ' ' << x.second << ")";
}
template<class A>
void print(vector<A> x) {
	for (A el : x) {
		print(el);
		cerr << ' ';
	}
	cerr << '\n';
}
template<class A>
void print(set<A> x) {
	for (A el : x) {
		print(el);
		cerr << ' ';
	}
	cerr << '\n';
}
template<class A>
void print(unordered_set<A> x) {
	for (A el : x) {
		print(el);
		cerr << ' ';
	}
	cerr << '\n';
}
template<class A, class B>
void print(map<A, B> x) {
	for (A el : x) {
		print(el);
		cerr << ' ';
	}
	cerr << '\n';
}
template<class A, class B>
void print(unordered_map<A, B> x) {
	for (A el : x) {
		print(el);
		cerr << ' ';
	}
	cerr << '\n';
}

#define int ll
#define sz(x) int(x.size())
#define dbg(x) cerr << #x << ":\n "; print(x); cerr << "\n";

ll ans;
int k, n, w, h;

void calc(vector<pair<int, int>>& v, int ind, int lx, int rx, ll cur) {
	if (ind == -1) {
		ans = max(ans, cur);
	} else {
		int mx = v[ind].first;
		if (mx < rx) {
			if (mx <= lx) {
				ans = max(ans, cur + (h - v[ind].second) * (rx - lx));
			} else {
				calc(v, ind - 1, lx, mx, cur + (rx - mx) * (h - v[ind].second));
			}
		}
		if (mx > lx) {
			if (mx >= rx) {
				ans = max(ans, cur + (h - v[ind].second) * (rx - lx));
			} else {
				calc(v, ind - 1, mx, rx, cur + (mx - lx) * (h - v[ind].second));
			}
		}
	}
}

void solve() {
	ans = 0;
	cin >> n >> w >> h;

	vector<pair<int, int>> p(n);
	for (int i = 0; i < n; ++i) {
		cin >> p[i].first >> p[i].second;
	}

	sort(p.begin(), p.end(), [&](pair<int, int> a, pair<int, int> b) {
		return a.second > b.second;
		});

	calc(p, n - 1, 0, w, 0);
	cout << ans << '\n';
}

signed main() {
	cin.tie(nullptr);
	ios::sync_with_stdio(false);

	cin >> k;

	int c, e;
	cin >> c >> e;

	int te = 1;
	cin >> te;

	for (int t = 1; t <= te; ++t) {
		cerr << "_____Test #" << t << "_____\n";
		solve();
	}
}