#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

#define int long long
#define all(a) a.begin(), a.end()
#define pb push_back
#define INF (int) 1e18 / 2

using namespace std;

const int N = 5005;

vector<multiset<pair<int, int>>> dp;

vector<vector<int>> g;
vector<int> p, c, l, r, cnt, has;

int ans = 0;

int get(int v) {
    int cur = v;
    if (cnt[v] == r[v])
        cur = -1;
    for (int u : g[v]) {
        int kek = get(u);
        if (kek == -1)
            continue;
        if (c[kek] < c[cur])
            cur = kek;
    }
    return cur;
}

void dfs(int v) {
    for (int u : g[v]) {
        dfs(u);
    }
    while (cnt[v] < l[v]) {
        int u = get(v);
        if (u == -1)
            break;
        has[u]++;
        ans += c[u];
        while (u != 0)
            cnt[u]++, u = p[u];
    }
}

void solve() {
    ans = 0;
    int n;
    cin >> n;
    g.assign(n + 1, {});
    p.assign(n + 1, 0);
    c.assign(n + 1, 0);
    l.assign(n + 1, 0);
    r.assign(n + 1, 0);
    cnt.assign(n + 1, 0);
    has.assign(n + 1, 0);
    dp.assign(n + 1, {});
    for (int i = 2; i <= n; i++)
        cin >> p[i], g[p[i]].pb(i);
    for (int i = 1; i <= n; i++)
        cin >> c[i];
    for (int i = 1; i <= n; i++)
        cin >> l[i] >> r[i];
    dfs(1);
    for (int i = 1; i <= n; i++) {
        if (cnt[i] < l[i] || r[i] < cnt[i]) {
            cout << -1 << '\n';
            return;
        }
    }
    cout << ans << '\n';
    for (int i = 1; i <= n; i++)
        cout << has[i] << " ";
    cout << '\n';
}

int32_t main() {
    cin.tie(0);
    cout.tie(0);
    ios::sync_with_stdio(false);

    int tt = 1;
    cin >> tt;
    while (tt--)
        solve();
}
