#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

#define int long long
#define all(a) a.begin(), a.end()
#define pb push_back
#define INF (int) 1e18 / 2

using namespace std;

const int N = 5005;

vector<vector<int>> g;
vector<multiset<pair<int, int>>> dp;
vector<int> l, r, c;
vector<int> cnt, has;

bool ok = false;

int ans = 0;

void dfs(int v) {
    for (int u : g[v]) {
        dfs(u);
        if (dp[u].size() < dp[v].size())
            swap(dp[v], dp[u]);
        for (auto p : dp[u])
            dp[v].insert(p);
        dp[u].clear();
        cnt[v] += cnt[u];
    }
    if (cnt[v] > r[v])
        ok = false;
    dp[v].insert({c[v], v});
    for (auto[i, j] : dp[v]) {
        if (cnt[v] >= l[v])
            break;
        if (has[j] < r[j]) {
            int d = min(l[v] - cnt[v], r[j] - has[j]);
            ans += d * i;
            has[j] += d;
            cnt[v] += d;
        }
    }
}

void solve() {
    int n;
    cin >> n;

    g.assign(n + 1, {});
    dp.assign(n + 1, {});
    l.assign(n + 1, 0);
    r.assign(n + 1, 0);
    c.assign(n + 1, 0);
    cnt.assign(n + 1, 0);
    has.assign(n + 1, 0);
    ok = true;
    ans = 0;

    for (int i = 2; i <= n; i++) {
        int p;
        cin >> p;
        g[p].pb(i);
    }
    for (int i = 1; i <= n; i++)
        cin >> c[i];
    for (int i = 1; i <= n; i++)
        cin >> l[i] >> r[i];
    dfs(1);
    if (!ok) {
        cout << -1 << '\n';
        return;
    }
    cout << ans << '\n';
    for (int i = 1; i <= n; i++)
        cout << has[i] << " ";
    cout << '\n';
}

int32_t main() {
    cin.tie(0);
    cout.tie(0);
    ios::sync_with_stdio(false);

    int tt = 1;
    cin >> tt;
    while (tt--)
        solve();
}
