#include <bits/stdc++.h>
#include <bits/extc++.h>

#define int long long

using namespace std;
template <typename T>
using oset = __gnu_pbds::tree<T, __gnu_pbds::null_type, less<T>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;
using ll = long long;

constexpr int MAXN = 10000007;
constexpr int LOGMAXN = 20; // 1048576

vector<int> graph[MAXN];
vector<int> lcav;

int getvx[MAXN], getvy[MAXN];

int getv(int r, int c) {
    int res = r * (r + 1) / 2 + c;
    getvx[res] = r;
    getvy[res] = c;
}

int depth[MAXN];

int occur[MAXN];

void build_lca_dfs(int v) {
    occur[v] = lcav.size();
    lcav.push_back(v);
    for (int ch : graph[v]) {
        depth[ch] = depth[v] + 1;
        build_lca_dfs(ch);
        lcav.push_back(v);
    }
}

int table[LOGMAXN][MAXN];

inline int getmin(const int &av, const int &bv) {
    return (depth[av] < depth[bv] ? av : bv);
}

void build_lca() {
    build_lca_dfs(0);
    for (int i = 0; i < lcav.size(); ++i) {
        table[0][i] = lcav[i];
    }
    int n = lcav.size();
    for (int lvl = 1; lvl < LOGMAXN; ++lvl) {
        for (int i = 0; i <= n - (1 << lvl); ++i) {
            table[lvl][i] = getmin(table[lvl - 1][i], table[lvl - 1][i + (1 << (lvl - 1))]);
        }
    }
}

int get_lca(int u, int v) {
    int mn = min(occur[u], occur[v]);
    int mx = max(occur[v], occur[u]) + 1;
    int lg = __lg(mx - mn);
    return getmin(table[lg][mn], table[lg][mx - (1 << lg)]);
}

int32_t main() {
    // ne rascheska
    int n;
    cin >> n;
    for (int r = 0; r < n; ++r) {
        graph[getv(r, r)].push_back(getv(r + 1, r + 1));
    }
    vector<int> a(n);
    vector<bool> cor(n);
    for (auto &now : a) {
        cin >> now;
        cor[now - 1] = true;
        int cury = 0;
        for (int r = 0; r < now - 1; ++r) {
            if (!cor[r]) {
                ++cury;
            }
        }
        for (int r = now - 1; r < n; ++r) {
            int nc = cury + !cor[r];
            graph[getv(r, cury)].push_back(getv(r + 1, nc));
            cury = nc;
        }
    }
    build_lca();
    int q;
    cin >> q;
    while (q --> 0) {
        int u, v, x, y;
        cin >> u >> v >> x >> y;
        int aaa = get_lca(getv(u, v), getv(x, y));
        cout << getvx[aaa] << ' ' << getvy[aaa] << '\n';
    }
    return 0;
}
