#pragma GCC optimize("Ofast")
#include<bits/stdc++.h>
typedef int_fast64_t ll;

using namespace std;

const ll INF = 1'000'000'000;

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_max(T& a, T b) {
        if (a < b) {
                a = b;
                return true;
        }       
        return false;
}

struct segment_tree {
	vector<ll> tree;
	ll size;
	segment_tree(ll n) {
		size = n;
		while (size < n) {
			size *= 2;
		}
		tree.resize(size * 4, 0);
	}
	ll get(ll l, ll r) {
		return get(1, 0, size, l, r);
	}
	ll get(ll v, ll l, ll r, ll ql, ll qr) {
		if (ql <= l && r <= qr) {
			return tree[v];
		}
		if (qr <= l || r <= ql) {
			return 0;
		}
		ll mid = (l + r) / 2;
		return get(v * 2, l, mid, ql, qr) + get(v * 2 + 1, mid, r, ql, qr);
	}
	void change(ll x) {
		change(1, 0, size, x);
	}
	void change(ll v, ll l, ll r, ll x) {
		if (x < l || r <= x) {
			return;
		}
		if (r - l == 1) {
			tree[v] = 1;
			return;
		}
		ll mid = (l + r) / 2;
		change(v * 2, l, mid, x);
		change(v * 2 + 1, mid, r, x);
		tree[v] = tree[v * 2] + tree[v * 2 + 1];
	}
};

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	ll n;
	cin >> n;
	vector<ll> arr(n, 0);
	for (ll i = 0; i < n; i++) {
		cin >> arr[i];
	}
	ll ans = 0;
	segment_tree st2(n);
	for (ll i = 0; i < n; i++) {
		segment_tree st(n);
		for (ll j = n - 1; j > i; j--) {
			ans += max(abs(arr[j] - arr[i]), max((n - st.get(arr[j], n)) - i - 1, j - st2.get(0, arr[i])));
			st.change(arr[j] - 1);
		}
		st2.change(arr[i] - 1);
	}
	cout << ans;
}
