#include <iostream>
#include <vector>
#include <algorithm>
#include <utility>
#include <numeric>

using namespace std;

#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()

using uint = unsigned int;
using int64 = long long;
using uint64 = unsigned long long;

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	int n; cin >> n;
	vector <int> v(n);
	for (auto& x : v) {
		cin >> x;
		--x;
	}

	vector <int> cv = v;

	vector <vector <int>> dist(n, vector <int>(n, 0));
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			dist[v[i]][v[j]] = abs(i - j);
		}
	}

	for (int i = 0; i < n; ++i) {
		int pos = i;
		while (pos > 0 && v[pos] < v[pos - 1]) {
			swap(v[pos], v[pos - 1]);
			--pos;
		}
		for (int j = 0; j < n; ++j) {
			for (int k = 0; k < n; ++k) {
				dist[v[k]][v[j]] = max(dist[v[k]][v[j]], abs(k - j));
			}
		}
	}

	v = cv;
	for (int i = n - 1; i >= 0; --i) {
		int pos = i;
		while (pos < n - 1 && v[pos + 1] < v[pos]) {
			swap(v[pos], v[pos + 1]);
			++pos;
		}
		for (int j = 0; j < n; ++j) {
			for (int k = 0; k < n; ++k) {
				dist[v[k]][v[j]] = max(dist[v[k]][v[j]], abs(k - j));
			}
		}
	}

	int64 ans = 0;
	for (auto& x : dist) {
		ans += accumulate(all(x), 0ll);
	}

	cout << ans / 2 << endl;
}