#include <iostream>
#include <vector>
#include <algorithm>
#include <utility>
#include <numeric>
#include <map>
#include <set>

using namespace std;

#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()

using uint = unsigned int;
using int64 = long long;
using uint64 = unsigned long long;

const int64 INF = (int64)1e18 + 2;

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	int n; cin >> n;
	vector <int> v(n);
	for (auto& x : v) {
		cin >> x;
		--x;
	}

	vector <int> sv = v;
	sort(all(sv));
	vector <vector <int>> dist(n, vector <int>(n, 0));
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			dist[sv[i]][sv[j]] = abs(i - j);
		}
	}

	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			dist[v[i]][v[j]] = max(dist[v[i]][v[j]], abs(i - j));
		}
	}

	auto cv = v;
	for (int i = 0; i < n; ++i) {
		int pos = i;
		while (pos > 0 && v[pos] < v[pos - 1]) {
			swap(v[pos], v[pos - 1]);
			--pos;
		}
		for (int j = 0; j < n; ++j) {
			dist[v[pos]][v[j]] = max(dist[v[pos]][v[j]], abs(pos - j));
		}
	}

	v = cv;
	for (int i = n - 1; i >= 0; --i) {
		int pos = i;
		while (pos < n - 1 && v[pos + 1] < v[pos]) {
			swap(v[pos], v[pos + 1]);
			++pos;
		}
		for (int j = 0; j < n; ++j) {
			dist[v[pos]][v[j]] = max(dist[v[pos]][v[j]], abs(pos - j));
		}
	}

	int64 ans = 0;
	for (int i = 0; i < n - 1; ++i) {
		for (int j = i + 1; j < n; ++j) {
			ans += max(dist[i][j], dist[j][i]);
		}
	}

	cout << ans << endl;
}