#include <iostream>
#include <vector>
#include <algorithm>
#include <utility>
#include <numeric>
#include <map>
#include <set>

using namespace std;

#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()

using uint = unsigned int;
using int64 = long long;
using uint64 = unsigned long long;

const int64 INF = (int64)1e18 + 2;

vector <vector <int>> g;
vector <int> cost;
vector <pair <int64, int64>> sg;
vector <int> sz;

int64 checkDfs(int v) {
	int64 mn = 0;
	int size = 1;
	for (auto& u : g[v]) {
		int64 uans = checkDfs(u);
		if (uans == -1) {
			return -1;
		}
		mn += uans;
		size += sz[u];
	}
	sz[v] = size;

	if (mn > sg[v].second) return -1;
	return max(mn, sg[v].first);
}

int64 ans;
vector <int64> cnt;
vector <int64> can;
vector <int> pr;

int64 getmn(int v) {
	int64 mn = INF;
	while (v != -1) {
		mn = min(mn, can[v]);
		v = pr[v];
	}
	return mn;
}
void add(int v, int64 value) {
	while (v != -1) {
		can[v] -= value;
		v = pr[v];
	}
}

vector <int64> sp;
set <pair <int64, int64>> dfs(int v) {
	int mx = -1;
	for (auto u : g[v]) {
		if (mx == -1 || sz[u] > sz[mx]) {
			mx = u;
		}
	}

	if (mx == -1) {
		set <pair <int64, int64>> st;

		ans += cost[v] * (can[v] - (sg[v].second - sg[v].first));
		cnt[v] += can[v] - (sg[v].second - sg[v].first);
		sp[v] = cnt[v];

		//add(v, can[v] - (sg[v].second - sg[v].first));
		if (can[v] != 0) st.insert({ cost[v], v });
		return st;
	}


	auto st = dfs(mx);
	sp[v] += sp[mx];
	for (auto u : g[v]) {
		if (u != mx) {
			auto st1 = dfs(u);
			sp[v] += sp[u];
			for (auto& x : st1) {
				st.insert(x);
			}
		}
	}
	st.insert({ cost[v], v });

	can[v] -= sp[v];

	while (can[v] > sg[v].second - sg[v].first) {
		int64 mn = can[st.begin()->second];//getmn(st.begin()->second);
		if (mn <= can[v] - (sg[v].second - sg[v].first)) {
			add(st.begin()->second, mn);

			ans += mn * st.begin()->first;
			cnt[st.begin()->second] += mn;

			st.erase(st.begin());
		}
		else {
			mn = can[v] - (sg[v].second - sg[v].first);
			sp[v] += mn;

			//add(st.begin()->second, mn);

			ans += mn * st.begin()->first;
			cnt[st.begin()->second] += mn;
		}
		break;
	}

	return st;
}

void solve() {
	int n; cin >> n;
	g.assign(n, {});
	pr.assign(n, -1);
	for (int i = 1; i < n; ++i) {
		int p; cin >> p;
		g[p - 1].push_back(i);
		pr[i] = p - 1;
	}

	cost.assign(n, 0);
	for (auto& x : cost) cin >> x;

	sg.assign(n, { 0, 0 });
	for (auto& [f, s] : sg) cin >> f >> s;

	sz.assign(n, 0);
	if (checkDfs(0) == -1) {
		cout << -1;
		return;
	}

	ans = 0;
	cnt.assign(n, 0);
	can.assign(n, 0);
	sp.assign(n, 0);
	for (int i = 0; i < n; ++i) {
		can[i] = sg[i].second;
	}
	dfs(0);

	cout << ans << '\n';
	for (auto x : cnt) cout << x << ' ';
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	int q; cin >> q;
	while (q--) {
		solve();
		cout << "\n\n";
	}
}