#include <iostream>
#include <vector>
#include <algorithm>
#include <utility>
#include <numeric>
#include <map>
#include <set>

using namespace std;

#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()

using uint = unsigned int;
using int64 = long long;
using uint64 = unsigned long long;

const int64 INF = (int64)1e18 + 2;

int64 toint(pair <int64, int64> p) {
	return p.first * (p.first + 1) / 2 + p.second;
}


vector <vector <int64>> g;
vector <pair <int64, int64>> t;
int64 curt = -1;
void tdfs(int64 v) {
	t[v].first = ++curt;
	for (auto u : g[v]) {
		tdfs(u);
	}
	t[v].second = ++curt;
}

void solve() {
	int n; cin >> n;
	vector <int64> pr((int64)(n + 1) * (n + 2) / 2, -2);
	pr[0] = -1;
	vector <pair <int, int>> way(n + 1, { 0, 0 });
	for (int i = 1; i <= n; ++i) {
		way[i] = way[i - 1];
		++way[i].first;
		++way[i].second;
	}
	for (int i = 1; i <= n; ++i) {
		pr[toint(way[i])] = toint(way[i - 1]);
	}

	for (int i = 0; i < n; ++i) {
		int a = 0; cin >> a;
		for (int i = a; i <= n; ++i) --way[i].second;

		for (int i = 1; i <= n; ++i) {
			pr[toint(way[i])] = toint(way[i - 1]);
		}
	}

	g.resize(pr.size());
	for (int i = 1; i < g.size(); ++i) {
		g[pr[i]].push_back(i);
	}

	t.resize(pr.size());
	tdfs(0);

	int q; cin >> q;
	while (q--) {
		pair <int64, int64> a0, b0;
		cin >> a0.first >> a0.second >> b0.first >> b0.second;
		int64 a = toint(a0), b = toint(b0);

		while (!(t[a].first <= t[b].first && t[b].second <= t[a].second)) {
			a = pr[a];
		}

		pair <int64, int64> ans;
		int i = 1;
		int64 s = 0;
		while (s + i < a) {
			s += i;
			++i;
		}
		ans.first = i - 1;
		a -= s;
		ans.second = a;

		cout << ans.first << ' ' << ans.second << '\n';
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	int q = 1; //cin >> q;
	while (q--) {
		solve();
		cout << "\n\n";
	}
}