#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
#pragma optimize("Ofast")
#pragma optimize("unroll-loops")


vector<unordered_set<int>> g;
//vector<vector<int>> up;
vector<short> depth;
vector<int> euler;
vector<pair<int, int>> euler_ind;
const int inf = (ll) 1e9;
vector<int> tin, tout;
int T = 0;

void dfs(int v) {
    tin[v] = T++;
    euler_ind[v].first = euler.size();
    euler.push_back(v);
    for (int u: g[v]) {
        depth[u] = depth[v] + 1;
//        up[0][u] = v;
        dfs(u);
        euler_ind[v].second = euler.size();
        euler.push_back(v);
    }
    euler_ind[v].second = euler.size();
    euler.push_back(v);
    tout[v] = T++;
}


vector<pair<short, int>> tree;

void build(int v, int vl, int vr) {
    if (vr - vl == 1) {
        tree[v] = {depth[euler[vl]], euler[vl]};
        return;
    }
    int vm = (vl + vr) / 2;
    build(2 * v + 1, vl, vm);
    build(2 * v + 2, vm, vr);
    tree[v] = min(tree[2 * v + 1], tree[2 * v + 2]);
    tree[v] = min(tree[2 * v + 1], tree[2 * v + 2]);
}


pair<int, short> get_min(int v, int vl, int vr, int l, int r) {
    if (l <= vl && vr <= r) return tree[v];
    if (l >= vr || r <= vl) return {inf, -1};
    int vm = (vl + vr) / 2;
    auto v1 = get_min(2 * v + 1, vl, vm, l, r);
    auto v2 = get_min(2 * v + 2, vm, vr, l, r);
    return min(v1, v2);
}


bool is_anc(int v1, int v2) {
    if (tin[v1] <= tin[v2] && tout[v1] >= tout[v2]) return true;
    return false;
}


int main() {
    cin.tie(nullptr);
    ios::sync_with_stdio(false);
    int n;
    cin >> n;
    int vert = (n + 1) * (n + 2) / 2;
    if (n <= 3000) {
        depth.resize(vert);
        tin.resize(vert);
        tout.resize(vert);
        g.resize(vert);
        vector<bool> a(n, 1);


//        vector<vector<int>> num(n + 1, vector<int>(n + 1));
//        int cur = 0;
//        for (int i = 0; i <= n; i++) {
//            for (int j = 0; j <= i; j++) {
//                num[i][j] = cur++;
//            }
//        }


        for (int epochs = 0; epochs <= n; epochs++) {
            if (epochs != 0) {
                int ind;
                cin >> ind;
                a[ind - 1] = false;
            }
            int r = 0, c = 0;
            for (int layer = 0; layer < n; layer++) {
                int next_r = r + 1, next_c = c + a[layer];
                int old = r * (r + 1) / 2 + c;
                int mnew = (next_r + 1) * next_r / 2 + next_c;
                g[old].insert(mnew);
                r = next_r;
                c = next_c;
            }
        }
        euler_ind.resize(vert);
        depth[0] = 0;
        dfs(0);
        tree.resize(4 * (euler.size()));
        build(0, 0, euler.size());

        int q;
        cin >> q;
        while (q--) {
            int r1, c1, r2, c2;
            cin >> r1 >> c1 >> r2 >> c2;
            int v1 = r1 * (r1 + 1) / 2 + c1;
            int v2 = r2 * (r2 + 1) / 2 + c2;
            int ans;
            if (is_anc(v1, v2)) {
                ans = v1;
            } else if (is_anc(v2, v1)) {
                ans = v2;
            } else {
                int l = euler_ind[v1].second, r = euler_ind[v2].first;
                if (l > r) {
                    l = euler_ind[v2].second;
                    r = euler_ind[v1].first;
                }
                ans = get_min(0, 0, euler.size(), l, r).second;
            }

            int left = 0, right = n + 1;
            if (ans == 0) {
                cout << "0 0\n";
                continue;
            }
            while (right - left > 1) {
                int mid = (left + right) / 2;
                if (mid * (mid + 1) / 2 <= ans) left = mid;
                else right = mid;
            }
            cout << left << ' ' << ans - left * (left + 1) / 2 << '\n';

        }
    }
}

