#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse3,sse4,avx")

#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

struct node
{
	vector<int> f;
	int size;
	node(int size) : size(size)
	{
		f.resize(size);
	}

	inline void add(int i, int x)
	{
		while (i < size)
		{
			f[i] += x;
			i |= (i + 1);
		}
	}

	inline int getpref(int i)
	{
		int res = 0;
		while (i >= 0)
		{
			res += f[i];
			i = (i & (i + 1)) - 1;
		}
		return res;
	}

	inline int get(int i, int j)
	{
		return getpref(j) - getpref(i - 1);
	}
};

vector<node> tree;
void add(int v, int vl, int vr, int i, int j, int x)
{
	tree[v].add(j, x);
	if (vr - vl == 1)
	{
		return;
	}
	if (i < (vl + vr) / 2)
	{
		add(2 * v + 1, vl, (vl + vr) / 2, i, j, x);
	}
	else
	{
		add(2 * v + 2, (vl + vr) / 2, vr, i, j, x);
	}
}

int get(int v, int vl, int vr, int qlx, int qrx, int qly, int qry)
{
	if (vl >= qrx || vr <= qlx)
	{
		return 0;
	}
	if (vl >= qlx && vr <= qrx)
	{
		return tree[v].get(qly, qry - 1);
	}
	return get(2 * v + 1, vl, (vl + vr) / 2, qlx, qrx, qly, qry) + get(2 * v + 2, (vl + vr) / 2, vr, qlx, qrx, qly, qry);
}

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	int n;
	cin >> n;
	vector<int> a(n);

	int tsize = 1;
	while (tsize < n) tsize <<= 1;

	tree.assign(2 * tsize, node(n + 1));

	for (int i = 0; i < n; i++)
	{
		cin >> a[i];
		add(0, 0, tsize, i, a[i], 1);
	}

	long long sum = 0;

	for (int i = 0; i < n; i++)
	{
		for (int j = i + 1; j < n; j++)
		{
			int curd = j - i;
			curd = max(curd, abs(a[j] - a[i]));
			int lesssuf = get(0, 0, tsize, j, tsize, 0, a[j]);
			//for (int k = j + 1; k < n; k++)
			//{
			//	if (a[k] < a[j])
			//	{
			//		lesssuf++;
			//	}
			//}

			curd = max(curd, j + lesssuf - i);

			int grepref = get(0, 0, tsize, 0, i, a[i], n + 1);
			//for (int k = 0; k < i; k++)
			//{
			//	if (a[k] > a[i])
			//	{
			//		grepref++;
			//	}
			//}

			curd = max(curd, j - i + grepref);

			sum += curd;
		}
	}

	cout << sum;
	return 0;
}