#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>
#include <set>

using namespace std;

vector<vector<int>> gr;
vector<int> sz;
vector<int> pr;

vector<int> et;
vector<int> top;
vector<int> tin;
vector<int> tout;
vector<int> ind;

vector<int> l;
vector<int> r;
int tsize;

void dfssz(int v)
{
	sz[v] = 1;
	int maxsz = -1;
	for (int i = 0; i < gr[v].size(); i++)
	{
		dfssz(gr[v][i]);
		if (maxsz == -1 || sz[gr[v][i]] > sz[gr[v][maxsz]])
		{
			maxsz = i;
		}
	}
	if (maxsz != -1)
	{
		swap(gr[v][0], gr[v][maxsz]);
	}
}

void dfset(int v, int tp)
{
	tin[v] = et.size();
	ind[v] = et.size();
	top[v] = tp;
	et.push_back(v);
	bool first = 1;
	for (auto to : gr[v])
	{
		dfset(to, (first ? tp : to));
		first = 0;
	}
	tout[v] = et.size() - 1;
}

struct nodel
{
	int maxv;
	int add;
};
struct noder
{
	int minv;
	int add;
};

vector<nodel> trl;
vector<noder> trr;

void pushl(int v, int vl, int vr)
{
	trl[v].maxv += trl[v].add;
	if (vr - vl != 1)
	{
		trl[2 * v + 1].add += trl[v].add;
		trl[2 * v + 2].add += trl[v].add;
	}
	trl[v].add = 0;
}
void pushr(int v, int vl, int vr)
{
	trr[v].minv += trr[v].add;
	if (vr - vl != 1)
	{
		trr[2 * v + 1].add += trr[v].add;
		trr[2 * v + 2].add += trr[v].add;
	}
	trr[v].add = 0;
}

inline int getl(int v)
{
	return trl[v].maxv + trl[v].add;
}

inline int getr(int v)
{
	return trr[v].minv + trr[v].add;
}

void addl(int v, int vl, int vr, int ql, int qr, int x)
{
	if (vl >= qr || vr <= ql)
	{
		return;
	}
	if (vl >= ql && vr <= qr)
	{
		trl[v].add += x;
		return;
	}
	pushl(v, vl, vr);
	addl(2 * v + 1, vl, (vl + vr) / 2, ql, qr, x);
	addl(2 * v + 2, (vl + vr) / 2, vr, ql, qr, x);
	trl[v].maxv = max(getl(2 * v + 1), getl(2 * v + 2));
}

void addr(int v, int vl, int vr, int ql, int qr, int x)
{
	if (vl >= qr || vr <= ql)
	{
		return;
	}
	if (vl >= ql && vr <= qr)
	{
		trr[v].add += x;
		return;
	}
	pushr(v, vl, vr);
	addr(2 * v + 1, vl, (vl + vr) / 2, ql, qr, x);
	addr(2 * v + 2, (vl + vr) / 2, vr, ql, qr, x);
	trr[v].minv = min(getr(2 * v + 1), getr(2 * v + 2));
}

int mxl(int v, int vl, int vr, int ql, int qr)
{
	if (vl >= qr || vr <= ql)
	{
		return 0;
	}
	if (vl >= ql && vr <= qr)
	{
		return getl(v);
	}
	pushl(v, vl, vr);
	return max(mxl(2 * v + 1, vl, (vl + vr) / 2, ql, qr), mxl(2 * v + 2, (vl + vr) / 2, vr, ql, qr));
}

int mnr(int v, int vl, int vr, int ql, int qr)
{
	if (vl >= qr || vr <= ql)
	{
		return (int)2e9;
	}
	if (vl >= ql && vr <= qr)
	{
		return getr(v);
	}
	pushr(v, vl, vr);
	return min(mnr(2 * v + 1, vl, (vl + vr) / 2, ql, qr), mnr(2 * v + 2, (vl + vr) / 2, vr, ql, qr));
}

void build(int v, int vl, int vr, int n)
{
	if (vr - vl == 1)
	{
		if (vl < n)
		{
			trl[v].maxv = l[et[vl]];
			trr[v].minv = r[et[vl]];
		}
		else
		{
			trl[v].maxv = 0;
			trr[v].minv = 2e9;
		}
		return;
	}
	build(2 * v + 1, vl, (vl + vr) / 2, n);
	build(2 * v + 2, (vl + vr) / 2, vr, n);
	trl[v].maxv = max(trl[2 * v + 1].maxv, trl[2 * v + 2].maxv);
	trr[v].minv = min(trr[2 * v + 1].minv, trr[2 * v + 2].minv);
}

int getval(int v)
{
	//int maxl = l[v];
	//int minr = r[v];
	int maxl = mxl(0, 0, tsize, ind[v], ind[v] + 1);
	int minr = mnr(0, 0, tsize, ind[v], ind[v] + 1);
	while (v != 0)
	{
		if (top[v] == v)
		{
			v = pr[v];
			//maxl = max(maxl, l[v]);
			//minr = min(minr, r[v]);
			maxl = max(maxl, mxl(0, 0, tsize, ind[v], ind[v] + 1));
			minr = min(minr, mnr(0, 0, tsize, ind[v], ind[v] + 1));
		}
		else
		{
			maxl = max(maxl, mxl(0, 0, tsize, ind[top[v]], ind[v]));
			minr = min(minr, mnr(0, 0, tsize, ind[top[v]], ind[v]));
			v = top[v];
		}
	}
	return min(maxl, minr);
}

void submin(int v, int val)
{
	addl(0, 0, tsize, ind[v], ind[v] + 1, -val);
	addr(0, 0, tsize, ind[v], ind[v] + 1, -val);
	while (v != 0)
	{
		if (top[v] == v)
		{
			v = pr[v];
			l[v] -= val;
			r[v] -= val;
			addl(0, 0, tsize, ind[v], ind[v] + 1, -val);
			addr(0, 0, tsize, ind[v], ind[v] + 1, -val);
		}
		else
		{
			addl(0, 0, tsize, ind[top[v]], v, -val);
			addr(0, 0, tsize, ind[top[v]], v, -val);
			v = top[v];
		}
	}
}

vector<int> c;
vector<int> cnt;

void dfssolve(int v, set<pair<int, int>>& s)
{
	if (gr[v].size() == 0)
	{
		s.insert({ c[v], v });
		int curadd = getval(v);
		cnt[v] += curadd;
		submin(v, cnt[v]);
		return;
	}
	dfssolve(gr[v][0], s);
	for (int i = 1; i < gr[v].size(); i++)
	{
		set<pair<int, int>> cur;
		dfssolve(gr[v][i], cur);
		for (auto& p : cur)
		{
			s.insert(p);
		}
	}
	s.insert({ c[v], v });
	while (mxl(0, 0, tsize, ind[v], ind[v] + 1) != 0 && !s.empty())
	{
		auto [curc, x] = *s.begin();
		int curmax = getval(x);
		submin(x, curmax);
		cnt[v] += curmax;
		if (curmax == 0)
		{
			s.erase(s.begin());
		}
	}
}

void solve()
{
	int n;
	cin >> n;
	gr.assign(n, vector<int>(0));
	pr.resize(n);
	sz.resize(n);
	l.resize(n);
	r.resize(n);

	et.resize(0);
	top.resize(n);
	tin.resize(n);
	tout.resize(n);
	ind.resize(n);

	tsize = 1;
	while (tsize < n) tsize <<= 1;
	trl.resize(2 * tsize);
	trr.resize(2 * tsize);

	for (int i = 1; i < n; i++)
	{
		int p;
		cin >> p;
		p--;
		gr[p].push_back(i);
	}

	c.resize(n);
	cnt.resize(n);
	for (int i = 0; i < n; i++)
	{
		cin >> c[i];
	}

	for (int i = 0; i < n; i++)
	{
		cin >> l[i] >> r[i];
	}

	dfssz(0);
	dfset(0, 0);
	build(0, 0, tsize, n);

	set<pair<int, int>> s;
	dfssolve(0, s);

	int maxl = 0;
	int minl = 0;
	for (int i = 0; i < n; i++)
	{
		maxl = max(maxl, mxl(0, 0, tsize, 0, i + 1));
		minl = min(minl, mxl(0, 0, tsize, 0, i + 1));
	}
	if (maxl != 0 || minl != 0)
	{
		cout << -1;
		return;
	}

	long long sum = 0;
	for (int i = 0; i < n; i++)
	{
		sum += (long long)cnt[i] * c[i];
	}

	cout << sum << "\n";
	for (int i = 0; i < n; i++)
	{
		cout << cnt[i] << " ";
	}
}

int main()
{
#ifdef _DEBUG
#pragma warning(disable : 4996)
	freopen("input.txt", "r", stdin);
#endif // _DEBUG


	int t;
	cin >> t;
	for (int i = 0; i < t; i++)
	{
		solve();
		cout << "\n";
	}
	return 0;
}