#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>

using namespace std;

vector<vector<long long>> gr;
vector<long long> sz;
vector<long long> pr;

vector<long long> et;
vector<long long> top;
vector<long long> tin;
vector<long long> tout;
vector<long long> ind;

vector<long long> l;
vector<long long> r;
long long tsize;

void dfssz(long long v)
{
	sz[v] = 1;
	long long maxsz = -1;
	for (long long i = 0; i < gr[v].size(); i++)
	{
		dfssz(gr[v][i]);
		if (maxsz == -1 || sz[gr[v][i]] > sz[gr[v][maxsz]])
		{
			maxsz = i;
		}
	}
	if (maxsz != -1)
	{
		swap(gr[v][0], gr[v][maxsz]);
	}
}

void dfset(long long v, long long tp)
{
	tin[v] = et.size();
	ind[v] = et.size();
	top[v] = tp;
	et.push_back(v);
	bool first = 1;
	for (auto to : gr[v])
	{
		dfset(to, (first ? tp : to));
		first = 0;
	}
	tout[v] = et.size() - 1;
}

struct nodel
{
	long long maxv;
	long long add;
};
struct noder
{
	long long minv;
	long long add;
};

vector<nodel> trl;
vector<noder> trr;

void pushl(long long v, long long vl, long long vr)
{
	trl[v].maxv += trl[v].add;
	if (vr - vl != 1)
	{
		trl[2 * v + 1].add += trl[v].add;
		trl[2 * v + 2].add += trl[v].add;
	}
	trl[v].add = 0;
}
void pushr(long long v, long long vl, long long vr)
{
	trr[v].minv += trr[v].add;
	if (vr - vl != 1)
	{
		trr[2 * v + 1].add += trr[v].add;
		trr[2 * v + 2].add += trr[v].add;
	}
	trr[v].add = 0;
}

inline long long getl(long long v)
{
	return trl[v].maxv + trl[v].add;
}

inline long long getr(long long v)
{
	return trr[v].minv + trr[v].add;
}

void addl(long long v, long long vl, long long vr, long long ql, long long qr, long long x)
{
	if (vl >= qr || vr <= ql)
	{
		return;
	}
	if (vl >= ql && vr <= qr)
	{
		trl[v].add += x;
		return;
	}
	pushl(v, vl, vr);
	addl(2 * v + 1, vl, (vl + vr) / 2, ql, qr, x);
	addl(2 * v + 2, (vl + vr) / 2, vr, ql, qr, x);
	trl[v].maxv = max(getl(2 * v + 1), getl(2 * v + 2));
}

void addr(long long v, long long vl, long long vr, long long ql, long long qr, long long x)
{
	if (vl >= qr || vr <= ql)
	{
		return;
	}
	if (vl >= ql && vr <= qr)
	{
		trr[v].add += x;
		return;
	}
	pushr(v, vl, vr);
	addr(2 * v + 1, vl, (vl + vr) / 2, ql, qr, x);
	addr(2 * v + 2, (vl + vr) / 2, vr, ql, qr, x);
	trr[v].minv = min(getr(2 * v + 1), getr(2 * v + 2));
}

long long mxl(long long v, long long vl, long long vr, long long ql, long long qr)
{
	if (vl >= qr || vr <= ql)
	{
		return 0;
	}
	if (vl >= ql && vr <= qr)
	{
		return getl(v);
	}
	pushl(v, vl, vr);
	return max(mxl(2 * v + 1, vl, (vl + vr) / 2, ql, qr), mxl(2 * v + 2, (vl + vr) / 2, vr, ql, qr));
}

long long mnr(long long v, long long vl, long long vr, long long ql, long long qr)
{
	if (vl >= qr || vr <= ql)
	{
		return (long long)2e9;
	}
	if (vl >= ql && vr <= qr)
	{
		return getr(v);
	}
	pushr(v, vl, vr);
	return min(mnr(2 * v + 1, vl, (vl + vr) / 2, ql, qr), mnr(2 * v + 2, (vl + vr) / 2, vr, ql, qr));
}

void build(long long v, long long vl, long long vr, long long n)
{
	if (vr - vl == 1)
	{
		if (vl < n)
		{
			trl[v].maxv = l[et[vl]];
			trr[v].minv = r[et[vl]];
		}
		else
		{
			trl[v].maxv = 0;
			trr[v].minv = 2e9;
		}
		return;
	}
	build(2 * v + 1, vl, (vl + vr) / 2, n);
	build(2 * v + 2, (vl + vr) / 2, vr, n);
	trl[v].maxv = max(trl[2 * v + 1].maxv, trl[2 * v + 2].maxv);
	trr[v].minv = min(trr[2 * v + 1].minv, trr[2 * v + 2].minv);
}

long long getval(long long v)
{
	//long long maxl = l[v];
	//long long minr = r[v];
	long long maxl = mxl(0, 0, tsize, ind[v], ind[v] + 1);
	long long minr = mnr(0, 0, tsize, ind[v], ind[v] + 1);
	while (v != 0)
	{
		if (top[v] == v)
		{
			v = pr[v];
			//maxl = max(maxl, l[v]);
			//minr = min(minr, r[v]);
			maxl = max(maxl, mxl(0, 0, tsize, ind[v], ind[v] + 1));
			minr = min(minr, mnr(0, 0, tsize, ind[v], ind[v] + 1));
		}
		else
		{
			maxl = max(maxl, mxl(0, 0, tsize, ind[top[v]], ind[v]));
			minr = min(minr, mnr(0, 0, tsize, ind[top[v]], ind[v]));
			v = top[v];
		}
	}
	return min(maxl, minr);
}

void submin(long long v, long long val)
{
	addl(0, 0, tsize, ind[v], ind[v] + 1, -val);
	addr(0, 0, tsize, ind[v], ind[v] + 1, -val);
	while (v != 0)
	{
		if (top[v] == v)
		{
			v = pr[v];
			l[v] -= val;
			r[v] -= val;
			addl(0, 0, tsize, ind[v], ind[v] + 1, -val);
			addr(0, 0, tsize, ind[v], ind[v] + 1, -val);
		}
		else
		{
			addl(0, 0, tsize, ind[top[v]], v, -val);
			addr(0, 0, tsize, ind[top[v]], v, -val);
			v = top[v];
		}
	}
}

void solve()
{
	long long n;
	cin >> n;
	gr.assign(n, vector<long long>(0));
	pr.resize(n);
	sz.resize(n);
	l.resize(n);
	r.resize(n);

	et.resize(0);
	top.resize(n);
	tin.resize(n);
	tout.resize(n);
	ind.resize(n);

	tsize = 1;
	while (tsize < n) tsize <<= 1;
	trl.resize(2 * tsize);
	trr.resize(2 * tsize);

	for (long long i = 1; i < n; i++)
	{
		long long p;
		cin >> p;
		p--;
		gr[p].push_back(i);
	}

	vector<long long> c(n);
	for (long long i = 0; i < n; i++)
	{
		cin >> c[i];
	}

	for (long long i = 0; i < n; i++)
	{
		cin >> l[i] >> r[i];
	}

	dfssz(0);
	dfset(0, 0);
	build(0, 0, tsize, n);

	vector<long long> perm(n);
	iota(perm.begin(), perm.end(), 0);
	sort(perm.begin(), perm.end(), [&c](long long a, long long b)
		{
			return c[a] < c[b];
		});

	vector<long long> cnt(n, 0);
	for (long long i = 0; i < n; i++)
	{
		long long curm = getval(perm[i]);
		submin(perm[i], curm);
		cnt[perm[i]] += curm;
	}

	long long maxl = 0;
	for (long long i = 0; i < n; i++)
	{
		maxl = max(maxl, mxl(0, 0, tsize, 0, i + 1));
	}
	if (maxl != 0)
	{
		cout << -1;
		return;
	}

	long long sum = 0;
	for (long long i = 0; i < n; i++)
	{
		sum += (long long)cnt[i] * c[i];
	}

	cout << sum << "\n";
	for (long long i = 0; i < n; i++)
	{
		cout << cnt[i] << " ";
	}
}

int main()
{
#ifdef _DEBUG
#pragma warning(disable : 4996)
	freopen("input.txt", "r", stdin);
#endif // _DEBUG


	long long t;
	cin >> t;
	for (long long i = 0; i < t; i++)
	{
		solve();
		cout << "\n";
	}
	return 0;
}