#include <iostream>
#include <bits/stdc++.h>

//#pragma GCC optimize("Ofast");
//#pragma GCC optimize("O3");

#define fastio ios_base::sync_with_stdio(NULL);cin.tie(0);cout.tie(0);
#define int long long
#define filein freopen("input.txt", "r", stdin);
#define fileout freopen("output.txt", "w", stdout);
#define infi 1e9

using namespace std;

const int c = 20;

map<pair<int, int>, int> global;
map<int, pair<int, int>> revglobal;

struct sparse_table{
    vector<vector<pair<int, int>>> sparse;
    vector<int> dp;
    void build(vector<pair<int, int>> &vec){
        int n = vec.size();
        dp.resize(n+1, 0);

        for(int i = 2; i <= n; i++){
            dp[i] = dp[i/2]+1;
        }

        sparse.resize(n, vector<pair<int, int>> (c, {infi, infi}));
        for(int i = 0; i < n; i++){
            sparse[i][0] = vec[i];
        }

        for(int i = 1; i <= c; i++){
            for(int k = 0; k < n; k++){
                if((1 << i) + k > n) continue;
                sparse[k][i] = min(sparse[k][i-1], sparse[k + (1 << (i-1))][i-1]);
            }
        }
    }

    pair<int, int> get(int l, int r){
        int len = dp[r-l];
        return min(sparse[l][len], sparse[r - (1 << len)][len]);
    }
};

vector<pair<int, int>> path;
vector<int> used;

void dfs(int v, int dipth, vector<vector<int>> &graph){
    path.push_back({dipth, v});
    used[v] = 1;
    for(auto to : graph[v]){
        if(used[to] == 0){
            dfs(to, dipth+1, graph);
            path.push_back({dipth, v});
        }
    }
}

void LCA(int n, vector<vector<int>> &graph){
    used.resize(n, 0);
    dfs(0, 0, graph);

    map<int, int> mp;

    for(int i = 0; i < path.size(); i++){
        mp[path[i].second] = i;
    }

    sparse_table st;
    st.build(path);

    int q;
    cin >> q;
    while(q--){
        int a, b;
        cin >> a >> b;
        int cc, d;
        cin >> cc >> d;
        int vl = global[{a, b}], vr = global[{cc, d}];
        auto t = st.get(min(mp[vl], mp[vr]), max(mp[vr], mp[vl])).second;
        int ansx = revglobal[t].first;
        int ansy = revglobal[t].second;
        cout << ansx << " " << ansy << "\n";
    }
}

void build(pair<int, int> a, vector<int> comand, int cnt, vector<vector<int>> &graph){
    if(cnt == comand.size()) return;
    if(comand[cnt] == 0){
        graph[global[a]].push_back(global[{a.first + 1, a.second}]);
        build({a.first+1, a.second}, comand, cnt+1, graph);
    }else{
        graph[global[a]].push_back(global[{a.first + 1, a.second + 1}]);
        build({a.first+1, a.second + 1}, comand, cnt+1, graph);
    }
}

void solve(){
    int n;
    cin >> n;
    int cnt = 0;
    for(int i = 0; i < n+1; i++){
        for(int j = 0; j <= i; j++){
            global[{i, j}] = cnt;
            revglobal[cnt] = {i, j};
            cnt++;
        }
    }

    vector<int> vec(n, 0);
    vector<int> comand;

    for(int i = 0; i < n; i++){
        comand.push_back(1);
    }

    vector<vector<int>> graph(1e4);

    for(int i = 0; i < n; i++){
        build({0, 0}, comand, 0, graph);
        cin >> vec[i];
        comand[vec[i] - 1] = 0;
    }
    build({0, 0}, comand, 0, graph);

    LCA(1e4, graph);
}

int32_t main() {
    //filein
    //fileout
    fastio

    int q = 1;

    while(q--){
        solve();
    }

    //std::cout << "Hello, World!" << std::endl;
    return 0;
}



/*
 *  int left[n];
    int right[n];

    for(int i = 0; i < n; i++) left[i] = pos[i];
    for(int j = 0; j < n; j++) right[j] = pos[j];

    vector<int> count(n);
    vector<int> nw(n);

    for(int i = 0; i < n; i++){
        for(int j = i; j < n; j++){
            nw = a;
            for(int k = 0; k < n; k++) count[k] = 0;

            for(int k = i; k <= j; k++){
                count[a[k]]++;
            }
            int cnt = i;
            for(int k = 0; k < n; k++){
                if(count[k] > 0){
                   nw[cnt] = k;
                   cnt++;
                }
            }

            for(int k = i; k <= j; k++){
                left[nw[k]] = min(left[nw[k]], k);
            }
            for(int k = i; k <= j; k++){
                right[nw[k]] = max(right[nw[k]], k);
            }
        }
    }

    int ans = 0;

    for(int i = 0; i < n; i++){
        for(int j = i+1; j < n; j++){
            ans += max(max(max(abs(right[j] - pos[i]), abs(left[j] - pos[i])), max(abs(right[i] - pos[j]), abs(left[i] - pos[j]))), j-i);
        }
    }

    cout << ans << "\n";
 */