#include <bits/stdc++.h>

struct Vector {
    int x, y;

    Vector() : x(0), y(0) {
        ;
    }

    Vector(int x, int y) : x(x), y(y) {
        ;
    }

    Vector operator+(const Vector& other) const {
        return Vector(x + other.x, y + other.y);
    }

    Vector operator-(const Vector& other) const {
        return Vector(x - other.x, y - other.y);
    }

    int64_t surf() const {
        return llabs(x * 1LL * y);
    }

    bool operator<(const Vector& other) const {
        return std::pair{x, y} < std::pair{other.x, other.y};
    }
};

int64_t uni(std::vector<std::pair<Vector, Vector>>& vec, const std::vector<int>& vy) {
    int m = vy.size() - 1;
    static std::vector<int> cum;
    cum.assign(m, 0);
    static std::vector<std::array<int, 4>> ev;
    ev.clear();
    for (auto& [v1, v2] : vec) {
        if (v1.x > v2.x) {
            std::swap(v1.x, v2.x);
        }
        if (v1.y > v2.y) {
            std::swap(v1.y, v2.y);
        }

        int it1 = std::lower_bound(vy.begin(), vy.end(), v1.y) - vy.begin();
        int it2 = std::lower_bound(vy.begin(), vy.end(), v2.y) - vy.begin();
        ev.push_back({v1.x, 1, it1, it2});
        ev.push_back({v2.x, -1, it1, it2});
    }
    std::sort(ev.begin(), ev.end());
    int64_t ans = 0;
    for (int i = 0; i < ev.size(); i++) {
        auto [x1, d, l, r] = ev[i];
        for (int i = l; i < r; i++) {
            cum[i] += d;
        }
        int64_t rs = 0;
        for (int i = 0; i < m; i++) {
            rs += (vy[i + 1] - vy[i]) * 1LL * bool(cum[i]);
        }
        if (i > 0) {
            ans += rs * (x1 - ev[i - 1].front());
        }
    }
    return ans;
}

void solve() {
    int n;
    Vector r;
    std::cin >> n >> r.x >> r.y;
    std::vector<Vector> input(n);
    for (auto& [x, y] : input) {
        std::cin >> x >> y;
    }
    if (n > 7) {
        std::cout << r.x * 1LL * r.y << "\n";
        return;
    }
    std::vector<int> vy = {0, r.y};
    for (auto& [x, y] : input) {
        vy.push_back(y);
    }
    std::sort(vy.begin(), vy.end());
    vy.erase(std::unique(vy.begin(), vy.end()), vy.end());

    std::vector<std::pair<Vector, Vector>> vec;
    int64_t ans = 0;
    for (int mask = 0; mask < (1 << 2 * n); mask++) {
        vec.clear();
        for (int i = 0; i < n; i++) {
            int dr = (mask >> 2 * i) & 3;
            vec.push_back({input[i], Vector()});
            if (dr == 0) {
                vec.back().second = r;
            } else if (dr == 1) {
                vec.back().second = Vector(0, r.y);
            } else if (dr == 2) {
                vec.back().second = Vector(0, 0);
            } else {
                vec.back().second = Vector(r.x, 0);
            }
        }
        ans = std::max(ans, uni(vec, vy));
        if (uni(vec, vy) == 48) {
            uni(vec, vy);
        }
    }
    std::cout << ans << "\n";
}

int32_t main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);

    int k;
    std::cin >> k;
    std::vector<int> inp_dir(k);
    for (int& i : inp_dir) {
        std::cin >> i;
        i--;
    }

    int t;
    std::cin >> t;
    while (t--) {
        solve();
    }

    return 0;
}
