#include <iostream>
#include <iomanip>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <cmath>
#include <vector>

typedef int_fast64_t ll;
typedef long double ld;

#define int int_fast64_t
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define input(a) for (auto& _ : a) cin >> _
#define print(a) for (auto _ : a) cout << _ << " "
#define mset multiset
#define mp make_pair

using namespace std;

const int MAXN = 1e5 + 10;

vector<int> c, l, r, b, s, p, tin, sz, start, h, t, ps, obr;
vector<vector<int>> g;
vector<set<pair<int, int>>> m;
bool flag = true;
int timer = 0;
int n;

void build(int v, int tl, int tr) {
	if (tr - tl == 1)
		t[v] = r[obr[tl]];
	else {
		int m = (tr + tl) / 2;
		build(v * 2, tl, m);
		build(v * 2 + 1, m, tr);
		t[v] = min(t[v * 2], t[v * 2 + 1]);
	}
}

void push(int v, int tl, int tr) {
	if (tr - tl > 1) {
		ps[v * 2] += ps[v];
		ps[v * 2 + 1] += ps[v];
	}
	t[v] += ps[v];
	ps[v] = 0;
}

void update(int v, int tl, int tr, int l, int r, int x) {
	push(v, tl, tr);
	if (r <= tl || tr <= l)
		return;
	if (l <= tl && r >= tr) {
		ps[v] += x;
		push(v, tl, tr);
		return;
	}
	int m = (tr + tl) / 2;
	update(v * 2, tl, m, l, r, x);
	update(v * 2 + 1, m, tr, l, r, x);
	t[v] = min(t[v * 2], t[v * 2 + 1]);
}

int get(int v, int tl, int tr, int l, int r) {
	push(v, tl, tr);
	if (r <= tl || tr <= l)
		return 1e18;
	if (l <= tl && r >= tr)
		return t[v];
	int m = (tr + tl) / 2;
	return min(get(v * 2, tl, m, l, r), get(v * 2 + 1, m, tr, l, r));
}

int mn(int v, int u) {
	int res = 1e18;
	while (h[start[v]] > h[u]) {
		res = min(res, get(1, 0, n, tin[start[v]], tin[v] + 1));
		v = p[start[v]];
	}
	res = min(res, get(1, 0, n, tin[u] + 1, tin[v] + 1));
	return res;
}

void pl(int v, int u, int k) {
	while (h[start[v]] > h[u]) {
		update(1, 0, n, tin[start[v]], tin[v] + 1, -k);
		v = p[start[v]];
	}
	update(1, 0, n, tin[u] + 1, tin[v] + 1, -k);
}

void dfs1(int v) {
	sz[v] = 1;
	int mx = 0;
	for (int i = 0; i < g[v].size(); ++i) {
		h[g[v][i]] = h[v] + 1;
		dfs1(g[v][i]);
		sz[v] += sz[g[v][i]];
		if (sz[g[v][i]] > sz[g[v][mx]])
			mx = i;
	}
	if (g[v].size())
		swap(g[v][mx], g[v][0]);
}

void dfs2(int v) {
	tin[v] = ++timer;
	obr[tin[v]] = v;
	for (auto u : g[v]) {
		if (u == g[v][0])
			start[u] = start[v];
		else
			start[u] = u;
		dfs2(u);
	}
}

void dfs(int v) {
	if (g[v].size() == 0) {
		b[v] = l[v];
		s[v] = b[v];
		update(1, 0, n, tin[v], tin[v] + 1, -b[v]);
		m[v].insert({ c[v], v });
		return;
	}
	int mx = g[v][0];
	for (auto u : g[v]) {
		dfs(u);
		s[v] += s[u];
		update(1, 0, n, tin[v], tin[v] + 1, -s[u]);
		if (m[u].size() > m[mx].size())
			mx = u;
	}
	if (!flag)
		return;
	m[v].swap(m[mx]);
	m[v].insert({ c[v], v });
	for (auto u : g[v]) {
		if (u != mx) {
			for (auto i : m[u])
				m[v].insert(i);
		}
	}
	while (m[v].size() && s[v] < l[v]) {
		auto [w, u] = *m[v].begin();
		m[v].erase(m[v].begin());
		int k = mn(u, v);
		if (k >= l[v] - s[v]) {
			if (k > l[v] - s[v])
				m[v].insert({ w, u });
			b[u] += l[v] - s[v];
			pl(u, v, l[v] - s[v]);
			update(1, 0, n, tin[v], tin[v] + 1, -(l[v] - s[v]));
			s[v] = l[v];
		}
		else {
			pl(u, v, k);
			update(1, 0, n, tin[v], tin[v] + 1, -k);
			s[v] += k;
			b[u] += k;
		}
	}
	if (s[v] < l[v] || s[v] > r[v])
		flag = false;
}

void solve() {
	cin >> n;
	flag = true;
	m.clear();
	m.resize(n + 1);
	c.assign(n + 1, 0);
	l.assign(n + 1, 0);
	r.assign(n + 1, 0);
	b.assign(n + 1, 0);
	s.assign(n + 1, 0);
	p.assign(n + 1, 0);
	tin.assign(n + 1, 0);
	obr.assign(n + 1, 0);
	sz.assign(n + 1, 0);
	start.assign(n + 1, 0);
	h.assign(n + 1, 0);
	g.assign(n + 1, {});
	t.assign(4 * n + 10, 0);
	ps.assign(4 * n + 10, 0);
	timer = -1;
	for (int i = 2; i <= n; ++i) {
		cin >> p[i];
		g[p[i]].push_back(i);
	}
	for (int i = 1; i <= n; ++i)
		cin >> c[i];
	for (int i = 1; i <= n; ++i)
		cin >> l[i] >> r[i];
	start[1] = 1;
	dfs1(1);
	dfs2(1);
	build(1, 0, n);
	dfs(1);
	if (!flag) {
		cout << "-1\n";
		return;
	}
	int ans = 0;
	for (int i = 1; i <= n; ++i)
		ans += b[i] * c[i];
	cout << ans << '\n';
	for (int i = 1; i <= n; ++i)
		cout << b[i] << " ";
	cout << "\n";
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int t;
	cin >> t;
	while (t--)
		solve();
	return 0;
}