#include <bits/stdc++.h>

using num = long long;

struct Vertex
{
    num r, c;
    num p;
    std::vector<num> children;
};
std::vector<Vertex> graph;

num count(num r)
{
    return (r+1)*r/2;
}

num coords_to_ind(num r, num c)
{
    return count(r) + c;
}

void build_path(std::vector<bool> const& to_right)
{
    num curr = 0;
    num r = 0, c = 0;

    for(num i = 0; i < to_right.size(); i++)
    {
        r++;
        if(to_right[i])
            c++;
        const num next = coords_to_ind(r, c);
        graph[curr].children.push_back(next);
        graph[next].p = curr;
        curr = next;
    }
}

// на 3-ю

num diag(num r, num c)
{
    return r - c;
}

int main()
{
    num n;
    std::cin >> n;
    const num size = count(n+1);

    graph.resize(size);
    for(num i = 0, r = 0; r <= n; r++)
    {
        for(num c = 0; c <= r; c++, i++)
        {
            graph[i].r = r;
            graph[i].c = c;
        }
    }

    std::vector<bool> to_right(n, true);
    build_path(to_right);

    for(num i = 0; i < n; i++)
    {
        num a;
        std::cin >> a;
    }

    num q;
    std::cin >> q;
    while(q--)
    {
        num r1, c1, r2, c2;
        std::cin >> r1 >> c1 >> r2 >> c2;
        if(r1 > r2)
        {
            std::swap(r1, r2);
            std::swap(c1, c2);
        }

        if(diag(r1, c1) == diag(r2, c2))
        {
            std::cout << r1 << ' ' << c1 << '\n';
            continue;
        }

        std::cout << std::min(diag(r1, c1), diag(r2, c2)) << " 0\n";
    }
}