#pragma GCC optimize("Ofast,fast-math,unroll-loops,no-stack-protector")

#include <bits/stdc++.h>

#define all(x) (x).begin(), (x).end()
#define len(x) (int) (x).size()
#define endl "\n"

using namespace std;

int n;
vector <int> line;

const int N = 5e5 + 100;
int tree[4 * N];


void build(int v, int l, int r) {
    if (r - l == 1) {
        tree[v] = line[l];
        return;
    }

    int m = (l + r) / 2;
    build(v * 2 + 1, l, m);
    build(v * 2 + 2, m, r);
    tree[v] = min(tree[v * 2 + 1], tree[v * 2 + 2]);
}

int get(int v, int l, int r, int ql, int qr) {
    if (ql <= l && r <= qr) {
        return tree[v];
    }
    if (l >= qr || r <= ql) {
        return INT_MAX;
    }

    int m = (l + r) / 2;
    return min(get(v * 2 + 1, l, m, ql, qr), get(v * 2 + 2, m, r, ql, qr));
}


int fw[N];
void upd(int v) {
    for (int x = v; x < N; x += x & (-x)) {
        fw[x]++;
    }
}

int get(int v) {
    int ans = 0;
    for (int x = v; x > 0; x -= x & (-x)) {
        ans += fw[x];
    }
    return ans;
}


vector <int> get(vector <array <int, 3>> req) { // when, where, id
    fill(fw, fw + N, 0);
    vector <int> ans(len(req));
    sort(all(req));

    int p1 = 0, p2 = 0;
    while (p1 < len(req)) {
        if (p2 == n || (p1 != len(req) && req[p1][0] <= p2)) {
            if (req[p1][1] == 0) {
                ans[req[p1++][2]] = 0;
            } else {
                ans[req[p1][2]] = req[p1][1] - get(req[p1][1]);
                p1++;
            }
        } else {
            upd(line[p2++]);
        }
    }
    return ans;
}


signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> n;
    line.resize(n);
    for (int& i : line) {
        cin >> i;
    }
    build(0, 0, len(line));

    int q;
    cin >> q;
    vector <array <int, 3>> req;
    for (int i = 0; i < q; i++) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        req.push_back({a, b, 2 * i});
        req.push_back({c, d, 2 * i + 1});  // where, val, id
    }

    vector <pair <int, int>> bor(len(req), {0, n + 2});
    for (int _ = 0; _ < 20; _++) {
        vector <array <int, 3>> check;
        for (int i = 0; i < len(req); i++) {
            if (bor[i].second - bor[i].first > 1) {
                check.push_back({(bor[i].first + bor[i].second) / 2, req[i][0], i});
            } else {
                check.push_back({0, 0, i});
            }
        }
        vector <int> ans = get(check);

        for (int i = 0; i < len(check); i++) {
            if (bor[i].second - bor[i].first == 1) {
                continue;
            }
            if (ans[i] >= req[i][1]) {
                bor[check[i][2]].first = (bor[check[i][2]].second + bor[check[i][2]].first) / 2;
            } else {
                bor[check[i][2]].second = (bor[check[i][2]].second + bor[check[i][2]].first) / 2;
            }
        }
    }

    vector <array <int, 3>> gety;
    for (int i = 0; i < q; i++) {
        int t1 = bor[i * 2].first, t2 = bor[i * 2 + 1].first;
        if (t1 > t2) {
            swap(t1, t2);
            gety.push_back({0, 0, i});
        }
        if (t1 != t2) {
            int mn = get(0, 0, len(line), t1, t2);
            gety.push_back({t1, mn - 1, i});
        }
    }

    vector <int> ans = get(gety);
    for (int i = 0; i < q; i++) {
        int t1 = bor[i * 2].first, t2 = bor[i * 2 + 1].first;
        if (t1 > t2) {
            swap(t1, t2);
        }
        if (t1 == t2) {
            if (req[i * 2][0] <= req[i * 2 + 1][0]) {
                cout << req[i * 2][0] << " " << req[i * 2][1] << endl;
            } else {
                cout << req[i * 2 + 1][0] << " " << req[i * 2 + 1][1] << endl;
            }
        } else {
            int x = get(0, 0, len(line), t1, t2) - 1, y = ans[i];
            if (req[i * 2][0] < x) {
                x = req[i * 2][0], y = req[i * 2][1];
            }
            if (req[i * 2 + 1][0] < x) {
                x = req[i * 2 + 1][0], y = req[i * 2 + 1][1];
            }
            cout << x << " " << y << endl;
        }
    }
    return 0;
}
