//#pragma GCC optimize("Ofast,fast-math,unroll-loops,no-stack-protector")

#include <bits/stdc++.h>

#define all(x) (x).begin(), (x).end()
#define len(x) (int) (x).size()
#define endl "\n"

using namespace std;

int n;
vector <int> line;

const int N = 5e5 + 100;
int tree[4 * N];


void build(int v, int l, int r) {
    if (r - l == 1) {
        tree[v] = line[l];
        return;
    }

    int m = (l + r) / 2;
    build(v * 2 + 1, l, m);
    build(v * 2 + 2, m, r);
    tree[v] = min(tree[v * 2 + 1], tree[v * 2 + 2]);
}

int get(int v, int l, int r, int ql, int qr) {
    if (ql <= l && r <= qr) {
        return tree[v];
    }
    if (l >= qr || r <= ql) {
        return INT_MAX;
    }

    int m = (l + r) / 2;
    return min(get(v * 2 + 1, l, m, ql, qr), get(v * 2 + 2, m, r, ql, qr));
}


int fw[N];
void upd(int v) {
    for (int x = v; x < N; x += x & (-x)) {
        fw[x]++;
    }
}

int get(int v) {
    int ans = 0;
    for (int x = v; x > 0; x -= x & (-x)) {
        ans += fw[x];
    }
    return ans;
}


vector <int> get(vector <array <int, 3>> req) { // when, where, id
    fill(fw, fw + N, 0);
    vector <int> ans(len(req));
    stable_sort(all(req));

    int p1 = 0, p2 = 0;
    while (p1 < len(req)) {
        if (p2 == n || (p1 != len(req) && req[p1][0] <= p2)) {
            if (req[p1][1] == 0) {
                ans[req[p1++][2]] = 0;
            } else {
                ans[req[p1][2]] = req[p1][1] - get(req[p1][1]);
                p1++;
            }
        } else {
            upd(line[p2++]);
        }
    }
    return ans;
}

int d[4 * N];
int mod[4 * N];

void push(int v, int ln) {
    d[v] += mod[v];
    if (ln == 1) {
        mod[v] = 0;
        return;
    }
    mod[v * 2 + 1] += mod[v];
    mod[v * 2 + 2] += mod[v];
    mod[v] = 0;
}

int down(int v, int l, int r, int val) {
    push(v, r - l);
    if (r - l == 1) {
        return l;
    }

    int m = (l + r) / 2;
    push(v * 2 + 1, m - l);
    push(v * 2 + 2, r - m);
    if (d[v * 2 + 1] <= val) {
        return down(v * 2 + 1, l, m, val);
    } else {
        return down(v * 2 + 2, m, r, val);
    }
}

void updd(int v, int l, int r, int ql, int qr) {
    push(v, r - l);
    if (ql <= l && r <= qr) {
        mod[v]++;
        push(v, r - l);
        return;
    }
    if (l >= qr || r <= ql) {
        return;
    }

    int m = (l + r) / 2;
    updd(v * 2 + 1, l, m, ql, qr);
    updd(v * 2 + 2, m, r, ql, qr);
    d[v] = min(d[v * 2 + 1], d[v * 2 + 2]);
}


signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    scanf("%d", &n);
    line.resize(n);
    for (int& i : line) {
        scanf("%d", &i);
    }
    vector <int> ind(n);
    for (int i = 0; i < n; i++) {
        ind[line[i] - 1] = i;
    }
    build(0, 0, len(line));

    int q;
    scanf("%d", &q);
    vector <int> bor(2 * q);
    vector <vector <array <int, 2>>> req(n + 1);
    vector <array <int, 2>> re(2 * q);

    for (int i = 0; i < q; i++) {
        int a, b, c, d;
        scanf("%d %d %d %d", &a, &b, &c, &d);
        req[a].push_back({b, 2 * i});
        req[c].push_back({d, 2 * i + 1});
        re[2 * i] = {a, b};
        re[2 * i + 1] = {c, d};
    }

    for (int i = 0; i <= n; i++) {
        for (auto [val, id] : req[i]) {
            bor[id] = down(0, 0, n + 1, val);
        }
        if (i != n) {
            updd(0, 0, n + 1, 0, ind[i] + 1);
        }
    }

    vector <array <int, 3>> gety;
    for (int i = 0; i < q; i++) {
        int t1 = bor[i * 2], t2 = bor[i * 2 + 1];
        if (t1 > t2) {
            swap(t1, t2);
        }
        if (t1 != t2) {
            int mn = get(0, 0, len(line), t1, t2);
            gety.push_back({t1, mn - 1, i});
        } else {
            gety.push_back({0, 0, i});
        }
    }

    vector <int> ans = get(gety);
    for (int i = 0; i < q; i++) {
        int t1 = bor[i * 2], t2 = bor[i * 2 + 1];
        if (t1 > t2) {
            swap(t1, t2);
        }
        if (t1 == t2) {
            if (re[i * 2][0] <= re[i * 2 + 1][0]) {
                printf("%d %d\n", re[i * 2][0], re[i * 2][1]);
            } else {
                printf("%d %d\n", re[i * 2 + 1][0], re[i * 2 + 1][1]);
            }
        } else {
            int x = get(0, 0, len(line), t1, t2) - 1, y = ans[i];
            if (re[i * 2][0] < x) {
                x = re[i * 2][0], y = re[i * 2][1];
            }
            if (re[i * 2 + 1][0] < x) {
                x = re[i * 2 + 1][0], y = re[i * 2 + 1][1];
            }
            printf("%d %d\n", x, y);
        }
    }
    return 0;
}
