#ifndef ONPC
#pragma GCC optimize("O3")
#pragma GCC target("avx,avx2")
//#pragma GCC optimize("unroll-loops")
#endif

#include <iostream>
#include <iomanip>
#include <cmath>
#include <utility>
#include <algorithm>
#include <numeric>
#include <vector>
#include <string>
#include <sstream>
#include <limits>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <deque>

using namespace std;
using ll = int64_t;
using ld = long double;
using vi = vector<int>;
using vc = vector<char>;
using vll = vector<ll>;
using vvi = vector<vi>;
using ii = pair<int, int>;
using vii = vector<ii>;

#define all(x) (x).begin(), (x).end()
#define endl '\n'

void dfs1(const vvi &g, vll &l, int v) {
    ll sl = 0;
    for (auto to : g[v]) {
        dfs1(g, l, to);
        sl += l[to];
    }
    l[v] = max(l[v], sl);
}

bool suit (const vi &p, const vll &a, const vll &r, int v) {
    while (v != -1) {
        if (a[v] + 1 <= r[v])
            v = p[v];
        else
            return false;
    }
    return true;
};

void inc(const vi &p, vll &a, int v) {
    while (v != -1) {
        ++a[v];
        v = p[v];
    }
}

vi dfs2(const vvi &g, const vi &p, vll &a, const vll &l, const vll &r, const vll &c, int v) {
    vi cv{v};
    for (auto to : g[v]) {
        vi nev;
        vi res = dfs2(g, p, a, l, r, c, to);
        merge(all(res), all(cv), back_inserter(nev), [&c](int a, int b) -> bool {
            return c[a] < c[b];
        });
        cv = nev;
    }
    int curr = 0;
    while (a[v] < l[v]) {
        while (!suit(p, a, r, cv[curr]))
            ++curr;
        inc(p, a, cv[curr]);
    }
    return cv;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        vi p(n, -1);
        vvi g(n);
        for (int i = 1; i < n; ++i) {
            cin >> p[i];
            --p[i];
            g[p[i]].push_back(i);
        }
        vll c(n), l(n), r(n), a(n, 0);
        for (auto &e : c)
            cin >> e;
        for (int i = 0; i < n; ++i)
            cin >> l[i] >> r[i];

        dfs1(g, l, 0);
        bool corr = true;
        for (int i = 0; i < n; ++i) {
            if (l[i] > r[i]) {
                cout << "-1" << endl;
                corr = false;
                break;
            }
        }
        if (!corr)
            break;

        /*vi vs(n);
        iota(all(vs), 0);
        sort(all(vs), [&c](int a, int b) -> bool {
            return c[a] < c[b];
        });*/
        /*auto suit = [&p, &a, &l, &r](int v) -> bool {
            while (v != -1) {
                if (a[v] + 1 <= r[v])
                    v = p[v];
                else
                    return false;
            }
            return true;
        };
        auto inc = [&p, &a](int v) -> void {
            while (v != -1) {
                ++a[v];
                v = p[v];
            }
        };*/
        /*int curr = 0;
        while (!suit(vs[curr]))
            ++curr;

        while (a[0] < l[0]) {
            inc(vs[curr]);
            while (!suit(vs[curr]))
                ++curr;
        }*/

        dfs2(g, p, a, l, r, c, 0);

        vll b(n, 0);
        for (int i = 0; i < n; ++i) {
            b[i] = a[i];
            for (auto to : g[i])
                b[i] -= a[to];
        }
        ll ans = 0;
        for (int i = 0; i < n; ++i)
            ans += b[i] * c[i];
        cout << ans << endl;
        for (auto &e : b)
            cout << e << ' ';
        cout << endl;
    }
}