#ifndef ONPC
#pragma GCC optimize("O3")
#pragma GCC target("avx,avx2")
//#pragma GCC optimize("unroll-loops")
#endif

#include <iostream>
#include <iomanip>
#include <cmath>
#include <utility>
#include <algorithm>
#include <numeric>
#include <vector>
#include <string>
#include <sstream>
#include <limits>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <deque>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using ll = int64_t;
using ld = long double;
using vi = vector<int>;
using vc = vector<char>;
using vll = vector<ll>;
using vvi = vector<vi>;
using ii = pair<int, int>;
using vii = vector<ii>;

using namespace __gnu_pbds;

#define all(x) (x).begin(), (x).end()
#define endl '\n'

using graph = vector<gp_hash_table<int, null_type>>;

template<typename F>
int bin_search(int l, int r, const F &f) {
    --l, ++r;
    while (l + 1 < r) {
        int m = (l + r) / 2;
        if (f(m))
            l = m;
        else
            r = m;
    }
    return r;
}

int gv(int r, int c) {
   return r * (r + 1) / 2 + c;
}

ii grc(int v) {
    int r = bin_search(0, 10000, [v](int r) -> bool {
        return gv(r, 0) <= v;
    }) - 1;
    return {r, v - gv(r, 0)};
}

void dfs(const graph &g, vvi &up, int logm, vi &tin, vi &tout, int &t, int v) {
    tin[v] = t++;
    for (int i = 1; i < logm; ++i) {
        up[v][i] = up[up[v][i - 1]][i - 1];
    }
    for (auto to : g[v]) {
        up[to][0] = v;
        dfs(g, up, logm, tin, tout, t, to);
    }
    tout[v] = t;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n;
    cin >> n;
    /*vi a(n);
    for (auto &e : a) {
        cin >> e;
        --e;
    }*/
    int m = (n + 2) * (n + 1) / 2;
    graph g(m);
    {
        vc path(n, false);
        int cr = 0;
        int cc = 0;
        for (int i = 0; i < n; ++i) {
            if (path[i]) {
                g[gv(cr, cc)].insert(gv(cr + 1, cc));
                ++cr;
            } else {
                g[gv(cr, cc)].insert(gv(cr + 1, cc + 1));
                ++cr, ++cc;
            }
        }
        for (int j = 0; j < n; ++j) {
            int e;
            cin >> e;
            path[e - 1] = true;
            cr = cc = 0;
            for (int i = 0; i < n; ++i) {
                if (path[i]) {
                    g[gv(cr, cc)].insert(gv(cr + 1, cc));
                    ++cr;
                } else {
                    g[gv(cr, cc)].insert(gv(cr + 1, cc + 1));
                    ++cr, ++cc;
                }
            }
        }
    }
    int logm = __lg(m) + 2;
#ifdef ONPC
    cout << n << ' ' << m << ' ' << logm << endl;
#endif
    vvi up(m, vi(logm, 0));
    int t = 0;
    vi tin(m), tout(m);
    dfs(g, up, logm, tin, tout, t, 0);
    auto anc = [&tin, &tout](int u, int v) -> bool {
        return tin[u] <= tin[v] && tin[v] < tout[u];
    };

    int q;
    cin >> q;
    while (q--) {
        int r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;
        int v1 = gv(r1, c1);
        int v2 = gv(r2, c2);
        int v3 = -1;
        if (anc(v1, v2))
            v3 = v1;
        else if (anc(v2, v1))
            v3 = v2;
        if (v3 != -1) {
            auto [r3, c3] = grc(v3);
            cout << r3 << ' ' << c3 << endl;
            continue;
        }
        for (int i = logm - 1 ; i >= 0; --i) {
            if (!anc(up[v1][i], v2)) {
                v1 = up[v1][i];
            }
        }
        v3 = up[v1][0];
        auto [r3, c3] = grc(v3);
        cout << r3 << ' ' << c3 << endl;
    }
}