#pragma GCC optimize("O3, Ofast, fast-math, unroll-loops")
#include <bits/stdc++.h>


#define ll long long

using namespace std;

const int MAXN = 5000 + 10;
const ll INF = 1e9 + 7;


vector<int> graph[MAXN];
vector<int> p[MAXN];
vector<ll> dp[MAXN];
int l[MAXN], r[MAXN];
ll c[MAXN];

int  sum_r[MAXN];

ll get_dp(int v, int w) {
    int mx_size = min({sum_r[v], r[v], MAXN - 1});
    if (w < mx_size) return dp[v][w];
    return dp[v][mx_size] + max(0, w - mx_size) * c[v];
}


void dfs(int v) {
    int sum_l = 0;
    for (int u: graph[v]) {
        r[u] = min(r[u], r[v]);
        dfs(u);
        sum_r[v] += r[u];
        sum_l += l[u];
    }
    int mx_size = min({sum_r[v], r[v], MAXN - 1});
    dp[v].resize(mx_size + 1);
    for (int i = 0; i <= mx_size; ++i) {
        dp[v][i] = i * c[v];
    }
    for (int i = 0; i < graph[v].size(); ++i) {
        int u = graph[v][i];
        p[u].resize(mx_size + 1);
        for (int w = mx_size; w >= 0; --w) {
            ll best = INF;
            int best_p = -1;
            for (int w2 = l[u]; w2 <= min({w, r[u]}) ; ++w2) {
                if (dp[v][w - w2] + get_dp(u, w2) < best) {
                    best = dp[v][w - w2] + get_dp(u, w2);
                    best_p = w2;
                }
            }
            p[u][w] = best_p;
            dp[v][w] = best;
        }
    }
}

int res[MAXN];

void ans(int v, int w) {
    int mx_size = min({sum_r[v], r[v], MAXN - 1});
    if (w > mx_size) {
        res[v] += w - mx_size;
        w = mx_size;
    }
    for (int i = ((int) graph[v].size()) - 1; i >= 0; --i) {
        ans(graph[v][i], p[graph[v][i]][w]);
        w -= p[graph[v][i]][w];
    }
    res[v] += w;
}


signed main() {
    cin.tie(0);
    ios::sync_with_stdio(false);
    int t;
    cin >> t;
    while (t-- > 0) {
        int n;
        cin >> n;
        for (int i = 1; i < n; ++i) {
            int p;
            cin >> p;
            --p;
            graph[p].push_back(i);
        }
        for (int i = 0; i < n; ++i) {
            cin >> c[i];
        }
        for (int i = 0; i < n; ++i) {
            cin >> l[i] >> r[i];
        }
        dfs(0);
        ll mn = INF;
        int best_w = -1;
        for (int i = l[0]; i <= r[0]; ++i) {
            if (get_dp(0, i) < mn) {
                mn = get_dp(0, i);
                best_w = i;
            }
        }
        if (best_w != -1) {
            ans(0, best_w);
            cout << mn << "\n";
            for (int i = 0; i < n; ++i) {
                cout << res[i] << " ";
            }
            cout << "\n";
        } else {
            cout << "-1" << "\n";
        }
        for (int i = 0; i < n; ++i) {
            graph[i].clear();
            p[i].clear();
            dp[i].clear();
            sum_r[i] = 0;
            res[i] = 0;
        }
    }
    return 0;
}