#include <bits/stdc++.h>

using namespace std;
using ll = long long;

constexpr int MAXN = (int)1e5;
vector<int> g[MAXN];
ll c[MAXN];
ll cnt[MAXN];
ll mn[MAXN], mx[MAXN];
int n;

struct remain {
    int vert;
    ll max_cnt;

    remain(int v, ll mxc) : vert(v), max_cnt(mxc) {};
};

struct subtree {
    set<remain>* rem;
    ll rem_cnt;
    ll chosen;
    ll cost;
    bool correct;

    subtree() : rem(new set<remain>()), rem_cnt(0), chosen(0), cost(0), correct(true) {};

    void merge(subtree other) {
        if (rem->size() < other.rem->size()) {
            swap(rem, other.rem);
        }
        for (const auto& el : *other.rem)
            rem->insert(el);

        rem_cnt += other.rem_cnt;
        chosen += other.chosen;
        cost += other.cost;
        if (!other.correct)
            correct = false;
    }
};

bool operator<(const remain& x, const remain& y) {
    return c[x.vert] < c[y.vert] || (c[x.vert] == c[y.vert] && x.vert < y.vert);
}

subtree dfs(int v) {
    subtree cur;
    for (int to : g[v]) {
        cur.merge(dfs(to));
    }

    if (cur.chosen > mx[v]) {
        cur.correct = false;
    }

    while (cur.chosen < mn[v] && !cur.rem->empty()) {
        remain buf = *cur.rem->begin();
        cur.rem->erase(cur.rem->begin());
        cur.rem_cnt -= buf.max_cnt;
        cur.cost += c[buf.vert] * buf.max_cnt;
        cnt[buf.vert] += buf.max_cnt;
        cur.chosen += buf.max_cnt;

        if (cur.chosen > mn[v]) {
            cur.rem->emplace(buf.vert, cur.chosen - mn[v]);
            cur.rem_cnt += cur.chosen - mn[v];
            cur.cost -= c[buf.vert] * (cur.chosen - mn[v]);
            cnt[buf.vert] -= cur.chosen - mn[v];
            cur.chosen = mn[v];
        }
    }

    if (cur.chosen < mn[v]) {
        cnt[v] = mn[v] - cur.chosen;
        cur.cost += cnt[v] * c[v];
        cur.chosen = mn[v];
    }

    while (cur.rem_cnt > mx[v] - mn[v]) {
        remain buf = *cur.rem->rbegin();
        cur.rem_cnt -= buf.max_cnt;
        cur.rem->erase(--cur.rem->end());

        if (cur.rem_cnt < mx[v] - mn[v]) {
            cur.rem->emplace(buf.vert, cur.rem_cnt - (mx[v] - mn[v]));
            cur.rem_cnt = mx[v] - mn[v];
        }
    }

    while (!cur.rem->empty() && c[cur.rem->rbegin()->vert] >= c[v]) {
        cur.rem_cnt -= cur.rem->rbegin()->max_cnt;
        cur.rem->erase(--cur.rem->end());
    }

    cur.rem->emplace(v, (mx[v] - mn[v]) - cur.rem_cnt);
    cur.rem_cnt = mx[v] - mn[v];

    return cur;
}

void clear_graph() {
    for (int v = 0; v < n; ++v) {
        g[v].clear();
    }
}

void solve() {
    cin >> n;
    for (int i = 1; i < n; ++i) {
        int p;
        cin >> p;
        g[p - 1].push_back(i);
    }
    for (int i = 0; i < n; ++i) {
        cin >> c[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> mn[i] >> mx[i];
    }

    subtree s = dfs(0);

    if (s.correct) {
        cout << s.cost << '\n';
        for (int v = 0; v < n; ++v) {
            cout << cnt[v] << ' ';
        }
        cout << '\n';
    } else {
        cout << "-1\n";
    }
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);

    int t;
    cin >> t;
    while (t--) {
        solve();
    }

    return 0;
}
