#include<iostream>
#include<vector>
#include<algorithm>
#include<set>

#define int long long

using namespace std;

int total_cost = 0;

bool fail = false;

pair<set<pair<int, pair<int, int>>>, int> DFS(int v, vector<vector<int>> &g, vector<int> &c, vector<int> &left, vector<int> &right, vector<int> &ans){
    int cnt = 0;
    set<pair<int, pair<int, int>>> p_buy;
    set<pair<int, pair<int, int>>> emp;
    for (int u : g[v]){
        auto res = DFS(u, g, c, left, right, ans);
        for (auto p : res.first){
            p_buy.insert(p);
        }
        cnt += res.second;
    }
    if (cnt > right[v]){
        fail = true;
        return {emp, 0};
    }
    p_buy.insert({c[v], {right[v] - cnt, v}});
    while (cnt < left[v]){
        if (p_buy.size() == 0){
            fail = true;
            return {emp, 0};
        }
        pair<int, pair<int, int>> p = *p_buy.begin();
        p_buy.erase(p_buy.begin());
        int x = min(left[v] - cnt, p.second.first);
        if (p.second.first > x){
            p_buy.insert({p.first, {p.second.first - x, p.second.second}});
        }
        ans[p.second.second] += x;
        cnt += x;
        total_cost += x * p.first;
    }
    int p_buy_cnt = right[v] - cnt;
    set<pair<int, pair<int, int>>> res;
    for (auto p : p_buy){
        if (p_buy_cnt < p.second.first){
            res.insert({p.first, {p_buy_cnt, p.second.second}});
            break;
        } else {
            res.insert(p);
            p_buy_cnt -= p.second.first;
        }
    }
    return {res, cnt};
}

signed main(){
    int t;
    cin >> t;
    while(t--){
        int n;
        cin >> n;
        vector<vector<int>> g(n);
        for (int i = 1; i < n; ++i){
            int p;
            cin >> p;
            g[p - 1].push_back(i);
        }
        vector<int> c(n);
        vector<int> left(n);
        vector<int> right(n);
        for (int i = 0; i < n; ++i){
            cin >> c[i];
        }
        for (int i = 0; i < n; ++i){
            cin >> left[i] >> right[i];
        }
        vector<int> ans(n);
        total_cost = 0;
        fail = false;
        DFS(0, g, c, left, right, ans);
        if (fail){
            cout << -1 << endl;
            continue;
        }
        cout << total_cost << endl;
        for (int i = 0; i < n; ++i){
            cout << ans[i] << " ";
        }
        cout << endl;
    }
    return 0;
}
/*
2
3
1 1
3 1 2
5 7
1 2
2 4
2
1
5 5
0 1
2 2

2
4
1 2 3
5 5 1 10
15 16
10 10
0 10
2 100
5
1 2 2 2
1000 100 1000 1 2
105 1000
100 100
1 15
1 2
47 48

*/
