#include <bits/stdc++.h>

using namespace std;
using ll = long long;
const int MAXN = 5e5 + 5;
vector<int> r, l;
vector<int> a;


struct node {
    int l = -1, r = -1;
    int sum = 0;
};
node nodes[50 * MAXN];
int roots[MAXN];
int cnt = 1;

int new_node() {
    return (cnt++);
}

int new_node(int v) {
    int res = new_node();
    if (v != -1)
        nodes[res] = nodes[v];
    return res;
}

int n;


int build(int l, int r) {
    if (r - l == 1) {
        return new_node();
    }
    int m = (r + l) / 2;
    int res = new_node();
    nodes[res].l = build(l, m);
    nodes[res].r = build(m, r);
    return res;
}

int add(int x, int v, int l = 0, int r = n) {
    int res = new_node(v);
    if (r - l == 1) {
        nodes[res].sum++;
        return res;
    }
    int m = (r + l) / 2;
    if (x < m) {
        nodes[res].l = add(x, nodes[res].l, l, m);
    } else {
        nodes[res].r = add(x, nodes[res].r, m, r);
    }
    nodes[res].sum++;
    return res;
}

int row = 0, c = 0;


int ask(int v1, int v2, int l = 0, int r = n) {
    if (r - l == 1) {
        return l + (nodes[v1].sum == nodes[v2].sum);
    }
    int m = (r + l) / 2;
    if (nodes[nodes[v1].l].sum != nodes[nodes[v2].l].sum) {
        return ask(nodes[v1].l, nodes[v2].l, l, m);
    }
    return ask(nodes[v1].r, nodes[v2].r, m, r);
}

int sum(int askl, int askr, int v1, int l = 0, int r = n) {
    if (!v1)
        return 0;
    if (askr <= l || r <= askl)
        return 0;
    if (askl <= l && r <= askr)
        return nodes[v1].sum;
    int m = (r + l) / 2;
    return sum(askl, askr, nodes[v1].l, l, m) + sum(askl, askr, nodes[v1].r, m, r);
}


int roots2[MAXN];

int old_when(int pos, int cnt) {
    int l = -1, r = n;
    while (r - l > 1) {
        int m = (r + l) / 2;
        if (sum(0, pos, roots[m]) >= cnt)
            r = m;
        else
            l = m;
    }
    return r;
}

int when(int cnt, int v, int l = 0, int r = n + 1) {
    if (r - l == 1)
        return l;
    int m = (r + l) / 2;
    if (nodes[nodes[v].l].sum > cnt) {
        return when(cnt, nodes[v].l, l, m);
    }
    return when(cnt - nodes[nodes[v].l].sum, nodes[v].r, m, r);
}

void solve() {
    cin >> n;
    a.resize(n);
    roots[0] = build(0, n);
    vector<int> da(n + 1);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        roots[i + 1] = add(a[i] - 1, roots[i]);
        da[a[i]] = i;
    }
    roots2[0] = build(0, n + 1);
    for (int i = 1; i <= n; i++) {
        roots2[i] = add(da[i], roots2[i - 1],0,n+1);
    }
    int q;
    cin >> q;
    for (int i = 0; i < q; i++) {
        int r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;
        int t1 = when(r1 - c1, roots2[r1]);
        int t2 = when(r2 - c2, roots2[r2]);

        int ind = ask(roots[t1], roots[t2]);
        ind = min(ind, min(r1, r2));
        cout << ind << ' ' << ind - sum(0, ind, roots[t1]) << '\n';
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    solve();
    return 0;
}
