#include <iostream>
#include <vector>

using namespace std;
const int MAXN = 5e5 + 3;
vector<int> a;


struct node {
    int l = -1, r = -1;
    int sum = 0;
};
int SUM[50 * MAXN];
int l[50 * MAXN];
int r[50 * MAXN];
//node nodes[10 * MAXN];
int roots[MAXN];
int cnt = 1;

int new_node() {
    return (cnt++);
}

int new_node(int v) {
    int res = new_node();
    if (v != -1) {
        r[res] = r[v];
        l[res] = l[v];
        SUM[res] = SUM[v];
    }
    return res;
}

int n;


int build(int vl, int vr) {
    if (vr - vl == 1) {
        return new_node();
    }
    int m = (vr + vl) / 2;
    int res = new_node();
    l[res] = build(vl, m);
    r[res] = build(m, vr);
    return res;
}

int add(int x, int v, int vl = 0, int vr = n) {
    int res = new_node(v);
    if (vr - vl == 1) {
        SUM[res]++;
        return res;
    }
    int m = (vr + vl) / 2;
    if (x < m) {
        l[res] = add(x, l[res], vl, m);
    } else {
        r[res] = add(x, r[res], m, vr);
    }
    SUM[res]++;
    return res;
}

int row = 0, c = 0;


int ask(int v1, int v2, int vl = 0, int vr = n) {
    if (vr - vl == 1) {
        return vl + (SUM[v1] == SUM[v2]);
    }
    int m = (vr + vl) / 2;
    if (SUM[l[v1]] != SUM[l[v2]]) {
        return ask(l[v1], l[v2], vl, m);
    }
    return ask(r[v1], r[v2], m, vr);
}

int sum(int askl, int askr, int v1, int vl = 0, int vr = n) {
    if (!v1)
        return 0;
    if (askr <= vl || vr <= askl)
        return 0;
    if (askl <= vl && vr <= askr)
        return SUM[v1];
    int m = (vr + vl) / 2;
    return sum(askl, askr, l[v1], vl, m) + sum(askl, askr, r[v1], m, vr);
}


int roots2[MAXN];

int old_when(int pos, int cnt) {
    int l = -1, r = n;
    while (r - l > 1) {
        int m = (r + l) / 2;
        if (sum(0, pos, roots[m]) >= cnt)
            r = m;
        else
            l = m;
    }
    return r;
}

int when(int cnt, int v, int vl = 0, int vr = n + 1) {
    if (vr - vl == 1)
        return vl;
    int m = (vr + vl) / 2;
    if (SUM[l[v]] > cnt) {
        return when(cnt, l[v], vl, m);
    }
    return when(cnt - SUM[l[v]], r[v], m, vr);
}

void solve() {
    cin >> n;
    a.resize(n);
    roots[0] = build(0, n);
    vector<int> da(n + 1);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        roots[i + 1] = add(a[i] - 1, roots[i]);
        da[a[i]] = i;
    }
    roots2[0] = build(0, n + 1);
    for (int i = 1; i <= n; i++) {
        roots2[i] = add(da[i], roots2[i - 1],0,n+1);
    }
    int q;
    cin >> q;
    for (int i = 0; i < q; i++) {
        int r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;
        int t1 = when(r1 - c1, roots2[r1]);
        int t2 = when(r2 - c2, roots2[r2]);

        int ind = ask(roots[t1], roots[t2]);
        ind = min(ind, min(r1, r2));
        cout << ind << ' ' << ind - sum(0, ind, roots[t1]) << '\n';
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    solve();
    return 0;
}
