#include <bits/stdc++.h>

using namespace std;
using ll = long long;
const int MAXN = 1e5 + 5;
vector<int> r, l;
bitset<MAXN> mask[MAXN];
vector<int> a;

int when(int pos, int cnt) {
    for (int i = 0; i < a.size(); i++) {
        if (cnt == 0) return i;
        if (a[i] <= pos)
            cnt--;
    }
    return a.size();
}

struct node {
    node *l = nullptr, *r = nullptr;
    int sum = 0;
};
node nodes[10 * MAXN];
node *roots[MAXN];
int cnt = 1;

node *new_node() {
    return nodes + (cnt++);
}

node *new_node(node *v) {
    node *res = new_node();
    if (v)
        *res = *v;
    return res;
}

int n;


node *build(int l, int r) {
    if (r - l == 1) {
        return new_node();
    }
    int m = (r + l) / 2;
    node *res = new_node();
    res->l = build(l, m);
    res->r = build(m, r);
    return res;
}

node *add(int x, node *v, int l = 0, int r = n) {
    node *res = new_node(v);
    if (r - l == 1) {
        res->sum++;
        return res;
    }
    int m = (r + l) / 2;
    if (x < m) {
        res->l = add(x, res->l, l, m);
    } else {
        res->r = add(x, res->r, m, r);
    }
    res->sum++;
    return res;
}

int row = 0, c = 0;


int ask(node *v1, node *v2, int l = 0, int r = n) {
    if (r - l == 1) {
        return l + (v1->sum == v2->sum);
    }
    int m = (r + l) / 2;
    if (v1->l->sum != v2->l->sum) {
        return ask(v1->l, v2->l, l, m);
    }
    return ask(v1->r, v2->r, m, r);
}

int sum(int askl, int askr, node *v1, int l = 0, int r = n) {
    if (!v1)
        return 0;
    if (askr <= l || r <= askl)
        return 0;
    if (askl <= l && r <= askr)
        return v1->sum;
    int m = (r + l) / 2;
    return sum(askl, askr, v1->l, l, m) + sum(askl, askr, v1->r, m, r);
}

void solve() {
    cin >> n;
    a.resize(n);
    roots[0] = build(0, n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        roots[i + 1] = add(a[i] - 1, roots[i]);
    }
    int q;
    cin >> q;
    for (int i = 0; i < q; i++) {
        int r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;
        int t1 = when(r1, r1 - c1);
        int t2 = when(r2, r2 - c2);
        int ind = ask(roots[t1], roots[t2]);
        ind = min(ind, min(r1, r2));
        cout << ind << ' ' << ind - sum(0, ind, roots[t1]) << '\n';
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    solve();
    return 0;
}
