#ifndef LOCAL
#pragma GCC optimize("Ofast")
#pragma GCC optimize("O3")
#endif

#include <iostream>
#include <vector>
#include <algorithm>

#define len(a) (int)a.size()

typedef long long ll;

const int INF = (int)1e9;

using namespace std;

void run();

int main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#endif

    run();

}

void run()
{
    int n;
    cin >> n;
    vector<int> arr(n);
    for (int i = 0; i < n; ++i)
    {
        cin >> arr[i];
        --arr[i];
    }

    vector<int> most_left(n);
    vector<int> most_right(n);
    for (int i = 0; i < n; ++i)
    {
        most_left[arr[i]] = most_right[arr[i]] = i;
    }

    vector<int> temp = arr;

    for (int i = 0; i < n; ++i)
    {
        int j = i;
        while (j && (temp[j - 1] > temp[j]))
        {
            swap(temp[j - 1], temp[j]);
            most_left[temp[j - 1]] = min(most_left[temp[j - 1]], j - 1);
            most_right[temp[j]] = max(most_right[temp[j]], j);
            --j;
        }
    }
    
    temp = arr;
    for (int i = n - 1; i > -1; --i)
    {
        int j = i;
        while ((j < n - 1) && (temp[j + 1] < temp[j]))
        {
            swap(temp[j + 1], temp[j]);
            most_right[temp[j + 1]] = max(most_right[temp[j + 1]], j + 1);
            most_left[temp[j]] = min(most_left[temp[j]], j);
            ++j;
        }
    }

    int ans = 0;
    for (int i = 0; i < n; ++i)
    {
        for (int j = i + 1; j < n; ++j)
        {
            ans += max(abs(most_left[i] - most_right[j]), abs(most_left[j] - most_right[i]));
        }
    }
    cout << ans << '\n';
}
