#include <iostream>
#include <random>
#include <vector>
#include <climits>
#include <map>
#include <algorithm>
std::vector<std::vector<int>> children;
std::vector<int> parent, cost_here, lcons, rcons;
std::vector<int64_t> ansv;
std::vector<int> bought, tbought;
int64_t gans = 0;
std::tuple<int, int> dfs(int at)
{
	//no rcons -> just buy as little as needed
	// ret  = {n bought, min cost in subtree}
	int64_t nb = 0;
	int64_t mc = at;
	for(int to : children[at])
	{
		auto[n2,m2] = dfs(to);
		nb += n2;
		if(cost_here[mc] > cost_here[m2]) mc = m2;
	}
	int n_rem = lcons[at] - nb;
	if(n_rem > 0)
	{
		int64_t cost = cost_here[mc];
		gans += cost * n_rem;
		bought[mc] += n_rem;
		nb += n_rem;
	}
	return { nb, mc };
}
int64_t very_dumb_solve()
{
	// try all tuples
	int n =children.size();
	int64_t end = 1;
	for(int i = 0; i < n; i++) end *= rcons[0];
	int64_t gans = LLONG_MAX;
	for(int64_t m = 0; m < end; m++)
	{
		int64_t cm =m ;
		//printf("m=%lld\n", m);
		int64_t ans = 0;
		std::vector<int> tbought(n);
		std::vector<int> bought(n);
		for(int j = 0; j < n; j++)
		{
			int here = cm % rcons[0];
			cm /= rcons[0];
			bought[j] += here;
			ans += here * 1ll * cost_here[j];
			int cur = j;
			while(cur != -1) tbought[cur] += here, cur = parent[cur];
		}
		bool ok = true;
		for(int j = 0; j < n; j++)
		{
			if(tbought[j] < lcons[j] || tbought[j] > rcons[j]) ok = false;
		}
		if(ok)
		{
			//for(int x : bought) printf("%d ", x);
			//printf("\n");
			gans = std::min(gans, ans);
		}
	}
	return gans == LLONG_MAX ? -1 : gans;
}
std::mt19937 mt;
int main()
{
	// minimize total cost if l <= sum in each subtree <= r
	// solution exists iff buying minimally to satisfy l in each vertex won't violate any r constraints
	// buying higher in the tree is always acceptable, if it's cheaper and won't violate child constraints
	// buy as little as possible in leaves
	// when merging trees, if there is not enough, buy from the cheapest vertices in the subtree
	// return counter maps (cost, n_remaining), add them for each child
	int T; std::cin >> T;
	while(T --> 0)
	{
		int n; std::cin >> n;
		//int n = 5;
		gans = 0;
		children.assign(n, {});
		parent.assign(n, {});
		cost_here.assign(n, {});
		lcons.assign(n, {});
		rcons.assign(n, {});
		ansv.assign(n, {});
		bought.assign(n, {});
		tbought.assign(n, {});
		parent[0] = -1;
		for(int i = 0; i < n-1; i++)
		{
			int p;
			scanf("%d", &p); p--;
			//p = mt() % -~i;
			parent[i+1] = p;
			children[p].push_back(i+1);
		}
		for(int i = 0; i < n; i++) scanf("%d", &cost_here[i]);
		//for(int i = 0; i < n; i++) cost_here[i] = mt() % 10 + 1;
		for(int i = 0; i < n; i++) scanf("%d%d", &lcons[i], &rcons[i]);
		//for(int i = 0; i < n; i++)
		//{
		//	lcons[i] = mt() % 3 + 1;
		//	rcons[i] = lcons[i] + mt() % 2;
		//}
		//for(int i = 1; i < n; i++)
		//	lcons[parent[i]] += lcons[i], rcons[parent[i]] += rcons[i];
		dfs(0);
		printf("%lld\n", gans);
		for(int x : bought) printf("%d ", x);
		printf("\n");
		//printf("%lld\n", very_dumb_solve());
	}
}
