//#define _GLIBCXX_DEBUG
#pragma GCC optimize("Ofast")
#pragma GCC target("avx2,avx512f,avx512dq,bmi2")
//#pragma GCC target("avx2")
#include <iostream>
#include <random>
#include <vector>
#include <climits>
#include <map>
#include <algorithm>
std::mt19937 mt;

uint32_t N = 0;
char buf[uint32_t(300e6)];
uint32_t bufpos = 0;
struct stree;
uint32_t alloc()
{
	bufpos += 12;
	return bufpos - 12;
}
stree* get(uint32_t i)
{
	return (stree*)(buf+i);
}

struct stree
{
	//stree* l, *r;
	uint32_t li = -1u, ri = -1u;
	uint32_t sum;
	void mkl() { if(li==-1u) { li = alloc(); get(li)->li=get(li)->ri=-1; get(li)->sum=0; } }
	void mkr() { if(ri==-1u) { ri = alloc(); get(ri)->li=get(ri)->ri=-1; get(ri)->sum=0; } }
	uint32_t inc(uint32_t at, uint32_t L, uint32_t R) const
	{
		uint32_t M = (L + R) / 2;
		uint32_t copy = alloc();
		get(copy)->li = li;
		get(copy)->ri = ri;
		get(copy)->sum = sum;
		if(M == L)
		{
			get(copy)->sum += 1;
			return copy;
		}
		if(at < M)
		{
			get(copy)->mkl();
			get(copy)->sum += 1;
			get(copy)->li = get(get(copy)->li)->inc(at, L, M);
			return copy;
		}
		else
		{
			get(copy)->mkr();
			get(copy)->sum += 1;
			get(copy)->ri = get(get(copy)->ri)->inc(at, M, R);
			return copy;
		}
	}
	uint32_t rsum(uint32_t L, uint32_t R, uint32_t qr) const
	{
		if(R <= qr) return sum;
		if(L >= qr || R <= 0) return 0;
		//uint32_t ans = 0;
		uint32_t M = (L+R)/2;
		if(qr <= M)
			return (li!=-1?get(li)->rsum(L, M, qr):0);
		else
			return (li!=-1?get(li)->sum:0) + (ri!=-1?get(ri)->rsum(M, R, qr):0);
		//if(l) ans += l->rsum(L, M, qr);;
		//if(r) ans += r->rsum(M, R, qr);
		//return ans;
	}
};
const int bound = 300002;
std::vector<int> history;
int find_iter(int r, int c)
{
	int L = 0, R = history.size();
	while(L != R)
	{
		int M = (L+R) / 2;
		//printf("total %d\n", history[M]->sum);
		int val = get(history[M])->rsum(0, bound, r);
		// val = number of left turns
		//printf("M=%d: lt=%d\n", M,val);
		if(r - c >= val) // not enough left turns -> not enough iterations
			L = M + 1;
		else R = M;
	}
	return L - 1;
}
struct mtree
{
	std::vector<int> data;
	mtree(std::vector<int> of)
	{
		int n2 = of.size();
		while(n2 & (n2-1)) n2++;
		data.resize(2*n2, INT_MAX);
		for(int i = 0; i < of.size(); i++)
		{
			data[i+n2] = of[i];
		}
		for(int i = n2; i --> 0;)
		{
			data[i] = std::min(data[2*i],data[2*i+1]);
		}
	}
	int rmin(int v, int L, int R, int ql, int qr)
	{
		if(L >= qr || R <= ql) return INT_MAX;
		if(L >= ql && R <= qr) return data[v];
		return std::min(
			rmin(2*v, L, (L+R)/2, ql, qr),
			rmin(2*v+1, (L+R)/2, R, ql, qr));
	}
};
int main()
{
	// binary lifting
	std::cin >> N;
	//triag.resize(N+1);
	//int gsz = (N+2) * (N+1) / 2;
	//parent[0].resize(gsz);
	//for(int i = 1; i < N+1; i++)
	//	triag[i] = i + triag[i-1];

	std::vector<int> a(N);
	//insn.resize(N, 1);
	//t_in.resize(gsz);
	//t_out.resize(gsz);
	//children.resize(gsz);
	for(int& x : a) scanf("%d", &x), x--;
	//for(int i = 0; i < N; i++)
	//{
	//	dfs(0, 0);
	//	insn[a[i]] = 0;
	//}
	//dfs(0, 0);
	//dfs2(0);

	int curt = alloc(); get(curt)->li = get(curt)->ri = -1u;
	history.push_back(curt);
	for(int i = 0; i < N; i++)
	{
		curt = get(curt)->inc(a[i], 0, bound);
		history.push_back(curt);
	}
	std::vector<int> near_ans = a; std::reverse(near_ans.begin(), near_ans.end());
	//children = {};
	int q; std::cin >> q;
	mtree mtr(near_ans);
	while(q --> 0)
	{
		int r1,c1,r2,c2;
		scanf("%d%d%d%d", &r1,&c1,&r2,&c2);
		//r1 = mt() % -~N;
		//r2 = mt() % -~N;
		//c1 = mt() % -~r1;
		//c2 = mt() % -~r2;
		if(r1 < r2) std::swap(r1, r2), std::swap(c1, c2);
		//r1 is lower
		int rr, rc;
		for(int _ = 0; _ < 1; _++)
		{
			int it1 = find_iter(r1,c1);
			int it2 = find_iter(r2,c2);
			//printf("%d %d: %d\n", r1, c1, find_iter(r1, c1));
			//printf("%d %d: %d\n", r2, c2, find_iter(r2, c2));
			if(c2 == r2 - get(history[it1])->rsum(0, bound,r2))
			{
				//printf("MATCH\n");
				rr = r2;
				rc = c2;
				continue;
			}
			int nc2 = N - it2;
			int nc1 = N - it1;
			int nr1 = N;
			int nr2 = N;
			//printf("%d %d %d %d\n", nr1, nc1, nr2, nc2);
			// compute height
			//int min = INT_MAX;
			int L = std::min(nc1, nc2);
			int R = std::max(nc1, nc2);
			int min = mtr.rmin(1, 0, mtr.data.size()/2, L, R);
			rr = min;
			rc = rr - get(history[it1])->rsum(0, bound, rr);

		}
		printf("%d %d\n", rr, rc);
	}
}
// persistent segment tree, lower_bound
// find an iteration corresponding to all r,c pairs
//  ^: persistent segment tree? history = prefixes of changes of insn.
//     binary search for first version which has low enough prefix sum until row r
// use that iteration number to descend to the bottom directly (r=N, c=-i)
// rmq -> find the level of lca
// level ancestor by partially simulating the iteration

// transpose persistent segment tree to use lower_bound?
