#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <cassert>
#include <algorithm>

//#define int long long
using namespace std;

using vi = vector<int>;
using vvi = vector<vector<int>>;
using vb = vector<bool>;
using pi = pair<int, int>;
using db = double;

#define mp make_pair
#define rep(n) for (int i = 0; i < n; i++)
#define all(x) x.begin(), x.end()

const int N = (3e3 + 1) * (3e3 + 2) / 2 + 1;
const int K = 24;
bool visited[N], le[N], ri[N];
int tin[N], tout[N];
int up[N][K], timer = 0;

void dfs(int v, int r = 0, int p = 0) {
	if (visited[v]) return;
	visited[v] = true;
	tin[v] = ++timer;
	up[v][0] = p;
	for (int j = 1; j < K; j++) {
		up[v][j] = up[up[v][j - 1]][j - 1];
	}
	if (ri[v]) dfs(v + r + 2, r + 1, v);
	if (le[v]) dfs(v + r + 1, r + 1, v);
	tout[v] = ++timer;
}

bool father(int a, int b) {
	return tin[a] < tin[b] && tout[a] > tout[b];
}

int lca(int a, int b) {
	if (a == b) return a;
	if (father(a, b)) return a;
	if (father(b, a)) return b;
	for (int l = K - 1; l >= 0; l--) {
		if (!father(up[a][l], b))
			a = up[a][l];
	}
	return up[a][0];
}

void solve() {
	int n; cin >> n;
	for (int i = 0; i < N; i++) visited[i] = le[i] = ri[i] = false;
	vi a(n);
	rep(n) cin >> a[i];
	vi path(n, 1);
	rep(n + 1) {
		int r = 0, c = 0, v = 0;
		for (int j = 0; j < n; j++) {
			if (path[j] == 1) {
				ri[v] = true;
				c++;
				v = v + r + 2;
			}
			else {
				le[v] = true;
				v = v + r + 1;
			}
			r++;
		}
		if (i < n)
			path[a[i] - 1] = 0;
	}
	int q; cin >> q;
	dfs(0);
	while (q--) {
		int r1, c1, r2, c2; cin >> r1 >> c1 >> r2 >> c2;
		int a = r1 * (r1 + 1) / 2 + c1;
		int b = r2 * (r2 + 1) / 2 + c2;
		int l = lca(a, b);
		int rr = -1, cc = -1;
		for (int r = 0;; r++) {
			if ((r + 1) * (r + 2) / 2 - 1 >= l) {
				rr = r;
				cc = r - ((r + 1) * (r + 2) / 2 - 1 - l);
				break;
			}
		}
		cout << rr << " " << cc << "\n";
	}
}

signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	int t = 1;// cin >> t;
	while (t--) solve();
}