#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using vi = vector<int>;
using vll = vector<ll>;
using ii = pair<int, int>;

const ll INF = 1e18;

int n, megan, t = 0;
vector<vll> children;
vi changeTime;
vi log2s;
vll steps;

int pow2(int i) {
    static vi pows{1};
    while ((int)pows.size() <= i)
        pows.push_back(pows.back() * 2);
    return pows[i];
}

inline ll toi(int r, int c) {
    return steps[r] + c;
}

inline ii fromi(ll i) {
    int r = distance(steps.begin(), upper_bound(steps.begin(), steps.end(), i)) - 1;
    int c = i - steps[r];
    return {r, c};
}

void initSteps() {
    steps.assign(n + 1, 0);
    ll k = 1;
    for (int i = 1; i <= n; i++) {
        steps[i] = steps[i - 1] + k;
        k++;
    }
}

void initlog2(int n) {
    log2s = vi(n + 1, 0);
    int k = 1;
    int f = 2, l = 4;
    while (f <= n) {
        if (f == l) {
            k++;
            l *= 2;
        }
        log2s[f] = k;
        f++;
    }
}

void initTree(int r, int c) {
    if (r == n)
        return;
    ll self = toi(r, c);
    if (t <= changeTime[r]) {
        children[self].push_back(toi(r + 1, c + 1));
        initTree(r + 1, c + 1);
    }
    if (t >= changeTime[r]) {
        if (t == changeTime[r]) t++;
        children[self].push_back(toi(r + 1, c));
        initTree(r + 1, c);
    }
}

vector<vll> table;
vi poss;

void dfs(vector<ll> &order, ll pos) {
    for (ll child : children[pos]) {
        dfs(order, child);
        poss[pos] = order.size();
        order.push_back(pos);
    }
    if (children[pos].size() == 0) {
        poss[pos] = order.size();
        order.push_back(pos);
    }
}

void initTable() {
    table.push_back(vll());
    poss.assign(megan, 0);
    dfs(table[0], 0);
    ll n = table[0].size();
    initlog2(n);
    ll h = log2s[n];
    ll step = 1;
    table.resize(h + 1);
    for (ll j = 1; j <= h; j++) {
        table[j].resize(n - step);
        for (ll i = 0; i < n - step; i++)
            table[j][i] = min(table[j - 1][i], table[j - 1][i + step]);
        step *= 2;
    }
}

ll calcMin(ll a, ll b) {
    ll i = poss[a], j = poss[b];
    if (i > j)
        swap(i, j);
    ll l = log2s[j - i + 1];
    return min(table[l][i], table[l][j - pow2(l) + 1]);
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n;
    megan = (n + 2) * (n + 1) / 2;
    initSteps();
    changeTime = vi(n);
    for (int i = 0; i < n; i++) {
        int l;
        cin >> l;
        changeTime[l - 1] = i;
    }
    children.resize(megan);
    initTree(0, 0);
    initTable();
    int q;
    cin >> q;
    while (q--) {
        int r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;
        ii ans = fromi(calcMin(toi(r1, c1), toi(r2, c2)));
        printf("%d %d\n", ans.first, ans.second);
    }
}