#include <bits/stdc++.h>

using namespace std;

const int MAXN = 3e3 + 10;
const int MAXV = (MAXN + 1) * (MAXN + 1) + (MAXN + 1);
const int LOG = 25;
int n;

array<array<int, LOG>, MAXV> dp;
array<int, MAXN> a;
array<array<int, 2>, MAXV> graph;
array<int, MAXV> used;
array<int, MAXV> cnt;

int tin[MAXV];
int tout[MAXV];

int timer = 0;
void dfs(int v, int p) {
  tin[v] = timer++;
  dp[v][0] = p;
  for (int i = 1; i < LOG; i++) {
    dp[v][i] = dp[dp[v][i - 1]][i - 1];
  }
  for (int i = 0; i < cnt[v]; i++) {
    int u = graph[v][i];
    dfs(u, v);
  }
  tout[v] = timer++;
}

bool is_ancestor(int v, int u) {
  return (tin[v] <= tin[u]) && (tout[v] >= tout[u]);
}

int lca(int v, int u) {
  if (is_ancestor(v, u)) {
    return v;
  }
  if (is_ancestor(u, v)) {
    return u;
  }
  for (int i = LOG - 1; i >= 0; i--) {
    if (!is_ancestor(dp[v][i], u))
      v = dp[v][i];
  }
  return dp[v][0];
}

void build() {
  int cur_r = 0;
  int cur_c = 0;
  int cur_v = 0;
  for (int i = 0; i < n; i++) {
    int next_r = cur_r + 1;
    int next_c = cur_c + 1 - a[i];
    int next_v = next_r * MAXN + next_c;

    if (!used[next_v]) {
      graph[cur_v][cnt[cur_v]++] = next_v;
      used[next_v] = 1;
    }

    cur_r = next_r;
    cur_c = next_c;
    cur_v = next_v;
  }
}

signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  cin >> n;
  build();
  for (int i = 0; i < n; i++) {
    int ind;
    cin >> ind;
    ind--;
    a[ind]++;
    build();
  }
  dfs(0, 0);
  int q;
  cin >> q;
  while (q--) {
    int v_r, v_c, u_r, u_c;
    cin >> v_r >> v_c >> u_r >> u_c;
    int v = v_r * MAXN + v_c;
    int u = u_r * MAXN + u_c;
    int l = lca(v, u);
    cout << l / MAXN << ' ' << l % MAXN << '\n';
  }
  return 0;
}