// KiruxaLight
#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>

using namespace std;

#pragma GCC target("avx")
#pragma GCC optimize("O3")

//#define int long long

int n;

int convert(int x, int y) {
	int was = x * (x + 1) / 2;
	int add = y;
	return was + add;
}

const int MAXN = 9006001 + 1;

pair <int, int> who[MAXN];

pair <int, int> unbox(int v) {
	return who[v];
}

vector <int> g[MAXN];

const int LOG = 24;

int up[LOG][MAXN];

int tin[MAXN], tout[MAXN];

int timer = 0;

void dfs(int v, int p = 0) {
	up[0][v] = p;
	tin[v] = timer++;
	for (auto& i : g[v]) {
		if (i != p) {
			dfs(i, v);
		}
	}
	tout[v] = timer++;
}


void init(int sz) {
	for (int i = 0; i + 1 < LOG; ++i) {
		for (int j = 0; j < sz; ++j) {
			int mid = up[i][j];
			up[i + 1][j] = up[i][mid];
		}
	}
}

bool is_ancestor(int a, int b) {
	return tin[a] <= tin[b] && tout[a] >= tout[b];
}

int lca(int u, int v) {
	if (is_ancestor(u, v)) {
		return u;
	}
	if (is_ancestor(v, u)) {
		return v;
	}
	for (int i = LOG - 1; i >= 0; --i) {
		//cout << u << " " << v << " : " << up[i][v] << " is ";
		if (!is_ancestor(up[i][v], u)) {
			v = up[i][v];
			//cout << "not ancestor" << endl;
		}
		//cout << endl;
	}
	return up[0][v];
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	cin >> n;
	int sz = (n + 1) * (n + 1);
	for (int i = 0; i <= n; ++i) {
		for (int j = i; j >= 0; --j) {
			int v = convert(i, j);
			who[v] = make_pair(i, j);
			//cout << i << " " << j << " -> " << v << endl;
		}
	}
	vector <int> a(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}
	vector <int> dx(n), dy(n);
	for (int i = 0; i < n; ++i) {
		dx[i] = 1;
		dy[i] = 1;
	}
	set <pair <int, int>> have;
	for (int i = 0; i <= n; ++i) {
		int cur_r = 0, cur_c = 0;
		for (int j = 0; j < n; ++j) {
			int now_r = cur_r, now_c = cur_c;
			cur_r += dx[j];
			cur_c += dy[j];
			int prev = convert(now_r, now_c);
			int v = convert(cur_r, cur_c);
			if (have.find({ prev, v }) != have.end()) {
				continue;
			}
			have.emplace(prev, v);
			g[prev].emplace_back(v);
			g[v].emplace_back(prev);
			//cout << prev << " === " << v << endl;
		}
		if (i == n) {
			continue;
		}
		int ind = a[i] - 1;
		dx[ind] = 1;
		dy[ind] = 0;
	}
	dfs(0);
	init(sz);
	int q;
	cin >> q;
	while (q--) {
		int r_a, c_a, r_b, c_b;
		cin >> r_a >> c_a >> r_b >> c_b;
		int u = convert(r_a, c_a);
		int v = convert(r_b, c_b);
		int c = lca(u, v);
		//cout << u << " " << v << ": " << c << endl;
		pair <int, int> p = unbox(c);
		cout << p.first << " " << p.second << "\n";
	}
}