#include <bits/stdc++.h>

using namespace std;

struct vtx {
    long long c, i, cnt;
};

bool operator < (const vtx& a, const vtx& b) {
    return a.c < b.c;
}

void check_dfs(int v, vector<vector<int>>& graph, vector<long long>& c, vector<long long>& l, vector<long long>& r, vector<long long>& b, bool& cannot) {
    if (cannot) return;
    long long s = 0;
    for (int u : graph[v]) {
        check_dfs(u, graph, c, l, r, b, cannot);
        s += l[u];
    }
    l[v] = max(l[v], s);
    b[v] = l[v] - s;
    if (l[v] > r[v]) {
        cannot = true;
    }
}

void dfs(int v, set<vtx>& s, vector<vector<int>>& graph, vector<long long>& c, vector<long long>& l, vector<long long>& r, vector<long long>& b) {
    for (int u : graph[v]) {
        set<vtx> s1;
        dfs(u, s1, graph, c, l, r, b);
        for (vtx vt : s1) {
            s.insert(vt);
        }
    }
    while (!s.empty() && s.begin()->c <= c[v] && b[v] > 0) {
        if (s.begin()->cnt < b[v]) {
            b[v] -= s.begin()->cnt;
            b[s.begin()->i] += s.begin()->cnt;
            s.erase(s.begin());
        } else {
            vtx vtx1 = *s.begin();
            vtx1.cnt -= b[v];
            b[vtx1.i] += b[v];
            b[v] = 0;
            s.erase(s.begin());
            s.insert(vtx1);
            break;
        }
    }
    long long rest = r[v] - l[v];
    set<vtx> src = s;
    while (!s.empty() && s.begin()->c <= c[v]) {
        if (s.begin()->cnt < rest) {
            rest -= s.begin()->cnt;
            src.insert(*s.begin());
            s.erase(s.begin());
        } else {
            vtx vtx1 = *s.begin();
            vtx1.cnt = rest;
            rest = 0;
            s.erase(s.begin());
            src.insert(vtx1);
        }
    }
    if (rest > 0)
        src.insert({c[v], v, rest});
    s = src;
}

int main() {
    int t;
    cin >> t;
    while (t--) {
        vector<vector<int>> graph;
        vector<long long> c;
        vector<long long> l;
        vector<long long> r;
        vector<long long> b;
        bool cannot = false;

        int n;
        cin >> n;
        graph.resize(n);
        for (int i = 1; i < n; i++) {
            int p;
            cin >> p;
            graph[p - 1].push_back(i);
        }
        c.resize(n);
        for (long long& i : c)
            cin >> i;
        l.resize(n);
        r.resize(n);
        b.resize(n, 0);
        for (int i = 0; i < n; i++)
            cin >> l[i] >> r[i];
        check_dfs(0, graph, c, l, r, b, cannot);
        if (cannot) {
            cout << "-1\n";
            continue;
        }
        set<vtx> s;
        dfs(0, s, graph, c, l, r, b);
        long long ans = 0;
        for (int i = 0; i < n; i++) {
            ans += (long long) c[i] * (long long) b[i];
        }
        cout << ans << "\n";
        for (int i = 0; i < n; i++) {
            cout << b[i] << " ";
        }
        cout << "\n";
    }
    return 0;
}
