#include <bits/stdc++.h>

#define ssize(a) (int)(a).size()
#define all(a) (a).begin(), (a).end()

using namespace std;

using ll = long long;


vector<vector<int>> g;
vector<int> euler;
vector<int> depth;
vector<int> tin;
int logn;
vector<int> tree;
int n;

int cell(int r, int c) {
    return r * (n + 1) + c;
}

void dfs(int v, int p, int d) {
    tin[v] = ssize(euler);
    euler.push_back(v);
    depth[v] = d;
    for (int u : g[v]) {
        dfs(u, v, d + 1);
        euler.push_back(v);
    }
}

int depth_min(int v, int u) {
    return (depth[v] < depth[u] ? v : u);
}

void build() {
    tree.resize(2 * ssize(euler));
    for (int i = 0; i < ssize(euler); ++i) {
        tree[i + ssize(euler)] = euler[i];
    }
    for (int i = ssize(euler) - 1; i >= 0; --i) {
        tree[i] = depth_min(tree[2 * i], tree[2 * i + 1]);
    }
}

int get(int l, int r) {
    int mn = euler[l];
    l += ssize(euler);
    r += ssize(euler);
    while (l < r) {
        if (l & 1) {
            mn = depth_min(mn, tree[l++]);
        }
        if (r & 1) {
            mn = depth_min(mn, tree[--r]);
        }
        l /= 2;
        r /= 2;
    }
    return mn;
}


int lca(int v, int u) {
    int l = tin[v];
    int r = tin[u];
    if (l > r)
        swap(l, r);
    return get(l, r + 1);
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        --a[i];
    }

    g.resize((n + 1) * (n + 1));
    depth.resize(ssize(g));
    tin.resize(ssize(g));
    logn = __lg((n + 1) * (n + 1));

    vector<int> type(n, 0);
    vector<pair<int, int>> path(n + 1);
    for (int i = 0, r = 0, c = 0; i < n + 1; ++i) {
        path[i] = {r, c};
        if (i != n) {
            g[cell(r, c)].push_back(cell(r + 1, c + 1));
        }
        ++r;
        ++c;
    }

    for (int i = 0; i < n; ++i) {
        type[a[i]] = 1;
        auto[r, c] = path[a[i]];
        for (int j = a[i]; j < n + 1; ++j) {
            path[j] = {r, c};
            int nr = r + 1, nc;
            if (j != n) {
                if (type[j] == 0) {
                    nc = c + 1;
                } else {
                    nc = c;
                }
                g[cell(r, c)].push_back(cell(nr, nc));
                r = nr;
                c = nc;
            }
        }
    }

    dfs(0, 0, 0);
    build();

    int q;
    cin >> q;
    for (int w = 0; w < q; ++w) {
        int r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;
        int l = lca(cell(r1, c1), cell(r2, c2));
        int r3 = l / (n + 1);
        int c3 = l % (n + 1);
        cout << r3 << " " << c3 << "\n";
    }

//    for (int v = 0; v < ssize(g); ++v) {
//        int vr = v / (n + 1);
//        int vc = v % (n + 1);
//        for (int u : g[v]) {
//            int ur = u / (n + 1);
//            int uc = u % (n + 1);
//            cout << vr << " " << vc << " " << ur << " " << uc << "\n";
//        }
//    }




    return 0;
}
