#ifndef LOCAL
#include <bits/stdc++.h>
#else
#include "stdc++.h"
#endif

using namespace std;


vector<int> graph[100020];
int parent[100020];
int cost[100020], L[100020], R[100020], current[100020], bought[100020];

pair<int, int> dfs2(int v) {
    if (R[v] == current[v]) {
        return {v, 0};
    }
    pair<int, int> option = {v, R[v] - current[v]};
    for (int u : graph[v]) {
        auto [p, cnt] = dfs2(u);
        if (cnt != 0 && cost[p] < cost[option.first]) {
            option = {p, cnt};
        }
    }
    option.second = min(option.second, R[v] - current[v]);
    return option;
}

vector<int> order;
void postOrder(int v = 0) {
    for (int u : graph[v]) {
        postOrder(u);
    }
    order.push_back(v);
}

void preOrder() {
    queue<int> q;
    q.push(0);
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        order.push_back(v);
        for (int u : graph[v]) {
            q.push(u);
        }
    }
}

int main() {
#ifndef LOCAL
    ios::sync_with_stdio(0);
    cin.tie(0);
#endif

    int tt;
    cin >> tt;
    while (tt--) {
        int n;
        cin >> n;
        for (int i = 0; i < n; i++) {
            graph[i].clear();
            current[i] = 0;
        }
        for (int i = 1; i < n; i++) {
            int p;
            cin >> p;
            graph[p - 1].push_back(i);
            parent[i] = p - 1;
        }
        parent[0] = -1;
        for (int i = 0; i < n; i++) {
            cin >> cost[i];
        }
        for (int i = 0; i < n; i++) {
            cin >> L[i] >> R[i];
        }
        long long answer = 0;
        order.clear();
        postOrder();
        bool bad = false;
        for (int v : order) {
            while (current[v] < L[v]) {
                auto [u, cnt] = dfs2(v);
                int c = cost[u];
                int p = v;
                while (p != -1) {
                    cnt = min(cnt, R[p] - current[p]);
                    p = parent[p];
                }
                if (cnt == 0) {
                    bad = true;
                    break;
                }
                int d = min(cnt, L[v] - current[v]);
                answer += d * 1LL * c;
                p = u;
                while (p != -1) {
                    current[p] += d;
                    p = parent[p];
                }
                bought[u] += d;
            }
        }
        if (!bad) {
            cout << answer << '\n';
            for (int i = 0; i < n; i++) {
                cout << bought[i] << ' ';
            }
            cout << '\n';
        } else {
            cout << "-1\n";
        }
    }
}
