#ifndef LOCAL
#include <bits/stdc++.h>
#else
#include "stdc++.h"
#endif

using namespace std;

struct Node {
    int left, right, sum;

    Node() : left(-1), right(-1), sum(0) {}
    int update(int tl, int tr, int pos, int val);
    int query(int tl, int tr, int l, int r);
};

Node tree[30000000];
int treeSize = 0;
int addNode() {
    treeSize++;
    return treeSize - 1;
}

int build(int tl, int tr) {
    int v = addNode();
    if (tl == tr) {
        tree[v].left = tree[v].right = -1;
        tree[v].sum = 0;
    } else {
        int tm = (tl + tr) >> 1;
        tree[v].left = build(tl, tm);
        tree[v].right = build(tm + 1, tr);
        tree[v].sum = tree[tree[v].left].sum + tree[tree[v].right].sum;
    }
    return v;
}

int Node::update(int tl, int tr, int pos, int val) {
    if (tl == tr) {
        int v = addNode();
        tree[v] = *this;
        tree[v].sum = val;
        return v;
    }
    int tm = (tl + tr) >> 1;
    int v = addNode();
    tree[v] = *this;
    if (pos <= tm) {
        tree[v].left = tree[left].update(tl, tm, pos, val);
    } else {
        tree[v].right = tree[right].update(tm + 1, tr, pos, val);
    }
    tree[v].sum = tree[tree[v].left].sum + tree[tree[v].right].sum;
    return v;
}

int Node::query(int tl, int tr, int l, int r) {
    if (l <= tl && tr <= r) {
        return sum;
    }
    int tm = (tl + tr) >> 1;
    int res = 0;
    if (l <= tm) {
        res += tree[left].query(tl, tm, l, min(r, tm));
    }
    if (r > tm) {
        res += tree[right].query(tm + 1, tr, max(l, tm + 1), r);
    }
    return res;
}

int tree2[2000020];

void build2(int v, int tl, int tr, vector<int>& nodes) {
    if (tl == tr) {
        tree2[v] = nodes[tl];
    } else {
        int tm = (tl + tr) >> 1;
        build2(v * 2, tl, tm, nodes);
        build2(v * 2 + 1, tm + 1, tr, nodes);
        tree2[v] = min(tree2[v * 2], tree2[v * 2 + 1]);
    }
}

int query2(int v, int tl, int tr, int l, int r) {
    if (l <= tl && tr <= r) {
        return tree2[v];
    }
    int res = 1e9;
    int tm = (tl + tr) >> 1;
    if (l <= tm) {
        res = min(res, query2(v * 2, tl, tm, l, min(tm, r)));
    }
    if (r > tm) {
        res = min(res, query2(v * 2 + 1, tm + 1, tr, max(tm + 1, l), r));
    }
    return res;
}

int main() {
#ifndef LOCAL
    ios::sync_with_stdio(0);
    cin.tie(0);
#endif

    int n;
    cin >> n;
    vector<int> arr(n);
    for (int& it : arr) {
        cin >> it;
        it--;
    }
    arr.push_back(n);
    vector<int> arrPos(n + 1);
    for (int i = 0; i <= n; i++) {
        arrPos[arr[i]] = i;
    }

    vector<int> versions(n + 2);
    versions[0] = build(0, n);
    for (int i = 1; i <= n + 1; i++) {
        versions[i] = tree[versions[i - 1]].update(0, n, arr[i - 1], 1);
    }

    auto getLast = [&](int x, int y) {
        int answer = -1;
        if (x + y == 0) {
            return n;
        }
        for (int i = 1 << 20; i > 0; i >>= 1) {
            int p = answer + i;
            if (p < n) {
                if (tree[versions[p + 1]].query(0, n, 0, x + y - 1) <= y) {
                    answer += i;
                }
            }
        }
        return answer + 1;
    };

    auto getFirst = [&](int x, int y) {
        int answer = -2;
        if (x + y == 0) {
            return 0;
        }
        for (int i = 1 << 20; i > 0; i >>= 1) {
            int p = answer + i;
            if (p < n) {
                if (tree[versions[p + 1]].query(0, n, 0, x + y - 1) < y) {
                    answer += i;
                }
            }
        }
        return answer + 2;
    };

    build2(1, 0, n, arr);

    int q;
    cin >> q;
    while (q--) {
        int r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;
        int x1 = c1, y1 = r1 - c1, x2 = c2, y2 = r2 - c2;
        int l1 = getFirst(x1, y1), l2 = getFirst(x2, y2);
        r1 = getLast(x1, y1), r2 = getLast(x2, y2);

        if (max(l1, l2) <= min(r1, r2)) {
            if (x1 + y1 < x2 + y2) {
                cout << y1 + x1 << ' ' << x1 << '\n';
            } else {
                cout << y2 + x2 << ' ' << x2 << '\n';
            }
        } else {
            if (r2 < l1) {
                swap(x1, x2);
                swap(y1, y2);
                swap(l1, l2);
                swap(r1, r2);
            }
            int k = query2(1, 0, n, r1, l2 - 1);
            int d = 0;
            if (k > 0) {
                d = tree[versions[l1]].query(0, n, 0, k - 1);
            }
            int r = k, c = k - d;
            cout << r << ' ' << c << '\n';
        }
    }
}
