#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <iomanip>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <queue>
#include <numeric>
#include <cmath>
#include <deque>
#include <sstream>
#include <bitset>
#include <ctime>
#include <random>
#include <functional>

using namespace std;
// #define int long long
using ll = long long;
using ld = long double;
constexpr int inf = 1e9 + 7;
constexpr double eps = 1e-6;


void Solve(istream &in, ostream &out) {
    int k;
    in >> k;
    for (int i = 0; i < k; ++i) {
        int _;
        in >> _;
    }
    int t;
    in >> t;
    while (t--) {
        ll n, w, h;
        in >> n >> w >> h;
        vector<int> X(n), Y(n);
        for (int i = 0; i < n; ++i) {
            in >> X[i] >> Y[i];
        }

        vector<int> order(n);
        iota(order.begin(), order.end(), 0);
        sort(order.begin(), order.end(),
             [&X](int i, int j) {
                 return X[i] < X[j];
             });

        ll last_x = -1, best = 0;
        ll res = 0;
        for (int i : order) {
            res += (X[i] - last_x) * best;
            last_x = X[i];
            best = max(best, h - Y[i]);
        }
        res += (w - last_x) * best;
        out << res << '\n';
    }
}


using Solution = function<void (istream &, ostream &)>;
using TestGenerator = function<void (ostream &)>;

void StressTest(Solution smart, Solution stupid, TestGenerator generator, ostream &result_out = cout) {
    static constexpr int N_EPOCHS = 10'000;
    for (int i = 0; i < N_EPOCHS; ++i) {
        ostringstream test;
        generator(test);
        istringstream in_smart(test.str()), in_stupid(test.str());
        ostringstream out_smart, out_stupid;
        smart(in_smart, out_smart);
        stupid(in_stupid, out_stupid);
        if(out_smart.str() != out_stupid.str()) {
            result_out << "Test:\n";
            result_out << test.str() << '\n';
            result_out << "Smart:\n";
            result_out << out_smart.str() << '\n';
            result_out << "Stupid\n";
            result_out << out_stupid.str() << '\n';
            return;
        }
    }
    result_out << "OK\n";
}


int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif
    Solve(cin, cout);
    cerr << clock() * 1.0 / CLOCKS_PER_SEC << '\n';
    return 0;
}
