#include <bits/stdc++.h>

using namespace std;

#define int long long

vector<vector<int>> adj;
vector<int> cc;
vector<int> ll, rr;

vector<int> dp_min_cost;
vector<int> dp_min_bought;
vector<map<int, vector<pair<int, int>>>> dp_left;
vector<int> ans;

bool ok;

void dfs(int u) {
	for(int v: adj[u]) {
		dfs(v);
		if(!ok) {
			return;
		}
		dp_min_cost[u] += dp_min_cost[v];
		dp_min_bought[u] += dp_min_bought[v];

		if(dp_left[v].size() > dp_left[u].size()) {
			swap(dp_left[v], dp_left[u]);
		}
		for(auto& [cost, items]: dp_left[v]) {
			auto& arr = dp_left[u][cost];
			arr.insert(arr.end(), items.begin(), items.end());
		}
		dp_left[v].clear();
	}

	int cnt = rr[u] - dp_min_bought[u];
	if(cnt < 0) {
		ok = false;
		return;
	}
	if(cnt > 0) {
		dp_left[u][cc[u]].emplace_back(u, cnt);
	}

	int sum_cnt_in_dp_left = 0;
	for(auto& [cost, items]: dp_left[u]) {
		for(auto& [w, cnt]: items) {
			sum_cnt_in_dp_left += cnt;
		}
	}
	while(sum_cnt_in_dp_left > cnt) {
		auto it = dp_left[u].end();
		--it;
		int d = min(it->second.back().second, sum_cnt_in_dp_left - cnt);
		sum_cnt_in_dp_left -= d;
		if((it->second.back().second -= d) == 0) {
			it->second.pop_back();
			if(it->second.empty()) {
				dp_left[u].erase(it);
			}
		}
	}

	if(dp_min_bought[u] < ll[u]) {
		int need = ll[u] - dp_min_bought[u];

		while(need > 0) {
			if(dp_left[u].empty()) {
				ok = false;
				return;
			}
			auto it = dp_left[u].begin();
			while(!it->second.empty() && need > 0) {
				int cnt = min(need, it->second.back().second);
				ans[it->second.back().first] += cnt;
				dp_min_cost[u] += cnt * it->first;
				need -= cnt;
				it->second.back().second -= cnt;
				if(it->second.back().second == 0) {
					it->second.pop_back();
				}
			}
			if(it->second.empty()) {
				dp_left[u].erase(it);
			}
		}

		dp_min_bought[u] = ll[u];
	}
}

void solve() {
	int n;
	cin >> n;

	adj.clear();
	adj.resize(n);
	for(int u = 1; u < n; u++) {
		int p;
		cin >> p;
		p--;
		adj[p].push_back(u);
	}

	cc.resize(n);
	for(int& x: cc) {
		cin >> x;
	}

	ll.resize(n);
	rr.resize(n);
	for(int i = 0; i < n; i++) {
		cin >> ll[i] >> rr[i];
	}

	ok = true;
	dp_min_cost.clear();
	dp_min_cost.resize(n);
	dp_min_bought.clear();
	dp_min_bought.resize(n);
	dp_left.clear();
	dp_left.resize(n);
	ans.clear();
	ans.resize(n);
	dfs(0);
	if(ok) {
		cout << dp_min_cost[0] << "\n";
		for(int x: ans) {
			cout << x << " ";
		}
		cout << "\n";
	} else {
		cout << -1 << "\n";
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int t;
	cin >> t;

	while(t --> 0) {
		solve();
	}

	return 0;
}