#include <bits/stdc++.h>

using namespace std;

#define int long long


class LiChaoTree {
	vector<int> xx;
	vector<pair<int, int>> line;
	vector<bool> mod;
	int n;

public:
	LiChaoTree(vector<int> xx): xx(xx) {
		n = xx.size();
		line.resize(4 * n);
		mod.resize(4 * n);
	}

	void push(int v, int vl, int vr) {
		if(mod[v]) {
			if(vr - vl > 1) {
				mod[v * 2] = true;
				line[v * 2] = make_pair(0, -1000000000000000000);
				mod[v * 2 + 1] = true;
				line[v * 2 + 1] = make_pair(0, -1000000000000000000);
			}
			mod[v] = false;
		}
	}

	void set(int v, int vl, int vr, int l, int r, pair<int, int> ln) {
		if(vl == l && vr == r) {
			mod[v] = true;
			line[v] = ln;
		} else {
			push(v, vl, vr);
			int vm = (vl + vr) / 2;
			max_eq(v * 2, vl, vm, vl, vm, line[v]);
			max_eq(v * 2 + 1, vm, vr, vm, vr, line[v]);
			line[v] = make_pair(0, -1000000000000000000);
			if(r <= vm) {
				set(v * 2, vl, vm, l, r, ln);
			} else if(l >= vm) {
				set(v * 2 + 1, vm, vr, l, r, ln);
			} else {
				set(v * 2, vl, vm, l, vm, ln);
				set(v * 2 + 1, vm, vr, vm, r, ln);
			}
		}
	}
	void set(int l, int r, pair<int, int> ln) {
		set(1, 0, n, l, r, ln);
	}

	void max_eq(int v, int vl, int vr, int l, int r, pair<int, int> ln) {
		if(vl == l && vr == r) {
			push(v, vl, vr);

			int old_at_start = line[v].first * xx[vl] + line[v].second;
			int new_at_start = ln.first * xx[vl] + ln.second;

			int old_at_end = line[v].first * xx[vr - 1] + line[v].second;
			int new_at_end = ln.first * xx[vr - 1] + ln.second;

			if(old_at_start <= new_at_start && old_at_end <= new_at_end) {
				line[v] = ln;
			} else if(old_at_start >= new_at_start && old_at_end >= new_at_end) {
				// pass
			} else {
				if(old_at_start >= new_at_start) {
					swap(ln, line[v]);
				}

				int vm = (vl + vr) / 2;
				int old_at_mid = line[v].first * xx[vm] + line[v].second;
				int new_at_mid = ln.first * xx[vm] + ln.second;

				if(old_at_mid <= new_at_mid) {
					max_eq(v * 2 + 1, vm, vr, vm, vr, line[v]);
					line[v] = ln;
				} else {
					max_eq(v * 2, vl, vm, vl, vm, ln);
				}
			}
		} else {
			push(v, vl, vr);
			int vm = (vl + vr) / 2;
			if(r <= vm) {
				max_eq(v * 2, vl, vm, l, r, ln);
			} else if(l >= vm) {
				max_eq(v * 2 + 1, vm, vr, l, r, ln);
			} else {
				max_eq(v * 2, vl, vm, l, vm, ln);
				max_eq(v * 2 + 1, vm, vr, vm, r, ln);
			}
		}
	}
	void max_eq(int l, int r, pair<int, int> ln) {
		max_eq(1, 0, n, l, r, ln);
	}

	int get(int v, int vl, int vr, int i) {
		if(vr - vl == 1) {
			return line[v].first * xx[i] + line[v].second;
		} else {
			push(v, vl, vr);
			int cur = line[v].first * xx[i] + line[v].second;
			int vm = (vl + vr) / 2;
			if(i < vm) {
				return max(get(v * 2, vl, vm, i), cur);
			} else {
				return max(get(v * 2 + 1, vm, vr, i), cur);
			}
		}
	}
	int get(int i) {
		return get(1, 0, n, i);
	}
};

vector<int> directions;

void solve() {
	int n, w, h;
	cin >> n >> w >> h;

	vector<pair<int, int>> pts(n);
	for(auto& [x, y]: pts) {
		cin >> x >> y;
	}

	sort(pts.begin(), pts.end(), [](auto p1, auto p2) {
		return p1.second < p2.second;
	});

	vector<int> xx;
	for(auto [x, y]: pts) {
		xx.push_back(x);
	}
	xx.push_back(0);
	xx.push_back(w);
	sort(xx.begin(), xx.end());
	xx.erase(unique(xx.begin(), xx.end()), xx.end());

	// vector<int> dp_l_x(xx.size());
	LiChaoTree dp_l_x(xx);
	vector<int> dp_r_x(xx.size());

	int mod_dp_l_x = 0;
	int mod_dp_r_x = 0;

	for(int i = n - 1; i >= 0; i--) {
		auto [x, y] = pts[i];
		int x_id = lower_bound(xx.begin(), xx.end(), x) - xx.begin();

		int next_x_id = i == 0 ? 0 : lower_bound(xx.begin(), xx.end(), pts[i - 1].first) - xx.begin();

		int d_dp_l_x = (x - xx[next_x_id]) * (h - y);
		mod_dp_l_x += d_dp_l_x;

		int d_dp_r_x = (xx[next_x_id] - x) * (h - y);
		mod_dp_r_x += d_dp_r_x;

		for(int r = next_x_id + 1; r < xx.size(); r++) {
			if(x < xx[next_x_id] || x > xx[r]) {
				dp_l_x.set(r, r + 1, make_pair(0, (xx[r] - xx[next_x_id]) * (h - y) - mod_dp_l_x));
			} else {
				dp_l_x.max_eq(r, r + 1, make_pair(0, (xx[r] - x) * (h - y) + dp_r_x[next_x_id] - d_dp_r_x + mod_dp_r_x - mod_dp_l_x));
			}
		}

		for(int l = 0; l < next_x_id; l++) {
			if(x < xx[l] || x > xx[next_x_id]) {
				dp_r_x[l] = (xx[next_x_id] - xx[l]) * (h - y) - mod_dp_r_x;
			} else {
				dp_r_x[l] = max(
					dp_r_x[l],
					(x - xx[l]) * (h - y) + dp_l_x.get(next_x_id) - d_dp_l_x + mod_dp_l_x - mod_dp_r_x
				);
			}
		}

		for(int r = 0; r < next_x_id + 1; r++) {
			dp_l_x.set(r, r + 1, make_pair(0, -mod_dp_l_x));
		}
		for(int l = next_x_id; l < xx.size(); l++) {
			dp_r_x[l] = -mod_dp_r_x;
		}
	}

	cout << dp_l_x.get(xx.size() - 1) + mod_dp_l_x << "\n";
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	// LiChaoTree tree({0, 1, 2, 3, 4, 5, 6, 7, 8, 9});
	// vector<int> arr(10, 0);

	// for(int i = 0; i < 10000; i++) {
	// 	int t = rand() % 2;
	// 	int l = rand() % 10;
	// 	int r = l + 1 + rand() % (10 - l);
	// 	auto ln = make_pair(rand() % 100, rand() % 100);
	// 	if(t == 0) {
	// 		cerr << "max= " << l << ".." << r << " " << ln.first << "*x + " << ln.second << endl;
	// 		tree.max_eq(l, r, ln);
	// 		for(int j = l; j < r; j++) {
	// 			arr[j] = max(arr[j], ln.first * j + ln.second);
	// 		}
	// 	} else {
	// 		cerr << "set " << l << ".." << r << " " << ln.first << "*x + " << ln.second << endl;
	// 		tree.set(l, r, ln);
	// 		for(int j = l; j < r; j++) {
	// 			arr[j] = ln.first * j + ln.second;
	// 		}
	// 	}
	// 	for(int j = 0; j < 10; j++) {
	// 		cerr << arr[j] << " ";
	// 	}
	// 	cerr << "| ";
	// 	for(int j = 0; j < 10; j++) {
	// 		cerr << tree.get(j) << " ";
	// 	}
	// 	cerr << endl;
	// 	for(int j = 0; j < 10; j++) {
	// 		assert(arr[j] == tree.get(j));
	// 	}
	// }
	// return 0;



	{
		int k;
		cin >> k;
		directions.resize(k);
		for(int& d: directions) {
			cin >> d;
		}
	}

	int t;
	cin >> t;
	while(t --> 0) {
		solve();
	}

	return 0;
}