#include <bits/stdc++.h>

using namespace std;

#define int long long


class LiChaoTree {
	vector<int> xx;
	vector<pair<int, int>> line;
	vector<bool> mod;
	int n;

public:
	LiChaoTree(vector<int> xx): xx(xx) {
		n = xx.size();
		line.resize(4 * n);
		mod.resize(4 * n);
	}

	void push(int v, int vl, int vr) {
		if(mod[v]) {
			if(vr - vl > 1) {
				mod[v * 2] = true;
				line[v * 2] = make_pair(0, -1000000000000000000);
				mod[v * 2 + 1] = true;
				line[v * 2 + 1] = make_pair(0, -1000000000000000000);
			}
			mod[v] = false;
		}
	}

	void set(int v, int vl, int vr, int l, int r, pair<int, int> ln) {
		if(vl == l && vr == r) {
			mod[v] = true;
			line[v] = ln;
		} else {
			push(v, vl, vr);
			int vm = (vl + vr) / 2;
			max_eq(v * 2, vl, vm, vl, vm, line[v]);
			max_eq(v * 2 + 1, vm, vr, vm, vr, line[v]);
			line[v] = make_pair(0, -1000000000000000000);
			if(r <= vm) {
				set(v * 2, vl, vm, l, r, ln);
			} else if(l >= vm) {
				set(v * 2 + 1, vm, vr, l, r, ln);
			} else {
				set(v * 2, vl, vm, l, vm, ln);
				set(v * 2 + 1, vm, vr, vm, r, ln);
			}
		}
	}
	void set(int l, int r, pair<int, int> ln) {
		if(l == r) {
			return;
		}
		set(1, 0, n, l, r, ln);
	}

	void max_eq(int v, int vl, int vr, int l, int r, pair<int, int> ln) {
		if(vl == l && vr == r) {
			push(v, vl, vr);

			int old_at_start = line[v].first * xx[vl] + line[v].second;
			int new_at_start = ln.first * xx[vl] + ln.second;

			int old_at_end = line[v].first * xx[vr - 1] + line[v].second;
			int new_at_end = ln.first * xx[vr - 1] + ln.second;

			if(old_at_start <= new_at_start && old_at_end <= new_at_end) {
				line[v] = ln;
			} else if(old_at_start >= new_at_start && old_at_end >= new_at_end) {
				// pass
			} else {
				if(old_at_start >= new_at_start) {
					swap(ln, line[v]);
				}

				int vm = (vl + vr) / 2;
				int old_at_mid = line[v].first * xx[vm] + line[v].second;
				int new_at_mid = ln.first * xx[vm] + ln.second;

				if(old_at_mid <= new_at_mid) {
					max_eq(v * 2 + 1, vm, vr, vm, vr, line[v]);
					line[v] = ln;
				} else {
					max_eq(v * 2, vl, vm, vl, vm, ln);
				}
			}
		} else {
			push(v, vl, vr);
			int vm = (vl + vr) / 2;
			if(r <= vm) {
				max_eq(v * 2, vl, vm, l, r, ln);
			} else if(l >= vm) {
				max_eq(v * 2 + 1, vm, vr, l, r, ln);
			} else {
				max_eq(v * 2, vl, vm, l, vm, ln);
				max_eq(v * 2 + 1, vm, vr, vm, r, ln);
			}
		}
	}
	void max_eq(int l, int r, pair<int, int> ln) {
		if(l == r) {
			return;
		}
		max_eq(1, 0, n, l, r, ln);
	}

	int get(int v, int vl, int vr, int i) {
		if(vr - vl == 1) {
			return line[v].first * xx[i] + line[v].second;
		} else {
			push(v, vl, vr);
			int cur = line[v].first * xx[i] + line[v].second;
			int vm = (vl + vr) / 2;
			if(i < vm) {
				return max(get(v * 2, vl, vm, i), cur);
			} else {
				return max(get(v * 2 + 1, vm, vr, i), cur);
			}
		}
	}
	int get(int i) {
		return get(1, 0, n, i);
	}
};

vector<int> directions;

int meh_ans(vector<pair<int, int>> pts, int x_start, int x_lim, int y_start, int y_lim) {
	if(pts.empty()) {
		return 0;
	}

	int n = pts.size();
	vector<vector<vector<int>>> dp(n + 1, vector<vector<int>>(n + 1, vector<int>(n + 1)));

	for(int i = n - 1; i >= 0; i--) {
		for(int x_i = -1; x_i < i; x_i++) {
			for(int y_i = -1; y_i < i; y_i++) {
				dp[i][x_i + 1][y_i + 1] = max(
					(x_lim - pts[i].first) * ((y_i == -1 ? y_lim : pts[y_i].second) - pts[i].second) + dp[i + 1][x_i + 1][i + 1],
					(pts[i].first - (x_i == -1 ? x_start : pts[x_i].first)) * (pts[i].second - y_start) + dp[i + 1][i + 1][y_i + 1]
				);
			}
		}
	}

	int ans = 0;
	for(auto& items: dp[0]) {
		for(int x: items) {
			ans = max(ans, x);
		}
	}

	return ans;
}

void solve() {
	int n, w, h;
	cin >> n >> w >> h;

	vector<pair<int, int>> pts(n);
	for(auto& [x, y]: pts) {
		cin >> x >> y;
	}
	sort(pts.begin(), pts.end(), [](auto p1, auto p2) {
		return make_pair(p1.first, -p1.second) < make_pair(p2.first, -p2.second);
	});

	vector<int> xx;
	for(auto [x, y]: pts) {
		xx.push_back(x);
	}
	xx.push_back(0);
	xx.push_back(w);
	sort(xx.begin(), xx.end());
	xx.erase(unique(xx.begin(), xx.end()), xx.end());

	vector<int> yy;
	for(auto [x, y]: pts) {
		yy.push_back(y);
	}
	yy.push_back(0);
	yy.push_back(h);
	sort(yy.begin(), yy.end());
	yy.erase(unique(yy.begin(), yy.end()), yy.end());

	int x_start = 0;
	int y_lim = h;

	int l = 0;
	int ans = 0;
	for(int r = 0; r < n; r++) {
		if(r > l && pts[r].second >= pts[r - 1].second) {
			vector<pair<int, int>> meh;
			while(pts[l].second >= pts[r].second) {
				meh.push_back(pts[l]);
				l++;
			}
			ans += meh_ans(meh, x_start, pts[r - 1].first, pts[r].second, y_lim);

			int cur = (
				(pts[r].first - x_start) * pts[r].second
				+ (w - pts[r - 1].first) * (y_lim - pts[r - 1].second)
				- (pts[r].first - pts[r - 1].first) * (pts[r].second - pts[r - 1].second)
			);
			ans += cur;

			x_start = pts[r].first;
			y_lim = pts[r - 1].second;

			l = r + 1;
		}
	}

	vector<pair<int, int>> meh;
	while(l < n) {
		meh.push_back(pts[l]);
		l++;
	}
	ans += meh_ans(meh, x_start, w, 0, y_lim);

	cout << ans << endl;
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	{
		int k;
		cin >> k;
		directions.resize(k);
		for(int& d: directions) {
			cin >> d;
		}
	}

	int t;
	cin >> t;
	while(t --> 0) {
		solve();
	}

	return 0;
}