#include <bits/stdc++.h>

using namespace std;

#define int long long


// class LiChaoTree {
// 	vector<int> xx;
// 	vector<pair<int, int>> line;
// 	vector<int> version;
// 	vector<int> mod;
// 	int last_ver;
// 	int n;

// public:
// 	LiChaoTree(vector<int> xx): xx(xx) {
// 		n = xx.size();
// 		line.resize(4 * n);
// 		version.resize(4 * n);
// 		mod.resize(4 * n);
// 		last_ver = 0;
// 	}

// 	void push(int v, int vl, int vr) {
// 		if(vr - vl > 1) {
// 			line[v * 2].second += mod[v];
// 			mod[v * 2] += mod[v];
// 			line[v * 2 + 1].second += mod[v];
// 			mod[v * 2 + 1] += mod[v];
// 		}
// 		mod[v] = 0;
// 	}

// 	int inc(int v, int vl, int vr, int l, int r, int x) {
// 		if(vl == l && vr == r) {
// 			mod[v] += x;
// 			line[v].second += x;
// 		} else {
// 			push(v, vl, vr);
// 			int vm = (vl + vr) / 2;
// 			if(r <= vm) {
// 				inc(v * 2, vl, vm, l, r, x);
// 			} else if(l >= vm) {
// 				inc(v * 2 + 1, vm, vr, l, r, x);
// 			} else {
// 				inc(v * 2, vl, vm, l, vm, x);
// 				inc(v * 2 + 1, vm, vr, vm, r, x);
// 			}
// 		}
// 	}
// 	int inc(int l, int r, int x) {
// 		inc(1, 0, n, l, r, x);
// 	}
// };

vector<int> directions;

void solve() {
	int n, w, h;
	cin >> n >> w >> h;

	vector<pair<int, int>> pts(n);
	for(auto& [x, y]: pts) {
		cin >> x >> y;
	}

	sort(pts.begin(), pts.end(), [](auto p1, auto p2) {
		return p1.second < p2.second;
	});

	vector<int> xx;
	for(auto [x, y]: pts) {
		xx.push_back(x);
	}
	xx.push_back(0);
	xx.push_back(w);
	sort(xx.begin(), xx.end());
	xx.erase(unique(xx.begin(), xx.end()), xx.end());

	vector<int> dp_l_x(xx.size());
	vector<int> dp_r_x(xx.size());

	int mod_dp_l_x = 0;
	int mod_dp_r_x = 0;

	for(int i = n - 1; i >= 0; i--) {
		auto [x, y] = pts[i];
		int x_id = lower_bound(xx.begin(), xx.end(), x) - xx.begin();

		int next_x_id = i == 0 ? 0 : lower_bound(xx.begin(), xx.end(), pts[i - 1].first) - xx.begin();

		int d_dp_l_x = (x - xx[next_x_id]) * (h - y);
		mod_dp_l_x += d_dp_l_x;

		int d_dp_r_x = (xx[next_x_id] - x) * (h - y);
		mod_dp_r_x += d_dp_r_x;

		for(int r = next_x_id + 1; r < xx.size(); r++) {
			if(x < xx[next_x_id] || x > xx[r]) {
				dp_l_x[r] = (xx[r] - xx[next_x_id]) * (h - y) - mod_dp_l_x;
			} else {
				dp_l_x[r] = max(
					(xx[r] - x) * (h - y) + dp_r_x[next_x_id] - d_dp_r_x + mod_dp_r_x - mod_dp_l_x,
					dp_l_x[r]
				);
			}
		}

		for(int l = 0; l < next_x_id; l++) {
			if(x < xx[l] || x > xx[next_x_id]) {
				dp_r_x[l] = (xx[next_x_id] - xx[l]) * (h - y) - mod_dp_r_x;
			} else {
				dp_r_x[l] = max(
					dp_r_x[l],
					(x - xx[l]) * (h - y) + dp_l_x[next_x_id] - d_dp_l_x + mod_dp_l_x - mod_dp_r_x
				);
			}
		}

		for(int r = 0; r < next_x_id + 1; r++) {
			dp_l_x[r] = -mod_dp_l_x;
		}
		for(int l = next_x_id; l < xx.size(); l++) {
			dp_r_x[l] = -mod_dp_r_x;
		}
	}

	cout << dp_l_x[xx.size() - 1] + mod_dp_l_x << "\n";
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	{
		int k;
		cin >> k;
		directions.resize(k);
		for(int& d: directions) {
			cin >> d;
		}
	}

	int t;
	cin >> t;
	while(t --> 0) {
		solve();
	}

	return 0;
}