#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;

#define len(a) int((a).size())
#define all(a) begin(a), end(a)

template<typename Fun>
struct y_combinator {
	const Fun fun;

	y_combinator(const Fun&& fun) : fun(forward<const Fun>(fun)) {}

	template<typename... Args>
	decltype(auto) operator()(Args&&... args) const {
		return fun(ref(*this), forward<Args>(args)...);
	}
};

int main() {
	ios::sync_with_stdio(false), cin.tie(nullptr);

	int n;
	cin >> n;
	vector<int> p(n);
	for (auto &x : p) {
		cin >> x;
		x--;
	}
	vector<int> where(n);
	for (int i = 0; i < n; i++) {
		where[p[i]] = i;
	}

	vector<vector<int>> ans(n, vector<int>(n));
	vector<vector<int>> pref(n, vector<int>(n));
	for (int i = 0; i < n; i++) {
		if (i) {
			pref[i] = pref[i - 1];
		}
		for (int j = 0; j < p[i]; j++) {
			pref[i][j]++;
		}
	}

	vector<vector<int>> suf(n, vector<int>(n));
	for (int i = n - 1; i >= 0; i--) {
		if (i != n - 1) {
			suf[i] = suf[i + 1];
		}
		for (int j = p[i] + 1; j < n; j++) {
			suf[i][j]++;
		}
	}

	struct segtree {
		int n;
		vector<int> tree;

		segtree(int n) : n(n), tree(2 * n) {}

		void build() {
			for (int i = n - 1; i; i--) {
				tree[i] = max(tree[i << 1], tree[i << 1 | 1]);
			}
		}

		int query(int l, int r) {
			int res = -1e7;
			for (l += n, r += n; l < r; l >>= 1, r >>= 1) {
				if (l & 1) {
					res = max(res, tree[l++]);
				}
				if (r & 1) {
					res = max(res, tree[--r]);
				}
			}
			return res;
		}
	};

	vector<segtree> tree_suf(n, segtree(n)), tree_pref = tree_suf;
	for (int x = 0; x < n; x++) {
		for (int i = 0; i < n; i++) {
			tree_suf[x].tree[n + i] = suf[i][x] + i;
			tree_pref[x].tree[n + i] = pref[i][x] - i;
		}
		tree_suf[x].build();
		tree_pref[x].build();
	}

	for (int x = 0; x < n; x++) {
		for (int y = x + 1; y < n; y++) {
			int p1 = where[x], p2 = where[y];
			ans[x][y] = max(ans[x][y], abs(p1 - p2));
			ans[x][y] = max(ans[x][y], abs(x - y));
			int xx = x, yy = y;
			if (p1 > p2) {
				swap(p1, p2);
				swap(xx, yy);
			}
			ans[x][y] = max(ans[x][y], tree_suf[yy].query(p1 + 1, p2 + 1) - p1);
			ans[x][y] = max(ans[x][y], tree_pref[xx].query(p1, p2) + p2);
			// for (int pos = p1 + 1; pos <= p2; pos++) {
			// 	ans[x][y] = max(ans[x][y], suf[pos][yy] + (pos - p1));
			// }
			// for (int pos = p1; pos < p2; pos++) {
			// 	ans[x][y] = max(ans[x][y], pref[pos][xx] + (p2 - pos));
			// }
		}
	}

	ll res = 0;
	for (int x = 0; x < n; x++) {
		for (int y = x + 1; y < n; y++) {
			res += ans[x][y];
            // cout << "(" << x << ", " << y << "): " << ans[x][y] << endl;
		}
	}
	cout << res << '\n';
}
