#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;

#define len(a) int((a).size())
#define all(a) begin(a), end(a)

template<typename Fun>
struct y_combinator {
	const Fun fun;

	y_combinator(const Fun&& fun) : fun(forward<const Fun>(fun)) {}

	template<typename... Args>
	decltype(auto) operator()(Args&&... args) const {
		return fun(ref(*this), forward<Args>(args)...);
	}
};

void solve() {
	int n;
	cin >> n;
	vector<vector<int>> g(n);
	vector<int> par(n, -1);
	for (int i = 1; i < n; i++) {
		cin >> par[i];
		par[i]--;
		g[par[i]].push_back(i);
	}
	vector<int> c(n);
	for (auto &x : c) {
		cin >> x;
	}
	vector<int> l(n), r(n);
	for (int i = 0; i < n; i++) {
		cin >> l[i] >> r[i];
	}

	vector<int> tin(n), tout(n), order;
	int timer = 0;

	y_combinator([&](auto dfs, int v) -> void {
		tin[v] = timer++;
		order.push_back(v);
		for (auto u : g[v]) {
			dfs(u);
		}
		tout[v] = timer;
	})(0);

	bool ok = true;
	vector<int> ans(n), can(n, 1e9);

	y_combinator([&](auto dfs, int v) -> pair<int, set<pair<int, int>>> {
		if (g[v].empty()) {
			can[v] = r[v] - l[v];
			ans[v] += l[v];
			set<pair<int, int>> st;
			st.emplace(c[v], v);
			return {l[v], st};
		}

		int tot = 0;
		set<pair<int, int>> st;
		st.emplace(c[v], v);
		for (auto u : g[v]) {
			auto [take, cur] = dfs(u);
			tot += take;
			if (tot > r[v]) {
				ok = false;
			}
			if (!ok) {
				return {-1, {}};
			}

			if (len(cur) > len(st)) {
				swap(cur, st);
			}
			for (auto x : cur) {
				st.insert(x);
			}
		}
		assert(tot <= r[v]);
		can[v] = r[v] - tot;

		int delta = max(0, l[v] - tot);
		tot += delta;

		while (delta > 0) {
			auto calc_can = [&](int u) {
				int ver = u, cur = 1e9;
				while (ver != par[v]) {
					cur = min(cur, can[ver]);
					if (cur == 0) break;
					ver = par[ver];
				}
				return cur;
			};

			int u = st.begin()->second;
			int to_sub = min(delta, calc_can(u));
			if (to_sub == 0) {
				st.erase(st.begin());
				continue;
			}

			ans[u] += to_sub;
			delta -= to_sub;

			while (u != par[v]) {
				can[u] -= to_sub;
				u = par[u];
			}
		}
		return {tot, st};
	})(0);

	if (!ok) {
		cout << "-1\n";
		return;
	}

	ll cost = 0;
	for (int i = 0; i < n; i++) {
		cost += 1ll * ans[i] * c[i];
	}
	cout << cost << '\n';
	for (int i = 0; i < n; i++) {
		cout << ans[i] << " \n"[i == n - 1];
	}
}

int main() {
	ios::sync_with_stdio(false), cin.tie(nullptr);

	int tests;
	cin >> tests;
	while (tests--) {
		solve();
	}
}
