#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;

#define len(a) int((a).size())
#define all(a) begin(a), end(a)

template<typename Fun>
struct y_combinator {
	const Fun fun;

	y_combinator(const Fun&& fun) : fun(forward<const Fun>(fun)) {}

	template<typename... Args>
	decltype(auto) operator()(Args&&... args) const {
		return fun(ref(*this), forward<Args>(args)...);
	}
};

void solve() {
	int n;
	cin >> n;
	vector<vector<int>> g(n);
	vector<int> par(n, -1);
	for (int i = 1; i < n; i++) {
		cin >> par[i];
		par[i]--;
		g[par[i]].push_back(i);
	}
	vector<int> c(n);
	for (auto &x : c) {
		cin >> x;
	}
	vector<int> l(n), r(n);
	for (int i = 0; i < n; i++) {
		cin >> l[i] >> r[i];
	}

	vector<int> sz(n), tin(n), tout(n), head(n);
	int timer = 0;

	y_combinator([&](auto dfs, int v) -> void {
		sz[v] = 1;
		for (auto u : g[v]) {
			dfs(u);
			sz[v] += sz[u];
		}
		sort(all(g[v]), [&](const auto &v, const auto &u) {
			return sz[v] > sz[u];
		});
	})(0);

	y_combinator([&](auto dfs, int v) -> void {
		tin[v] = timer++;
		for (int i = 0; i < len(g[v]); i++) {
			int u = g[v][i];
			head[u] = i == 0 ? head[v] : u;
			dfs(u);
		}
		tout[v] = timer;
	})(0);

	// struct segtree {
	// 	vector<int> a;

	// 	segtree(int n) : a(n) {}

	// 	void add(int l, int r, int delta) {
	// 		for (int i = l; i < r; i++) {
	// 			a[i] += delta;
	// 		}
	// 	}

	// 	int get_min(int l, int r) {
	// 		assert(l < r);
	// 		return *min_element(a.begin() + l, a.begin() + r);
	// 	}
	// } tree(n);

	struct segtree {
		int n;
		vector<int> tree, mod;

		segtree(int n) : n(n), tree(4 * n), mod(4 * n) {}

		void apply(int v, int delta) {
			tree[v] += delta;
			mod[v] += delta;
		}

		void push(int v) {
			apply(v << 1, mod[v]);
			apply(v << 1 | 1, mod[v]);
			mod[v] = 0;
		}

		void add(int l, int r, int delta) {
			add(1, 0, n, l, r, delta);
		}

		void add(int v, int vl, int vr, int l, int r, int delta) {
			if (r <= vl || vr <= l) {
				return;
			}
			if (l <= vl && vr <= r) {
				apply(v, delta);
				return;
			}
			push(v);
			int vm = (vl + vr) >> 1;
			add(v << 1, vl, vm, l, r, delta);
			add(v << 1 | 1, vm, vr, l, r, delta);
			tree[v] = min(tree[v << 1], tree[v << 1 | 1]);
		}

		int get_min(int l, int r) {
			return get_min(1, 0, n, l, r);
		}

		int get_min(int v, int vl, int vr, int l, int r) {
			if (r <= vl || vr <= l) {
				return 1e9;
			}
			if (l <= vl && vr <= r) {
				return tree[v];
			}
			push(v);
			int vm = (vl + vr) >> 1;
			return min(get_min(v << 1, vl, vm, l, r), get_min(v << 1 | 1, vm, vr, l, r));
		}
	} tree(n);

	auto get_min = [&](int from, int to) {
		int res = 1e9;
		while (head[from] != head[to]) {
			res = min(res, tree.get_min(tin[head[to]], tin[to] + 1));
			to = par[head[to]];
		}
		res = min(res, tree.get_min(tin[from], tin[to] + 1));
		return res;
	};

	auto add_on_path = [&](int from, int to, int delta) {
		while (head[from] != head[to]) {
			tree.add(tin[head[to]], tin[to] + 1, delta);
			to = par[head[to]];
		}
		tree.add(tin[from], tin[to] + 1, delta);
	};

	bool ok = true;
	vector<int> ans(n);

	y_combinator([&](auto dfs, int v) -> pair<int, set<pair<int, int>>> {
		if (g[v].empty()) {
			tree.add(tin[v], tin[v] + 1, r[v] - l[v]);
			ans[v] += l[v];
			set<pair<int, int>> st;
			st.emplace(c[v], v);
			return {l[v], st};
		}

		int tot = 0;
		set<pair<int, int>> st;
		st.emplace(c[v], v);
		for (auto u : g[v]) {
			auto [take, cur] = dfs(u);
			tot += take;
			if (tot > r[v]) {
				ok = false;
			}
			if (!ok) {
				return {-1, {}};
			}

			if (len(cur) > len(st)) {
				swap(cur, st);
			}
			for (auto x : cur) {
				st.insert(x);
			}
		}
		assert(tot <= r[v]);
		tree.add(tin[v], tin[v] + 1, r[v] - tot);

		int delta = max(0, l[v] - tot);
		tot += delta;

		while (delta > 0) {
			int u = st.begin()->second;
			int to_sub = min(delta, get_min(v, u));
			if (to_sub == 0) {
				st.erase(st.begin());
				continue;
			}

			ans[u] += to_sub;
			delta -= to_sub;
			add_on_path(v, u, -to_sub);
		}
		return {tot, st};
	})(0);

	if (!ok) {
		cout << "-1\n";
		return;
	}

	ll cost = 0;
	for (int i = 0; i < n; i++) {
		cost += 1ll * ans[i] * c[i];
	}
	cout << cost << '\n';
	for (int i = 0; i < n; i++) {
		cout << ans[i] << " \n"[i == n - 1];
	}
}

int main() {
	ios::sync_with_stdio(false), cin.tie(nullptr);

	int tests;
	cin >> tests;
	while (tests--) {
		solve();
	}
}
