#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;

#define len(a) int((a).size())
#define all(a) begin(a), end(a)

template<typename Fun>
struct y_combinator {
	const Fun fun;

	y_combinator(const Fun&& fun) : fun(forward<const Fun>(fun)) {}

	template<typename... Args>
	decltype(auto) operator()(Args&&... args) const {
		return fun(ref(*this), forward<Args>(args)...);
	}
};

int main() {
	ios::sync_with_stdio(false), cin.tie(nullptr);

	int n;
	cin >> n;
	vector<int> a(n);
	for (auto &x : a) {
		cin >> x;
	}

	vector<vector<int>> par(n + 1);
	for (int i = 0; i <= n; i++) {
		par[i].resize(i + 1, -1);
	}
	vector<int> coords(n + 1);
	iota(all(coords), 0);

	auto relax_par = [&](int from) {
		for (int x = from + 1; x <= n; x++) {
			par[x][coords[x]] = coords[x - 1];
		}
	};

	relax_par(0);
	for (int i = 0; i < n; i++) {
		for (int j = a[i]; j <= n; j++) {
			coords[j] -= 1;
		}
		relax_par(a[i] - 1);
	}

	int q;
	cin >> q;
	while (q--) {
		int x1, y1, x2, y2;
		cin >> x1 >> y1 >> x2 >> y2;
		for (; x1 > x2; x1--) {
			y1 = par[x1][y1];
		}
		for (; x2 > x1; x2--) {
			y2 = par[x2][y2];
		}
		while (x1 != x2 || y1 != y2) {
			y1 = par[x1--][y1];
			y2 = par[x2--][y2];
		}
		cout << x1 << ' ' << y1 << '\n';
	}
}
