#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>

using namespace std;

#define long long long int

void build_graph(vector<int> &pp, vector<set<int>> &a, int n) {
    vector<int> ci(n, 0);
    for (int i = 0;i < n;i++) {
        int cur = 0;
        for (int j = 0;j < n;j++) {
            if (ci[j] == 0) {
                a[cur].insert(cur + n + 2);
                a[cur + n + 2].insert(cur);
                cur += n + 2;
            }
            else {
                a[cur].insert(cur + n + 1);
                a[cur + n + 1].insert(cur);
                cur += n + 1;
            }
        }
        ci[pp[i] - 1] = 1;
        //for (auto pi : ci) cout << pi << " ";
        //cout << endl;
    }
    int cur = 0;
    for (int j = 0;j < n;j++) {
            if (ci[j] == 0) {
                a[cur].insert(cur + n + 2);
                a[cur + n + 2].insert(cur);
                cur += n + 2;
            }
            else {
                a[cur].insert(cur + n + 1);
                a[cur + n + 1].insert(cur);
                cur += n + 1;
            }
        }
}

bool dfs(int v, int &mmax, int stop, int pre, vector<set<int>> &a) {
    if (v == stop) {
        mmax = min(mmax, v);
        return true;
    }
    for (auto i : a[v]) {
        if (i != pre) {
            if (dfs(i, mmax, stop, v, a) == true) {
                mmax = min(mmax, v);
                return true;
            }
        }
    }
    return false;
}

int lca(int a, int b, vector<set<int>> &a1) {
    int mmax = 1e9;
    dfs(a, mmax, b, a, a1);
    return mmax;
}

int main() {
    int n;
    cin >> n;
    vector<int> pp(n);
    for (int i = 0;i < n;i++) cin >> pp[i];
    if (n > 3000) {
        int q;
        cin >> q;
        for (int i = 0;i < q;i++) {
            int a, b, c, d;
            cin >> a >> b >> c >> d;
            if (a - b == c - d) {
                if (a < c) cout << a << " " << b << endl;
                else cout << c << " " << d << endl;
            }
            else {
                a -= b; c -= d;
                b = 0; d = 0;
                if (a < c) cout << a << " " << 0 << endl;
                else cout << c << " " << 0 << endl;
            }
        }
    }
    else {
        vector<set<int>> a((n + 1) * (n + 1), set<int>());
        build_graph(pp, a, n);
        int q;
        cin >> q;
        for (int i = 0;i < q;i++) {
                int c1, c2, c3, c4;
            cin >> c1 >> c2 >> c3 >> c4;
            int k, l;
            int res = lca(c1 * (n + 1) + c2, c3 * (n + 1) + c4, a);
            k = res / (n + 1);
            l = res % (n + 1);
            cout << k << " " << l << endl;
        }
    }
}
