#define _CRT_SECURE_NO_WARNINGS

#pragma GCC optimize("avx2")

#include <iostream>
#include <fstream>
#include <iomanip>
#include <algorithm>
#include <numeric>
#include <assert.h>
#include <random>
#include <vector>
#include <set>
#include <queue>
#include <map>

using namespace std;

#define int long long

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

#define endl '\n'
#define all(v) v.begin(), v.end()
#define mp make_pair
#define pb push_back

const int N = (1 << 20);
const int D = (1 << 17);
const int inf = 1e17;
const pii m1 = mp(inf, inf);

vector<int> e[N];

int l[N];
int r[N];
int c[N];

int f[N];

int ans;

int tin[N], tout[N];
int T;

int sz[N];

pii o[N];
int po[N];
int minc[N];

int p[N];
int P[N];

void dfs_t(int i)
{
	sz[i] = 1;
	for (int j : e[i])
	{
		dfs_t(j);
		sz[i] += sz[j];
	}
}

void updc(int i, int x)
{
	i += D;
	minc[i] = x;
	for (i >>= 1; i > 0; i >>= 1)
	{
		if (minc[2 * i] == -1)
		{
			minc[i] = minc[2 * i + 1];
			continue;
		}
		if (minc[2 * i + 1] == -1)
		{
			minc[i] = minc[2 * i];
			continue;
		}
		if (c[minc[2 * i]] < c[minc[2 * i + 1]])
		{
			minc[i] = minc[2 * i];
		}
		else
		{
			minc[i] = minc[2 * i + 1];
		}
	}
}

void updo(int i, int x, int pos)
{
	i += D;
	o[i] = { x,pos };
	po[i] = 0;
	for (i >>= 1; i > 0; i >>= 1)
	{
		po[i] = 0;
		o[i] = min(o[2 * i], o[2 * i + 1]);
	}
}

void dfs_b(int i, int R)
{
	updc(T, i);
	updo(T, r[i], i);
	tin[i] = T++;
	int max1 = -1;
	for (int j : e[i])
	{
		if (max1 == -1 || sz[j] > sz[max1])
		{
			max1 = j;
		}
	}
	for (int j : e[i])
	{
		if (j == max1)
		{
			p[j] = R;
			P[j] = R;
			dfs_b(j, R);
		}
	}
	for (int j : e[i])
	{
		if (j != max1)
		{
			p[j] = j;
			P[j] = i;
			dfs_b(j, j);
		}
	}
	tout[i] = T;
}

int min_pos(int l, int r)
{
	int ans = -1;
	for (l += D, r += D; l != r; l >>= 1, r >>= 1)
	{
		if (l & 1)
		{
			if (minc[l] != -1)
			{
				if (ans == -1 || c[minc[l]] < c[ans])
				{
					ans = minc[l];
				}
			}
			l++;
		}
		else
		{
			r--;
			if (minc[r] != -1)
			{
				if (ans == -1 || c[minc[r]] < c[ans])
				{
					ans = minc[r];
				}
			}
		}
	}
	return ans;
}

void dfs_del(int i)
{
	if (minc[tin[i] + D] == -1)
	{
		return;
	}
	updc(tin[i], -1);
	for (int j : e[i])
	{
		dfs_del(j);
	}
}

void push(int i)
{
	o[2 * i].first -= po[i];
	po[2 * i] += po[i];
	o[2 * i + 1].first -= po[i];
	po[2 * i + 1] += po[i];
	po[i] = 0;
}

int geto(int l, int i = 1, int L = 0, int R = D)
{
	push(i);
	if (L + 1 == R)
	{
		return o[i].first;
	}
	if (l < (L + R) / 2)
	{
		return geto(l, 2 * i, L, (L + R) / 2);
	}
	else
	{
		return geto(l, 2 * i + 1, (L + R) / 2, R);
	}
}

pii mino(int l, int r, int i = 1, int L = 0, int R = D)
{
	push(i);
	if (R <= l || r <= L)
	{
		return m1;
	}
	if (l <= L && R <= r)
	{
		return o[i];
	}
	return min(mino(l, r, 2 * i, L, (L + R) / 2), mino(l, r, 2 * i + 1, (L + R) / 2, R));
}

pii min_cnt(int i, int r)
{
	pii ans = m1;
	while (p[i] != p[r])
	{
		ans = min(ans, mino(tin[p[i]], tin[i] + 1));
		i = P[p[i]];
	}
	ans = min(ans, mino(tin[r], tin[i] + 1));
	return ans;
}

void delo(int l, int r, int x, int i = 1, int L = 0, int R = D)
{
	push(i);
	if (R <= l || r <= L)
	{
		return;
	}
	if (l <= L && R <= r)
	{
		po[i] += x;
		o[i].first -= x;
		return;
	}
	delo(l, r, x, 2 * i, L, (L + R) / 2);
	delo(l, r, x, 2 * i + 1, (L + R) / 2, R);
	if (o[2 * i] < o[2 * i + 1])
	{
		o[i] = o[2 * i];
	}
	else
	{
		o[i] = o[2 * i + 1];
	}
}

void sub(int i, int x)
{
	while (i != -1)
	{
		delo(tin[p[i]], tin[i] + 1, x);
		i = P[p[i]];
	}
}

int n;

bool gg;

void dfs(int i)
{
	if (gg)
		return;
	for (int j : e[i])
	{
		dfs(j);
		if (gg)
			return;
	}
	int ost = geto(tin[i]);
	if (ost < 0)
	{
		gg = true;
		return;
	}
	while (ost > l[i])
	{
		int now = min_pos(tin[i], tout[i]);
		if (now == -1)
		{
			gg = true;
			return;
		}
		pii cnt = min_cnt(now, i);
		if (cnt.first == 0)
		{
			dfs_del(cnt.second);
			continue;
		}
		cnt.first = min(cnt.first, ost - l[i]);
		ans += c[now] * cnt.first;
		f[now] += cnt.first;
		sub(now, cnt.first);
		ost = geto(i);
	}
}

signed main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int t;
	cin >> t;
	while (t--)
	{
		cin >> n;
		gg = false;
		fill(f, f + n, 0);
		fill(sz, sz + n, 0);
		for (int i = 0; i < n; i++)
		{
			e[i].clear();
		}
		for (int i = 1; i < n; i++)
		{
			int p;
			cin >> p;
			p--;
			e[p].push_back(i);
		}
		for (int i = 0; i < n; i++)
		{
			cin >> c[i];
		}
		for (int i = 0; i < n; i++)
		{
			cin >> l[i] >> r[i];
			l[i] = r[i] - l[i];
		}
		ans = 0;
		T = 0;
		dfs_t(0);
		P[0] = -1;
		p[0] = 0;
		dfs_b(0, 0);
		dfs(0);
		if (gg)
		{
			cout << -1 << endl;
		}
		else
		{
			cout << ans << endl;
			for (int i = 0; i < n; i++)
			{
				cout << f[i] << " ";
			}
			cout << endl;
		}
	}
}