#include <bits/stdc++.h>
using namespace std;
using ll = long long;
#if LOCAL
#define dbg(o) ({cout << #o << " = " << (o) << "\n"; (o);})
#else
#define dbg(o) (o)
#endif

template<typename T>
ostream &operator<<(ostream &o, const vector<T> &v) {
    for (const auto &e : v) o << e << " ";
    return o;
}
template<typename T, typename Q>
ostream &operator<<(ostream &o, const pair<T, Q> &v) {
    o << v.first << " " << v.second;
    return o;
}
template<typename T, typename Q>
istream &operator>>(istream &o, pair<T, Q> &v) {
    o >> v.first >> v.second;
    return o;
}
template<typename T>
istream &operator>>(istream &o, vector<T> &v) {
    for (auto &e : v) o >> e;
    return o;
}






using Seg = pair<ll, ll>;
vector<vector<int>> graph;
vector<int> c;
vector<Seg> limits;

Seg operator+(Seg l, Seg r) {
    return {l.first + r.first, l.second + r.second};
}

const Seg EMPTY = {-1, -1};

Seg intersect(Seg l, Seg r) {
    if (l.first > r.first) swap(l, r);
    if (l.second < r.second) return EMPTY;
    return {r.first, min(l.second, r.second)};
}

using Store = set<pair<int, pair<ll, int>>>;
ll total_price = 0;
vector<ll> bought;


Seg dfs(int v, Store &store) {
    Seg my_lim = limits[v];
    Seg cur = {0, 0};

    for (int u: graph[v]) {
        Store new_store;
        Seg a = dfs(u, new_store);
        // TODO: optimize
        store.merge(new_store);

        if (a == EMPTY) return EMPTY;
        cur = cur + a;
    }

    store.insert({c[v], {my_lim.second - cur.first, v}});
    ll left_in_v = my_lim.second - cur.first;
    if (cur.first < my_lim.first) {
        ll delta = my_lim.first - cur.first;
        while (!store.empty() && delta > 0) {
            auto it = store.begin();
            store.erase(it);
            auto[price, data] = *it;
            auto[count, u] = data;
            ll sub = min(count, delta);
            count -= sub;
            delta -= sub;
            if (u == v) left_in_v -= sub;
            total_price += price * sub;
            dbg("buy");
            dbg(u);
            dbg(price);
            dbg(sub);
            bought[u] += sub;
            if (count > 0) {
                store.insert({price, {count, u}});
            }
        }
        if (delta > 0) {
            return EMPTY;
        }
        if (left_in_v > 0 && left_in_v != my_lim.second - my_lim.first) {
            store.erase({c[v], {left_in_v, v}});
            store.insert({c[v], {my_lim.second - my_lim.first, v}});
        }
        return {my_lim.first, my_lim.second};
    } else if (cur.first > my_lim.second) {
        return EMPTY;
    } else {
        return {cur.first, my_lim.second};
    }
}

void solve() {
    int n;
    cin >> n;
    graph.assign(n, {});
    for (int i = 1; i < n; ++i) {
        int p;
        cin >> p;
        p--;
        graph[p].push_back(i);
    }

    c.assign(n, 0), limits.assign(n, {});
    cin >> c;
    cin >> limits;
    dbg(c);
    dbg(limits);

    Store store;
    total_price = 0;
    bought.assign(n, 0);
    auto res = dfs(0, store);
    dbg(res);
    if (res == EMPTY) {
        cout << "-1\n";
    } else {
        cout << total_price << "\n";
        cout << bought << "\n";
    }
}

int main() {
#if LOCAL
    freopen("../input.txt", "r", stdin);
    int q;
    cin >> q;
    while(q--) {
        cout << "###########################\n";
        solve();
    }
#else
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int q;
    cin >> q;
    while (q--) solve();
#endif
    return 0;
}
