#pragma GCC optimize("Ofast,no-stack-protector")
#include <bits/stdc++.h>
#pragma GCC target("tune=native")

using namespace std;
using ll = long long;
#define all(o) (o).begin(), (o).end()
#if LOCAL
#define dbg(o) ({cout << #o << " = " << (o) << "\n"; (o);})
#else
#define dbg(o) (o)
#endif

template<typename T>
ostream &operator<<(ostream &o, const vector<T> &v) {
    for (const auto &e: v) o << e << " ";
    return o;
}

template<typename T, typename Q>
ostream &operator<<(ostream &o, const pair<T, Q> &v) {
    o << v.first << " " << v.second;
    return o;
}

template<typename T, typename Q>
istream &operator>>(istream &o, pair<T, Q> &v) {
    o >> v.first >> v.second;
    return o;
}

template<typename T>
istream &operator>>(istream &o, vector<T> &v) {
    for (auto &e: v) o >> e;
    return o;
}

const int LMN = 19;
const int MN = 1 << LMN;
const int MK = 120'000'000;

using ARR = array<int, MK>;
static ARR storage;
static int ptr = 0;

struct MyVector {
    int l, r;
    explicit MyVector(int sz = 0) {
        l = ptr;
        ptr += sz;
        r = ptr;
    }

    int size() const {
        return r - l;
    }

    int &operator[](int x) const {
        return storage[l + x];
    }

    ARR::iterator begin() const {
        return storage.begin() + l;
    }
    ARR::iterator end() const {
        return storage.begin() + r;
    }
};

struct MergeSortTree {
    vector<MyVector> f;
    int mx;

    explicit MergeSortTree(const vector<int> &p) : f(MN * 2), mx(int(p.size())) {
        for (int i = 0; i < p.size(); ++i) {
            f[i + MN] = MyVector(1);
            f[i + MN][0] = p[i];
        }
        for (int i = MN - 1; i > 0; --i) {
            f[i] = MyVector(f[i * 2].size() + f[i * 2 + 1].size());
            merge(all(f[i * 2]), all(f[i * 2 + 1]), f[i].begin());
        }
    }

    int order(int ub, int x) {
        int i = 1;
        while (i < MN) {
            int cnt = int(lower_bound(all(f[i * 2]), ub) - f[i * 2].begin());
            if (x >= cnt) {
                x -= cnt;
                i = i * 2 + 1;
            } else {
                i = i * 2;
            }
        }
        return min(mx, i - MN);
    }

    int count(int ub, int r) {
        int tl = 0, tr = MN, res = 0, v = 1;
        while (v < MN) {
            int m = (tl + tr) / 2;
            if (r >= m) {
                res += int(lower_bound(all(f[v * 2]), ub) - f[v * 2].begin());
                tl = m;
                v = v * 2 + 1;
            } else {
                tr = m;
                v = v * 2;
            }
        }
        // res += f[v][0] < ub;
        return res;
    }

    int get_min(int l, int r, int tl = 0, int tr = MN, int v = 1) {
        if (r - l < 1) return INT32_MAX;
        if (l == tl && r == tr) {
            return f[v][0];
        }
        int m = (tl + tr) / 2;
        int c1 = get_min(l, min(r, m), tl, m, v * 2);
        int c2 = get_min(max(l, m), r, m, tr, v * 2 + 1);
        return min(c1, c2);
    }
};

struct Sparse {
    vector<vector<int>> f;
    explicit Sparse(const vector<int> &p) : f(LMN, vector<int>(MN)) {
        copy(all(p), f[0].begin());
        for (int i = 1; i < LMN; ++i) {
            for (int j = 0; j < MN - (1 << i); ++j) {
                f[i][j] = min(f[i - 1][j], f[i - 1][j + (1 << (i - 1))]);
            }
        }
    }

    int get_min(int l, int r) {
        int sz = (r - l);
        int lg2 = 31 - __builtin_clz(sz);
        return min(f[lg2][l], f[lg2][r - (1 << lg2)]);
    }
};

void solve() {
    int n;
    cin >> n;
    n++;
    vector<int> p(n - 1);
    cin >> p;
    for (int i = 0; i < n - 1; ++i) p[i]--;

    MergeSortTree mst(p);
    Sparse sparse(p);

    int q;
    cin >> q;
    while (q--) {
        int r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;
        c1 = r1 - c1, c2 = r2 - c2;
        int i1 = mst.order(r1, c1), i2 = mst.order(r2, c2);

        int l = min(i1, i2), r = max(i1, i2);
        int lcp = sparse.get_min(l, r);
        // assert(lcp == );
        lcp = min({r1, r2, lcp});

        dbg(lcp);
        dbg("    ");

        int cnt = mst.count(lcp, i1);

        cout << lcp << " " << lcp - cnt << "\n";
    }
}

signed main() {
#if LOCAL
    freopen("../input.txt", "r", stdin);
    int q;
    cin >> q;
    while (q--) {
        cout << "###########################\n";
        solve();
    }
#else
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    solve();
#endif
    return 0;
}
