#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

#define all(sp) sp.begin(), sp.end()
//#define int long long

int n, sz, p, lg;
vector < vector < int > > g, pos, jump;
vector < int > to, depth, pred;
vector < pair < int, int > > cur = {{1, 0}, {1, 1}}, rpos;

void dfs1(int r, int c) {
    if (r == n - 1) {
        return;
    }
    int nr = r + cur[to[r]].first;
    int nc = c + cur[to[r]].second;
    if (pos[nr][nc] == -1) {
        pos[nr][nc] = p++;
        rpos[p - 1] = {nr, nc};
        pred[pos[nr][nc]] = pos[r][c];
        depth[pos[nr][nc]] = r;
    }
    if (find(all(g[pos[r][c]]), pos[nr][nc]) == g[pos[r][c]].end()) {
        g[pos[r][c]].emplace_back(pos[nr][nc]);
    }
    dfs1(nr, nc);
}

int findLca(int u, int v) {
    if (depth[u] < depth[v]) {
        swap(u, v);
    }
    for (int k = lg; k >= 0; --k) {
        int nu = jump[u][k];
        if (depth[nu] >= depth[v]) {
            u = nu;
        }
    }
    if (u == v) {
        return u;
    }
    for (int k = lg; k >= 0; --k) {
        int nu = jump[u][k];
        int nv = jump[v][k];
        if (nu != nv) {
            u = nu;
            v = nv;
        }
    }
    return pred[u];
}

void solve() {
    cin >> n;
    ++n;
    sz = n * (n + 1) / 2;
    g.resize(sz);
    pred.resize(sz);
    depth.resize(sz);
    rpos.resize(sz);
    to.resize(n, 1);
    pos.resize(n, vector < int > (n, -1));
    p = 0;
    pos[0][0] = p++;
    rpos[p - 1] = {0, 0};
    dfs1(0, 0);
    for (int i = 1; i < n; ++i) {
        int u;
        cin >> u;
        --u;
        to[u] = 0;
        dfs1(0, 0);
    }
    lg = 0;
    while ((1ll << lg) < n) {
        ++lg;
    }
    jump.resize(sz, vector < int > (lg + 1));
    for (int u = 0; u < sz; ++u) {
        jump[u][0] = pred[u];
    }
    for (int k = 1; k <= lg; ++k) {
        for (int u = 0; u < sz; ++u) {
            jump[u][k] = jump[jump[u][k - 1]][k - 1];
        }
    }
    int q;
    cin >> q;
    while (q--) {
        int r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;
        int lca = findLca(pos[r1][c1], pos[r2][c2]);
        cout << rpos[lca].first << ' ' << rpos[lca].second << '\n';
    }
    cout << '\n';
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int tt=1;
    //cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;
}
