#ifndef LOCAL
#pragma GCC optimize("Ofast,unroll-loops,fast-math,inline,no-stack-protector")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,avx,avx2,abm,mmx,popcnt")
#endif
#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ldb;

const int MAXMEM = 1e8;
char memo[MAXMEM];
size_t pos = 0;

void *operator new(size_t sz) {
    assert((pos += sz) <= MAXMEM);
    return (void*)(memo + pos - sz);
}

void operator delete(void *) {}
void operator delete(void *, size_t) {}


#define endl '\n'

#define all(v) (v).begin(),(v).end()

const int INF = 1e9 + 228;

const int MAXN = 5e5 + 228;

int n;
int arr[MAXN];

int tree1[4 * MAXN];

void build1(int v, int l, int r) {
    if (l + 1 == r) {
        tree1[v] = arr[l];
    } else {
        int m = (l + r) / 2;
        build1(2 * v + 1, l, m);
        build1(2 * v + 2, m, r);
        tree1[v] = min(tree1[2 * v + 1], tree1[2 * v + 2]);
    }
}

int get1(int v, int l, int r, int ql, int qr) {
    if (ql >= r || l >= qr) {
        return INF;
    }
    if (ql <= l && r <= qr) {
        return tree1[v];
    }
    int m = (l + r) / 2;
    return min(get1(2 * v + 1, l, m, ql, qr), get1(2 * v + 2, m, r, ql, qr));
}

vector<int> tree2[4 * MAXN];

void build2(int v, int l, int r) {
    if (l + 1 == r) {
        tree2[v] = {arr[l]};
    } else {
        int m = (l + r) / 2;
        build2(2 * v + 1, l, m);
        build2(2 * v + 2, m, r);
        tree2[v].resize(r - l);
        merge(all(tree2[2 * v + 1]), all(tree2[2 * v + 2]), tree2[v].begin());
    }
}

int get2(int v, int l, int r, int ql, int qr, int val) {
    if (l >= qr || ql >= r) {
        return 0;
    }
    if (ql <= l && r <= qr) {
        auto it = lower_bound(tree2[v].begin(), tree2[v].end(), val);
        return int(it - tree2[v].begin());
    }
    int m = (l + r) / 2;
    return get2(2 * v + 1, l, m, ql, qr, val) + get2(2 * v + 2, m, r, ql, qr, val);
}

int countless(int t, int val) {
    return get2(0, 0, n, 0, t, val);
}

int get_in_time(int t, int r) {
    return r - countless(t, r + 1);
}

int down(int v, int l, int r, int val, int cnt) {
    if (l + 1 == r) {
        return l;
    }
    auto &t = tree2[2 * v + 1];
    auto it = lower_bound(all(t), val);
    int cnt2 = int(it - t.begin());
    int m = (l + r) / 2;
    if (cnt2 <= cnt) {
        return down(2 * v + 2, m, r, val, cnt - cnt2);
    }
    return down(2 * v + 1, l, m, val, cnt);
}

int get_time(int r, int c) {
    if (c == 0)
        return n;
    return down(0, 0, n, r + 1, r - c);
}

int get_mn(int l, int r) {
    return get1(0, 0, n, l, r);
}

void solve() {
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> arr[i];
    }
    build1(0, 0, n);
    build2(0, 0, n);
    int q;
    cin >> q;
    while (q--) {
        int r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;
        int t1 = get_time(r1, c1);
        int t2 = get_time(r2, c2);
        if (t2 < t1) {
            swap(t1, t2);
            swap(r1, r2);
            swap(c1, c2);
        }
        int mn = get_mn(t1, t2);
        if (mn <= min(r1, r2)) {
            cout << mn - 1 << " " << get_in_time(t1, mn - 1) << endl;
        } else {
            if (r1 < r2) {
                cout << r1 << " " << c1 << endl;
            } else {
                cout << r2 << " " << c2 << endl;
            }
        }
    } 
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    while (t--) {
        solve();
    }
}
