#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

using namespace std;

mt19937 rnd(time(0));
#define ioss ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define pb push_back

template<class T>
T upmin(T &a, T b){return a > b ? a = b, 1 : 0;}
template<class T>
T upmax(T &a, T b){return a < b ? a = b, 1 : 0;}

struct DekartTree{

    struct Node{
        int x, y, sz;
        Node *L, *R;
        Node(int x) : x(x), y(rnd()), L(nullptr), R(nullptr), sz(1){}
    }*root;

    int size(Node *t){
        return t == nullptr ? 0 : t->sz;
    }

    void update(Node *t){
        t->sz = size(t->L) + size(t->R) + 1;
    }

    Node* merge(Node *a, Node *b){
        if(a == nullptr || b == nullptr){
            return b == nullptr ? a : b;
        }
        if(a->y > b->y) {
            a->R = merge(a->R, b);
            update(a);
            return a;
        }else{
            b->L = merge(b->L, a);
            update(b);
            return b;
        }
    }
    pair<Node*, Node*> split(Node *t, int x){
        if(t == nullptr)
            return {nullptr, nullptr};
        if(t->x < x){
            auto r = split(t->R, x);
            t->R = r.first;
            update(t);
            return {t, r.second};
        }else{
            auto l = split(t->L, x);
            t->L = l.second;
            update(t);
            return {l.first, t};
        }
    }
    void add(int x){
        auto t = split(root, x); // [0, X-1] [X, inf]
        root = merge(t.first, merge(new Node(x), t.second));
    }
};

void solve(){
    int n;
    cin>>n;
    vector<int> arr(n);
    for(auto &i : arr)cin>>i;
    for(int i = 0;i<n;i++)arr[i]--;
    // добавляется всего один элемент на позицию l <= m <= r
    // ответ увеличится для всех dp[i < l][j > m], и надо обновить его для самого m вправо + влево(тк туда не считали еще)
    // заметим что можем взять просто отрезок с l по n
    // и отсортировать его а потом ответ найти для него
    // и также сделать на развернутом массиве ЛОЛ
    int dp[n][n];
    memset(dp, 0, sizeof(dp));

    vector<int> pos(n);
    for(int l = 0; l < n; l++) {
        auto t = arr;
        sort(t.begin() + l, t.end());

        for(int i = 0; i < n; i++){
            pos[t[i]] = i;
        }
        for(int i = 0;i<n;i++){
            for(int j = 0; j<n;j++){
                upmax(dp[i][j], abs(pos[i] - pos[j]));
                upmax(dp[j][i], abs(pos[i] - pos[j]));
            }
        }
    }
    for(int r = n-1; r >= 0; r--) {
        auto t = arr;
        sort(t.begin(), t.begin() + r);

        for(int i = 0; i < n; i++){
            pos[t[i]] = i;
        }
        for(int i = 0;i<n;i++){
            for(int j = 0; j<n;j++){
                upmax(dp[i][j], abs(pos[i] - pos[j]));
                upmax(dp[j][i], abs(pos[i] - pos[j]));
            }
        }
    }

    ll ans = 0;
    for(int i = 0;i<n;i++){
        for(int j = i + 1; j < n; j++){
            ans += (ll)dp[i][j];
//            cout<<i+1<<' '<<j+1<<' '<<dp[i][j]<<'\n';
        }
    }
    cout<<ans<<'\n';

}

signed main() {
    ioss
    int t = 1;
//    cin>>t;
    while(t--){
        solve();
    }
    return 0;
}
