#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

using namespace std;

mt19937 rnd(time(0));
#define ioss ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define pb push_back

template<class T>
T upmin(T &a, T b){return a > b ? a = b, 1 : 0;}
template<class T>
T upmax(T &a, T b){return a < b ? a = b, 1 : 0;}

struct ST{
    ST *l = nullptr, *r = nullptr;
    int vl, vr;
    int add = 0, sum = 0;

    ST(int vl, int vr){
        this->vl = vl;
        this->vr = vr;
        if(vr > vl + 1){
            int vm = (vl + vr) / 2;
            l = new ST(vl, vm);
            r = new ST(vm, vr);
        }
    }
    bool is_leaf(){
        return vr == vl + 1;
    }
    int size(){
        return vr - vl;
    }
    bool in(int lq, int rq){
        return lq <= vl && rq >= vr;
    }
    bool out(int lq, int rq){
        return max(lq, vl) >= min(rq, vr);
    }
    void push(){
        if(is_leaf())return;
        l->add += add;
        r->add += add;
        l->sum += add * l->size();
        r->sum += add * r->size();
        add = 0;
    }
    void insertQry(int lq, int rq,int x){
        push();
        if(in(lq, rq)){
            add += x;
            sum += x * size();
            return;
        }
        if(out(lq, rq))return;
        l->insertQry(lq, rq, x);
        r->insertQry(lq, rq, x);
        sum = l->sum + r->sum;
    }
    int sumQry(int lq, int rq){
        if(in(lq, rq))return sum;
        if(out(lq, rq))return 0;
        push();
        return l->sumQry(lq, rq) + r->sumQry(lq, rq);
    }
};

struct DekartTree{

    struct Node{
        int x, y, sz;
        Node *L, *R;
        Node(int x) : x(x), y(rnd()), L(nullptr), R(nullptr), sz(1){}
    }*root;

    int size(Node *t){
        return t == nullptr ? 0 : t->sz;
    }

    void update(Node *t){
        t->sz = size(t->L) + size(t->R) + 1;
    }

    Node* merge(Node *a, Node *b){
        if(a == nullptr || b == nullptr){
            return b == nullptr ? a : b;
        }
        if(a->y > b->y) {
            a->R = merge(a->R, b);
            update(a);
            return a;
        }else{
            b->L = merge(b->L, a);
            update(b);
            return b;
        }
    }
    pair<Node*, Node*> split(Node *t, int x){
        if(t == nullptr)
            return {nullptr, nullptr};
        if(t->x < x){
            auto r = split(t->R, x);
            t->R = r.first;
            update(t);
            return {t, r.second};
        }else{
            auto l = split(t->L, x);
            t->L = l.second;
            update(t);
            return {l.first, t};
        }
    }
    void add(int x){
        auto t = split(root, x); // [0, X-1] [X, inf]
        root = merge(t.first, merge(new Node(x), t.second));
    }
};

vector<vector<int>> graph;
vector<int> c;
vector<pair<int,int>> lr;
vector<int> in;
vector<set<pair<pair<int,int>,int>>> can;// cost, count, id
vector<int> b;

void upd(int n){
    graph.clear();
    c.clear();
    lr.clear();
    in.clear();
    b.clear();
    b.resize(n);
    graph.resize(n);
    c.resize(n);
    lr.resize(n);
    in.resize(n);
    can.clear();
    can.resize(n);
}
int ok = 0;



void dfs(int v){
    if(ok){
        return;
    }
    int l = lr[v].first, r = lr[v].second;
    for(auto to : graph[v]){
        dfs(to);
        for(auto &i : can[to])
            can[v].insert(i);
        in[v] += in[to];
    }
    can[v].insert({{c[v], r}, v});
    if(in[v] > r) {
        ok = 1;
        return;
    }
    while(in[v] < l){
        auto fst = *can[v].begin();
        can[v].erase(fst);
        int add = min(l - in[v], fst.first.second);
        in[v] += add;
        fst.first.second -= add;
        b[fst.second] += add;
        if(fst.first.second > 0){
            can[v].insert(fst);
        }
    }
    int cnt = r - in[v];
    int sum_add = 0;
    for(auto &i : can[v]){
        sum_add += i.first.second;
    }
    while(sum_add > cnt){
        auto last = *can[v].rbegin();
        can[v].erase(last);
        int del = min(last.first.second, sum_add - cnt);
        last.first.second -= del;
        sum_add -= del;
        if(last.first.second > 0){
            can[v].insert(last);
        }
    }
}


void solve(){
    int n;
    cin>>n;
    upd(n);
    for(int i = 0;i<n-1;i++){
        int x;
        cin>>x;
        x--;
        graph[x].pb(i+1);
    }
    for(auto &i : c)cin>>i;
    for(auto &i : lr)cin>>i.first>>i.second;
    dfs(0);
    if(ok == 1){
        cout<<"-1\n";
        return;
    }
    int ans = 0;
    for(int i = 0;i<n;i++) {
        ans += b[i] * c[i];
    }
    cout<<ans<<'\n';
    for(auto i : b){
        cout<<i<<' ';
    }
    cout<<'\n';
}

signed main() {
    ioss
    int t = 1;
    cin>>t;
    while(t--){
        solve();
    }
    return 0;
}
