#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

using namespace std;

mt19937 rnd(time(0));
#define ioss ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define pb push_back

template<class T>
T upmin(T &a, T b){return a > b ? a = b, 1 : 0;}
template<class T>
T upmax(T &a, T b){return a < b ? a = b, 1 : 0;}

struct ST{
    ST *l = nullptr, *r = nullptr;
    int vl, vr;
    int add = 0, sum = 0;

    ST(int vl, int vr){
        this->vl = vl;
        this->vr = vr;
        if(vr > vl + 1){
            int vm = (vl + vr) / 2;
            l = new ST(vl, vm);
            r = new ST(vm, vr);
        }
    }
    bool is_leaf(){
        return vr == vl + 1;
    }
    int size(){
        return vr - vl;
    }
    bool in(int lq, int rq){
        return lq <= vl && rq >= vr;
    }
    bool out(int lq, int rq){
        return max(lq, vl) >= min(rq, vr);
    }
    void push(){
        if(is_leaf())return;
        l->add += add;
        r->add += add;
        l->sum += add * l->size();
        r->sum += add * r->size();
        add = 0;
    }
    void insertQry(int lq, int rq,int x){
        push();
        if(in(lq, rq)){
            add += x;
            sum += x * size();
            return;
        }
        if(out(lq, rq))return;
        l->insertQry(lq, rq, x);
        r->insertQry(lq, rq, x);
        sum = l->sum + r->sum;
    }
    int sumQry(int lq, int rq){
        if(in(lq, rq))return sum;
        if(out(lq, rq))return 0;
        push();
        return l->sumQry(lq, rq) + r->sumQry(lq, rq);
    }
};

struct DekartTree{

    struct Node{
        int x, y, sz;
        Node *L, *R;
        Node(int x) : x(x), y((int)rnd()), L(nullptr), R(nullptr), sz(1){}
    }*root;

    int size(Node *t){
        return t == nullptr ? 0 : t->sz;
    }

    void update(Node *t){
        t->sz = size(t->L) + size(t->R) + 1;
    }

    Node* merge(Node *a, Node *b){
        if(a == nullptr || b == nullptr){
            return b == nullptr ? a : b;
        }
        if(a->y > b->y) {
            a->R = merge(a->R, b);
            update(a);
            return a;
        }else{
            b->L = merge(b->L, a);
            update(b);
            return b;
        }
    }
    pair<Node*, Node*> split(Node *t, int x){
        if(t == nullptr)
            return {nullptr, nullptr};
        if(t->x < x){
            auto r = split(t->R, x);
            t->R = r.first;
            update(t);
            return {t, r.second};
        }else{
            auto l = split(t->L, x);
            t->L = l.second;
            update(t);
            return {l.first, t};
        }
    }
    void add(int x){
        auto t = split(root, x); // [0, X-1] [X, inf]
        root = merge(t.first, merge(new Node(x), t.second));
    }
};

struct sparse_min{
    vector<int> H;
    vector<vector<ll>> sp;

    ll get(int l, int r){
        int h = H[r - l + 1];
        return min(sp[h][l], sp[h][r - (1 << h) + 1]);
    }

    sparse_min(vector<ll> &a){
        int n = (int)a.size();
        H.resize(n+1);
        for(int i = 3; i < n + 1; i++){
            H[i] = H[i-1] + (((i-1) & (i - 2)) == 0);
        }
        int s = 0;
        while((1<<s) < n)s++;
        sp.resize(s, vector<ll>(n));
        for(int i = 0;i<n;i++){
            sp[0][i] = a[i];
        }
        for(int j = 1; j < s; j++){
            for(int i = 0; i + (1 << j) - 1 < n; j++){
                sp[j][i] = get(i, i + (1 << j) + 1);
            }
        }
    }
};

struct LCA{
    vector<int> depth;
    vector<vector<int>> par, graph;
    int n, s = 0;

    void dfs(int v, int par_, int deep){
        depth[v] = deep;
        par[v][0] = par_;
        for(int i = 1; i < s; i++){
            par[v][i] = par[par[v][i-1]][i-1];
        }
        for(auto to : graph[v]){
            dfs(to, v, deep + 1);
        }
    }

    LCA(vector<vector<int>> &graph){
        this->graph = graph;
        this->n = (int)graph.size();
        depth.resize(n);
        while((1<<s) < n)s++;
        par.resize(n+1, vector<int> (s));
        dfs(0, 0, 0);
    }

    int getLca(int a, int b){
        if(depth[b] > depth[a])swap(a, b);
        for(int i = s - 1; i >= 0; i--){
            if(depth[par[a][i]] >= depth[b]){
                a = par[a][i];
            }
        }
        if(a == b)return a;
        for(int i = s - 1; i >= 0; i--){
            if(par[a][i] != par[b][i]){
                a = par[a][i];
                b = par[b][i];
            }
        }
        return par[a][0];
    }

};

void solve(){
    int n;
    cin>>n;
    vector<int> a(n);
    for(auto &i : a)cin>>i;
    pair<int,int> graph[n][n];
    vector<int> way(n, 0);
    vector<pair<int,int>> pos(n+1);
    for(int i = 0;i<n;i++){
        pos[i] = {i, i};
        graph[i][i].second = 1;
    }
    // second -> вправо
    // first -> влево


    for(int i = 0;i<n;i++){
        way[a[i] - 1] = 1;
        for(int j = a[i] - 1; j < n; j++){
            if(way[j] == 1){
                pos[j+1] = {pos[j].first + 1, pos[j].second};
                graph[pos[j].first][pos[j].second].first = 1;
            }else{
                pos[j+1] = {pos[j].first + 1, pos[j].second+1};
                graph[pos[j].first][pos[j].second].second = 1;
            }
        }
    }
    map<pair<int,int>, int> mp;
    int id = 0;
    for(int i = 0;i<=n;i++){
        for(int j = 0;j<=i;j++){
            mp[{i, j}] = id++;
        }
    }

    vector<pair<int,int>> rep(id);
    for(int i = 0;i<=n;i++){
        for(int j = 0;j<=i;j++){
            rep[mp[{i,j}]] = {i, j};
        }
    }

    vector<vector<int>> graph2(id);
    for(int i = 0;i<n;i++){
        for(int j = 0;j<=i;j++){
            if(graph[i][j].first == 1) {
                graph2[mp[{i, j}]].pb(mp[{i + 1, j}]);
//                cout<<mp[{i, j}] << ' '<< mp[{i+1, j}]<<'\n';
            }
            if(graph[i][j].second == 1) {
                graph2[mp[{i, j}]].pb(mp[{i + 1, j + 1}]);
//                cout<<mp[{i, j}] << ' '<< mp[{i+1, j+1}]<<'\n';
            }
        }
    }
    LCA lca(graph2);

    int q;
    cin>>q;
    while(q--){
        int r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;
        auto ans = rep[lca.getLca(mp[{r1, c1}], mp[{r2, c2}])];
        cout<<ans.first<<' '<<ans.second<<'\n';
    }
}

signed main() {
//    ioss
    int t = 1;
//    cin>>t;
    while(t--){
        solve();
    }
    return 0;
}
