#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <tuple>

using namespace std;

#define fastInp cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);

typedef long long ll;
typedef long double ld;

vector<vector<ll>> gr;
vector<ll> cost, limit;
vector<pair<ll, ll>> mx;
vector<ll> sm;
bool f;

ll setlims(int v) {
	ll calc = 0;
	for (auto to : gr[v]) {
		calc += setlims(to);
	}
	if (calc > mx[v].second) {
		f = 1;
		return 0;
	}

	calc = max(calc, mx[v].first);
	limit[v] = calc;

	return calc;
}

vector<set<tuple<ll, ll, ll>>> add;
vector<ll> res;
ll ans = 0;
ll dfs(int v) {
	ll calc = 0;
	for (auto to : gr[v]) {
		calc += dfs(to);
		sm[v] += sm[to];
		if (add[v].size() < add[to].size()) swap(add[v], add[to]);

		for (auto c : add[to]) {
			add[v].insert(c);
		}
	}

	add[v].insert({ cost[v], mx[v].second - calc, v });
	sm[v] += mx[v].second - calc;

	while (calc < limit[v]) {
		tuple<ll, ll, ll> cur = (*add[v].begin());
		add[v].erase(cur);

		ll q = min(limit[v] - calc, get<1>(cur));
		sm[v] -= q;
		res[get<2>(cur)] += q;

		ans += q * get<0>(cur);
		calc += q;
		if (q != get<1>(cur)) add[v].insert({ get<0>(cur), get<1>(cur) - q, get<2>(cur) });
	}
	
	while (sm[v] > mx[v].second - limit[v]) {
		tuple<ll, ll, ll> cur = (*add[v].rbegin());
		add[v].erase(cur);
		ll q = min(get<1>(cur), sm[v] - (mx[v].second - limit[v]));
		sm[v] -= q;

		if (q != get<1>(cur)) add[v].insert({ get<0>(cur), get<1>(cur) - q, get<2>(cur) });
	}

	return calc;
}

ll sol() {
	ll n;
	cin >> n;

	gr.clear();
	gr.resize(n);

	for (int i = 1; i < n; i++) {
		ll v;
		cin >> v;
		v--;
		gr[v].push_back(i);
	}

	cost.clear();
	limit.clear();
	mx.clear();
	cost.resize(n);
	mx.resize(n);
	limit.resize(n);
	sm.clear();
	sm.resize(n);
	for (auto& c : cost) cin >> c;
	for (auto& c : mx) cin >> c.first >> c.second;

	f = 0;
	setlims(0);
	if (f) return -1;

	add.clear();
	add.resize(n);
	ans = 0;
	
	res.clear();
	res.resize(n);

	dfs(0);
	
	return ans;
}

int main() {
	fastInp;

	ll t;
	cin >> t;

	while (t--) {
		ll t = sol();
		cout << t << endl;
		if (t != -1) {
			for (auto c : res) cout << c << " ";
			cout << endl;
		}
	}

	return 0;
}

/*
2
3
1 1
3 1 2
5 7
1 2
2 4

2
1
5 5
0 1
2 2




1
3
1 2
5 2 1
3 3
1 2
1 2
*/