#include <iostream>
#include <vector>
#define int long long

using namespace std;

vector<vector<int>> g;
vector<int> ans, c, l, r, dp;
bool possible = true;

struct node {
    int i, c, s;
    node() = default;
    node(int _i, int _c, int _s): i(_i), c(_c), s(_s) {}
    bool operator<(node v) {
        return make_pair(c, s) < make_pair(v.c, v.s);
    }
};

void merge(vector<node> &v1, vector<node> v2, vector<node> &to) {
    int n = v1.size(), m = v2.size();
    int p1 = 0, p2 = 0;
    vector<node> res;
    while (p1 + p2 < n + m) {
        if (p1 < n && v1[p1].s == 0) p1++;
        if (p2 < m && v2[p2].s == 0) p2++;
        if (p1 == n) res.push_back(v2[p2++]);
        else if (p2 == m) res.push_back(v1[p1++]);
        else if (v1[p1] < v2[p2]) res.push_back(v1[p1++]);
        else res.push_back(v2[p2++]);
    }
    swap(res, to);
}

vector<node> dfs(int v = 0) {
    vector<node> res;
    res.emplace_back(v, c[v], r[v]);
    for (int u: g[v]) {
        merge(res, dfs(u), res);
        dp[v] += dp[u];
    }
    int ptr = 0;
    if (dp[v] > r[v]) possible = false;
    while (ptr < res.size() && dp[v] < l[v]) {
        int delta = min(res[ptr].s, l[v] - dp[v]);
        res[ptr].s -= delta;
        dp[v] += delta;
        ans[res[ptr].i] += delta;
        ptr++;
    }
    if (dp[v] < l[v]) possible = false;
    int sum = 0;
    while (ptr < res.size() && dp[v] + sum + res[ptr].s <= r[v]) sum += res[ptr++].s;
    if (ptr < res.size()) res[ptr++].s = r[v] - sum - dp[v];
    for (;ptr < res.size(); res[ptr++].s = 0) {}
    return res;
}

signed main() {
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        g.resize(n);
        ans.resize(n);
        c.resize(n);
        l.resize(n);
        r.resize(n);
        dp.resize(n);
        for (int i = 1; i < n; i++) {
            int p;
            cin >> p;
            g[p - 1].push_back(i);
        }
        for (int& el: c) cin >> el;
        for (int i = 0; i < n; i++) cin >> l[i] >> r[i];
        dfs();
        if (!possible) cout << -1 << endl;
        else {
            int w = 0;
            for (int i = 0; i < n; i++) {
                w += ans[i] * c[i];
            }
            cout << w << endl;
            for (int el: ans) cout << el << ' ';
            cout << endl;
        }
    }
}
