#include <iostream>
#include <vector>
#define int long long
#define node pair<int, int>
#define r first
#define c second

using namespace std;

vector<vector<vector<node>>> g;
vector<vector<int>> d, tin, tout, used;
int timer = 0;

void dfs(node v = {0, 0}, node p = {-1, -1}) {
    tin[v.r][v.c] = timer++;
    for (node u: g[v.r][v.c]) {
        if (u == p) continue;
        d[u.r][u.c] = d[v.r][v.c] + 1;
        dfs(u, v);
    }
    tout[v.r][v.c] = timer++;
}

bool is_parent(node v, node u) {
    return (tin[v.r][v.c] <= tin[u.r][u.c] && tout[u.r][u.c] <= tout[v.r][v.c]);
}

void go(const vector<int> &a, node v = {0, 0}) {
    used[v.r][v.c] = true;
    if (v.r != a.size()) {
        if (!used[v.r + 1][v.c + a[v.r]]) g[v.r][v.c].emplace_back(v.r + 1, v.c + a[v.r]);
        go(a, {v.r + 1, v.c + a[v.r]});
    }
}

signed main() {
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
    int n;
    cin >> n;
    g.resize(n + 1);
    d.resize(n + 1);
    tin.resize(n + 1);
    tout.resize(n + 1);
    used.resize(n + 1);
    for (int i = 0; i <= n; i++) {
        g[i].resize(i + 1);
        d[i].resize(i + 1);
        tin[i].resize(i + 1);
        tout[i].resize(i + 1);
        used[i].resize(i + 1);
    }
    vector<int> a(n, 1);
    go(a);
    for (int i = 0; i < n; i++) {
        int ind;
        cin >> ind;
        ind--;
        a[ind] = 0;
        go(a);
    }
    dfs();
    int q;
    cin >> q;
    while (q--) {
        node v1, v2, ans = {0, 0};
        cin >> v1.r >> v1.c >> v2.r >> v2.c;
        for (int r = 0; r <= n; r++) {
            for (int c = 0; c <= r; c++) {
                node v3 = {r, c};
                if (is_parent(v3, v1) && is_parent(v3, v2) && d[r][c] > d[ans.r][ans.c]) {
                    ans = v3;
                }
            }
        }
        cout << ans.r << ' ' << ans.c << endl;
    }
}
