#include <iostream>
#include <vector>
#define node pair<int, int>
#define r first
#define c second

using namespace std;

int timer = 0;
const int log = 13, max_n = 3001;
vector<node> g[max_n][max_n];
int d[max_n][max_n], tin[max_n][max_n], tout[max_n][max_n], used[max_n][max_n];
pair<int, int> up[13][max_n][max_n];

void dfs(node v = {0, 0}, node p = {0, 0}) {
    tin[v.r][v.c] = timer++;
    up[0][v.r][v.c] = p;
    for (int i = 1; i < log; i++) {
        node par = up[i - 1][v.r][v.c];
        up[i][v.r][v.c] = up[i - 1][par.r][par.c];
    }
    for (node u: g[v.r][v.c]) {
        if (u == p) continue;
        d[u.r][u.c] = d[v.r][v.c] + 1;
        dfs(u, v);
    }
    tout[v.r][v.c] = timer++;
}

bool is_parent(node v, node u) {
    return (tin[v.r][v.c] <= tin[u.r][u.c] && tout[u.r][u.c] <= tout[v.r][v.c]);
}

void go(const vector<int> &a, node v = {0, 0}) {
    used[v.r][v.c] = true;
    if (v.r != a.size()) {
        if (!used[v.r + 1][v.c + a[v.r]]) g[v.r][v.c].emplace_back(v.r + 1, v.c + a[v.r]);
        go(a, {v.r + 1, v.c + a[v.r]});
    }
}

node lca(node u, node v) {
    if (is_parent(u, v)) return u;
    if (is_parent(v, u)) return v;
    if (d[u.r][u.c] < d[v.r][v.c]) swap(u, v);
    for (int i = log - 1; i >= 0; i--) {
        node par = up[i][u.r][u.c];
        if (d[par.r][par.c] >= d[v.r][v.c]) u = par;
    }
    if (u == v) return u;
    for (int i = log - 1; i >= 0; i--) {
        if (up[i][u.r][u.c] != up[i][v.r][v.c]) {
            u = up[i][u.r][u.c];
            v = up[i][v.r][v.c];
        }
    }
    return up[0][u.r][u.c];
}

signed main() {
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
    int n;
    cin >> n;
    vector<int> a(n, 1);
    go(a);
    for (int i = 0; i < n; i++) {
        int ind;
        cin >> ind;
        ind--;
        a[ind] = 0;
        go(a);
    }
    dfs();
    int q;
    cin >> q;
    while (q--) {
        node v1, v2;
        cin >> v1.r >> v1.c >> v2.r >> v2.c;
        node ans = lca(v1, v2);
        cout << ans.r << ' ' << ans.c << endl;
    }
}
