#include <iostream>
#include <algorithm>
#include <math.h>
#include <map>
#include <vector>
#include <cstring>
#include <queue>
#include <set>
using namespace std;
#define ll int
#define ld long double
#define vl vector<ll>
#define vvl vector<vl>
#define ii pair<ll, ll>
#define vp vector<ii>
#define vvp vector<vp>
const ll INF = (ll)1e17;
const ll MOD = (ll)1e9 + 7;
vector<set<ll>> matrix;
ll K = 25;
vvl bin_up;
vl tin;
vl tout;
ll timer = 0;
vp eler;
void dfs(ll v, ll depth=1) {
	tin[v] = timer++;
	eler.push_back({ depth, v });
	for (auto i : matrix[v]) {
		dfs(i, depth+1);
		eler.push_back({ depth, v });
		timer++;
	}
	tout[v] = timer++;
	eler.push_back({ depth, v });
}
vl logn;
vvp sp;
ll N = 4504505;
void build_sp() {
	N = (ll)eler.size();
	sp.resize(N, vp(25));
	logn.resize(N);
	logn[0] = -1;
	for (ll i = 1, step = 1; i < N; i++) {
		logn[i] = logn[i - 1];
		if (i == step) {
			logn[i]++;
			step *= 2;
		}
	}
	for (ll i = 0; i < N; i++) sp[i][0] = eler[i];
	for (ll k = 1, step = 1; k < K; k++, step *= 2) {
		for (ll pos = 0; pos + 2 * step <= N; pos++) {
			sp[pos][k] = min(sp[pos][k - 1], sp[pos + step][k - 1]);
		}
	}
}
ll get_lca(ll a, ll b) {
	ll x = tin[a];
	ll y = tin[b];
	if (x > y) swap(x, y);
	ll p = logn[y - x+1];
	return min(sp[x][p], sp[y - ((ll)1 << p) + 1][p]).second;
}
void solve() {
	ll n;
	cin >> n;
	map<pair<ll, ll>, ll> mapa;
	map<ll, pair<ll, ll>> obr_mapa;
	ll fre = 0;
	for (ll i = 0; i <= n; i++) {
		for (ll j = 0; j <= i; j++) {
			mapa[{i, j}] = fre;
			obr_mapa[fre] = { i,j };
			fre++;
		}
	}
	fre--;
	matrix.resize(fre + 1);
	vector<bool> zam(n + 1, true);
	for (ll i = 0; i <= n; i++) {
		ii tec = { 0, 0 };
		for (ll j = 0; j < n; j++) {
			if (zam[j]) {
				matrix[mapa[tec]].insert(mapa[{tec.first + 1, tec.second + 1}]);
				tec.first++;
				tec.second++;
			}
			else {
				matrix[mapa[tec]].insert(mapa[{tec.first + 1, tec.second}]);
				tec.first++;
			}
		}
		if (i != n) {
			ll x;
			cin >> x;
			zam[x - 1] = false;
		}
	}
	tin.resize(fre+1);
	tout.resize(fre+1);
	dfs(0);
	build_sp();
	ll q;
	cin >> q;
	while (q--) {
		ll x1, y1, x2, y2;
		cin >> x1 >> y1 >> x2 >> y2;
		auto ans = obr_mapa[get_lca(mapa[{x1, y1}], mapa[{x2, y2}])];
		cout << ans.first << ' ' << ans.second << '\n';
	}
}
int main()
{
	//ll t;
	//cin >> t;
	//while(t--)
	solve();
}