#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

#define pb push_back
#define ff first
#define ss second
#define all(x) (x).begin(), (x).end()
#define print(x) { for(auto &__val: x) cout << __val << ' '; cout << '\n';}

class SegmentTree{
public:
    int n;
    vector<int> t, add;
    SegmentTree() {}
    SegmentTree(int _n) {
        n = _n;
        t.resize(4 * n);
        add.resize(4 * n);
    }
    void push(int v) {
        if(add[v] == 0) return;
        t[v] -= add[v];
        if(v < 2 * n) {
            add[v*2] += add[v];
            add[v*2+1] += add[v];
        }
        add[v] = 0;
    }
    void build(int v, int tl, int tr, vector<int> &a) {
        if(tl == tr) t[v] = a[tl];
        else {
            int tm = (tl + tr)/2;
            build(v*2, tl, tm, a);
            build(v*2+1, tm+1, tr, a);
            t[v] = min(t[v*2], t[v*2+1]);
        }
    }
    void upd(int v, int tl, int tr, int l, int r, int x) {
        push(v);
        if(l > tr || r < tl) return;
        if(l <= tl && tr <= r) {
            add[v] += x;
            push(v);
            return;
        }
        int tm = (tl + tr)/2;
        upd(v*2, tl, tm, l, r, x);
        upd(v*2+1, tm+1, tr, l, r, x);
        t[v] = min(t[v*2], t[v*2+1]);
    }
    int get(int v, int tl, int tr, int l, int r) {
        push(v);
        if(l > tr || r < tl) return 2e9;
        if(l <= tl && tr <= r) return t[v];
        int tm = (tl + tr)/2;
        return min(get(v*2, tl, tm, l, r), get(v*2+1, tm+1, tr, l, r));
    }
    int getOne(int v, int tl, int tr, int pos) {
        push(v);
        if(tl == tr) return t[v];
        else {
            int tm = (tl + tr)/2;
            if(pos <= tm) return getOne(v*2, tl, tm, pos);
            else return getOne(v*2+1, tm+1, tr, pos);
        }
    }
};

vector<vector<int>> graf;
vector<int> l, r, c, ans;
//vector<priority_queue<int>> q;

//HLD
vector<int> p, head, sz;
vector<SegmentTree> hld;
vector<vector<int>> mem;
vector<int> pos;

void szHLD(int v) {
    sz[v] = 1;
    for(auto &i: graf[v]) {
        szHLD(i);
        sz[v] += sz[i];
    }
}

void buildHLD(int v) {
    if(head[v] == -1) head[v] = v;
    mem[head[v]].pb(v);
    int pos = -1, mx = 0;
    for(int i=0;i<graf[v].size();i++) {
        if(sz[graf[v][i]] > mx) {
            mx = sz[graf[v][i]];
            pos = i;
        }
    }
    if(pos == -1) return;
    head[graf[v][pos]] = head[v];
    for(auto &i: graf[v]) {
        buildHLD(i);
    }
}

int minHLD(int v) {
    int mn = 2e9;
    int tps = head[v], ips = pos[v];
    while(tps != 0) {
        mn = min(mn, hld[tps].get(1, 0, mem[tps].size()-1, 0, ips));
        v = p[tps];
        tps = head[v];
        ips = pos[v];
    }
    mn = min(mn, hld[tps].get(1, 0, mem[tps].size()-1, 0, ips));
    return mn;
}

void addHLD(int v, int add) {
    int tps = head[v], ips = pos[v];
    while(tps != 0) {
        hld[tps].upd(1, 0, mem[tps].size()-1, 0, ips, add);
        v = p[tps];
        tps = head[v];
        ips = pos[v];
    }
    hld[tps].upd(1, 0, mem[tps].size()-1, 0, ips, add);
}

vector<pair<int, int>> q;

void srt(int v) {
    q.pb({c[v], v});
    for(auto &i: graf[v]) srt(i);
}

int op(int v, int add) {
    int mn = minHLD(v);
    mn = max(mn, 0);
    mn = min(mn, add);
    add -= mn;
    addHLD(v, mn);
    ans[v] += mn;
    return add;
}

bool dfs(int v) {
    if(graf[v].empty()) {
        int tq = op(v, l[v]);
        if(tq != 0) return false;
        return true;
    }
    for(auto &i: graf[v]){
        if(!dfs(i)) return false;
    }
    int A = (r[v] - hld[head[v]].getOne(1, 0, mem[head[v]].size()-1, pos[v]));
    if(A < l[v]) {
        int add = l[v] - A;
        q.clear();
        srt(v);
        sort(all(q));
        for(auto &[cst, i]: q) {
            add = op(i, add);
            if(add == 0) break;
        }
    }
    A = (r[v] - hld[head[v]].getOne(1, 0, mem[head[v]].size()-1, pos[v]));
    if(A < l[v] || A > r[v]){
        return false;
    }
    return true;
}

void solve() {
    graf.clear();
    p.clear();
    hld.clear();
    head.clear();
    sz.clear();
    mem.clear();
    l.clear();
    r.clear();
    c.clear();
    q.clear();
    ans.clear();
    pos.clear();
    int n;
    cin >> n;
    graf.resize(n);
    p.resize(n);
    hld.resize(n);
    head.resize(n, -1);
    sz.resize(n);
    mem.resize(n);
    l.resize(n);
    r.resize(n);
    c.resize(n);
    //q.resize(n);
    ans.resize(n);
    pos.resize(n);
    for(int i=1;i<n;i++) {
        int x;
        cin >> x;
        p[i] = x - 1;
        graf[p[i]].pb(i);
    }
    for(auto &i: c) cin >> i;
    for(int i=0;i<n;i++) cin >> l[i] >> r[i];
    szHLD(0);
    buildHLD(0);
    for(int i=0;i<n;i++) {
        if(mem[i].empty()) continue;
        vector<int> rs;
        int ps = 0;
        for(auto &j: mem[i]) {
            rs.pb(r[j]);
            pos[j] = ps++;
        }
        hld[i] = SegmentTree(ps);
        hld[i].build(1, 0, mem[i].size()-1, rs);
    }
    if(!dfs(0)) {
        cout << -1 << '\n';
    } else {
        ll res = 0;
        for(int i=0;i<n;i++) res += ans[i] * 1ll * c[i];
        cout << res << '\n';
        print(ans)
    }
}
/*
2
3
1 1
3 1 2
5 7
1 2
2 4
2
1
5 5
0 1
2 2
*/
signed main() {
    ios_base::sync_with_stdio(false);cin.tie(nullptr);
    int t = 1;
    cin >> t;
    while(t--) {
        solve();
    }
}
