#include <iostream>
#include <iomanip>
#include <cstdlib>
#include <cstdio>
#include <algorithm>
#include <cmath>
#include <numeric>
#include <utility>
#include <vector>
#include <deque>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <bitset>
#include <string>
#include <sstream>
#include <chrono>
#include <random>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

const int INF = 2e9;
int n;
vector<vector<int>> g;
vector<int> l, r, c, tin, d, dmax, par, a, b, per;
vector<int> str, stind, modr;
vector<set<pair<int, int>>> best;
int tnow = 0;
bool can = true;

void dfs_d(int v) {
    dmax[v] = d[v];
    for (int i = 0; i < (int)g[v].size(); ++i) {
        d[g[v][i]] = d[v] + 1;
        dfs_d(g[v][i]);
        if (dmax[v] < dmax[g[v][i]]) {
            dmax[v] = dmax[g[v][i]];
            swap(g[v][i], g[v][0]);
        }
    }
}

void update_ind(int v, int left, int right, int ind) {
    if (right - left == 1) {
        stind[v] = 1;
        return;
    }
    int mid = (left + right) / 2;
    if (ind < mid) {
        update_ind(v * 2 + 1, left, mid, ind);
    }
    else {
        update_ind(v * 2 + 2, mid, right, ind);
    }
    ++stind[v];
}

int get_ind(int v, int left, int right, int L, int R) {
    if (stind[v] == 0) {
        return -1;
    }
    if (right - left == 1) {
        return left;
    }
    int mid = (left + right) / 2;
    if (R > mid) {
        int val = get_ind(v * 2 + 2, mid, right, L, R);
        if (val == -1 && L < mid) {
            val = get_ind(v * 2 + 1, left, mid, L, R);
        }
        return val;
    }
    int val = get_ind(v * 2 + 1, left, mid, L, R);
    return val;
}

void build_r(int v, int left, int right) {
    if (right - left == 1) {
        str[v] = r[left];
        return;
    }
    int mid = (left + right) / 2;
    build_r(v * 2 + 1, left, mid);
    build_r(v * 2 + 2, mid, right);
    str[v] = min(str[v * 2 + 1], str[v * 2 + 2]);
}

void push_r(int v, int left, int right) {
    if (modr[v] != 0) {
        str[v] -= modr[v];
        if (right - left > 1) {
            modr[v * 2 + 1] += modr[v];
            modr[v * 2 + 2] += modr[v];
        }
        modr[v] = 0;
    }
}

void update_r(int v, int left, int right, int L, int R, int val) {
    push_r(v, left, right);
    if (R <= left || right <= L) {
        return;
    }
    if (L <= left && right <= R) {
        modr[v] += val;
        push_r(v, left, right);
        return;
    }
    int mid = (left + right) / 2;
    update_r(v * 2 + 1, left, mid, L, R, val);
    update_r(v * 2 + 2, mid, right, L, R, val);
    str[v] = min(str[v * 2 + 1], str[v * 2 + 2]);
}

int get_r(int v, int left, int right, int L, int R) {
    push_r(v, left, right);
    if (R <= left || right <= L) {
        return INF;
    }
    if (L <= left && right <= R) {
        return str[v];
    }
    int mid = (left + right) / 2;
    return min(get_r(v * 2 + 1, left, mid, L, R), get_r(v * 2 + 2, mid, right, L, R));
}

void dfs_tin(int v) {
    per[tnow] = v;
    tin[v] = tnow++;
    for (int i = 0; i < (int)g[v].size(); ++i) {
        dfs_tin(g[v][i]);
        if (i != 0) {
            update_ind(0, 0, n, tin[g[v][i]]);
        }
    }
}

void dfs_can(int v) {
    int lsum = 0;
    for (int u : g[v]) {
        dfs_can(u);
        if (!can) {
            return;
        }
        lsum += l[u];
        if (lsum > r[v]) {
            can = false;
            return;
        }
    }
    l[v] = max(l[v], lsum);
}

void dfs_ans(int v) {
    best[v].insert(make_pair(c[v], v));
    for (int u : g[v]) {
        dfs_ans(u);
        a[v] += a[u];
        if (best[v].size() < best[u].size()) {
            best[v].swap(best[u]);
        }
        for (auto elem : best[u]) {
            best[v].insert(elem);
        }
        best[u].clear();
    }
    while (a[v] < l[v]) {
        int q = best[v].begin()->second;
        int val = l[v] - a[v];
        while (q != 0) {
            int w = per[get_ind(0, 0, n, 0, tin[q] + 1)];
            val = min(val, get_r(0, 0, n, tin[w], tin[q] + 1));
            q = par[w];
        }
        q = best[v].begin()->second;
        while (q != 0) {
            int w = per[get_ind(0, 0, n, 0, tin[q] + 1)];
            update_r(0, 0, n, tin[w], tin[q] + 1, val);
            q = par[w];
        }
        b[best[v].begin()->second] += val;
        a[v] += val;
        if (l[v] != a[v]) {
            best[v].erase(best[v].begin());
        }
    }
}

void solve() {
    cin >> n;
    g.resize(n);
    c.resize(n);
    l.resize(n);
    r.resize(n);
    tin.resize(n);
    d.resize(n, 0);
    dmax.resize(n, 0);
    par.resize(n);
    a.resize(n, 0);
    b.resize(n, 0);
    best.resize(n);
    per.resize(n);
    modr.resize(4 * n, 0);
    str.resize(4 * n, INF);
    stind.resize(4 * n, 0);
    par[0] = 0;
    for (int i = 1; i < n; ++i) {
        cin >> par[i];
        g[--par[i]].emplace_back(i);
    }
    for (int i = 0; i < n; ++i) {
        cin >> c[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> l[i] >> r[i];
    }
    dfs_can(0);
    if (can) {
        dfs_d(0);
        dfs_tin(0);
        update_ind(0, 0, n, 0);
        build_r(0, 0, n);
        dfs_ans(0);
        long long ans = 0;
        for (int i = 0; i < n; ++i) {
            ans += (long long)c[i] * (long long)b[i];
        }
        cout << ans << "\n";
        for (int i = 0; i < n; ++i) {
            cout << b[i] << " ";
        }
        cout << "\n";
    }
    else {
        cout << "-1\n";
    }
    c.clear();
    g.clear();
    l.clear();
    r.clear();
    tin.clear();
    d.clear();
    dmax.clear();
    str.clear();
    stind.clear();
    modr.clear();
    par.clear();
    a.clear();
    b.clear();
    best.clear();
    per.clear();
    tnow = 0;
    can = true;
}

void fastio() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
}

signed main() {
    fastio();

    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }

    return 0;
}
