#include <iostream>
#include <iomanip>
#include <cstdlib>
#include <cstdio>
#include <algorithm>
#include <cmath>
#include <numeric>
#include <utility>
#include <vector>
#include <deque>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <bitset>
#include <string>
#include <sstream>
#include <chrono>
#include <random>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

const int MAXLOG = 12;

void solve() {

    int n;
    cin >> n;
    vector<int> mod(n + 1, 0);
    vector<vector<vector<int>>> binup(MAXLOG, vector<vector<int>>(n + 1, vector<int>(n + 1, 0)));
    for (int i = 1; i <= n; ++i) {
        binup[0][i][i] = i - 1;
    }
    for (int i = 1; i <= n; ++i) {
        int c;
        cin >> c;
        mod[c] = 1;
        int modsum = 0;
        int prevmodsum = 0;
        for (int j = 1; j <= n; ++j) {
            modsum += mod[j];
            binup[0][j][j - modsum] = j - 1 - prevmodsum;
            prevmodsum = modsum;
        }
    }
    for (int mylog = 1; mylog < MAXLOG; ++mylog) {
        for (int i = 0; i <= n; ++i) {
            for (int j = 0; j <= i; ++j) {
                binup[mylog][i][j] = binup[mylog - 1][max(0, i - (1 << (mylog - 1)))][binup[mylog - 1][i][j]];
            }
        }
    }
    int q;
    cin >> q;
    while (q--) {
        int r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;
        if (r1 < r2) {
            swap(r1, r2);
            swap(c1, c2);
        }
        int d = r1 - r2;
        for (int mylog = 0; mylog < MAXLOG; ++mylog) {
            if ((d >> mylog) & 1) {
                c1 = binup[mylog][r1][c1];
                r1 -= (1 << mylog);
            }
        }
        if (c1 == c2) {
            cout << r1 << " " << c1 << "\n";
        } else {
            for (int mylog = MAXLOG - 1; mylog >= 0; --mylog) {
                if (binup[mylog][r1][c1] != binup[mylog][r2][c2]) {
                    c1 = binup[mylog][r1][c1];
                    c2 = binup[mylog][r2][c2];
                    r1 -= (1 << mylog);
                    r2 -= (1 << mylog);
                }
            }
            cout << r1 - 1 << " " << binup[0][r1][c1] << "\n";
        }
    }

}

void fastio() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
}

signed main() {
    fastio();

    int t = 1;
    while (t--) {
        solve();
    }

    return 0;
}
