#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second
//#define int long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define ld long double

const int MAXN = 1e5 + 10;

vector<array<int, 2> > g;

void relax(vector<int> &cur, int n) {
    int a = 0, b = 0;
    for (int i = 0; i < n; i++) {
        int t = (a + 1) * a / 2 + b;
        int nw = (a + 2) * (a + 1) / 2 + b + cur[i];
        g[t][cur[i]] = nw;
        a++;
        b += cur[i];
    }
}

vector<int> tin, tout;
vector<vector<int> > up;
int timer = 0;

void dfs(int v, int p) {
    tin[v] = timer++;
    up[0][v] = p;
    for (int i = 1; i < 20; i++) {
        up[i][v] = up[i - 1][up[i - 1][v]];
    }
    for (auto to : g[v]) {
        if (to != -1) {
            dfs(to, v);
        }
    }
    tout[v] = timer++;
}

bool in(int a, int b) {
    return tin[a] <= tin[b] && tout[a] >= tout[b];
}

int lca(int a, int b) {
    if (in(a, b))
        return a;
    if (in(b, a))
        return b;
    int k = 19;
    while (k >= 0) {
        if (!in(up[k][a], b))
            a = up[k][a];
        k--;
    }
    return up[0][a];
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    vector<int> v(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i];
        v[i]--;
    }
    vector<int> cur(n, 1);
    g.resize((n + 2) * (n + 1) / 2, {-1, -1});
    relax(cur, n);
    for (int i = 0; i < n; i++) {
        cur[v[i]] = 0;
        relax(cur, n);
    }
    tin.resize((n + 2) * (n + 1) / 2);
    tout.resize((n + 2) * (n + 1) / 2);
    up.resize(20, vector<int> ((n + 2) * (n + 1) / 2));
    vector<pair<int, int> > get((n + 2) * (n + 1) / 2);
    for (int i = 0; i <= n; i++) {
        for (int j = 0; j <= i; j++) {
            get[(i + 1) * i / 2 + j] = {i, j};
        }
    }
    dfs(0, 0);
    int q;
    cin >> q;
    while (q --> 0) {
        int a1, b1, a2, b2;
        cin >> a1 >> b1 >> a2 >> b2;
        int t = lca((a1 + 1) * a1 / 2 + b1, (a2 + 1) * a2 / 2 + b2);
        cout << get[t].fi << " " << get[t].se << '\n';
    }

    return 0;
}
/*
3
1 3 2
5
3 3 3 0
2 2 2 1
1 0 3 1
3 1 3 2
2 2 2 2

 */