#include <iostream>
#include <iomanip>

#include <algorithm>

#include <vector>
#include <string>
#include <set>
#include <map>

#include <unordered_map>
#include <cassert>

using namespace std;

#define sz(x) ((int)(x).size())
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

typedef long long ll;

const ll inf = 1e18;

const int N = 3000 * 3000 + 3001;

int n;
set<int> g[N];
void add(vector<bool>& path) {
	int r = 0, c = 0;
	for (auto t : path) {
		int new_r = r + 1, new_c = c + t;
		g[r * n + c].insert(new_r * n + new_c);
		r = new_r, c = new_c;
	}
}

int tin[N], tout[N];
vector<int> up[N];

int timer = 0, L = 0;
void dfs(int v, int p = 0) {
	up[v].assign(L, 0);
	up[v][0] = p;

	tin[v] = timer;
	timer++;
	for (auto to : g[v]) {
		dfs(to, v);
	}
	tout[v] = timer;
	timer++;
}

void build_up(int v) {
	for (int j = 1; j < L; j++) {
		int pred = up[v][j - 1];
		up[v][j] = up[pred][j - 1];
	}

	for (auto to : g[v]) {
		build_up(to);
	}
}

bool is_upper(int a, int b) {
	return tin[a] <= tin[b] &&
		tout[b] <= tout[a];
}

int get_lca(int a, int b) {
	if (is_upper(a, b))
		return a;
	if (is_upper(b, a))
		return b;
	while (!is_upper(b, a)) {
		b = up[b][0];
	}
	return b;
}

int main() {
	ios_base::sync_with_stdio(false), cin.tie(NULL), cout.tie(NULL);

	cin >> n;
	vector<bool> path(n, 1);
	add(path);
	for (int i = 0; i < n; i++) {
		int pos;  cin >> pos;
		pos--;
		path[pos] = 0;
		add(path);
	}

	while ((1 << L) <= n + 1) {
		L++;
	}

	dfs(0);
	build_up(0);

	int q; cin >> q;
	while (q--) {
		pair<int, int> a; cin >> a.first >> a.second;
		pair<int, int> b; cin >> b.first >> b.second;

		int l = get_lca(a.first * n + a.second, b.first * n + b.second);
		cout << l / n << ' ' << l % n << '\n';
	}

	return 0;
}