#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <cmath>
#include <set>
#include <cassert>
#include <algorithm>

using namespace std;

#define all(x) x.begin(), x.end()
typedef long long ll;

//#define int ll

int to(int r, int c) {
	return r * (r + 1) / 2 + c;
}

pair<int, int> back(int y) {
	int x = sqrt(2 * y);
	while ((x) * (x + 1) / 2 > y) --x;
	while ((x + 1) * (x + 2) / 2 <= y) ++x;
	return { x, y - (x) * (x + 1) / 2 };
}

vector<set<int>> g;

vector<int> tin, tout;
vector<vector<int>> up;
int timer = 0;
int l = 0;

void dfs(int v, int pr = -1) {
	tin[v] = timer;
	if (pr != -1) {
		up[0][v] = pr;
		for (int i = 1; i < l; ++i) {
			up[i][v] = up[i - 1][up[i - 1][v]];
		}
	}
	for (auto& i : g[v])
		dfs(i, v);
	tout[v] = timer++;
}

bool upper(int a, int b) {
	return tin[a] <= tin[b] && tout[a] >= tout[b];
}

int lca(int a, int b) {
	if (upper(a, b)) return a;
	for (int i = l - 1; i >= 0; --i)
		if (!upper(up[i][a], b)) a = up[i][a];
	return up[0][a];
}

void solve() {
	int n;
	cin >> n;
	vector<int> a(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		--a[i];
	}
	g.resize((n + 2) * (n + 1) / 2);
	vector<bool> u(n, 1);
	for (int i = 0; i < n + 1; ++i) {
		int r = 0, c = 0;
		for (int i = 0; i < n; ++i) {
			int nr = r + 1, nc = c + u[i];
			g[to(r, c)].emplace(to(nr, nc));
			r = nr, c = nc;
		}
		if (i == n) break;
		u[a[i]] = 0;
	}
	l = log2(g.size()) + 2;
	tin.resize(g.size());
	tout.resize(g.size());
	up.resize(l, vector<int>(g.size()));
	dfs(0);
	int q;
	cin >> q;
	for (int i = 0; i < q; ++i) {
		int r1, c1, r2, c2;
		cin >> r1 >> c1 >> r2 >> c2;
		auto ans = back(lca(to(r1, c1), to(r2, c2)));
		cout << ans.first << " " << ans.second << '\n';
	}
}

signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	cin.tie(0);
	ios_base::sync_with_stdio(false);
#endif
	int t = 1;
	//cin >> t;
	while (t-- > 0) {
		solve();
		cout << '\n';
	}
	return 0;
}