#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <cmath>
#include <set>
#include <cassert>
#include <algorithm>

using namespace std;

#define all(x) x.begin(), x.end()
typedef long long ll;

#define int ll

ll get_suf(ll used, vector<int>& lasth, vector<pair<int, int>>& lasts, vector<ll>& prsum, ll h) {
	int ind = lower_bound(all(lasth), h) - lasth.begin();
	int w = lasts[ind].first;
	int h1 = lasts[ind - 1].second - (-h);
	ll al = w * (lasts[ind - 1].second - lasts[ind].second - h1);
	return al;
}

ll get(ll used, int lasth, vector<int>& lastsh, vector<pair<int, int>>& lasts, vector<ll>& prsum, ll h) {
	if (h <= lasth) return 0;
	int ind = lower_bound(all(lastsh), h) - lastsh.begin();
	ll al = prsum[ind];
	al -= used;
	return (al - get_suf(used, lastsh, lasts, prsum, h));
}

void solve(int k) {
	int n, w, h;
	cin >> n >> w >> h;
	pair<int, int> last = { 0, h };
	vector<pair<int, int>> a(n);
	for (auto& i : a)
		cin >> i.first >> i.second;
	sort(all(a));
	ll ans = 0;
	vector<pair<int, int>> lasts = { last };
	vector<int> lastsh = { -h };
	for (int i = 0; i < n; ++i) {
		if ((last.first == a[i].first && a[i].second < last.second)
			|| ((last.second == a[i].second) && (a[i].first > last.first))) {
			if (last != make_pair(0ll, h)) {
				lasts.pop_back();
				lastsh.pop_back();
			}
			last = a[i];
			lasts.emplace_back(last);
			lastsh.emplace_back(-last.second);
		}
		if (a[i].first > last.first && a[i].second < last.second) {
			last = a[i];
			lasts.emplace_back(last);
			lastsh.emplace_back(-last.second);
		}
	}
	int lasth = lastsh.front();
	ll s = 0, used = 0;
	vector<ll> prsum(lasts.size());
	for (int i = 1; i < lasts.size(); ++i) {
		prsum[i] = prsum[i - 1] + (lasts[i].first) *
			(lasts[i - 1].second - lasts[i].second);
	}
	set<pair<int, int>> al;
	for (auto& i : lasts) al.emplace(i);
	a.erase(find(all(a), lasts.back()));
	a.emplace_back(lasts.back());
	last = { 0, h };
	for (int i = 0; i < n - 1; ++i) {
		if (al.count(a[i])) {
			ans += (ll)(w - a[i].first) * (last.second - a[i].second);
			last = a[i];
		}
		else {
			used += get(used, lasth, lastsh, lasts, prsum, -a[i].second);
			lasth = max(lasth, -a[i].second);
		}
	}
	ll aa = max((ll)(w - a[n - 1].first) * (last.second - a[n - 1].second),
		get(used, lasth, lastsh, lasts, prsum, -a[n - 1].second));
	cout << ans + aa + used;
}

signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	cin.tie(0);
	ios_base::sync_with_stdio(false);
#endif
	int k, t;
	cin >> k;
	for (int i = 0; i < k; ++i) {
		cin >> t;
	}
	cin >> t;
	while (t-- > 0) {
		solve(k);
		cout << '\n';
	}
	return 0;
}