#include <bits/stdc++.h>

#define rep(i, n) for(int i = 0; i < (n); ++i)
#define all(a) (a).begin(), (a).end()
#define ar array
#define rall(a) (a).rbegin(), (a).rend()


using namespace std;

typedef long long ll;
typedef long double ld;

using vi = vector<int>;
using vl = vector<ll>;

const int INFi = 2e9;
const ll INF = 2e18;
const int maxN = 1e5 + 5;
const int LG = 20;

struct fenwick {
    vector<int> fenw;
    int n;

    void build(int k) {
        n = k;
        fenw.resize(n);
    }

    void upd(int i, int x) {
        for (; i < n; i = i | (i + 1)) fenw[i] += x;
    }

    int get(int i) {
        int r = 0;
        for (; i >= 0; i = (i & (i + 1)) - 1) r += fenw[i];
        return r;
    }

    int lower_bound(int x) {
        int r = -1;
        for (int j = LG; j >= 0; --j) {
            int t = (1 << j) + r;
            if (t < n && fenw[t] < x) {
                x -= fenw[t];
                r = t;
            }
        }
        return r + 1;
    }

    int get(int l, int r) {
        return get(r) - get(l - 1);
    }
};

void solve() {
    int n;
    cin >> n;
    vi a(n);
    rep(i, n) cin >> a[i];
    int q;
    cin >> q;
    vi b(n);
    rep(i, n) {
        a[i]--;
        b[a[i]] = i;
    }
    vi c(n);
    fenwick f;
    f.build(n);
    rep(i, n) {
        c[a[i]] = f.get(a[i]);
        f.upd(a[i], 1);
    }
    auto get = [&](int r, int c) {
        vi kek;
        rep(i, r) kek.push_back(b[i]);
        sort(all(kek));
        c = r - c;
        if (c == 0) return pair<int, int>{-1, kek[c] - 1};
        if (c == kek.size()) return pair<int, int>{kek[c - 1], INFi};
        return pair<int, int>{kek[c - 1], kek[c] - 1};
    };
    vector<pair<int, int>> Q(q * 2);
    vector<pair<int, int>> LR(q * 2);
    vector<vi> qq(n + 1);

    rep(i, q * 2) {
        cin >> Q[i].first >> Q[i].second;
        qq[Q[i].first].push_back(i);
    }

    fenwick f2;
    f2.build(n);
    rep(r, n + 1) {
        for (auto i: qq[r]) {
            int c = r - Q[i].second;
            LR[i] = {-1, INFi};
            if (c != 0) {
                LR[i].first = f2.lower_bound(c);
            }
            if (c != r) {
                LR[i].second = f2.lower_bound(c + 1) - 1;
            }
        }
        if (r != n) f2.upd(b[r], 1);
    }
    rep(i, q) {
        auto[r1, c1] = Q[i * 2];
        auto[r2, c2] = Q[i * 2 + 1];
        if (Q[i * 2] == Q[i * 2 + 1]) {
            cout << Q[i * 2].first << ' ' << Q[i * 2].second << '\n';
            continue;
        }
        auto[L1, R1] = LR[i * 2];
        auto[L2, R2] = LR[i * 2 + 1];
        if (L2 < L1) {
            swap(L1, L2);
            swap(R1, R2);
        }
        assert(L1 <= L2);
        if (R1 >= L2) {
//            assert(R1 >= R2);
            if (r1 < r2) {
                cout << r1 << ' ' << c1 << '\n';
            } else {
                cout << r2 << ' ' << c2 << '\n';
            }
            continue;
        }
        // R1 < L2
        int mn = INFi;
        for (int j = L1 + 1; j <= L2; ++j) {
            mn = min(mn, a[j]);
        }
        if (mn == INFi) return;
        assert(mn != INFi);
        int p = mn - c[mn];
        cout << mn << ' ' << p << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t = 1;
    rep(_, t) {
        solve();
    }
    return 0;
}