#include <bits/stdc++.h>

#define rep(i, n) for(int i = 0; i < (n); ++i)
#define all(a) (a).begin(), (a).end()
#define ar array
#define rall(a) (a).rbegin(), (a).rend()


using namespace std;

typedef long long ll;
typedef long double ld;

using vi = vector<int>;
using vl = vector<ll>;

const int INFi = 2e9;
const ll INF = 2e18;
const int maxN = 1e5 + 5;
const int LG = 20;

int k;
vi allow;

struct dsu {
    vector<int> dsu;

    void build(int n) {
        dsu.resize(n);
        iota(all(dsu), 0);
    }

    int get(int a) {
        return dsu[a] == a ? a : dsu[a] = get(dsu[a]);
    }

    bool unio(int a, int b) {
        a = get(a);
        b = get(b);
        if (a == b) return false;
        dsu[a] = b;
        return true;
    }
};

ll small_solve(vector<pair<int, int>> pts, int w, int h) {
    int n = pts.size();
    vector<ar<ll, 2>> dp(n + 1, {0, 0});
    vector<ar<ll, 2>> add(n + 1, {0, 0});
    for (int i = 0; i < n; ++i) {
        add[i][0] = 1ll * ((i != 0 ? pts[i - 1].second : h) - pts[i].second) * (w - pts[i].first);
        add[i][1] = 1ll * (pts[i].first - (i != 0 ? pts[i - 1].first : 0)) * pts[i].second;
        if (i > 0) {
            add[i][0] += add[i - 1][0];
            add[i][1] += add[i - 1][1];
        }
    }
    add[n] = add[n - 1];
    dp[0] = add[0];
    for (int i = 0; i < n; ++i) {
        rep(j, 2) {
            for (int e = i + 1; e <= n; ++e) {
                ll val = dp[i][j] + add[e - 1][j] - add[i][j];
                if (e != n) {
                    if (j == 0) {
                        val += 1ll * (pts[e].first - (i != 0 ? pts[i - 1].first : 0)) * pts[e].second;
                    } else {
                        val += 1ll * ((i != 0 ? pts[i - 1].second : h) - pts[e].second) * (w - pts[e].first);
                    }
                }
                dp[e][j ^ 1] = max(dp[e][j ^ 1], val);
            }
        }
    }
    return max(dp[n][0], dp[n][1]);
}

void solve() {
    assert(k == 2);
    assert(allow[0] == 1 && allow[1] == 2);
    int n;
    cin >> n;
    int w, h;
    cin >> w >> h;
    vector<pair<int, int>> pts(n);
    rep(i, n) cin >> pts[i].first >> pts[i].second;
    sort(all(pts), [&](const pair<int, int> &a, const pair<int, int> &b) {
        return make_pair(a.second, b.first) < make_pair(b.second, b.first);
    });
    int Lx = 0;
    int Rx = w;
    ll cur = 0;
    ll ans = 0;
    for (int i = 0; i < n; ++i) {
        if (pts[i].first <= Lx || pts[i].first >= Rx) {
            ans = max(ans, cur + 1ll * (Rx - Lx) * (h - pts[i].second));
            break;
        }
        if (pts[i].first - Lx > Rx - pts[i].first) {
            ll val = 1ll * (Rx - pts[i].first) * (h - pts[i].second);
            if (i + 1 < n) val += 1ll * (pts[i].first - Lx) * (h - pts[i + 1].second);
            ans = max(ans, cur + val);
            cur += 1ll * (pts[i].first - Lx) * (h - pts[i].second);
            Lx = pts[i].first;
        } else {
            ll val = 1ll * (pts[i].first - Lx) * (h - pts[i].second);
            if (i + 1 < n) val += 1ll * (Rx - pts[i].first) * (h - pts[i + 1].second);
            ans = max(ans, cur + val);
            cur += 1ll * (Rx - pts[i].first) * (h - pts[i].second);
            Rx = pts[i].first;
        }
    }
    cout << ans << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t = 1;
    cin >> k;
    rep(i, k) {
        int x;
        cin >> x;
        allow.push_back(x);
    }
    cin >> t;
    rep(_, t) {
        solve();
    }
    return 0;
}