// mukar.cpp : This file contains the 'main' function. Program execution begins and ends there.
//
#ifdef  LOCAL
#include <C:\Users\roi\Desktop\stdc++.h>
#else
#include <bits/stdc++.h>
#endif

using namespace std;

typedef long long ll;
//#define int ll
typedef vector <int> vi;
typedef vector <vi> vii;
typedef pair <int, int> pii;

#define all(a) (a).begin(), (a).end()

struct Fenwick
{
	vi t;

	Fenwick(int n) {
		t.resize(n + 1, 0);
	}

	void add(int i, int x) {
		for (int r = i; r < t.size(); r += (r & -r)) {
			t[r] += x;
		}
	}

	int get(int r) {
		int res = 0;
		for (int i = r; i > 0; i -= (i & -i)) {
			res += t[i];
		}
		return res;
	}
};

signed main() {
	ios::sync_with_stdio(0); cin.tie(0);
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif 
	int n;
	cin >> n;
	vi a(n);
	for (auto& x : a) {
		cin >> x;
	}
	
	Fenwick f(n);
	vi prev(n);
	for (int i = 0; i < n; ++i) {
		prev[i] = i - f.get(a[i]);
		f.add(a[i], 1);
	}
	fill(all(f.t), 0);
	vi next(n);
	for (int i = n - 1; i >= 0; i--) {
		next[i] = f.get(a[i]);
		f.add(a[i], 1);
	}


	vi kek(n);
	for (int i = 0; i < n; ++i) {
		a[i]--;
		kek[a[i]] = i;
	}
	int sum = 0;
	for (int i = 0; i < n; ++i) {
		for (int j = i + 1; j < n; ++j) {
			int x = kek[i], y = kek[j];
			if (x > y) {
				swap(x, y);
			}
			int m = max(j - i, y - x + prev[x]);
			m = max(m, y - x + next[y]);
			sum += m;
		}
	}
	cout << sum << "\n";
	return 0;
}