#include <bits/stdc++.h>

using namespace std;

const int MAXN = 3010;
const int INF = 1e9;

int arr[MAXN];
int pos[MAXN];
int n;
int mntime[MAXN][MAXN];

void calcmintime() {
    vector<char> val(n, 1);
    for (int i = 0; i <= n; ++i) {
        for (int j = 0; j <= i; ++j)
            mntime[i][j] = INF;
    }
    mntime[0][0] = 0;
    for (int t = 0; t <= n; ++t) {
        int bal = 0;
        for (int i = 0; i < n; ++i) {
            bal += val[i];
            mntime[i + 1][bal] = min(mntime[i + 1][bal], t);
        }
        if (t < n)
            val[arr[t]] = 0;
    }
}

bool isright(int r, int c) {
    int t = mntime[r][c];
    if (pos[r - 1] < t)
        return false;
    return true;
}

void goup(int &r, int &c) {
    if (isright(r, c))
        c--;
    r--;
}

int fwtree[MAXN];

int get(int i) {
    int res = 0;
    for (; i > 0; i -= i & -i) {
        res += fwtree[i];
    }
    return res;
}

void upd(int i, int x) {
    for (; i < MAXN; i += i & -i) {
        fwtree[i] += x;
    }
}

int mag[MAXN];

void calcmag() {
    for (int i = 0; i < n; ++i) {
        mag[i] = get(arr[i]);
        upd(arr[i] + 1, 1);
    }
}

const int LOG = 21;
int tree[MAXN][LOG];

void buildsparse() {
    for (int i = n - 1; i >= 0; --i) {
        tree[i][0] = i;
        for (int b = 1; b < LOG; ++b) {
            int j = min(n - 1, i + (1 << (b - 1)));
            int ai = tree[i][b - 1];
            int bi = tree[j][b - 1];
            if (arr[ai] < arr[bi])
                tree[i][b] = ai;
            else
                tree[i][b] = bi;
        }
    }
}

int getminsparse(int l, int r) {
    if (l + 1 == r)
        return tree[l][0];
    int lg = 31 - __builtin_clz(r - l - 1);
    int a = tree[l][lg];
    int b = tree[r - (1 << lg)][lg];
    if (arr[a] < arr[b])
        return a;
    return b;
}

int getkpor(int l, int r, int k) {
    if (r - l == k)
        return n;
    vector<int> brr(r - l);
    for (int i = l; i < r; ++i)
        brr[i - l] = pos[i];
    sort(brr.begin(), brr.end());
    return brr[k];
}

int getmintime(int r, int c) {
    int left = r - c;
    int t = getkpor(0, r, left);
    return t;
}


pair<int, int> lca(int r1, int c1, int r2, int c2) {
    if (r1 > r2)
        swap(r1, r2), swap(c1, c2);
    int l = getmintime(r1, c1);
    int r = getmintime(r2, c2);
    if (r < l)
        swap(l, r);
    if (l == r)
        return {r1, c1};
    int mndi = getminsparse(l, r);
    int mnd = arr[mndi];
    if (mnd > r1) {
        return {r1, c1};
    }
    int cnt = mag[mndi];
    return {mnd, mnd - cnt};
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> arr[i];
        arr[i]--;
        pos[arr[i]] = i;
    }
    calcmag();
    buildsparse();
    calcmintime();
    int q;
    cin >> q;
    for (int qq = 0; qq < q; ++qq) {
        int r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;
        auto[r3, c3] = lca(r1, c1, r2, c2);
        cout << r3 << ' ' << c3 << '\n';
    }
}