#include <bits/stdc++.h>
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define X first
#define Y second

using namespace std;

int get_lower(vector<int>& v, int x) {
    int l = -1, r = v.size();
    while (l + 1 < r) {
        int m = (l + r) >> 1;
        (v[m] <= x ? l : r) = m;
    }
    return l + 1;
}

int N;

struct Tree {
    vector<vector<int>> t;
    int n;
    void build(vector<int>& a, int v, int vl, int vr) {
        if (vr - vl == 1) {
            t[v].push_back(a[vl]);
            return;
        }
        int vm = (vl + vr) >> 1;
        build(a, v + v + 1, vl, vm);
        build(a, v + v + 2, vm, vr);
        t[v].resize(t[v + v + 1].size() + t[v + v + 2].size());
        merge(all(t[v + v + 1]), all(t[v + v + 2]), t[v].begin());
    }
    void build(vector<int>& a) {
        n = a.size();
        t.resize(4 * n);
        build(a, 0, 0, n);
    }
    int lower(int l, int r, int x, int v, int vl, int vr) {
        if (vl >= r || vr <= l)
            return 0;
        if (vl >= l && vr <= r)
            return get_lower(t[v], x);
        int vm = (vl + vr) >> 1;
        return lower(l, r, x, v + v + 1, vl, vm) + lower(l, r, x, v + v + 2, vm, vr);
    }
    int lower(int l, int r, int x) {
        return lower(l, r, x, 0, 0, n);
    }
    int kth(int r, int k) {
        int L = 0, R = N;
        while (L + 1 < R) {
            int M = (L + R) >> 1;
            (lower(0, r, M) < k ? L : R) = M;
        }
        return R;
    }
};

int get_time(int floor, int shift, Tree& T) {
    if (shift == 0)
        return 0;
    --floor;
    return T.kth(floor + 1, shift);
}

pair<int, int> up(int v, int c, int d, int vtm, Tree& T) {
    int to = max(0, v - d);
    int chel = T.lower(to, v, vtm);
    chel = v - to - chel;
    return {to, c - chel };
}

const int lg = 20;

pair<int, int> lca(int r1, int c1, int t1, int r2, int c2, int t2, Tree& T) {
    if (r1 == r2 && c1 == c2) {
        return { r1, c1 };
    }
    if (r1 < r2) {
        swap(r1, r2);
        swap(c1, c2);
        swap(t1, t2);
    }
    for (int i = 0; i < lg; ++i) {
        if ((1 << i) & (r1 - r2)) {
            auto ver = up(r1, c1, 1 << i, t1, T);
            r1 = ver.X, c1 = ver.Y;
        }
    }
    for (int i = lg - 1; i >= 0; --i) {
        auto ver1 = up(r1, c1, 1 << i, t1, T);
        auto ver2 = up(r2, c2, 1 << i, t2, T);
        if (ver1 != ver2) {
            r1 = ver1.X, c1 = ver1.Y;
            r2 = ver2.X, c2 = ver2.Y;
        }
    }
    return up(r1, c1, 1, t1, T);
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    int n;
    cin >> n;
    N = n + 10;
    vector<int> change(n);
    for (int i = 1; i <= n; ++i) {
        int x;
        cin >> x;
        change[x - 1] = i;
    }
    Tree T;
    T.build(change);
    int q;
    cin >> q;
    while (q--) {
        int r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;
        int s1 = r1 - c1;
        int s2 = r2 - c2;
        int tm1 = get_time(r1, s1, T);
        int tm2 = get_time(r2, s2, T);
        auto ans = lca(r1, c1, tm1, r2, c2, tm2, T);
        cout << ans.X << ' ' << ans.Y << '\n';
    }
}
