#include <iostream>
#include <vector>
#include <algorithm>

int n;

long long toIdx(long long r, long long c)
{
	return r * (r + 1) / 2 + c;
}

std::pair<int, int> fromIdx(long long idx)
{
	int r = 0;
	while (r * (r + 1) / 2 <= idx) r++;
	r--;
	int c = idx - r * (r + 1) / 2;
	return std::make_pair(r, c);
}

int main()
{
	std::cin >> n;
	n++;
	std::vector<int> paths(n * (n + 1) / 2);
	std::vector<bool> turns(n + 2, false);
	std::vector<int> turn(n + 2);
	bool flag = true;
	int index = 0;
	for (int i = 0; i < n; i++)
	{
		std::cin >> turn[i];
		if (i > 0)
		{
			if (flag) flag = turn[i] == turn[i - 1] + 1;
		}
	}
	if (flag)
	{
		int q;
		std::cin >> q;
		for (int i = 0; i < q; i++)
		{
			int r1, c1, r2, c2;
			std::cin >> r1 >> c1 >> r2 >> c2;
			int line1 = r1 - c1;
			int line2 = r2 - c2;
			if (line1 == line2)
			{
				if (r1 < r2) 
				{
					std::cout << r1 << " " << c1 << std::endl;
				}
				else {
					std::cout << r2 << " " << c2 << std::endl;
				}
			}
			else 
			{
				int line = std::min(line1, line2);
				std::cout << line << " " << 0 << std::endl;
			}
		}
		return 0;
	}
	for (int i = 0; i < n; i++)
	{
		int prev = toIdx(0, 0);
		int r = 0;
		int c = 0;
		while (r < n)
		{
			paths[toIdx(r, c)] = prev;
			prev = toIdx(r, c);
			r++;
			if (!turns[r]) c++;
		}
		if (i != n - 1)
		{
			int a = turn[index];
			turns[a] = true;
			index++;
		}
	}
	int q;
	std::cin >> q;
	for (int i = 0; i < q; i++)
	{
		int r1, c1, r2, c2;
		std::cin >> r1 >> c1 >> r2 >> c2;
		int a = toIdx(r1, c1);
		int b = toIdx(r2, c2);
		while (fromIdx(a).first > fromIdx(b).first) a = paths[a];
		while (fromIdx(a).first < fromIdx(b).first) b = paths[b];
		while (a != b)
		{
			a = paths[a];
			b = paths[b];
		}
		std::pair<int, int> ans = fromIdx(a);
		std::cout << ans.first << " " << ans.second << std::endl;
	}
	return 0;
}