#pragma GCC optimize("Ofast")
//#pragma GCC target("avx2,sse4,popcnt")

#include <bits/stdc++.h>

#define sq(x) ((x)*(x))
#define err(x) cerr << "["#x"]  " << (x) << "\n"
#define errv(x) {cerr << "["#x"]  ["; for (const auto& i : (x)) cerr << (i) << ", "; cerr << "]\n";}
#define errvn(x, n) {cerr << "["#x"]  ["; for (int i = 0; i < (n); ++i) cerr << (x)[i] << ", "; cerr << "]\n";}
#define errf() cerr << "\n\n"

using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
inline ll getrnd(ll l, ll r) {
    return uniform_int_distribution<ll>(l, r)(rng);
}

template <typename T1, typename T2>
inline bool relax(T1& a, const T2& b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

template <typename T1, typename T2>
inline bool strain(T1& a, const T2& b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

// ::::::::::::::::::::::::::::::::::

const int N = 1e5 + 5;

struct seg_tree {
    vector<ll> mx;
    seg_tree(int n) : mx(4 * n, 2e9) {}

    void update(int v, int tl, int tr, int l, int r, ll x) {
        if (l > r) return;
        if (tl == l && tr == r) {
            relax(mx[v], x);
        } else {
            int tm = (tl + tr) / 2;
            update(2 * v, tl, tm, l, min(r, tm), x);
            update(2 * v + 1, tm + 1, tr, max(l, tm + 1), r, x);
        }
    }

    ll get(int v, int tl, int tr, int pos) {
        if (tl == tr) {
            return mx[v];
        }
        int tm = (tl + tr) / 2;
        if (pos <= tm)
            return min(mx[v], get(2 * v, tl, tm, pos));
        else
            return min(mx[v], get(2 * v + 1, tm + 1, tr, pos));
    }
};

//struct seg_tree_add {
//    vector<ll> tree;
//
//    seg_tree_add(int n) : tree(4 * n) {}
//
//    void update(int v, int tl, int tr, int l, int r, ll x) {
//        if (l > r) return;
//        if (tl == l && tr == r) {
//            tree[v] += x;
//            return;
//        } else {
//            int tm = (tl + tr) / 2;
//        }
//    }
//};

ll tree[4 * N], lazy[4 * N];

void upd(int v, ll x) {
    tree[v] += x;
    lazy[v] += x;
}

void push(int v) {
    if (lazy[v] != 0) {
        upd(2 * v, lazy[v]);
        upd(2 * v + 1, lazy[v]);
        lazy[v] = 0;
    }
}

void update(int v, int tl, int tr, int l, int r, ll x) {
    if (l > r) return;
    if (tl == l && tr == r) {
        upd(v, x);
    } else {
        int tm = (tl + tr) / 2;
        push(v);
        update(2 * v, tl, tm ,l, min(r, tm), x);
        update(2 * v + 1, tm + 1, tr, max(l, tm + 1), r, x);
        tree[v] = tree[2 * v] + tree[2 * v + 1];
    }
}

ll get(int v, int tl, int tr, int l, int r) {
    if (l > r) return 1e18;
    if (tl == l && tr == r) {
        return tree[v];
    } else {
        int tm = (tl + tr) / 2;
        push(v);
        return min(get(2 * v, tl, tm, l, min(r, tm)), get(2 * v + 1, tm + 1, tr, max(l, tm + 1), r));
    }
}

int n, bad = 0, timer = 0;
int tin[N], tout[N], p[N], sz[N], head[N];
ll ans[N], c[N], l[N], r[N], now[N], can[N], res[N];
vector<int> graph[N];
set<pair<ll, ll>> have[N];

inline bool ispar(int a, int b) {
    return tin[a] <= tin[b] && tout[b] <= tout[a];
}

void prep(int v, int par) {
    tin[v] = timer++;
    p[v] = par;
    if (!graph[v].empty()) {
        head[graph[v][0]] = head[v];
        for (int to : graph[v]) {
            if (to != graph[v][0]) {
                head[to] = to;
            }
            prep(to, v);
        }
    }
    tout[v] = timer;
}

void prep0(int v) {
    int toc = -1;
    sz[v] = 1;
    for (int to : graph[v]) {
        prep0(to);
        sz[v] += sz[to];
        if (toc == -1 || sz[toc] > sz[to])
            toc = to;
    }
    if (toc != -1) {
        int ps = 0;
        while (graph[v][ps] != toc)
            ++ps;
        swap(graph[v][ps], graph[v][0]);
    }
}

void upd_path(int v, int fr, ll x) {
//    while (fr != v) {
//        can[fr] += x;
//        fr = p[fr];
//    }
//    can[v] += x;

    while (!ispar(head[fr], v)) {
        update(1, 0, n - 1, tin[head[fr]], tin[fr], x);
        fr = p[head[fr]];
    }
    if (tin[fr] > tin[v])
        swap(fr, v);
    update(1, 0,  n - 1, tin[fr], tin[v], x);
}

ll get_path(int v, int fr) {
    ll res = 1e18;
    while (fr != v) {
        relax(res, get(1, 0, n - 1, tin[fr], tin[fr]));
        fr = p[fr];
    }
    relax(res, get(1, 0, n - 1, tin[v], tin[v]));
    return res;
}

void dfs(int v) {
    for (int to : graph[v]) {
        dfs(to);
        now[v] += now[to];
        ans[v] += ans[to];
    }
    if (graph[v].empty()) {
        now[v] = l[v];
        ans[v] = l[v] * c[v];
        have[v].emplace(c[v], v);
        upd_path(v, v, r[v] - l[v]);
        res[v] = l[v];
//        tr.update(1, 0, n - 1, tin[v], tout[v] - 1, r[v] - now[v]);
        return;
    }


    if (now[v] > r[v]) {
        bad = 1;
        return;
    } else {
        have[v].emplace(c[v], v);
//        tr.update(1, 0, n - 1, tin[v], tout[v] - 1, r[v] - now[v]);
        upd_path(v, v, r[v] - now[v]);
    }

    int fst = graph[v][0];
    have[v].swap(have[fst]);
    for (int to : graph[v]) {
        while (!have[to].empty()) {
            auto [cost, fr] = *have[to].begin();
            have[to].erase(have[to].begin());
            have[v].emplace(cost, fr);
        }
    }
    while (now[v] < l[v] && !have[v].empty()) {
        auto [cost, fr] = *have[v].begin();
        have[v].erase(have[v].begin());
//        ll can = max(0LL, tr.get(1, 0, n - 1, tin[fr]));
        ll can = get_path(v, fr);
        ll need = l[v] - now[v];
        ll dt = 0;
        if (can > need) {
            have[v].emplace(cost, fr);
            ans[v] += need * cost;
            dt = need;
        } else {
            ans[v] += can * cost;
            dt = can;
        }
//        int x = fr;
//        while (x != v) {
//            now[x] += dt;
//            tr.update(1, 0, n - 1, tin[x], tout[x] - 1, r[x] - now[x]);
//            x = p[x];
//        }
//        now[v] += dt;
//        tr.update(1, 0, n - 1, tin[v], tout[v] - 1, r[v] - now[v]);
        res[fr] += dt;
        now[v] += dt;
        upd_path(v, fr, -dt);
    }
    if (now[v] < l[v]) {
        bad = 1;
        return;
    }
//    tr.update(1, 0, n - 1, tin[v], tout[v] - 1, r[v] - now[v]);
}

void solve() {
    cin >> n;
    for (int i = 1; i < n; ++i) {
        int par;
        cin >> par;
        --par;
        graph[par].emplace_back(i);
    }
    for (int i = 0; i < n; ++i)
        cin >> c[i];
    for (int i = 0; i < n; ++i)
        cin >> l[i] >> r[i];
    prep0(0);
    head[0] = 0;
    prep(0, 0);
    dfs(0);
    if (bad) {
        cout << "-1\n";
    } else {
        cout << ans[0] << '\n';
        for (int i = 0; i < n; ++i)
            cout << res[i] << ' ';
        cout << '\n';
    }
    // CLEAR MULTITEST
    bad = 0;
    timer = 0;
    for (int i = 0; i < n; ++i) {
        have[i].clear();
        graph[i].clear();
        tin[i] = tout[i] = p[i] = sz[i] = head[i] = 0;
        ans[i] = now[i] = c[i] = l[i] = r[i] = res[i] = 0;
    }
    for (int i = 0; i < 4 * n; ++i) {
        tree[i] = lazy[i] = 0;
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);

    int t = 1;
    cin >> t;
    while (t--)
        solve();
    return 0;
}




