#pragma GCC optimize("Ofast")
//#pragma GCC target("avx2,sse4,popcnt")

#include <bits/stdc++.h>

#define sq(x) ((x)*(x))
#define err(x) cerr << "["#x"]  " << (x) << "\n"
#define errv(x) {cerr << "["#x"]  ["; for (const auto& i : (x)) cerr << (i) << ", "; cerr << "]\n";}
#define errvn(x, n) {cerr << "["#x"]  ["; for (int i = 0; i < (n); ++i) cerr << (x)[i] << ", "; cerr << "]\n";}
#define errf() cerr << "\n\n"

using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
inline ll getrnd(ll l, ll r) {
    return uniform_int_distribution<ll>(l, r)(rng);
}

template <typename T1, typename T2>
inline bool relax(T1& a, const T2& b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

template <typename T1, typename T2>
inline bool strain(T1& a, const T2& b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

// ::::::::::::::::::::::::::::::::::

const int N = 1e5 + 5;

struct seg_tree {
    vector<int> mx;
    seg_tree(int n) : mx(4 * n, 2e9) {}

    void update(int v, int tl, int tr, int l, int r, int x) {
        if (l > r) return;
        if (tl == l && tr == r) {
            relax(mx[v], x);
        } else {
            int tm = (tl + tr) / 2;
            update(2 * v, tl, tm, l, min(r, tm), x);
            update(2 * v + 1, tm + 1, tr, max(l, tm + 1), r, x);
        }
    }

    int get(int v, int tl, int tr, int pos) {
        if (tl == tr) {
            return mx[v];
        }
        int tm = (tl + tr) / 2;
        if (pos <= tm)
            return min(mx[v], get(2 * v, tl, tm, pos));
        else
            return min(mx[v], get(2 * v + 1, tm + 1, tr, pos));
    }
};

int n, bad = 0, timer = 0;
int tin[N], tout[N];
ll ans[N], c[N], l[N], r[N], now[N], mxcan[N], res[N];
vector<int> graph[N];
set<tuple<int, int, int>> have[N];

void prep(int v) {
    tin[v] = timer++;
    for (int to : graph[v]) {
        prep(to);
    }
    tout[v] = timer;
}

void dfs(int v, seg_tree& tr) {
    int toc = -1;
    for (int to : graph[v]) {
        dfs(to, tr);
        now[v] += now[to];
        ans[v] += ans[to];
        if (toc == -1 || have[toc].size() > have[to].size())
            toc = to;
    }
    if (toc == -1) {
        now[v] = l[v];
        ans[v] = l[v] * c[v];
        have[v].emplace(c[v], r[v] - l[v], v);
        res[v] = l[v];
        mxcan[v] = r[v] - l[v];
        tr.update(1, 0, n - 1, tin[v], tout[v] - 1, r[v] - now[v]);
        return;
    }

    if (now[v] > r[v]) {
        bad = 1;
        return;
    } else {
        have[v].emplace(c[v], r[v] - now[v], v);
        mxcan[v] = r[v] - now[v];
//        tr.update(1, 0, n - 1, tin[v], tout[v] - 1, r[v] - now[v]);
    }

    for (int to : graph[v]) {
        while (!have[to].empty()) {
            auto [cost, can, fr] = *have[to].begin();
            have[to].erase(have[to].begin());
            have[v].emplace(cost, min((ll)can, mxcan[v]), fr);
        }
    }
    while (now[v] < l[v]) {
        auto [cost, can, fr] = *have[v].begin();
        have[v].erase(have[v].begin());
        can = tr.get(1, 0, n - 1, tin[fr]);
        ll need = l[v] - now[v];
        if (can > need) {
            have[v].emplace(cost, can - need, fr);
            now[v] += need;
            ans[v] += need * cost;
            res[fr] += need;
        } else {
            now[v] += can;
            ans[v] += can * cost;
            res[fr] += can;
        }
    }
    tr.update(1, 0, n - 1, tin[v], tout[v] - 1, r[v] - now[v]);
}

void solve() {
    cin >> n;
    for (int i = 1; i < n; ++i) {
        int par;
        cin >> par;
        --par;
        graph[par].emplace_back(i);
    }
    for (int i = 0; i < n; ++i)
        cin >> c[i];
    for (int i = 0; i < n; ++i)
        cin >> l[i] >> r[i];
    seg_tree tr(n);
    prep(0);
    dfs(0, tr);
    if (bad) {
        cout << "-1\n";
    } else {
        cout << ans[0] << '\n';
        for (int i = 0; i < n; ++i)
            cout << res[i] << ' ';
        cout << '\n';
    }
    // CLEAR MULTITEST
    bad = 0;
    timer = 0;
    for (int i = 0; i < n; ++i) {
        have[i].clear();
        graph[i].clear();
        tin[i] = tout[i] = 0;
        ans[i] = res[i] = now[i] = c[i] = l[i] = r[i] = mxcan[i] = 0;
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);

    int t = 1;
    cin >> t;
    while (t--)
        solve();
    return 0;
}

