#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second
#define all(x) (x).begin(), (x).end()
#define pb emplace_back
#define ld long double
#define ll long long
#define mp make_pair
#define pii pair<int, int>

const int INF = 1e9 + 1;

vector<vector<int>> g;
vector<int> cost;

vector<int> order;
vector<int> pos;
vector<pii> t;
vector<int> tin, tout, depth;
vector<int> sz;

int timer = 0;

void dfs(int v) {
    pos[v] = order.size();
    tin[v] = order.size();
    sz[v] = 1;
    order.pb(v);
    for (auto &to : g[v]) {
        dfs(to);
        sz[v] += sz[to];
    }
    tout[v] = order.size();
}

void build(int v, int vl, int vr) {
    if (vr - vl == 1) {
        t[v] = mp(cost[order[vl]], order[vl]);
        return;
    }
    int vm = (vl + vr) / 2;
    build(2 * v + 1, vl, vm);
    build(2 * v + 2, vm, vr);
    t[v] = min(t[2 * v + 1], t[2 * v + 2]);
}

void mod(int v, int vl, int vr, int id) {
    if (vr - vl == 1) {
        t[v] = mp(INF, -1);
        return;
    }
    int vm = (vl + vr) / 2;
    if (id < vm) mod(2 * v + 1, vl, vm, id);
    else mod(2 * v + 2, vm, vr, id);
    t[v] = min(t[2 * v + 1], t[2 * v + 2]);
}

pii get(int v, int vl, int vr, int l, int r) {
    if (vl >= l && vr <= r) return t[v];
    if (r <= vl || l >= vr) return mp(INF, -1);
    int vm = (vl + vr) / 2;
    return min(get(2 * v + 1, vl, vm, l, r), get(2 * v + 2, vm, vr, l, r));
}

vector<int> order1, pos1, f;
vector<int> p;

void dfs1(int v) {
    pos1[v] = order1.size();
    order1.pb(v);
    int mx = -1;
    for (auto &to : g[v]) {
        if (mx == -1 || sz[to] > sz[mx]) mx = to;
    }
    if (mx == -1) return;
    f[mx] = f[v];
    dfs1(mx);
    for (auto &to : g[v]) {
        if (to == mx) continue;
        f[to] = to;
        dfs1(to);
    }
}

vector<int> t1, tadd1;

void build1(int v, int vl, int vr, vector<int> &a) {
    if (vr - vl == 1) {
        t1[v] = a[order1[vl]];
        return;
    }
    int vm = (vl + vr) / 2;
    build1(2 * v + 1, vl, vm, a);
    build1(2 * v + 2, vm, vr, a);
    t1[v] = min(t1[2 * v + 1], t1[2 * v + 2]);
}

void push(int v) {
    tadd1[2 * v + 1] += tadd1[v];
    tadd1[2 * v + 2] += tadd1[v];
    t1[2 * v + 1] += tadd1[v];
    t1[2 * v + 2] += tadd1[v];
    tadd1[v] = 0;
}

int get1(int v, int vl, int vr, int l, int r) {
    if (vl >= l && vr <= r) return t1[v];
    if (r <= vl || l >= vr) return INF;
    push(v);
    int vm = (vl + vr) / 2;
    return min(get1(2 * v + 1, vl, vm, l, r), get1(2 * v + 2, vm, vr, l, r));
}

void mod1(int v, int vl, int vr, int l, int r, int d) {
    if (vl >= l && vr <= r) {
        tadd1[v] += d;
        t1[v] += d;
        return;
    }
    if (r <= vl || l >= vr) return;
    push(v);
    int vm = (vl + vr) / 2;
    mod1(2 * v + 1, vl, vm, l, r, d);
    mod1(2 * v + 2, vm, vr, l, r, d);
    t1[v] = min(t1[2 * v + 1], t1[2 * v + 2]);
}

int ask(int v) {
    int n = p.size();
    int ans = INF;
    while (v != -1) {
        int p1 = pos1[v];
        int p2 = pos1[f[v]];
        ans = min(ans, get1(0, 0, n, p2, p1 + 1));
        v = p[f[v]];
    }
    return ans;
}

void incr(int v, int d) {
    int n = p.size();
    while (v != -1) {
        int p1 = pos1[v];
        int p2 = pos1[f[v]];
        mod1(0, 0, n, p2, p1 + 1, d);
        v = p[f[v]];
    }
}

void solve() {
    int n;
    cin >> n;
    p.assign(n, -1);
    depth.assign(n, 0);
    g.clear();
    g.resize(n);
    tin.clear();
    tin.resize(n);
    tout.clear();
    tout.resize(n);
    order.clear();
    pos.clear();
    pos.resize(n);
    sz.assign(n, 0);
    f.assign(n, 0);
    order1.clear();
    pos1.assign(n, 0);
    for (int i = 1; i < n; i++) {
        cin >> p[i];
        p[i]--;
        g[p[i]].pb(i);
        depth[i] = depth[p[i]] + 1;
    }
    cost.resize(n);
    for (auto &c : cost) cin >> c;
    dfs(0);
    t.clear();
    t.resize(4 * n);
    build(0, 0, n);
    vector<int> l(n), r(n);
    for (int i = 0; i < n; i++) cin >> l[i] >> r[i];
    dfs1(0);
    t1.clear();
    t1.resize(4 * n);
    tadd1.assign(4 * n, 0);
    build1(0, 0, n, r);
    vector<pii> d(n);
    for (int i = 0; i < n; i++) d[i] = mp(depth[i], i);
    sort(all(d));
    reverse(all(d));
    vector<int> cur(n);
    ll ans = 0;
    vector<int> take(n);
    for (auto &c : d) {
        int v = c.se;
        while (1) {
            int cur = r[v] - get1(0, 0, n, pos1[v], pos1[v] + 1);
            if (cur == l[v]) break;
            int u = -1, cntop = INF;
            while (1) {
                u = get(0, 0, n, tin[v], tout[v]).se;
                if (u == -1) break;
                cntop = ask(u);
                if (cntop == 0) {
                    mod(0, 0, n, pos[u]);
                    continue;
                }
                break;
            }
            if (u == -1) {
                cout << -1 << "\n";
                return;
            }
            cntop = min(cntop, l[v] - cur);
            ans += (ll)cost[u] * cntop;
            take[u] += cntop;
            incr(u, -cntop);
        }
    }
    cout << ans << "\n";
    for (auto &c : take) cout << c << " ";
    cout << "\n";
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--) solve();
    return 0;
}
