#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <random>
#include <sstream>
#include <assert.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define input(a) do { for (auto& e : a) cin >> e; } while(0);
#define print(a) do {cerr << #a << ": "; for (auto& e : a) cerr << e << " "; cerr << "\n";} while(0);

mt19937_64 rnd(1231);

struct v {
	ll l;
	ll r;
	ll c;
};

vector<vector<int>> graph;
vector<v> arr;

vector<v> mins;

bool dfsMins(int v) {
	mins[v].l = arr[v].l;
	mins[v].r = arr[v].r;
	for (auto& other : graph[v]) {
		if (!dfsMins(other))
			return false;
	}
	if (!graph[v].empty()) {
		ll totall = 0;
		ll totalr = 0;
		for (auto& other : graph[v]) {
			totall += mins[other].l;
			totalr += mins[other].r;
		}
		mins[v].l = max(mins[v].l, totall);
		mins[v].r = min(mins[v].r, totalr);
	}
	return mins[v].l <= mins[v].r;
}

ll ans = 0;

vector<int> cntBuy;
//lowest id  cntused
pair<pair<ll, int>, ll> dfsAns(int v) {
	ll cnthas = 0;
	ll lowest = arr[v].c;
	int bid = v;
	for (auto& other : graph[v]) {
		auto [p, cnt] = dfsAns(other);
		auto [cost, id] = p;
		cnthas += cnt;
		if (lowest > cost) {
			lowest = cost;
			bid = id;
		}
	}
	if (cnthas >= mins[v].l)
		return {{lowest, bid}, cnthas};
	cntBuy[bid] += mins[v].l - cnthas;
	ans += lowest * (mins[v].l - cnthas);
	return {{lowest, bid}, mins[v].l};
}

void solve() {
	int n;
	cin >> n;
	graph = vector<vector<int>>(n);
	arr = vector<v>(n);
	mins = vector<v>(n);
	for (int i = 1; i < n; i++) {
		int p;
		cin >> p;
		p--;
		graph[p].push_back(i);
	}
	for (auto& e : arr)
		cin >> e.c;
	for (auto& e : arr)
		cin >> e.l >> e.r;
	if (!dfsMins(0)) {
		cout << "-1\n";
		return;
	}

	cntBuy = vector<int>(n);
	ans = 0;
	dfsAns(0);
	cout << ans << "\n";
	for (auto& e : cntBuy)
		cout << e << " ";
	cout << "\n";
	return;
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);

	int t;
	cin >> t;
	while (t--)
		solve();
}