#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <random>
#include <sstream>
#include <assert.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define input(a) do { for (auto& e : a) cin >> e; } while(0);
#define print(a) do {cerr << #a << ": "; for (auto& e : a) cerr << e << " "; cerr << "\n";} while(0);

#define int ld

mt19937_64 rnd(1231);

struct v {
	ll l;
	ll r;
	ll c;
};

vector<vector<int>> graph;
vector<v> arr;

class comp {
public:
	bool operator()(int a, int b) const {
		return arr[a].c < arr[b].c;
	}
};


vector<int> cntBuy;
//    vertex(sorted by c) cost       
vector<map<int, int, comp>> toBuy; // TODO: rewrite to merge (+15)
vector<int> mapPointers;
// returns map pointer + cntBuy
pair<int, int> dfsAns(int v) {
	toBuy[mapPointers[v]][v] += 2e9;
	vector<int> chPoint(1, mapPointers[v]);
	ll chBuy = 0;
	for (auto& other : graph[v]) {
		auto [p, cnt] = dfsAns(other);
		if (p == -1)
			return {-1, -1};
		chPoint.push_back(p);
		chBuy += cnt;
	}
	if (chBuy > arr[v].r)
		return {-1, -1};
	sort(chPoint.begin(), chPoint.end(), [](int a, int b) {
		return toBuy[a].size() > toBuy[b].size();
	});
	auto& m = toBuy[chPoint[0]];
	for (int i = 1; i < chPoint.size(); i++) {
		for (auto& [a, b] : toBuy[chPoint[i]])
			m[a] = b;
	}
	if (chBuy < arr[v].l) {
		int toBuy = arr[v].l - chBuy;
		while (toBuy > 0 && !m.empty()) {
			auto [at, cnt] = *m.begin();
			m.erase(m.begin());
			if (arr[at].c > arr[v].c)
				break;
			int nowBuy = min(toBuy, cnt);
			cnt -= nowBuy;
			toBuy -= nowBuy;
			cntBuy[at] += nowBuy;
			if (cnt != 0) {
				m[at] = cnt;
				break;
			}
		}
		chBuy = arr[v].l;
	}
	int free = arr[v].r - chBuy;
	map<int, int, comp> newMap;

	for (auto& [at, cnt] : m) {
		if (cnt <= free) {
			free -= cnt;
			newMap[at] = cnt;
		}
		else {
			if (free == 0)
				break;
			newMap[at] = free;
			break;
		}
	}
	swap(toBuy[chPoint[0]], newMap);
	return {chPoint[0], chBuy};
}

void solve() {
	int n;
	cin >> n;
	graph = vector<vector<int>>(n);
	arr = vector<v>(n);
	for (int i = 1; i < n; i++) {
		int p;
		cin >> p;
		p--;
		graph[p].push_back(i);
	}
	for (auto& e : arr)
		cin >> e.c;
	for (auto& e : arr)
		cin >> e.l >> e.r;

	cntBuy = vector<int>(n);
	toBuy = vector<map<int, int, comp>>(n);
	mapPointers = vector<int>(n);
	iota(mapPointers.begin(), mapPointers.end(), 0);

	auto [a, b] = dfsAns(0);
	if (a == -1) {
		cout << "-1\n";
	}
	else {
		ll ans = 0;
		for (int i = 0; i < n; i++) {
			ans += arr[i].c * cntBuy[i];
		}

		cout << ans << "\n";
		for (auto& e : cntBuy)
			cout << e << " ";
		cout << "\n";
	}
}

signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int t;
	cin >> t;
	while (t--)
		solve();
}