#include <bits/stdc++.h>

#define int long long

using namespace std;

int n;
vector <vector <int>> fenwick;

int query(int idx, int x)
{
    int res = 0;
    for (int i = idx; i > 0; i -= (i & (-i))) {
        res += lower_bound(fenwick[i].begin(), fenwick[i].end(), x) - fenwick[i].begin();
    }
    return res;
}

void update(int idx, int x)
{
    for (int i = idx; i <= n; i += (i & (-i)))
        fenwick[i].push_back(x);
}

signed main()
{
    cin >> n;
    vector <int> arr(n);
    for (auto& i: arr)
        cin >> i;

    fenwick.resize(n + 1);
    for (int i = 0; i < n; ++i)
        update(i + 1, arr[i]);

    for (int i = 1; i <= n; ++i)
        sort(fenwick[i].begin(), fenwick[i].end());

    int ans = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            int res = abs(arr[j] - arr[i]);

            int d = j - i;
            res = max(res, d + (i - query(i, arr[i] + 1)));
            res = max(res, d + (arr[j] - 1 - query(j, arr[j] + 1)));

            ans += res;
        }
    }

    cout << ans << "\n";
}
