#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <stack>
#include <deque>

using namespace std;

class st {
private:
	vector <int> d;
	int n;
	void add(int ind, int l, int r, int i) {
		++d[ind];
		if (l == r)
			return;
		int mid = (l + r) / 2;
		if (mid >= i)
			add(2 * ind + 1, l, mid, i);
		else
			add(2 * ind + 2, mid + 1, r, i);
	}
	int sum(int ind, int l, int r, int nl, int nr) {
		if (nl == l && nr == r)
			return d[ind];
		int mid = (nl + nr) / 2;
		if (mid >= r)
			return sum(ind * 2 + 1, l, r, nl, mid);
		else if (mid < l)
			return sum(2 * ind + 2, l, r, mid + 1, nr);
		return sum(2 * ind + 1, l, mid, nl, mid) + sum(2 * ind + 2, mid + 1, r, mid + 1, nr);
	}
public:
	st(int _n = 0) {
		n = _n;
		d.resize(4 * n);
	}
	void init(int _n = 0) {
		n = _n;
		d.assign(4 * n, 0);
	}
	void add(int i) {
		add(0, 0, n - 1, i);
	}
	int sum(int l, int r) {
		return sum(0, l, r, 0, n - 1);
	}
};

vector <int> p1, minpos, maxpos;

vector <vector <int>> maxdist;

int n;

int main() {
	cin >> n;
	p1.resize(n);
	minpos.resize(n);
	maxpos.resize(n);
	maxdist.assign(n, vector <int>(n));
	for (int i = 0; i < n; ++i)
		cin >> p1[i];
	st sst(n);
	for (int i = 0; i < n; ++i) {
		minpos[i] = sst.sum(0, p1[i] - 1);
		sst.add(p1[i] - 1);
	}
	sst.init(n);
	for (int i = n - 1; i >= 0; --i) {
		maxpos[i] = n - 1 - sst.sum(p1[i] - 1, n - 1);
		sst.add(p1[i] - 1);
	}
	long long answer = 0;
	int maxdistnow;
	for (int i = 0; i < n; ++i) {
		for (int j = i + 1; j < n; ++j) {
			maxdistnow = abs(p1[i] - p1[j]);
			maxdistnow = max(maxdistnow, j - minpos[i]);
			maxdistnow = max(maxdistnow, maxpos[j] - i);
			answer += maxdistnow;
		}
	}
	cout << answer;

}
