#include <bits/stdc++.h>

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

#define int long long

using namespace std;

const int N = 1e5 + 228;
const int inf = 1e18 + 228;

vector<int> G[N];
pair<int, int> mx[N];

int cost[N];
int par[N];
long long ans;
bool bad_ans = false;
int sz[N];

int timer = 0;
int tin[N], tout[N];
int lst[N];
int cnt[N];
int _who[N];

struct SegTree1 {
	vector<pair<int, int>> t;
	int n;

	void build(int v, int l, int r, vector<int> &a) {
		if (r - l == 1) {
			t[v] = {a[l], l};
			return;
		}

		int m = (l + r) / 2;
		build(v * 2 + 1, l, m, a);
		build(v * 2, m, r, a);
		t[v] = min(t[v * 2 + 1], t[v * 2]);
	}

	void update(int v, int l, int r, int pos) {
		if (r - l == 1) {
			t[v] = {inf, -1};
			return;
		}

		int m = (l + r) / 2;
		if (pos < m)
			update(v * 2 + 1, l, m, pos);
		else
			update(v * 2, m, r, pos);
		t[v] = min(t[v * 2 + 1], t[v * 2]);
	}

	void update(int pos) {
		update(1, 0, n, pos);
	}

	SegTree1(vector<int> a) {
		n = a.size();
		int sz = 1;
		while (sz < 2 * n)
			sz *= 2;
		t.resize(sz);
		build(1, 0, n, a);
	}

	pair<int, int> get(int v, int l, int r, int L, int R) {
		if (R <= l || r <= L)
			return {inf, -1};
		if (L <= l && r <= R)
			return t[v];
		int m = (l + r) / 2;
		return min(get(v * 2 + 1, l, m, L, R), get(v * 2, m, r, L, R));
	}

	pair<int, int> get(int l, int r) {
		return get(1, 0, n, l, r);
	}
};

struct SegTreeHld {
	vector<int> t;
	vector<int> mod;
	int n;

	void build(int v, int l, int r, vector<int> &a) {
		if (r - l == 1) {
			t[v] = a[l];
			return;
		}

		int m = (l + r) / 2;
		build(v * 2 + 1, l, m, a);
		build(v * 2, m, r, a);
		t[v] = min(t[v * 2 + 1], t[v * 2]);
	}

	void update(int v, int l, int r, int L, int R, int val) {
		if (R <= l || r <= L)
			return;
		if (L <= l && r <= R) {
			t[v] -= val;
			mod[v] -= val;
			return;
		}

		int m = (l + r) / 2;
		update(v * 2 + 1, l, m, L, R, val);
		update(v * 2, m, r, L, R, val);
		t[v] = min(t[v * 2 + 1], t[v * 2]) + mod[v];
	}

	void update(int l, int r, int val) {
		update(1, 0, n, l, r, val);
	}

	SegTreeHld(vector<int> a) {
		n = a.size();
		int sz = 1;
		while (sz < 2 * n)
			sz *= 2;
		t.resize(sz);
		mod.resize(sz);
		build(1, 0, n, a);
	}

	int get(int v, int l, int r, int L, int R) {
		if (R <= l || r <= L)
			return inf;
		if (L <= l && r <= R)
			return t[v];
		int m = (l + r) / 2;
		return min(get(v * 2 + 1, l, m, L, R), get(v * 2, m, r, L, R)) + mod[v];
	}

	int get(int l, int r) {
		return get(1, 0, n, l, r);
	}
};

// SegTree structs

int calc_min(int v, SegTreeHld &path) {
	int ans = path.get(tin[lst[v]], tin[v] + 1);
	if (lst[v] == 0)
		return ans;
	return min(ans, calc_min(par[lst[v]], path));
}

void update_min(int v, int val, SegTreeHld &path) {
	// cout << v << ' ' << val << ' ' << lst[v] << ' ' << par[lst[v]] << '\n';
	path.update(tin[lst[v]], tin[v] + 1, val);
	if (lst[v] == 0)
		return;
	update_min(par[lst[v]], val, path);
}

void dfs(int v, SegTreeHld &path, SegTree1 &t) {
	cnt[v] = 0;
	for (int i : G[v]) {
		dfs(i, path, t);
	}
	if (path.get(tin[v], tin[v] + 1) < 0) {
		bad_ans = 1;
		return;
	}
	// int it = 0;
	while (mx[v].second - path.get(tin[v], tin[v] + 1) < mx[v].first) {
		// ++it;
		// assert(it < 7);
		pair<int, int> z = t.get(tin[v], tout[v]);
		if (z.second == -1) {
			bad_ans = true;
			return;
		}
		int can = max(0ll, calc_min(z.second, path));
		int now = mx[v].second - path.get(tin[v], tin[v] + 1);
		// cout << "! " << v + 1 << ' ' << mx[v].first << ':' << now << ' ' << can << ' ' << _who[z.second] + 1 << '\n';
		ans += 1ll * z.first * min(can, mx[v].first - now);
		cnt[_who[z.second]] += min(can, mx[v].first - now);
		// cout << min(can, mx[v].first - now) << '\n';
		if (can == 0) {
			t.update(z.second);
		}
		update_min(_who[z.second], min(can, mx[v].first - now), path);
	}
}

void dfs_sz(int v) {
	sz[v] = 1;
	for (int i : G[v]) {
		dfs_sz(i);
		sz[v] += sz[i];
	}
}

void dfs_hld(int v) {
	tin[v] = timer++;
	for (int &i : G[v]) {
		if (sz[i] > sz[G[v][0]]) {
			swap(i, G[v][0]);
		}
	}
	if (G[v].size()) {
		lst[G[v][0]] = lst[v];
		dfs_hld(G[v][0]);
		for (int i : G[v]) {
			if (i != G[v][0]) {
				lst[i] = i;
				dfs_hld(i);
			}
		}
	}
	tout[v] = timer;
}

void solve() {
	int n;
	cin >> n;
	for (int i = 0; i < n; ++i) {
		G[i].clear();
	}
	fill(cnt, cnt + n, 0);
	ans = 0, bad_ans = 0;
	timer = 0;
	for (int i = 1; i < n; ++i) {
		cin >> par[i];
		--par[i];
		G[par[i]].push_back(i);
	}
	for (int i = 0; i < n; ++i) {
		cin >> cost[i];
	}
	for (int i = 0; i < n; ++i) {
		cin >> mx[i].first >> mx[i].second;
	}
	dfs_sz(0);
	dfs_hld(0);
	// for (int i = 0; i < n; ++i)
	// 	cout << tin[i] << ' ';
	// cout << '\n';

	vector<int> tmp1(n), tmp2(n);
	for (int i = 0; i < n; ++i) {
		_who[tin[i]] = i;
		tmp1[tin[i]] = mx[i].second, tmp2[tin[i]] = cost[i];
	}
	SegTreeHld path(tmp1);
	SegTree1 t(tmp2);

	dfs(0, path, t);
	if (bad_ans) {
		cout << -1 << '\n';
	} else {
		cout << ans << '\n';
		for (int i = 0; i < n; ++i)
			cout << cnt[i] << ' ';
		cout << '\n';
	}
}

signed main() {
	#ifndef LOCAL
		ios_base::sync_with_stdio(0);
		cin.tie(0);
	#endif

	int t;
	cin >> t;
	while (t--)
		solve();
}