#include <iostream>
#include <algorithm>

struct Offer {
    int32_t cost, num, ind;

    Offer(int32_t cost_, int32_t num_, int32_t ind_) {
        cost = cost_;
        num  =num_;
        ind = ind_;
    }

    bool operator<(Offer& other) {
        return cost < other.cost;
    }
};

void dfs(int32_t v, std::vector<int32_t>* children, std::pair<int32_t, int32_t>* bounds, bool& ok, int32_t* ans,
         std::vector<Offer>* offers, int32_t* costs) {
    for(int32_t i = 0; i < children[v].size(); i++) {
        dfs(children[v][i], children, bounds, ok, ans, offers, costs);
        if(!ok)
            return;
    }

    std::pair<int32_t, int32_t> bounds_cur = bounds[v];
    for(int32_t i = 0; i < children[v].size(); i++) {
        bounds_cur.first -= bounds[children[v][i]].first;
        bounds_cur.second -= bounds[children[v][i]].first;
    }
    if(bounds_cur.second < 0) {
        ok = false;
        return;
    }

    for(int32_t i = 0; i < children[v].size(); i++) {
        for(int32_t j = 0; j < offers[children[v][i]].size(); j++)
            offers[v].push_back(offers[children[v][i]][j]);
    }
    std::sort(offers[v].begin(), offers[v].end());

    while(bounds_cur.first > 0) {
        if(offers[v].empty() || offers[v][0].cost > costs[v]) {
            ans[v] += bounds[v].first;
            bounds_cur.first -= ans[v];
            bounds_cur.second -= ans[v];
        } else {
            //use the offer
            int32_t num_cur = std::min(bounds_cur.first, offers[v][0].num);
            bounds_cur.first -= num_cur;
            bounds_cur.second -= num_cur;
            ans[offers[v][0].ind] += num_cur;
            offers[v][0].num -= num_cur;
            if(offers[v][0].num == 0)
                offers[v].erase(offers[v].begin());
        }
    }
    offers[v].emplace_back(costs[v], bounds_cur.second, v);
    std::sort(offers[v].begin(), offers[v].end());

    int32_t total = 0;
    for(int32_t i = 0; i < offers[v].size(); i++) {
        total += offers[v][i].num;
        if(total > bounds_cur.second) {
            while(offers[v].size() > i + 1)
                offers[v].pop_back();
            offers[v].back().num -= (total - bounds_cur.second);
        }
    }
}

int main() {
    int32_t num_tests;
    std::cin >> num_tests;

    for(int32_t t = 0; t < num_tests; t++) {
        int32_t n;
        std::cin >> n;

        std::vector<int32_t>* children = new std::vector<int32_t>[n];
        for(int32_t i = 1; i < n; i++) {
            int32_t p;
            std::cin >> p;
            p--;

            children[p].push_back(i);
        }

        int32_t* cost = new int32_t[n];
        for(int32_t i = 0; i < n; i++)
            std::cin >> cost[i];

        std::pair<int32_t, int32_t>* borders = new std::pair<int32_t, int32_t>[n];
        for(int32_t i = 0; i < n; i++)
            std::cin >> borders[i].first >> borders[i].second;

        bool ok = true;
        int32_t* ans = new int32_t[n];
        for(int32_t i = 0; i < n; i++)
            ans[i] = 0;
        std::vector<Offer>* offers = new std::vector<Offer>[n];
        dfs(0, children, borders, ok, ans, offers, cost);

        if(!ok) {
            std::cout << -1 << "\n";
            continue;
        }

        int64_t ans_val = 0;
        for(int32_t i = 0; i < n; i++)
            ans_val += (int64_t)cost[i] * ans[i];
        std::cout << ans_val << "\n";
        for(int32_t i = 0; i < n; i++)
            std::cout << ans[i] << " ";
        std::cout << "\n";
    }
    return 0;
}
