#include <iostream>
#include <algorithm>
#include <set>

bool inside(std::pair<int32_t, int32_t> p, int32_t x1, int32_t y1, int32_t x2, int32_t y2) {
    return p.first >= x1 && p.first <= x2 && p.second >= y1 && p.second <= y2;
}

int64_t solve3(int32_t n, std::pair<int32_t, int32_t>* arr, int32_t x1, int32_t y1,int32_t x2, int32_t y2,
               bool* banned) {
    if(x1 == x2 || y1 == y2)
        return 0;

    int32_t lowest = -1;
    for(int32_t i = 0; i < n; i++)
        if(inside(arr[i], x1, y1, x2, y2) && !banned[i] && (lowest == -1 || arr[i].second < arr[lowest].second))
            lowest = i;
    if(lowest == -1)
        return 0;
    banned[lowest] = true;

    int32_t lowest2 = -1;
    for(int32_t i = 0; i < n; i++)
        if(!banned[i] && inside(arr[i], arr[lowest].first, arr[lowest].second, x2, y2) && (lowest2 == -1 || arr[i].second < arr[lowest2].second))
            lowest2 = i;
    int64_t res = (int64_t)(x2 - arr[lowest].first) * (y2 - arr[lowest].second) +
                  solve3(n, arr, x1, y1, arr[lowest].first, (lowest2 == -1 ? y2 : arr[lowest2].second), banned);
    if(lowest2 != -1)
        res += (int64_t)(arr[lowest].first - x1) * (y2 - arr[lowest2].second);

    lowest2 = -1;
    for(int32_t i = 0; i < n; i++)
        if(!banned[i] && inside(arr[i], x1, arr[lowest].second, arr[lowest].first, y2) && (lowest2 == -1 || arr[i].second < arr[lowest2].second))
            lowest2 = i;
    int64_t res2 = (int64_t)(arr[lowest].first - x1) * (y2 - arr[lowest].second) +
                   solve3(n, arr, arr[lowest].first, y1, x2, (lowest2 == -1 ? y2 : arr[lowest2].second), banned);
    if(lowest2 != -1)
        res2 += (int64_t)(x2 - arr[lowest2].first) * (y2 - arr[lowest2].second);

    return std::max(res, res2);
}

int64_t solve1(int32_t n, std::pair<int32_t, int32_t>* arr, int32_t w, int32_t h) {
    std::sort(arr, arr + n);

    int32_t top = h;
    int64_t ans = 0;
    for(int32_t i = 0; i < n; i++)
        if(arr[i].second < top) {
            ans += (int64_t)(w - arr[i].first) * (top - arr[i].second);
            top = arr[i].second;
        }
    return ans;
}

int main() {
    int32_t k;
    std::cin >> k;

    int32_t mask = 0;
    for(int32_t i = 0; i < k; i++) {
        int32_t x;
        std::cin >> x;

        mask |= 1 << (x - 1);
    }

    int32_t num_tests;
    std::cin >> num_tests;

    for(int32_t t = 0; t < num_tests; t++) {
        int32_t n, w, h;
        std::cin >> n >> w >> h;

        std::pair<int32_t, int32_t> *arr = new std::pair<int32_t, int32_t>[n];
        for (int32_t i = 0; i < n; i++)
            std::cin >> arr[i].first >> arr[i].second;

        if(mask == 1) {
            std::cout << solve1(n, arr, w, h);
        }
        if (mask == 3) {
            bool* banend = new bool[n];
            for(int32_t i = 0; i < n; i++)
                banend[i] = false;
            std::cout << solve3(n, arr, 0, 0, w, h, banend) << "\n";
        }
    }
    return 0;
}
