#include <bits/stdc++.h>

#define int long long

#define mp std::make_pair
using ll = long long;
using pii = std::pair<int, int>;
#define all(a) a.begin(), a.end()

template<class T, class T1>
bool mx(T &a, const T1 &b) {
    if (b > a) {
        a = b;
        return true;
    }
    return false;
}

template<class T, class T1>
bool mn(T &a, const T1 &b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}

const int INF = 0x3f3f3f3f;

const int MAXN = 1e5 + 228;

// <segment tree>
std::vector<pii> stree;
std::vector<int> pushed;

void makePush(int v, int ll, int rr) {
    stree[v].first += pushed[v];
    if (ll != rr) {
        pushed[2 * v] += pushed[v];
        pushed[2 * v + 1] += pushed[v];
    }
    pushed[v] = 0;
}

pii sget(int v, int l, int r, int ll, int rr) {
    makePush(v, ll, rr);
    if (rr < l || r < ll) return mp(INF, INF);
    if (l <= ll && rr <= r) return stree[v];
    int mid = (ll + rr) / 2;
    return std::min(sget(2 * v, l, r, ll, mid), sget(2 * v + 1, l, r, mid + 1, rr));
}

void upd(int v, int l, int r, int ll, int rr, int val) {
    makePush(v, ll, rr);
    if (rr < l || r < ll) return;
    if (l <= ll && rr <= r) {
        pushed[v] += val;
        makePush(v, ll, rr);
        return;
    }
    int mid = (ll + rr) / 2;
    upd(2 * v, l, r, ll, mid, val);
    upd(2 * v + 1, l, r, mid + 1, rr, val);
    stree[v] = std::min(stree[2 * v], stree[2 * v + 1]);
}
// </segment tree>

int n;
std::vector<int> g[MAXN];
int p[MAXN];
int c[MAXN];
int l[MAXN], r[MAXN];
int actual[MAXN];
bool del[MAXN];
int h[MAXN];

ll ans = 0;

// <hld>
int subSz[MAXN];
void startDfs(int v, int pred) {
    if (pred != -1) g[v].erase(std::find(all(g[v]), pred));
    subSz[v] = 1;
    for (auto &to : g[v]) {
        startDfs(to, v);
        subSz[v] += subSz[to];
        if (subSz[to] > subSz[g[v][0]]) {
            std::swap(g[v][0], to);
        }
    }
}

int timer = 0;
int tin[MAXN], jump[MAXN];
int bp[MAXN];
void dfs2(int v) {
    tin[v] = timer++;
    for (int i = 0; i < g[v].size(); i++) {
        if (i == 0) {
            jump[g[v][i]] = jump[v];
        }
        dfs2(g[v][i]);
    }
}

pii getMin(int u, int v) {
    // u -> v
    pii res = mp(INF, INF);
    do {
        int j = jump[u];
        if (h[j] > h[v]) {
            mn(res, sget(1, tin[j], tin[u], 0, n - 1));
        } else {
            mn(res, sget(1, tin[v], tin[u], 0, n - 1));
            break;
        }
        u = p[j];
    } while (u != -1 && h[u] >= h[v]);
    return res;
}

void upd(int u, int v, int val) {
    // u -> v
    do {
        int j = jump[u];
        if (h[j] > h[v]) {
            upd(1, tin[j], tin[u], 0, n - 1, val);
        } else {
            upd(1, tin[v], tin[u], 0, n - 1, val);
        }
        u = p[j];
    } while (u != -1 && h[u] >= h[v]);
}

pii getSub(int v) {
    return sget(1, tin[v], tin[v] + subSz[v] - 1, 0, n - 1);
}
// </hld>

void deleteVertex(int v, std::multiset<pii> &vals) {
    if (del[v]) return;
    del[v] = true;
    vals.erase(mp(c[v], v));
    upd(v, v, INF);
    for (auto &to: g[v]) {
        if (h[to] > h[v]) {
            deleteVertex(to, vals);
        }
    }
}

std::multiset<pii> calcAns(int v) { // (cost, v)
    std::multiset<pii> now;
    now.emplace(c[v], v);
    for (auto &to: g[v]) {
        h[to] = h[v] + 1;
        auto res = calcAns(to);
        if (res.size() > now.size()) std::swap(res, now);
        now.merge(res);
    }
    if (getMin(v, v).first <= 0) {
        deleteVertex(v, now);
    }
    while (!now.empty()) {
        int u = now.begin()->second;

        int need = getMin(v, v).first - r[v] + l[v];
        if (need <= 0) break;
        mn(need, getMin(u, v).first);

        if (need == 0) {
            assert(0);
        }

        u = now.begin()->second;
        actual[u] += need;
        ans += 1ll * c[u] * need;
        upd(u, 0, -need);
        while (true) {
            auto tmp = getSub(v);
            if (tmp.first <= 0) {
                deleteVertex(bp[tmp.second], now);
            } else break;
        }
    }
    return now;
}

void actualBuild(int v, int l, int r) {
    if (l == r) {
        stree[v] = mp(INF, l);
        return;
    }
    int mid = (l + r) / 2;
    actualBuild(2 * v, l, mid);
    actualBuild(2 * v + 1, mid + 1, r);
    stree[v] = std::min(stree[2 * v], stree[2 * v + 1]);
}

void initTree() {
    stree.assign(4 * n, mp(INF, INF));
    pushed.assign(4 * n, 0);
    actualBuild(1, 0, n - 1);
}

int taken[MAXN];
void calcTaken(int v) {
    taken[v] += actual[v];
    for (auto &to : g[v]) {
        calcTaken(to);
        taken[v] += taken[to];
    }
}

void solve() {
    std::cin >> n;
    timer = 0;
    for (int i = 0; i < n; i++) {
        g[i].clear();
        c[i] = l[i] = r[i] = del[i] = p[i] = h[i] = actual[i] = tin[i] = taken[i] = bp[i] = 0;
        jump[i] = i;
    }
    initTree();
    p[0] = -1;
    ans = 0;
    for (int i = 1; i < n; i++) {
        std::cin >> p[i];
        p[i]--;
        g[i].push_back(p[i]);
        g[p[i]].push_back(i);
    }
    startDfs(0, -1);
    dfs2(0);
    for (int i = 0; i < n; i++) {
        bp[tin[i]] = i;
    }

    for (int i = 0; i < n; i++) {
        std::cin >> c[i];
    }
    for (int i = 0; i < n; i++) {
        std::cin >> l[i] >> r[i];
    }

    for (int i = 0; i < n; i++) {
        upd(1, tin[i], tin[i], 0, n - 1, -INF + r[i]);
    }

    calcAns(0);
    calcTaken(0);
    for (int i = 0; i < n; i++) {
        if (taken[i] < l[i] || taken[i] > r[i]) {
            std::cout << -1 << '\n';
            return;
        }
    }
    std::cout << ans << '\n';
    for (int i = 0; i < n; i++) {
        std::cout << actual[i] << ' ';
    }
    std::cout << '\n';
}

signed main() {
    int TESTS = 1;
    std::cin >> TESTS;
    while (TESTS--) {
        solve();
    }
}
