#pragma GCC optimize("O3,unroll-loops,rename-register,rename-registers,fast-math")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4.1,sse4.2,avx,avx2")

#include <bits/stdc++.h>

#define mp std::make_pair
using ll = long long;
using pii = std::pair<int, int>;
#define all(a) a.begin(), a.end()

template<class T, class T1>
bool mx(T &a, const T1 &b) {
    if (b > a) {
        a = b;
        return true;
    }
    return false;
}

template<class T, class T1>
bool mn(T &a, const T1 &b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}

const int MAXN = 1e5 + 228;
int a[MAXN];

struct node {
    int sum;
    node *l, *r;

    node() : sum(0), l(nullptr), r(nullptr) {}
};

node *build(int ll, int rr) {
    if (ll == rr) return new node();
    int mid = (ll + rr) / 2;
    node *res = new node();
    res->l = build(ll, mid), res->r = build(mid + 1, rr);
    return res;
}

node *upd(node *root, int pos, int ll, int rr) {
    if (ll == rr) {
        auto res = new node();
        res->sum = 1;
        return res;
    }
    int mid = (ll + rr) / 2;
    auto res = new node();
    if (pos <= mid) {
        res->r = root->r;
        res->l = upd(root->l, pos, ll, mid);
    } else {
        res->l = root->l;
        res->r = upd(root->r, pos, mid + 1, rr);
    }
    if (res->r) res->sum += res->r->sum;
    if (res->l) res->sum += res->l->sum;
    return res;
}

int get(node *root, int l, int r, int ll, int rr) {
    if (rr < l || r < ll) return 0;
    if (l <= ll && rr <= r) return root->sum;
    int mid = (ll + rr) / 2;
    return get(root->l, l, r, ll, mid) + get(root->r, l, r, mid + 1, rr);
}

int n;

std::vector<node *> versions;

int getColumn(int r, int time) {
    return r - get(versions[time], 0, r, 1, n);
}

int getTime(int r, int c) {
    if (r == c) {
        return 0;
    }
    int left = -1, right = n + 1;
    while (right - left > 1) {
        int mid = (left + right) / 2;
        if (getColumn(r, mid) < c) {
            right = mid;
        } else {
            left = mid;
        }
    }
    return left;
}

void solve() {
    std::cin >> n;
    versions.emplace_back(build(1, n));
    for (int i = 0; i < n; i++) {
        std::cin >> a[i];
        versions.emplace_back(upd(versions.back(), a[i], 1, n));
    }

    int q;
    std::cin >> q;
    while (q--) {
        int r1, c1, r2, c2;
        std::cin >> r1 >> c1 >> r2 >> c2;
        int t1 = getTime(r1, c1);
        int t2 = getTime(r2, c2);

        int l = 0, r = std::min(r1, r2) + 1;
        while (r - l > 1) {
            int mid = (l + r) / 2;
            int a1 = getColumn(mid, t1);
            int a2 = getColumn(mid, t2);
            if (a1 == a2) l = mid;
            else r = mid;
        }
        std::cout << l << ' ' << getColumn(l, t1) << '\n';
    }
}

signed main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);

    int TESTS = 1;
//    std::cin >> TESTS;
    while (TESTS--) {
        solve();
    }
}
