#include <bits/stdc++.h>

//#define int long long
#define all(x) x.begin(), x.end()

using namespace std;

const int MAXN = 100500;

vector<int> g[MAXN];
int ll[MAXN], rr[MAXN], cc[MAXN], res[MAXN];
int ans[MAXN];
bool flag = true;

struct DSU {
    vector<int> sz, pred, sm;
    vector<map<pair<int, int>, int>> ok;

    DSU(int n) {
        sz.resize(n, 1);
        sm.resize(n, 0);
        pred.resize(n);
        iota(all(pred), 0);
        ok.resize(n);
    }

    int root(int v) {
        while (v != pred[v]) {
            v = pred[v];
        }
        return v;
    }

    void unite(int u, int v) {
        u = root(u);
        v = root(v);
        if (u == v) {
            return;
        }
        if (sz[u] < sz[v]) {
            swap(u, v);
        }
        sz[u] += sz[v];
        pred[v] = u;
        for (auto el: ok[v]) {
            ok[u][el.first] += el.second;
            sm[u] += el.second;
        }
    }
};

void dfs(int v, DSU &dsu) {
    if (!flag) {
        return;
    }
    res[v] = 0;
    ans[v] = 0;
    for (int u: g[v]) {
        dfs(u, dsu);
        dsu.unite(u, v);
        res[v] += res[u];
    }
    if (res[v] > rr[v]) {
        flag = false;
        return;
    }
    int rv = dsu.root(v);
    dsu.ok[rv][{cc[v], v}] = rr[v] - res[v];
    dsu.sm[rv] += rr[v] - res[v];
    if (res[v] < ll[v]) {
        int val = ll[v] - res[v];
        vector<pair<int, int>> ban;
        for (auto &el: dsu.ok[rv]) {
            if (el.second >= val) {
                ans[el.first.second] += val;
                el.second -= val;
                if (el.second == 0) {
                    ban.push_back(el.first);
                }
                dsu.sm[rv] -= val;
                val = 0;
                break;
            } else {
                ans[el.first.second] += el.second;
                val -= el.second;
                dsu.sm[rv] -= el.second;
                ban.push_back(el.first);
                el.second = 0;
            }
        }
        if (val > 0) {
            flag = false;
            return;
        }
        for (auto el: ban) {
            dsu.ok[rv].erase(el);
        }
        res[v] = ll[v];
    }
    int mx = rr[v] - res[v];
    int smsm = dsu.sm[rv];
    if (smsm <= mx) {
        return;
    }
    int val = 0;
    while (!dsu.ok[rv].empty()) {
        auto now = *--dsu.ok[rv].end();
        if (smsm - (val + now.second) >= mx) {
            val += now.second;
            dsu.ok[rv].erase(--dsu.ok[rv].end());
        } else {
            int need = smsm - val - mx;
            (--dsu.ok[rv].end())->second -= need;
            val += need;
        }
        if (smsm - val == mx) {
            break;
        }
    }
    dsu.sm[rv] = mx;
}

void sol() {
    int n;
    cin >> n;
    flag = true;
    fill(g, g + n + 5, vector<int>());
    for (int i = 2; i <= n; i++) {
        int p;
        cin >> p;
        g[p].push_back(i);
    }
    for (int i = 1; i <= n; i++) {
        cin >> cc[i];
    }
    for (int i = 1; i <= n; i++) {
        cin >> ll[i] >> rr[i];
    }
    DSU dsu(n + 1);
    dfs(1, dsu);
    if (!flag) {
        cout << -1 << '\n';
        return;
    }
    long long hihi = 0;
    for (int v = 1; v <= n; v++) {
        hihi += ans[v] * (long long) cc[v];
    }
    cout << hihi << '\n';
    for (int v = 1; v <= n; v++) {
        cout << ans[v] << ' ';
    }
    cout << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        sol();
    }
}

/*
2
3
1 1
3 1 2
5 7
1 2
2 4
2
1
5 5
0 1
2 2

 */