#include <bits/stdc++.h>

#define F first
#define S second

using namespace std;
using ll = long long;
using vi = vector<int>;
using pi = pair<int, int>;

template<class T> bool ckmin(T& a, const T& b) { return b < a ? a = b, true : false; }
template<class T> bool ckmax(T& a, const T& b) { return a < b ? a = b, true : false; }

ll solve1(const int n, const int w, const int h, vector<int> x, vector<int> y) {
    vector<int> ord(n), st;
    iota(ord.begin(), ord.end(), 0);
    sort(ord.begin(), ord.end(), [&] (int i, int j) { return x[i] < x[j]; });

    int y0 = h;
    ll ans = 0;

    for (int i : ord) {
        if (y[i] >= y0) continue;
        ans += (ll) (y0 - y[i]) * (w - x[i]);
        y0 = y[i];
    }

    return ans;
}

/*
 * /---\    /---\
 * \    \--/    /
 *  \   Grib   /
 *   \ Filipov/
 *    \      /
 *     \    /
 *      \--/
 */

struct SegmentTreeMax {
    int n;
    vector<int> y;
    vector<int> t;

    SegmentTreeMax(int n, const vector<int>& y) : n(n), y(y), t(2*n) {
        iota(t.begin()+n, t.end(), 0);
        for (int i = n; i--; ) t[i] = get_min(t[2*i], t[2*i+1]);
    }

    int get_min(int i, int j) {
        if (i < 0 || j < 0) return max(i, j);
        return y[i] < y[j] ? i : j;
    }

    void change(int i, int x) {
        y[i] = x;
        for (i += n; i != 1; i >>= 1) t[i >> 1] = get_min(t[i], t[i^1]);
    }

    int query(int l, int r) {
        int ans = -1;
        for (l += n, r += n - 1; l <= r; l >>= 1, r >>= 1) {
            if ((l&1) == 1) ans = get_min(ans, t[l++]);
            if ((r&1) == 0) ans = get_min(ans, t[r--]);
        }
        return ans;
    }
};

ll solve23(const int n, const int w, const int h, vector<int> x, vector<int> y) {
    vector<int> ord(n), stl, str;
    iota(ord.begin(), ord.end(), 0);
    sort(ord.begin(), ord.end(), [&] (int i, int j) { return x[i] < x[j]; });

    vector<int> px = x, py = y;
    for (int i = 0; i < n; ++i) {
        x[i] = px[ord[i]];
        y[i] = py[ord[i]];
    }

    SegmentTreeMax sgt(n, y);

    auto sol = [&](int l, int r, int xl, int xr, int h, auto _sol) -> ll {
        if (r <= l || xl == xr) return 0;
        const int m = sgt.query(l, r);
        if (y[m] >= h) return 0;

        const int vl = lower_bound(x.begin(), x.end(), x[m]) - x.begin();
        const int vr = upper_bound(x.begin(), x.end(), x[m]) - x.begin();

        sgt.change(m, h);
        const int ir = sgt.query(vl, r);
        const int il = sgt.query(l, vr);
        const int yr = min(h, ir == -1 || ir == m ? h : y[ir]);
        const int yl = min(h, il == -1 || il == m ? h : y[il]);
        sgt.change(m, y[m]);

        const ll ansl = (ll)(h-yl)*(xr-xl) + (ll)(yl-y[m])*(x[m]-xl) + _sol(vr, r, x[m], xr, yl, _sol);
        const ll ansr = (ll)(h-yr)*(xr-xl) + (ll)(yr-y[m])*(xr-x[m]) + _sol(l, vl, xl, x[m], yr, _sol);


/*
        cout << "[" << l << ", " << r << ") ==> " << "[" << vl << ", " << vr << ")" << " ==> " << m 
            << ", h=" << h << ", x=[" << xl << ", " << xr << "]" << endl;

        cout << x[m] << ":" << y[m] << " --> " << yl << " " << yr << endl;
        cout << "... max " << ansl << " " << ansr << endl;
*/

        return max(ansl, ansr);
    };

    ll ans = sol(0, n, 0, w, h, sol);
    return ans;
}

ll solve456(const int n, const int w, const int h, vector<int> x, vector<int> y) {
    return 0;
}

ll solve78(const int n, const int w, const int h, vector<int> x, vector<int> y) {
    return 0;
}

ll solve9(const int n, const int w, const int h, vector<int> x, vector<int> y) {
    if (n >= 4) return (ll) w * h;
    
    ll ans = 0;

    vector<int> d(n);
    bool first = true;
    while (true) {
        bool ok = false;

        ll cur = 0;
        for (int msk = 1 << n; --msk; ) {
            ll mul = 1;
            
            int x1 = 0, y1 = 0, x2 = w, y2 = h;
            
            for (int j = 0; j < n; ++j) {
                if ((~msk >> j) & 1) continue;

                if (d[j] == 0) ckmax(x1, x[j]), ckmax(y1, y[j]);
                if (d[j] == 1) ckmax(x1, x[j]), ckmin(y2, y[j]);
                if (d[j] == 2) ckmin(x2, x[j]), ckmax(y1, y[j]);
                if (d[j] == 3) ckmin(x2, x[j]), ckmin(y2, y[j]);

                mul = -mul;
            }

            cur -= mul * max<ll>(y2 - y1, 0) * max<ll>(x2 - x1, 0);
        }

        ckmax(ans, cur);

        for (int i = 0; i < n; ++i) {

            d[i]++;
            if (d[i] == 4) {
                d[i] = 0;
            } else {
                ok = true;
                break;
            }
        }
        first = false;
        if (!ok) break;
    }

    return ans;
}

int main() {
    ios::sync_with_stdio(0); cin.tie(0);

    int k; cin >> k;
    vector<int> mode(5);
    while (k--) {
        int x; cin >> x;
        mode[x] = true;
    }

    int t; cin >> t;
    while (t--) {

        int n, w, h; cin >> n >> w >> h;
        vector<int> x(n), y(n);
        for (int i = 0; i < n; ++i) cin >> x[i] >> y[i];

        ll res = 0;
        if (mode[1] && mode[2] && mode[3] && mode[4]) {
            res = solve9(n, w, h, x, y);
        } else if (mode[1] && mode[2] && mode[3]) {
            res = solve78(n, w, h, x, y);
        } else if (mode[1] && mode[3]) {
            res = solve456(n, w, h, x, y);
        } else if (mode[1] && mode[2]) {
            res = solve23(n, w, h, x, y);
        } else if (mode[1]) {
            res = solve1(n, w, h, x, y);
        }

        cout << res << '\n';
    }
}