#include <iostream>
#include <vector>
#include <map>
#include <algorithm>

using namespace std;

struct point{
    long long x;
    long long y;
};

bool comp1(point a, point b){
    if(a.x == b.x){
        return a.y < b.y;
    }
    return a.x < b.x;
}

bool comp3(point a, point b){
    return a.y < b.y;
}

void solve1(){
    int n, w, h;
    cin >> n >> w >> h;
    vector<point> ladder;
    ladder.resize(n);
    for(int i = 0; i < n; ++i){
        cin >> ladder[i].x >> ladder[i].y;
    }
    sort(ladder.begin(), ladder.end(), comp1);
    vector<point> ladderbutbetter;
    for(point i : ladder){
        if(ladderbutbetter.size() == 0 || ladderbutbetter.back().y > i.y){
            ladderbutbetter.push_back(i);
        }
    }
    long long ans = 0;
    for(int i = 0; i < ladderbutbetter.size(); ++i){
        if(i == ladderbutbetter.size() - 1){
            ans += ((long long)(h - ladderbutbetter[i].y)) * (w - ladderbutbetter[i].x);
        }else{
            ans += ((long long)(h - ladderbutbetter[i].y)) * (ladderbutbetter[i+1].x - ladderbutbetter[i].x);
        }
    }
    cout << ans << '\n';
}

void solve3(){
    long long n, w, h;
    cin >> n >> w >> h;
    vector<point> points;
    points.resize(n);
    for(int i = 0; i < n; ++i){
        cin >> points[i].x >> points[i].y;
    }
    if(n == 1){
        cout << ((h-points[0].y)) * max(points[0].x, w-points[0].x) << '\n';
        return;
    }
    sort(points.begin(), points.end(), comp3);
    long long curans = 0;
    long long optans = 0;
    long long l = 0, r = w;
    for(int i = 0; i < n-1; ++i){
        if(points[i].x <= l ||points[i].x >= r){
            optans = max(optans, curans + (r-l)*(h-points[i].y));
            break;
        }
        if(points[i].y == points[i+1].y){
            optans = max(optans, curans + (r-l)*(h-points[i].y));
            break;
        }else if(points[i].x < points[i+1].x){
            //cout << curans + (r-points[i].x)*(points[i+1].y - points[i].y) + (h-points[i+1].y)*(r-l) << endl;
            optans = max(optans, curans + (r-points[i].x)*(points[i+1].y - points[i].y) + (h-points[i+1].y)*(r-l));
            curans += (points[i].x-l)*(h - points[i].y);
            l = points[i].x;
        }else{
            //cout << curans + (points[i].x-l)*(points[i+1].y - points[i].y) + (h-points[i+1].y)*(r-l) << endl;
            optans = max(optans, curans + (points[i].x-l)*(points[i+1].y - points[i].y) + (h-points[i+1].y)*(r-l));
            curans += (r-points[i].x)*(h - points[i].y);
            r = points[i].x;
        }
        //cout << curans << '\n';
    }
    optans = max(optans, curans);
    cout << optans << '\n';
}

void solve9(){
    int n, w, h;
    cin >> n >> w >> h;
    vector<point> p;
    p.resize(n);
    for(int i = 0; i < n; ++i){
        cin >> p[i].x >> p[i].y;
    }
    if(n > 3){
        cout << ((long long)w)*h << '\n';
    } else if(n == 1){
        cout << ((long long)max(p[0].x, w-p[0].x))*max(p[0].y, h-p[0].y) << '\n';
    } else if(n == 2){
        long long aans = 0;
        for(int nap1 = 1; nap1 <= 4; ++nap1){
            for(int nap2 = 1; nap2 <= 4; ++nap2){
                int u1, u2, d1, d2, l1, l2, r1, r2;
                if(nap1 == 1){
                    u1=h;
                    d1=p[0].y;
                    l1=p[0].x;
                    r1=w;
                }else if(nap1 == 2){
                    u1=h;
                    d1=p[0].y;
                    l1=0;
                    r1=p[0].x;
                }else if(nap1 == 3){
                    u1=p[0].y;
                    d1=0;
                    l1=0;
                    r1=p[0].x;
                }else{
                    u1=p[0].y;
                    d1=0;
                    l1=p[0].x;
                    r1=w;
                }
                if(nap2 == 1){
                    u2=h;
                    d2=p[1].y;
                    l2=p[1].x;
                    r2=w;
                }else if(nap2 == 2){
                    u2=h;
                    d2=p[1].y;
                    l2=0;
                    r2=p[1].x;
                }else if(nap2 == 3){
                    u2=p[1].y;
                    d2=0;
                    l2=0;
                    r2=p[1].x;
                }else{
                    u2=p[1].y;
                    d2=0;
                    l2=p[1].x;
                    r2=w;
                }
                long long ans = 0;
                ans += ((long long)(u1-d1))*(r1-l1)+((long long)(u2-d2))*(r2-l2);
                int ui = min(u1, u2), di = max(d1, d2), ri = min(r1, r2), li = max(l1, l2);
                ans -= max((long long)0, ((long long)(ui-di)))*max(0, (ri-li));
                aans = max(ans, aans);
            }
        }
        cout << aans << '\n';
    } else {
        long long aans = 0;
        for(int nap1 = 1; nap1 <= 4; ++nap1){
            for(int nap2 = 1; nap2 <= 4; ++nap2){
                for(int nap3 = 1; nap3 <= 4; ++nap3){
                    int u1, u2, d1, d2, l1, l2, r1, r2, u3, d3, r3, l3;
                    if(nap1 == 1){
                        u1=h;
                        d1=p[0].y;
                        l1=p[0].x;
                        r1=w;
                    }else if(nap1 == 2){
                        u1=h;
                        d1=p[0].y;
                        l1=0;
                        r1=p[0].x;
                    }else if(nap1 == 3){
                        u1=p[0].y;
                        d1=0;
                        l1=0;
                        r1=p[0].x;
                    }else{
                        u1=p[0].y;
                        d1=0;
                        l1=p[0].x;
                        r1=w;
                    }
                    if(nap2 == 1){
                        u2=h;
                        d2=p[1].y;
                        l2=p[1].x;
                        r2=w;
                    }else if(nap2 == 2){
                        u2=h;
                        d2=p[1].y;
                        l2=0;
                        r2=p[1].x;
                    }else if(nap2 == 3){
                        u2=p[1].y;
                        d2=0;
                        l2=0;
                        r2=p[1].x;
                    }else{
                        u2=p[1].y;
                        d2=0;
                        l2=p[1].x;
                        r2=w;
                    }
                    if(nap3 == 1){
                        u3=h;
                        d3=p[2].y;
                        l3=p[2].x;
                        r3=w;
                    }else if(nap3 == 2){
                        u3=h;
                        d3=p[2].y;
                        l3=0;
                        r3=p[2].x;
                    }else if(nap3 == 3){
                        u3=p[2].y;
                        d3=0;
                        l3=0;
                        r3=p[2].x;
                    }else{
                        u3=p[2].y;
                        d3=0;
                        l3=p[2].x;
                        r3=w;
                    }
                    long long ans = 0;
                    ans += ((long long)(u1-d1))*(r1-l1)+((long long)(u2-d2))*(r2-l2)+((long long)(u3-d3))*(r3-l3);
                    ans -= max((long long)0, ((long long)(min(u1, u2)-max(d1, d2))))*max(0, (min(r1, r2)-max(l1, l2)))+max((long long)0, ((long long)(min(u1, u3)-max(d1, d3))))*max(0, (min(r1, r3)-max(l1, l3)))+max((long long)0, ((long long)(min(u3, u2)-max(d3, d2))))*max(0, (min(r3, r2)-max(l3, l2)));
                    int ui = min(u3, min(u1, u2)), di = max(d1,max( d2, d3)), ri = min(r1, min(r2, r3)), li = max(l1, max(l2, l3));
                    ans += max((long long)0, ((long long)(ui-di)))*max(0, (ri-li));
                    aans = max(ans, aans);
                }
            }
        }
        cout << aans << '\n';
    }
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int k, t;
    cin >> k;
    vector<int> nap;
    nap.resize(k);
    for(int i = 0; i < k; ++i) cin >> nap[i];
    cin >> t;
    if(k == 4){
        for(int i = 0; i < t; ++i) solve9();
    }else if(k == 3){

    }else if(k == 2){
        if(nap.back() == 2){
            for(int i = 0; i < t; ++i) solve3();
        }else{

        }
    }else{
        for(int i = 0; i < t; ++i) solve1();
    }
}
