#include <bits/stdc++.h>

using namespace std;

const int MAXN = 3010 * 3010 + 10;
const int MAXK = 15;

using pii = pair<int, int>;
unordered_map<int, unordered_set<int>> g;
int timer = 0;
int a[MAXN], cmd[MAXN];
int up[MAXK][MAXN], tin[MAXN], tout[MAXN], height[MAXN];

inline int to_v(int r, int c) {
    return r * 3010 + c;
}

void dfs(int v, int prev) {
    up[0][v] = prev;
    for (int i = 1; i < MAXK; i++) {
        up[i][v] = up[i - 1][up[i - 1][v]];
    }

    height[v] = height[prev] + 1;
    tin[v] = timer++;

    for (int u : g[v]) {
        dfs(u, v);
    }

    tout[v] = timer++;
}

inline bool is_parent(int v, int u) {
    return tin[v] <= tin[u] && tout[u] <= tout[v];
}

int lca(int v, int u) {
    if (height[u] < height[v]) {
        swap(v, u);
    }

    if (is_parent(v, u)) {
        return v;
    }

    for (int i = MAXK - 1; i >= 0; i--) {
        int x = up[i][u];
        if (!is_parent(x, v)) {
            u = x;
        }
    }

    return up[0][u];
}

int32_t main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);

    int n;
    cin >> n;

    for (int i = 0; i < n; i++) {
        cin >> a[i];
        cmd[i] = 1;
    }

    for (int i = 0; i < n + 1; i++) {
        int r = 0, c = 0;
        for (int j = 0; j < n; j++) {
            g[to_v(r, c)].insert(to_v(r + 1, c + cmd[j]));
            //cerr << r << " " << c << " => " << r + 1 << " " << c + cmd[j] << "\n";
            r++;
            c += cmd[j];
        }

        //cerr << i << " " << a[i] << "\n";
        if (i != n) {
            cmd[a[i] - 1] = 0;
        }
    }

    dfs(to_v(0, 0), to_v(0, 0));

    int q;
    cin >> q;

    while (q--) {
        int r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;

        int v = lca(to_v(r1, c1), to_v(r2, c2));

        cout << (v / 3010) << " " << (v % 3010) << "\n";
    }

    return 0;
}