#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <map>
#include <set>
#include <random>
#include <ctime>
#include <unordered_map>
#include <unordered_set>

using namespace std;

using ll = long long;
using ld = long double;

struct Fen_tree {
	int n = 0;
	vector<int> t;

	Fen_tree(int n) : n(n), t(n, 0) {}

	inline void up(int pos, int x) {
		while (pos < n) {
			t[pos] += x;
			pos |= (pos + 1);
		}
	}

	inline int get(int pos) {
		int ans = 0;
		while (pos >= 0) {
			ans += t[pos];
			pos = (pos & (pos + 1)) - 1;
		}
		return ans;
	}

};
signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);
	int n;
	cin >> n;
	vector<int> p(n);
	for (int i = 0; i < n; ++i) {
		cin >> p[i];
		--p[i];
	}
	vector<int> cntl(n, 0), cntr(n, 0);
	Fen_tree tree(n);
	for (int i = 0; i < n; ++i) {
		cntl[i] = tree.get(n - 1) - tree.get(p[i]);
		tree.up(p[i], 1);
	}
	tree.t = vector<int>(n, 0);
	for (int i = n - 1; i >= 0; --i) {
		cntr[i] = tree.get(p[i] - 1);
		tree.up(p[i], 1);
	}
	ll ans = 0;
	for (int i = 0; i < n; ++i) {
		for (int j = i + 1; j < n; ++j) {
			int a1 = abs(p[i] - p[j]);
			int a2 = cntl[i] + j - i;
			int a3 = cntr[j] + j - i;
			ans += (ll)max({ a1, a2, a3 });
		}
	}
	cout << ans;
}