﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <fstream>
#include <string>
#include <map>
#include <set>
using namespace std;
using s64 = long long;
#define all(obj) obj.begin(), obj.end()

vector<int> p;
vector<s64> c;
vector<s64> l, r;
vector<vector<int>> g;

// dp[v] = ответ для поддерева v
// dp[a[v]] = min cost
struct state {
	s64 cost;
	vector<int> ch;
};
vector<vector<state>> dp;

void build(int v) {
	dp[v].resize(r[v] + 1);
	for (int i = 0; i <= r[v]; i++) {
		dp[v][i].cost = c[v] * i;
		dp[v][i].ch.resize(g[v].size());
	}

	for(int e = 0; e < g[v].size(); e++){
		int to = g[v][e];
		build(to);
		vector<state> ndp(r[v] + 1);
		for (int x = 0; x <= r[v]; x++) {
			if (!dp[v][x].ch.empty()) {
				for (int y = l[to]; y <= r[to] && x + y <= r[v]; y++) {
					if (ndp[x + y].ch.empty()) {
						ndp[x + y].cost = dp[v][x].cost + dp[to][y].cost;
						ndp[x + y].ch = dp[v][x].ch;
						ndp[x + y].ch[e] = y;
					}
					else if (ndp[x + y].cost > dp[v][x].cost + dp[to][y].cost) {
						ndp[x + y].cost = dp[v][x].cost + dp[to][y].cost;
						ndp[x + y].ch = dp[v][x].ch;
						ndp[x + y].ch[e] = y;
					}
				}
			}
		}
		dp[v] = move(ndp);
	}
}

bool ok;

vector<s64> a;
void restore(int v, s64 x) {
	if (!(l[v] <= x && x <= r[v])) {
		ok = false;
		return;
	}
	if (dp[v][x].ch.empty() && g[v].size()) {
		ok = false;
		return;
	}
	a[v] = x;
	for (int e = 0; e < g[v].size(); e++) {
		restore(g[v][e], dp[v][x].ch[e]);
		a[v] -= a[g[v][e]];
	}
}

void solve(istream& cin) {
	int n;
	{
		cin >> n;
		p.resize(n);
		g.assign(n, {});
		p[0] = -1;
		for (int i = 1; i < n; i++) {
			cin >> p[i];
			p[i]--;
			g[p[i]].push_back(i);
		}
		c.resize(n);
		for (int i = 0; i < n; i++) {
			cin >> c[i];
		}
		l.resize(n), r.resize(n);
		for (int i = 0; i < n; i++) {
			cin >> l[i] >> r[i];
		}
	}

	dp.clear();
	dp.resize(n);
	build(0);
	int best = l[0];
	for (int i = l[0]; i <= r[0]; i++) {
		if (!dp[0][0].ch.empty() && dp[0][best].cost > dp[0][i].cost) {
			best = i;
		}
	}

	a.assign(n, 0);
	ok = true;
	restore(0, best);

	if (ok) {
		cout << dp[0][best].cost << "\n";
		for (int i = 0; i < n; i++) {
			cout << a[i] << " ";
		}
		cout << "\n";
	}
	else {
		cout << "-1\n";
	}
}

int main() {
	//ifstream cin("input.txt");
	
	int t;
	cin >> t;
	while (t--) {
		solve(cin);
	}

	return 0;
}