﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <fstream>
#include <string>
#include <map>
#include <set>
#include <climits>
#include <random>
using namespace std;
using s64 = long long;
#define all(obj) obj.begin(), obj.end()

vector<int> dir_id;
int k;

void solve(istream& cin) {
	int n;
	s64 w, h;
	cin >> n >> w >> h;
	vector<s64> x(n), y(n);
	for (int i = 0; i < n; i++) {
		cin >> x[i] >> y[i];
		y[i] = h - y[i];
	}

	auto f = [&](vector<int> dir) {
		struct event {
			s64 x, y;
			bool up;
			bool open;
			bool operator < (const event& Rhs) const {
				if (x == Rhs.x) {
					return open > Rhs.open;
				}
				return x < Rhs.x;
			}
		};
		vector<event> evs;
		for (int i = 0; i < n; i++) {
			int left, top, right, bottom;
			if (dir_id[dir[i]] == 0) {
				evs.push_back({ x[i], y[i], true, true });
				evs.push_back({ w, y[i], true, false });
			}
			else if (dir_id[dir[i]] == 1) {
				evs.push_back({ 0, y[i], true, true });
				evs.push_back({ x[i], y[i], true, false });
			}
			else if (dir_id[dir[i]] == 2) {
				evs.push_back({ 0, y[i], false, true });
				evs.push_back({ x[i], y[i], false, false });
			}
			else {
				evs.push_back({ x[i], y[i], false, true });
				evs.push_back({ w, y[i], false, false });
			}
		}
		sort(all(evs));

		multiset<s64> upy, downy;
		s64 prev_x = -1;
		s64 area = 0;
		for (auto [x, y, up, open] : evs) {
			if (prev_x != x) {
				// calc area [prev_x, x)
				s64 z = 0;
				if (!upy.empty() && !downy.empty() && *upy.rbegin() >= *downy.begin()) {
					z = h;
				}
				else {
					if (!upy.empty()) {
						z += *upy.rbegin(); // +1?
					}
					if (!downy.empty()) {
						z += h - *downy.begin();
					}
				}

				area += z * (x - prev_x);
			}

			prev_x = x;

			if (open) {
				if (up) {
					upy.insert(y);
				}
				else {
					downy.insert(y);
				}
			}
			else {
				if (up) {
					upy.erase(upy.find(y));
				}
				else {
					downy.erase(downy.find(y));
				}
			}
		}
		return area;
	};

	s64 ans = 0;

	mt19937 rnd(42);
	
	for(int i = 0; i < 10; i++) {

		vector<int> dir(n);
		for (int i = 0; i < n; i++) {
			dir[i] = rnd() % k;
		}
		s64 old = f(dir);
		bool run = true;
		while (run) {
			run = false;
			//for (int i = 0; i < 100; i++) {
				//int p = rnd() % n;
			for(int p = 0; p < n; p++) {
				for (int j = 0; j < k; j++) {
					int tmp = dir[p];
					dir[p] = j;
					int cur = f(dir);
					if (cur > old) {
						old = cur;
						run = true;
					}
					else {
						dir[p] = tmp;
					}
				}
			}
		}

		ans = max(ans, old);
	}

	cout << ans << "\n";
}

int main() {
	//ifstream cin("input.txt");
	
	cin >> k;
	for(int j = 0; j < k; j++) {
		int i;
		cin >> i;
		i--;
		dir_id.push_back(i);
	}

	int t = 1;
	cin >> t;
	while (t--) {
		solve(cin);
	}

	return 0;
}