#include<algorithm>
#include<iostream>
#include<vector>
#include<cmath>

using namespace std;

struct BIT {
	vector<int> data;

	BIT(int n) : data(n, 0) {}

	void qadd(int ind, int val) {
		for (; ind < data.size(); ind += ind & -ind) {
			data[ind] += val;
		}
	}

	int pref(int ind) {
		int res = 0;
		for (; ind > 0; ind -= ind & -ind) {
			res += data[ind];
		}
		return res;
	}
};

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n; cin >> n;
	vector<int> a(n);
	for (int i = 0; i < n; ++i) { cin >> a[i]; }

	BIT bit(1 + n);
	vector<int> lb(n, 0);
	for (int i = 0; i < n; ++i) {
		bit.qadd(a[i], 1);
		lb[i] = i + 1 - bit.pref(a[i]);
	}
	bit = BIT(1 + n);
	vector<int> rl(n, 0);
	for (int i = n - 1; i >= 0; --i) {
		bit.qadd(a[i], 1);
		rl[i] = bit.pref(a[i] - 1);
	}

	long long res = 0;
	for (int i = 0; i < n; ++i) {
		for (int j = i + 1; j < n; ++j) {
			res += max({(int)abs(a[i] - a[j]), j - i + lb[i], j - i + rl[j]});
		}
	}
	cout << res << "\n";
}
