#include <iostream>
#include <algorithm>
#include <vector>
#include <bitset>
#include <array>
#include <string>
#include <cstring>
#include <cmath>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <chrono>
#include <random>
#define ar array
std::mt19937 rnd(503);
using namespace std;
typedef long long ll;
const int N = 3005;

struct fenw {
	vector<ll> f1, f2;
	int n;
	fenw(int n) : n(n) {
		f1.assign(n + 1, 0);
		f2 = f1;
	}
	void upd(vector<ll> &f, int p, ll x) {
		for (++p; p <= n; p += (p & -p)) {
			f[p] += x;
		}
	}
	void rng_upd(int l, int r, int x) {
		upd(f1, l, x), upd(f1, r, -x);
		upd(f2, l, ll(x) * l), upd(f2, r, ll(-x) * r);
	}
	ll sum(int p) {
		ll ans = 0;
		int p1 = p;
		for (; p; p -= (p & -p)) {
			ans += f1[p] * p1 - f2[p];
		}
		return ans;
	}
	int get(int p) {
		return sum(p + 1) - sum(p);
	}
};

int n, a[N], d[N][N];

void solve() {
	cin >> n;
	for (int i = 0; i < n; ++i) {
		cin >> a[i]; --a[i];
	}
	for (int i = 0; i < n; ++i) {
		for (int j = i+1; j < n; ++j) {
			d[i][j] = j - i;
		}
	}
	fenw f1(n);
	for (int i = 0; i < n; ++i) {
		f1.rng_upd(a[i] + 1, n, 1);
		int p1 = f1.get(a[i]);
		fenw f2(n);
		for (int j = n - 1; j > i; --j) {
			f2.rng_upd(a[j] + 1, n, 1);
			int p2 = f2.get(a[j]);
			int ai = a[i], aj = a[j];
			if (ai > aj) swap(ai, aj);
			d[ai][aj] = max(d[ai][aj], j - p1);
			d[ai][aj] = max(d[ai][aj], j + p2 - i);
		}
	}
	ll ans = 0;
	for (int i = 0; i < n; ++i) {
		for (int j = i + 1; j < n; ++j) {
			ans += d[i][j];
		}
	}
	cout << ans;
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int t = 1;
	while (t--) {
		solve();
		cout << "\n";
	}
}