#include <iostream>
#include <set>

using namespace std;

pair <short, short> up[3002][3002][13];
bool used[3002];
int tin[3002][3002];
int tout[3002][3002];
int tmr = 0;
short n;

void dfs(short i, short j, short pj = 0, short cnt = 1)
{
    up[i][j][0] = {max(0, i - 1), pj};
    for (short k = 1; k <= 12; k++)
        up[i][j][k] = up[up[i][j][k - 1].first][up[i][j][k - 1].second][k - 1];
    if (cnt == n + 1)
        return;
    if (used[cnt])
        dfs(i + 1, j, j, cnt + 1);
    else
        dfs(i + 1, j + 1, j, cnt + 1);
}

void dfs2(short i, short j)
{
    tin[i][j] = ++tmr;
    if (up[i + 1][j][0] == make_pair(i, j))
        dfs2(i + 1, j);
    if (up[i + 1][j + 1][0] == make_pair(i, j))
        dfs2(i + 1, j + 1);
    tout[i][j] = ++tmr;
}

bool isAncestor(short x1, short y1, short x2, short y2)
{
    return (tin[x1][y1] <= tin[x2][y2] && tout[x2][y2] <= tout[x1][y1]);
}

pair <short, short> lca(short x1, short y1, short x2, short y2)
{
    if (isAncestor(x1, y1, x2, y2))
        return {x1, y1};
    if (isAncestor(x2, y2, x1, y1))
        return {x2, y2};
    for (short i = 12; i >= 0; i--)
    if (!isAncestor(up[x1][y1][i].first, up[x1][y1][i].second, x2, y2)){
        short nx = up[x1][y1][i].first, ny = up[x1][y1][i].second;
        x1 = nx;
        y1 = ny;
    }
    return up[x1][y1][0];
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cin >> n;
    dfs(0, 0);
    for (int i = 1; i <= n; i++){
        short x;
        cin >> x;
        used[x] = 1;
        tmr = 0;
        dfs(0, 0);
    }
    dfs2(0, 0);
    int q;
    cin >> q;
    while (q--){
        short x1, y1, x2, y2;
        cin >> x1 >> y1 >> x2 >> y2;
        pair <short, short> ans = lca(x1, y1, x2, y2);
        cout << ans.first << ' ' << ans.second << '\n';
    }
    return 0;
}
