#include <iostream>
#include <vector>
#include <algorithm>
#define ll long long
#define all(x) x.begin(),x.end()
#define fi first
#define se second
using namespace std;
vector<int> a;
int n, q;
vector<vector<vector<int>>> g;
vector<vector<int>> tin, tout, used;
vector<vector<vector<pair<int,int>>>> up;
int gtime = 0;

void dfs (int ui, int uj) {
    /*if (used[ui][uj])
        return;
    used[ui][uj] = 1;*/
    tin[ui][uj] = ++gtime;
    if (g[ui][uj][0]) {
        up[ui + 1][uj][0] = {ui, uj};
        dfs(ui + 1, uj);
    }
    if (g[ui][uj][1]) {
        up[ui + 1][uj + 1][0] = {ui, uj};
        dfs(ui + 1, uj + 1);
    }
    tout[ui][uj] = ++gtime;
}

bool isAnc (int ui, int uj, int vi, int vj) {
    return (tin[ui][uj] <= tin[vi][vj]) && (tout[ui][uj] >= tout[vi][vj]);
}

pair<int,int> lca (int ui, int uj, int vi, int vj) {
    if (isAnc(ui, uj, vi, vj))
        return {ui, uj};
    if (isAnc(vi, vj, ui, uj))
        return {vi, vj};
    for (int l = 13; l >= 0; --l) {
        auto [ti, tj] = up[ui][uj][l];
        if (!isAnc(ti, tj, vi, vj))
            ui = ti, uj = tj;
    }
    return up[ui][uj][0];
}

void solve1 () {
    g.resize(n + 1, vector<vector<int>> (n + 1, vector<int> (2, 0)));
    tin.resize(n + 1, vector<int> (n + 1));
    tout.resize(n + 1, vector<int> (n + 1));
    used.resize(n + 1, vector<int> (n + 1, 0));
    up.resize(n + 1, vector<vector<pair<int,int>>> (n + 1, vector<pair<int,int>> (20)));
    vector<int> dir(n + 1, 0);
    for (int i = 1; i <= n + 1; ++i) {
        int ci = 0, cj = 0;
        for (int j = 1; j <= n; ++j) {
            if (dir[j] == 0) {
                g[ci][cj][1] = 1;
                ++cj;
            } else {
                g[ci][cj][0] = 1;
            }
            ++ci;
        }
        if (i <= n)
            dir[a[i]] = 1;
    }
    up[0][0][0] = {0, 0};
    dfs(0, 0);
    for (int l = 1; l <= 13; ++l) {
        for (int i = 0; i <= n; ++i) {
            for (int j = 0; j <= i; ++j) {
                up[i][j][l] = up[up[i][j][l - 1].fi][up[i][j][l - 1].se][l - 1];
            }
        }
    }
    cin >> q;
    for (int _ = 0; _ < q; ++_) {
        int i1, j1, i2, j2; cin >> i1 >> j1 >> i2 >> j2;
        auto [ti, tj] = lca(i1, j1, i2, j2);
        cout << ti << ' ' << tj << '\n';
    }
}

void solve3 () {
    cin >> q;
    for (int _ = 0; _ < q; ++_) {
        int i1, j1, i2, j2; cin >> i1 >> j1 >> i2 >> j2;
        int t1 = i1 - j1, t2 = i2 - j2;
        if (t1 == t2) {
            if (i1 < i2) {
                cout << i1 << ' ' << j1 << '\n';
            } else {
                cout << i2 << ' ' << j2 << '\n';
            }
            continue;
        }
        cout << min(t1, t2) << " 0\n";
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    a.resize(n + 1);
    int f = 1;
    for (int i = 1; i <= n; ++i) {
        cin >> a[i];
        if (a[i] != i) {
            f = 0;
        }
    }
    if (f) {
        solve3();
        return 0;
    }
    solve1();
}
