#include<bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define int ll

const int MAXN = 1e5 + 100;
const int INF = 1e18;

vector<int> sp[MAXN];
int c[MAXN];
int l[MAXN];
int r[MAXN];
int tin[MAXN];
int tout[MAXN];
int min_r[MAXN];
int t[4 * MAXN + 4];
int cnt[4 * MAXN + 4];
vector<int> euler;
int sm = 0;
bool fl = true;

int get_min_ind(int a, int b) {
    if (c[a] < c[b]) {
        return a;
    }
    return b;
}

void build(int i, int l, int r) {
    if (l + 1 == r) {
        t[i] = euler[l];
        return;
    }
    int m = (l + r) / 2;
    build(2 * i + 1, l, m);
    build(2 * i + 2, m, r);
    t[i] = get_min_ind(t[2 * i + 1], t[2 * i + 2]);
}

void update_t(int i, int l, int r, int q_i, int x) {
    if (q_i < l || r <= q_i) {
        return;
    }
    if (l + 1 == r) {
        t[i] = x;
        return;
    }
    int m = (l + r) / 2;
    update_t(2 * i + 1, l, m, q_i, x);
    update_t(2 * i + 2, m, r, q_i, x);
    t[i] = get_min_ind(t[2 * i + 1], t[2 * i + 2]);
}

void update_cnt(int i, int l, int r, int q_i, int x) {
    //cout << i << " " << l << " " << r << " - " << q_i << " " << x << endl;
    if (q_i < l || r <= q_i) {
        return;
    }
    if (l + 1 == r) {
        cnt[i] += x;
        return;
    }
    int m = (l + r) / 2;
    update_cnt(2 * i + 1, l, m, q_i, x);
    update_cnt(2 * i + 2, m, r, q_i, x);
    //cout << "returned from two updates: " << i << endl;
    cnt[i] = cnt[2 * i + 1] + cnt[2 * i + 2];
}

int get_min(int i, int l, int r, int q_l, int q_r) {
    if (q_l <= l && r <= q_r) {
        return t[i];
    }
    if (r <= q_l || q_r <= l) {
        return MAXN - 1;
    }
    int m = (l + r) / 2;
    return get_min_ind(get_min(2 * i + 1, l, m, q_l, q_r), get_min(2 * i + 2, m, r, q_l, q_r));
}

int get_cnt(int i, int l, int r, int q_l, int q_r) {
    if (q_l <= l && r <= q_r) {
        return cnt[i];
    }
    if (r <= q_l || q_r <= l) {
        return 0;
    }
    int m = (l + r) / 2;
    return get_cnt(2 * i + 1, l, m, q_l, q_r) + get_cnt(2 * i + 2, m, r, q_l, q_r);
}

void prec(int u, int p) {
    if (p == -1) {
        min_r[u] = r[u];
    }
    else {
        min_r[u] = min(min_r[p], r[u]);
    }
    tin[u] = euler.size();
    euler.push_back(u);
    for (auto v : sp[u]) {
        if (v != p) {
            prec(v, u);
        }
    }
    tout[u] = euler.size();
    euler.push_back(u);
}

void dfs(int u, int p) {
    //cout << "IN: " << u << endl;
    for (auto v : sp[u]) {
        if (v != p) {
            dfs(v, u);
            if (!fl) {
                return;
            }
        }
    }
    //cout << "get now in: " << u << endl;
    int now = get_cnt(0, 0, euler.size(), tin[u], tout[u] + 1);
    //cout << "OK now = " << now << endl;
    if (now > r[u]) {
        /// KEKW
        fl = false;
        return;
    }
    int rem = l[u] - now;
    while(rem > 0) {
        //cout << "get min in: " << u << endl;
        int mn = get_min(0, 0, euler.size(), tin[u], tout[u] + 1);
        //cout << "OK min = " << mn << endl;
        if (mn == MAXN - 1) {
            fl = false;
            return;
        }
        //cout << "get tmp" << endl;
        int tmp = get_cnt(0, 0, euler.size(), tin[mn], tout[mn] + 1);
        //cout << "OK tmp = " << tmp << endl;
        int can = min(min_r[mn] - tmp, rem);
        //cout << "UPDATE: " << mn << " with " << can << endl;
        update_cnt(0, 0, euler.size(), tin[mn], can);
        //update_cnt(0, 0, euler.size(), tout[mn], can);
        //cout << "OK update" << endl;
        rem -= can;
        sm += can * c[mn];
        //cout << rem << " " << tmp << " " << can << endl;
        if (tmp == min_r[mn]) {
            update_t(0, 0, euler.size(), tin[mn], MAXN - 1);
            update_t(0, 0, euler.size(), tout[mn], MAXN - 1);
        }
    }
    //cout << endl;
}

void solve() {
    int n;
    cin >> n;
    int p;
    for (int i = 1; i < n; ++i) {
        cin >> p;
        --p;
        sp[p].push_back(i);
        sp[i].push_back(p);
    }
    for (int i = 0; i < n; ++i) {
        cin >> c[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> l[i] >> r[i];
    }
    //cout << "OK cin" << endl;
    prec(0, -1);
    //cout << "OK prec" << endl;
    build(0, 0, euler.size());
    //cout << "OK build" << endl;
    dfs(0, -1);
    //cout << "OK dfs" << endl;
    if (!fl) {
        cout << -1 << "\n";
        return;
    }
    cout << sm << "\n";
    for (int i = 0; i < n; ++i) {
        cout << get_cnt(0, 0, euler.size(), tin[i], tin[i] + 1) << " ";
    }
    cout << "\n";
    for (int i = 0; i < n; ++i) {
        sp[i].clear();
        euler.clear();
        sm = 0;
        fl = true;
    }
    return;
}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    c[MAXN - 1] = INF;
    int tests = 1;
    cin >> tests;
    while(tests--) {
        solve();
    }
}
