#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <iomanip>
#include <numeric>

using namespace std;
#define int long long
#define ld long double
#define debug(x) cout << #x << " is " << x << '\n';

const int mod = 1e9 + 7, N = 1e3 + 1;

int n;
vector <vector <int>> g, dp;
vector <int> lx, rx, c, ans;
void dfs(int v) {
	dp[v][0] = 0;
	for (auto& u : g[v]) {
		dfs(u);
		vector <int> ndp(N, mod * mod);
		for (int i = 0; i < N; ++i) {
			for (int j = 0; j + i < N; ++j) {
				ndp[i + j] = min(ndp[i + j], dp[v][i] + dp[u][j]);
			}
		}
		dp[v] = ndp;
	}
	for (int i = 0; i < N; ++i) {
		for (int j = 0; j + i < N; ++j) {
			dp[v][i + j] = min(dp[v][i + j], dp[v][i] + c[v] * j);
		}
	}
	for (int i = 0; i < N; ++i) {
		if (i < lx[v] or i > rx[v]) dp[v][i] = mod * mod;
	}
}

void rec(int v, int X) {
	dp[v].assign(N, mod * mod);
	dp[v][0] = 0;
	vector <vector <int>> pr;
	for (auto& u : g[v]) {
		vector <int> ndp(N, mod * mod);
		pr.push_back(vector <int>(N, -1));
		for (int i = 0; i < N; ++i) {
			for (int j = 0; j + i < N; ++j) {
				if (dp[v][i] + dp[u][j] < ndp[i + j]) {
					pr.back()[i + j] = i;
					ndp[i + j] = dp[v][i] + dp[u][j];
				}
			}
		}
		dp[v] = ndp;
	}
	pr.push_back(vector <int>(N, -1));
	vector <int> ndp(N, mod * mod);
	for (int i = 0; i < N; ++i) {
		for (int j = 0; j + i < N; ++j) {
			if (ndp[i + j] > dp[v][i] + c[v] * j) {
				ndp[i + j] = dp[v][i] + c[v] * j;
				pr.back()[i + j] = i;
			}
		}
	}
	ans[v] = X - pr.back()[X];
	X = pr.back()[X];
	int curId = g[v].size();
	while (curId >= 0) {
		curId--;
		if (curId < 0) break;
		rec(g[v][curId], X - pr[curId][X]);
		X = pr[curId][X];
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout << fixed << setprecision(6);

	int tt; cin >> tt;
	while (tt-- > 0) {
		cin >> n;
		g.assign(n + 1, {});
		lx.assign(n + 1, 0);
		rx.assign(n + 1, 0);
		c.assign(n + 1, 0);
		ans.assign(n + 1, 0);
		dp.assign(n + 1, vector <int>(N, mod * mod));
		for (int i = 2; i <= n; ++i) {
			int p; cin >> p;
			g[p].push_back(i);
		}
		for (int i = 1; i <= n; ++i) cin >> c[i];
		for (int i = 1; i <= n; ++i)
			cin >> lx[i] >> rx[i];
		dfs(1);
		int mn = N;
		for (int i = N - 1; i >= 0; --i) {
			if (dp[1][i] != mod * mod) mn = i;
		}
		if (mn == N) {
			cout << "-1\n";
			continue;
		}
		rec(1, mn);
		for (int i = 1; i <= n; ++i) cout << ans[i] << ' ';
		cout << '\n';
	}

}