#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <iomanip>
#include <numeric>

using namespace std;
//#define int long long
#define ld long double
#define debug(x) cout << #x << " is " << x << '\n';

const int mod = 1e9 + 7, N = 10, L = 12;

vector <vector <int>> g;
vector <int> tin, tout, euler, h;
int timer = 0;
void dfs(int v, int p) {
	tin[v] = timer++;
	euler.push_back(v);
	for (auto& u : g[v]) {
		h[u] = h[v] + 1;
		dfs(u, v);
		euler.push_back(v);
		timer++;
	}
}

int lca(int u, int v) {
	int ans = u;
	for (int i = min(tin[u], tin[v]); i <= max(tin[u], tin[v]); ++i) {
		if (h[euler[i]] < h[ans])
			ans = euler[i];
	}
	return ans;
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout << fixed << setprecision(6);

	int n; cin >> n;
	vector <int> a(n);
	for (auto& x : a) cin >> x;
	vector <bool> cur(n);
	g.resize((n + 2) * (n + 2));
	int m = (n + 2) * (n + 2);
	tin.resize(m);
	tout.resize(m);
	h.resize(m);
	for (int i = 0; i <= n; ++i) {
		int x = 0, y = 0;
		for (auto z : cur) {
			int nx = x + 1, ny = y + !z;
			g[x * (n + 1) + y].push_back(nx * (n + 1) + ny);
			x = nx, y = ny;
		}
		if (i < n) cur[a[i] - 1] = true;
	}

	for (auto& x : g) {
		sort(x.begin(), x.end());
		x.erase(unique(x.begin(), x.end()), x.end());
	}

	dfs(0, 0);
	int q; cin >> q;
	while (q--) {
		int u1, v1, u2, v2;
		cin >> u1 >> v1 >> u2 >> v2;
		int res = lca(u1 * (n + 1) + v1, u2 * (n + 1) + v2);
		cout << res / (n + 1) << ' ' << res % (n + 1) << '\n';
	}


}