#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <iomanip>
#include <numeric>

using namespace std;
//#define int long long
#define ld long double
#define debug(x) cout << #x << " is " << x << '\n';

const int mod = 1e9 + 7, N = 10, L = 12;

vector <vector <int>> g;
vector <int> tin, tout, euler, h;
int timer = 0;
void dfs(int v, int p) {
	tin[v] = timer++;
	euler.push_back(v);
	for (auto& u : g[v]) {
		h[u] = h[v] + 1;
		dfs(u, v);
		euler.push_back(v);
		timer++;
	}
}

struct SegTree {
	int n;
	vector <int> tree, ind;
	SegTree(int n = 0) : n(n) {
		tree.resize(2 * n);
		ind.resize(2 * n);
	}
	int get(int l, int r) {
		l += n, r += n;
		int ans = tree[l], id = l - n;
		for (; l < r; l /= 2, r /= 2) {
			if (l & 1) {
				if (tree[l] < ans) {
					ans = tree[l];
					id = ind[l];
				}
				l++;
			} 
			if (r & 1) {
				--r;
				if (tree[r] < ans) {
					ans = tree[r];
					id = ind[r];
				}
			}
		}
		return id;
	}
	void upd(int i, int x) {
		int id = i;
		i += n;
		tree[i] = x;
		ind[i] = id;
		for (i /= 2; i > 0; i /= 2) {
			if (tree[i * 2] > tree[i * 2 + 1]) {
				tree[i] = tree[i * 2 + 1];
				ind[i] = ind[i * 2 + 1];
			}
			else {
				tree[i] = tree[i * 2];
				ind[i] = ind[i * 2];
			}
		}
	}
} ST;

int lca(int u, int v) {
	int ans = ST.get(min(tin[u], tin[v]), max(tin[u], tin[v]) + 1);
	return euler[ans];
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout << fixed << setprecision(6);

	int n; cin >> n;
	vector <int> a(n);
	for (auto& x : a) cin >> x;
	vector <bool> cur(n);
	g.resize((n + 2) * (n + 2));
	int m = (n + 2) * (n + 2);
	tin.resize(m);
	tout.resize(m);
	h.resize(m);
	for (int i = 0; i <= n; ++i) {
		int x = 0, y = 0;
		for (auto z : cur) {
			int nx = x + 1, ny = y + !z;
			g[x * (n + 1) + y].push_back(nx * (n + 1) + ny);
			x = nx, y = ny;
		}
		if (i < n) cur[a[i] - 1] = true;
	}

	for (auto& x : g) {
		sort(x.begin(), x.end());
		x.erase(unique(x.begin(), x.end()), x.end());
	}

	dfs(0, 0);
	ST = SegTree(euler.size());
	for (int i = 0; i < euler.size(); ++i)
		ST.upd(i, h[euler[i]]);
	int q; cin >> q;
	while (q--) {
		int u1, v1, u2, v2;
		cin >> u1 >> v1 >> u2 >> v2;
		int res = lca(u1 * (n + 1) + v1, u2 * (n + 1) + v2);
		cout << res / (n + 1) << ' ' << res % (n + 1) << '\n';
	}


}