#include <bits/stdc++.h>

using namespace std;
using ll = long long;

void solve();

int main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
    int t;
    cin >> t;
    do {
        solve();
    } while (--t);
    return 0;
}

#define lower_index(v, x) lower_bound(v.begin(), v.end(), x) - v.begin()
#define upper_index(v, x) upper_bound(v.begin(), v.end(), x) - v.begin()
using segment = pair<int, int>;
#define l first
#define r second

const int MAX = 1e3;

pair<ll, vector<int>> solve(vector<int> p, vector<int> c, vector<segment> s) {
    int n = c.size();
    vector<vector<int>> t(n);
    for (int i = 1; i < n; ++i) t[p[i]].push_back(i);
    vector<vector<ll>> cost(n, vector<ll>(MAX + 1, 1e18));
    vector<vector<vector<int>>> how(n, vector<vector<int>>(MAX + 1));
    for (int i = 0; i < n; ++i) for (int c = 0; c <= MAX; ++c) how[i][c].assign(t[i].size(), 0);
    auto dfs = [&](auto dfs, int cur) -> void {
        for (int x = 0; x <= s[cur].r; ++x) {
            cost[cur][x] = c[cur] * 1LL * x;
        }
        for (int j = 0; j < t[cur].size(); ++j) {
            int next = t[cur][j];
            dfs(dfs, next);
            vector<ll> newCost(MAX + 1, 1e18);
            for (int x = 0; x <= MAX; ++x) {
                for (int y = 0; x + y <= s[cur].r; ++y) {
                    if (newCost[x + y] > cost[cur][x] + cost[next][y]) {
                        newCost[x + y] = cost[cur][x] + cost[next][y];
                        how[cur][x + y][j] = y;
                    }
                }
            }
            cost[cur] = newCost;
        }
        for (int i = 0; i < s[cur].l; ++i) cost[cur][i] = 1e18;
    };
    dfs(dfs, 0);
    ll ans = *min_element(cost[0].begin(), cost[0].end());
    if (ans == 1e18) return {-1, {}};
    vector<int> res(n);
    auto re = [&](auto re, int cur, int x) -> void {
        res[cur] = x;
        for (int j = 0; j < t[cur].size(); ++j) {
            int next = t[cur][j];
            res[cur] -= how[cur][x][j];
            re(re, next, how[cur][x][j]);
        }
    };
    re(re, 0, min_element(cost[0].begin(), cost[0].end()) - cost[0].begin());
    return {ans, res};
}

void solve() {
    int n;
    cin >> n;
    vector<int> p(n);
    for (int i = 1; i < n; ++i) {
        cin >> p[i];
        --p[i];
    }
    vector<int> c(n);
    for (int &x: c) cin >> x;
    vector<segment> s(n);
    for (auto &[l, r]: s) cin >> l >> r;
    auto[cost, how] = solve(p, c, s);
    cout << cost << '\n';
    if (cost != -1) for (int x: how) cout << x << ' ';
    cout << '\n';
}