#include <bits/stdc++.h>

using namespace std;
using ll = long long;

void solve();

int main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
    solve();
    return 0;
}

#define lower_index(v, x) lower_bound(v.begin(), v.end(), x) - v.begin()
#define upper_index(v, x) upper_bound(v.begin(), v.end(), x) - v.begin()

struct cell {
    int i, j;

    cell(int i, int j) : i(i), j(j) {}

    cell() = default;

    bool operator<(const cell &other) const {
        return pair{i, j} < pair{other.i, other.j};
    }
};

using pvertex = int;

struct vertex {
    int left = 0, right = 0;
    int sum;

    vertex(pvertex left, pvertex right, int sum) : left(left), right(right), sum(sum) {}

    vertex(int sum) : sum(sum) {}
};

vector<vertex> memo{vertex(0)};

template<typename ...Args>
pvertex new_vertex(Args... args) {
    memo.emplace_back(args...);
    return memo.size() - 1;
}

pvertex add(pvertex cur, int i, int curL, int curR) {
    if (curL + 1 == curR) return new_vertex(memo[cur].sum + 1);
    int curM = (curL + curR) / 2;
    if (i < curM) {
        pvertex lf = add(memo[cur].left, i, curL, curM);
        return new_vertex(lf, memo[cur].right, memo[lf].sum + memo[memo[cur].right].sum);
    }
    pvertex rg = add(memo[cur].right, i, curM, curR);
    return new_vertex(memo[cur].left, rg, memo[memo[cur].left].sum + memo[rg].sum);
}

pvertex build(int n) {
    if (n == 1) return new_vertex(0);
    return new_vertex(build(n / 2), build(n / 2), 0);
}

int sz;

int sum(pvertex cur, int l, int r, int curL, int curR) {
    if (l <= curL && curR <= r) return memo[cur].sum;
    if (r <= curL || curR <= l) return 0;
    int curM = (curL + curR) / 2;
    return sum(memo[cur].left, l, r, curL, curM) + sum(memo[cur].right, l, r, curM, curR);
}

int atLeast(pvertex cur, int q, int curL, int curR) {
    if (curL + 1 == curR) return curR;
    int curM = (curL + curR) / 2;
    if (memo[memo[cur].left].sum >= q) return atLeast(memo[cur].left, q, curL, curM);
    q -= memo[memo[cur].left].sum;
    return atLeast(memo[cur].right, q, curM, curR);
}

vector<pvertex> build(vector<int> a) {
    int n = a.size();
    sz = n;
    sz = 2 << __lg(sz);
    pvertex z = build(sz);
    vector<int> pos(n);
    for (int i = 0; i < n; ++i) pos[a[i]] = i;
    vector<pvertex> ans(n + 1);
    ans[0] = z;
    for (int i = 0; i < n; ++i) {
        ans[i + 1] = add(ans[i], pos[i], 0, sz);
    }
    return ans;
}

void solve(vector<int> a, vector<pair<cell, cell>> q) {
    vector<pvertex> persistent = build(a);
    int n = a.size();
    auto get = [&](int i, int j) -> int {
        if (j == i) return 0;
        return atLeast(persistent[i], i - j, 0, sz);
        int curJ = i;
        for (int k = 0; k < n; ++k) {
            if (a[k] < i) curJ--;
            if (curJ == j) return k + 1;
        }
        assert(false);
        return 0;
    };
    auto j = [&](int i, int c) -> int {
        return i - sum(persistent[i], 0, c, 0, sz);
        int curJ = i;
        for (int k = 0; k < c; ++k) {
            if (a[k] < i) curJ--;
        }
        return curJ;
    };
    for (auto &[c1, c2]: q) {
        auto[i1, j1] = c1;
        auto[i2, j2] = c2;
        int idx1 = get(i1, j1);
        int idx2 = get(i2, j2);
        int ans = min(i1, i2);
        for (int i = min(idx2, idx1); i < max(idx1, idx2); ++i) {
            ans = min(ans, a[i]);
        }
        cout << ans << ' ' << j(ans, idx1) << '\n';
    }
}

void solve() {
    int n, q;
    cin >> n;
    memo.reserve(40 * n);
    vector<int> a(n);
    for (int &x: a) cin >> x;
    for (int &x: a) --x;
    cin >> q;
    vector<pair<cell, cell>> qu(q);
    for (auto &[c1, c2]: qu) {
        cin >> c1.i >> c1.j >> c2.i >> c2.j;
    }
    solve(a, qu);
}
