#include <bits/stdc++.h>

using namespace std;
using ll = long long;

void solve();

int main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
    solve();
    return 0;
}

#define lower_index(v, x) lower_bound(v.begin(), v.end(), x) - v.begin()
#define upper_index(v, x) upper_bound(v.begin(), v.end(), x) - v.begin()

struct cell {
    int i, j;

    cell(int i, int j) : i(i), j(j) {}

    cell() = default;

    bool operator<(const cell &other) const {
        return pair{i, j} < pair{other.i, other.j};
    }
};

ll solve(vector<bool> ok, vector<cell> pts, const vector<int> &x, const vector<int> &y, int w, int h) {
    int n = pts.size();
    vector<vector<int>> ys(x.size());
    for (auto &[i, j]: pts) {
        ys[i].push_back(j);
    }
    for (auto &row: ys) sort(row.begin(), row.end());
    ll ans = 0;
    int minY = y.size() - 1;
    for (int i = 0; i + 1 < x.size(); ++i) {
        if (ys[i].size()) minY = min(minY, ys[i][0]);
        ans += (x[i + 1] - x[i]) * 1LL * (h - y[minY]);
    }
    return ans;
}

void solve() {
    int k;
    cin >> k;
    vector<bool> ok(4);
    for (int i = 0; i < k; ++i) {
        int x;
        cin >> x;
        ok[--x] = true;
    }
    int t;
    cin >> t;
    do {
        int n, w, h;
        cin >> n >> w >> h;
        vector<cell> p(n);
        vector<int> x{0, w}, y{0, h};
        for (auto &[i, j]: p) {
            cin >> i >> j;
            x.push_back(i);
            y.push_back(j);
        }
        sort(x.begin(), x.end());
        x.erase(unique(x.begin(), x.end()), x.end());
        sort(y.begin(), y.end());
        y.erase(unique(y.begin(), y.end()), y.end());
        for (auto &[i, j]: p) {
            i = lower_index(x, i);
            j = lower_index(y, j);
        }
        cout << solve(ok, p, x, y, w, h) << '\n';
    } while (--t);
}
