#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

#define vi vector<int>
#define vvi vector<vi>
#define vll vector<ll>
#define pll pair<ll, ll>
#define pi pair<int, int>
#define vpi vector<pi>
#define vpll vector<pll>
#define vb vector<bool>

struct Node {
    vi elements;
    int n;

    Node() {}

    explicit Node(int num) {
        elements = {num};
        n = 1;
    }

    Node(Node &a, Node &b) {
        int i1 = 0, i2 = 0;
        while (true) {
            if (i1 == a.n and i2 == b.n) break;
            else if (i1 == a.n) elements.push_back(b.elements[i2++]);
            else if (i2 == b.n) elements.push_back(a.elements[i1++]);
            else if (a.elements[i1] < b.elements[i2]) elements.push_back(a.elements[i1++]);
            else elements.push_back(b.elements[i2++]);
        }
        n = a.n + b.n;
    }

    int cnt_less(int x) {
        if (elements[0] > x) return 0;
        int left = 0, right = n, medium;
        while (right - left > 1) {
            medium = (left + right) / 2;
            if (elements[medium] <= x) left = medium;
            else right = medium;
        }
        return left + 1;
    }
};

struct MergeSort {
    vector<Node> tree;
    int n;

    explicit MergeSort(vi &arr) {
        n = arr.size();
        tree.resize(4 * n);
        build(1, 0, n - 1, arr);
    }

    void build(int i, int tl, int tr, vi &arr) {
        if (tl == tr) tree[i] = Node(arr[tl]);
        else {
            int tm = (tl + tr) / 2;
            build(i * 2, tl, tm, arr);
            build(i * 2 + 1, tm + 1, tr, arr);
            tree[i] = Node(tree[i * 2], tree[i * 2 + 1]);
        }
    }

    int find(int i, int tl, int tr, int val, int cnt) {
        if (tl == tr) return tl;
        int tm = (tl + tr) / 2;
        int res = tree[i * 2].cnt_less(val);
        if (res >= cnt) return find(i * 2, tl, tm, val, cnt);
        return find(i * 2 + 1, tm + 1, tr, val, cnt - res);
    }

    int find(int val, int cnt) {
        return find(1, 0, n - 1, val, cnt);
    }
};

int get_min_route(int x, int y, vi &a, MergeSort &ms) {
    if (0 == y - x) return 0;
    return ms.find(y - 1, y - x) + 1;
}

pair<int, int> get_inter(int max_h, int r1, int r2, int n, vvi &routes) {
    int cur_x = 0, cur_y = 0;
    for (int i = 0; i < max_h; i++) {
        if (routes[r1][i] == routes[r2][i]) {
            cur_x += routes[r1][i];
            cur_y++;
        } else {
            break;
        }
    }
    return {cur_x, cur_y};
}

void solve() {
    int n;
    cin >> n;
    vi a(n);
    for (int &i: a) {
        cin >> i;
        i--;
    }

    MergeSort ms(a);

    vvi routes(n + 1);
    vi tmp(n, 1);
    routes[0] = tmp;
    for (int i = 1; i <= n; i++) {
        tmp[a[i - 1]] = 0;
        routes[i] = tmp;
    }

    int q;
    cin >> q;
    while (q--) {
        int y1, x1, y2, x2;
        cin >> y1 >> x1 >> y2 >> x2;
        int r1 = get_min_route(x1, y1, a, ms);
        int r2 = get_min_route(x2, y2, a, ms);
        auto p = get_inter(min(y1, y2), r1, r2, n, routes);
        cout << p.second << ' ' << p.first << '\n';
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int tests = 1;
   // cin >> tests;
    while (tests--) {
        solve();
    }
}