#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <deque>
#include <stack>
#include <queue>
#include <unordered_map>
#include <unordered_set>
#include <time.h>
#include <math.h>
#include <random>
#include <string>
#include <iomanip>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

int n;
vector<vector<int>> g;
vector<vector<pii>> open;
vector<int> l, r, c, placed, summcnt, parent, blocked;
vector<ll> min_space;
ll ans = 0;

bool check(int v) {
	ll suml = 0;
	min_space[v] = l[v];
	for (int to : g[v]) {
		if (!check(to)) return 0;
		suml += min_space[to];
	}
	min_space[v] = max(min_space[v], suml);
	if (min_space[v] > r[v])
		return 0;
	return 1;
}

void block(int v) { // summary O(n)
	blocked[v] = 1;
	for (int to : g[v])
		if (!blocked[to])
			block(to);
}

int dfs(int v) {
	for (int to : g[v])
		summcnt[v] += dfs(to);
	vector<pii> &good = open[v];
	sort(good.begin(), good.end());
	int cur = 0;
	while (summcnt[v] < l[v]) { // each iteration block some nodes or break
		if (cur == good.size()) exit(1);
		auto [cost, ind] = good[cur];
		cur++;
		if (blocked[ind]) continue;
		ll mx = l[v] - summcnt[v], t = ind, mn = r[ind] - summcnt[ind];
		int least = ind;
		while (t != v) { // O(n)
			t = parent[t];
			if (r[t] - summcnt[t] < mn) {
				least = t;
				mn = r[t] - summcnt[t];
			}
		}
		if (mn < mx) block(least);
		else mn = mx;
		t = least;
		summcnt[t] += mn;
		while (t != v) {
			t = parent[t];
			summcnt[t] += mn;
		}
		ans += mn * cost;
		placed[ind] += mn;
	}
	return summcnt[v];
}

int32_t main() {
	cin.tie(0); cout.tie(0); cin.sync_with_stdio(0); cout.sync_with_stdio(0);
	int t;
	cin >> t;
	while (t--) {
		cin >> n;
		g.assign(n, {});
		c.assign(n, 0);
		l.assign(n, 0);
		r.assign(n, 0);
		parent.assign(n, 0);
		summcnt.assign(n, 0);
		placed.assign(n, 0);
		blocked.assign(n, 0);
		min_space.assign(n, 0);
		open.assign(n, {});
		for (int i = 1; i < n; i++) {
			int p;
			cin >> p;
			g[--p].push_back(i);
			parent[i] = p;
		}
		for (int i = 0; i < n; i++)
			cin >> c[i];
		for (int i = 0; i < n; i++)
			cin >> l[i] >> r[i];
		if (!check(0)) {
			cout << -1 << "\n";
			continue;
		}
		for (int i = 0; i < n; i++) {
			int t = i;
			open[t].push_back({ c[i], i });
			while (t != 0) {
				t = parent[t];
				open[t].push_back({ c[i], i }); // O(n^2*logn)
			}
		}
		ans = 0;
		dfs(0);
		cout << ans << "\n";
		for (int i = 0; i < n; i++)
			cout << placed[i] << " ";
		cout << "\n";
	}
}