#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

#define int long long
const int N = 1e5 + 228;

typedef vector<int> vi;
typedef vector<vi> vvi;
typedef pair<int, int> pi;
typedef vector<pi> vpi;
#define all(x) x.begin(), x.end()
#define sz(x) ((int)(x.size()))

vi g[N];
int c[N];
pi lr[N];
pi lr2[N];
set<pair<int, pi>> st[N];
int sum[N];
int ans[N];
int cans;

pi unite(const pi& p1, const pi& p2) {
	return make_pair(max(p1.first, p2.first), min(p1.second, p2.second));
}

void normalize(int v, int cnt) {
	while (sum[v] > cnt) {
		auto it = st[v].end();
		--it;
		auto p = *it;
		st[v].erase(it);
		if (sum[v] - p.second.first >= cnt) {
			sum[v] -= p.second.first;
		}
		else {
			st[v].insert(make_pair(p.first, make_pair(p.second.first - (cnt - sum[v]), p.second.second)));
			sum[v] += cnt - sum[v]; //sum[v] = cnt
		}
	}
}

bool dfs(int v, int p) {
	lr2[v] = make_pair(0, 0);
	for (int u : g[v]) {
		if (u == p) continue;
		if (!dfs(u, v)) return false;
		lr2[v].first += lr2[u].first;
		lr2[v].second += lr2[u].second;
	}
	if (lr2[v].first > lr[v].second) return false;
	int cnt = lr[v].second - lr2[v].first;
	sum[v] = cnt;
	st[v].insert(make_pair(c[v], make_pair(sum[v], v)));
	for (int u : g[v]) {
		if (u == p) continue;
		if (st[v].size() < st[u].size()) {
			st[v].swap(st[u]);
			swap(sum[v], sum[u]);
		}
		for (auto c : st[u]) {
			st[v].insert(c);
		}
		sum[v] += sum[u];
		st[u].clear();
		normalize(v, cnt);
	}
	while (lr2[v].first < lr[v].first) {
		auto it = st[v].begin();
		auto p = *it;
		st[v].erase(it);
		if (lr2[v].first + p.second.first <= lr[v].first) {
			cans += p.first * p.second.first;
			ans[p.second.second] += p.second.first;
			lr2[v].first += p.second.first;
		}
		else {
			int d = lr[v].first - lr2[v].first;
			cans += p.first * d;
			ans[p.second.second] += d;
			lr2[v].first += d;
			st[v].insert(make_pair(p.first, make_pair(p.second.first - d, p.second.second)));
		}
	}
	return true;
}

void solve() {
	int n;
	cin >> n;
	for (int i = 0; i < n; ++i) {
		g[i].clear();
		ans[i] = 0;
		st[i].clear();
	}
	for (int i = 1; i < n; ++i) {
		int p;
		cin >> p;
		--p;
		g[p].push_back(i);
		g[i].push_back(p);
	}
	for (int i = 0; i < n; ++i) {
		cin >> c[i];
	}
	for (int i = 0; i < n; ++i) {
		cin >> lr[i].first >> lr[i].second;
	}
	cans = 0;
	if (!dfs(0, 0)) {
		cout << "-1\n";
		return;
	}
	cout << cans << "\n";
	for (int i = 0; i < n; ++i) {
		cout << ans[i] << " ";
	}
	cout << "\n";
}

signed main() {
	int t;
	cin >> t;
	while (t--) {
		solve();
	}
}