#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
//#pragma GCC target("avx,avx2,fmi,bmi2")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/rope>

#define endl '\n'
#define all(arr) arr.begin(), arr.end()
//#define int long long
#define out(x) cout << (x) << endl, exit(0)

using namespace std;
using namespace __gnu_pbds;
using namespace __gnu_cxx;

typedef pair<int, int> ipair;
typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> treap;

const int MAXN = 3030;
const int MAXV = MAXN * MAXN;
const int MAXK = MAXV << 1;
const int INF = 2e9;

int n, k;
int arr[MAXN], eul[MAXK], tin[MAXV], dep[MAXV];
bool trr[MAXN];
vector<int> gr[MAXV];

inline int code(int r, int c) {
	return r * (n + 1) + c;
}

inline ipair decode(int v) {
	return {v / (n + 1), v % (n + 1)};
}

void dfs(int r, int c) {
	if (r == n + 1) return;
	gr[code(r, c)].push_back(code(r + 1, c + trr[r]));
	dfs(r + 1, c + trr[r]);
}

void dfseul(int v, int d) {
	dep[v] = d;
	tin[v] = k;
	eul[k++] = v;
	for (int u: gr[v]) {
		dfseul(u, d + 1);
		eul[k++] = v;
	}
}

void build() {
	memset(trr, 1, sizeof(trr));
	dfs(0, 0);
	for (int i = 0; i < n; ++i) {
		trr[arr[i]] ^= true;
		dfs(0, 0);
	}
	for (int v = 0; v < MAXV; ++v) {
		if (gr[v].empty()) continue;
		sort(all(gr[v]));
		gr[v].resize(unique(all(gr[v])) - gr[v].begin());
	}
	dfseul(0, 0);

}

ipair go(int r1, int c1, int r2, int c2) {
	int v = code(r1, c1), u = code(r2, c2);
	int vid = tin[v], uid = tin[u];
	if (uid < vid) swap(vid, uid);
	ipair ans {INF, INF};
	for (int i = vid; i <= uid; ++i)
		ans = min(ans, {dep[eul[i]], eul[i]});
	return decode(ans.second);
}

int32_t main() {
	ios_base::sync_with_stdio(false), cin.tie(NULL), cout.tie(NULL);
	cout.setf(ios::fixed), cout.precision(10);
	cin >> n;
	for (int i = 0; i < n; ++i)
		cin >> arr[i], --arr[i];
	build();
	int t; cin >> t;
	while (t--) {
		int r1, c1, r2, c2; cin >> r1 >> c1 >> r2 >> c2;
		auto [r3, c3] = go(r1, c1, r2, c2);
		cout << r3 << ' ' << c3 << endl;
	}
}