#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <tuple>
#include <cassert>

using namespace std;

using ll = long long;
template<typename T>
using v = vector<T>;
template <typename T1, typename T2>
using pa = pair<T1, T2>;

template<typename T>
istream& operator>>(istream& in, v<T>& a) {
	for (T& x : a) {
		in >> x;
	}
	return in;
}

ll k;
v<ll> x;

void solve() {
	ll n, w, h;
	cin >> n >> w >> h;
	v<pa<ll, ll>> a(n);
	for (ll i = 0; i < n; ++i) {
		cin >> a[i].first >> a[i].second;
	}
	sort(a.begin(), a.end(), [](pa<ll, ll> a, pa<ll, ll> b) {return pa<ll, ll>(a.second, a.first) < pa<ll, ll>(b.second, b.first); });
	ll le = 0, ri = w;
	ll res = 0;
	for (auto[x, y] : a) {
		ll s1 = (h - y) * max(0ll, min(ri, x) - le);
		ll s2 = (h - y) * max(0ll, ri - max(le, x));
		if (s1 > s2) {
			res += s1;
			le = max(le, x);
		}
		else {
			res += s2;
			ri = min(ri, x);
		}
	}
	cout << res << '\n';
}

int main() {
	cin >> k;
	x = v<ll>(k);
	cin >> x;
	ll t = 1;
	cin >> t;
	for (ll i = 0; i < t; ++i) {
		solve();
	}
}