#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <tuple>
#include <cassert>

using namespace std;

using ll = long long;
template<typename T>
using v = vector<T>;
template <typename T1, typename T2>
using pa = pair<T1, T2>;

template<typename T>
istream& operator>>(istream& in, v<T>& a) {
	for (T& x : a) {
		in >> x;
	}
	return in;
}

ll k;
v<ll> x;

struct sparse_table {
	ll n;
	v<ll> log;
	v<v<pa<ll, ll>>> st;
	sparse_table(const v<ll>& a) : n(a.size()), log(a.size() + 1) {
		for (ll i = 2; i <= n; ++i) {
			log[i] = log[i >> 1] + 1;
		}
		st = v<v<pa<ll, ll>>>(log[n] + 1, v<pa<ll, ll>>(n));
		for (ll i = 0; i < n; ++i) {
			st[0][i] = { a[i], i };
		}
		for (ll j = 1; j <= log[n]; ++j) {
			for (ll i = 0; i <= (n - (1ll << j)); ++i) {
				st[j][i] = min(st[j - 1][i], st[j - 1][i + (1ll << (j - 1))]);
			}
		}
	}
	pa<ll, ll> get_range(ll L, ll R) {
		ll j = log[R - L];
		return min(st[j][L], st[j][R - (1ll << j)]);
	}
};

void solve() {
	ll n, w, h;
	cin >> n >> w >> h;
	v<pa<ll, ll>> a(n);
	for (ll i = 0; i < n; ++i) {
		cin >> a[i].first >> a[i].second;
	}
	sort(a.begin(), a.end());
	v<ll> ys(n);
	for (ll i = 0; i < n; ++i) {
		ys[i] = a[i].second;
	}
	sparse_table st(ys);
	v<v<ll>> dpv(n + 2, v<ll>(n + 2));
	for (ll len = 2; len <= n + 1; ++len) {
		for (ll L = 0; L + len < n + 2; ++L) {
			ll R = L + len;
			auto [cy, c] = st.get_range(L, R - 1);
			ll x1 = (L > 0) ? a[L - 1].first : 0ll;
			ll x2 = (R <= n) ? a[R - 1].first : w;
			ll s1 = (h - cy) * (a[c].first - x1) + dpv[c][R];
			ll s2 = (h - cy) * (x2 - a[c].first) + dpv[R][c];
			dpv[L][R] = max(s1, s2);
		}
	}
	cout << dpv[0][n + 1];
}

int main() {
	cin >> k;
	x = v<ll>(k);
	cin >> x;
	ll t = 1;
	cin >> t;
	for (ll i = 0; i < t; ++i) {
		solve();
	}
}