#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <set>
#include <random>
#include <cassert>

using namespace std;

mt19937_64 rnd(12);
//#define int int64_t
#define fi first
#define se second
#define all(x) (x).begin(), (x).end()

vector<vector<int>> gr;
vector<int> deep, used;
vector<int> eul, tin, tout;
int tim = 0;

void dfs(int v, int d) {
    tin[v] = tout[v] = eul.size();
    deep[v] = d;
    eul.push_back(v);
    used[v] = 1;
    for (int i : gr[v]) {
        if (used[i]) continue;
        dfs(i, d+1);
        tout[v] = eul.size();
        eul.push_back(v);
    }
}

vector<int> s;
void build(int l, int r, int v) {
    if (l == r-1) s[v] =eul[l];
    else {
        int m = (l + r)/2;
        build(l, m, v+1);
        build(m, r, v+(m-l)*2);
        if (deep[s[v+1]] < deep[s[v+(m-l)*2]]) {
            s[v] = s[v+1];
        } else {
            s[v] = s[v+(m-l)*2];
        }
    }
}

int ask(int l, int r, int lx, int rx, int v) {
    if (l >= rx || r <= lx) return -1;
    if (l >= lx && r <= rx) return s[v];
    int m = (l + r) / 2;
    int a = ask(l, m, lx, rx, v+1);
    int b = ask(m, r, lx, rx, v+(m-l)*2);
    if (a == -1) return b;
    if (b == -1) return a;
    if (deep[a] < deep[b]) return a;
    else return b;
}

int ask(int l, int r) {
    return ask(0, eul.size(), l, r+1, 0);
}

int lca(int a, int b) {
    //cout << "sus " << endl;
    if (tin[a] > tin[b]) swap(a, b);
    //cout << a << ' ' << b << endl;
    //cout << tin[a] << ' ' << tout[b] << endl;
    return ask(tin[a], tout[b]);
}

void solve() {
    int n;
    cin >> n;
    int sz = (n+1) * (n+2) / 2;
    vector<int> mas(n);
    int f = n-1;
    for (int i = 0; i < n; ++i) {
        cin >> mas[i];
        mas[i]--;
        if (i != 0 && mas[i] != mas[i-1] + 1) {
            f = i;
            break;
        }
    }
    int q;
    cin >> q;
    for (int t = 0; t < q; ++t) {
        int c1, r1, c2, r2;
        cin >> r1 >> c1 >> r2 >> c2;
        int u = r1 * (r1+1)/2 + c1;
        int v = r2 * (r2+1)/2 + c2;

        if (r1 >= f && c1 <= r1-f && r2 >= f && c2 <= r2-f) {
            if (c1 == c2) {
                if (r1 < r2) cout << r1 << ' ' << c1 << '\n';
                else cout << r2 << ' ' << c2 << '\n';
            } else {
                cout << min(c2, c1) << ' ' << min(c2, c1) << '\n';
            }
            continue;
        }
        if (!(r1 >= f && c1 <= r1-f) && !(r2 >= f && c2 <= r2-f)) {
            if (r1-c1 == r2-c2) {
                if (r1 < r2) cout << r1 << ' ' << c1 << '\n';
                else cout << r2 << ' ' << c2 << '\n';
            } else {
                cout << min(r1 - c1, r2 - c2) << ' ' << 0 << '\n';
            }
            continue;
        }

        if (r1 >= f && c1 <= r1-f) {
            cout << r2 - c2 << ' ' << 0 << '\n';
            continue;
        }
        if (r2 >= f && c2 <= r2-f) {
            cout << r1 - c1 << ' ' << 0 << '\n';
            continue;
        }
        assert(0);
        /*
        //cout << u << ' ' << v << endl;
        int lc = lca(u, v);
        int rr = lc - deep[lc] * (deep[lc] + 1) / 2;
        cout << deep[lc] << ' ' << rr << '\n';*/
    }
}

int32_t main() {
    //ios_base::sync_with_stdio(0); cin.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) solve();
}

/*
3
1 2 3
5
3 3 3 0
2 2 2 1
1 0 3 1
3 1 3 2
2 2 2 2
 */

/*
 *
1
8
1 2 2 3 4 2 2
2 1 1 4 5 9 5 2
2 2
0 0
0 2
0 1
1 1
0 1
0 0
0 0
 */