#include <iostream>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <numeric>
#include <random>
#include <cassert>
#include <ctime>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
#include <bitset>
using namespace std;
mt19937_64 rnd(time(NULL));

const long long INF = 1e10, MOD = 1e9 + 1;

struct segtree
{
	long long n;
	vector<long long> t, p;

	segtree(long long in)
	{
		n = in;
		t.resize(n * 4);
		p.resize(n * 4);
		build(0, 0, n - 1);
	}

	void build(long long v, long long tl, long long tr)
	{
		if (tl == tr)
		{
			t[v] = tl;
			return;
		}

		long long tm = (tl + tr) / 2;
		build(v * 2 + 1, tl, tm);
		build(v * 2 + 2, tm + 1, tr);
		t[v] = t[v * 2 + 1] + t[v * 2 + 2];
	}

	void push(long long v, long long tl, long long tr)
	{
		if (tl == tr)
		{
			return;
		}

		long long tm = (tl + tr) / 2;
		long long l1 = tm - tl + 1, l2 = tr - tm;
		t[v * 2 + 1] += p[v] * l1;
		t[v * 2 + 2] += p[v] * l2;
		p[v * 2 + 1] += p[v];
		p[v * 2 + 2] += p[v];
		p[v] = 0;
	}

	long long get(long long v, long long tl, long long tr, long long l, long long r)
	{
		if (tr < l || r < tl)
		{
			return 0;
		}
		if (l <= tl && tr <= r)
		{
			return t[v];
		}

		long long tm = (tl + tr) / 2;
		push(v, tl, tr);
		return get(v * 2 + 1, tl, tm, l, r) + get(v * 2 + 2, tm + 1, tr, l, r);
	}

	void upd(long long v, long long tl, long long tr, long long l, long long r, long long val)
	{
		if (tr < l || r < tl)
		{
			return;
		}
		if (l <= tl && tr <= r)
		{
			t[v] += val * (tr - tl + 1);
			p[v] += val;
			return;
		}

		long long tm = (tl + tr) / 2;
		push(v, tl, tr);
		upd(v * 2 + 1, tl, tm, l, r, val);
		upd(v * 2 + 2, tm + 1, tr, l, r, val);
		t[v] = t[v * 2 + 1] + t[v * 2 + 2];
	}
};

void solve()
{
	long long n;
	string s;
	long long y;
	cin >> s >> y;
	n = s.size();

	vector<vector<long long>> pos(10);
	for (long long i = 0; i < n; i++)
	{
		pos[s[i] - '0'].push_back(i);
	}

	segtree t(n);
	set<long long> used = { -1 };
	for (long long num = 9; num > -1; num--)
	{
		for (long long i = 0; i < pos[num].size(); i++)
		{
			pos[num][i] = t.get(0, 0, n - 1, pos[num][i], pos[num][i]);
			auto it = used.lower_bound(pos[num][i]);
			it--;
			long long idx = *it + 1;

			long long mid = pos[num][i] - idx - 1;
			if (mid >= 18)
			{
				t.upd(0, 0, n - 1, pos[num][i], pos[num][i], -mid - 1);
				t.upd(0, 0, n - 1, idx, pos[num][i] - 1, 1);
			}
			else
			{

			}
		}
	}
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	solve();

	return 0;
}

/*














*/
