#include <iostream>
#include <map>
#include <vector>
#include <algorithm>
using namespace std;
using ll = long long;

const ll MAXN = 3e5 + 123;
ll a[MAXN];

struct dsu {
    void resize(ll n) {
        rt.resize(n);
        for (ll i = 0; i < n; ++i)
            rt[i] = i;
    }

    ll gst(ll i) {
        if (rt[i] == i)
            return i;
        return rt[i] = gst(rt[i]);
    }

    void unite(ll i, ll j) {
        i = gst(i);
        j = gst(j);
        rt[min(i, j)] = max(i, j);
    }
 private:
    vector<ll> rt;
};

signed main() {
    ll n, q;
    cin >> n >> q;
    vector<ll> cpr;
    ll sm = 0;
    for (ll i = 0; i < n; ++i) {
        cin >> a[i];
        sm += a[i];
        cpr.push_back(a[i]);
    }
    sort(cpr.begin(), cpr.end());
    cpr.resize(unique(cpr.begin(), cpr.end()) - cpr.begin());
    ll m = cpr.size();
    
    vector<ll> cnt(m);
    for (ll i = 0; i < n; ++i) {
        ll j = lower_bound(cpr.begin(), cpr.end(), a[i]) - cpr.begin();
        ++cnt[j];
    }
    for (ll i = 1; i < m; ++i)
        cnt[i] += cnt[i - 1];

    vector<pair<ll, pair<ll, ll>>> qrs(q);
    for (ll i = 0; i < q; ++i) {
        ll t;
        cin >> t;
        if (t == 1 || t == 2) {
            ll k;
            cin >> k;
            qrs[i] = {k, {-t, i}};
        } else {
            ll k, j;
            cin >> k >> j;
            --j;
            qrs[i] = {k, {j, i}};
        }
    }
    sort(qrs.begin(), qrs.end());
    ll grow = 0;
    for (ll i = 1; i < m; ++i) {
        grow += cnt[i - 1];
    }
    vector<ll> unite_time(m - 1);
    multimap<ll, ll> time_unite;
    for (ll i = 0; i + 1 < m; ++i) {
        unite_time[i] = cpr[i + 1] - cpr[i];
        time_unite.insert({unite_time[i], i});
    }
    ll cursm = sm;
    ll difcnt = m;
    ll tpv = 0;
    ll qri = 0;
    vector<ll> ans(q, -1);
    dsu su;
    su.resize(n);
    while (qri < q) {
        if (time_unite.empty()) {
            while (qri < q) {
                auto [t0, jojo] = qrs[qri];
                auto [type, qri0] = jojo;
                if (type == -1) {
                    ans[qri0] = difcnt;
                } else if (type == -2) {
                    ans[qri0] = cursm + grow * (t0 - tpv) - sm;
                } else {
                    ll ai = lower_bound(cpr.begin(), cpr.end(), a[type]) - cpr.begin();
                    ll j = su.gst(ai);
                    ans[qri0] = cpr[j] + (m - j - 1) * t0;
                }
                ++qri;
            }
            break;
        }
        auto it = time_unite.begin();
        ll tm = it->first;
        ll i = it->second;
        time_unite.erase(time_unite.begin());
        while (qri < q && qrs[qri].first < tm) {
            auto [t0, jojo] = qrs[qri];
            auto [type, qri0] = jojo;
            if (type == -1) {
                ans[qri0] = difcnt;
            } else if (type == -2) {
                ans[qri0] = cursm + grow * (t0 - tpv) - sm;
            } else {
                ll ai = lower_bound(cpr.begin(), cpr.end(), a[type]) - cpr.begin();
                ll j = su.gst(ai);
                ans[qri0] = cpr[j] + (m - j - 1) * t0;
            }
            ++qri;
        }
        cursm += (tm - tpv) * grow;
        grow -= cnt[i];
        tpv = tm;
        --difcnt;
        if (i + 1 < n)
            su.unite(i, i + 1);
    }
    for (ll i = 0; i < q; ++i)
        cout << ans[i] << '\n';
}
