#include <iostream>
#include <map>
#include <vector>
#include <algorithm>
using namespace std;
using ll = long long;

const ll MAXN = 3e5 + 123;
ll a[MAXN];

struct dsu {
    void resize(ll n) {
        rt.resize(n);
        for (ll i = 0; i < n; ++i)
            rt[i] = i;
    }

    ll gst(ll i) {
        if (rt[i] == i)
            return i;
        return rt[i] = gst(rt[i]);
    }

    void unite(ll i, ll j) {
        i = gst(i);
        j = gst(j);
        rt[min(i, j)] = max(i, j);
    }
 private:
    vector<ll> rt;
};

struct stree {
    void assign(vector<ll> brds) {
        sz = brds.size(); 
        sm.resize(sz * 2 - 1);
        mod.resize(sz * 2 - 1);
        compr = brds;
    }

    void add(int l, int r, ll x) {
        add(0, 0, sz, l, r, x);
    }

    ll get(int l, int r) {
        return get(0, 0, sz, l, r);
    }
    
 private:
    ll sz;
    vector<ll> compr;
    vector<ll> sm;
    vector<ll> mod;

    void add(int ind, int lnd, int rnd, int l, int r, ll x) {
        if (lnd >= l && rnd <= r) {
            sm[ind] += x * (compr[rnd] - compr[lnd]);
            mod[ind] += x;
            return;
        } else if (lnd >= r || rnd <= l) {
            return;
        }
        int mnd = (lnd + rnd) / 2;
        int chd = ind + (mnd - lnd) * 2;
        add(ind + 1, lnd, mnd, l, r, x);
        add(chd, mnd, rnd, l, r, x);
        sm[ind] = sm[ind + 1] + sm[chd] + mod[ind] * (compr[rnd] - compr[lnd]);
    }

    ll get(int ind, int lnd, int rnd, int l, int r) {
        if (lnd >= l && rnd <= r) {
            return sm[ind];
        } else if (lnd >= r || rnd <= l)
            return 0;
        int mnd = (lnd + rnd) / 2;
        int chd = ind + (mnd - lnd) * 2;
        return get(ind + 1, lnd, mnd, l, r) + get(chd, mnd, rnd, l, r) + mod[ind] * (compr[min(r, rnd)] - compr[max(l, lnd)]);
    }
};

signed main() {
    ll n, q;
    cin >> n >> q;
    vector<ll> cpr;
    ll sm = 0;
    for (ll i = 0; i < n; ++i) {
        cin >> a[i];
        sm += a[i];
        cpr.push_back(a[i]);
    }
    sort(cpr.begin(), cpr.end());
    cpr.resize(unique(cpr.begin(), cpr.end()) - cpr.begin());
    ll m = cpr.size();
    
    vector<ll> cnt(m);
    for (ll i = 0; i < n; ++i) {
        ll j = lower_bound(cpr.begin(), cpr.end(), a[i]) - cpr.begin();
        ++cnt[j];
    }
    for (ll i = 1; i < m; ++i)
        cnt[i] += cnt[i - 1];

    vector<pair<ll, pair<ll, ll>>> qrs;
    vector<pair<ll, pair<ll, ll>>> qrs_3;
    for (ll i = 0; i < q; ++i) {
        ll t;
        cin >> t;
        if (t == 1 || t == 2) {
            ll k;
            cin >> k;
            qrs.push_back({k, {-t, i}});
        } else {
            ll k, j;
            cin >> k >> j;
            --j;
            qrs_3.push_back({a[j], {k, i}});
        }
    }
    sort(qrs.begin(), qrs.end());
    sort(qrs_3.begin(), qrs_3.end());
    ll grow = 0;
    for (ll i = 1; i < m; ++i) {
        grow += cnt[i - 1];
    }
    vector<ll> unite_time(m - 1);
    multimap<ll, ll> time_unite;
    for (ll i = 0; i + 1 < m; ++i) {
        unite_time[i] = cpr[i + 1] - cpr[i];
        time_unite.insert({unite_time[i], i});
    }
    ll cursm = sm;
    ll difcnt = m;
    ll tpv = 0;
    ll qri = 0;
    vector<ll> ans(q, -1);
    dsu su;
    su.resize(n);
    q = qrs.size();

    while (qri < q) {
        if (time_unite.empty()) {
            while (qri < q) {
                auto [t0, jojo] = qrs[qri];
                auto [type, qri0] = jojo;
                if (type == -1) {
                    ans[qri0] = difcnt;
                } else if (type == -2) {
                    ans[qri0] = cursm + grow * (t0 - tpv) - sm;
                }
                ++qri;
            }
            break;
        }
        auto it = time_unite.begin();
        ll tm = it->first;
        ll i = it->second;
        time_unite.erase(time_unite.begin());
        while (qri < q && qrs[qri].first < tm) {
            auto [t0, jojo] = qrs[qri];
            auto [type, qri0] = jojo;
            if (type == -1) {
                ans[qri0] = difcnt;
            } else if (type == -2) {
                ans[qri0] = cursm + grow * (t0 - tpv) - sm;
            }
            ++qri;
        }
        cursm += (tm - tpv) * grow;
        grow -= cnt[i];
        tpv = tm;
        --difcnt;
        if (i + 1 < n)
            su.unite(i, i + 1);
    }
    q = qrs_3.size();
    vector<ll> times(m);
    for (int i = 0; i < m - 1; ++i)
        times[i] = unite_time[i];
    for (int i = 0; i < q; ++i) {
        times.push_back(qrs_3[i].second.first);
    }
    
    sort(times.begin(), times.end());
    times.resize(unique(times.begin(), times.end()) - times.begin());
    int tsz = times.size();
    vector<ll> WHAT(tsz);
    stree tr;
    tr.assign(times);
    for (int i = m - 1; i >= 0; --i) {
        while (qrs_3.size() && qrs_3.back().first == cpr[i]) {
            auto [t0, qri0] = qrs_3.back().second;
            int t0i = lower_bound(times.begin(), times.end(), t0) - times.begin();
            ans[qri0] = cpr[i];
            // cout << "[" << qri0 << ' ' << t0i << "]" << endl;
            for (int j = 0; j < t0i; ++j)
                ans[qri0] += WHAT[j] * (times[j + 1] - times[j]);
            // ans[qri0] = tr.get(0, t0i);
            qrs_3.pop_back();
        }
        if (i) {
            ll tmax = lower_bound(times.begin(), times.end(), unite_time[i - 1]) - times.begin();
            for (int j = 0; j < tmax; ++j)
                WHAT[j] += 1;
            // for (int j = 0; j < tsz; ++j)
            //     cout << "(" << times[j] << ' ' << WHAT[j] << ") ";
            // cout << endl;
        }
    }
    for (auto x : ans)
        cout << x << '\n';
}
