#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <tuple>
#include <set>
using namespace std;

int n, m;
int INF = 1e9;

vector<vector<int>> g;
vector<int> used;
vector<int> h;
vector<int> minh;

int dfs(int v, int p, int t)
{
    used[v] = t;
    int min_h = INF;
    bool ch = false;
    for (int u:g[v])
    {
        if (u != p)
        {
            if (used[u] == t)
            {
                min_h = min(min_h, h[u]);
            }
            else
            {
                ch = true;
                h[u] = h[v] + 1;
                min_h = min(min_h, dfs(u, v, t));
            }
        }
    }
    minh[v] = min_h;
    return min_h;
}

void solution(int t)
{
    auto ch = &h;
    cin >> n >> m;
    g.clear();
    g.resize(n);
    int u, v;
    for (int i = 0; i < m; i++)
    {
        cin >> u >> v;
        u--;
        v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    used.resize(n, 0);
    h.clear();
    h.resize(n, 0);
    minh.clear();
    minh.resize(n, 0);
    dfs(0, -1, t);

    vector<bool> usedup(n, false);
    vector<bool> useddown(n, false);
    queue<tuple<int, int, bool>> q;
    vector<int> ans(n, -1);
    q.push({0, 0, true});
    while (!q.empty())
    {
        auto [v, l, up] = q.front();
        q.pop();
        if ((up && usedup[v]) || (!up && useddown[v]))
        {
            continue;
        }
        if (up)
        {
            usedup[v] = true;
            ans[v] = l;
            for (int u:g[v])
            {
                q.push({u, l + 1, false});
            }
        }
        else
        {
            useddown[v] = true;
            for (int u:g[v])
            {
                if (minh[u] < h[v])
                {
                    q.push({u, l + 1, true});
                }
            }
        }
    }
    for (int i = 1; i < n; i++)
    {
        cout << ans[i] << " ";
    }
    cout << endl;
}

int main() {
    int t;
    cin >> t;
    for (int i = 0; i < t; i++)
    {
        solution(i + 1);
    }
}
