#ifdef DEBUG
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using vi = vector<ll>;
using ii = pair<ll, ll>;
using vii = vector<ii>;
using vvi = vector<vi>;
using vvii = vector<vii>;
using vsi = vector<set<ll>>;
using vb = vector<bool>;
using vvb = vector<vb>;
using vc = vector<char>;
using vvc = vector<vc>;

template<class T, class Y>
istream &operator>>(istream &s, pair<T, Y> &p) {
  return s >> p.first >> p.second;
}

template<class T>
istream &operator>>(istream &s, vector<T> &v) {
  for (auto &e : v) s >> e;
  return s;
}

template<class T>
ostream &operator<<(ostream &s, const vector<T> &v) {
  for (const auto &e : v) s << e << ' ';
  return s;
}

void solve();

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  cout.setf(ios::fixed);
  cout.precision(30);

  solve();
}

bool debug =
#ifdef DEBUG
    true
#else
false
#endif
;

// --------


void solve() {
  string x;
  cin >> x;
  ll y;
  cin >> y;
  ll n = (ll) x.size();
  if (y == 1 and !debug) {
    sort(x.rbegin(), x.rend());
    cout << x << endl;
    return;
  }

  bool only_12 = true;
  for (auto c : x) {
    if (c != '1' and c != '2') {
      only_12 = false;
      break;
    }
  }

  string ans;

  if (only_12) {
    ll cnt1 = 0;
    ll id = 0;
    for (auto c : x) {
      if (c == '1') ++cnt1;
      else {
        ll cost = cnt1 * y;
        ll profit = 1;
        bool ok = false;
        for (ll i = 0; i < cnt1; ++i) {
          profit *= 10;
          if (profit > cost) {
            ok = true;
            break;
          }
        }
        profit -= 1;
        for (ll i = 0; i < n - id - 1; ++i) {
          profit *= 10;
          if (profit >= cost) {
            ok = true;
            break;
          }
        }
        if (ok) {
          swap(x[id], x[id - cnt1]);
        } else {
          break;
        }
      }
      ++id;
    }
//    cout << x << endl;
//    return;
    ans = x;
  }

  ll pos = 0;
  for (int i = 9; i >= 0; --i) {
    for (int j = 0; j < n; ++j) {
      if (x[j] == i + '0') {
        __int128_t cost = (j - pos) * y;
        __int128_t before = 0, after = 0;
        for (ll k = pos; k <= j; ++k) {
          before *= 10;
          before += x[k] - '0';
        }
        after = x[j] - '0';
        for (ll k = pos; k <= j - 1; ++k) {
          after *= 10;
          after += x[k] - '0';
        }
        __int128_t profit = after - before;
        for (int k = 0; k < n - j - 1; ++k) {
          profit *= 10;
        }
        if (profit >= cost) {
          x = x.substr(0, pos) + x[j] + x.substr(pos, j - pos) + x.substr(j + 1, n - j - 1);
          ++pos;
        } else {
          break;
        }
      }
    }
  }
  if (only_12) assert(ans == x);
  cout << x << endl;
}