#include <iostream>
#include <vector>
#include <set>
#include <iomanip>
#include <string>
#include <assert.h>
#include <algorithm>
#include <cmath>

using namespace std;

using ll = long long;

#define all(x) begin(x), end(x)
#define rall(x) rbegin(x), rend(x)

const int mod = 1e9 + 7;
const int N = 400000;

pair<int, int> c[N];
int ans[N];
int a[N];

int p[N];
int sz[N];

int par(int v)
{
	if (p[v] == v) return v;
	return p[v] = par(p[v]);
}

int unite(int a, int b)
{
	a = par(a);
	b = par(b);
	if (a != b)
	{
		if (sz[a] < sz[b])
			swap(a, b);
		p[b] = a;
		sz[a] += sz[b];
		return -1;
	}
	return 0;
}

void solve()
{
	int n, m;
	cin >> n >> m;

	for (int i = 0; i < n; i++)
	{
		cin >> c[i].first;
		c[i].second = i;
	}

	sort(c, c + n);

	for (int i = 0; i < n; i++)
	{
		//p[c[i].second] = i;
		a[i] = c[i].first;
		p[i] = i;
		sz[i] = 1;
	}

	vector<vector<int>> sw;

	for (int i = 0; i < n - 1; i++)
	{
		sw.push_back({ a[i + 1] - a[i], i, i + 1 });
	}

	sort(all(sw));
	vector<vector<int>> q(m, vector<int>(3));

	for (int i = 0; i < m; i++)
	{
		cin >> q[i][1] >> q[i][0];
		q[i][2] = i;
	}

	sort(all(q));
	int j = 0;
	int kek = n;

	for (int i = 0; i < m; i++)
	{
		while (j < sw.size() && sw[j][0] <= q[i][0])
		{
			kek += unite(sw[j][1], sw[j][2]);
			j++;
		}

		ans[q[i][2]] = kek;
	}

	for (int i = 0; i < m; i++)
	{
		cout << ans[i] << '\n';
	}

}

signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int t = 1;
	// cin >> t;

	while (t--)
	{
		solve();
	}

	return 0;
}