#include <iostream>
#include <vector>
#include <set>
#include <queue>
#include <iomanip>
#include <string>
#include <assert.h>
#include <algorithm>
#include <cmath>

using namespace std;

using ll = long long;

#define int ll

const int inf = 1e9;

#define all(x) begin(x), end(x)
#define rall(x) rbegin(x), rend(x)

const int N = 4010;

int g[N][N];
vector<int> T[N];

int used[N];
ll _min = inf;

int dfs(int v, int w)
{
	if (v == w)
	{
		used[v] = 2;
		return 1;
	}
	used[v] = 1;
	for (int u : T[v])
	{
		if (!used[u] && g[v][u] != 0)
		{
			if (dfs(u, w))
			{
				_min = min(_min, g[v][u]);
				used[v] = 2;
				return 1;
			}
		}
	}
	return 0;
}
void dfs_set(int v, int w)
{
	if (v == w)
	{
		return;
	}

	used[v] = 0;	
	for (int u : T[v])
	{
		if (used[u] == 2)
		{
			dfs_set(u, w);
			g[v][u] -= _min;
			g[u][v] += _min;
			return;

		}
	}
}

void solve()
{
	int n, m;
	cin >> n >> m;

	vector<int> a(n);
	vector<pair<int, int>> b(m);
	vector<int> c(m);
	vector<int> t(m);

	for (int i = 0; i < n; i++)
	{
		cin >> a[i];
	}

	for (int j = 0; j < m; j++)
	{
		cin >> b[j].first >> b[j].second >> c[j] >> t[j];
		b[j].first--;
		b[j].second--;
	}

	for (int x = 0; x < n; x++)
	{
		/*for (int i = 0; i < n + m + 2; i++)
		{
			for (int j = 0; j < n + m + 2; j++)
			{
				g[i][j] = 0;
			}
			T[i].clear();
		}

		for (int i = 0; i < n; i++)
		{
			g[i][n + m] = a[i];
			T[i].push_back(n + m);
			T[n + m].push_back(i);
		}*/

		int l = 0, r = 0;

		for (int j = 0; j < m; j++)
		{
			l = b[j].first, r = b[j].second;
			if (t[j] == 1)
			{
				l = min(b[j].first, x);
				r = max(b[j].second, x);
			}

			/*for (int i = l; i <= r; i++)
			{
				g[n + j][i] = c[j];
				T[n + j].push_back(i);
				T[i].push_back(n + j);
			}
			g[n + m + 1][n + j] = c[j];
			T[n + m + 1].push_back(n + j);
			T[n + j].push_back(n + m + 1);*/
		}

		int ans = 0;
		
		int k = c[0];

		for (int i = l; i <= r; i++)
		{
			if (k == 0) break;
			int add = min(a[i], k);
			k -= add;
			ans += add;
		}

		cout << ans << " ";
		
		/*
		while (dfs(n + m + 1, n + m))
		{
			dfs_set(n + m + 1, n + m);
			fill(used, used + n + m + 2, 0);
			ans += _min;
		}*/

	}
	cout << '\n';
}

signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int t = 1;
	cin >> t;

	while (t--)
	{
		solve();
	}

	return 0;
}