#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;

#define int ll
#define len(a) (int)(a).size()
#define all(a) (a).begin(), (a).end()


__int128 binpow(__int128 base, int power) {
    __int128 res = 1;
    while (power > 0) {
        if (power & 1)
            res *= base;
        base *= base;
        power >>= 1;
    }
    return res;
}

struct segmenttree {
    int n = 1;
    vector<int> tree;

    segmenttree(int l) {
        while (n < l) n <<= 1;
        tree.resize(n * 2);
    }

    void update(int l, int r, int u) {
        for (l += n, r += n; l < r; l >>= 1, r >>= 1) {
            if (l & 1) tree[l++] += u;
            if (r & 1) tree[--r] += u;
        }
    }

    int query(int t) {
        int res = 0;
        for (t += n; t > 0; t >>= 1) {
            res += tree[t];
        }
        return res;
    }
};

void solve() {
    string x;
    ll y;
    cin >> x >> y;
    int n = len(x);
    vector<stack<int>> positions(10);
    for (int i = n - 1; i >= 0; --i) {
        positions[x[i] - '0'].push(i);
    }
    vector<bool> used(n);
    segmenttree shift(n);
    int current = x[0] - '0';
    for (int i = 0; i < n; ++i) {
        int next_digit = current;
        int pow_10 = n - i - 1;
        if (pow_10 >= 25) {
            for (int possible_next_digit = current + 1; possible_next_digit < 10; ++possible_next_digit) {
                if (!positions[possible_next_digit].empty()) {
                    next_digit = possible_next_digit;
                }
            }
        } else {
            __int128 value = 0;
            for (int possible_next_digit = current + 1; possible_next_digit < 10; ++possible_next_digit) {
                // gain = 10 ** (n - i - 1) * digits_difference
                // loss = y * positions_difference
                // if gain > __int128max -> loss does not matter // not true
                if (positions[possible_next_digit].empty())
                    continue;
                int pos = positions[possible_next_digit].top();
                pos += shift.query(pos);
                __int128 current_value = binpow((__int128)10, pow_10) * (possible_next_digit - current) - (__int128)y * (pos - i);
                if (value < current_value) {
                    next_digit = possible_next_digit;
                    value = current_value;
                }
            }
        }
        int pos = positions[next_digit].top();
        positions[next_digit].pop();
        shift.update(0, pos, 1);
        used[pos] = true;
        if (next_digit == current) {
            while (used[pos]) {
                ++pos;
            }
            if (pos < n)
                current = x[pos] - '0';
        }
        cout << next_digit;
    }
    cout << "\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    solve();
    return 0;
}