#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;

#define int ll
#define len(a) (int)(a).size()
#define all(a) (a).begin(), (a).end()


__int128 binpow(__int128 base, int power) {
    __int128 res = 1;
    while (power > 0) {
        if (power & 1)
            res *= base;
        base *= base;
        power >>= 1;
    }
    return res;
}

struct segmenttree {
    int n = 1;
    vector<int> tree;

    segmenttree(int l) {
        while (n < l) n <<= 1;
        tree.resize(n * 2);
    }

    void update(int l, int r, int u) {
        for (l += n, r += n; l < r; l >>= 1, r >>= 1) {
            if (l & 1) tree[l++] += u;
            if (r & 1) tree[--r] += u;
        }
    }

    int query(int t) {
        int res = 0;
        for (t += n; t > 0; t >>= 1) {
            res += tree[t];
        }
        return res;
    }
};

void solve() {
    int n, q;
    cin >> n >> q;
    vector<pair<ll, int>> c(n);
    for (auto & e : c)
        cin >> e.first;
    for (int i = 0; i < n; ++i) {
        c[i].second = i;
    }
    sort(all(c));
    vector<int> player_position(n);
    for (int i = 0; i < n; ++i) {
        player_position[c[i].second] = i;
    }
    vector<ll> diffs;
    vector<ll> breakpoints;
    for (int i = 1; i < n; ++i) {
        breakpoints.emplace_back(c[i].first - c[i - 1].first);
    }
    sort(all(breakpoints));
    vector<pair<ll, int>> breakpoints_compressed = {{breakpoints[0], 1}};
    for (int i = 1; i < n; ++i) {
        if(breakpoints[i] != breakpoints[i - 1])
            breakpoints_compressed.emplace_back(breakpoints[i], 1);
        else
            breakpoints_compressed.back().second++;
    }
    vector<ll> breakpoint_rounds(len(breakpoints_compressed));
    vector<int> round_sum_change(len(breakpoints_compressed));
    vector<ll> sum_before_round(len(breakpoints_compressed));
    int cnt_unique = n;
    for (int i = 0; i < len(breakpoints_compressed); ++i) {
        breakpoint_rounds[i] = breakpoints_compressed[i].first;
        sum_before_round[i] = cnt_unique * (breakpoint_rounds[i] - (i == 0 ? 0 : breakpoint_rounds[i - 1])) + (i == 0 ? 0 : sum_before_round[i - 1]);
        cnt_unique -= breakpoints_compressed[i].second;
        round_sum_change[i] = cnt_unique;
    }

    while (q--) {
        int t;
        cin >> t;
        if (t == 1) {
            ll k;
            cin >> k;
            cout << n - (upper_bound(all(breakpoints), k) - breakpoints.begin()) << "\n";
        }
        if (t == 2) {
            ll k;
            cin >> k;
            int prev_change_round_i = upper_bound(all(breakpoint_rounds), k) - breakpoint_rounds.begin() - 1;
            if (prev_change_round_i == -1) {
                cout << k * n << "\n";
            } else {
                cout << sum_before_round[prev_change_round_i] + round_sum_change[prev_change_round_i] *
                    (breakpoint_rounds[prev_change_round_i]) << "\n";
            }
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    solve();
    return 0;
}