#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <queue>

using namespace std;
using ll = long long;
using vi = vector<int>;
using vll = vector<ll>;

const int INF = 1e9 + 9;

/*
void dfs(int v, int p, vector<int>& h, vector<int>& dp, vector<vector<int>>& g) {
    for (int i : g[v]) {
        if (h[i] == INF) {
            h[i] = h[v] + 1;
            dfs(i, v, h, dp, g);
            dp[v] = min(dp[v], dp[i]);
        } else if (i != p && p != -1) {
            dp[p] = min(dp[v], h[i]);
        }
    }
}
*/

void dfs(int v, int u, vector<int>& color, const vector<vector<int>>& g, int c) {
    color[v] = c;

    for (int i : g[v]) {
        if (i != u && color[i] != c) {
            dfs(i, u, color, g, c);
        }
    }
}

int f(const vector<int>& a, const vector<int>& b) {
    int n = a.size(), m = b.size(), i = 0, j = 0;
    while (i < n && j < m) {
        if (a[i] == b[j]) {
            return a[i];
        }
        if (a[i] < b[j]) {
            ++i;
        } else {
            ++j;
        }
    }
    return -1;
}

void solve() {
    int n, m, u, v, mtime = 0;
    cin >> n >> m;
    vector<vi> g(n);
    vi ans(n, INF), h(n, INF), dp(n, INF), used(n, 0);
    ans[0] = 0;
    for (int i = 0; i < m; ++i) {
        cin >> u >> v;
        --u;
        --v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    for (int i = 0; i < n; ++i) {
        sort(g[i].begin(), g[i].end());
    }

    vector<vector<int>> color(n, vector<int>(n, -1));
    for (int i = 0; i < n; ++i) {
        for (int j = 0, col = 0; j < n; ++j) {
            if (j != i && color[i][j] == -1) {
                dfs(j, i, color[i], g, col);
                ++col;
            }
        }
    }

    queue<int> q;
    q.push(0);
    while (!q.empty()) {
        v = q.front();
        q.pop();
        for (int i = 0; i < n; ++i) {
            if (ans[i] <= ans[v] + 2) {
                continue;
            }
            u = f(g[i], g[v]);
            if (u == -1) {
                continue;
            }
            if (color[u][i] != color[u][v]) {
                continue;
            }
            ans[i] = ans[v] + 2;
            q.push(i);
        }
    }
    for (int i = 1; i < n; ++i) {
        if (ans[i] == INF) {
            cout << -1 << ' ';
        } else {
            cout << ans[i] << ' ';
        }
    }
    cout << '\n';
}

int main() {
    int t;
    cin >> t;
    for (; t; --t) {
        solve();
    }
    return 0;
}
