#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <queue>

using namespace std;
using ll = long long;
using vi = vector<int>;
using vll = vector<ll>;

const int INF = 1e9 + 9;

struct robot {
    int l, r, c;
    bool t;

    robot() = default;
    robot(int l, int r, int c, bool t) : l(l), r(r), c(c), t(t) {}
};

ll solve0(const vi& a, const vector<robot>& r, int x) {
    int n = a.size(), m = r.size(), c;
    vi b(n, 0), d(m, 0);
    ll res = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (b[i] == a[i]) {
                break;
            }
            if (r[j].t) {
                if (i < min(x, r[j].l) || max(x, r[j].r) < i) {
                    continue;
                }
            } else {
                if (i < r[j].l || r[j].r < i) {
                    continue;
                }
            }
            c = min(r[j].c - d[j], a[i] - b[i]);
            d[j] += c;
            b[i] += c;
        }
        res += b[i];
    }
    return res;
}

void solve() {
    int n, m;
    cin >> n >> m;
    vi a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<robot> r(m);
    for (int i = 0; i < m; ++i) {
        cin >> r[i].l >> r[i].r >> r[i].c >> r[i].t;
        --r[i].l;
        --r[i].r;
    }

    for (int i = 0; i < n; ++i) {
        cout << solve0(a, r, i) << ' ';
    }
    cout << '\n';
}

int main() {
    int t;
    cin >> t;
    for (; t; --t) {
        solve();
    }
    return 0;
}
