#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>

#pragma GCC optimize("O3")
#pragma GCC target("avx2")

const int maxN = 5e5;

bool used[maxN];
int t, n, m, u, v, dist[maxN], p[maxN], ban[maxN], dp[maxN], ans;
std::vector<int> gr[maxN], path, bad;
std::queue<int> q;

void bfs() {
	std::fill(dist, dist + n, n + 1);
	q.push(0);
	dist[0] = 0;
	while (!q.empty()) {
		u = q.front();
		q.pop();
		used[u] = false;
		for (int v : gr[u])
			if (dist[v] > dist[u] + 1) {
				dist[v] = dist[u] + 1;
				p[v] = u;
				if (!used[v])
					q.push(v);
				used[v] = true;
			}
	}
}

void dfs(int u) {
	used[u] = true;
	for (int v : gr[u])
		if (ban[v] != -1)
			dp[u] = std::max(dp[u], ban[v]);
		else {
			if (!used[v])
				dfs(v);
			dp[u] = std::max(dp[u], dp[v]);
		}
}

int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(0);
	std::cout.tie(0);
	std::cin >> t;
	while (t--) {
		std::cin >> n >> m;
		for (int i = 0; i < n; i++)
			gr[i].clear();
		while (m--) {
			std::cin >> u >> v;
			gr[--u].push_back(--v);
			gr[v].push_back(u);
		}
		bfs();
		for (int i = 1; i < n; i++)
			if (dist[i] == n + 1)
				std::cout << "-1 ";
			else
				std::cout << dist[i] / 2 + 1 << " ";
		std::cout << "\n";
	}
	return 0;
}