#include<bits/stdc++.h>

using std::cin;
using std::cout;
using std::cerr;
using std::vector;
using std::string;
using std::pair;

using ll = long long;
using ld = long double;

//#define int ll

int getRand() {
	return (rand() << 16) + rand();
}

struct Node {
	Node* l = nullptr;
	Node* r = nullptr;
	ll x = 0;
	ll a = 0, b = 0;
	int sum = 1, y = getRand();
	int ind = 0;
};

int getSum(Node* v) {
	return (v == nullptr ? 0 : v->sum);
}

void update(Node* v) {
	v->sum = getSum(v->l) + getSum(v->r) + 1;
}

void apply(Node* v, ll a, ll b) {
	if(v == nullptr)
		return;
	v->a += a;
	v->b += b;
	v->x += b + a * getSum(v->l);
}

void push(Node* v) {
	apply(v->l, v->a, v->b);
	apply(v->r, v->a, v->b + (getSum(v->l) + 1) * v->a);
	v->a = 0, v->b = 0;
}

Node* merge(Node* l, Node* r) {
	if(l == nullptr)
		return r;
	if(r == nullptr)
		return l;
	if(l->y > r->y) {
		push(l);
		l->r = merge(l->r, r);
		update(l);
		return l;
	} else {
		push(r);
		r->l = merge(l, r->l);
		update(r);
		return r;
	}
}

Node* erase(Node* root, int ind) {
	assert(root != nullptr);
	push(root);
	if(root->ind == ind) {
		return merge(root->l, root->r);
	}
	if(root->ind > ind) {
		root->l = erase(root->l, ind);
		update(root);
		return root;
	} else {
		root->r = erase(root->r, ind);
		update(root);
		return root;
	}
}

pair<ll, ll> get(Node* root, int ind1) {
	assert(root != nullptr);
	if(root->ind == ind1)
		return {root->x, getSum(root->l)};
	ll ind, res;
	push(root);
	if(root->ind > ind1) {
		std::tie(res, ind) = get(root->l, ind1);
		res += root->b + root->a * ind;
		return {res, ind};
	} else {
		std::tie(res, ind) = get(root->r, ind1);
		ind += 1 + getSum(root->l);
		res += root->b + root->a * ind;
		return {res, ind};
	}
}
/*
Node* erase(Node* root, ll x) {
	if(root == nullptr)
		return root;
	push(root);
	if(root->x == x)
		return merge(erase(root->l, x), erase(root->r, x));
	return root;
}

Node* prune(Node* root, ll x) {
	assert(root != nullptr);
	push(root);
	if(root->x == x) {
		root->l = erase(root->l, x);
		root->r = erase(root->r, x);
		update(root);
		return merge(erase(root->l, x), erase(root->r, x));
	}
	if(root->x > x) {
		root->l = prune(root->l, x);
		update(root);
		return root;
	} else {
		root->r = prune(root->r, x);
		update(root);
		return root;
	}
}
*/

Node* build(vector<Node*> nodes) {
	vector<Node*> st;
	for(Node* v : nodes) {
		while(!st.empty() && st.back()->y < v->y) {
			v->l = st.back();
			update(v);
			st.pop_back();
		}
		if(!st.empty()) {
			st.back()->r = v;
			update(st.back());
		}
		st.push_back(v);
	}
	return st[0];
}

struct Query {
	int t, i;
	ll k;
	int ind;
};

signed main() {
	std::ios_base::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	int n, q;
	cin >> n >> q;

	vector<ll> c(n);
	for(ll &i : c)
		cin >> i;
	vector<int> ind(n);
	for(int i = 0; i < n; ++i)
		ind[i] = i;
	std::stable_sort(ind.begin(), ind.end(), [&](int a, int b){
		return c[a] < c[b];
	});
	std::set<pair<ll, int>> s;
	std::set<int> cur;
	vector<Node*> nodes;
	vector<ll> dist1(n);
	for(int i = 0; i < n; ++i) {
		if(i == n - 1 || c[ind[i]] != c[ind[i + 1]]) {
			if(i != n  - 1) {
				s.insert({c[ind[i + 1]] - c[ind[i]], i});
				dist1[i] = c[ind[i + 1]] - c[ind[i]];
			}
			nodes.push_back(new Node);
			nodes.back()->x = c[ind[i]];
			nodes.back()->ind = i;
			cur.insert(i);
		}
	}
	ll buf = 0;
	int cnt = 0;
	int last = n;
	for(int i = n - 1; i > - 1; --i) {
		if(i == 0 || c[ind[i - 1]] != c[ind[i]]) {
			buf += cnt * (ll)(last - i);
			last = i;
			++cnt;
		}
	}
	vector<int> ind1(n);
	for(int i = 0; i < n; ++i)
		ind1[ind[i]] = i;
	Node* root = build(nodes);
	vector<Query> qs;
	for(int ind = 0; ind < q; ++ind) {
		int t;
		cin >> t;
		--t;
		ll k;
		cin >> k;
		qs.push_back(Query{t, 0, k});
		qs.back().ind = ind;
		if(t == 2) {
			cin >> qs.back().i;
			--qs.back().i;
		}
	}

	std::sort(qs.begin(), qs.end(), [](auto& a, auto& b){
		return a.k < b.k;
	});

	vector<ll> ans(q);
	ll pos = 0;
	ll past = 0;
	ll sum = 0;
	ll done = 0;
	while(pos < q) {
		ll min = 1e18;
		if(!s.empty())
			min = s.begin()->first - past;
		ll n = s.size() + 1;
		for(; pos < q && qs[pos].k < past + min; ++pos) {
			if(qs[pos].t == 0)
				ans[qs[pos].ind] = n;
			if(qs[pos].t == 1)
				ans[qs[pos].ind] = sum + (qs[pos].k - past) * buf;
			if(qs[pos].t == 2) {
				int i = ind1[qs[pos].i];
				auto it = cur.lower_bound(i);
				assert(it != cur.end());
				auto p = get(root, *it);
				ans[qs[pos].ind] = p.first + (n - p.second - 1) * (qs[pos].k - past);
				//cout << qs[pos].k << ' ' << qs[pos].i << std::endl;
			}
		}
		past += min;
		sum += buf * min;
		apply(root, -min, min * (n - 1));
		while(!s.empty() && s.begin()->first == past) {
			int ind = s.begin()->second;
			cur.erase(ind);
			buf -= ind + 1;
			root = erase(root, ind);
			auto it1 = cur.lower_bound(ind);
			int last = n - 1;
			ll dist = s.begin()->first - past;
			s.erase(s.begin());
			if(it1 != cur.begin()) {
				last = *(--it1);
				dist += dist1[last] - past;
				s.erase({dist1[last], last});
				dist1[last] = dist + past;
				s.insert({dist1[last], last});
			}
		}
	}
	for(ll i : ans)
		cout << i << '\n';
	return 0;
}
