#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const int INF = 1e9;
const string ZERO = "0000000000000000000000000000";

void plus_(string& s, long long x) {
	string t = ZERO;
	int k = t.size() - 1;
	while (x > 0) {
		char c = x % 10 + 48;
		x /= 10;
		t[k] = c;
		--k;
	}
	vector<int> p(s.size(), 0);
	for (int i = s.size() - 1; i > 0; --i) {
		int sx = s[i] - 48, tx = t[i] - 48;
		int res = p[i] + sx + tx;
		int res1 = res % 10, res2 = res / 10;
		s[i] = res1 + 48;
		p[i - 1] = res2;
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);


	int n, q;
	cin >> n >> q;
	vector<pair<long long, long long>> sorted_c(n);
	vector<int> ind(n);
	vector<vector<long long>> c(1, vector<long long>(n)), p(1, vector<long long>(n, 0));
	vector<long long> k(1, 0), q1(1, 0);
	vector<pair<string, unsigned long long>> q2(1, { ZERO, 0ll });
	for (int i = 0; i < n; ++i) {
		cin >> c[0][i];
		sorted_c[i] = { c[0][i], i };
	}
	sort(sorted_c.begin(), sorted_c.end());
	reverse(sorted_c.begin(), sorted_c.end());
	for (int i = 0; i < n; ++i) {
		ind[sorted_c[i].second] = i;
		c[0][i] = sorted_c[i].first;
	}

	int j = 0, mini = 0;
	while (c[j][0] != c[j][n - 1]) {
		//cout << "J: " << j << "\n";
		int curk = INF;
		c.push_back(vector<long long>(n));
		p.push_back(vector<long long>(n, 0));
		k.push_back(0);
		q1.push_back(0);
		q2.push_back({ ZERO, 0ll });
		long long prev = 0, diff = 0;
		for (int i = mini; i < n; ++i) {
			if (c[j][i] == c[j][0]) {
				++mini;
				continue;
			}

			if (c[j][i] != c[j][i - 1]) {
				prev = i - 1;
				++diff;
			}

			p[j][i] = diff;
			long long v = p[j][i] - p[j][prev], d = c[j][prev] - c[j][i], t = d / v;
			if (t < curk)
				curk = t;
		}
		//cout << "curk: " << curk << "\n";
		for (int i = 0; i < n; ++i) {
			c[j + 1][i] = c[j][i] + curk * p[j][i];
			plus_(q2[j + 1].first, (c[j + 1][i] - c[0][i]));
			q2[j].second += p[j][i];
		}
		k[j + 1] = k[j] + curk;
		q1[j] = diff + 1;
		++j;
		if (curk == INF)
			break;
	}
	q1[j] = 1;
	
	for (int i = 0; i < q; ++i) {
		unsigned long long t, x;
		cin >> t >> x;
		
		long long l = 0, r = k.size();
		while (r - l > 1) {
			int m = (l + r) / 2;
			if (k[m] <= x)
				l = m;
			else
				r = m;
		}
		x -= k[l];

		if (t == 1) {
			cout << q1[l] << "\n";
		}
		if (t == 2) {
			string st = q2[l].first;
			plus_(st, q2[l].second * x);
			bool first = true;
			for (int i = 0; i < st.size(); ++i) {
				if (st[i] == '0') {
					if (!first)
						cout << st[i];
				}
				else {
					first = false;
					cout << st[i];
				}
			}
			cout << "\n";
		}
		if (t == 3) {
			int y;
			cin >> y;
			cout << c[l][ind[y - 1]] + p[l][ind[y - 1]] * x << "\n";
		}
	}
}