#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <utility>

using namespace std;

struct vert
{
	vert* ls, *rs;
	long long l, r;
	vector <long long> v;
	vector <long long> pv;
};

void build(vert* a, long long l, long long r, vector <long long>& b) {
	a->l = l;
	a->r = r;
	a->ls = nullptr;
	a->rs = nullptr;
	if (r - l == 1) {
		a->v = {};
		a->v.push_back(b[l]);
		a->pv = { 0, b[l] };
		return;
	}
	a->ls = new vert;
	a->rs = new vert;
	build(a->ls, l, (r + l) / 2, b);
	build(a->rs, (l + r) / 2, r, b);
	a->v.resize(r - l);
	std::merge(a->ls->v.begin(), a->ls->v.end(), a->rs->v.begin(), a->rs->v.end(), a->v.begin());
	a->pv = { 0 };
	for (long long i = 0; i < a->v.size(); i++) {
		a->pv.push_back(a->pv.back() + a->v[i]);
	}
}

long long getnum(vert* a, long long l, long long r, long long k) {
	if (a->r <= l || a->l >= r) return 0;
	if (a->l >= l && a->r <= r) {
		return upper_bound(a->v.begin(), a->v.end(), k) - a->v.begin();
	}
	return getnum(a->ls, l, r, k) + getnum(a->rs, l, r, k);
}

long long getsum(vert* a, long long l, long long r, long long k) {
	if (a->r <= l || a->l >= r) return 0;
	if (a->l >= l && a->r <= r) {
		return a->pv[upper_bound(a->v.begin(), a->v.end(), k) - a->v.begin()];
	}
	return getsum(a->ls, l, r, k) + getsum(a->rs, l, r, k);
}

signed main() {
	long long n, q;
	cin >> n >> q;
	vector <long long>a(n);
	map <long long, long long> b;
	map <long long, long long> bn;
	for (auto& i : a) cin >> i;
	for (auto& i : a) b[i]++;
	vector <pair <long long, long long>> c;
	for (auto& i : b) c.push_back(i);
	sort(c.begin(), c.end());
	vector <pair <long long, long long>> d;
	vector <long long> an, g, pa = { 0 }, ag, pag = { 0 }, d2;
	vector <long long> anold, gold, agold;
	long long p = 0, ans = 0 ;
	for (long long j = 0; j < c.size(); j++) bn[c[j].first] = j;
	for (long long i = 0; i < c.size() - 1; i++) {
		p += c[i].second;
		ans += c[i].second * (c.size() - i - 1);
		d.push_back(make_pair(c[i + 1].first - c[i].first, i));
		d2.push_back(c[i + 1].first - c[i].first);
		g.push_back(d.back().first);
		an.push_back(p);
		ag.push_back(g.back() * an.back());
		//pa.push_back(pa.back() + an.back());
		//pag.push_back(pag.back() + ag.back());
	}
	vert* root = new vert;
	if (c.size() > 1) build(root, 0, c.size() - 1, d2);
	sort(d.begin(), d.end());
	anold = an;
	gold = g;
	agold = ag;
	for (long long i = 0; i < c.size() - 1; i++) {
		an[i] = anold[d[i].second];
		g[i] = gold[d[i].second];
		ag[i] = agold[d[i].second];
		d2[i] = d[i].first;
	}
	for (long long i = 0; i < c.size() - 1; i++) {
		pa.push_back(pa.back() + an[i]);
		pag.push_back(pag.back() + ag[i]);
	}
	while (q--) {
		long long t, k;
		cin >> t >> k;
		if (t == 1) {
			cout << c.size() - (upper_bound(d2.begin(), d2.end(), k) - d2.begin()) << "\n";
		}
		if (t == 2) {
			long long l = upper_bound(d2.begin(), d2.end(), k - 1) - d2.begin();
			cout << ans * k - k * pa[l] + pag[l] << "\n";
		}
		if (t == 3) {
			long long i;
			cin >> i;
			if (c.size() == 1) {
				cout << a[0] << "\n";
				continue;
			}
			long long ans = a[i - 1];
			i = bn[a[i - 1]];
			ans += getsum(root, i, c.size(), k);
			ans += (c.size() - i - 1 - getnum(root, i, c.size(), k))* k;
			cout << ans << "\n";
		}
	}
}