#include <iostream>
#include <vector>
#include <algorithm>
#define int long long

using namespace std;

struct unite{
    int d, i;
    bool operator<(const unite &a) {
        return d < a.d;
    }
};

const int maxn = 12e5 + 1;

vector <int> val[maxn];
vector <int> p[maxn];
vector <unite> cd;

void build(int i, int l, int r) {
    if (l + 1 == r) {
        val[i] = {cd[l].d};
        p[i] = {0, cd[l].d};
        return;
    }
    int m = (l + r) / 2;
    build(2 * i + 1, l, m);
    build(2 * i + 2, m, r);
    val[i].resize(r - l);
    merge(val[2 * i + 1].begin(), val[2 * i + 1].end(),
          val[2 * i + 2].begin(), val[2 * i + 2].end(),
          val[i].begin());
    p[i].resize(r - l + 1);
    p[i][0] = 0;
    for (int j = 0; j < r - l; ++j) {
        p[i][j + 1] = p[i][j] + val[i][j];
    }
}

int get_sum1(int i, int tl, int tr, int ql, int qr, int x) {
    if (tr <= ql || qr <= tl) {
        return 0;
    }
    if (ql <= tl && tr <= qr) {
        return p[i][upper_bound(val[i].begin(), val[i].end(), x) - val[i].begin()];
    }
    int tm = (tl + tr) / 2;
    return get_sum1(2 * i + 1, tl, tm, ql, qr, x) + get_sum1(2 * i + 2, tm, tr, ql, qr, x);
}

int get_sum2(int i, int tl, int tr, int ql, int qr, int x) {
    if (tr <= ql || qr <= tl) {
        return 0;
    }
    if (ql <= tl && tr <= qr) {
        return upper_bound(val[i].begin(), val[i].end(), x) - val[i].begin();
    }
    int tm = (tl + tr) / 2;
    return get_sum2(2 * i + 1, tl, tm, ql, qr, x) + get_sum2(2 * i + 2, tm, tr, ql, qr, x);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    int n, q; cin >> n >> q;
    vector < pair <int, int> > c(n);
    int cp[n];
    int id[n];
    for (int i = 0; i < n; ++i) {
        cin >> c[i].first;
        cp[i] = c[i].first;
        c[i].second = i;
    }
    sort(c.begin(), c.end());
    vector <unite> d(1, {0, -1});
    vector <int> lv;
    int s = 0;
    int cnt = 1;
    id[c[0].second] = 0;
    for (int i = 1; i < n; ++i) {
        if (c[i].first != c[i - 1].first) {
            d.push_back({c[i].first - c[i - 1].first, s});
            cd.push_back({c[i].first - c[i - 1].first, s});
            lv.push_back(cnt);
            cnt = 1;
            s++;
        } else {
            cnt++;
        }
        id[c[i].second] = s;
    }
    lv.push_back(cnt);
    s++;
    vector <int> pl(s + 1, 0);
    for (int i = 1; i <= s; ++i) {
        pl[i] = pl[i - 1] + lv[i - 1];
    }
    sort(d.begin(), d.end());
    int ch[s];
    ch[0] = 0;
    cnt = 0;
    for (int i = s - 1; i >= 0; --i) {
        ch[0] += cnt * lv[i];
        cnt++;
    }
    for (int i = 0; i < s - 1; ++i) {
        ch[i + 1] = ch[i] - pl[d[i + 1].i + 1];
    }
    int pc[s]; pc[0] = 0;
    for (int i = 1; i < s; ++i) {
        int delt = d[i].d - d[i - 1].d;
        pc[i] = pc[i - 1] + ch[i - 1] * delt;
    }
    build(0, 0, s - 1);
    for (int qq = 0; qq < q; ++qq) {
        int t; cin >> t;
        if (t == 1) {
            int k; cin >> k;
            int l = 0, r = s;
            while (r - l > 1) {
                int m = (l + r) / 2;
                if (d[m].d <= k) {
                    l = m;
                } else {
                    r = m;
                }
            }
            cout << s - l << "\n";
        } else if (t == 2) {
            int k; cin >> k;
            int l = 0, r = s;
            while (r - l > 1) {
                int m = (l + r) / 2;
                if (d[m].d <= k) {
                    l = m;
                } else {
                    r = m;
                }
            }
            cout << pc[l] + (k - d[l].d) * ch[l] << "\n";
        } else {
            int k; cin >> k;
            int i; cin >> i;
            i--;
            int delta = cp[i];
            i = id[i];
            if (i == s - 1) {
                cout << delta << "\n";
                continue;
            }
            auto res1 = get_sum1(0, 0, s - 1, i, s - 1, k);
            auto res2 = get_sum2(0, 0, s - 1, i, s - 1, k);
            cout << delta + (s - 1 - i) * k - (res2 * k - res1) << "\n";
        }
    }
}
