#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm> 

using namespace std;
typedef long long ll;

vector<vector<int>>g;
int memory[1000][1000];
vector<int>ans;
int inf = 1e9;

void brute(int v = 0, int box = 0, int score = 0, int deep = 0) {
	if (score > 1000 || deep > 3000)
		return;
	if (memory[v][box] <= score)
		return;
	memory[v][box] = score;
	bool ok = false;
	for (auto u : g[v])
		if (u != box)
			brute(u, box, score, deep + 1);
		else
			ok = true;
	if (ok) {
		if (ans[v] != -1 && ans[v] <= score + 1)
			return;
		ans[v] = score + 1;
		for (auto u : g[v])
			if (u != box)
				brute(v, u, score + 2, deep + 1);
	}
}

void solveC(int n, int m) {
	g.resize(n);
	ans.resize(n, -1);
	for (int i = 0; i < m; i++) {
		int v, u;
		cin >> v >> u;
		v--; u--;
		g[v].push_back(u);
		g[u].push_back(v);
	}
	if (m == n - 1 || g[0].size() == 1) {
		for (int i = 0; i < n - 1; i++) {
			cout << "-1 ";
		}
		cout << '\n';
		g.clear();
		ans.clear();
		return;
	}
	for (int i = 0; i < n; i++)
		for (int j = 0; j < n; j++)
			memory[i][j] = inf;
	for (auto u : g[0]) {
		brute(0, u, 1);
	}
	for (int i = 1; i < n; i++) {
		cout << ans[i] << ' ';
	}
	cout << '\n';
	g.clear();
	ans.clear();
}

int main() {
	cin.tie(0);
	ios_base::sync_with_stdio(0);
	int t = 1;
	cin >> t;
	while (t--) {
		int n, m;
		cin >> n >> m;
		if (n <= 5000)
			solveC(n, m);
	}
	return 0;
}