#include <iostream>
#include <vector>
#include <deque>
#include <numeric>
#include <algorithm>
#include <map>
#define all(x) x.begin(), x.end()
using namespace std;
#define int long long

const int maxn = 4e5;

struct fenwick {
    int f[maxn];

    int get(int i) {
        int ans = 0;
        while (i >= 0) {
            ans += f[i];
            i = (i & (i + 1)) - 1;
        }
        return ans;
    }

    void upd(int i, int val) {
        while (i < maxn) {
            f[i] += val;
            i = (i | (i + 1));
        }
    }
};

int p[maxn];
int sz[maxn];
int maxId[maxn];
int add;
int a[maxn];
int memm[maxn];
int minId[maxn];
int cost[maxn];
fenwick f;
int mem = 0;

int col(int v) {
    return (v == p[v] ? v : p[v] = col(p[v]));
}
int n;

void unite(int u, int v, int dd) {
    u = col(u);
    v = col(v);
    if (sz[u] > sz[v]) swap(u, v);
    add -= min(maxId[v], maxId[u]) + 1;
    for (int j = n - 1; j >= 0; --j) {
        a[j] += dd * cost[j];
    }
    f.upd(0, -1);
    f.upd(min(maxId[v], maxId[u]) + 1, 1);
    for (int x = min(maxId[v], maxId[u]); x >= 0; --x) {
        --cost[x];
    }
    maxId[v] = max(maxId[v], maxId[u]);
    minId[v] = min(minId[v], minId[u]);
    sz[v] += sz[u];
    p[u] = v;
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int q;
    cin >> n >> q;
    iota(p, p + n, 0);
    iota(maxId, maxId + n, 0);
    iota(minId, minId + n, 1);
    for (int i = 0; i < n; ++i) {
        cost[i] = n - 1 - i;
    }
    fill(sz, sz + n, 1);
    vector<pair<int, int>> ff;
    map<int, int> per;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        ff.push_back({ a[i], i });
    }
    sort(all(ff));
    for (int i = 0; i < n; ++i) {
        per[ff[i].second] = i;
    }
    sort(a, a + n);
    vector<pair<int, int>> un;
    for (int i = 0; i + 1 < n; ++i) {
        un.push_back({ a[i + 1] - a[i], i });
    }
    sort(all(un));
    vector<pair<pair<int, int>, pair<int, int>>> qq;
    for (int j = 0; j < q; ++j) {
        int t, k, i;
        cin >> t;
        if (t == 3) {
            cin >> k >> i;
        } else {
            cin >> k;
            i = k;
        }
        qq.push_back({ { k, j }, { t, per[i - 1] } });
    }
    int have = n - 1;
    add = have * (have + 1) / 2;
    int ptr = 0;
    sort(all(qq));
    vector<int> ans(q);
    int pr = 0;
    int ans2 = 0;
    for (auto [ aaa, b] : qq) {
        auto [k, j] = aaa;
        auto [t, i] = b;
        while (ptr < un.size() && un[ptr].first <= k) {
            int i = un[ptr].second;
            ans2 += (un[ptr].first - pr) * add;
            mem = un[ptr].first - pr;
            unite(i, i + 1, mem);
            pr = un[ptr].first;
            --have;
            ++ptr;
        }
        ans2 += (k - pr) * add;
        if (t == 1) {
            ans[j] = have + 1;
        } else if (t == 2) {
            ans[j] = ans2;
        } else {
            ans[j] = a[i] + (k - pr) * cost[i];
        }
        pr = k;
    }
    for (int i : ans) {
        cout << i << '\n';
    }
}
