#include <iostream>
#include <vector>
#include <deque>
#include <numeric>
#include <algorithm>
#define all(x) x.begin(), x.end()
using namespace std;

const int maxn = 3e5;
int p[maxn];
int sz[maxn];

int col(int v) {
    return (v == p[v] ? v : p[v] = col(p[v]));
}

void unite(int u, int v) {
    u = col(u);
    v = col(v);
    p[u] = v;
    sz[u] += sz[v];
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, q;
    cin >> n >> q;
    iota(p, p + n, 0);
    vector<int> a(n);
    for (int& i : a) {
        cin >> i;
    }
    sort(all(a));
    vector<pair<int, int>> un;
    for (int i = 0; i + 1 < n; ++i) {
        un.push_back({ a[i + 1] - a[i], i });
    }
    sort(all(un));
    vector<pair<pair<int, int>, pair<int, int>>> qq;
    for (int j = 0; j < q; ++j) {
        int t, k, i;
        cin >> t;
        if (t == 3) {
            cin >> k >> i;
        } else {
            cin >> k;
            i = k;
        }
        qq.push_back({ { k, j }, { t, i } });
    }
    int have = n - 1;
    int ptr = 0;
    sort(all(qq));
    vector<int> ans(q);
    int pr = 0;
    int ans2 = 0;
    for (auto [ a, b] : qq) {
        auto [k, j] = a;
        auto [t, i] = b;
        while (ptr < un.size() && un[ptr].first <= k) {
            int i = un[ptr].second;
            ans2 += (un[ptr].first - pr) * have * (have - 1) / 2;
            pr = un[ptr].first;
            unite(i, i + 1);
            --have;
            ++ptr;
        }
        if (t == 1) {
            ans[j] = have + 1;
        } else if (t == 2) {
            ans[j] = ans2;
        }
    }
    for (int i : ans) {
        cout << i << '\n';
    }
}
