#include <iostream>
#include <vector>
#include <deque>
#include <numeric>
#include <map>
#include <queue>
#include <algorithm>
#define all(x) x.begin(), x.end()
using namespace std;

const int inf = 1e9;
const int maxn = 5000;
int c[maxn][maxn];
bool bad[maxn];

void dfs(int v, vector<vector<int>> &g, int cm, int ban) {
    c[ban][v] = cm;
    for (int u : g[v]) {
        if (u != ban && !c[ban][u]) {
            dfs(u, g, cm, ban);
        }
    }
}

int tin[maxn];
int fup[maxn];
int timer = 0;
bool used[maxn];

void dfs1(int v, vector<vector<int>> &g, int p, bool root = 0) {
    fup[v] = tin[v] = timer++;
    used[v] = 1;
    int c = 0;
    for (int u : g[v]) {
        if (u == p) continue;
        if (used[u]) {
            fup[v] = min(fup[v], tin[u]);
        } else {
            ++c;
            dfs1(u, g, v);
            if (fup[u] >= tin[v]) bad[v] = 1;
            fup[v] = min(fup[v], fup[u]);
        }
    }
    if (root && c > 1) {
        bad[v] = 1;
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    fill(bad, bad + n, false);
    vector<vector<int>> g(n);
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        --u; --v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    fill(tin, tin + n, 0);
    fill(fup, fup + n, 0);
    fill(used, used + n, 0);
    dfs1(0, g, -1, 1);
    for (int i = 0; i < n; ++i) {
        if (!bad[i]) {
            for (int j = 0; j < n; ++j) {
                c[i][j] = 1;
            }
        } else {
            for (int j = 0; j < n; ++j) {
                c[i][j] = 0;
            }
            int id = 1;
            for (int j = 0; j < n; ++j) {
                if (i != j && !c[i][j]) dfs(j, g, id++, i);
            }
        }
    }
    vector<vector<vector<int>>> dist(n, vector<vector<int>> (n + 1, vector<int>(2, inf)));
    deque<pair<int, pair<int, int>>> q;
    dist[0][0][0] = 0;
    q.push_back({ 0, { 0, 0 } });
    vector<vector<vector<int>>> gp(n, vector<vector<int>> (n + 1));
    for (int i = 0; i < n; ++i) {
        for (int j : g[i]) {
            gp[i][c[i][j]].push_back(j);
        }
    }
    while (!q.empty()) {
        auto [v, fg] = q.front();
        auto [p, f] = fg;
        q.pop_front();
        if (f) {
            for (int u: gp[v][p]) {
                if (dist[u][0][f ^ 1] > dist[v][p][f] + 1) {
                    dist[u][0][f ^ 1] = dist[v][p][f] + 1;
                    q.push_back({u, {0, f ^ 1}});
                }
            }
        } else {
            for (int u : g[v]) {
                if (dist[u][c[u][v]][f ^ 1] > dist[v][p][f] + 1) {
                    dist[u][c[u][v]][f ^ 1] = dist[v][p][f] + 1;
                    q.push_back({u, {c[u][v], f ^ 1}});
                }
            }
        }
    }
    for (int i = 1; i < n; ++i) {
        int res = dist[i][0][0];
        if (res == inf) {
            cout << -1 << ' ';
        } else {
            cout << 2 * (res / 2) << ' ';
        }
    }
    cout << '\n';
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}