#include <iostream>
#include <vector>
#include <deque>
#include <numeric>
#include <map>
#include <queue>
#include <cassert>
#include <set>
#include <bits/extc++.h>
#include <algorithm>

#define all(x) x.begin(), x.end()
using namespace std;

const int inf = 1e9;

const int f = 1;

#define l first.first
#define r first.second
#define c second.first
#define t second.second

const int maxn = (1 << 16);
int tree[maxn];

void upd(int i, int x) {
    i += maxn / 2;
    tree[i] += x;
    while (i > 1) {
        i >>= 1;
        tree[i] += x;
    }
}

int get(int qi, int i = 1, int ll = 0, int rr = maxn / 2) {
    if (ll + 1 == rr) return ll;
    int m = (ll + rr) / 2;
    if (tree[i * 2] && qi < m) {
        int ans = get(qi,i * 2, ll, m);
        if (ans >= qi) {
            return ans;
        }
    }
    if (!tree[i * 2 + 1]) return -1;
    return get(qi, i * 2 + 1, m, rr);
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> a(n);
    for (int &i: a) {
        cin >> i;
    }
    vector<pair<pair<int, int>, pair<int, int>>> b(m);
    for (int i = 0; i < m; ++i) {
        cin >> b[i].l >> b[i].r >> b[i].c >> b[i].t;
    }
    for (int x = 1; x <= n; ++x) {
        __gnu_pbds::gp_hash_table<int, vector<pair<int, int>>> rr;
        vector<int> left;
        vector<int> mem = a;
        for (int j = 0; j < m; ++j) {
            left.push_back(b[j].c);
            if (b[j].t == f) {
                int L = min(x, b[j].l);
                int R = max(x, b[j].r);
                rr[R].push_back({L, j});
            } else {
                int L = b[j].l;
                int R = b[j].r;
                rr[R].push_back({L, j});
            }
        }
        for (int i = 0; i < n; ++i) {
            upd(i, a[i] - tree[i + maxn / 2]);
        }
        long long ans = 0;
        for (auto& [i, v] : rr) {
            for (auto [L, j] : v) {
                while (left[j] && tree[1]) {
                    int pos = get(L - 1);
                    if (pos != -1 && pos < i) {
                        int can = min(a[pos], left[j]);
                        a[pos] -= can;
                        left[j] -= can;
                        ans += can;
                        upd(pos, -can);
                    } else {
                        break;
                    }
                }
            }
        }
        a = mem;
        cout << ans << ' ';
    }
    cout << '\n';
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int tt;
    cin >> tt;
    while (tt--) {
        solve();
    }
}