#include <iostream>
#include <vector>
#include <deque>
#include <numeric>
#include <map>
#include <queue>
#include <algorithm>
#include <bitset>
#define all(x) x.begin(), x.end()
using namespace std;

const int inf = 1e9;
const int maxn = 1000;
int c[maxn][maxn];
bitset<maxn> used;

void dfs(int v, vector<bitset<maxn>> &g, int cm, int ban) {
    c[ban][v] = cm;
    for (int u = (g[v] & used)._Find_first(); (g[v] & used).any(); u = (g[v] & used)._Find_next(u)) {
        if (u != ban && !c[ban][u]) {
            dfs(u, g, cm, ban);
        }
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<bitset<maxn>> g(n);
    vector<vector<int>> gp(n);
    for (int i = 0; i < n; ++i) {
        g[i].reset();
    }
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        --u; --v;
        g[u][v] = g[v][u] = 1;
        gp[u].push_back(v);
        gp[v].push_back(u);
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            c[i][j] = 0;
        }
        int id = 1;
        used.reset();
        for (int j = 0; j < n; ++j) {
            if (i != j && !c[i][j]) dfs(j, g, id++, i);
        }
    }
    vector<vector<vector<int>>> dist(n, vector<vector<int>> (n + 1, vector<int>(2, inf)));
    dist[0][n][0] = 0;
    deque<pair<int, pair<int, int>>> q;
    q.push_back({ 0, { n, 0 } });
    while (!q.empty()) {
        auto [v, fg] = q.front();
        auto [p, f] = fg;
        q.pop_front();
        for (int u : gp[v]) {
            if (f && c[v][u] != c[v][p]) continue;
            if (dist[u][v][f ^ 1] > dist[v][p][f] + 1) {
                dist[u][v][f ^ 1] = dist[v][p][f] + 1;
                q.push_back({ u, { v, f ^ 1} });
            }
        }
    }
    for (int i = 1; i < n; ++i) {
        int res = inf;
        for (int j = 0; j < n; ++j) {
            res = min(res, dist[i][j][0]);
        }
        if (res == inf) {
            cout << -1 << ' ';
        } else {
            cout << 2 * (res / 2) << ' ';
        }
    }
    cout << '\n';
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}