#include <bits/stdc++.h>
using namespace std;
#define int long long


struct Query {
    int type, i, id;
    long long k;
    void scan(int idd) {
        id = idd;
        cin >> type >> k;
        if (type == 3) {
            cin >> i;
            --i;
        }
        else
            i = 0;
    }
    bool operator < (const Query& other) const {
        if (k != other.k)
            return k < other.k;
        if (type != other.type)
            return type < other.type;
        return i < other.i;
    }
};

vector<long long> make_uniq(const vector<pair<long long, int>>& a) {
    vector<long long> uniq;
    int prev = -1;
    for (auto e : a) {
        if (e.first != prev) {
            uniq.push_back(e.first);
            prev = e.first;
        }
    }
    return uniq;
}

vector<long long> solution_square(vector<pair<long long, int>>& expa, vector<Query>& queries) {
    int n = expa.size(), q_num = queries.size();
    long long k = 0;
    vector<long long> uniq = make_uniq(expa);
    vector<long long> player(n);
    vector<int> player_delta(n);
    for (int i = 0; i < n; ++i)
        player[expa[i].second] = expa[i].first;
    long long sm = 0;
    vector<pair<int, long long>> answers;
    long long jump = 0;
    for (int i = 0; i < uniq.size() - 1; ++i) {
        jump = min(jump, uniq[i + 1] - uniq[i]);
    }
    long long sm_delta = 0;
    int pt = 0;
    for (int i = 0; i < n; ++i) {
        while (pt < uniq.size() && uniq[pt] == expa[i].first)
            ++pt;
        player_delta[expa[i].second] = uniq.size() - pt;
        sm_delta += (uniq.size() - pt);
    }
    for (Query q :queries) {
        while (k + jump <= q.k) {
            int pt = 0;
            for (int i = 0; i < n; ++i) {
                while (pt < uniq.size() && uniq[pt] == expa[i].first)
                    ++pt;
                long long delta = (uniq.size() - pt) * jump;
                expa[i].first += delta;
                player[expa[i].second] = expa[i].first;
                sm += delta;
            }
            uniq = make_uniq(expa);
            k += jump;
            jump = 1e18;
            for (int i = 0; i < uniq.size() - 1; ++i) {
                jump = min(jump, uniq[i + 1] - uniq[i]);
            }
            pt = 0;
            sm_delta = 0;
            for (int i = 0; i < n; ++i) {
                while (pt < uniq.size() && uniq[pt] == expa[i].first)
                    ++pt;
                sm_delta += (uniq.size() - pt);
            }
        }
        if (q.type == 1) {
            answers.push_back({q.id, uniq.size()});
        }
        else if (q.type == 2) {
            answers.push_back({q.id, sm + sm_delta * (q.k - k)});
        }
        else {
            answers.push_back({q.id, player[q.i] + player_delta[q.i] * (q.k - k)});
        }
    }

    sort(answers.begin(), answers.end());
    vector<long long> ans;
    for (auto a :answers)
        ans.push_back(a.second);
    return ans;
}

vector<long long> solutionk1(vector<pair<long long, int>>& expa, vector<Query>& queries) {
    vector<long long> uniq = make_uniq(expa);
    vector<long long> difs;
    for (int i = 0; i < uniq.size() - 1; ++i) {
        difs.push_back(uniq[i + 1] - uniq[i]);
    }
    sort(difs.begin(), difs.end());
    vector<pair<int, long long>> answers;
    int pt = 0;
    for (Query q :queries) {
        while (pt < difs.size() && difs[pt] <= q.k)
            ++pt;
        long long cur_ans = uniq.size() - pt;
        answers.push_back({q.id, cur_ans});
    }
    sort(answers.begin(), answers.end());
    vector<long long> ans;
    for (auto a :answers)
        ans.push_back(a.second);
    return ans;
}

signed main()
{
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    freopen("B.in", "r", stdin);
    freopen("B.out", "w", stdout);
    int n, q_num;
    cin >> n >> q_num;
    vector<pair<long long, int>> expa(n);
    for (int  i = 0; i < n; ++i) {
        cin >> expa[i].first;
        expa[i].second = i;
    }
    sort(expa.begin(), expa.end());
    vector<Query> queries(q_num);
    for (int i = 0; i < q_num; ++i)
        queries[i].scan(i);
    sort(queries.begin(), queries.end());
    vector<long long> ans = solution_square(expa, queries);
    for (auto a :ans)
        cout << a << '\n';
}
