#include <iostream>
#include <vector>
#include <iomanip>
#include <algorithm>
#include <numeric>
#include <string>
#include <stack>
#include <deque>
#include <queue>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <bitset>
#include <chrono>
#include <random>
#include <ctime>
#include <cmath>
#include <cassert>

using namespace std;

#define sz(x) ((int)((x).size()))
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

using ll = int64_t;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using int128 = __int128_t;

const char en = '\n';
const int INF = 1e9 + 7;
const ll INFLL = 1e18 + 7;

struct Query {
    int id;
    int t;
    ll k;
    int i;

    Query() {}

    Query(int id, int t, ll k) : id(id), t(t), k(k) {}
    Query(int id, int t, ll k, int i) : id(id), t(t), k(k), i(i) {}
};

struct DSU {
    int n, cmp;
    vector<int> par;
    vector<int> siz;
    vector<ll> val;

    DSU (int _n, vector<ll> &a) {
        n = _n;
        cmp = n;
        par.resize(n);
        siz.resize(n);
        val = a;
        for (int i = 0; i < n; ++i) {
            par[i] = i;
            siz[i] = 1;
        }
    }

    int get(int v) {
        if (par[v] == v) {
            return v;
        }
        return par[v] = get(par[v]);
    }

    ll get_val(int v) {
        v = get(v);
        return val[v];
    }

    bool unite(int a, int b, ll x) {
        a = get(a);
        b = get(b);
        if (a == b) {
            val[a] = max(val[a], x);
            return false;
        }
        --cmp;
        if (siz[a] > siz[b]) {
            swap(a, b);
        }
        par[a] = b;
        val[b] = max({val[a], val[b], x});
        siz[b] += siz[a];
        return true;
    }
};

void solve() {
    int n, q;
    cin >> n >> q;

    vector<pair<ll, int>> a(n);
    vector<ll> b(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first;
        b[i] = a[i].first;
        a[i].second = i;
    }
    sort(rall(a));

    vector<Query> qs(q);
    for (int i = 0; i < q; ++i) {
        int t;
        ll k;
        cin >> t >> k;
        if (t == 3) {
            int x;
            cin >> x;
            --x;
            qs[i] = Query(i, t, k, x);
        }
        else {
            qs[i] = Query(i, t, k);
        }
    }
    sort(all(qs), [](Query a, Query b) {
        return a.k < b.k;
    });
    vector<ll> ans(q, -1);

    DSU dsu(n, b);
    vector<pair<ll, int>> c = {a[0]};
    for (int i = 1; i < n; ++i) {
        if (a[i].first == a[i - 1].first) {
            dsu.unite(a[i - 1].second, a[i].second, a[i].first);
        }
        else {
            c.emplace_back(a[i]);
        }
    }
    int m = sz(c);

    ll sum = 0;
    ll round = 0;
    int j = 0;
    while (j < q && qs[j].k == 0) {
        if (qs[j].t == 1) {
            ans[qs[j].id] = dsu.cmp;
        }
        else if (qs[j].t == 2) {
            ans[qs[j].id] = sum;
        }
        else {
            ans[qs[j].id] = dsu.get_val(qs[j].i);
        }
        ++j;
    }

    ll last = 0;
    vector<int> pos(n);

    while (j < q && sz(c) > 1) {

        m = sz(c);

//        vector<int> ids = {1};
        ll best = c[0].first - c[1].first;
        int v = dsu.get(c[1].second);
        ll summa = dsu.siz[v];
        for (int i = 2; i < m; ++i) {
            ll d = c[i - 1].first - c[i].first - 1;
//            if (d == best) {
//                ids.emplace_back(i);
//            }
//            else if (d < best) {
//                ids.clear();
//                ids.emplace_back(i);
//            }
            best = min(best, d);
            v = dsu.get(c[i].second);
            summa += 1LL * i * dsu.siz[v];
        }

        if (best == 0) {
            best = 1;
        }

        ll newround = round + best;

        while (j < q && qs[j].k < newround) {
            if (qs[j].t == 1) {
                ans[qs[j].id] = dsu.cmp;
            }
            else if (qs[j].t == 2) {
                ans[qs[j].id] = sum + (qs[j].k - round) * summa;
            }
            else {
                ans[qs[j].id] = dsu.get_val(qs[j].i);
            }
            ++j;
        }

        round = newround;
        sum += best * summa;

        vector<pair<ll, int>> newc = {c[0]};
        for (int i = 1; i < m; ++i) {
            auto it = c[i];
            it.first += best * i;
            if (it.first == newc.back().first) {
                dsu.unite(it.second, newc.back().second, it.first);
            }
            else {
                dsu.unite(it.second, it.second, it.first);
                newc.emplace_back(it);
            }
        }

        while (j < q && qs[j].k == round) {
            if (qs[j].t == 1) {
                ans[qs[j].id] = dsu.cmp;
            }
            else if (qs[j].t == 2) {
                ans[qs[j].id] = sum;
            }
            else {
                ans[qs[j].id] = dsu.get_val(qs[j].i);
            }
            ++j;
        }


        c.swap(newc);
    }

    while (j < q) {
        if (qs[j].t == 1) {
            ans[qs[j].id] = dsu.cmp;
        }
        else if (qs[j].t == 2) {
            ans[qs[j].id] = sum;
        }
        else {
            ans[qs[j].id] = dsu.get_val(qs[j].i);
        }
        ++j;
    }

    for (auto i: ans) {
        cout << i << en;
    }
}

int32_t main() {
    int T = 1;
#ifdef THEEVILBIRD
    freopen("b.txt", "r", stdin);
    T = 1;
#else
    ios_base::sync_with_stdio(0); cin.tie(0);
#endif
    while (T--) {
        solve();
    }
    return 0;
}
