#include <iostream>
#include <vector>
#include <iomanip>
#include <algorithm>
#include <numeric>
#include <string>
#include <stack>
#include <deque>
#include <queue>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <bitset>
#include <chrono>
#include <random>
#include <ctime>
#include <cmath>
#include <cassert>

using namespace std;

#define sz(x) ((int)((x).size()))
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

using ll = int64_t;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using int128 = __int128_t;

const char en = '\n';
const int INF = 1e9 + 7;
const ll INFLL = 1e18 + 7;

struct Query {
    int id;
    int t;
    ll k;
    int i;

    Query() {}

    Query(int id, int t, ll k) : id(id), t(t), k(k) {}
    Query(int id, int t, ll k, int i) : id(id), t(t), k(k), i(i) {}
};

void solve() {
    int n, q;
    cin >> n >> q;
    vector<pair<ll, int>> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first;
        a[i].second = i;
    }
    sort(rall(a));
    vector<Query> qs(q);
    for (int i = 0; i < q; ++i) {
        int t;
        ll k;
        cin >> t >> k;
        if (t == 3) {
            int x;
            cin >> x;
            --x;
            qs[i] = Query(i, t, k, x);
        }
        else {
            qs[i] = Query(i, t, k);
        }
    }
    sort(all(qs), [](Query a, Query b) {
        return a.k < b.k;
    });
    ll timer = 0;
    vector<ll> ans(q);
    ll sum = 0, diff = 0;
    for (int i = 1; i < n; ++i) {
        if (a[i].first != a[i - 1].first) {
            ++diff;
        }
    }
    vector<int> pos(n);
    for (int i = 0; i < n; ++i) {
        pos[a[i].second] = i;
    }
    for (int i = 0, j = 0; j < q; ++i) {
        diff = 0;
        for (int x = 1; x < n; ++x) {
            if (a[x].first != a[x - 1].first) {
                ++diff;
            }
            ++timer;
        }
        while (j < n && i == qs[j].k) {
            if (qs[j].t == 1) {
                ans[qs[j].id] = diff + 1;
            }
            else if (qs[j].t == 2) {
                ans[qs[j].id] = sum;
            }
            else {
                ans[qs[j].id] = a[pos[qs[j].i]].first;
            }
            ++j;
            ++timer;
        }
        if (diff != 0) {
            diff = 0;
            vector<ll> getnow(n, 0);
            for (int x = 1; x < n; ++x) {
                if (a[x].first != a[x - 1].first) {
                    ++diff;
                }
                getnow[a[x].second] = diff;
                ++timer;
            }
            for (int x = 0; x < n; ++x) {
                sum += getnow[a[x].second];
                a[x].first += getnow[a[x].second];
                ++timer;
            }
        }
        assert(timer <= 5e6);
    }
    for (auto i: ans) {
        cout << i << en;
    }
}

int32_t main() {
    int T = 1;
#ifdef THEEVILBIRD
    freopen("b.txt", "r", stdin);
    T = 1;
#else
    ios_base::sync_with_stdio(0); cin.tie(0);
#endif
    while (T--) {
        solve();
    }
    return 0;
}
