#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <functional>
#include <queue>
#include <deque>

using namespace std;
//#define int long long

const int inf = 1e9;

void solve() {
  int n, m;
  cin >> n >> m;
  vector<vector<int>> g(n);
  for (int i = 0; i < m; i++) {
    int u, v;
    cin >> u >> v;
    --u, --v;
    g[u].push_back(v);
    g[v].push_back(u);
  }

  vector<vector<int>> dp(n, vector<int> (n, inf));
  dp[0][0] = 0;

  deque<pair<int, int>> q;
  q.push_front({0, 0});

  auto update = [&] (int i, int j, int val, int add) {
    if (val < dp[i][j]) {
      dp[i][j] = val;
      if (add == 1) {
        q.push_back({i, j});
      } else {
        q.push_front({i, j});
      }
    }
  };

  while (!q.empty()) {
    auto [i, j] = q.front();
    q.pop_front();
    for (auto &u : g[i]) {
      if (u == j) {
        update(i, i, dp[i][j] + 1, 1);
      } else if (i == j) {
        update(i, u, dp[i][j] + 1, 1);
      } else {
        update(u, j, dp[i][j], 0);
      }
    }
  }

  for (int i = 1; i < n; i++) {
    cout << (dp[i][i] == inf ? -1 : dp[i][i]) << ' ';
  }
  cout << '\n';
}

signed main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  int tc;
  cin >> tc;
  while (tc --> 0) solve();
  return 0;
}
