#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <functional>
#include <queue>
#include <deque>
#include <cassert>

using namespace std;
#define int long long

void solve() {
  int n, m;
  cin >> n >> m;
  vector<int> a(n);
  bool eq = 1;
  for (auto &x : a) {
    cin >> x;
    eq &= x == 1;
  }
  vector<array<int, 4>> robots(m);
  for (auto &[l, r, c, t] : robots) {
    cin >> l >> r >> c >> t;
    --l, --r;
  }
  for (int x = 0; x < n; x++) {
    vector<vector<pair<int, int>>> add(n);
    for (auto &[L, R, c, t] : robots) {
      int l = L, r = R;
      if (t == 1) {
        l = min(l, x);
        r = max(r, x);
      }
      add[l].emplace_back(r + 1, c);
    }
    int res = 0;
    set<pair<int, int>> st;
    vector<int> b = a;
    for (int i = 0; i < n; i++) {
      while (!st.empty() && st.begin()->first == i) {
        st.erase(st.begin());
      }
      for (auto &x : add[i]) {
        st.insert(x);
      }
      while (!st.empty() && b[i] > 0) {
        auto [r, c] = *st.begin();
        st.erase(st.begin());
        int can = min(c, b[i]);
        b[i] -= can;
        res += can;
        c -= can;
        if (c > 0) {
          st.insert({r, c});
        }
      }
    }
    cout << res << ' ';
  }
}

signed main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  int tc;
  cin >> tc;
  while (tc --> 0) solve();
  return 0;
}
