#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

#define int long long

vector<int> fen;

void add(int i, int x) {
    for (; i < fen.size(); i = i | (i + 1)) {
        fen[i] += x;
    }
}

int get(int i) {
    int res = 0;
    for (; i >= 0; i = (i & (i + 1)) - 1) {
        res += fen[i];
    }
    return res;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int n, q;
    cin >> n >> q;
    vector<pair<int, int>> c(n);
    for (int i = 0; i < n; ++i) {
        cin >> c[i].first;
        c[i].second = i;
    }
    vector<vector<int>> quests(q);
    for (int i = 0; i < q; ++i) {
        int t;
        cin >> t;
        if (t == 1 || t == 2) {
            int k;
            cin >> k;
            quests[i] = {k, t, i};
        } else {
            int k, ii;
            cin >> k >> ii;
            --ii;
            quests[i] = {k, t, ii, i};
        }
    }
    sort(quests.begin(), quests.end());
    sort(c.begin(), c.end());
    set<vector<int>> mn;
    for (int i = 0; i < n - 1; ++i) {
        mn.insert({c[i + 1].first - c[i].first, i, i + 1});
    }
    fen.resize(n);
    for (int i = 0; i < n; ++i) {
        add(i, 1);
    }
    vector<int> ans(q);
    int last = 0;
    int s = 0;
    int cnt = n * (n - 1) / 2;
    for (int i = 0; i < quests.size(); ++i) {
        while (mn.size() && quests[i][0] >= (*mn.begin())[0]) {
            s += ((*mn.begin())[0] - last) * cnt;
            last = (*mn.begin())[0];
            cnt -= (*mn.begin())[1] + 1;
            mn.erase(mn.begin());
        }
        s += (quests[i][0] - last) * cnt;
        last = quests[i][0];
        if (quests[i][1] == 1) {
            ans[quests[i][2]] = mn.size() + 1;
        } else {
            ans[quests[i][2]] = s;
        }
    }
    for (auto i: ans) {
        cout << i << "\n";
    }
}