//
// Created by roi on 28.03.2022.
//
#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <fstream>

using namespace std;

vector<vector<int>> g;

bool cmp(pair<pair<int, int>, int> a, pair<pair<int, int>, int> b) {
    return make_pair(a.first.second, a.first.first) < make_pair(b.first.second, b.first.first);
}

vector<int> tree;
vector<int> mod;

void build(int v, int l, int r, vector<int> &a) {
    mod[v] = 1;
    if (r - l == 1) {
        tree[v] = a[l];
        return;
    }
    int m = (l + r) / 2;
    build(2 * v + 1, l, m, a);
    build(2 * v + 2, m, r, a);
    tree[v] = tree[2 * v + 1] + tree[2 * v + 2];
}

int update(int v, int l, int r, int ql, int qr, int x) {
    if (mod[v] == 0){
        return 0;
    }
    if (x == 0){
        return 0;
    }
    if (ql <= l && r <= qr) {
        if (tree[v] <= x) {
            int res = tree[v];
            tree[v] = 0;
            mod[v] = 0;
            return res;
        }
        if (r - l == 1){
            tree[v] -= x;
            return x;
        }
    }
    if (ql >= r || l >= qr) {
        return 0;
    }
    int x0 = x;
    int m = (l + r) / 2;
    x -= update(2 * v + 1, l, m, ql, qr, x);
    x -= update(2 * v + 2, m, r, ql, qr, x);
    tree[v] = (tree[2 * v + 1] * mod[2 * v + 1] + tree[2 * v + 2] * mod[2 * v + 2]) * mod[v];
    return x0 - x;
}

int get(int v, int l, int r, int ql, int qr){
    if (ql <= l && r <= qr){
        return tree[v] * mod[v];
    }
    if (l >= qr || ql >= r){
        return 0;
    }
    int m = (l + r) / 2;
    return (get(2 * v + 1, l, m, ql, qr) + get(2 * v + 2, m, r, ql, qr)) * mod[v];
}

int main() {
#ifdef LOCAL
    ifstream cin("D.in");
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int t22;
    cin >> t22;
    int n, m;
    while (cin >> n >> m) {
        vector<int> l(m), r(m), c(m), t(m);
        vector<int> a(n);
        for (int i = 0; i < n; ++i) {
            cin >> a[i];
        }
        tree.resize(4 * n);
        mod.resize(4 * n);
        for (int i = 0; i < m; ++i) {
            cin >> l[i] >> r[i] >> c[i] >> t[i];
            --l[i];
            --r[i];
        }
        vector<pair<pair<int, int>, int>> lr_(m);
        vector<int> r_(m);

        for (int x = 0; x < n; ++x) {
            build(0, 0, n, a);
            long long sum = 0;
            for (int j = 0; j < m; ++j) {
                lr_[j].first.first = l[j];
                lr_[j].first.second = r[j];
                if (t[j] == 1) {
                    lr_[j].first.first = min(lr_[j].first.first, x);
                    lr_[j].first.second = max(lr_[j].first.second, x);
                }
                lr_[j].second = j;
            }
            sort(lr_.begin(), lr_.end(), cmp);
            for (int j = 0; j < m; ++j) {
                int c1 = c[lr_[j].second];
                sum += update(0, 0, n, lr_[j].first.first, lr_[j].first.second + 1, c1);
            }
            cout << sum << ' ';
        }
        cout << endl;
    }
}
