#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <stack>
#include <deque>
#include <queue>
#include <set>
#include <map>
#include <unordered_map>
#include <string>
#include <chrono>
#include <random>
#include <iomanip>

#define all(a) (a).begin(), (a).end();
#define debug(a) std::cerr << #a << ": " << a << '\n';

using ll = long long;
using ld = long double;
using str = std::string;
using pll = std::pair<ll, ll>;

const ll Max = 1e18, Min = -1e18;
const ld Pi = std::acos(-1);
const ld eps = 1e-12;
const ll Mod = 1234567891;

void bfs(std::string& s, std::map<str, ll>& dist) {
	std::queue<str> q;
	std::map<str, bool> used;
	dist[s] = 0;
	used[s] = true;
	q.push(s);
	str tmp, now;
	while (!q.empty()) {
		now = q.front();
		q.pop();
		for (int i = 0; i < (ll)now.size() - 1; ++i) {
			tmp = now;
			std::swap(tmp[i], tmp[i + 1]);
			if (dist[tmp] < dist[now] + 1) {
				dist[tmp] = dist[now] + 1;
			}
			if (!used[tmp]) {
				q.push(tmp);
				used[tmp] = true;
			}
		}
	}
}

void solve() {
	std::string s;
	std::cin >> s;
	ll y;
	std::cin >> y;
	std::map<str, ll> dist;
	bfs(s, dist);
	ll max = Min;
	str now;
	for (auto j : dist) {
		if (max < std::stoll(j.first) - y * j.second) {
			max = std::stoll(j.first) - y * j.second;
			now = j.first;
		}
	}
	std::cout << now << '\n';
}

int main() {
	std::ios::sync_with_stdio(0);
	std::cin.tie(0);
	std::cout.tie(0);
	std::cout << std::fixed << std::setprecision(100);
	ll t = 1;
	// std::cin >> t;
	while (t--) {
		solve();
	}
}
