#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <cstdlib>
#include <ctime>
#include <random>
#include <cassert>
#include <array>
#include <string>
#include <set>
#include <map>
#include <queue>


using namespace std;


#define int long long
#define ll long long
#define ld long double
#define flt double
#define pb push_back
#define emb empalce_back
#define all(a) a.begin(), a.end()
#define rall(a) a.rbeign(), a.rend()
#define nlpt nullptr
#define prcs cout << fixed << setprecision(20)


mt19937 rnd(1231231);


struct DSU {
	int n;
	vector<int> t;


	void build(int _n) {
		n = _n;
		t.resize(n);
		for (int i = 0; i < n; ++i) {
			t[i] = i;
		}
	}


	int get(int v) {
		if (t[v] == v) {
			return v;
		}
		return (t[v] = get(t[v]));
	}


	void mrg(int a, int b) {
		a = get(a);
		b = get(b);
		if (a == b) {
			return;
		}
		t[a] = b;
	}
};


int n, m;
vector<vector<int>> g;
vector<vector<int>> g1;
vector<ll> rs;
vector<DSU> usd;


void bfs(vector<int> &usd, int v0, int bnd) {
	usd.assign(n, 0);
	vector<int> q;
	q.reserve(n);
	q.pb(v0);
	while (!q.empty()) {
		int v = q.back();
		q.pop_back();
		usd[v] = 1;
		for (auto to : g[v]) {
			if (!usd[to] && to != bnd) {
				usd[to] = 1;
				q.pb(to);
			}
		}
	}
}


void bfs1(vector<int> &d, int v0) {
	d.assign(n, -1);
	queue<int> q;
	q.push(v0);
	d[v0] = 0;
	while (!q.empty()) {
		int v = q.front();
		q.pop();
		for (auto to : g1[v]) {
			if (d[to] == -1) {
				d[to] = d[v] + 1;
				q.push(to);
			}
		}
	}
}


bool ok(int u, int v, int t) {
	return usd[v].get(u) == usd[v].get(t);
}


void solve_slow() {
	usd.resize(n);
	for (int bnd = 0; bnd < n; ++bnd) {
		usd[bnd].build(n);
		for (int v = 0; v < n; ++v) {
			if (v == bnd) {
				continue;
			}
			for (auto to : g[v]) {
				if (to != bnd) {
					usd[bnd].mrg(v, to);
				}
			}
		}
	}
	g1.assign(n, vector<int>());
	for (int u = 0; u < n; ++u) {
		for (auto v : g[u]) {
			for (auto to : g[v]) {
				if (!ok(u, v, to)) {
					continue;
				}
				g1[u].push_back(to);
			}
		}
	}
	bfs1(rs, 0);
	for (int i = 0; i < n; ++i) {
		if (rs[i] == -1) {
			continue;
		}
		rs[i] *= 2;
	}
}


int32_t main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int t;
	cin >> t;
	while (t--) {
		cin >> n >> m;
		g.assign(n, vector<int>());
		for (int i = 0; i < m; ++i) {
			int u, v;
			cin >> u >> v;
			--u;
			--v;
			g[u].push_back(v);
			g[v].push_back(u);
		}
		solve_slow();
		for (int i = 1; i < n; ++i) {
			cout << rs[i] << " ";
		}
		cout << "\n";
	}
	return 0;
}