

#pragma GCC optimize("Ofast")


#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <cstdlib>
#include <ctime>
#include <random>
#include <cassert>
#include <array>
#include <string>
#include <set>
#include <map>


using namespace std;


#define int long long
#define ll long long
#define ld long double
#define flt double
#define pb push_back
#define emb empalce_back
#define all(a) a.begin(), a.end()
#define rall(a) a.rbeign(), a.rend()
#define nlpt nullptr
#define prcs cout << fixed << setprecision(20)


mt19937 rnd(1231231);


struct rbt {
	int l, r;
	ll c;
	int t;

	rbt() {}
	rbt(int l, int r, ll c, int t) : l(l), r(r), c(c), t(t) {}
};


bool _compr(const rbt& r1, const rbt& r2) {
	return r1.r < r2.r;
}


bool _compl(const rbt& r1, const rbt& r2) {
	return r1.l < r2.l;
}


int n, m;
vector<ll> a;
vector<rbt> w;
vector<ll> rs;


ll solve_slow1(vector<rbt>& w, int tl, int tr, ll sm) {
	sort(all(w), _compl);
	int j = 0;
	multiset<pair<ll, ll>> st;
	for (int i = tl; i <= tr; ++i) {
		while(j < (int)(w.size()) && w[j].l <= i) {
			st.insert(make_pair(w[j].r, w[j].c));
			++j;
		}
		while (!st.empty() && st.begin()->first < i) {
			st.erase(st.begin());
		}
		ll x = a[i];
		while (x > 0 && !st.empty()) {
			auto [r, c] = *st.begin();
			st.erase(st.begin());
			if (c <= x) {
				x -= c;
				sm += c;
			}
			else {
				c -= x;
				sm += x;
				x = 0;
				st.insert(make_pair(r, c));
			}
		}
	}
	return sm;
}


void solve_t1(vector<rbt> &w, int tl, int tr, ll sm) {
	ll tm = (tl + tr) / 2;
	bool ok = 1;
	for (auto& f : w) {
		if (f.l <= tm && tm + 1 <= f.r && f.t == 0) {
			ok = 0;
			break;
		}
	}
	if (!ok && tr - tl < 6000) {
		for (int i = tl; i <= tr; ++i) {
			auto w1 = w;
			for (auto &f : w1) {
				if (f.t == 1) {
					f.l = min(f.l, i);
					f.r = max(f.r, i);
				}
			}
			rs[i] = solve_slow1(w1, tl, tr, sm);
		}
		return;
	}
	if (tl == tr) {
		ll x = a[tl];
		for (auto f : w) {
			if (f.c < x) {
				x -= f.c;
				sm += f.c;
			}
			else {
				sm += x;
				x = 0;
			}
		}
		rs[tl] = sm;
		return;
	}
	sort(all(w), _compr);
	map<ll, ll> st;
	map<ll, ll> st2;
	int j = (int)(w.size()) - 1;
	ll sm1 = sm;
	for (int i = tr; i > tm; --i) {
		while (j >= 0 && w[j].r >= i) {
			if (w[j].t == 1) {
				st[min(w[j].l, tm + 1)] += w[j].c;
				--j;
			}
			else {
				st2[w[j].l] += w[j].c;
				--j;
			}
		}
		ll x = a[i];
		while (!st2.empty() && x > 0) {
			auto it = st2.end();
			--it;
			ll c = it->second;
			ll l = it->first;
			st2.erase(it);
			if (l > i) {
				continue;
			}
			if (c <= x) {
				x -= c;
				sm1 += c;
				c = 0;
			}
			else {
				sm1 += x;
				c -= x;
				st2[l] = c;
				x = 0;
			}
		}
		while (!st.empty() && x > 0) {
			auto it = st.end();
			--it;
			ll c = it->second;
			ll l = it->first;
			st.erase(it);
			if (c <= x) {
				x -= c;
				sm1 += c;
				c = 0;
			}
			else {
				sm1 += x;
				c -= x;
				st[l] = c;
				x = 0;
			}
		}
	}
	vector<rbt> w1;
	for (auto &f : w) {
		if (f.r <= tm) {
			w1.push_back(f);
		}
	}
	for (auto [l, c] : st) {
		w1.push_back(rbt(l, tm + 1, c, 1));
	}
	solve_t1(w1, tl, tm, sm1);
	w1.clear();
	sm1 = sm;
	st.clear();
	st2.clear();
	sort(all(w), _compl);
	j = 0;
	sm1 = sm;
	for (int i = tl; i <= tm; ++i) {
		while (j < (int)(w.size()) && w[j].l <= i) {
			if (w[j].t == 1) {
				st[max(w[j].r, tm)] += w[j].c;
				++j;
			}
			else {
				st2[w[j].r] += w[j].c;
				++j;
			}
		}
		ll x = a[i];
		while (!st2.empty() && x > 0) {
			auto it = st2.begin();
			ll c = it->second;
			ll r = it->first;
			st2.erase(it);
			if (r < i) {
				continue;
			}
			if (c <= x) {
				x -= c;
				sm1 += c;
				c = 0;
			}
			else {
				sm1 += x;
				c -= x;
				st2[r] = c;
				x = 0;
			}
		}
		while (!st.empty() && x > 0) {
			auto it = st.begin();
			ll c = it->second;
			ll r = it->first;
			st.erase(it);
			if (c <= x) {
				x -= c;
				sm1 += c;
				c = 0;
			}
			else {
				sm1 += x;
				c -= x;
				st[r] = c;
				x = 0;
			}
		}
	}
	for (auto& f : w) {
		if (f.l > tm) {
			w1.push_back(f);
		}
	}
	for (auto [r, c] : st) {
		w1.push_back(rbt(tm, r, c, 1));
	}
	solve_t1(w1, tm + 1, tr, sm1);
}


void solve_t1() {
	rs.resize(n);
	solve_t1(w, 0, n - 1, 0);
}


ll solve_slow(vector<rbt>& w, vector<ll> a) {
	vector<vector<int>> bgns(n);
	for (int i = 0; i < m; ++i) {
		bgns[w[i].l].push_back(i);
	}
	multiset<pair<ll, ll>> st;
	ll rs = 0;
	for (int i = 0; i < n; ++i) {
		for (auto t : bgns[i]) {
			st.insert(make_pair(w[t].r, w[t].c));
		}
		while (!st.empty() && st.begin()->first < i) {
			st.erase(st.begin());
		}
		while (a[i] > 0 && !st.empty()) {
			auto [r, c] = *st.begin();
			st.erase(st.begin());
			if (c <= a[i]) {
				a[i] -= c;
				rs += c;
			}
			else {
				c -= a[i];
				rs += a[i];
				a[i] = 0;
				st.insert(make_pair(r, c));
			}
		}
	}
	return rs;
}


void solve_slow() {
	rs.resize(n);
	for (int i = 0; i < n; ++i) {
		auto w1 = w;
		for (auto& f : w1) {
			if (f.t == 1) {
				f.l = min(f.l, i);
				f.r = max(f.r, i);
			}
		}
		rs[i] = solve_slow(w1, a);
	}
}


void gen_test(int _n, int _m, int mxc) {
	n = _n;
	m = _m;
	a.resize(n);
	for (int i = 0; i < n; ++i) {
		a[i] = rnd() % mxc;
	}
	w.resize(m);
	for (int i = 0; i < m; ++i) {
		int l = rnd() % n;
		int r = rnd() % n;
		if (l > r) {
			swap(l, r);
		}
		ll c = rnd() % mxc;
		int t = rnd() % 2;
		w[i] = rbt(l, r, c, t);
	}
}


void print_test() {
	cout << 1 << "\n";
	cout << n << " " << m << "\n";
	for (int i = 0; i < n; ++i) {
		cout << a[i] << " ";
	}
	cout << "\n";
	for (int i = 0; i < m; ++i) {
		cout << w[i].l + 1 << " " << w[i].r + 1 << " " << w[i].c << " " << w[i].t << "\n";
	}
}



void stress(int _n = 10, int _m = 10, int mxc = 10) {
	int c = 0;
	while (1) {
		cout << ++c << "\n";
		int n1 = rnd() % _n + 1;
		int m1 = rnd() % _m + 1;
		gen_test(n1, m1, mxc);
		solve_slow();
		auto rs1 = rs;
		solve_t1();
		auto rs2 = rs;
		if (rs1 != rs2) {
			print_test();
			break;
		}
	}
}


int32_t main() {
	// stress();
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int t;
	cin >> t;
	while (t--) {
		cin >> n >> m;
		a.resize(n);
		for (int i = 0; i < n; ++i) {
			cin >> a[i];
		}
		w.resize(m);
		for (int i = 0; i < m; ++i) {
			int l, r;
			ll c;
			int t;
			cin >> l >> r >> c >> t;
			--l;
			--r;
			w[i] = rbt(l, r, c, t);
		}
		solve_t1();
		for (int i = 0; i < n; ++i) {
			cout << rs[i] << " ";
		}
		cout << "\n";
	}
	return 0;
}
/*
1
3 3
1 1 1
1 2 1 0
1 2 1 1
1 2 1 0
*/