#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <cstdlib>
#include <ctime>
#include <random>
#include <cassert>
#include <array>
#include <string>
#include <set>
#include <map>


using namespace std;


#define int long long
#define ll long long
#define ld long double
#define flt double
#define pb push_back
#define emb empalce_back
#define all(a) a.begin(), a.end()
#define rall(a) a.rbeign(), a.rend()
#define nlpt nullptr
#define prcs cout << fixed << setprecision(20)


mt19937 rnd(1231231);


struct rbt {
	int l, r;
	ll c;
	int t;

	rbt() {}
	rbt(int l, int r, ll c, int t) : l(l), r(r), c(c), t(t) {}
};


int n, m;
vector<ll> a;
vector<rbt> w;
vector<ll> rs;


ll solve_slow(vector<rbt>& w, vector<ll> a) {
	vector<vector<int>> bgns(n);
	for (int i = 0; i < m; ++i) {
		bgns[w[i].l].push_back(i);
	}
	multiset<pair<ll, ll>> st;
	ll rs = 0;
	for (int i = 0; i < n; ++i) {
		for (auto t : bgns[i]) {
			st.insert(make_pair(w[t].r, w[t].c));
		}
		while (!st.empty() && st.begin()->first < i) {
			st.erase(st.begin());
		}
		while (a[i] > 0 && !st.empty()) {
			auto [r, c] = *st.begin();
			st.erase(st.begin());
			if (c <= a[i]) {
				a[i] -= c;
				rs += c;
			}
			else {
				c -= a[i];
				rs += a[i];
				a[i] = 0;
				st.insert(make_pair(r, c));
			}
		}
	}
	return rs;
}


void solve_slow() {
	rs.resize(n);
	for (int i = 0; i < n; ++i) {
		auto w1 = w;
		for (auto& f : w1) {
			if (f.t == 1) {
				f.l = min(f.l, i);
				f.r = max(f.r, i);
			}
		}
		rs[i] = solve_slow(w1, a);
	}
}


int32_t main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int t;
	cin >> t;
	while (t--) {
		cin >> n >> m;
		a.resize(n);
		for (int i = 0; i < n; ++i) {
			cin >> a[i];
		}
		w.resize(m);
		for (int i = 0; i < m; ++i) {
			int l, r;
			ll c;
			int t;
			cin >> l >> r >> c >> t;
			--l;
			--r;
			w[i] = rbt(l, r, c, t);
		}
		solve_slow();
		for (int i = 0; i < n; ++i) {
			cout << rs[i] << " ";
		}
		cout << "\n";
	}
	return 0;
}