#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;
using namespace std;

struct Query {
    int index, t, k, i;
    Query(int index, int t, int k): index(index), t(t), k(k) {}
    Query(int index, int t, int k, int i): index(index), t(t), k(k), i(i) {}
};

void solve() {
    int n, q;
    cin >> n >> q;

    vector <ll> exp(n);
    for (ll &x: exp) cin >> x;

    auto step = [&] (vector <ll> &e) {
        vector <int> add(n);
        for (int i = 0; i < n; i++) {
            set <int> seen;
            for(int j =0; j < n; j++) {
                if (e[j] > e[i] && seen.find(e[j]) == seen.end()) {
                    add[i]++;
                    seen.insert(e[j]);
                }
            }
        }

        for (int i = 0; i < n; i++) {
            e[i] += add[i];
        }

        return accumulate(add.begin(), add.end(), 0ll);
    };

    int t, k, u;
    vector <Query> queries;
    for (int i = 0; i < q; i++) {
        cin >> t >> k;
        if (t == 3) {
            cin >> u;
            queries.emplace_back(i, t, k, u - 1);
        } else {
            queries.emplace_back(i, t, k);
        }
    }

    sort(queries.begin(), queries.end(), [] (Query lhs, Query rhs) {
        return lhs.k < rhs.k;
    });

    vector <ll> answers(q);

    int kx = 0; ll s = 0;
    for (auto &query: queries) {
        while (kx < query.k) {
            s += step(exp);
            kx++;
        }

        if (query.t == 3) {
            answers[query.index] = exp[query.i];
        } else if (query.t == 1) {
            set <int> seen;
            for (int x: exp)
                seen.insert(x);

            answers[query.index] = seen.size();
        } else {
            answers[query.index] = s;
        }
    }

    for (ll x: answers) cout << x << '\n';
}

signed main() {
    cin.tie(NULL);
    ios_base::sync_with_stdio(false);

    #ifdef local
    freopen("input.txt", "r", stdin);
    #endif // local

    solve();
}
