#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cmath>
#include <set>
#include <map>

using namespace std;

const int MAXNt = (1 << 14);

long long st[2 * MAXNt];

void upd(int pos, long long val) {
	st[pos] = val;
}

long long get_sum(int l, int r = MAXNt - 1) {
	long long res = 0;
	for (int i = l; i <= r; i++)
		res += st[i];
	return res;
}

int stc[2 * MAXNt];

void updc(int pos) {
	stc[pos]++;
}

int get_cnt(int l, int r) {
	int res = 0;
	for (int i = l; i <= r; i++)
		res += stc[i];
	return res;
}

bool comp(pair <pair <long long, int>, int> a, pair <pair <long long, int>, int> b) {
	if (a.first.first == b.first.first)
		return a.second < b.second;
	return a.first.first < b.first.first;
}

void solve() {
	int n, q;
	cin >> n >> q;
	vector <long long> c(n);
	for (int i = 0; i < n; i++)
		cin >> c[i];
	vector <pair <long long, int>> temp;
	for (int i = 0; i < n; i++)
		temp.push_back({ c[i], i });
	sort(temp.begin(), temp.end());
	vector <pair <long long, pair <int, int>>> edge;
	vector <pair <long long, int>> edgee;
	vector <int> pos(n);
	for (int i = 0; i < n; i++)
		pos[temp[i].second] = i;
	for (int i = 0; i < n - 1; i++) {
		edge.push_back({ temp[i + 1].first - temp[i].first, {temp[i].second, temp[i + 1].second} });
		if (temp[i + 1].first != temp[i].first)
			edgee.push_back({ temp[i + 1].first - temp[i].first, i + 1 });
	}
	sort(edge.begin(), edge.end());
	sort(edgee.begin(), edgee.end());
	vector <long long> ans(q, 0);
	vector <pair <long long, int>> q2;
	vector <pair <pair <long long, int>, int>> q3;
	for (int i = 0; i < q; i++) {
		int t;
		cin >> t;
		long long k;
		cin >> k;
		if (t == 1) {
			int l = 0, r = edge.size() - 1;
			while (l < r) {
				int mid = (l + r + 1) / 2;
				if (edge[mid].first <= k)
					l = mid;
				else
					r = mid - 1;
			}
			int res = l + 1;
			if (l == 0 && edge[0].first > k)
				res = 0;
			ans[i] = n - res;
		}
		else if (t == 2) {
			q2.push_back({ k, i });
		}
		else {
			int id;
			cin >> id;
			id--;
			q3.push_back({ {k, id}, i });
		}
	}
	sort(q2.begin(), q2.end());
	sort(q3.begin(), q3.end(), comp);
	int id = 0;
	long long speed = 0;
	int t = 0;
	vector <int> s0(n, 0);
	for (int i = temp.size() - 2; i >= 0; i--) {
		if (temp[i + 1].first != temp[i].first)
			t++;
		speed += t;
		s0[i] = t;
	}
	long long sum = 0;
	long long tim = 0;
	for (int i = 0; i < q2.size(); i++) {
		while (id < edgee.size() && q2[i].first >= edgee[id].first) {
			sum += speed * (edgee[id].first - tim);
			tim = edgee[id].first;
			speed -= edgee[id].second;
			id++;
		}
		sum += speed * (q2[i].first - tim);
		tim = q2[i].first;
		ans[q2[i].second] = sum;
	}
/*	id = 0;
	for (int i = 0; i < q3.size(); i++) {
		while (id < (int)edgee.size() && q3[i].first.first > edgee[id].first) {
			upd(edgee[id].second, edgee[id].first);
			updc(edgee[id].second);
			id++;
		}
		int g = pos[q3[i].first.second];
		long long sum = c[q3[i].first.second] + q3[i].first.first * s0[g];
		long long bad = get_cnt(g, n) * q3[i].first.first - get_sum(g, n);
		sum -= bad;
		ans[q3[i].second] = sum;
	} */
	for (int i = 0; i < q; i++)
		cout << ans[i] << "\n";
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int tests = 1;
	//  cin >> tests;
	for (int test = 1; test <= tests; test++) {
		solve();
	}
}