#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cmath>
#include <set>
#include <map>
#include <random>
#include <queue>

using namespace std;

const int MAXN = 5000 + 7;

vector <int> g[MAXN];
int dist[MAXN];

int c[MAXN][MAXN];

void dfs(int v, int ban, int gg) {
	queue <int> q;
	q.push(v);
	c[ban][v] = gg;
	while (q.size()) {
		int v = q.front();
		q.pop();
		for (auto to : g[v]) {
			if (c[ban][to] == -1 && ban != to) {
				c[ban][to] = gg;
				q.push(to);
			}
		}
	}
}

int dp[MAXN][MAXN];

void solve() {
	int n, m;
	cin >> n >> m;
	int v, u;
	for (int i = 0; i < n; i++)
		g[i].clear();
	for (int i = 0; i < m; i++) {
		cin >> v >> u;
		v--; u--;
		g[v].push_back(u);
		g[u].push_back(v);
	}
	for (int w = 0; w < n; w++)
		fill(c[w], c[w] + n, -1);
	for (int w = 0; w < n; w++) {
		int gg = 0;
		for (int st = 0; st < n; st++) {
			if (c[w][st] == -1 && st != w) {
				dfs(st, w, gg);
				gg++;
			}
		}
	}
	queue <int> q;
	fill(dist, dist + n, 1e9);
	dist[0] = 0;
	q.push(0);
	while (q.size()) {
		int v = q.front();
		q.pop();
		for (auto to : g[v]) {
			for (auto to2 : g[to]) {
				if (dist[to2] > dist[v] + 2 && c[to][v] == c[to][to2]) {
					dist[to2] = dist[v] + 2;
					q.push(to2);
				}
			}
		}
	}
	for (int i = 1; i < n; i++) {
		if (dist[i] == 1e9)
			cout << "-1 ";
		else
			cout << dist[i] << " ";
	}
	cout << "\n";
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int tests = 1;
	cin >> tests;
	for (int test = 1; test <= tests; test++) {
		solve();
	}
}