#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <cassert>
#include <map>
#include <deque>

using namespace std;
typedef long long ll;
#define int long long

const int inf = 1e9 + 10;
struct ed
{
	int u, v;
	int f, e;
	int s;

	ed() {}

	ed(int u, int v, int f, int e, int s) : u(u), v(v), f(f), e(e), s(s) {}
};

int n, m;
int a[200010];
int l[200010];
int r[200010];
int c[200010];
int h[200010];
int s, t;

vector <ed> g[400010];

inline void add(int u, int v, int e)
{
	g[u].push_back(ed(u, v, 0, e, g[v].size()));
	g[v].push_back(ed(v, u, 0, 0, g[u].size() - 1));
}

int was[400010];
bool bad[400010]; ////////////////////////////////////////////////////////////
int C = 1;
int ans;
int BO;
int d[400010];

inline bool bfs()
{
	for (int i = s; i <= t; ++i)
	{
		d[i] = i == s ? 0 : inf;
	}

	deque <int> queue;
	queue.push_back(s);

	while (queue.size())
	{
		auto u = queue.front();
		queue.pop_front();
		for (auto v : g[u])
		{
			int to = v.e - v.f;
			if (to < BO) continue;
			if (d[v.v] > d[u] + 1)
			{
				d[v.v] = d[u] + 1;
				queue.push_back(v.v);
			}
		}
	}
	return d[t] < inf;
}

int dfs(int u, int x)
{
	if (was[u] == C) return 0;
	if (bad[u]) return 0;
	if (u == t) return x;
	was[u] = C;
	
	for (auto& v : g[u])
	{
		int to = min(x, v.e - v.f);
		if (to < BO) continue;
		if (d[v.v] != d[u] + 1) continue;
		auto gt = dfs(v.v, to);
		if (!gt) continue;
		v.f += gt;
		g[v.v][v.s].f -= gt;
		return gt;
	}
	bad[u] = true;
	return 0;
}

int fl()
{
	BO = inf;
	ans = 0;
	while (BO)
	{
		while (bfs())
		{
			for (int i = s; i <= t; ++i) bad[i] = false;
			while (true)
			{
				++C;
				auto got = dfs(s, inf);
				ans += got;
				if (!got) break;
			}
		}
		BO /= 2;
	}
	return ans;
}

vector <ed> cp[400010];

inline void solve()
{
	cin >> n >> m;

	for (int i = 1; i <= n; ++i)
	{
		cin >> a[i];
	}

	for (int i = 1; i <= m; ++i)
	{
		cin >> l[i] >> r[i] >> c[i] >> h[i];
	}

	s = 0;
	t = n + m + 1;

	for (int j = 1; j <= m; ++j)
	{
		add(s, j, c[j]);
	}
	for (int j = 1; j <= n; ++j)
	{
		add(j + m, t, a[j]);
	}

	for (int j = 1; j <= m; ++j)
	{
		int lx = l[j], rx = r[j];
		for (int k = lx; k <= rx; ++k) add(j, k + m, inf);
	}
	int hu = fl();
	for (int i = s; i <= t; ++i) cp[i] = g[i];

	for (int i = 1; i <= n; ++i)
	{
		for (int i = s; i <= t; ++i) g[i] = cp[i];
		for (int j = 1; j <= m; ++j)
		{
			if (!h[j]) continue;
			if (i < l[j])
			{
				for (int k = i; k < l[j]; ++k) add(j, k + m, inf);
			}
			else if (i > r[j])
			{
				for (int k = r[j] + 1; k <= i; ++k) add(j, k + m, inf);
			}
		}
		auto got = fl() + hu;
		cout << got << ' ';
	}

	cout << '\n';
}

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	int t;
	cin >> t;
	while (t--) solve();

	return 0;
}