#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <random>

#define int long long
#define begend(x) x.begin(),x.end()

using namespace std;
int n, q;
vector<int> d_unsorted;
vector<vector<pair<int, int>>> str;
vector<vector<int>> strD;
vector<vector<int>> prefLC;
vector<vector<int>> prefLMC;

void build(int v, int l, int r) {
	int len = r - l;
	auto& d_mul = str[v];
	auto& d = strD[v];
	auto& prefL = prefLC[v];
	auto& prefLM = prefLMC[v];
	for (int i = l; i < r; i++)
		d_mul.push_back({ d_unsorted[i],i });
	for (int i = l; i < r; i++)
		d.push_back(d_unsorted[i]);
	sort(begend(d_mul));
	sort(begend(d));

	prefL = vector<int>(len);
	prefL.back() = d_mul.back().second;
	for (int i = len - 2; i >= 0; i--)
		prefL[i] = prefL[i + 1] + d_mul[i].second;
	prefLM = vector<int>(len);
	prefLM.back() = d_mul.back().second * d_mul.back().first;
	for (int i = len - 2; i >= 0; i--)
		prefLM[i] = prefLM[i + 1] + d_mul[i].second * d_mul[i].first;

	if (len == 1)return;
	int mid = (l + r) / 2;
	build(v * 2, l, mid);
	build(v * 2 + 1, mid, r);
}
int getDif(int v, int k, int l, int r, int lq) {
	if (r <= lq)return 0;
	if (l < lq) {
		int mid = (l + r) / 2;
		return	getDif(v * 2, k, l, mid, lq) + getDif(v * 2 + 1, k, mid, r, lq);
	}

	auto& d_mul = str[v];
	auto& d = strD[v];
	auto& prefL = prefLC[v];
	auto& prefLM = prefLMC[v];
	int cnt = upper_bound(begend(d), k) - d.begin();
	int cntAll = 0;
	if (cnt != prefLM.size()) {
		cntAll -= prefLM[cnt];
		cntAll += prefL[cnt] * k;
	}
	return cntAll;
}

int32_t main()
{
	cin >> n >> q;
	vector<int> nums(n);
	vector<pair<int, int>> nums2(n);
	for (int i = 0; i < n; i++) {
		cin >> nums2[i].first;
		nums2[i].second = i;
	}
	sort(nums2.begin(), nums2.end());
	vector<int> table(n);
	for (int i = 0; i < n; i++)
	{
		nums[i] = nums2[i].first;
		table[nums2[i].second] = i;
	}

	vector<int> d(n - 1);
	for (int i = 0; i < n - 1; i++)
		d[i] = nums[i + 1] - nums[i];
	d_unsorted = d;
	sort(d.begin(), d.end());

	vector<int> suffSum(n);
	suffSum.back() = 0;
	for (int i = n - 2; i >= 0; i--)
		suffSum[i] = d_unsorted[i] + suffSum[i + 1];

	vector<pair<int, int>> d_mul(n - 1);
	for (int i = 0; i < n - 1; i++)
		d_mul[i].first = nums[i + 1] - nums[i];
	for (int i = 0; i < n - 1; i++)
		d_mul[i].second = i + 1;

	sort(begend(d_mul));
	vector<int> prefL(n - 1);
	prefL.back() = d_mul.back().second;
	for (int i = n - 3; i >= 0; i--)
		prefL[i] = prefL[i + 1] + d_mul[i].second;
	vector<int> prefLM(n - 1);
	prefLM.back() = d_mul.back().second * d_mul.back().first;
	for (int i = n - 3; i >= 0; i--)
		prefLM[i] = prefLM[i + 1] + d_mul[i].second * d_mul[i].first;

	int nlog = 1 << (int)ceil(log2(n));
	d_unsorted.resize(2 * nlog);
	str.resize(2 * nlog);
	strD.resize(2 * nlog);
	prefLC.resize(2 * nlog);
	prefLMC.resize(2 * nlog);
	build(1, 0, nlog);

	for (int i = 0; i < q; i++)
	{
		int t, k;
		cin >> t >> k;
		if (t == 1) {
			int cnt = upper_bound(begend(d), k) - d.begin();
			cout << nums.size() - cnt << endl;
		}
		else if (t == 2) {
			int cnt = upper_bound(begend(d), k) - d.begin();
			int cntAll = prefLM[0];
			if (cnt != n - 1) {
				cntAll -= prefLM[cnt];
				cntAll += prefL[cnt] * k;
			}
			cout << cntAll << endl;
		}
		else if (t == 3) {
			int ind;
			cin >> ind;
			ind = table[ind - 1] + 1;
			cout << d_unsorted[ind] + getDif(1, k, 0, nlog, ind) - getDif(1, k, 0, nlog, ind - 1) + nums[ind] << endl;
		}
	}
}