#include <bits/stdc++.h>
using namespace std;
#define int long long

typedef pair<int, int> STinput;
typedef vector<STinput> ST;

const STinput zero({0, 0});

int powround(int n) {
    int k(1);
    while (k < n) {
        k *= 2;
    }
    return k;
}

STinput add(STinput a, STinput b) {
    return {a.first + b.first, a.second + b.second};
}

void create(ST& tree, int n) {
    tree.assign(2 * powround(n), zero);
}

void add(ST& tree, int v, STinput x) {
    //cout << v << " " << x.first << " " << x.second << endl;
    int p(tree.size() / 2 + v);
    tree[p] = x;
    p /= 2;
    while (p > 0) {
        //cout << p << endl;
        tree[p] = add(tree[2 * p], tree[2 * p + 1]);
        p /= 2;
    }
}

STinput isum(ST& tree, int x, int l, int r, int lq, int rq) {
    if ((l >= rq) || (lq >= r)) {
        //cout << x << " " << l << " " << r << " " << lq << " " << rq << " 0 0" << endl;
        return zero;
    }
    if ((r <= rq) && (lq <= l)) {
        //cout << x << " " << l << " " << r << " " << lq << " " << rq << " " << tree[x].first << " " << tree[x].second << endl;
        return tree[x];
    }
    int m((l + r) / 2);
    STinput res(add(isum(tree, 2 * x, l, m, lq, rq), isum(tree, 2 * x + 1, m, r, lq, rq)));
    //cout << x << " " << l << " " << r << " " << lq << " " << rq << " " << res.first << " " << res.second << endl;
    return res;
}

STinput sum(ST& tree, int l, int r) {
    return isum(tree, 1, 0, tree.size() / 2, l, r);
}

void answerize(vector<int>& answers, vector<pair<pair<int, int>, int>>& type3s, vector<pair<int, int>>& sgaps, int leader, vector<int>& sortedposses) {
    ST tree;
    create(tree, sgaps.size() + 1);
    //cout << tree.size() << endl;
    vector<tuple<int, int, int>> events{};
    for (auto i : sgaps) {
        events.push_back(make_tuple(i.first, -1, i.second - 1));
    }
    for (auto i : type3s) {
        events.push_back(make_tuple(i.first.first, sortedposses[i.first.second], i.second));
    }
    sort(events.begin(), events.end());
    for (int i = events.size() - 1; i >= 0; i--) {
        if (get<1>(events[i]) == -1) { //Open a gap
            //cout << "GAP" << endl;
            //cout << get<0>(events[i]) << " " << get<1>(events[i]) << " " << get<2>(events[i]) << endl;
            add(tree, get<2>(events[i]), {get<0>(events[i]), 1});
        } else { //Answer an event
            //cout << "TYPE3" << endl;
            //cout << get<0>(events[i]) << " " << get<1>(events[i]) << " " << get<2>(events[i]) << endl;
            pair<int, int> summa(sum(tree, get<1>(events[i]), sgaps.size()));
            //cout << "TEST" << endl;
            //cout << summa.first << " " << summa.second << endl;
            answers[get<2>(events[i])] = leader - (summa.first - summa.second * get<0>(events[i]));
        }
    }
}


int fnozg(int k, vector<int>& sgaps) {
    auto upb(upper_bound(sgaps.begin(), sgaps.end(), k));
    return (upb - sgaps.begin());
}

int sexp(int k, vector<int>& sgaps, vector<int>& prefix_sgaps, vector<int>& suffix_sgaps, int leader, int n) {
    auto upb(upper_bound(sgaps.begin(), sgaps.end(), k));
    int kgap(upb - sgaps.begin());
    //cout << kgap << endl;
    //cout << prefix_sgaps[kgap] << " " << suffix_sgaps[n - 1 - kgap] << endl;
    return prefix_sgaps[kgap] + k * suffix_sgaps[n - 1 - kgap];
}

signed main() {
    int n, Q, q, r, sumstart(0);
    cin >> n >> Q;
    vector<pair<int, int>> starts{};
    vector<int> sortedposses(n);
    for (int i = 0; i < n; i++) {
        cin >> q;
        sumstart += q;
        starts.push_back({q, i});
    }
    sort(starts.begin(), starts.end());
    for (int i = 0; i < n; i++) {
        sortedposses[starts[i].second] = i;
    }
    vector<int> gaps{}, sgaps{};
    vector<pair<int, int>> sgaps2;
    for (int i = 1; i < n; i++) {
        gaps.push_back(starts[i].first - starts[i - 1].first);
        sgaps.push_back(starts[i].first - starts[i - 1].first);
        sgaps2.push_back({starts[i].first - starts[i - 1].first, i});
    }
    sort(sgaps2.begin(), sgaps2.end());
    vector<int> prefix_sgaps{0}, suffix_sgaps{0};
    /*for (auto i : sgaps2) {
        cout << i.first << " " << i.second << endl;
    }*/
    int sg(0);
    for (int i = 0; i < sgaps2.size(); i++) {
        sg += sgaps2[i].first * sgaps2[i].second;
        prefix_sgaps.push_back(sg);
    }
    sg = 0;
    for (int i = sgaps2.size() - 1; i >= 0; i--) {
        sg += sgaps2[i].second;
        suffix_sgaps.push_back(sg);
    }
    int leader(starts.back().first);
    sort(sgaps.begin(), sgaps.end());
    vector<int> answers(Q, 0);
    vector<pair<pair<int, int>, int>> type3s{};
    for (int i = 0; i < Q; i++) {
        cin >> q;
        if (q == 1) {
            cin >> q;
            answers[i] = n - fnozg(q, sgaps);
        } else if (q == 2) {
            cin >> q;
            answers[i] = sexp(q, sgaps, prefix_sgaps, suffix_sgaps, leader, n);
        } else if (q == 3) {
            cin >> q >> r;
            r--;
            type3s.push_back({{q, r}, i});
        }
    }
    answerize(answers, type3s, sgaps2, leader, sortedposses);
    for (int i = 0; i < Q; i++) {
        cout << answers[i] << endl;
    }
}
