#include <bits/stdc++.h>

using namespace std;

__int128 to_int(string xs) {
	__int128 res = 0;
	for (char c : xs) {
		res = res * 10 + c - '0';
	}
	return res;
}

string to_str(__int128 x, int n) {
	string res = "";
	for (int i = 0; i < n; ++i) {
		res.push_back('0' + (int)(x % 10));
		x /= 10;
	}
	reverse(res.begin(), res.end());
	return res;
}

struct Fenwick {
	int n;
	vector<int> f;

	void add(int i, int val) {
		for (++i; i <= n; i += i & -i) {
			f[i] += val;
		}
	}

	int get(int i) {
		int res = 0;
		for (; i > 0; i -= i & -i) {
			res += f[i];
		}
		return res;
	}

	int get(int l, int r) {
		return get(r) - get(l);
	}

	Fenwick(int n) : n(n) {
		f = vector<int>(n + 1, 0);
	}
};

string solve_small(string x, long long y) {
	int n = x.size();
	
	vector<__int128> pw(n);
	pw[0] = 1;
	for (int i = 1; i < n; ++i) {
		pw[i] = pw[i - 1] * 10;
	}

	vector<__int128> dp(1 << n);
	vector<int> par(1 << n, -1);

	dp[0] = 0;
	for (int mask = 1; mask < (1 << n); ++mask) {
		for (int i = 0; i < n; ++i) {
			if ((mask >> i) & 1) {
				__int128 val = dp[mask - (1 << i)] + __int128(x[i] - '0') * pw[n - __builtin_popcount(mask)];
				for (int j = i + 1; j < n; ++j) {
					if ((mask >> j) & 1) {
						val -= y;
					}
				}
				if (par[mask] == -1 || val > dp[mask]) {
					dp[mask] = val;
					par[mask] = i;
				}
			}
		}
	}

	string res = "";
	int mask = (1 << n) - 1;
	while (mask != 0) {
		res += x[par[mask]];
		mask -= (1 << par[mask]);
	}
	reverse(res.begin(), res.end());
	return res;
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);

	string x;
	long long y;
	cin >> x >> y;

	if (x.size() <= 20) {
		cout << solve_small(x, y) << endl;
		return 0;
	}

	return 0;	
}