#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <numeric>
#include <cassert>
#include <iomanip>
#include <string>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

#ifndef DESPAIR_101
#define cerr if (false) cerr
#endif

template<class A>
void print(A x) {
	cerr << x;
}
template<class A>
void print(vector<A> x) {
	for (A el : x) {
		print(el);
		cerr << ' ';
	}
	cerr << '\n';
}

#define int ll
#define sz(x) int(x.size())
#define dbg(x) cerr << #x << ":\n "; print(x); cerr << "\n";

void solve() {
	int n, q;
	cin >> n >> q;

	vector<pair<int, int>> c(n);

	for (int i = 0; i < n; ++i) {
		cin >> c[i].first;
		c[i].second = i;
	}
	sort(c.begin(), c.end());
	vector<int> ind(n);
	for (int i = 0; i < n; ++i) {
		ind[c[i].second] = i;
	}

	vector<vector<int>> ex(10002, vector<int>(n));
	for (int i = 0; i < n; ++i) {
		ex[0][i] = c[i].first;
	}

	for (int k = 1; k < 10002; ++k) {
		ex[k] = ex[k - 1];
		int diff = 0;
		for (int i = n - 2; i >= 0; --i) {
			if (ex[k - 1][i] < ex[k - 1][i + 1]) ++diff;
			ex[k][i] += diff;
		}
	}

	dbg(ex[0]);
	
	for (int i = 0; i < q; ++i) {
		int t;
		cin >> t;
		if (t == 1) {
			int k;
			cin >> k;
			int diff = 0;
			for (int i = n - 2; i >= 0; --i) {
				if (ex[k][i] < ex[k][i + 1]) ++diff;
			}
			cout << diff + 1 << '\n';
		} else if (t == 2) {
			int k;
			cin >> k;
			int ans = 0;
			for (int i = 0; i < n; ++i) {
				ans += ex[k][i] - ex[0][i];
			}
			cout << ans << '\n';
		} else {
			int k, j;
			cin >> k >> j;
			cout << ex[k][ind[j - 1]] << '\n';
		}
	}
}

signed main() {
	cin.tie(nullptr);
	ios::sync_with_stdio(false);

	int te = 1;
	//cin >> te;

	for (int t = 1; t <= te; ++t) {
		cerr << "_____Test# " << t << "_____\n";
		solve();
	}
}
