#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC target("avx,avx2")

#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <numeric>
#include <cassert>
#include <iomanip>
#include <string>
#include <random>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

#ifndef DESPAIR_101
#define cerr if (false) cerr
#endif

template<class A>
void print(A x) {
	cerr << x;
}
template<class A, class B>
void print(pair<A, B> x) {
	cerr << '(' << x.first << ' ' << x.second << ')';
}
template<class A>
void print(vector<A> x) {
	for (A el : x) {
		print(el);
		cerr << ' ';
	}
	cerr << '\n';
}

#define int ll
#define sz(x) int(x.size())
#define dbg(x) cerr << #x << ":\n "; print(x); cerr << "\n";

mt19937 rnd(101);

int ans[int(3e5)];

void calc1(int n, int q, vector<int>& c_, vector<pair<int, int>>& q1) {
	vector<pair<int, int>> c(n);
	vector<int> d(n - 1);

	for (int i = 0; i < n; ++i) {
		c[i].first = c_[i];
		c[i].second = i;
	}
	sort(c.begin(), c.end());

	for (int i = 0; i < n - 1; ++i) {
		d[i] = c[i + 1].first - c[i].first;
	}

	sort(d.rbegin(), d.rend());
	sort(q1.begin(), q1.end());
	for (auto [k, i] : q1) {
		while (!d.empty() && d.back() <= k) d.pop_back();
		ans[i] = sz(d) + 1;
	}
}

void calc2(int n, int q, vector<int>& c_, vector<pair<int, int>>& q2) {
	vector<pair<int, int>> c(n);
	vector<int> d(n - 1);

	for (int i = 0; i < n; ++i) {
		c[i].first = c_[i];
		c[i].second = i;
	}
	sort(c.begin(), c.end());

	map<int, vector<int>> mp;
	for (int i = 0; i < n - 1; ++i) {
		d[i] = c[i + 1].first - c[i].first;
		if (d[i]) mp[d[i]].push_back(i + 1);
	}

	int cur = 0;
	int diff = 0;
	for (int i = n - 2; i >= 0; --i) {
		if (c[i].first < c[i + 1].first) ++diff;
		cur += diff;
	}

	int last = 1;
	vector<tuple<int, int, int>> sus;
	sus.emplace_back(0, 0, 0);
	for (auto& [x, ind] : mp) {
		sus.emplace_back(last, x, cur);
		last = x + 1;
		for (int i : ind) cur -= i;
	}
	sus.emplace_back(last, int(1e13), cur);

	int pl = 0, j = 0;
	sort(q2.begin(), q2.end());
	for (auto [k, i] : q2) {
		while (true) {
			auto [le, ri, add] = sus[j];
			if (ri < k) {
				pl += (ri - le + 1) * add;
				++j;
			} else {
				break;
			}
		}
		auto [le, ri, add] = sus[j];
		ans[i] = pl + (k - le + 1) * add;
	}
}

struct Node {
	int x;
	int y;
	int cnt;
	int sum;
	int size;
	Node* l;
	Node* r;
	Node(int v) {
		cnt = 1;
		size = 1;
		x = v;
		sum = v;
		y = rnd();
		l = r = nullptr;
	}
};

int getSum(Node* t) {
	if (!t) return 0;
	return t->sum;
}

int getSize(Node* t) {
	if (!t) return 0;
	return t->size;
}

void relax(Node* t) {
	if (!t) return;
	t->sum = t->x * t->cnt + getSum(t->l) + getSum(t->r);
	t->size = t->cnt + getSize(t->l) + getSize(t->r);
}

Node* merge(Node* a, Node* b) {
	if (!a) return b;
	if (!b) return a;
	if (a->y > b->y) {
		a->r = merge(a->r, b);
		relax(a);
		return a;
	} else {
		b->l = merge(a, b->l);
		relax(b);
		return b;
	}
}

pair<Node*, Node*> split(Node* a, int v) {
	if (!a) return { nullptr, nullptr };
	if (a->x > v) {
		auto [t1, t2] = split(a->l, v);
		a->l = t2;
		relax(a);
		return { t1, a };
	} else {
		auto [t1, t2] = split(a->r, v);
		a->r = t1;
		relax(a);
		return { a, t2 };
	}
}

Node* insert(Node* t, int v) {
	auto [t1, t2] = split(t, v);
	auto [t11, t12] = split(t1, v - 1);
	if (t12) {
		++t12->size;
		++t12->cnt;
		t12->sum += t12->x;
	} else {
		t12 = new Node(v);
	}
	return merge(t11, merge(t12, t2));
}

void dfs(Node* t) {
	if (!t) return;
	dfs(t->l);
	cout << "!\n" << t->x << ' ' << t->cnt << '\n';
	dfs(t->r);
}

void calc3(int n, int q, vector<int>& c_, vector<tuple<int, int, int>>& q3) {
	vector<pair<int, int>> c(n);
	for (int i = 0; i < n; ++i) {
		c[i].first = c_[i];
		c[i].second = i;
	}
	sort(c.begin(), c.end());
	vector<int> ti(n);
	for (int i = 0; i < n; ++i) {
		ti[c[i].second] = i;
	}
	vector<int> d(n - 1);
	for (int i = 0; i < n - 1; ++i) {
		d[i] = c[i + 1].first - c[i].first;
	}

	for (auto& [k, ind, i] : q3) {
		ind = ti[ind];
	}

	sort(q3.begin(), q3.end(), [&](auto& l, auto& r) {
		return get<1>(l) < get<1>(r);
		});

	Node* tree = nullptr;
	for (int i = n - 1; i >= 0; --i) {
		//dfs(tree); cout << "\n";
		//K IND ANS_IND
		while (!q3.empty() && get<1>(q3.back()) == i) {
			auto [t1, t2] = split(tree, get<0>(q3.back()));
			//dfs(t1)
			ans[get<2>(q3.back())] = c[get<1>(q3.back())].first + getSum(t1) + get<0>(q3.back()) * getSize(t2);
			tree = merge(t1, t2);
			q3.pop_back();
		}
		if (i > 0) {
			tree = insert(tree, d[i - 1]);
		}
	}
	//for (auto [k, ind, i] : q3) {
	//	int sum = 0;
	//	for (int j = ti[ind]; j < n - 1; ++j) {
	//		sum += min(k, d[j]);
	//	}
	//	ans[i] = c_[ind] + sum;
	//}
}

void solve() {
	int n, q;
	cin >> n >> q;

	vector<int> c(n);
	for (int i = 0; i < n; ++i) {
		cin >> c[i];
	}

	vector<pair<int, int>> q1;
	vector<pair<int, int>> q2;
	vector<tuple<int, int, int>> q3;

	for (int i = 0; i < q; ++i) {
		int t, k, j;
		cin >> t;
		if (t == 1) {
			cin >> k;
			q1.emplace_back(k, i);
		} else if (t == 2) {
			cin >> k;
			q2.emplace_back(k, i);
		} else {
			cin >> k >> j;
			q3.emplace_back(k, j - 1, i);
		}
	}

	calc1(n, q, c, q1);
	calc2(n, q, c, q2);
	calc3(n, q, c, q3);

	for (int i = 0; i < q; ++i) {
		cout << ans[i] << '\n';
	}
}

signed main() {
	cin.tie(nullptr);
	ios::sync_with_stdio(false);

	int te = 1;
	//cin >> te;

	for (int t = 1; t <= te; ++t) {
		cerr << "_____Test# " << t << "_____\n";
		solve();
	}
}
