#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <cstring>
#include <numeric>
#include <queue>
#include <map>
#include <cassert>

#define int long long
#define all(a) a.begin(), a.end()
#define pb push_back
#define INF (int) 1e18 / 2

using namespace std;

const int N = 5e5 + 5;

vector<pair<int, int>> gt[2 * N];
vector<int> g[2 * N];
vector<int> tin, fup;
map<pair<int, int>, int> c;
vector<pair<int, int>> edges;

int color = 0;
int T = 1;

void dfs1(int v, int st) {
	for (auto[u, id] : gt[v]) {
		if (c.find({min(v, u), max(v, u)}) != c.end())
			continue;
		if (u == st)
			c[{min(v, u), max(v, u)}] = color;
		else
			c[{min(v, u), max(v, u)}] = color, dfs1(u, st);
	}
}

void dfs(int v, int p = -1) {
	int children = 0;
	tin[v] = fup[v] = T++;
	for (auto[u, id] : gt[v]) {
		if (u == p)
			continue;
		if (!tin[u]) {
			dfs(u, v);
			if (p != -1 && fup[u] >= tin[v])
				edges.pb({v, u});
			fup[v] = min(fup[v], fup[u]);
			children++;
			if (p == -1)
				edges.pb({0, u});
		} else {
			fup[v] = min(fup[v], tin[u]);
		}
	}
}


void solve() {
	int n, m;
	cin >> n >> m;
	fill(g, g + 2 * n,vector<int>());
	fill(gt, gt + n, vector<pair<int, int>>());
	tin.assign(n, 0);
	fup.assign(n, 0);
	c.clear();
	edges.clear();
	color = 0;
	T = 1;
	vector<pair<int, int>> kek;
	for (int i = 0; i < m; i++) {
		int v, u;
		cin >> v >> u;
		v--, u--;
		g[2 * v].pb(2 * u + 1);
		g[2 * v + 1].pb(2 * u);
		g[2 * u].pb(2 * v + 1);
		g[2 * u + 1].pb(2 * v);
		gt[v].pb({u, i});
		gt[u].pb({v, i});
		kek.pb({min(v, u), max(v, u)});
	}
	dfs(0, -1);
	for (auto[v, u] : edges) {
		color++;
		c[{min(v, u), max(v, u)}] = color;
		dfs1(u, v);
	}
	for (auto[v, u] : kek) {
		if (!c[{v, u}]) {
			c[{v, u}] = 0;
		}
	}
	vector<int> d(2 * n, INF);
	d[0] = 0;
	queue<pair<int, int>> q;
	q.push({0, -1});
	while (!q.empty()) {
		auto[v, col] = q.front();
		q.pop();
		int _v = v / 2;
		for (int u : g[v]) {
			int _u = u / 2;
			if (v & 1 && c[{min(_v, _u), max(_v, _u)}] != col)
				continue;
			if (d[u] > d[v] + 1)
				d[u] = d[v] + 1, q.push({u, c[{min(_v, _u), max(_v, _u)}]});
		}
	}
	for (int i = 1; i < n; i++)
		cout << (d[2 * i] == INF ? -1 : d[2 * i]) << " ";
	cout << '\n';
}

int32_t main() {
	cin.tie(0);
	cout.tie(0);
	ios::sync_with_stdio(false);

	int tt;
	cin >> tt;
	while (tt--) {
		solve();
	}
}
