#include <iostream>
#include <string>
#include <vector>
#include <map>
#include <algorithm>
#include <cmath>
#include <functional>
#include <set>
#include <unordered_map>


using namespace std;
using ll = long long;

//#define int ll
#define ve vector
#define pb push_back
#define all(h) (h).begin(), (h).end()
#define print(h) for (auto el : h) cout << el << " "; cout << "\n";
#define ft first
#define sd second

ve<ve <ll> > tree;

void push(int v) {
	tree[v * 2 + 1][0] += tree[v * 2 + 1][1] * tree[v][2];
	tree[v * 2 + 2][0] += tree[v * 2 + 2][1] * tree[v][2];
	tree[v * 2 + 1][2] += tree[v][2];
	tree[v * 2 + 2][2] += tree[v][2];
	tree[v][2] = 0;
}

void upd_ft(int v, int l, int r, int q, int x) {
	if (l >= r || l > q || q >= r) return;
	if (l + 1 == r) {
		tree[v][0] = tree[v][0] + x * tree[v][2];
		tree[v][1] += x;
		return;
	}
	push(v);
	int m = (l + r) / 2;
	upd_ft(v * 2 + 1, l, m, q, x);
	upd_ft(v * 2 + 2, m, r, q, x);
	tree[v][0] = tree[v * 2 + 1][0] + tree[v * 2 + 2][0];
	tree[v][1] = tree[v * 2 + 1][1] + tree[v * 2 + 2][1];
}

void upd_sd(int v, int l, int r, int ql, int qr, int x) {
	if (l >= r || l >= qr || ql >= r) return;
	if (ql <= l && r <= qr) {
		tree[v][0] += tree[v][1] * x;
		tree[v][2] += x;
		return;
	}
	push(v);
	int m = (l + r) / 2;
	upd_sd(v * 2 + 1, l, m, ql, qr, x);
	upd_sd(v * 2 + 2, m, r, ql, qr, x);
	tree[v][0] = tree[v * 2 + 1][0] + tree[v * 2 + 2][0];
}

ve<int> p;

void init(int n) {
	p.assign(n, 0);
	for (int i = 0; i < n; ++i) {
		p[i] = i;
	}
}

int find(int v) {
	if (p[v] == v) return v;
	return p[v] = find(p[v]);
}


void merge(int a, int b) {
	a = find(a);
	b = find(b);
	p[a] = b;
}

map <ll, ll> opr;

ve <pair <ll, int>> tree2;

void push2(int v) {
	tree2[v * 2 + 1].ft += tree2[v].ft;
	tree2[v * 2 + 1].sd += tree2[v].sd;
	tree2[v * 2 + 2].ft += tree2[v].ft;
	tree2[v * 2 + 2].sd += tree2[v].sd;
	tree2[v] = { 0, 0 };
}

void upd(int v, int l, int r, int ql, int qr, pair < ll, int > x) {
	if (l >= r || ql >= r || l >= qr) return;
	if (ql <= l && r <= qr) {
		tree2[v].ft += x.ft;
		tree2[v].sd += x.sd;
		return;
	}
	push2(v);
	int m = (l + r) / 2;
	upd(v * 2 + 1, l, m, ql, qr, x);
	upd(v * 2 + 2, m, r, ql, qr, x);
}

pair <ll, int> get_pair(int v, int l, int r, int q) {
	if (l + 1 == r) return tree2[v];
	int m = (l + r) / 2;
	push2(v);
	if (q < m) return get_pair(v * 2 + 1, l, m, q);
	return get_pair(v * 2 + 2, m, r, q);
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n, q;
	cin >> n >> q;
	ve<ll> a(n);
	set <ll> al;
	map <ll, int> cnt;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		++cnt[a[i]];
		al.insert(a[i]);
	}
	ve<ll> b;
	int id = 0;
	for (auto el : al) {
		b.pb(el);
		opr[el] = id;
		++id;
	}
	int m = b.size();
	tree.resize(4 * m, { 0, 0, 0 });
	for (int i = b.size() - 1; i >= 0; --i) {
		upd_ft(0, 0, m, i, cnt[b[i]]);
		upd_sd(0, 0, m, 0, i, 1);
	}
	ve<ll> ans(q);
	ve<ll> zap;
	ve<pair<ll, pair <ll, ll>>> g;
	for (int i = 0; i < m - 1; ++i) {
		g.pb({ b[i + 1] - b[i], {0, i} });
	}
	for (int i = 0; i < q; ++i) {
		int t;
		cin >> t;
		if (t == 1) {
			ll k;
			cin >> k;
			g.pb({ k, {t, i} });
			zap.pb(0);
		}
		if (t == 2) {
			ll k;
			cin >> k;
			g.pb({ k, {t, i} });
			zap.pb(0);
		}
		if (t == 3) {
			ll k, j;
			cin >> k >> j;
			g.pb({ k, {t, i} });
			zap.pb(j - 1);
		}
	}
	sort(all(g));
	init(m);
	ll tec = 0;
	ll last_k = 0;
	ll cnt_comp = m;
	ve<ll> tec_sz(m, 0);
	set <int> used;
	ve<ll> add(m);
	tree2.assign(4 * m, { 0, 0 });
	for (int i = 0; i < m; ++i) {
		tec_sz[i] = b[i];
		used.insert(i);
		add[i] = m - i - 1;
		upd(0, 0, m, i, i + 1, { b[i], m - i - 1 });
	}
	int lasta = -1;
	for (auto el : g) {
		if (el.sd.ft == 0) {
			int x = find(el.sd.sd);
			int y = find(el.sd.sd + 1);
			tec += (el.ft - last_k) * tree[0][0];
			//upd_ft(0, 0, m, x, -cnt[b[x]]);
			//upd_ft(0, 0, m, y, cnt[b[x]]);
			cnt[b[y]] += cnt[b[x]];
			cnt[b[x]] = 0;
			--cnt_comp;
			upd_sd(0, 0, m, 0, x + 1, -1);
			ll cnt_add = cnt_comp;
			upd(0, 0, m, 0, x + 1, { el.ft, -1 });
			last_k = el.ft;
			merge(x, y);

		}
		if (el.sd.ft == 1) {
			ans[el.sd.sd] = cnt_comp;
		}
		if (el.sd.ft == 2) {
			ans[el.sd.sd] = tec + tree[0][0] * (el.ft - last_k);
		}
		if (el.sd.ft == 3) {
			auto it = get_pair(0, 0, m, find(opr[a[zap[el.sd.sd]]]));
			ans[el.sd.sd] = it.ft + it.sd * (el.ft);
		}
	}
	for (auto it : ans) {
		cout << it << "\n";
	}
	return 0;
}