#include <iostream>
#include <string>
#include <vector>
#include <map>
#include <algorithm>
#include <cmath>
#include <functional>
#include <set>


using namespace std;
using ll = long long;

//#define int ll
#define ve vector
#define pb push_back
#define all(h) (h).begin(), (h).end()
#define print(h) for (auto el : h) cout << el << " "; cout << "\n";
#define ft first
#define sd second

ve<ve <ll> > tree;

void push(int v) {
	tree[v * 2 + 1][0] += tree[v * 2 + 1][1] * tree[v][2];
	tree[v * 2 + 2][0] += tree[v * 2 + 2][1] * tree[v][2];
	tree[v * 2 + 1][2] += tree[v][2];
	tree[v * 2 + 2][2] += tree[v][2];
	tree[v][2] = 0;
}

void upd_ft(int v, int l, int r, int q, int x) {
	if (l >= r || l > q || q >= r) return;
	if (l + 1 == r) {
		tree[v][0] = tree[v][0] + x * tree[v][2];
		tree[v][1] += x;
		return;
	}
	push(v);
	int m = (l + r) / 2;
	upd_ft(v * 2 + 1, l, m, q, x);
	upd_ft(v * 2 + 2, m, r, q, x);
	tree[v][0] = tree[v * 2 + 1][0] + tree[v * 2 + 2][0];
	tree[v][1] = tree[v * 2 + 1][1] + tree[v * 2 + 2][1];
}

void upd_sd(int v, int l, int r, int ql, int qr, int x) {
	if (l >= r || l >= qr || ql >= r) return;
	if (ql <= l && r <= qr) {
		tree[v][0] += tree[v][1] * x;
		tree[v][2] += x;
		return;
	}
	push(v);
	int m = (l + r) / 2;
	upd_sd(v * 2 + 1, l, m, ql, qr, x);
	upd_sd(v * 2 + 2, m, r, ql, qr, x);
	tree[v][0] = tree[v * 2 + 1][0] + tree[v * 2 + 2][0];
}

ve<int> p;

void init(int n) {
	p.assign(n, 0);
	for (int i = 0; i < n; ++i) {
		p[i] = i;
	}
}

int find(int v) {
	if (p[v] == v) return v;
	return p[v] = find(p[v]);
}


void merge(int a, int b) {
	a = find(a);
	b = find(b);
	p[a] = b;
}

signed main() { 
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n, q;
	cin >> n >> q;
	ve<pair <ll, int> > a(n);
	set <ll> al;
	map <ll, int> cnt;
	for (int i = 0; i < n; ++i) {
		cin >> a[i].ft;
		a[i].sd = i;
		++cnt[a[i].ft];
		al.insert(a[i].ft);
	}
	ve<ll> b;
	for (auto el : al) {
		b.pb(el);
	}
	int m = b.size();
	tree.resize(4 * m, { 0, 0, 0 });
	for (int i = b.size() - 1; i >= 0; --i) {
		upd_ft(0, 0, m, i, cnt[b[i]]);
		upd_sd(0, 0, m, 0, i, 1);
	}
	ve<ll> ans(q);
	ve<ll> zap;
	ve<pair<ll, pair <ll, ll>>> g;
	for (int i = 0; i < m - 1; ++i) {
		g.pb({ b[i + 1] - b[i], 0, i });
	}
	for (int i = 0; i < q; ++i) {
		int t;
		cin >> t;
		if (t == 1) {
			ll k;
			cin >> k;
			g.pb({ k, {t, i} });
			zap.pb(0);
		}
		if (t == 2) {
			ll k;
			cin >> k;
			g.pb({ k, {t, i} });
			zap.pb(0);
		}
		if (t == 3) {
			ll k, j;
			cin >> k >> j;
			g.pb({ k, {t, i} });
			zap.pb(j);
		}
	}
	sort(all(g));
	init(m);
	ll tec = 0;
	ll last_k = 0;
	ll cnt_comp = m;
	for (auto el : g) {
		if (el.sd.ft == 0) {
			int a = find(el.sd.sd);
			int b = find(el.sd.sd + 1);
			tec += (el.ft - last_k) * tree[0][0];
			upd_ft(0, 0, m, a, -cnt[a]);
			upd_ft(0, 0, m, b, cnt[a]);
			cnt[b] += cnt[a];
			cnt[a] = 0;
			--cnt_comp;
			upd_sd(0, 0, m, 0, a + 1, -1);
			last_k = el.ft;
			merge(a, b);
		}
		if (el.sd.ft == 1) {
			ans[el.sd.sd] = cnt_comp;
		}
		if (el.sd.ft == 2) {
			ans[el.sd.sd] = tec + tree[0][0] * (el.ft - last_k);
		}
		if (el.sd.ft == 3) {
			ans[el.sd.sd] = 4;
		}
	}
	for (auto it : ans) {
		cout << it << "\n";
	}
	return 0;
}