//#include <bits/stdc++.h>
#include "iostream"
#include "set"
#include "unordered_set"
#include "map"
#include "unordered_map"
#include "vector"
#include "cmath"
#include "algorithm"
#include "numeric"
#include "string"
#include "bits/stdc++.h"
//#pragma optimize("Ofast")
//#pragma optimize("unroll-loops")
using namespace std;
typedef long long ll;


struct query {
    int type;
    ll k;
    int i;

    query() = default;
};


int get_root(int v, vector<int> &dsu) {
    if (dsu[v] != v) return get_root(dsu[v], dsu);
    return dsu[v];
}

void merge_dsu(int a, int b, vector<int> &dsu, vector<ll> &sz, vector<int> &ranks) {
    a = get_root(a, dsu);
    b = get_root(b, dsu);
    if (ranks[a] > ranks[b]) swap(a, b);
    dsu[a] = dsu[b];
    ranks[b] += ranks[a];
    sz[b] += sz[a];
}


int get_size(int v, vector<int> &dsu, vector<ll> &sz) {
    return sz[get_root(v, dsu)];
}


int main() {
    int n, G;
    cin >> n >> G;
    vector<ll> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    vector<ll> c(n);
    copy(a.begin(), a.end(), c.begin());
    vector<pair<ll, vector<int>>> classes;
    sort(c.begin(), c.end());
    map<ll, int> squeeze;
    int cur = -1;
    ll last = -1;
    for (int i = 0; i < n; i++) {
        if (c[i] != last) {
            cur++;
        }
        squeeze[c[i]] = cur;
        last = c[i];
    }

    classes.reserve(squeeze.size());
    for (auto i: squeeze) {
        classes.emplace_back(i.first, vector<int>());
    }
    for (int i = 0; i < n; i++) {
        classes[squeeze[a[i]]].second.push_back(i);
    }
    n = (int) classes.size();
    vector<ll> szs(n);
    for (ll i: c) {
        szs[squeeze[i]]++;
    }
    vector<pair<ll, int>> difs;
    for (int i = 0; i + 1 < n; i++) {
        difs.emplace_back(abs(classes[i].first - classes[i + 1].first), i);
    }
    sort(difs.begin(), difs.end());

    vector<pair<ll, int>> events;
    for (int i = 0; i + 1 < n; i++) {
        events.push_back(difs[i]);
    }

    bool flag = true;
    vector<query> q(G);
    for (int i = 0; i < G; i++) {
        int t;
        ll k;
        cin >> t >> k;
        q[i].type = t;
        q[i].k = k;
        if (t == 3) {
            flag = false;
            int ind;
            cin >> ind;
            q[i].i = ind - 1;
        }
    }

    vector<long long int> pref(n);

    pref[0] = szs[0];
    for (int i = 1; i < n; i ++) pref[i] = pref[i - 1] + szs[i];


    vector <long long int> finalPref(n);
    ll tmp = 0;
    for (int i = 0; i < n; i ++) {
        tmp += szs[i] * (n - i - 1);
    }
    finalPref[0] = tmp;
    for (int i = 1; i < n; i ++) {
        tmp -= pref[difs[i - 1].second];
        finalPref[i] = finalPref[i - 1] + tmp;
    }

    if (!flag) {
        return 0;
    }
    for (auto ql: q) {
        int left = 0, right = n - 1;
        if (ql.k < difs[0].first) {
            if (ql.type == 1) {
                cout << n << '\n';
            } else {
                cout << n * ql.k << '\n';
            }
            continue;
        }
//        if (ql.type == 2) ql.k ++;
        while (right - left > 1) {
            int mid = (left + right) / 2;
            if (events[mid].first <= ql.k) left = mid;
            else right = mid;
        }
        if (ql.type == 1) {
            cout << n - right << '\n';
        } else {
            cout << finalPref[left] + (ql.k - difs[left].first) * (n - right) << '\n';
        }
    }

}