#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <string>
#include <queue>

typedef int_fast64_t ll;
typedef long double ld;

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define input(a) for (auto& _ : a) cin >> _
#define print(a) for (auto _ : a) cout << _ << " "
#define int int_fast64_t

using namespace std;

int n, m;

void dfs(int v, vector<vector<int>>& g, vector<int>& d, vector<int>& to_add, vector<bool>& used, int i, int k) {
	used[v] = true;
	for (auto u : g[v]) {
		if (u == i) {
			if (k < d[v]) {
				d[v] = k;
				to_add.push_back(v);
			}
		}
		else if (!used[u])
			dfs(u, g, d, to_add, used, i, k);
	}
}

vector<int> bfs(vector<vector<int>>& g) {
	vector<int> d(n + 1, 1e9);
	queue<int> q;
	q.push(1);
	d[1] = 0;
	while (q.size()) {
		int v = q.front();
		q.pop();
		for (auto u : g[v]) {
			vector<bool> used(n + 1, false);
			vector<int> to_add;
			dfs(v, g, d, to_add, used, u, d[v] + 2);
			for (auto i : to_add)
				q.push(i);
		}
	}
	return d;
}

void solve() {
	cin >> n >> m;
	vector<vector<int>> g(n + 1);
	for (int i = 0; i < m; ++i) {
		int u, v;
		cin >> u >> v;
		g[u].push_back(v);
		g[v].push_back(u);
	}
	auto d = bfs(g);
	for (int i = 2; i <= n; ++i)
		cout << (d[i] >= (int)1e9 ? -1 : d[i]) << " ";
	cout << "\n";
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int t;
	cin >> t;
	while (t--)
		solve();
	return 0;
}