#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <string>
#include <queue>

typedef int_fast64_t ll;
typedef long double ld;

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define input(a) for (auto& _ : a) cin >> _
#define print(a) for (auto _ : a) cout << _ << " "
#define int int_fast64_t

using namespace std;

int n, m;

vector<pair<int, int>> bfs(vector<vector<int>>& g) {
	vector<pair<int, int>> d(n + 1, { 1e9, 1e9 });
	d[1].first = 0;
	queue<pair<int, int>> q;
	q.push({ 1, 1 });
	while (q.size()) {
		auto [v, k] = q.front();
		q.pop();
		for (auto u : g[v]) {
			if (k == 1 && d[v].first + 1 < d[u].second) {
				d[u].second = d[v].first + 1;
				q.push({ u, 2 });
			}
			if (k == 2 && d[v].second + 1 < d[u].first) {
				d[u].first = d[v].second + 1;
				q.push({ u, 1 });
			}
		}
	}
	return d;
}

void solve() {
	cin >> n >> m;
	vector<vector<int>> g(n + 1);
	for (int i = 0; i < m; ++i) {
		int u, v;
		cin >> u >> v;
		g[u].push_back(v);
		g[v].push_back(u);
	}
	auto d = bfs(g);
	for (int i = 2; i <= n; ++i)
		cout << (d[i].first >= (int)1e9 ? -1 : d[i].first) << " ";
	cout << "\n";
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int t;
	cin >> t;
	while (t--)
		solve();
	return 0;
}