#include "bits/stdc++.h"

using namespace std;

#define ll long long
#define vi vector<ll>
#define all(x) x.begin(), x.end()
#define pii pair<ll, ll>
#define mp make_pair

const ll INF = 2e9;
const ll MAXN = 3e5 + 10;

struct hard_query {
    ll pos, t, ind;

    hard_query(ll pos, ll t, ll ind): pos(pos), t(t), ind(ind) {}
    hard_query() = default;
};

struct stree {
    ll t[4 * MAXN];

    void upd(ll v, ll tl, ll tr, ll pos, ll x) {
        if (tl + 1 == tr) return void(t[v] = x);
        ll tm = (tl + tr) / 2;
        if (pos < tm) upd(2 * v, tl, tm, pos, x);
        else upd(2 * v + 1, tm, tr, pos, x);
        t[v] = t[2 * v] + t[2 * v + 1];
    }

    ll get_ans(ll v, ll tl, ll tr, ll l, ll r) {
        if (tl >= r || l >= tr) return 0;
        if (l <= tl && tr <= r) return t[v];
        ll tm = (tl + tr) / 2;
        return get_ans(2 * v, tl, tm, l, r) + get_ans(2 * v + 1, tm, tr, l, r);
    }
};

stree t_sum;
stree t_cnt;

void solve() {
    ll n, q; cin >> n >> q;
    vi a(n); for (ll &i : a) cin >> i;
    map<ll, ll> cnt;
    for (ll i = 0; i < n; ++i) {
        if (cnt.find(a[i]) == cnt.end()) cnt[a[i]] = 0;
        cnt[a[i]]++;
    }
    vector<pii> merge_events;
    ll j = 0;
    vi sizes, add(1);
    for (auto it = cnt.begin(); it != cnt.end(); ++it, ++j) {
        auto it_next = ++it; it--;
        if (it_next == cnt.end()) continue;
        merge_events.push_back(mp(it_next->first - it->first, j));
        add[0] += ((ll)cnt.size() - j - 1) * it->second;
        sizes.push_back(it->second);
    }
    sort(all(merge_events));
    for (ll i = 1; i < sizes.size(); ++i) {
        sizes[i] += sizes[i - 1];
    }
    for (ll i = 0; i < merge_events.size(); ++i) {
        add.push_back(add.back() - sizes[merge_events[i].second]);
    }
    vi sum(1);
    for (ll i = 0; i < merge_events.size(); ++i) {
        if (i == 0) sum.push_back(add[i] * merge_events[i].first);
        else sum.push_back(add[i] * (merge_events[i].first - merge_events[i - 1].first));
    }
    for (ll i = 1; i < sum.size(); ++i) sum[i] += sum[i - 1];
    vi ans_q(q);
    vector<hard_query> qs;
    for (ll i = 0; i < q; ++i) {
        ll t; cin >> t;
        if (t == 1) {
            ll k; cin >> k;
            ans_q[i] = cnt.size() - (upper_bound(all(merge_events), mp(k, INF)) - merge_events.begin());
        } else if (t == 2) {
            ll k; cin >> k;
            ll pos = upper_bound(all(merge_events), mp(k, INF)) - merge_events.begin();
            ll ans = sum[pos];
            ll time = k;
            if (pos != 0) time -= merge_events[pos - 1].first;
            ans += time * add[pos];
            ans_q[i] = ans;
        } else {
            ll pos, k; cin >> k >> pos;
            pos--;
            qs.push_back(hard_query(pos, k, i));
        }
    }
//    map<ll, ll> get_pos_cnt;
//    j = 0;
//    for (auto it = cnt.begin(); it != cnt.end(); ++it) {
//        get_pos_cnt[it->first] = j;
//        ++j;
//    }
//    vector<vector<hard_query>> to_ans(cnt.size());
//    for (auto i : qs) to_ans[get_pos_cnt[a[i.pos]]].push_back(i);
//    j = cnt.size();
//    for (auto it = --cnt.end();; --it) {
//        --j;
//        for (auto query : to_ans[j]) {
//            ll pos = upper_bound(all(merge_events), mp(query.t, INF)) - merge_events.begin();
//            ll cnt_q = t_cnt.get_ans(1, 0, merge_events.size(), 0, pos);
//            ll sum_q = t_sum.get_ans(1, 0, merge_events.size(), 0, pos);
//            ll ans = (cnt.size() - j - 1 - cnt_q) * query.t;
//            ans += sum_q;
//            ans_q[query.ind] = ans + a[query.pos];
//        }
//        //
//        if (it == cnt.begin()) break;
//        auto prev_it = --it; ++it;
//        ll time = it->first - prev_it->first;
//        ll pos = lower_bound(all(merge_events), mp(time, j - 1)) - merge_events.begin();
//        t_sum.upd(1, 0, merge_events.size(), pos, time);
//        t_cnt.upd(1, 0, merge_events.size(), pos, 1);
//    }
    for (ll i : ans_q) cout << i << "\n";
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
#endif

    solve();


}
