#include <bits/stdc++.h>

#define all(x) (x).begin(), (x).end()
#define len(x) (int) (x).size()
#define endl "\n"
#define int long long
#define li __int128_t


using namespace std;

mt19937_64 rnd(228);
const int N = 3e5 + 100;
map <int, int> dp;
map <int, int> ansmap;


struct node {
    int add = 0, cnt = 0;
    int modstart = 0, moddelta = 0;
    int startval = 0;
    int y = 0;
    int sz = 1;
    int cntsm = 0;

    node *l = nullptr, *r = nullptr;

    node(int a, int b) : y(rnd()), startval(a), cnt(b), cntsm(b) {};

    node() = default;
};


int sz(node *root) {
    if (root == nullptr) {
        return 0;
    } else {
        return root->sz;
    }
}

int smm(node *root) {
    if (root == nullptr) {
        return 0;
    } else {
        return root->cntsm;
    }
}

void recalc(node *root) {
    if (root == nullptr) {
        return;
    }
    root->sz = sz(root->l) + sz(root->r) + 1;
    root->cntsm = smm(root->l) + smm(root->r) + root->cnt;

}


void push(node *root) {
    if (root == nullptr) {
        return;
    }

    root->add += root->modstart + root->moddelta * sz(root->l);

    if (root->l != nullptr) {
        root->l->modstart += root->modstart;
        root->l->moddelta += root->moddelta;
    }
    if (root->r != nullptr) {
        root->r->modstart += root->modstart + root->moddelta * (sz(root->l) + 1);
        root->r->moddelta += root->moddelta;
    }
    root->modstart = root->moddelta = 0;
}


node *merge(node *a, node *b) {
    push(a), push(b);
    if (a == nullptr) {
        return b;
    }
    if (b == nullptr) {
        return a;
    }
    if (a->y < b->y) {
        a->r = merge(a->r, b);
        recalc(a);
        return a;
    } else {
        b->l = merge(a, b->l);
        recalc(b);
        return b;
    }
}

pair<node *, node *> split(node *a, int k) {
    push(a);
    if (a == nullptr) {
        return {nullptr, nullptr};
    }

    if (k > sz(a)) {
        assert(false);
    }

    if (sz(a->l) >= k) {
        auto[x, y] = split(a->l, k);
        a->l = y;
        recalc(a);
        return {x, a};
    } else {
        auto[x, y] = split(a->r, k - sz(a->l) - 1);
        a->r = x;
        recalc(a);
        return {a, y};
    }
}


int countless(node *root, int val) {
    push(root);
    if (root == nullptr) {
        return 0;
    }
    if (root->startval > val) {
        return countless(root->l, val);
    } else if (root->startval == val) {
        return sz(root->l);
    } else {
        return sz(root->l) + 1 + countless(root->r, val);
    }
}


node *unite(node *a, node *b) {
    push(a), push(b);
    b->cnt += a->cnt;
    return b;
}


int getadd(node* root, int v) {
    push(root);
    if (root -> startval == v) {
        return root -> add;
    } else if (root -> startval > v) {
        return getadd(root -> l, v);
    } else {
        return getadd(root -> r, v);
    }
}


int dsuget(node* root, int v) {
    if (dp[v] == v) {
        return getadd(root, v);
    }

    int x = dsuget(root, dp[v]);
    if (dp[dp[v]] != v) {
        x += ansmap[v];
        ansmap[v] += ansmap[dp[v]];
        dp[v] = dp[dp[v]];
        return x;
    } else {
        return ansmap[v] + x;
    }
}


signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, q;
    cin >> n >> q;

    vector<int> start(n);
    map<int, int> val;
    for (int &i: start) {
        cin >> i;
        val[i]++;
    }

    node *root = nullptr;
    for (auto[i, cnt]: val) {
        root = merge(root, new node(i, cnt));
        dp[i] = i;
    }

    vector<array<int, 4>> event;
    for (int i = 0; i < q; i++) {
        int t;
        cin >> t;
        if (t == 1) {
            int x;
            cin >> x;
            event.push_back({x, 1, -1, i});
        } else if (t == 2) {
            int x;
            cin >> x;
            event.push_back({x, 2, -1, i});
        } else {
            int a, b;
            cin >> a >> b;
            event.push_back({a, 3, b - 1, i});
        }
    }

    auto it = val.begin(), it2 = next(val.begin());
    while (it2 != val.end()) {
        event.push_back({it2->first - it->first, 0, -it->first, -1});
        it++, it2++;
    }

    sort(all(event));

    vector<li> ans(q, -1);
    int last = 0;
    li sm = 0, delta = 0;
    {
        int pref = 0;
        for (auto [a, b] : val) {
            pref++;
            delta += b * (len(val) - pref);
        }
    }

    for (auto[a, t, b, id]: event) {
        root->modstart += (sz(root) - 1) * (a - last);
        root->moddelta += -1 * (a - last);
        sm += (li) (a - last) * delta;
        last = a;

        if (t == 1) {
            ans[id] = sz(root);
        } else if (t == 2) {
            ans[id] = sm;
        } else if (t == 3) {
            ans[id] = dsuget(root, start[b]) + start[b];
        } else {
            b *= -1;
            int val = countless(root, b);
            auto[q, w] = split(root, val);
            auto[e, r] = split(w, 2);
            auto[x, y] = split(e, 1);
            int to = y -> startval;
            dp[b] = to;

            ansmap[b] = x -> add - dsuget(y, to);
            delta -= smm(q) + smm(x);
            root = merge(merge(q, unite(x, y)), r);

        }
    }

    for (auto x: ans) {
        int down = 0;
        int mod = 1;
        for (int _ = 0; _ < 18; _++) {
            down += (x % 10) * mod;
            x /= 10;
            mod *= 10;
        }
        if (x) {
            cout << (int) x << down << endl;
        } else {
            cout << down << endl;
        }
    }
    return 0;
}
