#include <algorithm>
#include <iostream>
#include <vector>
#include <string>

using namespace std;

#define all(a) (a).begin(), (a).end()

typedef long long ll;


class FenwickTree {
	vector < int > t;

public:
	FenwickTree(int sz) {
		t.resize(sz + 1, 0);
	}

	void change(int x, int add) {
		for (int i = x + 1; i < t.size(); i += i & -i)
			t[i] += add;
	}

	int prefix_sum(int x) {
		int res = 0;
		for (int i = x + 1; i > 0; i -= i & -i)
			res += t[i];
		return res;
	}
};


signed main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

	string s;
	ll y;
	cin >> s >> y;
	int n = s.size();

	ll cnt = 0;
	for (ll i = 1; i < y; i *= 10)
		cnt++;
	for (ll i = 1; i < n; i *= 10)
		cnt++;

	vector < pair < int, int > > ord;
	for (int i = 0; i < n; i++)
		ord.push_back({ s[i] - '0', i });
	sort(all(ord), [&](pair < int, int > a, pair < int, int > b) {
		return a.first > b.first || a.first == b.first && a.second > b.second;
	});

	string ans;
	for (int i = 0; i < n - cnt; i++)
		ans += ord[i].first + '0';
	s.clear();

	vector < pair < int, int > > tmp;
	for (int i = max(n - cnt, 0LL); i < n; i++)
		tmp.push_back(ord[i]);
	ord = tmp;
	sort(all(ord), [&](pair < int, int > a, pair < int, int > b) {
		return a.second < b.second;
	});
	s.clear();
	for (pair < int, int > el : ord)
		s.push_back(el.first + '0');
	n = s.size();

	vector < pair < string, ll > > dp((1 << n), { "", 0 });
	for (int m = 1; m < (1 << n); m++) {
		ll deg = 1;
		for (int i = 0; i < n; i++) {
			if (m & (1 << i))
				deg *= 10;
		}
		deg /= 10;

		int cnt = 0;
		for (int i = 0; i < n; i++) {
			if (!(m & (1 << i)))
				continue;

			int nm = m ^ (1 << i);
			string v1 = s[i] + dp[nm].first;
			ll v2 = dp[nm].second + deg * (s[i] - '0') - y * cnt;
			if (dp[m].second < v2 || dp[m].second == v2 && dp[m].first < v1)
				dp[m] = { v1, v2 };
			cnt++;
		}
	}

	cout << ans << dp[(1 << n) - 1].first << "\n";

	return 0;
}