#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <queue>
#include <algorithm>

#define endl '\n'

using namespace std;

const int Base = 5005;

int t;
int n, m;
int usedCl = 1;
int used[Base];
int usedPairCl = 1;
int usedPair[Base][Base];
int dp[Base];
vector<int> e[Base];
queue<int> que;

void dfs(int x, int ban, int dpVal)
{
	used[x] = usedCl;

	for(auto i : e[x])
	{
		if (i != ban && used[i] != usedCl)
		{
			dfs(i, ban, dpVal);
		}
		else if (i == ban && dp[x] == -1)
		{
			dp[x] = dpVal;
			usedPair[x][i] = usedPairCl;
			que.push(x);
		}
	}
}

void check(int x)
{
	for (auto i : e[x])
	{
		if (usedPair[x][i] != usedPairCl)
		{
			usedPair[x][i] = usedPairCl;
			dfs(x, i, dp[x] + 2);
			usedCl++;
		}
	}
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif // _DEBUG

	ios_base::sync_with_stdio(0);
	cin.tie(0);

	cin >> t;
	while (t--)
	{
		cin >> n >> m;

		usedPairCl++;
		for (int i = 0; i < n; i++)
		{
			e[i].clear();
			dp[i] = -1;
		}

		for (int i = 0; i < m; i++)
		{
			int u, v;
			cin >> u >> v;
			u--;
			v--;
			e[u].push_back(v);
			e[v].push_back(u);
		}

		dp[0] = 0;
		que.push(0);
		while (!que.empty())
		{
			int x = que.front();
			que.pop();
			
			check(x);
		}
		for (int i = 1; i < n; i++)
		{
			cout << dp[i] << ' ';
		}
		cout << endl;
	}

	return 0;
}