#include <bits/stdc++.h>

using namespace std;

struct Edge{
    int v,i;
    Edge(int v,int i):v(v),i(i){};

    Edge(){};
};

vector<vector<Edge> > g;
vector<vector<int> > g2;

vector<bool> used,used_edge;
bool dfs(int v,int end){
    if(v==end){
        return true;
    }
    used[v] = true;
    for(auto [to,id]:g[v]){
        if(used[to]||!used_edge[id]) continue;

        if(dfs(to,end)){
            return true;
        }
    }

    return false;
}

int main() {
    ios::ios_base::sync_with_stdio(false);
    cin.tie(0);
#ifdef MY_DEBUG
    freopen("input.txt","r",stdin);
#endif

    int t;
    cin>>t;

    for(int _i=0;_i<t;_i++){
        int n,m;
        cin>>n>>m;
        g.assign(n,vector<Edge> ());

        for(int i=0;i<m;i++){
            int u,v;
            cin>>u>>v;
            u--;v--;

            g[u].push_back(Edge(v,i));
            g[v].push_back(Edge(u,i));
        }

        used.assign(n,false);
        g2.assign(n,vector<int> ());
        used_edge.assign(m,true);
        for(int i=0;i<n;i++){
            vector<int> arr;
            for(auto [to,id]:g[i]){
                used_edge[id] = false;
                arr.push_back(to);
            }

            for(int id1 = 0;id1<arr.size();id1++){
                for(int id2 =id1+1;id2<arr.size();id2++){
                    int v1 = arr[id1],v2 = arr[id2];
                    used.assign(n,false);

                    if(dfs(v1,v2)){
                        g2[v1].push_back(v2);
                        g2[v2].push_back(v1);
                    }
                }
            }

            for(auto [to,id]:g[i]){
                used_edge[id] = true;
            }
        }

        int INF = 1e9+100;
        vector<int> dist(n,INF);
        dist[0] = 0;
        used.assign(n,false);
        for(int i=0;i<n;i++){
            int v = -1;

            for(int j=0;j<n;j++){
                if(!used[j]&&(v==-1||dist[j]<dist[v])){
                    v = j;
                }
            }

            used[v] = true;

            for(auto to:g2[v]){
                if(!used[to]&&dist[to]>dist[v]+1){
                    dist[to] = dist[v]+1;
                }
            }
        }

        for(int i=1;i<n;i++){
            if(dist[i]<INF){
                cout<<2*dist[i]<<" ";
            }else{
                cout<<-1<<" ";
            }
        }
        cout<<endl;
    }

}
