#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
#define int ll
const int INF = 1e18;


int n, m;
vector<vector<int>> ig;

vector<vector<int>> g;
vector<vector<int>> cost;

int encode(int v, int x) {
	return x * n + v;
}

pair<int, int> decode(int val) {
	int v = val % n;
	return {v, val / n};
}

void edge(int x, int y, int c) {
	g[x].push_back(y);
	cost[x].push_back(c);

	g[y].push_back(x);
	cost[y].push_back(c);
}

void solve() {
	cin >> n >> m;

	ig = vector<vector<int>>(n, vector<int>(0));
	g = vector<vector<int>>(n * n + n, vector<int>(0));
	cost = vector<vector<int>>(n * n + n, vector<int>(0));

	int u, v;
	for ( int i = 0; i < m; ++i ) {
		cin >> u >> v;
		u--; v--;

		edge(encode(u, n), encode(u, v), 1);
		edge(encode(v, n), encode(v, u), 1);

		for ( int x = 0; x < n; ++x ) {
			if ( (x == u) || (x == v) ) continue;

			edge(encode(u, x), encode(v, x), 0);
		}
	}

	vector<int> dist(n * n + n, INF);
	dist[encode(0, n)] = 0;

	priority_queue<pair<int, int>> qu;
	qu.push({0, encode(0, n)});

	while ( !qu.empty() ) {
		pair<int, int> el = qu.top();
		qu.pop();

		if ( el.first > dist[el.second] ) continue;

		for ( int i = 0; i < g[el.second].size(); ++i ) {
			if ( el.first + cost[el.second][i] < dist[g[el.second][i]] ) {
				dist[g[el.second][i]] = el.first + cost[el.second][i];
				qu.push({dist[g[el.second][i]], g[el.second][i]});
			}
		}
	}

	vector<int> ans(n - 1);
	for ( int i = 1; i < n; ++i ) ans[i - 1] = dist[encode(i, n)];
	for ( int i = 1; i < n; ++i ) if ( ans[i - 1] == INF ) ans[i - 1] = -1;

	for ( int i = 1; i < n; ++i ) cout << ans[i - 1] << " ";
	cout << endl;
}

signed main() {
	int t;
	cin >> t;

	for ( int i = 0; i < t; ++i ) {
		solve();
	}
	return 0;
}