// ConsoleApplication1.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <unordered_map>
#include <algorithm>
#include <queue>

#define int long long
using namespace std;

using vi = vector<int>;
using vvi = vector<vector<int>>;
using pi = pair<int, int>;
using vb = vector<bool>;

#define mp make_pair
#define rep(n) for (int i = 0; i < n; i++)
#define all(x) x.begin(), x.end()

const int INF = 1e18 + 2;

vvi graph;
vvi dist;
vector<vb> edge;
int n, m;

void bfs() {
	deque<pi> q;
	q.push_back(mp(1, 1));
	dist[1][1] = 0;
	while (!q.empty()) {
		pi vv = q.front();
		q.pop_front();
		int v1 = vv.first;
		int v2 = vv.second;
		if (edge[v1][v2]) {
			if (dist[v1][v1] == INF) {
				q.push_back(mp(v1, v1));
				dist[v1][v1] = dist[v1][v2] + 1;
			}
		}
		for (auto& to : graph[v1]) {
			if (v1 == v2) {
				if (dist[v1][to] == INF) {
					dist[v1][to] = dist[v1][v2] + 1;
					q.push_back(mp(v1, to));
				}
			}
			else {
				if (dist[to][v2] == INF && to != v2) {
					q.push_front(mp(to, v2));
					dist[to][v2] = dist[v1][v2];
				}
			}
		}
	}
}

void solve() {
	cin >> n >> m;
	edge.assign(n + 1, vb(n + 1, false));
	dist.assign(n + 1, vi(n + 1, INF));
	graph.resize(n + 1);
	rep(m) {
		int a, b; cin >> a >> b;
		edge[a][b] = edge[b][a] = true;
		graph[a].push_back(b);
		graph[b].push_back(a);
	}
	bfs();
	for (int i = 2; i <= n; i++) {
		if (dist[i][i] == INF) cout << "-1 ";
		else cout << dist[i][i] << " ";
	}
	cout << "\n";
	edge.clear();
	dist.clear();
	graph.clear();
}

signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	int t; cin >> t;
	while (t--) solve();
}
