#include <iostream>
#include <vector>
#include <algorithm>
#include <random>
#include <set>
#include <queue>

using namespace std;

#define int int32_t
#define uint uint32_t

#define ll int64_t
#define ull uint64_t

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

#define en '\n'
#define mt

void io() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

vector<vector<int>> gRes;
vector<vector<int>> g;
vector<char> used;
vector<char> u2;

void dfs2(int v) {
    u2[v] = true;
    for (auto &u : g[v]) {
        if (!u2[u]) dfs2(u);
    }
}

void dfs(int v) {
    used[v] = true;
    for (auto &u : g[v]) {
        fill(all(u2), false);
        u2[u] = true;
        dfs2(v);
        for (auto &k : g[u]) {
            if (u2[k]) {
                gRes[v].push_back(k);
                gRes[k].push_back(v);
            }
        }
        if (!used[u]) dfs(u);
    }
}

void solve() {
    int n, m;
    cin >> n >> m;

    g.clear(), g.resize(n);
    gRes.clear(), gRes.resize(n);
    used.clear(), used.resize(n, false);
    u2.clear(), u2.resize(n, false);

    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        --a, --b;
        g[a].push_back(b);
        g[b].push_back(a);
    }

    dfs(0);

    queue<int> q;
    q.push(0);
    vector<int> d(n, -1);
    while (!q.empty()) {
        auto v = q.front();
        q.pop();
        for (auto &u : gRes[v]) {
            if (d[u] == -1) {
                d[u] = d[v] + 1;
                q.push(u);
            }
        }
    }
    for (int i = 1; i < n; ++i) cout << (d[i] == -1 ? -1 : d[i] * 2) << ' ';
    cout << en;
}

int32_t main() {
    io();
#ifdef mt
    int ttt;
    cin >> ttt;
    while (ttt-- > 0) solve();
#else
    solve();
#endif
    return 0;
}