#include <bits/stdc++.h>

#define ssize(a) (int)(a).size()
#define all(a) (a).begin(), (a).end()

using namespace std;

using ll = long long;


const int inf = 1e9 + 100;


struct Edge {
    int to;
    int cap;
    int flow;
};


int s, t;

vector<Edge> edges;
vector<vector<int>> g;
vector<bool> used;

void add_edge(int a, int b, int c) {
    g[a].push_back(ssize(edges));
    edges.push_back({b, c, 0});
    g[b].push_back(ssize(edges));
    edges.push_back({a, 0, 0});
}

int dfs(int v, int  cmin) {
    if (cmin == 0) {
        return 0;
    }

    used[v] = true;
    if (v == t) {
        return cmin;
    }

    for (int e_id : g[v]) {
        auto& e = edges[e_id];
        if (used[e.to])
            continue;
        int found = dfs(e.to, min(cmin, e.cap - e.flow));
        if (found) {
            e.flow += found;
            edges[e_id ^ 1].flow -= found;
            return found;
        }
    }
    return 0;
}

void count(vector<ll> a, vector<int> l, vector<int> r, vector<ll> c, vector<int> type, int x) {
    int n = ssize(a);
    int m = ssize(l);
    for (int i = 0; i < m; ++i) {
        if (type[i] == 1) {
            l[i] = min(l[i], x);
            r[i] = max(r[i], x);
        }
    }
    edges.clear();

    for (int i = 0; i < ssize(g); ++i) {
        g[i].clear();
    }

    s = n + m;
    t = n + m + 1;

    for (int i = 0; i < m; ++i) {
        add_edge(s, i, c[i]);
    }
    for (int i = 0; i < n; ++i) {
        add_edge(m + i, t, a[i]);
    }

    for (int i = 0; i < m; ++i) {
        for (int j = l[i]; j <= r[i]; ++j) {
            add_edge(i, m + j, inf);
        }
    }

    fill(all(used), false);
    int found = dfs(s, inf);
    ll max_flow = 0;
    while (found > 0) {
        max_flow += found;
        fill(all(used), false);
        found = dfs(s, inf);
    }

    cout << max_flow << " ";
}


void solve() {
    int n, m;
    cin >> n >> m;
    vector<ll> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    vector<int> l(m);
    vector<int> r(m);
    vector<ll> c(m);
    vector<int> type(m);
    for (int i = 0; i < m; ++i) {
        cin >> l[i] >> r[i] >> c[i] >> type[i];
        --l[i], --r[i];
    }

    g.resize(n + m + 2);
    used.resize(n + m + 2, false);

    for (int x = 0; x < n; ++x) {
        count(a, l, r, c, type, x);
    }
    cout << "\n";
}


int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int tests;
    cin >> tests;
    while (tests--) {
        solve();
    }


    return 0;
}
