#include <bits/stdc++.h>

#define int long long

using namespace std;

const int maxn = 3e5 + 228;
int link[maxn];
int sizex[maxn];

struct tree {
    vector<int> t, cnt;

    tree(){
        t.resize(maxn * 4);
        cnt.resize(maxn * 4);
    }

    void push(int v, int l, int r) {
        if (cnt[v]) {
            t[v] += cnt[v] * (r - l + 1);
            if (l != r) {
                cnt[v * 2] += cnt[v];
                cnt[v * 2 + 1] += cnt[v];
            }
            cnt[v] = 0;
        }
    }

    void add(int v, int l, int r, int ql, int qr, int x) {
        push(v, l, r);
        if (ql <= l && r <= qr) {
            cnt[v] += x;
            push(v, l, r);
        } else if (l > qr || ql > r) {
            return;
        } else {
            int mid = (l + r) / 2;
            add(v * 2, l, mid, ql, qr, x);
            add(v * 2 + 1, mid + 1, r, ql, qr, x);
            t[v] = t[v * 2] + t[v * 2 + 1];
        }
    }

    int get(int v, int l, int r, int ql, int qr) {
        push(v, l, r);
        if (ql <= l && r <= qr) {
            return t[v];
        } else if (l > qr || ql > r) {
            return 0;
        } else {
            int mid = (l + r) / 2;
            return get(v * 2, l, mid, ql, qr) + get(v * 2 + 1, mid + 1, r, ql, qr);
        }
    }
};

int find(int a) {
    if (link[a] == a)
        return a;
    return link[a] = find(link[a]);
}

void unite(int a, int b) {
    a = find(a);
    b = find(b);
    if (a == b)
        return;
    if (sizex[a] > sizex[b])
        swap(a, b);
    link[a] = b;
    sizex[b] += sizex[a];
}

void solve() {
    for (int i = 0; i < maxn; i++) {
        link[i] = i;
        sizex[i] = 1;
    }
    int n, q;
    cin >> n >> q;
    vector<int> a(n);
    vector<int> kek;
    set<int> abc;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        kek.push_back(a[i]);
    }
    sort(kek.begin(), kek.end());
    int cntt = 0;
    map<int, int> lol2;
    lol2[kek.back()] = n - 1;
    map<int, int> lol3;
    tree t;
    for (int i = n - 1; i >= 0; i--) {
        if (i + 1 < n && kek[i] != kek[i + 1]) {
            cntt++;
            lol2[kek[i]] = i;
            lol3[kek[i]] = cntt + 1;
        }
        t.add(1, 0, maxn, i, i, cntt);
    }
    kek.resize(unique(kek.begin(), kek.end()) - kek.begin());
    vector<pair<int, pair<int, int>>> times;
    for (int i = 0; i + 1 < kek.size(); i++) {
        times.emplace_back(kek[i + 1] - kek[i], make_pair(kek[i], kek[i + 1]));
    }
    sort(times.begin(), times.end());
    reverse(times.begin(), times.end());
    map<int, int> lol;
    int cnt = kek.size();
    for (int i = n - 1; i >= 0; i--) {
        if (lol.count(a[i])) {
            unite(i, lol[a[i]]);
        } else {
            lol[a[i]] = i;
        }
    }
    vector<pair<int, pair<int, int>>> posts(q);
    for (int i = 0; i < q; i++) {
        int t;
        cin >> t;
        if (t == 1) {
            int k;
            cin >> k;
            posts[i] = make_pair(k, make_pair(-1, i));
        } else if (t == 2) {
            int k;
            cin >> k;
            posts[i] = make_pair(k, make_pair(-2, i));
        } else {
            int k, j;
            cin >> k >> j;
            j--;
            posts[i] = make_pair(k, make_pair(j, i));
        }
    }
    sort(posts.begin(), posts.end());
    vector<int> ans(q);
    int add = 0;
    int lst = 0;
    tree tb, tk;
    for (auto i: posts) {
        while (times.size() && times.back().first <= i.first) {
//            cout << times.back()  .first << " " << times.back().second.first << " " << times.back().second.second << endl;
            if (true) {
//                cout << "ABOBA " << lol[times.back().second.first] << " " << lol[times.back().second.second] << endl;
                add += t.get(1, 0, maxn, 0, n-1) * (times.back().first - lst);
                lst = times.back().first;
                cnt--;
                t.add(1, 0, maxn, 0, lol2[times.back().second.first], -1);
//                tb.add(1, 0, maxn, lol2[times.back().second.second], lol2[times.back().second.second], times.back().first);
//                tk.add(1, 0, maxn, lol2[times.back().second.second], lol2[times.back().second.second], 1);
            }
            unite(lol[times.back().second.first], lol[times.back().second.second]);
            times.pop_back();
        }
        if (i.second.first == -1) {
            ans[i.second.second] = cnt;
        } else if (i.second.first == -2) {
            ans[i.second.second] = add + t.get(1, 0, maxn, 0, n - 1) * (i.first - lst);
        } else {
            ans[i.second.second] = a[i.second.first] + (lol3[a[i.second.first]] - 1) * i.first - tk.get(1, 0, maxn, lol2[a[i.second.first]], maxn) * i.first + tb.get(1, 0, maxn, lol2[a[i.second.first]], maxn);
        }
    }
    for (int i: ans)
        cout << i << endl;
}

/*
6 6
5 4 4 2 2 2
1 0
1 1
1 2
2 1
2 2
3 1 5
=====
5 4
0 3 5 4 2
1 0
1 1
2 1
3 1 1

 */

signed main() {
    int q;
//    cin >> q;
    q = 1;
    while (q-- > 0) {
        solve();
    }
    return 0;
}