#pragma GCC target("avx2")
#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast")

#include <bits/stdc++.h>

//#define int long long

using namespace std;

const int maxn = 5e3 + 1;

vector<int> g[maxn];
bool used[maxn];
int color[maxn][maxn];
int cnt = 0;
int can[maxn][maxn];
int cur = 0;

void dfs(int v) {
    used[v] = true;
    color[v][cnt] = cur;
    for (int i: g[v]) {
        if (!used[i])
            dfs(i);
    }
}


void solve() {
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; i++)
        g[i].clear();
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        a--, b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    int cnt = 0;
    for (int i = 0; i < n; i++)
        used[i] = false;
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            dfs(i);
            cnt++;
        }
    }
    vector<int> bad(n);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++)
            used[j] = false;
        used[i] = true;
        int my_cnt = 0;
        ::cnt = i;
        for (int j = 0; j < n; j++) {
            if (!used[j]) {
                dfs(j);
                cur++;
                my_cnt++;
            }
        }
        if (my_cnt > cnt) {
            bad[i] = 1;
        }
    }
    for (int i = 0; i < n; i++)
        for (int j = 0; j < n; j++)
            can[i][j] = 0;
    for (int i = 0; i < n; i++) {
        for (int j: g[i]) {
            for (int l: g[j]) {
                if (!bad[j] || color[i][j] == color[l][j]) {
                    can[i][l] = can[l][i] = 1;
                }
            }
        }
    }
    queue<int> q;
    vector<int> dist(n, -1);
    dist[0] = 0;
    q.push(0);
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (int j = 0; j < n; j++) {
            if (can[v][j]) {
                if (dist[j] == -1 || dist[j] > dist[v] + 1) {
                    dist[j] = dist[v] + 1;
                    q.push(j);
                }
            }
        }
    }
    for (int i = 1; i < n; i++) {
        if (dist[i] == -1) {
            cout << -1 << " ";
        } else {
            cout << dist[i] * 2 << " ";
        }
    }
    cout << endl;

}

/*
4
4 4
1 2
2 3
3 4
4 1
5 5
1 2
2 3
3 4
4 5
5 1
5 6
1 2
3 2
1 3
3 5
5 4
3 4
9 12
1 2
2 3
3 1
4 5
5 6
6 4
7 8
8 9
9 7
3 6
6 9
9 3
 */

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int q;
    cin >> q;
    while (q-- > 0) {
        solve();
    }
    return 0;
}
