#include <bits/stdc++.h>
using namespace std;
#define int int64_t

const int MAXN = 3e5;
array<int, 2> arr[MAXN];
int ind[MAXN], d[MAXN];

array<int, 4> tree[MAXN * 4];

array<int, 4> operator+(array<int, 4> a, array<int, 4> b) {
    for (int i = 0; i < 4; ++i) {
        a[i] += b[i];
    }
    return a;
}

void pull(int v) {
    tree[v] = tree[v * 2] + tree[v * 2 + 1];
}

void build(int v, int vl, int vr) {
    if (vr - vl == 1) {
        tree[v] = {d[vl] * vl, vl, d[vl], 1};
        return;
    }
    int vm = (vl + vr) / 2;
    build(v * 2, vl, vm);
    build(v * 2 + 1, vm, vr);
    pull(v);
}

void update(int v, int vl, int vr, int ind) {
    if (ind >= vr || ind < vl) return;
    if (vr - vl == 1) {
        tree[v] = {0, 0, 0, 0};
        return;
    }
    int vm = (vl + vr) / 2;
    update(v * 2, vl, vm, ind);
    update(v * 2 + 1, vm, vr, ind);
    pull(v);
}

array<int, 4> get(int v, int vl, int vr, int l, int r) {
    if (l >= vr || r <= vl) return {0, 0, 0, 0};
    if (l <= vl && r >= vr) return tree[v];
    int vm = (vl + vr) / 2;
    auto res1 = get(v * 2, vl, vm, l, r);
    auto res2 = get(v * 2 + 1, vm, vr, l, r);
    return res1 + res2;
}

int ans[MAXN];

main() {
    int n, q;
    cin >> n >> q;
    int sum = 0;
    for (int i = 0; i < n; ++i) {
        cin >> arr[i][0];
        sum += arr[i][0];
        arr[i][1] = i;
    }
    sort(arr, arr + n);
    vector<array<int, 3>> ev;
    for (int i = 0; i < n; ++i) {
        ind[arr[i][1]] = i;
        if (i) {
            d[i] = arr[i][0] - arr[i - 1][0];
            ev.push_back({d[i], -3, i});
        }
    }
    for (int i = 0; i < q; ++i) {
        int t, k;
        cin >> t >> k;
        if (t == 3) {
            int id;
            cin >> id;
            id--;
            ev.push_back({k, ind[id], i});
        } else {
            ev.push_back({k, -t, i});
        }
    }
    sort(ev.begin(), ev.end());
    build(1, 0, n);
    update(1, 0, n, 0);
    for (auto elem : ev) {
        if (elem[1] == -3) {
            update(1, 0, n, elem[2]);
        } else if (elem[1] == -2) {
            auto res = get(1, 0, n, 0, n);
            int sum1 = n * arr[n - 1][0] - res[0] + elem[0] * res[1];
            ans[elem[2]] = sum1 - sum;
        } else if (elem[1] == -1) {
            auto res = get(1, 0, n, 0, n);
            ans[elem[2]] = res[3] + 1;
        } else {
            auto res = get(1, 0, n, elem[1] + 1, n);
            ans[elem[2]] = arr[n - 1][0] - res[2] + res[3] * elem[0];
        }
    }
    for (int i = 0; i < q; ++i) {
        cout << ans[i] << endl;
    }
    return 0;
}
