#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <map>
#include <queue>
#include <bitset>
#include <ctime>
#include <chrono>

using namespace std;

#define fastInp cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);
typedef long long ll;
typedef long double ld;

#define int ll

const ll SZ = 5010, INF = 1e9 * 1e9 + 100, MX = 1'000'000'000'000 + 1000;
ll n, m;
vector<vector<ll>> gr, nw;

ll dist[SZ], used[SZ];
bitset<SZ> adj[SZ], hlp;
ll col[SZ], cols[SZ];
vector<ll> vis;
vector<ll> sv[SZ];

ll color(int v, int cl = -1) {
	if (cl != -1) col[v] = cl;
	used[v] = 1;
	ll cnt = 1;
	
	for (auto to : gr[v]) {
		if (!used[to]) {
			if (cl == -1) {
				color(to, cnt);
				cnt++;
			}
			else {
				color(to, cl);
			}
		}
	}

	return cnt;
}

ll lft = 0;

void sol() {
	ll n, m;
	cin >> n >> m;

	srand(432423);
	for (int i = 0; i < n; i++) adj[i] = 0;

	auto st = clock();
	gr.clear();
	gr.resize(n);
	nw.clear();
	nw.resize(n);

	for (int i = 0; i < m; i++) {
		ll u, v;
		cin >> u >> v;
		u--; v--;
		gr[u].push_back(v);
		gr[v].push_back(u);
	}

	for (int i = 0; i < n; i++) {
		dist[i] = INF;
	}

	dist[0] = 0;

	vector<ll> perm;
	for (int i = 0; i < n; i++) perm.push_back(i);
	random_shuffle(perm.begin(), perm.end());

	ld goodT = (ld(2)) / ld(lft) * ld(n) - 0.004;
	if (n <= 100) goodT = 2;
	lft -= n;

	for (auto i : perm) {
		for (int j = 0; j < n; j++) used[j] = 0;
		ll tt = color(i);

		for (int j = 1; j < tt; j++) {
			sv[j].clear();
		}

		for (auto to : gr[i]) sv[col[to]].push_back(to);

		for (int j = 1; j < tt; j++) {
			if (sv[j].size() == 1) continue;
			hlp = 0;
			for (auto c : sv[j]) hlp[c] = 1;
			for (auto c : sv[j]) adj[c] |= hlp;
		}

		if ((clock() - st) / CLOCKS_PER_SEC >= goodT) break;
	}
	queue<ll> q;
	q.push(0);

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			if (adj[i][j]) nw[i].push_back(j);
		}
	}

	while (!q.empty()) {
		ll v = q.front();
		q.pop();

		for (auto to : nw[v]) {
			if (dist[to] > dist[v] + 1) {
				dist[to] = dist[v] + 1;
				q.push(to);
			}
		}
	}

	for (int i = 1; i < n; i++) {
		if (dist[i] >= INF) {
			cout << "-1 ";
		}
		else {
			cout << dist[i] * 2 << " ";
		}
	}
}

signed main() {
	fastInp;

	ll t;
	cin >> t;

	lft = 5000;
	while (t--) {
		sol();
	}

	return 0;
}

/*
4

4 4
1 2
2 3
3 4
4 1

5 5
1 2
2 3
3 4
4 5
5 1

5 6
1 2
3 2
1 3
3 5
5 4
3 4

9 12
1 2
2 3
3 1
4 5
5 6
6 4
7 8
8 9
9 7
3 6
6 9
9 3




1
12 15
1 2
1 12
2 3
4 1
2 4
4 3
5 3
5 1
5 6
3 7
7 8
4 9
9 10
10 11
11 9
*/