#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <map>
#include <queue>

using namespace std;

#define fastInp cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);
typedef long long ll;
typedef long double ld;

#define int ll

const ll SZ = 3e5 + 100, INF = 1e9 * 1e9 + 100, MX = 1'000'000'000'000 + 1000;
ll n, m;
vector<vector<ll>> gr;

ll dist[SZ][2];

void sol() {
	ll n, m;
	cin >> n >> m;

	gr.clear();
	gr.resize(n);

	for (int i = 0; i < m; i++) {
		ll u, v;
		cin >> u >> v;
		u--; v--;
		gr[u].push_back(v);
		gr[v].push_back(u);
	}

	for (int i = 0; i < n; i++) {
		dist[i][0] = INF;
		dist[i][1] = INF;
	}

	dist[0][0] = 0;
	queue<pair<ll, ll>> q;
	q.push({ 0, 0 });

	while (!q.empty()) {
		pair<ll, ll> v = q.front();
		q.pop();

		for (auto to : gr[v.first]) {
			if (dist[to][!v.second] >= INF) {
				dist[to][!v.second] = dist[v.first][v.second] + 1;
				q.push({ to, !v.second });
			}
		}
	}

	for (int i = 1; i < n; i++) {
		if (dist[i][0] >= INF) {
			cout << "-1 ";
		}
		else {
			cout << dist[i][0] << " ";
		}
	}
}

signed main() {
	fastInp;

	ll t;
	cin >> t;

	while (t--) {
		sol();
	}

	return 0;
}

/*
4

4 4
1 2
2 3
3 4
4 1

5 5
1 2
2 3
3 4
4 5
5 1

5 6
1 2
3 2
1 3
3 5
5 4
3 4


*/