#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <queue>
#include <algorithm>
#define int long long
using namespace std;

const int inf = 1e13;

vector <vector <int>> g;
vector <int> tin, fup;
vector <char> bad;
int timer = 0;

void dfs(int u, int p) {
	fup[u] = tin[u] = timer++;
	int sons = 0;
	for (auto v : g[u]) {
		if (v == p)
			continue;
		if (tin[v] == -1) {
			dfs(v, u); sons++;
			if (fup[v] >= tin[u])
				bad[u] = true;
			fup[u] = min(fup[u], fup[v]);
		}
		else {
			fup[u] = min(fup[u], tin[v]);
		}
	}

	if (p == -1) {
		bad[u] = false;
		if (sons >= 2)
			bad[u] = true;
	}
}

void solve() {
	int n, m; cin >> n >> m;
	g.assign(n, {});
	tin.assign(n, -1); fup.assign(n, -1);
	timer = 0;
	for (int i = 0; i < m; i++) {
		int u, v; cin >> u >> v; u--, v--;
		g[u].push_back(v);
		g[v].push_back(u);
	}

	bad.assign(n, false);
	dfs(0, -1);

	vector <int> dp(3 * n, -1); dp[0 + 2] = 0;
	queue <int> q; q.push(0 + 2);
	while (!q.empty()) {
		int s = q.front(); q.pop();
		int u = s / 3;
		int var = s % 3;
		if (var == 0) {
			for (auto v : g[u]) {
				if (bad[u] && fup[v] <= tin[u])
					continue;
				int vv = v * 3 + 2;
				if (dp[vv] == -1) {
					dp[vv] = dp[s] + 1;
					q.push(vv);
				}
			}
		}
		else if (var == 1) {
			for (auto v : g[u]) {
				if (bad[u] && tin[v] < tin[u])
					continue;
				int vv = v * 3 + 2;
				if (dp[vv] == -1) {
					dp[vv] = dp[s] + 1;
					q.push(vv);
				}
			}
		}
		else {
			for (auto v : g[u]) {
				if (bad[v]) {
					if (fup[u] >= tin[v]) {
						int vv = v * 3 + 1;
						if (dp[vv] == -1) {
							dp[vv] = dp[s] + 1;
							q.push(vv);
						}
					}
					else {
						int vv = v * 3 + 0;
						if (dp[vv] == -1) {
							dp[vv] = dp[s] + 1;
							q.push(vv);
						}
					}
				}
				else {
					int vv = v * 3 + 0;
					if (dp[vv] == -1) {
						dp[vv] = dp[s] + 1;
						q.push(vv);
					}
					vv = v * 3 + 1;
					if (dp[vv] == -1) {
						dp[vv] = dp[s] + 1;
						q.push(vv);
					}
				}
			}
		}
	}

	for (int i = 1; i < n; i++) {
		int t = dp[i * 3 + 2];
		cout << t << ' ';
	}
	cout << '\n';
}


signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);

	int tt = 1;
	cin >> tt;
	while (tt--) {
		solve();
	}

	return 0;
}
