#include <bits/stdc++.h>
using namespace std;

#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;

//#define int long long

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

template<typename T> using ordered_set = tree<T, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

#define ff first
#define ss second
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define print(x) {for(auto &__val: x) cout << __val << ' '; cout << '\n';}

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
mt19937_64 rngl(chrono::steady_clock::now().time_since_epoch().count());
int random(int l, int r) { return uniform_int_distribution<int>(l, r)(rng);}
ll randoml(ll l, ll r) { return uniform_int_distribution<ll>(l, r)(rngl);}

ll st[19] = {};


int cost(const string &x, const string &y) {
    vector<vector<int>> ind(10);
    ordered_set<pii> q;
    int n = (int)y.size();
    for(int i=n-1;i>=0;i--) {
        q.insert({i, y[i] - '0'});
        ind[y[i] - '0'].pb(i);
    }
    int cst = 0;
    for(auto &i: x) {
        int tmp = i - '0';
        int pos = ind[tmp].back();
        int cnt = (int)q.order_of_key({pos, tmp});
        cst += cnt;
        q.erase({pos, tmp});
        ind[tmp].pop_back();
    }
    return cst;
}

ll cost(const string &x) {
    ll res = 0;
    int n = (int)x.size();
    for(int i=0;i<n;i++) res += st[n-i-1] * (x[i] - '0');
    return res;
}

string stupid(string s, ll y) {
    string ans = s;
    ll cst = cost(s);
    string cps = s;
    sort(all(cps));
    do{
        ll tmp = cost(cps) - y * cost(cps, s);
        if(tmp > cst || (tmp == cst && cps > ans)) {
            cst = tmp;
            ans = cps;
        }
    }while(next_permutation(all(cps)));
    return ans;
}

string stupid2(string s, ll y) {
    int n = (int)s.size();
    string ans = s;
    ll cst = cost(s);
    for(int i=0;i<(1 << n);i++) {
        string cps;
        vector<int> a(10);
        for(int j=0;j<n;j++) {
            if(i&(1 << j)) a[s[j] - '0']++;
        }
        for(int j=9;j>=0;j--) while(a[j]--) cps += char('0' + j);
        for(int j=0;j<n;j++) {
            if((i&(1 << j)) == 0) cps += s[j];
        }
        ll tmp = cost(cps) - y * cost(cps, s);
        if(tmp > cst || (tmp == cst && cps > ans)) {
            cst = tmp;
            ans = cps;
        }
    }
    return ans;
}

string stupid3(string s, ll y) {
    int n = (int)s.size();
    if(s.size() <= 10) return stupid2(s, y);
    else {
        string tmp;
        while(tmp.size() != 10) tmp += s.back(), s.pop_back();
        reverse(all(tmp));
        sort(rall(s));
        return s + stupid2(tmp, y);
    }
}

string clever(string s, ll y) {
    ordered_set<pii> q;
    vector<vector<int>> ind(10);
    int n = (int)s.size();
    for(int i=0;i<n;i++) {
        q.insert({i, s[i] - '0'});
        ind[s[i] - '0'].pb(i);
    }
    string ans;
    for(int j=9;j>=0;j--) {
        for(auto &i: ind[j]) {
            int cnt = (int)q.order_of_key({i, j});
            if(cnt > 17 || n - 1 - (int)ans.size() > 17) {
                ans += char('0' + j);
                q.erase({i, j});
                continue;
            }
            ll sum = 0;
            int tmp = n - (int)ans.size() - 1;
            for(auto &v: q) {
                if(v == pii{i, j}) break;
                sum += st[tmp] * v.ss;
                tmp--;
            }
            if(j * (st[n - 1 - (int)ans.size()] - st[n - 1 - (int)ans.size() - cnt]) + sum / 10 - sum >= cnt * y) {
                ans += char('0' + j);
                q.erase({i, j});
            } else {
                break;
            }
        }
    }
    for(auto &i: q) ans += char('0' + i.ss);
    return ans;
}

pair<string, ll> gen(int n) {
    string s(n, '0');
    for(int i=0;i<n;i++) s[i] += random(0, 9);
    return {s, randoml(0, 100)};
}

/*
278838094
86900492
wrong: 927883804
correct: 827838094

2989
100
wrong: 9928
correct: 9829
*/
void ready() {
    string s;
    cin >> s;
    ll y;
    cin >> y;
    string q = s;
    sort(all(q));
    //cout << cost(q, s) << '\n';
    cout << stupid3(s, y) << '\n';
    exit(0);
}

void solve() {
    st[0] = 1;
    for(int i=1;i<19;i++) st[i] = st[i-1] * 10ll;
    ready();
    auto[s, y] = gen(random(1, 12));
    auto res_stupid = stupid2(s, y);
    auto res_clever = clever(s, y);
    if(res_clever != res_stupid) {
        cout << s << '\n';
        cout << y << '\n';
        cout << "wrong: " << res_clever << '\n';
        cout << "correct: " << res_stupid << '\n';
        exit(0);
    }
}
signed main() {
    //ios_base::sync_with_stdio(false); cin.tie(nullptr);
    int t = 10000;
    //cin >> t;
    while(t--) {
        solve();
    }
}