#include <bits/stdc++.h>
using namespace std;

#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;

typedef long long ll;
typedef pair<int, int> pii;

template<typename T> using ordered_set = tree<T, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

#define ff first
#define ss second
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define print(x) {for(auto &__val: x) cout << __val << ' '; cout << '\n';}

vector<int> rang, parent, nxt;

int reset(int n) {
    for(int i=0;i<n;i++) {
        rang[i] = 1;
        parent[i] = i;
        nxt[i] = i;
    }
}
int find_set(int v) {
    if(parent[v] == v) return v;
    return parent[v] = find_set(parent[v]);
}
void union_sets(int a, int b) {
    a = find_set(a);
    b = find_set(b);
    if(a != b) {
        if(rang[a] < rang[b]) swap(a, b);
        rang[a] += rang[b];
        parent[b] = a;
        nxt[a] = max(nxt[a], nxt[b]);
    }
}
int get(int x) {
    return nxt[find_set(x)];
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> a(n);
    for(auto &i: a) cin >> i;
    vector<int> l(m), r(m), c(m), t(m);
    for(int i=0;i<m;i++) cin >> l[i] >> r[i] >> c[i] >> t[i], l[i]--, r[i]--;
    vector<int> now(n);
    rang.resize(n+1);
    parent.resize(n+1);
    nxt.resize(n+1);
    for(int x=0;x<n;x++) {
        now.assign(n, 0);
        rang.assign(n, 0);
        iota(all(parent), 0);
        iota(all(nxt), 0);
        vector<array<int, 3>> b(m);
        for(int j=0;j<m;j++) {
            if(t[j]) {
                b[j] = {min(x, l[j]), max(x, r[j]), c[j]};
            } else {
                b[j] = {l[j], r[j], c[j]};
            }
        }
        sort(all(b), [&](const array<int, 3> &a, const array<int, 3> &b){
            if(a[1] == b[1]) return a[0] < b[0];
            return a[1] < b[1];
        });
        for(auto &[tl, tr, tc]: b) {
            int pos = get(tl);
            while(pos <= tr) {
                int need = a[pos] - now[pos];
                int mn = min(tc, need);
                now[pos] += mn;
                tc -= mn;
                need -= mn;
                if(need == 0) union_sets(pos, pos + 1);
                if(tc == 0) break;
                pos = get(pos);
            }
        }
        ll ans = 0;
        for(auto &i: now) ans += i;
        cout << ans << ' ';
    }
    cout << '\n';
}
/*

*/
signed main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr);
    int t = 1;
    cin >> t;
    while(t--) {
        solve();
    }
}
