#include <iostream>
#include <iomanip>
#include <algorithm>
#include <numeric>
#include <cmath>
#include <utility>
#include <cstdio>
#include <cstdlib>
#include <vector>
#include <deque>
#include <bitset>
#include <string>
#include <sstream>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <random>
#include <chrono>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

void fastio() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
}

struct Event {
    int x, ind;
    Event() {}
    Event(int x_, int ind_): x(x_), ind(ind_) {}
    bool operator<(Event other) {
        return x < other.x;
    }
};

void solve() {
    int n, m;
    cin >> n >> m;
    vector<long long> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<int> l(m), r(m), t(m);
    vector<long long> c(m);
    for (int i = 0; i < m; ++i) {
        cin >> l[i] >> r[i] >> c[i] >> t[i];
        --l[i];
        --r[i];
    }
    for (int x = 0; x < n; ++x) {
        vector<Event> line;
        vector<long long> ccop = c, acop = a;
        for (int i = 0; i < m; ++i) {
            int li = l[i];
            if (t[i]) {
                li = min(li, x);
            }
            line.emplace_back(li, i);
        }
        sort(line.begin(), line.end());
        int ind = 0;
        set<pair<int, int>> best;
        long long ans = 0;
        for (int i = 0; i < n; ++i) {
            while (ind < m && line[ind].x == i) {
                int ri = r[line[ind].ind];
                if (t[line[ind].ind]) {
                    ri = max(ri, x);
                }
                best.insert(make_pair(ri, line[ind].ind));
                ++ind;
            }
            while (a[i] && !best.empty()) {
                long long val = min(a[i], c[best.begin()->second]);
                a[i] -= val;
                c[best.begin()->second] -= val;
                if (c[best.begin()->second] == 0) {
                    best.erase(best.begin());
                }
                ans += val;
            }
            while (!best.empty() && best.begin()->first == i) {
                best.erase(best.begin());
            }
        }
        cout << ans << " ";
        a = acop;
        c = ccop;
    }
    cout << "\n";
}

signed main() {
    fastio();

    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }

    return 0;
}
