#include <iostream>
#include <cmath>

#include <algorithm>

#include <vector>
#include <string>
#include <map>
#include <set>
#include <queue>

using namespace std;

typedef long long ll;

const ll inf = 1e18;

void solve() {
	int n, m; cin >> n >> m;
	vector<vector<int>> g(n);
	for (int i = 0; i < m; i++) {
		int v, u; cin >> v >> u;
		v--; u--;

		g[v].push_back(u);
		g[u].push_back(v);
	}

	deque<pair<int, int>> q;
	map<pair<int, int>, int> dist;
	map<pair<int, int>, bool> used;
	q.push_front({ 0, 0 });
	dist[{0, 0}] = 0;
	used[{0, 0}] = true;

	while (!q.empty()) {
		pair<int, int> v = q.front();
		q.pop_front();

		if (v.first == v.second) {
			for (auto to : g[v.first]) {
				pair<int, int> cur = { v.first, to };
				if (!used[cur]) {
					q.push_back(cur);
					dist[cur] = dist[v] + 1;
					used[cur] = true;
				}
			}
		}
		else {
			for (auto to : g[v.first]) {
				if (to != v.second) {
					pair<int, int> cur = { to, v.second };
					if (!used[cur]) {
						q.push_front(cur);
						dist[cur] = dist[v];
						used[cur] = true;
					}
				}
				else {
					pair<int, int> cur = { v.first, v.first };
					if (!used[cur]) {
						q.push_back(cur);
						dist[cur] = dist[v] + 1;
						used[cur] = true;
					}
				}
			}
		}
	}

	for (int i = 1; i < n; i++) {
		if (!used[{i, i}])
			cout << -1 << ' ';
		else
			cout << dist[{i, i}] << ' ';
	}

	cout << '\n';
}

int main() {
	int t; cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}