#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>

using namespace std;

typedef long long ll;

const int MAX_pow_10 = 18;
ll pow_10[MAX_pow_10 + 1];

void build_pow_10() {
	pow_10[0] = 1;
	for (int i = 1; i <= MAX_pow_10; i++) {
		pow_10[i] = pow_10[i - 1] * 10;
	}
}

ll y;
int n;
ll best_res;
vector<int> ans;
// vector<int> ind[10];
vector<int> a, next_same, next_free, prev_free;
vector<int> b, others;

int bb;
vector<int> tree;

void build_tree(int n) {
	bb = 1;
	while (bb < n) {
		bb *= 2;
	}
	tree.assign(2 * bb, 0);
	for (int i = 0; i < n; i++) {
		tree[bb + i] = i;
	}
}

void substract_tree(int t, int tl, int tr, int left, int right) {
	if (left >= right) {
		return;
	}
	if (tl == left && tr == right) {
		tree[t]--;
		return;
	}
	int mid = (tl + tr) / 2;
	substract_tree(t * 2, tl, mid, left, min(right, mid));
	substract_tree(t * 2 + 1, mid, tr, max(left, mid), right);
}

void add_tree(int t, int tl, int tr, int left, int right) {
	if (left >= right) {
		// cout << "return\n";
		return;
	}
	if (tl == left && tr == right) {
		tree[t]++;
		// cout << t << "++\n";
		return;
	}
	int mid = (tl + tr) / 2;
	add_tree(t * 2, tl, mid, left, min(right, mid));
	add_tree(t * 2 + 1, mid, tr, max(left, mid), right);
}

int get_val(int i) {
	int t = bb + i, val = 0;
	while (t) {
		val += tree[t];
		t /= 2;
	}
	return val;
}

int last[10];

void print_tree() {
	for (int i = 1; i < 2 * bb; i++) {
		cout << tree[i] << " ";
	}
	cout << "<- tree\n";
}

void try_place(int i, ll res) {
	if (i == n) {
		// cout << "here\n";
		if (res > best_res) {
			best_res = res;
			ans = b;
		}
		else if (res == best_res && b > ans) {
			ans = b;
		}
		return;
	}
	for (int d = 0; d < 10; d++) {
		if (last[d] == -1) {
			continue;
		}
		b.push_back(d);;
		int k = last[d];
		if (prev_free[k] >= 0 && next_free[k] < n) {
			next_free[prev_free[k]] = next_free[k];
			prev_free[next_free[k]] = prev_free[k];
		}
		substract_tree(1, 0, bb, k + 1, n);
		last[d] = next_same[k];
		// cout << "val = " << get_val(k) << "\n";
		// print_tree();
		ll new_res = res + d * pow_10[n - i - 1] - y * get_val(k);
		try_place(i + 1, new_res);
		last[d] = k;
		// cout << "add_tree\n";
		add_tree(1, 0, bb, k + 1, n);
		if (prev_free[k] >= 0 && next_free[k] < n) {
			next_free[prev_free[k]] = k;
			prev_free[next_free[k]] = k;
		}
		b.pop_back();
	}
	// int x = others.size();
	// for (int j = 0; j < x; j++) {
	// 	b.push_back(others[j]);
	// 	others.erase(others.begin() + j);
	// 	ll new_res = res + b.back() * pow_10[n - i - 1] - y * j;
	// 	try_place(i + 1, new_res);
	// 	others.emplace(others.begin() + j, b.back());
	// 	b.pop_back();
	// }
}

void solve(vector<int> aa) {
	build_pow_10();
	// string s;
	// cin >> s;
	n = aa.size();
	a = aa;
	next_same.resize(n), next_free.resize(n), prev_free.resize(n);
	best_res = 0;
	for (int i = 0; i < n; i++) {
		// char c;
		// cin >> c;
		// a[i] = s[i] - '0';
		// cin >> a[i];
		best_res += a[i] * pow_10[n - i - 1];
		next_free[i] = i + 1;
		prev_free[i] = i - 1;
	}
	// int last[10];
	memset(last, -1, sizeof(last));
	for (int i = n - 1; i >= 0; i--) {
		next_same[i] = last[a[i]];
		last[a[i]] = i;
	}
	cin >> y;
	ans = a;
	// for (int i = 0; i < n; i++) {
	// 	ind[a[i]].push_back(i);
	// }
	others = a;
	build_tree(n);
	try_place(0, 0);
	for (int i = 0; i < n; i++) {
		cout << ans[i];
	}
	cout << "\n";
	// cout << "res = " << best_res << "\n";
}

const int LAST = 10;

int main() {
	string s;
	cin >> s;
	n = s.size();
	a.resize(n);
	vector<pair<int, int>> ai;
	for (int i = 0; i < n; i++) {
		// cin >> a[i];
		a[i] = s[i] - '0';
		ai.push_back({ -a[i], i });
	}
	sort(ai.begin(), ai.end());
	int x = max(0, n - LAST);
	for (int i = 0; i < x; i++) {
		b.push_back(-ai[i].first);
	}
	vector<pair<int, int>> aai;
	for (int i = x; i < n; i++) {
		aai.push_back({ ai[i].second, -ai[i].first });
	}
	sort(aai.begin(), aai.end());
	vector<int> aa;
	for (int i = 0; i < n - x; i++) {
		aa.push_back(aai[i].second);
	}
	// cout << "aa: \n";
	// for (int x : aa) {
	// 	cout << x << "\n";
	// }
	solve(aa);
}
