#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;

struct state {
	int n, m;
	vector<int> level;
	vector<ll> values;
	ll cnt_added;

	state(vector<ll> c, ll cnt_added = 0) {
		n = c.size();
		level.resize(n);
		vector<pair<ll, int>> x;
		// cout << "c: ";
		for (int i = 0; i < n; i++) {
			x.push_back({ c[i], i });
			// cout << c[i] << ", ";
		}
		// cout << "\n";
		sort(x.begin(), x.end());
		int lev = 0;
		for (int i = 0; i < n; i++) {
			level[x[i].second] = lev;
			// cout << "level[" << x[i].second << "] = " << lev << "\n";
			lev += (i + 1 == n || x[i].first != x[i + 1].first);
			// cout << "new_lev = " << lev << "\n";
			// cout << "sz = " << values.size() << "\n";
			if (lev > values.size()) {
				values.push_back(x[i].first);
			}
		}
		m = values.size();
		this->cnt_added = cnt_added;
	}

	bool is_last() const {
		return (m == 1);
	}

	state get_next() {
		vector<ll> c(n);
		ll new_cnt_added = cnt_added;
		for (int i = 0; i < n; i++) {
			// cout << "m = " << m << "values[" << level[i] << "] = " << values[level[i]] << "\n";
			c[i] = values[level[i]] + (m - level[i] - 1);
			new_cnt_added += (m - level[i] - 1);
		}
		return state(c, new_cnt_added);
	}

	int get_cnt_levels() {
		return m;
	}

	ll get_cnt_added() {
		return cnt_added;
	}

	ll get_value_now(int i) {
		return values[level[i]];
	}
};

int main() {
	int n, q;
	cin >> n >> q;
	vector<ll> c(n);
	for (int i = 0; i < n; i++) {
		cin >> c[i];
	}
	vector<state> states;
	states.push_back(state(c));
	while (!states.back().is_last()) {
		states.push_back(states.back().get_next());
	}
	for (int i = 0; i < q; i++) {
		int t, k;
		cin >> t >> k;
		k = min(k, (int)states.size() - 1);
		if (t == 1) {
			cout << states[k].get_cnt_levels() << "\n";
		}
		else if (t == 2) {
			cout << states[k].get_cnt_added() << "\n";
		}
		else {
			int j;
			cin >> j;
			j--;
			cout << states[k].get_value_now(j) << "\n";
		}
	}
}
