#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

typedef long long ll;

struct robot {
	int l, r, c, t;

	friend istream& operator>>(istream& is, robot& r) {
		is >> r.l >> r.r >> r.c >> r.t;
		r.l--;
		return is;
	}
};

int n, m;
vector<int> a;
vector<robot> robots;

ll get_ans(int i) {
	vector<pair<int, int>> events;
	for (int j = 0; j < m; j++) {
		int l = min(robots[j].l, i);
		int r = max(robots[j].r, i + 1);
		if (robots[j].t == 0) {
			l = robots[j].l;
			r = robots[j].r;
		}
		events.push_back({ l, j + 1 });
		events.push_back({ r, -j - 1 });
	}
	sort(events.begin(), events.end());
	ll ans = 0;
	set<pair<int, int>> q;
	vector<int> now_c(m, 0);
	for (int j = 0; j < m; j++) {
		now_c[j] = robots[j].c;
	}
	for (int j = 0, k = 0; j < n; j++) {
		while (k < 2 * m && events[k].first == j) {
			int x = abs(events[k].second) - 1;
			if (events[k].second > 0) {
				q.insert({ (robots[x].t == 0 ? robots[x].r : max(robots[x].r, i + 1)), x });
			}
			else {
				q.erase({ events[k].first, x });
			}
			k++;
		}
		int x = a[j];
		while (x && !q.empty()) {
			int e = q.begin()->second;
			int add = min(x, now_c[e]);
			now_c[e] -= add;
			x -= add;
			ans += add;
			if (!now_c[e]) {
				q.erase(q.begin());
			}
		}
	}
	return ans;
}

void solve() {
	cin >> n >> m;
	robots.resize(m);
	a.resize(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	for (int i = 0; i < m; i++) {
		cin >> robots[i];
	}
	for (int i = 0; i < n; i++) {
		cout << get_ans(i) << " ";
	}
	cout << "\n";
}

int main() {
	int t;
	cin >> t;
	for (int i = 0; i < t; i++) {
		solve();
	}
}
