#include <bits/stdc++.h>

#define rep(i, n) for(int i = 0; i < (n); ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define ar array

using namespace std;

typedef long long ll;
typedef long double ld;

using vi = vector<int>;
using vl = vector<ll>;
using vvi = vector<vi>;

const int INFi = 2e9;
const ll INF = 2e18;
const int maxN = 1e5;

struct fenwick {
    vector<ll> fenw;
    int n;

    void build(int k) {
        n = k;
        fenw.resize(n);
    }

    void upd(int i, ll x) {
        for (; i < n; i |= i + 1) fenw[i] += x;
    }

    ll get(int i) {
        ll r = 0;
        for (; i >= 0; i = (i & (i + 1)) - 1) r += fenw[i];
        return r;
    }
};

void solve() {
    int n, q;
    cin >> n >> q;
    vl c(n);
    rep(i, n) cin >> c[i];
    vector<int> tp(q);
    vector<ll> k(q);
    vector<int> p(q);
    vi ord(q);
    iota(all(ord), 0);
    rep(i, q) {
        cin >> tp[i];
        cin >> k[i];
        if (tp[i] == 3) {
            cin >> p[i];
        }
    }
    sort(all(ord), [&](const int &i, const int &j) {
        return k[i] < k[j];
    });
    vector<ll> ans(q);
    fenwick f;
    f.build(n);
    vi ordc(n);
    iota(all(ordc), 0);
    sort(all(ordc), [&](const int &i, const int &j) {
        return c[i] > c[j];
    });
    for (int i = 1; i < n; ++i) f.upd(i, 1);
    vector<int> pos(n);
    rep(i, n) pos[ordc[i]] = i;
    vector<pair<ll, int>> events;
    for (int i = 1; i < n; ++i) events.emplace_back(c[ordc[i - 1]] - c[ordc[i]], i);
    sort(all(events));
    ll addALL = 0;
    ll add = 1ll * (n - 1) * n / 2;
    ll cur = 0;
    fenwick f2;
    f2.build(n);
    for (int i = 1; i < n; ++i) f2.upd(i, c[ordc[i - 1]] - c[ordc[i]]);
    int j = 0;
    auto go = [&](ll x) {
        while (j < (int) events.size() && events[j].first <= x) {
            ll to = events[j].first;
            addALL += add * (to - cur);
            cur = to;
            int i = events[j].second;
            int e = f.get(i);
            add -= (n - i);
            f.upd(i, -1);
            f2.upd(i, -to);
            j++;
        }
        addALL += add * (x - cur);
        cur = x;
    };
    for (auto &i: ord) {
        go(k[i]);
        if (tp[i] == 1) {
            ans[i] = n - j;
        } else if (tp[i] == 2) {
            ans[i] = addALL;
        } else {
            int x = p[i];
            x = pos[x - 1];
            int e = f.get(x);
            ll s = c[ordc[0]];
            ll val = f2.get(x);
            s -= val;
            s += 1ll * e * k[i];
            ans[i] = s;
        }
    }
    rep(i, q) cout << ans[i] << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t = 1;
    rep(_, t) {
        solve();
    }
    return 0;
}