#include <iostream>
#include <ios>
#include <vector>
#include <stack>
#include <set>
#include <map>
#include <iomanip>
#include <algorithm>
#include <queue>
#include <random>

using namespace std;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef long long ll;
typedef long double ld;

#define all(x) ((x).begin()), ((x).end())
#define rall(x) ((x).rbegin()), ((x).rend())
#define nl '\n'

string solve1(string left, ll y) {
	vector<ll> pows(18);
	pows[0] = 1;
	for (int i = 1; i < 18; i++)
	{
		pows[i] = 10 * pows[i - 1];
	}
	int sz = left.size();

	for (int i = 0; i < sz; i++)
	{
		ll maxB = 0;
		int maxId = i;
		for (int j = i + 1; j < sz; j++)
		{
			if (left[j] == left[i]) continue;
			ll balance = 0;
			for (int k = i + 1; k <= j; k++)
			{
				balance += (ll)(left[k - 1] - left[k]) * pows[sz - k - 1];
			}
			balance += pows[sz - i - 1] * (ll)(left[j] - left[i]);
			balance += y * (ll)(i - j);
			if (balance > maxB || (balance == maxB && left[j] > left[maxId])) {
				maxB = balance;
				maxId = j;
			}
		}
		string newL = "";
		for (int j = 0; j < sz; j++)
		{
			if (j < i || j > maxId) {
				newL += left[j];
			}
			else if (j == i) {
				newL += left[maxId];
			}
			else {
				newL += left[j - 1];
			}
		}
		left = newL;
	}
	return left;
}

string solve2(string left, ll y) {
	vector<ll> pows(18);
	pows[0] = 1;
	for (int i = 1; i < 18; i++)
	{
		pows[i] = 10 * pows[i - 1];
	}
	int sz = left.size();

	for (char c = '9'; c > '0'; c--)
	{
		for (int i = 1; i < sz; i++)
		{
			if (left[i] != c) continue;
			int ans = -1;
			for (int j = 0; j < i; j++)
			{
				if (left[j] >= left[i]) continue;
				ll balance = 0;
				for (int k = j + 1; k <= i; k++)
				{
					balance += (ll)(left[k - 1] - left[k]) * pows[sz - k - 1];
				}
				balance += pows[sz - j - 1] * (ll)(left[i] - left[j]);
				balance -= y * (ll)(i - j);
				if (balance >= 0) {
					ans = j;
					break;
				}
			}

			if (ans != -1) {
				string newL = "";
				for (int j = 0; j < sz; j++)
				{
					if (j < ans || j > i) {
						newL += left[j];
					}
					else if (j == ans) {
						newL += left[i];
					}
					else {
						newL += left[j - 1];
					}
				}
				left = newL;
			}
		}
	}
	return left;
}

ll check(vector<int> done, string source, ll y) {
	ll blame = 0;
	vector<bool> used(source.size(), false);
	for (int i = 0; i < done.size(); i++)
	{
		int cnt = 0;
		bool ok = false;
		for (int j = 0; j < done.size(); j++)
		{
			if (used[j]) continue;
			if (done[i] == source[j] - '0') {
				blame += (ll)cnt * (ll)y;
				used[j] = true;
				ok = true;
				break;
			}
			cnt++;
		}
		if (!ok) {
			return 1e18;
		}
	}
	return blame;
}

ll count(vector<int> data) {
	ll pow = 1;
	ll ans = 0;
	for (int i = data.size() - 1; i >= 0; i--)
	{
		ans += data[i] * pow;
		pow *= 10;
	}
	return ans;
}

string make_str(vector<int> data) {
	string s = "";
	for (int i = 0; i < data.size(); i++)
	{
		s += (char)(data[i] + '0');
	}
	return s;
}

string solve(string left, int y) {
	vector<ll> pows(18);
	pows[0] = 1;
	for (int i = 1; i < 18; i++)
	{
		pows[i] = 10 * pows[i - 1];
	}
	int sz = left.size();
	vi opts;
	for (int i = 0; i < sz; i++)
	{
		opts.push_back(left[i] - '0');
	}
	sort(all(opts));
	ll minBlame = count(opts) - check(opts, left, y);
	string ans = make_str(opts);
	do
	{
		ll res = count(opts) - check(opts, left, y);
		if (res > minBlame) {
			minBlame = res;
			ans = make_str(opts);
		}
		if (res == minBlame) {
			if (make_str(opts) > ans) {
				ans = make_str(opts);
			}
		}
	} while (next_permutation(all(opts)));
	ll res = count(opts) - check(opts, left, y);
	if (res > minBlame) {
		minBlame = res;
		ans = make_str(opts);
	}
	if (res == minBlame) {
		if (make_str(opts) > ans) {
			ans = make_str(opts);
		}
	}
	return ans;
}

mt19937 my_rand;
pair<string, int> gen() {
	int sz = 1 + my_rand() % 9;
	string s = "";
	for (int i = 0; i < sz; i++)
	{
		s += (char)('0' + my_rand() % 10);
	}
	int y = my_rand() % 10000000;
	return { s, y };
}

void stress() {
	while (true) {
		auto sample = gen();
		auto ans1 = solve1(sample.first, (ll)sample.second);
		auto ans2 = solve(sample.first, (ll)sample.second);
		if (ans1 != ans2) {
			cout << "ERROR" << endl;
			cout << ans1 << endl << ans2 << endl << sample.first << endl << sample.second << endl;
		}
		else {
			//cout << "OK" << endl;
		}
	}
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	cout << fixed << setprecision(16);
	my_rand.seed(1791791791);
	//stress();

	string s;
	ll y;
	cin >> s >> y;
	int logy = 1;

	ll y1 = y;
	while (y1 > 0) {
		y1 /= 10;
		logy++;
	}
	int count = 0;
	char current = '9';
	int id = 0;
	string res = "";
	vector<bool> used(s.size(), false);
	while (count < (int)s.size() - 10) {
		if (id == s.size()) {
			id = 0;
			current--;
		}
		if (s[id] == current) {
			res += current;
			used[id] = true;
			count++;
		}
		id++;
	}

	string left = "";
	for (int i = 0; i < s.size(); i++)
	{
		if (!used[i]) {
			left += s[i];
		}
	}
	
	auto v1 = solve1(left, y);
	auto v2 = solve2(left, y);

	vi a1;
	for (int i = 0; i < v1.size(); i++)
	{
		a1.push_back(v1[i] - '0');
	}
	vi a2;
	for (int i = 0; i < v2.size(); i++)
	{
		a2.push_back(v2[i] - '0');
	}

	if (check(a1, left, y) > check(a2, left, y)) {
		swap(v1, v2);
	}

	cout << res << solve(left, y);

	return 0;
}
