#include <iostream>
#include <ios>
#include <vector>
#include <stack>
#include <set>
#include <map>
#include <iomanip>
#include <algorithm>
#include <queue>

using namespace std;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef long long ll;
typedef long double ld;

#define all(x) ((x).begin()), ((x).end())
#define rall(x) ((x).rbegin()), ((x).rend())
#define nl '\n'

struct query {
	int id, t;
	ll k, i;

	bool operator < (const query& other) const {
		if (k != other.k) {
			return k < other.k;
		}
		return t < other.t;
	}
};

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	cout << fixed << setprecision(16);

	int n, q;
	cin >> n >> q;

	vector<ll> c(n), csort(n);
	vector<ll> score(n);
	vector<ll> deltas(n);

	map<ll, int> count;
	for (int i = 0; i < n; i++)
	{
		cin >> c[i];
		csort[i] = c[i];
		score[i] = c[i];
		count[c[i]]++;
	}
	sort(all(csort));

	vector<query> queries(q);
	for (int i = 0; i < q; i++)
	{
		int t;
		cin >> t;
		queries[i].id = i;
		queries[i].t = t;
		ll k;
		cin >> k;
		queries[i].k = k;
		if (t == 3) {
			cin >> queries[i].i;
			queries[i].i--;
		}
	}

	map<ll, int> less;
	map<ll, int> lessCnt;
	int cntDiff = count.size();
	ll appending = 0;
	int prevId = 0;
	int cntLess = 0;
	ll lessTotal = 0;
	ll prevVal = -1;

	for (auto item : count)
	{
		lessTotal += item.second;
		cntLess++;
		lessCnt[item.first] = cntLess;
		less[item.first] = lessTotal;
		appending += (ll)item.second * (count.size() - cntLess);
		if (prevVal != -1) {
			query q;
			q.k = item.first - prevVal;
			q.id = -1;
			q.t = 0;
			q.i = prevVal;
			queries.push_back(q);
		}
		prevVal = item.first;
	}

	/*for (int i = 1; i < n; i++)
	{
		if (prev != csort[i]) {
			less[prev] = i;
			appending += (ll)(n - i) * (ll)(i - prevId);
			prevId = i;
			cntDiff++;
			
		}
		prev = csort[i];
	}*/
	less[csort.back()] = n;

	sort(all(queries));
	ll prevK = 0;
	ll total = 0;

	for (int i = 0; i < n; i++)
	{
		deltas[i] = count.size() - lessCnt[c[i]];
	}

	vector<ll> answers(q);
	ll prevApp = 0;
	for (auto q : queries)
	{
		total += (q.k - prevK) * appending;
		prevK = q.k;
		switch (q.t)
		{
		case 0: {
			appending -= less[q.i];
			for (int i = 0; i < n; i++)
			{
				score[i] += deltas[i] * (q.k - prevApp);
				if (c[i] <= q.i) {
					deltas[i]--;
				}
			}
			prevApp = q.k;
			cntDiff--;
			break;
		}
		case 1: {
			answers[q.id] = cntDiff;
			break;
		}

		case 2: {
			answers[q.id] = total;
			break;
		}
		case 3: {
			
			answers[q.id] = score[q.i] + deltas[q.i] * (q.k - prevApp);
			break;
		}
		default:
			break;
		}
	}
	for (int i = 0; i < q; i++)
	{
		cout << answers[i] << nl;
	}
	cout.flush();
	return 0;
}
