#pragma GCC optimize("Ofast")
//#pragma GCC target("avx2,sse4,popcnt")

#include <bits/stdc++.h>

#define sq(x) ((x)*(x))
#define err(x) cerr << "["#x"]  " << (x) << '\n'
#define errv(x) {cerr << "["#x"]  ["; for(const auto& i : (x))  cerr << i << ", "; cerr << "]\n";}
#define errvn(x, n) {cerr << "["#x"]  ["; for (int i = 0; i < (n); ++i) cerr << (x)[i] << ", "; cerr << "]\n";}
#define errf() cerr << "\n\n"

using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
inline ll getrnd(ll l, ll r) {
    return uniform_int_distribution<ll>(l, r)(rng);
}

template<typename T1, typename T2>
inline bool relax(T1& a, const T2& b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

template<typename T1, typename T2>
inline bool strain(T1& a, const T2& b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

// :::::::::::::::::::::::::::::::::::

const int N = 3e5 + 5;


struct seg_tree {
    vector<ll> tree;

    seg_tree(int n) : tree(4 * n) {}

    void update(int v, int tl, int tr, int pos, int x) {
        if (tl == tr) {
            tree[v] = x;
            return;
        }
        int tm = (tl + tr) / 2;
        if (pos <= tm)
            update(2 * v, tl, tm, pos, x);
        else
            update(2 * v + 1, tm + 1, tr, pos, x);
        tree[v] = tree[2 * v] + tree[2 * v + 1];
    }

    ll get(int v, int tl, int tr, int l, int r) {
        if (l > r) return 0;
        if (tl ==l && tr == r) {
            return tree[v];
        } else {
            int tm = (tl + tr) / 2;
            return get(2 * v, tl, tm, l, min(r, tm)) + get(2 * v + 1, tm + 1, tr, max(l, tm + 1), r);
        }
    }
};

seg_tree sum_sz(N);

ll a[N], b[N], par[N], l[N], r[N], sz[N];

int find(int v) {
    return par[v] == v ? v : (par[v] = find(par[v]));
}

bool unite(int a, int b) {
    a = find(a);
    b = find(b);
    if (a != b) {
        if (sz[a] < sz[b])
            swap(a, b);
        par[b] = a;
        relax(l[a], l[b]);
        strain(r[a], r[b]);
        sum_sz.update(1, 0, N - 1, b, 0);
        sz[a] += sz[b];
        sum_sz.update(1, 0, N - 1, a, sz[a]);
    }
    return a != b;
}


void solve() {
    int n, q;
    cin >> n >> q;
    vector<int> ord(n);
    iota(ord.begin(), ord.end(), 0);
    for (int i = 0; i < n; ++i)
        cin >> a[i];
    sort(ord.begin(), ord.end(), [&](int x, int y) {
        return a[x] < a[y];
    });
    vector<int> wh(n);
    for (int i = 0; i < n; ++i)
        wh[ord[i]] = i;
    for (int i = 0; i < n; ++i)
        b[i] = a[ord[i]];

    vector<ll> ans(q);
    vector<tuple<ll, ll, ll, ll>> qs;
    for (int i = 0; i < q; ++i) {
        int t;
        cin >> t;
        ll k;
        cin >> k;
        if (t == 3) {
            int pos;
            cin >> pos;
            qs.emplace_back(k, t, pos - 1, i);
        } else {
            qs.emplace_back(k, t, 0, i);
        }
    }
    ll cur_sum = 0;
    ll have = 0;
    for (int i = 0; i < n; ++i) {
        par[i] = l[i] = r[i] = i;
        sz[i] = 1;
        sum_sz.update(1, 0, N - 1, i, 1);
        if (i) {
            qs.emplace_back(b[i] - b[i - 1], -1, i, -1);
        }
        cur_sum += i;
    }
    errvn(b, n);
    sort(qs.begin(), qs.end());
    int comps = n;
    ll prev_k = 0;
    for (auto [k, t, pos, ind] : qs) {
        if (t == 1) {
            ans[ind] = comps;
        } else if (t == 2) {
            ans[ind] = have + (k - prev_k) * cur_sum;
        } else if (t == 3) {
            pos = wh[pos];
            int cp = r[find(pos)];
            int bg = 0;
            for (int i = cp + 1; i < n; ++i)
                if (find(i) == i)
                    ++bg;
            ans[ind] = b[pos] + k * bg;
        } else {
            int ok = find(pos - 1) != find(pos);
            if (ok) {
                have += (k - prev_k) * cur_sum;
                int cp = l[find(pos)];
//                for (int i = cp - 1; i >= 0; --i) {
//                    if (find(i) == i)
//                        cur_sum -= sz[i];
//                }
                cur_sum -= sum_sz.get(1, 0, N - 1, 0, cp - 1);
                --comps;
                unite(pos, pos - 1);
                prev_k = k;
            }
        }
    }

    for (int i = 0; i < q; ++i)
        cout << ans[i] << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);

    int t = 1;
//    cin >> t;
    while (t--)
        solve();
    return 0;
}

