#pragma GCC optimize("Ofast")
//#pragma GCC target("avx2,sse4,popcnt")

#include <bits/stdc++.h>

#define sq(x) ((x)*(x))
#define err(x) cerr << "["#x"]  " << (x) << '\n'
#define errv(x) {cerr << "["#x"]  ["; for(const auto& i : (x))  cerr << i << ", "; cerr << "]\n";}
#define errvn(x, n) {cerr << "["#x"]  ["; for (int i = 0; i < (n); ++i) cerr << (x)[i] << ", "; cerr << "]\n";}
#define errf() cerr << "\n\n"

using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
inline ll getrnd(ll l, ll r) {
    return uniform_int_distribution<ll>(l, r)(rng);
}

template<typename T1, typename T2>
inline bool relax(T1& a, const T2& b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

template<typename T1, typename T2>
inline bool strain(T1& a, const T2& b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

// :::::::::::::::::::::::::::::::::::

const int N = 5e5 + 5, INF = 1e9;

int dp[N];
vector<int> graph[N];

void solve() {
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int x, y;
        cin >> x >> y;
        --x; --y;
        graph[x].emplace_back(y);
        graph[y].emplace_back(x);
    }
    for (int i = 0; i < n; ++i)
        dp[i] = INF;
    queue<int> scope;
    for (int to : graph[0]) {
        dp[to] = 0;
        scope.emplace(to);
    }
    vector<vector<int>> can(n);
    for (int i = 0; i < n; ++i)
        can[i] = graph[i];
    while (!scope.empty()) {
        auto v = scope.front();
        scope.pop();
        for (int to : graph[v]) {
            while (!can[to].empty()) {
                int to2 = can[to].back();
                can[to].pop_back();
                if (relax(dp[to2], dp[v] + 1))
                    scope.push(to2);
            }
//            can[to] = graph[to];
        }
    }

    for (int i = 1; i < n; ++i) {
        int res = INF;
        for (int to : graph[i]) {
            relax(res, dp[to] * 2 + 2);
        }
        cout << (res == INF ? -1 : res) << ' ';
    }
    cout << '\n';
    // CLEAR TESTS
    for (int i = 0; i < n; ++i) {
        graph[i].clear();
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);

    int t = 1;
    cin >> t;
    while (t--)
        solve();
    return 0;
}


