#include <iostream>
#include <bits/stdc++.h>

using namespace std;

#define range(i, n) for (int i = 0; i < (n); ++i)
#define rrange(i, n) for (int i = (n) - 1; i >= 0; --i)

#define all(a) (a).begin(), (a).end()

typedef long long ll;

const int MAXN = 5e5 + 10;
const int INF = 1e9;
vector<int> graph[MAXN];

bool used[MAXN];

bool dfs_to_1(int v) {
    used[v] = true;
    if (v == 0) return true;
    for (auto u : graph[v]) {
        if (used[u]) continue;
        if (dfs_to_1(u)) return true;
    }
    return false;
}

int n_b[MAXN];
int w_b[MAXN];
int p_b[MAXN];

void solve() {
    int n, m; cin >> n >> m;
    fill(graph, graph + n, vector<int>());
    range(i, m) {
        int a, b; cin >> a >> b;
        --a; --b;
        graph[b].push_back(a);
        graph[a].push_back(b);
    }

    fill(n_b, n_b + n, INF);
    fill(w_b, w_b + n, INF);
    fill(p_b, p_b + n, INF);
    vector<int> ws, ps, ns;
    ws.push_back(0);
    w_b[0] = 0;
    bool change;
    do {
        change = false;
        vector<int> nws, nps, nns;
        while (!ws.empty()) {
            auto v = ws.back();
            ws.pop_back();
            for (auto u : graph[v]) {
                if (p_b[u] > w_b[v] + 1) {
                    p_b[u] = w_b[v] + 1;
                    nps.push_back(u);
                    change = true;
                }
            }
        }
        while (!ps.empty()) {
            auto v = ps.back();
            ps.pop_back();
            for (auto u : graph[v]) {
                if (w_b[u] > p_b[v] + 1) {
                    fill(used, used + n, 0);
                    used[v] = true;
                    if (!dfs_to_1(u)) continue;
                    w_b[u] = p_b[v] + 1;
                    nws.push_back(u);
                    change = true;
                }
            }
        }
        ps.swap(nps);
        ws.swap(nws);
    } while (change);
    for (int i = 1; i < n; ++i) {
        cout << (w_b[i] == INF?-1:w_b[i]) << ' ';
    }
    cout << '\n';
}

int main() {
    int t = 1;
    cin >> t;
    range(i, t) {
        solve();
    }
    return 0;
}
