#include <iostream>
#include <vector>
#include <algorithm>
#include <assert.h>
#include <ctime>

using namespace std;

typedef long long ll;
typedef long double ld;

#define input(a) do {for (auto& e : a) cin >> e;} while(0);
#define print(a) do {cerr << #a << ": "; for (auto& e : a) cerr << e << " "; cerr << "\n";} while(0);

const int K = 20;
ll Y = 0;

ll calc(vector<int>& now, string& s) {
	ll value = 0;
	for (int i = 0; i < s.length(); i++) {
		value *= 10;
		value += s[i] - '0';
	}
	int ops = 0;
	for (auto& e : now)
		ops += e;
	value -=  Y * ops;
	return value;
}
string getS(vector<int>& now, string& s0) {
	int n = now.size();
	vector<int> poses(n);
	for (int i = 0; i < n; i++)
		poses[i] = i;
	for (int i = 0; i < n; i++) {
		poses[i] -= now[i];
		for (int j = i + 1; j < n; j++) {
			if (j - now[j] <= poses[i])
				poses[i]++;
		}
	}
	string ans = "?";	
	for (int i = 1; i < n; i++) {
		ans += '?';
	}
	//print(now);
	//print(poses);
	for (int i = 0; i < n; i++) {
		assert(ans[poses[i]] == '?');
		ans[poses[i]] = s0[i];
	}
	return ans;
}

int t0 = 0;

void calc(vector<int>& now, int i, string& s0, string& bs, ll& ba) {
	if (i >= now.size()) {
		string sNow = getS(now, s0);
		ll ansNow = calc(now, sNow);
		if (ba < ansNow || (ba == ansNow && sNow > bs)) {
			swap(bs, sNow);
			swap(ba, ansNow);
		}
		return;
	}
	for (int j = 0; j <= i; j++) {
		now[i] = j;
		calc(now, i + 1, s0, bs, ba);
		if (clock() - t0 > ld(0.5) * CLOCKS_PER_SEC)
			return;
	}
	now[i] = 0;
}

string solve(string inp, ll y) {
	ll ba = 0;
	string bs = inp;
	//cerr << "calcing " << inp << "\n";

	vector<int> now(inp.size());
	
	t0 = clock();
	calc(now, 0, inp, bs, ba);
	return bs;
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	string s;
	cin >> s;
	int n = s.length();
	ll y;
	cin >> y;
	Y = y;
	int cnt[10];
	int used[10];
	for (int i = 0; i <= 9; i++) {
		cnt[i] = 0;
		used[i] = 0;
	}
	for (auto& e : s)
		cnt[e - '0']++;

	string ans = "";
	int now = 9;
	for (int i = 0; i < n - K; i++) {
		while (cnt[now] == 0) {
			now--;
		}
		used[now]++;
		cnt[now]--;
		ans += '0' + now;
	}
	string left = "";
	for (int i = 0; i < n; i++) {
		int now = s[i] - '0';
		if (used[now] == 0)
			left += s[i];
		else
			used[now]--;
	}
	ans += solve(left, y);
	cout << ans;	
}