#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>

using namespace std;

typedef long long ll;
typedef long double ld;

#define input(a) do {for (auto& e : a) cin >> e;} while(0);
#define print(a) do {cerr << #a << ": "; for (auto& e : a) cerr << e << " "; cerr << "\n";} while(0);


struct query {
	int t;
	ll k;
	int i;
	int id;
};

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);

	int n, q;
	cin >> n >> q;
	vector<ll> state(n);
	input(state);
	vector<ll> anses(q);
	vector<query> tasks(q);

	for (int i = 0; i < q; i++) {
		auto& now = tasks[i];
		now.id = i;
		cin >> now.t >> now.k;
		if (now.t == 3) {
			cin >> now.i;
			now.i--;
		}
	}
	sort(tasks.begin(), tasks.end(), [](query& a, query& b) {
		return a.k < b.k;
	});

	int qid = 0;
	ll totalAdded = 0;
	for (int know = 0;  qid < tasks.size(); know++) {
		while (qid < tasks.size() && tasks[qid].k == know) {
			auto& now = tasks[qid];
			if (now.t == 1) {
				set<ll> els;
				for (auto& e : state)
					els.insert(e);
				anses[now.id] = els.size();
			}
			if (now.t == 2)
				anses[now.id] = totalAdded;
			if (now.t == 3)
				anses[now.id] = state[now.i];
			qid++;
		}
		set<ll> els;
		for (auto& e : state)
			els.insert(e);
		map<ll, int> add;
		int addNow = (int)els.size() - 1;
		for (auto& e : els) {
			add[e] = addNow;
			addNow--;
		}
		for (auto& e : state) {
			totalAdded += add[e];
			e += add[e];
		}
	}

	for (auto& e : anses)
		cout << e << "\n";
}