#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>

using namespace std;

typedef long long ll;
typedef long double ld;

#define input(a) do {for (auto& e : a) cin >> e;} while(0);
#define print(a) do {cerr << #a << ": "; for (auto& e : a) cerr << e << " "; cerr << "\n";} while(0);

vector<vector<int>> graph;
vector<int> isBad;

void solve() {
	int n, m;
	cin >> n >> m;
	graph = vector<vector<int>>(n);
	isBad = vector<int>(n, 0);
	for (int i = 0; i < m; i++) {
		int a, b;
		cin >> a >> b;
		a--;
		b--;
		graph[a].push_back(b);
		graph[b].push_back(a);
	}
	// set bad
	
	vector<vector<int>> dists(n, vector<int>(2, -1));
	queue<pair<int, int>> ord;
	dists[0][0] = 0;
	ord.push({0, 0});
	while (!ord.empty()) {
		auto [v, t] = ord.front();
		ord.pop();
		for (auto& other : graph[v]) {
			if (isBad[other])
				continue;
			int nxtT = !t;
			if (dists[other][nxtT] != -1)
				continue;
			dists[other][nxtT] = dists[v][t] + 1;
			ord.push({other, nxtT});
		}
	}
	for (int i = 0; i < n; i++) {
		for (int t = 0; t < 2; t++) {
			if (dists[i][t] == -1) {
				dists[i][t] = 1e9;
			}
		}
	}
	for (int p = 1; p < n; p++) {
		int ans = dists[p][0];
		for (auto& other : graph[p]) {
			ans = min(ans, dists[other][1] + 1);
		}
		if (ans > 1e8)
			ans = -1;
		cout << ans << " ";
	}
	cout << "\n";
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);

	int t;
	cin >> t;
	while (t--)
		solve();
}