#include <iostream>
#include <algorithm>
#include <vector>
#include <iomanip>
#include <set>
#include <random>
#include <map>
#include <cmath>
#include <string>

#pragma GCC target("avx,avx2,sse,sse2,sse3,sse4,popcnt")

#pragma GCC oiptimize("-Ofast,unroll-loops,fast-math")

using namespace std;

struct request {
	int i, ind;
	long long k;
	request(int _j = 0, int nd = 0, int _k = 0) : i(_j), ind(nd), k(_k) {}
};

bool cmp(request fr, request sc) {
	return fr.ind > sc.ind;
}

mt19937 rnd(time(0));

class dd {
private:
	struct node {
		long long val, res_sum;
		int cnt, sz, lft = -1, rgh = -1, y;
		node(long long v = 0, int c = 1) {
			val = v;
			cnt = c;
			sz = c;
			res_sum = val;
			y = rnd();
		}
	};
	vector <node> nodes;
	int sz(int ind) {
		if (ind == -1)
			return 0;
		return nodes[ind].sz;
	}
	long long rs(int ind) {
		if (ind == -1)
			return 0;
		return nodes[ind].res_sum;
	}
	void upd(int ind) {
		nodes[ind].sz = nodes[ind].cnt + sz(nodes[ind].lft) + sz(nodes[ind].rgh);
		nodes[ind].res_sum = nodes[ind].val + rs(nodes[ind].lft) + rs(nodes[ind].rgh);
	}
	int merge(int a, int b) {
		if (a == -1 || b == -1)
			return a + b + 1;
		if (nodes[a].y > nodes[b].y) {
			nodes[a].rgh = merge(nodes[a].rgh, b);
			upd(a);
			return a;
		}
		nodes[b].lft = merge(a, nodes[b].lft);
		upd(b);
		return b;
	}
	pair <int, int> split(int ind, long long val) {
		if (ind == -1)
			return { -1, -1 };
		if (nodes[ind].val <= val) {
			auto res = split(nodes[ind].rgh, val);
			nodes[ind].rgh = res.first;
			upd(ind);
			return { ind, res.second };
		}
		auto res = split(nodes[ind].lft, val);
		nodes[ind].lft = res.second;
		upd(ind);
		return { res.first, ind };
	}
	int root = -1;
public:
	dd() {};
	void insert(long long val) {
		auto res = split(root, val);
		if (res.first == -1 || nodes[res.first].val != val) {
			int ind = nodes.size();
			nodes.emplace_back(val, 1);
			res.first = merge(res.first, ind);
		} else {
			++nodes[res.first].cnt;
			upd(res.first);
		}
		root = merge(res.first, res.second);
	}
	long long cntnm(long long val) {
		auto res = split(root, val);
		int res2 = rs(res.first);
		root = merge(res.first, res.second);
		return res2;
	}
};

int n, q;

map <long long, vector <int>> groups;

vector <int> groups2, cntgr;

vector <long long> groups3, gr4;

vector <long long> jng, prefcnt, prefcnt2, prefcnt3;

vector <pair <long long, int>> jng2;

long long first_round = 0;

vector <request> requests;

vector <long long> answers;

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	cin >> n >> q;
	long long c;
	for (int i = 0; i < n; ++i) {
		cin >> c;
		groups[c].push_back(i);
	}
	int ind = 0;
	groups2.resize(n);
	for (auto& el : groups) {
		cntgr.push_back(0);
		for (int ind2 : el.second) {
			groups2[ind2] = ind;
			++cntgr[ind];
		}
		groups3.push_back(el.first);
		++ind;
	}
	jng.resize(ind - 1);
	jng2.resize(ind - 1);
	prefcnt.resize(ind);
	prefcnt2.resize(ind);
	prefcnt3.resize(ind);
	for (int i = 1; i < ind; ++i)
		prefcnt2[i] = cntgr[i - 1] + prefcnt2[i - 1];
	for (int i = ind - 2; i >= 0; --i) {
		jng[i] = groups3[i + 1] - groups3[i];
		jng2[i] = { jng[i], prefcnt2[i + 1] };
		first_round += cntgr[i] * ((long long)(ind - i - 1));
	}
	sort(jng2.begin(), jng2.end());
	for (int i = 1; i < ind; ++i) {
		prefcnt3[i] = prefcnt3[i - 1] + jng2[i - 1].second;
		prefcnt[i] = prefcnt[i - 1] + jng2[i - 1].first * jng2[i - 1].second;
	}
	int t;
	long long k;
	answers.resize(q);
	for (int i = 0; i < q; ++i) {
		cin >> t;
		if (t == 1) {
			cin >> k;
			if (ind == 1) {
				answers[i] = 1;
				continue;
			}
			int lft = -1, rgh = ind - 1, mid;
			while (rgh - lft > 1) {
				mid = (lft + rgh) / 2;
				if (jng2[mid].first <= k)
					lft = mid;
				else
					rgh = mid;
			}
			answers[i] = ind - (lft + 1);
		} else if (t == 2) {
			cin >> k;
			if (ind == 1 || k == 0) {
				answers[i] = 0;
				continue;
			}
			int lft = -1, rgh = ind - 1, mid;
			while (rgh - lft > 1) {
				mid = (lft + rgh) / 2;
				if (jng2[mid].first < k)
					lft = mid;
				else
					rgh = mid;
			}
			long long result;
			if (lft != -1)
				result = first_round * (jng2[lft].first + 1) - prefcnt[lft + 1] + (first_round - prefcnt3[lft + 1]) * (k - (jng2[lft].first + 1));
			else
				result = first_round * k;
			answers[i] = result;
		} else {
			cin >> k;
			int ind;
			cin >> ind;
			ind = groups2[ind - 1];
			requests.emplace_back(i, ind, k);

		}
	}
	sort(requests.begin(), requests.end(), cmp);
	int cur_ind = ind - 1;
	dd ddd;
	for (auto el : requests) {
		while (cur_ind > el.ind)
			ddd.insert(jng[--cur_ind]);
		long long result = ddd.cntnm(el.k);
		result = k * (ind - el.ind) - result;
		answers[el.i] = result + groups3[el.ind];
	}
	for (auto el : answers)
		cout << el << "\n";
}