#include <bits/stdc++.h>
  
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
  
using namespace std;
 
struct fenwick {
    vector<long long> a;
 
    fenwick(int n) {
        a.resize(n);
    }
 
    long long get(int pos) {
        int ans = 0;
        for (; pos >= 0; pos = (pos & (pos + 1)) - 1)
            ans += a[pos];
        return ans;
    }
 
    void update(int pos, long long val) {
        for (; pos < (int) a.size(); pos = (pos + 1) | pos)
            a[pos] += val;
    }
};
 
struct dsu {
    vector<int> p;
    vector<int> who;
 
    dsu(int n) {
        p.resize(n);
        iota(all(p), 0);
    }
 
    int get(int a) {
        if (a == p[a])
            return a;
        return p[a] = get(p[a]);
    }
 
    void merge(int a, int b) {
        a = get(a), b = get(b);
        if (a == b)
            return;
        if (a < b)
            swap(a, b);
        p[b] = a;
    }
};
 
vector<long long> ans_q;
 
void solve_1(vector<long long> d, vector<array<long long, 4>> q) {
    long long ans = d.size() + 1;
    sort(all(d));
    int it = 0;
    for (auto i : q) {
        while (it < (int) d.size() && d[it] <= i[0])
            ++it, --ans;
        if (i[1] == 1)
            ans_q[i[2]] = ans;
    }
}
 
void solve_2(vector<long long> a, vector<array<long long, 4>> q) {
    int n = a.size();
    fenwick f(n);
    long long lst = 0;
    long long inv = 1ll * n * (n - 1) / 2;
    long long tmp = 0;
    vector<pair<long long, int>> d(n - 1);
    for (int i = 0; i < n - 1; ++i) {
        d[i] = {a[i + 1] - a[i], i};
    }
    sort(all(d));
    int it = 0;
    vector<int> now_cnt(n, 1);
    for (int i = 0; i < n; ++i)
        f.update(i, 1);
    dsu c(n);
    for (auto i : q) {
        while (it < (int) d.size() && d[it].first <= i[0]) {
            // cout << d[it].first << ' ' << lst << ;
            int pos1 = c.get(d[it].second);
            int pos2 = c.get(d[it].second + 1);
            c.merge(d[it].second, d[it].second + 1);
            tmp += (d[it].first - lst) * inv;
            inv -= f.get(pos1);
            lst = d[it].first;
            f.update(pos2, now_cnt[pos1]);
            f.update(pos1, -now_cnt[pos1]);
            ++it;
        }
        long long del = i[0] - lst;
        if (i[1] == 2) {
            ans_q[i[2]] = tmp + del * inv;
        }
    }
}
 
int main() {
    #ifndef LOCAL
        ios_base::sync_with_stdio(0);
        cin.tie(0);
    #endif
 
    int n, t;
    cin >> n >> t;
    vector<long long> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    auto _a = a;
    sort(all(a));
    map<long long, int> who;
    for (int i = 0; i < n; ++i)
        who[a[i]] = i;
    vector<long long> d;
    for (int i = 0; i < n - 1; ++i) {
        d.emplace_back(a[i + 1] - a[i]);
    }
    ans_q.resize(t);
    vector<array<long long, 4>> q(t);
    for (int i = 0; i < t; ++i) {
        cin >> q[i][1] >> q[i][0];
        q[i][2] = i;
        if (q[i][1] == 3)
            cin >> q[i][3];
    }
    sort(all(q));
    solve_1(d, q);
    solve_2(a, q);
    {
        fenwick t1(n + 1);
        fenwick t2(n + 1);
        vector<pair<long long, int>> d(n - 1);
        for (int i = 0; i < n - 1; ++i) {
            d[i] = {a[i + 1] - a[i], i};
        }
        sort(all(d));
        int it = 0;
        for (auto i : q) {
            while (it < (int) d.size() && d[it].first <= i[0]) {
                t1.update(d[it].second, 1);
                t2.update(d[it].second, d[it].first);
                ++it;
            }
            if (i[1] == 3) {
                int ind = who[_a[i[3] - 1]];
                int k = t1.get(n) - t1.get(ind);
                long long sum = t2.get(n) - t2.get(ind);
                // cout << _a[i[3] - 1] << ' ' << i[0] * (n - ind - 1) << ' ' << k << ' ' << sum << '\n';
                ans_q[i[2]] = _a[i[3] - 1] + i[0] * (n - ind - 1) - i[0] * k + sum;
            }
        }
    }
    for (auto i : ans_q)
        cout << i << '\n';
}