#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <queue>
#include <set>

/*
4
4 4
1 2
2 3
3 4
4 1
5 5
1 2
2 3
3 4
4 5
5 1
5 6
1 2
3 2
1 3
3 5
5 4
3 4
9 12
1 2
2 3
3 1
4 5
5 6
6 4
7 8
8 9
9 7
3 6
6 9
9 3*/

#define all(x) x.begin(), x.end()

using namespace std;
using ll = long long;

const int MAXN = 500'000;
const int INF = (int)1e9;

vector<int> g[MAXN];

void clear(int n)
{
	for (int i = 0; i < n; ++i)
		g[i].clear();
}

struct position
{
	int boxRoom, robotRoom;
	bool holding = false;

	bool operator<(const position& pos) const
	{
		return make_tuple(boxRoom, robotRoom, holding) < make_tuple(pos.boxRoom, pos.robotRoom, pos.holding);
	}
};

void solve1(int n)
{
	//vector<int> dist(n, INF);
	//dist[0] = 0;
	//queue<pair<int, int>> q = { 0, 0 };
	//while (!q.empty())
	//{
	//	auto [d, u] = q.front();
	//	q.pop();

	//	for (auto v : g[u])
	//	{
	//		if (dist[v] == INF)
	//		{
	//			q.emplace(d + 1, v);
	//			dist[v] = d + 1;
	//		}
	//	}
	//}

	//for (int i = 1; i < n; ++i)
	//	cout << dist[i] * 2 - 1;
}

void solve()
{
	int n = 0, m = 0;
	cin >> n >> m;

	clear(n);

	int u = 0, v = 0;
	for (int i = 0; i < m; ++i)
	{
		cin >> u >> v;
		g[u - 1].push_back(v - 1);
		g[v - 1].push_back(u - 1);
	}

	map<int, int> staying;
	vector<int> ans(n, INF);
	set<pair<int, position>> q;

	vector<set<int>> notTried(n);
	for (int i = 0; i < n; ++i)
		for (auto v : g[i])
			notTried[i].insert(v);

	vector<set<int>> gs = notTried;

	q.insert({ 0, position{ -1, 0, true } });
	set<position> visited;
	while (!q.empty())
	{
		auto [d, pos] = *q.begin();
		q.erase(q.begin());

		if (pos.holding == true)
			ans[pos.robotRoom] = min(ans[pos.robotRoom], d);

		if (pos.holding)
		{
			vector<int> toDel;
			for (auto v : notTried[pos.robotRoom])
			{
				if (v != pos.boxRoom)
				{
					toDel.push_back(v);
					position newPos{ v, pos.robotRoom, false };
					if (!visited.count(newPos))
					{
						q.insert({ d + 1, newPos});
						visited.insert(newPos);
					}
				}
			}

			for (auto v : toDel)
				notTried[pos.robotRoom].erase(v);
		}
		else
		{
			if (gs[pos.robotRoom].count(pos.boxRoom))
			{
				position newPos{ pos.boxRoom, pos.robotRoom, true };
				if (!visited.count(newPos))
				{
					visited.insert(newPos);
					q.insert({ d + 1, newPos });
				}
			}
			for (auto v : g[pos.boxRoom])
			{
				position newPos{ pos.boxRoom, v, false };
				if (!visited.count(newPos))
				{
					q.insert({ d, newPos });
					visited.insert(newPos);
				}
			}
			/*for (auto v : g[pos.robotRoom])
			{
				if (v != pos.boxRoom)
				{
					position newPos{ pos.boxRoom, v, false };
					if (!visited.count(newPos))
					{
						q.insert({ d, newPos });
						visited.insert(newPos);
					}		
				}
			}	*/	
		}
	}

	for (int i = 1; i < n; ++i)
		if (ans[i] != INF)
			cout << ans[i] << " ";
		else
			cout << -1 << " ";
	cout << "\n";
}

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);


	int t = 0;
	cin >> t;

	while (t--)
	{
		solve();
	}

	return  0;
}