#include <iostream>
#include <vector>
#include <algorithm>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
const int N = 3e5 + 5;
vector<pair<int, long long>> x[4 * N];
void build(int v, int l, int r, vector<pair<long long, int>> & t) {
    if (l == r) {
        x[v] = {{t[l].second, t[l].first}};
    } else {
        int md = (l + r) / 2;
        build(2 * v, l, md, t);
        build(2 * v + 1, md + 1, r, t);
        x[v].resize(x[2 * v].size() + x[2 * v + 1].size());
        merge(x[2 * v].begin(), x[2 * v].end(), x[2 * v + 1].begin(), x[2 * v + 1].end(), x[v].begin());
    }
}
void build1(int v, int l, int r) {
    if (l < r) {
        int md = (l + r) / 2;
        build1(2 * v, l, md);
        build1(2 * v + 1, md + 1, r);
        for (int i = x[v].size() - 2; i >= 0; --i)
            x[v][i].second += x[v][i].second;
    }
}
pair<int, long long> get(int v, int l, int r, int c, int tl, int tr) {
    if (tl < r || tr > l)
        return {0, 0};
    if (tl >= l && tr <= r) {
        int i = lower_bound(x[v].begin(), x[v].end(), make_pair(c, 0LL)) - x[v].begin();
        return {x[v].size() - i, x[v][i].second};
    }
    int md = (tl + tr) / 2;
    auto t1 = get(2 * v, l, r, c, tl, md);
    auto t2 = get(2 * v + 1, l, r, c, md + 1, tr);
    return {t1.first + t2.first, t1.second + t2.second};
}
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, q;
    cin >> n >> q;
    vector<pair<long long, int>> a(n), t(n);
    vector<long long> b(n), c(n), d(n);
    vector<int> p(n + 1);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first;
        a[i].second = i + 1;
    }
    sort(a.begin(), a.end());
    for (int i = 0; i < n; ++i)
        p[a[i].second] = i;

    for (int i = 1; i < n; ++i) {
        t[i].first = a[i].first - a[i - 1].first;
        t[i].second = i;
    }
    sort(t.begin(), t.end());
    d[0] = (long long)n * (n - 1) / 2;
    for (int i = 1; i < n; ++i) {
        b[i] = t[i].first;
        d[i] = d[i - 1] - t[i].second;
        c[i] = c[i - 1] + d[i - 1] * (b[i] - b[i - 1]);
    }
    build(1, 0, n - 1, t);
    build1(1, 0, n - 1);

    while (q--) {
        int type, i;
        long long k;
        cin >> type >> k;
        int m = upper_bound(b.begin(), b.end(), k) - b.begin() - 1;
        if (type == 1) {
            cout << n - m << '\n';
        } else if (type == 2) {
            cout << c[m] + d[m] * (k - b[m]) << '\n';
        } else {
            cin >> i;
            i = p[i];
            long long ans = a[i].first + k * (n - i - 1);
            for (int j = 0; j <= m; ++j) {
                if (t[j].second > i) {
                    ans -= k - b[j];
                }
            }
            auto [cnt, res] = get(1, 0, m, i + 1, 0, n - 1);
            ans -= cnt * k - res;
            cout << ans << '\n';
        }
    }
    return 0;
}