#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
using namespace std;
const int N = 5e5 + 5, INF = 1e9;
int fin[N], tin[N], timer;
void dfs(int v, int p, vector<vector<int>> & g, vector<vector<int>> & to, vector<bool> & used) {
    fin[v] = INF;
    tin[v] = ++timer;
    used[v] = true;
    for (auto u : g[v]) {
        if (u != p) {
            if (used[u])
                fin[v] = min(fin[v], tin[u]);
            else {
                to[u].push_back(v);
                to[v].push_back(u);
                dfs(u, v, g, to, used);
                fin[v] = min(fin[v], fin[u]);
            }
        }
    }
}
void solve() {
    timer = 0;
    int n, m;
    cin >> n >> m;
    vector<vector<int>> g(n + 1), t(n + 1);
    vector<bool> used(n + 1);
    vector<vector<vector<int>>> dist(2, vector<vector<int>> (n + 1));
    queue<tuple<int, int, int>> q;
    vector<int> a, count(n + 1, 1);
    count[1] = 0;
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    dfs(1, 0, g, t, used);
    vector<vector<vector<int>>> to(n + 1);
    for (int i = 1; i <= n; ++i) {
        to[i].resize(t[i].size());
        dist[0][i].resize(t[i].size(), INF);
        dist[1][i].resize(t[i].size(), INF);
    }

    for (int i = 1; i <= n; ++i) {
        sort(g[i].begin(), g[i].end(), [](int u, int v) {return tin[u] < tin[v]; });
        int j = 0;
        for (auto u : g[i]) {
            if (fin[u] < tin[i]) {
                to[i][0].push_back(u);
            } else {
                while (j + 1 < t[i].size() && t[i][j + 1] >= u)
                    ++j;
                to[i][j].push_back(u);
            }
        }
    }
    for (int i = 0; i < dist[0][1].size(); ++i) {
        dist[0][1][i] = 0;
        q.push({0, 1, i});
    }
    while (!q.empty()) {
        auto [c, v, i] = q.front();
        q.pop();
        int d1 = dist[c][v][i];
        c ^= 1;
        for (int j = 0; j < to[v].size(); ++j) {
            if (to[v][j].size() > 1) {
                for (auto u: to[v][j]) {
                    if (d1 + 1 < dist[c][u][j]) {
                        dist[c][u][j] = d1 + 1;
                        q.push({c, u, j});
                    }
                }
            }
        }
    }
    for (int i = 2; i <= n; ++i) {
        int x = *min_element(dist[0][i].begin(), dist[0][i].end());
        if (x < INF)
            cout << x << ' ';
        else
            cout << -1 << ' ';
    }
    cout << '\n';
}
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--)
        solve();
    return 0;
}