#include <vector>
#include <iomanip>
#include <iostream>
#include <algorithm>

using namespace std;

int main() {
#ifdef DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#else
  ios::sync_with_stdio(false);
  cin.tie(0);
  cout.tie(0);
#endif

  int n, q;
  cin >> n >> q;
  vector<long long> C(n);
  for (int i = 0; i < n; ++i)
    cin >> C[i];
  vector<int> order(n);
  for (int i = 0; i < n; ++i)
    order[i] = i;
  sort(order.begin(), order.end(), [&C](int a, int b) {
    return C[a] > C[b];
  });
  vector<long long> k(n - 1);
  for (int i = 0; i < n - 1; ++i)
    k[i] = C[order[i]] - C[order[i + 1]];
  vector<int> id(n);
  for (int i = 0; i < n; ++i)
    id[order[i]] = i;
  while (q--) {
    int t;
    cin >> t;
    long long K;
    cin >> K;
    if (t == 1) {
      int ans = n;
      for (int i = 0; i < n - 1; ++i)
        ans -= k[i] <= K;
      cout << ans << '\n';
    } else if (t == 2) {
      long long ans = 0;
      for (int i = 0; i < n - 1; ++i)
        ans += min(k[i], K) * (n - i - 1);
      cout << ans << '\n';
    } else {
      int i;
      cin >> i;
      --i;
      long long ans = C[i];
      for (int j = 0; j < id[i]; ++j)
        ans += min(K, k[j]);
      cout << ans << '\n';
    }
  }
  return 0;
}
