#include <vector>
#include <iomanip>
#include <iostream>
#include <algorithm>

using namespace std;

const int MAXN = 300'300;
pair<long long, long long> fenw[MAXN];

pair<long long, long long> operator +(const pair<long long, long long> &a, const pair<long long, long long> &b) {
  return make_pair(a.first + b.first, a.second + b.second);
}

void add(int i, pair<long long, long long> val) {
  for (; i < MAXN; i = (i | (i + 1)))
    fenw[i] = fenw[i] + val;
}

pair<long long, long long> get(int i) {
  pair<long long, long long> ans(0ll, 0ll);
  for (; i >= 0; i = (i & (i + 1)) - 1)
    ans = ans + fenw[i];
  return ans;
}

int main() {
#ifdef DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#else
  ios::sync_with_stdio(false);
  cin.tie(0);
  cout.tie(0);
#endif

  int n, q;
  cin >> n >> q;
  vector<long long> C(n);
  for (int i = 0; i < n; ++i)
    cin >> C[i];
  vector<int> order(n);
  for (int i = 0; i < n; ++i)
    order[i] = i;
  sort(order.begin(), order.end(), [&C](int a, int b) {
    return C[a] > C[b];
  });
  vector<long long> k(n - 1);
  for (int i = 0; i < n - 1; ++i)
    k[i] = C[order[i]] - C[order[i + 1]];
  vector<int> id(n);
  for (int i = 0; i < n; ++i)
    id[order[i]] = i;
  vector<pair<long long, int>> Q1;
  vector<pair<long long, int>> Q2;
  vector<pair<pair<long long, int>, int>> Q3;
  for (int j = 0; j < q; ++j) {
    int t;
    cin >> t;
    long long K;
    cin >> K;
    if (t == 1) {
      Q1.emplace_back(K, j);
    } else if (t == 2) {
      Q2.emplace_back(K, j);
    } else {
      int i;
      cin >> i;
      --i;
      Q3.emplace_back(make_pair(K, id[i]), j);
    }
  }
  vector<pair<long long, int>> sorted_k(n - 1);
  for (int i = 0; i < n - 1; ++i)
    sorted_k[i] = make_pair(k[i], i);
  sort(sorted_k.begin(), sorted_k.end());
  vector<long long> ans(q);
  {
    sort(Q1.begin(), Q1.end());
    int j = 0;
    for (auto t : Q1) {
      while (j < n - 1 && sorted_k[j].first <= t.first)
        ++j;
      ans[t.second] = n - j;
    }
  }
  {
    sort(Q2.begin(), Q2.end());
    for (int i = 0; i < n - 1; ++i)
      add(i, make_pair(0ll, n - i - 1));
    int j = 0;
    for (auto t : Q2) {
      while (j < n - 1 && sorted_k[j].first <= t.first) {
        add(sorted_k[j].second, make_pair(sorted_k[j].first * (n - sorted_k[j].second - 1), -(n - sorted_k[j].second - 1)));
        ++j;
      }
      auto tmp = get(n - 1);
      ans[t.second] = tmp.first + tmp.second * t.first;
    }
    fill(fenw, fenw + MAXN, make_pair(0ll, 0ll));
  }
  {
    sort(Q3.begin(), Q3.end());
    for (int i = 0; i < n - 1; ++i)
      add(i, make_pair(0ll, 1));
    int j = 0;
    for (auto t : Q3) {
      while (j < n - 1 && sorted_k[j].first <= t.first.first) {
        add(sorted_k[j].second, make_pair(sorted_k[j].first, -1));
        ++j;
      }
      auto tmp = get(t.first.second - 1);
      ans[t.second] = C[order[t.first.second]] + tmp.first + tmp.second * t.first.first;
    }
    fill(fenw, fenw + MAXN, make_pair(0ll, 0ll));
  }
  for (int i = 0; i < q; ++i)
    cout << ans[i] << '\n';
  return 0;
}
