#include <deque>
#include <vector>
#include <iomanip>
#include <iostream>
#include <algorithm>

using namespace std;

const int MAXN = 500'500;
vector<pair<int, int>> G[MAXN];
int tin[MAXN];
int tup[MAXN];
int ttime = 0;
bool bad_vertex[MAXN];
int bad_edge_id[2 * MAXN];
bool cringe[2 * MAXN];
vector<int> stack;
int cur_stack_id[MAXN];
pair<int, int> edges[MAXN];
vector<int> G2[2 * MAXN];
int up_id[MAXN];

void dfs1(int v, int p) {
  up_id[v] = p == -1 ? -1 : (edges[p].first == v ? 2 * p + 1 : 2 * p);
  cur_stack_id[v] = stack.size();
  int cnt = 0;
  tin[v] = tup[v] = ttime;
  ++ttime;
  for (auto t : G[v]) {
    if (t.second == p)
      continue;
    if (tin[t.first] == -1) {
      int id = edges[t.second].first == v ? 2 * t.second + 1 : 2 * t.second;
      stack.emplace_back(id);
      dfs1(t.first, t.second);
      stack.pop_back();
      if (tup[t.first] >= tin[v]) {
        bad_vertex[v] = true;
        cringe[id] = true;
      }
      tup[v] = min(tup[v], tup[t.first]);
      ++cnt;
    } else {
      tup[v] = min(tup[v], tin[t.first]);
      if (cur_stack_id[t.first] != -1) {
        if (edges[t.second].first == v) {
          bad_edge_id[2 * t.second] = stack[cur_stack_id[t.first]];
          bad_edge_id[2 * t.second + 1] = up_id[v];
        } else {
          bad_edge_id[2 * t.second] = up_id[v];
          bad_edge_id[2 * t.second + 1] = stack[cur_stack_id[t.first]];
        }
      }
    }
  }
  cur_stack_id[v] = -1;
}

int dp[2 * MAXN];
bool check_left[MAXN];
bool check_right[MAXN];
bool check_bad_edge[2 * MAXN];

const int INF = 1e9;

void solve() {
  int n, m;
  cin >> n >> m;
  for (int i = 0; i < m; ++i) {
    int a, b;
    cin >> a >> b;
    --a; --b;
    edges[i] = make_pair(a, b);
    G[a].emplace_back(b, i);
    G[b].emplace_back(a, i);
    bad_edge_id[2 * i + 0] = 2 * i + 0;
    bad_edge_id[2 * i + 1] = 2 * i + 1;
  }
  ttime = 0;
  fill(tin, tin + n, -1);
  fill(bad_vertex, bad_vertex + n, false);
  fill(cur_stack_id, cur_stack_id + n, -1);
  fill(cringe, cringe + 2 * m, false);
  dfs1(0, -1);
  for (int i = 0; i < m; ++i) {
    if (!bad_vertex[edges[i].first])
      bad_edge_id[2 * i + 1] = -1;
    else {
      if (!cringe[bad_edge_id[2 * i + 1]])
        bad_edge_id[2 * i + 1] = up_id[edges[i].first];
    }
    if (!bad_vertex[edges[i].second])
      bad_edge_id[2 * i + 0] = -1;
    else {
      if (!cringe[bad_edge_id[2 * i + 0]])
        bad_edge_id[2 * i + 0] = up_id[edges[i].second];
    }
  }
  for (int i = 0; i < 2 * m; ++i)
    G2[bad_edge_id[i]].emplace_back(i);
  fill(dp, dp + 2 * m, INF);
  fill(check_left, check_left + n, false);
  fill(check_right, check_right + n, false);
  fill(check_bad_edge, check_bad_edge + 2 * m, false);
  deque<int> Q;
  for (int i = 0; i < m; ++i) {
    if (edges[i].first == 0) {
      dp[2 * i + 0] = 1;
      Q.emplace_back(2 * i + 0);
    }
    if (edges[i].second == 0) {
      dp[2 * i + 1] = 1;
      Q.emplace_back(2 * i + 1);
    }
  }
  while (!Q.empty()) {
    int id = Q.front();
    Q.pop_front();
    int v, u;
    if (id % 2 == 0)
      v = edges[id / 2].first, u = edges[id / 2].second;
    else
      v = edges[id / 2].second, u = edges[id / 2].first;
    if (!check_left[v]) {
      for (auto t : G[v]) {
        int id2 = edges[t.second].first == v ? 2 * t.second : 2 * t.second + 1;
        if (dp[id2] > dp[id] + 2) {
          dp[id2] = dp[id] + 2;
          Q.emplace_back(id2);
        }
      }
      check_left[v] = true;
    }
    if (!bad_vertex[u]) {
      if (!check_right[u]) {
        for (auto t : G[u]) {
          int id2 = edges[t.second].first == u ? 2 * t.second + 1 : 2 * t.second;
          if (dp[id2] > dp[id]) {
            dp[id2] = dp[id];
            Q.emplace_front(id2);
          }
        }
        check_right[u] = true;
      }
    } else {
      if (!check_bad_edge[bad_edge_id[id]]) {
        for (auto id2 : G2[bad_edge_id[id]]) {
          if (dp[id2] > dp[id]) {
            dp[id2] = dp[id];
            Q.emplace_front(id2);
          }
        }
        check_bad_edge[bad_edge_id[id]] = true;
      }
    }
  }
  vector<int> ans(n, INF);
  for (int i = 0; i < m; ++i) {
    ans[edges[i].first] = min(ans[edges[i].first], dp[2 * i + 0] + 1);
    ans[edges[i].second] = min(ans[edges[i].second], dp[2 * i + 1] + 1);
  }
  for (int i = 1; i < n; ++i)
    cout << (ans[i] == INF ? -1 : ans[i]) << ' ';
  cout << '\n';
  for (int i = 0; i < n; ++i)
    G[i].clear();
  for (int i = 0; i < 2 * m; ++i)
    G2[i].clear();
}

int main() {
#ifdef DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#else
  ios::sync_with_stdio(false);
  cin.tie(0);
  cout.tie(0);
#endif

  int t;
  cin >> t;
  while (t--) {
    solve();
  }
  return 0;
}
