#include <bits/stdc++.h>
#include <cassert>

#define F first
#define S second

using namespace std;
using ll = long long;
using pi = pair<int, int>;
using vi = vector<int>;

struct Dsu {
    vector<int> c, p;

    Dsu(int n) : c(n, 1), p(n) {
        iota(p.begin(), p.end(), 0);
    }

    int root(int v) {
        return p[v] == v ? v : p[v] = root(p[v]);
    }

    bool unite(int a, int b) {
        a = root(a);
        b = root(b);

        if (a == b) {
            return false;
        } else {
            if (c[a] < c[b]) swap(a, b);
            p[b] = a;
            c[a] += c[b];
            return true;
        }
    }
};

struct Query {
    ll k;
    int t, i, id;
};

const int V = 2e7;

struct Node {
    ll a0, dx;
    int l, r;
} nd[V];

int rt = -1; 
int vc = 0;

void add(int& v, ll vl, ll vr, ll l, ll r, ll a0, ll dx) {
    if (r <= vl || vr <= l) return;

    if (v < 0) {
        v = vc++;
        nd[v].a0 = 0;
        nd[v].dx = 0;
        nd[v].l = nd[v].r = -1;
    }

    if (l <= vl && vr <= r) {
        nd[v].a0 += a0;
        nd[v].dx += dx;
    } else {
        ll vm = (vl + vr) / 2;
        add(nd[v].l, vl, vm, l, r, a0, dx);
        add(nd[v].r, vm, vr, l, r, a0, dx);
    }
}

ll get_value(int v, ll vl, ll vr, ll i) {
    if (v < 0) return 0;
    ll res = i * nd[v].dx + nd[v].a0;

    if (vl + 1 != vr) {
        ll vm = (vl + vr) / 2;
        if (i < vm) res += get_value(nd[v].l, vl, vm, i);
        else        res += get_value(nd[v].r, vm, vr, i);
    }

    return res;
}

void solve() {
    int n, q; cin >> n >> q;

    vector<ll> c(n), dt;
    for (ll& x : c) cin >> x;
    
    auto c0 = c;
    sort(c0.begin(), c0.end());
    for (int i = 0; i + 1 < n; ++i) dt.push_back(c0[i+1] - c0[i]);
    sort(dt.begin(), dt.end());

    vector<Query> q2, q3;
    vector<ll> ans(q, -1);
    Dsu dsu(n);

    for (int i = 0; i < q; ++i) {
        ll k;
        int t, j; cin >> t >> k;

        if (t == 1) {
            ans[i] = n - (upper_bound(dt.begin(), dt.end(), k) - dt.begin());
        } else {
            if (t == 3) cin >> j, j--;

            if (t == 2) q2.push_back(Query { k, t, j, i });
            if (t == 3) q3.push_back(Query { k, t, j, i });
        }
    }

    if (!q2.empty()) {
        sort(q2.begin(), q2.end(), [&](const Query& l, const Query& r) {
            return l.k < r.k;
        });

        vector<int> ord(n-1);
        iota(ord.begin(), ord.end(), 0);
        sort(ord.begin(), ord.end(), [&](int l, int r) { return c0[l+1] - c0[l] < c0[r+1] - c0[r]; });

        auto it = ord.begin();
        ll k0 = 0, s0 = 0, a = (ll)n*(n-1)/2;

        for (auto [k, _t, _i, id] : q2) {
            while (it != ord.end() && c0[*it+1] - c0[*it] < k) {
                const ll kk = c0[*it+1] - c0[*it];
                s0 += (kk - k0) * a;
                k0 = kk;
                a -= *it+1;

                ++it;
            }

            ans[id] = s0 + (k - k0) * a;
        }
    }

    if (!q3.empty()) {
        const ll k0 = 1e12+1;

        vector<int> ord(n), _pos(n);
        iota(ord.begin(), ord.end(), 0);
        sort(ord.begin(), ord.end(), [&] (int l, int r) { return c[l] > c[r]; });
        for (int i = n; i--; ) _pos[ord[i]] = i;
        for (auto& [k, _t, i, id] : q3) i = _pos[i];
        sort(q3.begin(), q3.end(), [&](const Query& l, const Query& r) { return l.i < r.i; });

        int j = 0;
        for (const auto& [k, _t, i, id] : q3) {
            while (j < i) {
                ++j;
                const ll dx = c[ord[j-1]] - c[ord[j]];
                add(rt, 0, k0, 0, dx, -dx, +1);
            }

            ans[id] = get_value(rt, 0, k0, k) + c0.back();
        }
    }
    
    for (auto x : ans) cout << x << '\n';
}

int main() {
    ios::sync_with_stdio(0); cin.tie(0);

    int t = 1;
    // cin >> t;
    while (t--) solve();
}