#include <bits/stdc++.h>

#define F first
#define S second

using namespace std;
using ll = long long;
using pi = pair<int, int>;
using vi = vector<int>;

struct Dsu {
    vector<int> p, c;
    vector<pair<int*, int>> hist;
    vector<int> mark;

    Dsu(int n) : p(n), c(n, 1) {
        iota(p.begin(), p.end(), 0);
    }

    int root(int v) {
        while (v != p[v]) v = p[v];
        return v;
    }

    bool unite(int a, int b) {
        a = root(a);
        b = root(b);
        if (a != b) {
            if (c[a] < c[b]) swap(a, b);
            
            save(&p[b]);
            save(&c[a]);
            
            p[b] = a;
            c[a] += c[b];

            return true;
        } else {
            return false;
        }
    }

    void save(int* x) {
        hist.emplace_back(x, *x);
    }

    void save() {
        mark.push_back(hist.size());
    }

    void load() {
        while (hist.size() > mark.back()) {
            auto [p, x] = hist.back(); hist.pop_back();
            *p = x;
        }
        mark.pop_back();
    }

};

struct Solve {
    int n, m, vc, gt;
    vector<vi> g;
    vector<vi> gg;
    Dsu dsu;

    vector<int> v0;

    void check(int l, int r) {
        if (l + 1 == r) {
            map<int, int> ids;
            const int v = l;
            for (int to : g[v]) {
                const int id = dsu.root(to);
                if (!ids.count(id)) {
                    ids[id] = vc++;
                    v0.push_back(v);
                    gg.emplace_back();
                }

                gg[to].push_back(ids[id]);
                gg[ids[id]].push_back(to);
            }
        } else {
            int m = (l + r) / 2;

            dsu.save();
            for (int i = l; i < m; ++i) {
                for (int u : g[i]) {
                    if (u < m || u >= r) dsu.unite(i, u);
                }
            }
            check(m, r);
            dsu.load();

            dsu.save();
            for (int i = m; i < r; ++i) {
                for (int u : g[i]) {
                    if (u < l || u >= m) dsu.unite(i, u);
                }
            }
            check(l, m);
            dsu.load();
        }
    }

    Solve(int n0, int m0) : n(n0), m(m0), g(n0), dsu(n0), gt(n0), gg(n0) {
        for (int i = 0; i < m; ++i) {
            int a, b; cin >> a >> b;
            g[a-1].push_back(b-1);
            g[b-1].push_back(a-1);
        }

        vc = n;
        v0.resize(n);
        iota(v0.begin(), v0.end(), 0);
        gt = 0;

        check(0, n);
    }

    vector<int> get_answer() {
        vector<int> ans(n, -1);
        vector<int> dist(vc, -1);

        dist[0] = 0;
        queue<int> q; q.push(0);
        
        while (!q.empty()) {
            int v = q.front(); q.pop();
            for (int to : gg[v]) {
                if (dist[to] == -1) {
                    q.push(to);
                    dist[to] = dist[v] + 1;
                }
            }
        }

        dist.resize(n);
        dist.erase(dist.begin());
        return dist;
    }
};

void solve() {
    int n, m; cin >> n >> m;
    Solve sol(n, m);
    auto ans = sol.get_answer();

    for (int x : ans) cout << x << ' '; cout << '\n';
}

int main() {
    ios::sync_with_stdio(0); cin.tie(0);

    int t = 1;
    cin >> t;
    while (t--) solve();
}