#include <bits/stdc++.h>

using namespace std;

using ll = long long;

const int MAXN = 5e5 + 10;

int timer = 0;
vector<int> g[MAXN];
set<int> banned, banned2;
vector<int> used(MAXN, 0), dist(MAXN, INT_MAX), ans(MAXN, INT_MAX);
vector<int> tin(MAXN, 0), dp_up(MAXN, 0);

void dfs(int v, int prev = -1) {
    if (used[v]) {
        return;
    }

    used[v] = true;
    tin[v] = timer;
    dp_up[v] = timer;
    timer++;
    for (int u : g[v]) {
        if (prev == u) {
            continue;
        }

        if (!used[u]) {
            dfs(u, v);
            dp_up[v] = min(dp_up[v], dp_up[u]);

            if (dp_up[u] >= tin[v]) {
                banned2.insert(v); // vertex banned
            }

            if (dp_up[u] >= tin[u]) {
                banned.insert(u); // edge banned
            }
        } else {
            dp_up[v] = min(dp_up[v], tin[u]);
        }
    }


}

int32_t main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);


    int t;
    cin >> t;

    set<pair<ll, ll>> q;
    while (t--) {
        int n, m;
        cin >> n >> m;

        timer = 0;
        banned.clear();
        banned2.clear();
        for (int i = 0; i < n; i++) {
            g[i].clear();
            used[i] = false;
            dist[i] = INT_MAX;
            ans[i] = INT_MAX;
        }

        for (int i = 0; i < m; i++) {
            int u, v;
            cin >> u >> v;

            u--;
            v--;

            g[u].push_back(v);
            g[v].push_back(u);
        }

        dfs(0);

        dist[0] = 0;
        ans[0] = 0;
        q.clear();
        q.insert({0, 0});

        while (!q.empty()) {
            auto [d, v] = *q.begin();
            q.erase(q.begin());

            if (banned.find(v) != banned.end()) {
                continue;
            }

            for (int u : g[v]) {
                if (dist[u] > d + 1) {
                    dist[u] = d + 1;

                    //bool check = banned2.find(u) != banned2.end();

                    for (int k : g[u]) {
                        if (dp_up[k] > tin[u]) {
                            continue;
                        }

                        if (ans[k] > dist[u] + 1) {
                            q.erase({ans[k], k});
                            ans[k] = dist[u] + 1;
                            q.insert({dist[u] + 1, k});
                        }
                    }
                }
            }
        }


        for (int i = 1; i < n; i++) {
            cout << (ans[i] == INT_MAX ? -1 : ans[i]) << " ";
        }
        cout << endl;
    }


    return 0;
}