﻿#include <iostream>
#include <fstream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <queue>
#include <math.h>
using namespace std;

using s64 = long long;
using ld = long double;

#define all(obj) obj.begin(), obj.end()

s64 cast(string s) {
	reverse(all(s));
	ld n = 0;
	for (char c : s) {
		n *= 10;
		n += c - '0';
	}
	return n;
}

s64 epow(s64 a, s64 n) {
	if (n == 0) {
		return 1;
	}
	else {
		s64 z = epow(a, n / 2);
		z *= z;
		if (n & 1) {
			z *= a;
		}
		return z;
	}
}

void solve(istream& cin) {
	string s;
	cin >> s;
	reverse(all(s));
	int n = s.size();
	s64 y;
	cin >> y;
	while (true) {
		vector<pair<s64, string>> next;
		for (int i = 0; i < n; i++) {
			string t = s;
			for (int j = i; j + 1 < n && t[j] != t[j + 1] && j - i < 10; j++) {
				swap(t[j], t[j + 1]);
				if (t[j] < t[j + 1]) {
					s64 old = cast(s.substr(i, j - i + 2));
					s64 cur = cast(t.substr(i, j - i + 2));

					next.push_back({ (cur - old) * epow(10, i) - y * (j - i + 1), t });
				}
			}
		}
		sort(all(next));
		if (next.empty() || next.back().first < 0) {
			break;
		}
		s = next.back().second;
	}
	reverse(all(s));
	cout << s << "\n";
}

int main() {
	//ifstream cin("input.txt");

	solve(cin);

	return 0;
}