﻿#include <iostream>
#include <fstream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <math.h>
using namespace std;

using s64 = long long;
using ld = long double;

#define all(obj) obj.begin(), obj.end()

int main() {
	//ifstream cin("input.txt");
	
	int n, q;
	cin >> n >> q;
	vector<s64> c(n);
	vector<int> p(n);
	{
		for (int i = 0; i < n; i++) {
			cin >> c[i];
			p[i] = i;
		}
		sort(all(p), [&](int lhs, int rhs) {
			return c[lhs] < c[rhs];
			});
		vector<int> t(n);
		for (int i = 0; i < n; i++) {
			t[p[i]] = i;
		}
		p = t;
	}

	vector<vector<s64>> dp;
	vector<s64> cnt;

	// build O(n^2)
	{
		auto s = c;
		sort(all(s));
		s64 k = 0;
		while (true) {
			dp.push_back(s);
			cnt.push_back(k);
			int best = -1;
			for (int i = 0; i + 1 < n; i++) {
				if (s[i] != s[i + 1]) {
					if (best == -1 || s[i + 1] - s[i] < s[best + 1] - s[best]) {
						best = i;
					}
				}
			}

			if (best == -1) {
				break;
			}

			s64 d = s[best + 1] - s[best];
			k += d;
			int cnt = 0;
			for (int i = n - 1; i >= 0; i--) {
				s[i] += d * cnt;
				if (i > 0 && s[i] - d * cnt != s[i - 1]) {
					cnt++;
				}
			}
		}
	}

	// O(n)
	auto get = [&](s64 k) {
		int i;
		for (i = 1; i < cnt.size() && k >= cnt[i]; i++) {}
		i--;
		auto s = dp[i];
		k -= cnt[i];
		{
			s64 d = k;
			int cnt = 0;
			for (int i = n - 1; i >= 0; i--) {
				s[i] += d * cnt;
				if (i > 0 && s[i] - d * cnt != s[i - 1]) {
					cnt++;
				}
			}
		}
		return s;
	};

	vector<s64> z;
	int sz_diff = 0;
	{
		auto s = c;
		sort(all(s));
		s.erase(unique(all(s)), s.end());
		sz_diff = s.size();
		for (int i = 0; i + 1 < s.size(); i++) {
			z.push_back(s[i + 1] - s[i]);
		}
		sort(all(z));
	}

	while (q--) {
		int t;
		s64 k;
		cin >> t >> k;
		if (t == 1) { // O(log n)
			cout << sz_diff - (upper_bound(all(z), k) - z.begin()) << "\n";
		}
		else if (t == 2) {
			auto s = get(k);

			s64 sum = 0;
			for (int i = 0; i < n; i++) {
				sum += s[i] - c[i];
			}
			cout << sum << "\n";
		}
		else {
			int i;
			cin >> i;
			i--;

			auto s = get(k);

			cout << s[p[i]] << "\n";
		}
	}

	return 0;
}