﻿#include <iostream>
#include <fstream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <math.h>
using namespace std;

using s64 = long long;
using ld = long double;

#define all(obj) obj.begin(), obj.end()

int main() {
	//ifstream cin("input.txt");
	
	int n, q;
	cin >> n >> q;
	vector<s64> c(n);
	vector<int> p(n);
	{
		for (int i = 0; i < n; i++) {
			cin >> c[i];
			p[i] = i;
		}
		sort(all(p), [&](int lhs, int rhs) {
			return c[lhs] < c[rhs];
			});
		vector<int> t(n);
		for (int i = 0; i < n; i++) {
			t[p[i]] = i;
		}
		p = t;
	}

	vector<s64> z;
	int sz_diff = 0;
	{
		auto s = c;
		sort(all(s));
		s.erase(unique(all(s)), s.end());
		sz_diff = s.size();
		for (int i = 0; i + 1 < s.size(); i++) {
			z.push_back(s[i + 1] - s[i]);
		}
		sort(all(z));
	}

	struct query {
		int t;
		s64 k;
		int i;
		int id;
		s64 ans;

		bool operator < (const query& Rhs) const {
			return k < Rhs.k;
		}
	};
	vector<query> qs(q);
	for (int i = 0; i < q; i++) {
		int t;
		s64 k;
		cin >> t >> k;
		qs[i] = { t, k, -1, i};

		if(t == 3) {
			int pos;
			cin >> pos;
			pos--;
			qs[i].i = p[pos];
		}
	}
	sort(all(qs));

	sort(all(c));
	s64 cur_k = 0;
	s64 cur_sum = 0;
	s64 cur_g = 0;
	vector<s64> cur_cnt(n);
	auto fixed = [&](s64 k) {
		while (cur_k < k) {
			int best = -1;
			for (int i = 0; i + 1 < n; i++) {
				if (c[i] != c[i + 1]) {
					if (best == -1 || c[i + 1] - c[i] < c[best + 1] - c[best]) {
						best = i;
					}
				}
			}

			if (best == -1) {
				break;
			}

			s64 d = c[best + 1] - c[best];
			if (d + cur_k > k) {
				break;
			}
			cur_k += d;
			int cnt = 0;
			for (int i = n - 1; i >= 0; i--) {
				c[i] += d * cnt;
				cur_sum += d * cnt;
				cur_cnt[i] = cnt;
				if (i > 0 && c[i] - d * cnt != c[i - 1]) {
					cnt++;
				}
			}

			{
				cur_g = 0;
				vector<s64> g;
				int cnt = 0;
				s64 prev = c[0];
				for (int i = 0; i < n; i++) {
					if (prev != c[i]) {
						g.push_back(cnt);
						prev = c[i];
						cnt = 0;
					}
					cnt++;
				}
				g.push_back(cnt);
				reverse(all(g));
				for (int i = 0; i < g.size(); i++) {
					cur_g += i * g[i];
				}
			}
		}
	};

	// O(n^2 + q)

	for (auto& [t, k, i, id, ans] : qs) {
		fixed(k);
		if (t == 1) {
			ans = sz_diff - (upper_bound(all(z), k) - z.begin());
		}
		else if(t == 2) {
			s64 d = k - cur_k;
			ans = cur_sum + cur_g * d;
		}
		else {
			s64 d = k - cur_k;
			ans = c[i] + d * cur_cnt[i];
		}
	}
	
	sort(all(qs), [&](auto lhs, auto rhs) {
		return lhs.id < rhs.id;
	});
	for (auto it : qs) {
		cout << it.ans << "\n";
	}

	return 0;
}