#include <iostream>
#include <algorithm>
#include <bitset>
#include <vector>
#include <string>
#include <cstring>
#include <array>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <cmath>
#include <random>
#include <chrono>
#define ar array
#define int ll
using namespace std;
typedef long long ll;
typedef long double ld;
const int N = 3e5 + 5;

struct dsu {
	vector<int> p, sz;
	vector<ar<int, 2>> rng;
	int n;
	dsu(int n) : n(n) {
		p.resize(n);
		sz.assign(n, 1);
		rng.resize(n);
		for (int i = 0; i < n; ++i) {
			p[i] = i;
			rng[i] = { i,i };
		}
	}
	int get(int a) {
		return p[a] = (p[a] == a ? a : get(p[a]));
	}
	bool unite(int a, int b) {
		a = get(a), b = get(b);
		if (a == b) return 0;
		if (sz[a] > sz[b]) swap(a, b);
		p[a] = b, sz[b] += sz[a];
		rng[b] = { min(rng[a][0],rng[b][0]),max(rng[a][1],rng[b][1]) };
		return 1;
	}
};

struct fenw {
	vector<ll> f1, f2;
	int n;
	fenw(int n) : n(n) {
		f1.assign(n + 1, 0);
		f2 = f1;
	}
	void add(vector<ll> &f, int p, ll x) {
		for (++p; p <= n; p += (p & -p)) {
			f[p] += x;
		}
	}
	void rng_add(int l, int r, ll x) {
		add(f1, l, x), add(f1, r, -x);
		add(f2, l, x * l), add(f2, r, -x * r);
	}
	ll sum(int p) {
		int p1 = p;
		ll ans = 0;
		for (; p; p -= (p & -p)) {
			ans += f1[p] * p1 - f2[p];
		}
		return ans;
	}
	ll get(int p) {
		return sum(p + 1) - sum(p);
	}
};

int n, q, st_cmp[N], pos[N];
ll c[N], ans[N];
vector<ll> qs[N];

void solve() {
	cin >> n >> q;
	vector<ar<ll, 2>> sc;
	for (int i = 0; i < n; ++i) {
		cin >> c[i];
		sc.push_back({ c[i],i });
	}
	sort(sc.begin(), sc.end());
	for (int i = 0; i < n; ++i) {
		pos[sc[i][1]] = i;
		c[i] = sc[i][0];
	}
	sc.clear();

	dsu cmp(n);
	vector<ar<ll, 2>> un;
	for (int i = 0; i < n - 1; ++i) {
		if (c[i] == c[i + 1]) {
			cmp.unite(i, i + 1);
		}
		else {
			un.push_back({ c[i + 1] - c[i],i });
		}
	}
	sort(un.begin(), un.end());
	int cur = 0;
	st_cmp[0] = 0;
	for (int i = 1; i < n; ++i) {
		if (c[i - 1] != c[i]) {
			++cur;
			st_cmp[i] = cur;
		}
	}

	for (int i = 0; i < q; ++i) {
		int t; cin >> t;
		ll k; cin >> k;
		if (t == 1) {
			qs[i] = { k,i,t };
		}
		else if (t == 2) {
			qs[i] = { k,i,t };
		}
		else {
			int idx;
			cin >> idx; --idx;
			qs[i] = { k,i,t,pos[idx] };
		}
	}
	sort(qs, qs + q);

	ll add_exp = 0;
	int temp_cmp = (int)un.size() + 1;
	for (int i = 0; i < n; ++i) {
		if (cmp.get(i) == i) {
			add_exp += ll(cmp.sz[i]) * (temp_cmp - 1);
			--temp_cmp;
		}
	}

	ll prev_k = 0, prev_un = 0, added = 0;
	int un_ptr = 0, cmp_cnt = (int)un.size() + 1, g = cmp_cnt;
	fenw dk_cnt(n), dk_sum(n);

	for (int i = 0; i < q; ++i) {
		ll k = qs[i][0];
		int idx = qs[i][1];
		while (un_ptr < (int)un.size() && un[un_ptr][0] <= k) {
			int j = un[un_ptr][1], R = cmp.rng[cmp.get(j)][1] + 1;
			dk_cnt.rng_add(0,R,1);
			dk_sum.rng_add(0,R,un[un_ptr][0]);
			added += add_exp * (un[un_ptr][0] - prev_un);
			add_exp -= R;
			prev_un = un[un_ptr][0];
			cmp.unite(j, j + 1);
			--cmp_cnt;
			++un_ptr;
		}
		if (qs[i][2] == 1) {
			ans[idx] = cmp_cnt;
		}
		else if (qs[i][2] == 2) {
			ans[idx] = added + add_exp * (k - prev_un);
		}
		else {
			int j = qs[i][3], dk_j = dk_cnt.get(j);
			ans[idx] = c[j] + ll(g - 1 - st_cmp[j] - dk_j) * k + dk_sum.get(j);
		}
		prev_k = k;
	}
	for (int i = 0; i < q; ++i) {
		cout << ans[i] << "\n";
	}
}

void clear() {
}
signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int t = 1;
	while (t--) {
		solve();
		clear();
		cout << "\n";
	}
}

/*

5 5
1 1 5 8 10
3 100 1
3 10 2
3 10 3
3 10 4
3 10 5

*/