#define wv(x) {cout << (#x) << ' '; for (auto i : x) cout << i << ' '; cout << endl;}
#define forn(i, n) for (int i = 0; i < n; i++)
#include <iostream>
#include <vector>
#include <algorithm>
#include <fstream>
#include <string>
#include <map>
#include <set>
#include <cmath>
using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef vector <ll> vi;
typedef vector <vi> vvi;
typedef pair <ll, ll> ii;
typedef vector <ii> vii;
typedef vector <vii> vvii;
typedef pair <ll, ii> iii;

ll INF = 2e9;
int n, q;

struct node
{
    ll summ = 0, val = 0, t = 0;
    vi ups;
    bool nr = false;
};
vector <node> tree;
vi norm;

void push(int p, int l, int r)
{
    if (tree[p].nr == 0)
    {
        tree[p].ups.clear();
        return;
    }
    if (l == r)
    {
        for (auto i : tree[p].ups)
        {
            tree[p].summ += (i - tree[p].t) * tree[p].val;
            tree[p].t = i;
            tree[p].val--;
        }
        tree[p].ups.clear();
        return;
    }
    for (auto i : tree[p].ups)
    {
        if (tree[2*p].nr)
            tree[2*p].ups.push_back(i);
        if (tree[2*p+1].nr)
            tree[2*p+1].ups.push_back(i);
    }
    tree[p].ups.clear();
}

void assig(int p, int l, int r, int ind, ll val)
{
    if (l == r)
    {
        tree[p].val = val;
        if (norm[l])
            tree[p].nr = 1;
        return;
    }
    int mid = (l + r)/2;
    if (mid >= ind)
        assig(2*p, l, mid, ind, val);
    else
        assig(2*p+1, mid+1, r, ind, val);
    tree[p].nr = (tree[2*p].nr||tree[2*p+1].nr);
}

void update(int p, int l, int r, int a, int b, ll t)
{
    if (b < l || r < a)
        return;
    push(p, l, r);
    if (a <= l && r <= b)
    {
        tree[p].ups.push_back(t);
        push(p, l, r);
        return;
    }
    int mid = (l + r)/2;
    update(2*p, l, mid, a, b, t);
    update(2*p+1, mid+1, r, a, b, t);
}

ll get(int p, int l, int r, int ind, ll t)
{
    push(p, l, r);
    if (l == r)
    {
        return tree[p].summ + tree[p].val * (t-tree[p].t);
    }
    int mid = (l+r)/2;
    if (mid >= ind)
        return get(2*p, l, mid, ind, t);
    return get(2*p+1, mid+1, r, ind, t);

}

void solve()
{
    cin >> n >> q;
    vii c(n);
    forn(i, n) {
        cin >> c[i].first;
        c[i].second = i;
    }
    sort(c.begin(), c.end());
    vi a(n);
    vi pos(n);
    forn(i, n)
    {
        a[i] = c[i].first;
        pos[c[i].second] = i;
    }
    vvi events;
    for (int i = 1;i < n; i++)
    {
        events.push_back({a[i]-a[i-1], 0, i, 0});
    }
    norm.resize(n);
    forn(_, q)
    {
        ll t, k;
        cin >>t >> k;
        if (t == 1)
        {
            events.push_back({k, 1, 0, _});
        }
        else if (t == 2)
        {
            events.push_back({k, 2, 0, _});
        }
        else
        {
            int ind;
            cin >> ind;
            events.push_back({k, 3, ind, _});
            norm[pos[ind-1]] = 1;
        }
    }
    sort(events.begin(), events.end());
    /*for (auto i : events)
    {
        cout << i[0] << ' ' << i[3] << endl;
    }
    cout << endl;*/
    tree.resize(4*n);
    ll cou = 0;
    ll dob = 0;
    for (int i = n-1; i >= 0;i--)
    {
        dob += cou++;
        assig(1, 0, n-1, i, cou-1);
    }
    ll last = 0;
    ll summ = 0;
    ll kolvo = n;
    vii ans;
    for (auto ev : events)
    {
        int ty = ev[1];
        ll t = ev[0];
        int ind = ev[2];
        int ind2 = ev[3];
        summ += dob*(t-last);
        last = t;
        if (ty == 0)
        {
            dob -= ind;
            update(1, 0, n-1, 0, ind-1, t);
            kolvo--;
        }
        else if (ty == 1)
        {
            ans.push_back({ind2, kolvo});
        }
        else if (ty == 2)
        {
            ans.push_back({ind2, summ});
        }
        else
        {
            ans.push_back({ind2, a[pos[ind-1]] + get(1, 0, n-1, pos[ind-1], t)});
        }
    }
    sort(ans.begin(), ans.end());
    for (auto i : ans)
        cout << i.second << endl;
    cout << endl;


    return;
}

int main() {
    //freopen("input.txt", "r", stdin);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    solve();

    return 0;
}