//#define _CRT_SECURE_NO_WARNINGS
//#pragma GCC target ("avx,avx2,sse,sse2,sse3,sse4,fma,popcnt")
//#pragma GCC optimize ("-Ofast,unroll-loops,fast-math")
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <sstream>
#include <random>
#include <map>
#include <set>
#include <array>

using namespace std;

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

const int INF = 2e9;
vector<vector<int>> gr;

int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int t;
	cin >> t;
	while (t--) {
		int n, m;
		cin >> n >> m;
		gr.assign(n, {});
		for (int i = 0; i < m; ++i) {
			int u, v;
			cin >> u >> v;
			--u, --v;
			gr[u].push_back(v);
			gr[v].push_back(u);
		}
		vector<int> up(n, INF), used(2 * n);
		vector<pair<int, int>> dwn(n, { INF, -1 });
		up[0] = 0;
		set<pair<int, int>> sup, sdwn;
		sup.emplace(0, 0);
		sdwn.emplace(INF, 0);
		for (int i = 1; i < n; ++i) {
			sup.emplace(INF, i);
			sdwn.emplace(INF, i);
		}
		sup.emplace(INF, -1);
		sdwn.emplace(INF, -1);
		for (int i = 0; i < 2 * n; ++i) {
			int u1 = sup.begin()->second, u2 = sdwn.begin()->second;
			if ((u1 == -1 || up[u1] == INF) && (u2 == -1 || dwn[u2].first == INF))
				break;
			if (u2 == -1 || dwn[u2].first == INF || u1 != -1 && up[u1] <= dwn[u2].first) {
				used[u1] = 1;
				sup.erase(sup.begin());
				for (int v : gr[u1])
					if (dwn[v].first > up[u1] + 1) {
						sdwn.erase(make_pair(dwn[v].first, v));
						dwn[v] = { up[u1] + 1, u1 };
						sdwn.emplace(dwn[v].first, v);
					}
			}
			else {
				used[u2 + n] = 1;
				sdwn.erase(sdwn.begin());
				for (int v : gr[u2])
					if (up[v] > dwn[u2].first + 1) {
						sup.erase(make_pair(up[v], v));
						up[v] = dwn[u2].first + 1;
						sup.emplace(up[v], v);
					}
			}
		}
		for (int i = 1; i < n; ++i) {
			if (up[i] == INF)
				cout << "-1 ";
			else
				cout << up[i] << ' ';
		}
		cout << '\n';
	}
}
