#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <numeric>
#include <iomanip>
#include <set>
#include <map>
#include <queue>
#include <cassert>

using namespace std;
#define int long long
#define ld long double
#define debug(x) cout << #x << " is " << x << '\n';

const int mod = 1e9 + 7;

int pow10(int x) {
	assert(x <= 19);
	if (x == 0) return 1;
	return 10 * pow10(x - 1);
}

int toInt(string s) {
	assert(s.size() <= 19);
	int res = 0;
	for (auto& x : s)
		res = res * 10 + (x - '0');
	return res;
}

string calc(string s, int y) {
	int n = s.size();
	string t = s;
	sort(t.begin(), t.end());
	int ans = toInt(s);
	string res = s;
	do {
		string curS = s;
		vector <bool> ban(n);
		bool bad = false;
		int cnt = 0;
		for (auto c = '9'; c >= '0'; --c) {
			vector <int> ids1, ids2;
			for (int i = 0; i < n; ++i) {
				if (curS[i] == c) ids1.push_back(i);
				if (t[i] == c) ids2.push_back(i);
			}
			for (int i = 0; i < ids1.size(); ++i) {
				if (ids1[i] < ids2[i]) bad = true;
				else {
					for (int j = ids1[i] - 1; j >= ids2[i]; --j)
						swap(curS[j], curS[j + 1]), cnt++;
				}
			}
		}
		if (bad) continue;
		if (toInt(t) - cnt * y >= ans) {
			ans = toInt(t) - cnt * y;
			res = t;
		}

	} while (next_permutation(t.begin(), t.end()));
	return res;
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout << fixed << setprecision(6);

	string s; cin >> s;
	int y; cin >> y;
	cout << calc(s, y) << '\n';
}