#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <numeric>
#include <iomanip>
#include <set>
#include <map>
#include <queue>
#include <cassert>

using namespace std;
#pragma GCC optimize("O3")
#define ld long double
#define debug(x) cout << #x << " is " << x << '\n';

const int mod = 1e9 + 7;

vector <vector <int>> g;
vector <vector <int>> c;
void dfs(int v, int col, int ban) {
	if (v == ban) return;
	c[ban][v] = col;
	for (auto& u : g[v]) {
		if (c[ban][u] == 0) dfs(u, col, ban);
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout << fixed << setprecision(6);

	int tt; cin >> tt;
	while (tt--) {
		int n, m; cin >> n >> m;
		g.assign(n + 1, {});
		c.assign(n + 1, vector <int>(n + 1, 0));
		for (int i = 0, u, v; i < m; ++i) {
			cin >> u >> v;
			g[u].push_back(v);
			g[v].push_back(u);
		}

		for (int i = 1; i <= n; ++i) {
			int curCol = 1;
			for (int j = 1; j <= n; ++j) {
				if (c[i][j] == 0) dfs(j, curCol++, i);
			}
		}

		vector <int> dp(n + 1, mod);
		dp[1] = 0;
		vector <bool> used(n + 1);
		for (int its = 0; its < n; ++its) {
			int v = -1;
			for (int i = 1; i <= n; ++i) {
				if (!used[i] and (v == -1 or dp[v] > dp[i]))
					v = i;
			}
			used[v] = true;
			for (auto& u : g[v]) {
				for (auto& x : g[u]) {
					if (used[x]) continue;
					if (c[u][v] != c[u][x]) continue;
					dp[x] = min(dp[x], dp[v] + 2);
				}
			}
		}
		for (int i = 2; i <= n; ++i) cout << (dp[i] == mod ? -1 : dp[i]) << ' ';
		cout << '\n';
	}

}