#include <bits/stdc++.h>

using namespace std;
using ll = long long;

void solve();

int main() {
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    int t = 1;
    cin >> t;
    do {
        solve();
    } while (--t);
    return 0;
}

struct edge {
    int u, v, i;

    edge(int u, int v, int i) : u(u), v(v), i(i) {}

    int get(int x) { return v + u - x; }

    edge() = default;
};

struct dsu {
    int n;
    vector<int> p, sz;

    explicit dsu(int n) : n(n), p(n), sz(n, 1) { iota(p.begin(), p.end(), 0); }

    int get(int x) { return x == p[x] ? x : p[x] = get(p[x]); }

    bool unite(int u, int v) {
        u = get(u), v = get(v);
        if (u == v) return false;
        if (sz[u] > sz[v]) swap(u, v);
        p[u] = v;
        sz[v] += sz[u];
        return true;
    }
};

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> g(n);
    vector<edge> es(2 * m);
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        es[2 * i] = edge(u, v, 2 * i);
        es[2 * i + 1] = edge(v, u, 2 * i + 1);
        g[u].emplace_back(2 * i);
        g[v].emplace_back(2 * i + 1);
    }
    dsu esu(2 * m);
    vector<int> depth(n), parentEdge(n, -1);
    vector<bool> used(n);
    auto init = [&](auto init, int cur, int prev) -> void {
        if (used[cur]) return;
        used[cur] = true;
        for (int e: g[cur]) {
            int next = es[e].get(cur);
            if (next == prev) {
                parentEdge[cur] = e;
            } else {
                if (!used[next]) {
                    depth[next] = depth[cur] + 1;
                    init(init, next, cur);
                }
            }
        }
    };
    init(init, 0, 0);
    vector<int> fup(n, n);
    vector<int> stack;
    fill(used.begin(), used.end(), false);
    auto dfs = [&](auto dfs, int cur) -> void {
        if (used[cur]) return;
        used[cur] = true;
        stack.push_back(cur);
        for (int e: g[cur]) {
            if (e == parentEdge[cur]) continue;
            int next = es[e].get(cur);
            if (depth[next] == depth[cur] + 1) {
                dfs(dfs, next);
                fup[cur] = min(fup[cur], fup[next]);
            } else if (depth[next] < depth[cur]) {
                fup[cur] = min(fup[cur], depth[next]);
            }
        }
        for (int e: g[cur]) {
            if (e == parentEdge[cur]) continue;
            int next = es[e].get(cur);
            if (depth[next] == depth[cur] + 1) {
                if (fup[next] < depth[cur]) {
                    esu.unite(parentEdge[cur], e);
                }
            } else if (depth[next] < depth[cur]) {
                esu.unite(e, parentEdge[cur]);
                int alpha = stack[depth[next] + 1];
                esu.unite(parentEdge[alpha] ^ 1, e ^ 1);
            }
        }
        stack.pop_back();
    };
    dfs(dfs, 0);
    vector<vector<pair<int, int>>> gr(2 * m + n);
    auto link = [&](int u, int v, int c) {
        gr[u].emplace_back(v, c);
        gr[v].emplace_back(u, c);
    };
    for (int j = 0; j < 2 * m; ++j) {
        link(j, esu.get(j), 0);
        link(j, 2 * m + es[j].v, 1);
    }
    vector<int> dist(gr.size(), 1e9);
    dist[2 * m] = 0;
    deque<int> bfs;
    bfs.emplace_back(2 * m);
    while (!bfs.empty()) {
        int cur = bfs.front();
        bfs.pop_front();
        for (auto[next, d]: gr[cur]) {
            if (d == 0 && dist[next] > dist[cur]) {
                dist[next] = dist[cur];
                bfs.push_front(next);
            } else if (d == 1 && dist[next] > dist[cur] + 1) {
                dist[next] = dist[cur] + 1;
                bfs.push_back(next);
            }
        }
    }
    for (int i = 1; i < n; ++i) cout << (dist[2 * m + i] != 1e9 ? dist[2 * m + i] : -1) << ' ';
    cout << '\n';
}