#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <deque>

using namespace std;

#define v vector
#define int long long
#define ll __int128
#define len(a) (int)a.size()
#define all(a) a.begin(), a.end()

const int INF = 1e17;

int n, m;
v<v<int>> g;
v<v<int>> color;

int c = 0;

void dfs(int i, int b) {
    color[b][i] = c;
    for (auto j : g[i]) {
        if (color[b][j] == -1 && j != b) {
            dfs(j, b);
        }
    }
}

v<v<int>> G;
v<int> d;

void bfs() {
    d.clear();
    d.resize(n, -1);
    d[0] = 0;
    v<int> used(n, 0);
    deque<int> q;
    q.push_back(0);
    used[0] = 1;
    while (len(q) > 0) {
        auto i = q.front();
        q.pop_front();
        for (auto j : G[i]) {
            if (!used[j]) {
                q.push_back(j);
                d[j] = d[i] + 1;
                used[j] = 1;
            }
        }
    }

    for (int i = 1; i < n; i++) {
        if (d[i] != -1) {
            cout << d[i] * 2 << " ";
        } else {
            cout << -1 << " ";
        }
    }
    cout << "\n";
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t; cin >> t;
    while (t--) {
        cin >> n >> m;
        g.clear();
        g.resize(n);
        for (int i = 0; i < m; i++) {
            int u, to; cin >> u >> to;
            u--; to--;
            g[u].push_back(to);
            g[to].push_back(u);
        }

        color.clear();
        color.resize(n, v<int> (n, -1));
        for (int i = 0; i < n; i++) {
            c = 0;
            for (int j = 0; j < n; j++) {
                if (color[i][j] == -1 && i != j) {
                    dfs(j, i);
                    c++;
                }
            }
        }

        G.clear();
        G.resize(n);
        for (int i = 0; i < n; i++) {
            for (auto x : g[i]) {
                for (auto y : g[i]) {
                    if (x == y) continue;

                    if (color[i][x] == color[i][y]) {
                        G[x].push_back(y);
                    }
                }
            }
        }

        bfs();
    }
    return 0;
}
