#pragma GCC optimize("Ofast,fast-math,unroll-loops")
#pragma GCC target("avx,avx2,sse,sse2,sse3,ssse3,sse4,abm,mmx,popcnt")

#include <bits/stdc++.h>
///*
const int MAX_MEM = 5e8;
char MEM[MAX_MEM];
int CUR_MEM = 0;
void* operator new(size_t x) {
    auto ret = MEM + CUR_MEM;
    CUR_MEM += x;
    return ret;
}
void operator delete(void*) {}
//*/

void solve() {
    int n, m;
    std::cin >> n >> m;
    std::vector<std::vector<int>> g(n);
    for (int i = 0; i < m; ++i) {
        int u, v;
        std::cin >> u >> v;
        --u, --v;
        g[u].emplace_back(v);
        g[v].emplace_back(u);
    }
    std::vector<int> is_ts(n, false);
    std::vector<int> used(n, false);
    /*
    auto dfs = [&](auto &&dfs, int ver) -> void {
        used[ver] = true;
        for (auto &to: g[ver]) {
            if (!used[to])
                dfs(dfs, to);
        }
    };
    for (int ts = 0; ts < n; ++ts) {
        used.assign(n, false);
        used[ts] = true;
        int start = !ts;
        dfs(dfs, start);
        if (std::count(used.begin(), used.end(), false)) {
            is_ts[ts] = true;
        }
    }
     */
    std::vector<int> tin(n), fup(n);
    used.assign(n, false);
    int cur_time = 0;
    auto dts = [&] (auto &&dts, int v, int p = -1, bool is_root = true) -> void {
        tin[v] = fup[v] = cur_time++;
        used[v] = true;
        int cnt_children = 0;
        for (auto &to : g[v]) {
            if (to == p)
                continue;
            if (!used[to]) {
                dts(dts, to, v, false);
                ++cnt_children;
                fup[v] = std::min(fup[v], fup[to]);
            } else {
                fup[v] = std::min(fup[v], tin[to]);
            }
            if (fup[to] >= tin[v] && !is_root) {
                is_ts[v] = true;
            }
        }
        if (is_root && cnt_children > 1) {
            is_ts[v] = true;
        }
    };
    dts(dts, 0);
//    used = is_ts;
    used.assign(n, 0);
    std::vector<std::vector<int>> ng(n);
    auto ggen = [&](auto &&ggen, int ver, int curc, int forb) -> void {
        if (ver == forb) {
            return;
        }
        used[ver] = curc;
        for (auto &to: g[ver]) {
            if (!used[to])
                ggen(ggen, to, curc, forb);
        }
    };
    std::vector<std::vector<int>> dg(2 * n);
    for (int v = 0; v < n; ++v) {
        if (is_ts[v]) {
            int cur_col = 1;
            used.assign(n, 0);
            int cursdg = dg.size();
            for (auto &to : g[v]) {
                if (!used[to])
                    ggen(ggen, to, cur_col++, v), dg.emplace_back();
            }
            for (auto &to : g[v]) {
                dg[2 * to].emplace_back(cursdg + used[to] - 1);
                dg[cursdg + used[to] - 1].emplace_back(2 * to);
            }
        }
    }
    for (int v = 0; v < n; ++v) {
        for (auto &to : g[v]) {
            if (!is_ts[to]) {
                dg[2 * v].emplace_back(2 * to + 1);
                dg[2 * to + 1].emplace_back(2 * v);
            }
        }
    }
    const int INF = 1e9;
    std::vector<int> dist(dg.size(), INF);
    std::queue<int> q;
    dist[0] = 0;
    q.emplace(0);
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (auto &to : dg[v]) {
            if (dist[to] > dist[v] + 1) {
                dist[to] = dist[v] + 1;
                q.emplace(to);
            }
        }
    }
    for (int v = 1; v < n; ++v) {
        std::cout << (dist[2 * v] == INF ? -1 : dist[2 * v]) << " ";
    }
    std::cout << "\n";
}

signed main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);
    int tests;
    std::cin >> tests;
    while (tests--) {
        solve();
    }
    return 0;
}
