#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <string>
#include <cassert>

using namespace std;

#define int long long
#define all(x) x.begin(), x.end()
#define sz(x) ((int)(x.size()))
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef pair<int, int> pi;
typedef vector<pi> vpi;

//const long long INFll = 1e18 + 3;

string solve1(string a, int y) {
	int n = sz(a);
	for (int i = 0; i < n; ++i) {
		int cbest = 0;
		int ibest = i;
		string anowans = a;
		int delta = 0;
		for (int j = i + 1; j < n; ++j) {
			string anow = a;
			char cc = a[j];
			anow.erase(anow.begin() + j);
			anow.insert(anow.begin() + i, cc);
			int c1 = stoll(anowans) - y * delta;
			int c2 = stoll(anow) - y * (j - i);
			if (c1 < c2 || (c1 == c2 && anow > anowans)) {
				anowans = anow;
				delta = j - i;
			}
		}
		a = anowans;
	}
	return a;
}

string solve2(string a, int y) {
	int n = sz(a);
	vector<pair<int, int>> b;
	string bs;
	int cnt = 0;
	vector<bool> res(n, false);
	for (int i = 0; i < n; ++i) {
		int ic = -1;
		int ib = -1;
		for (int j = 0; j < sz(a); ++j) {
			if (res[j]) continue;
			if ((a[j] - '0') > ic) {
				ic = a[j] - '0';
				ib = j;
			}
		}
		b.push_back(make_pair(ic, ib));
		bs += a[ib];
		res[ib] = true;
	}
	string ac = a;
	for (int i = 0; i < n; ++i) {
		int ic = -1;
		int ib = -1;
		for (int j = 0; j < sz(ac); ++j) {
			if ((ac[j] - '0') > ic) {
				ic = ac[j] - '0';
				ib = j;
			}
		}
		cnt += ib;
		ac.erase(ac.begin() + ib);
	}
	int cans = stoll(a);
	string sans = a;
	if (stoll(bs) - y * cnt > cans) {
		cans = stoll(bs) - y * cnt;
		sans = bs;
	}
	for (int i = n - 2; i >= 0; --i) {
		int pos = i;
		while (pos < n - 1 && b[pos].second > b[pos + 1].second) {
			swap(bs[pos], bs[pos + 1]);
			swap(b[pos], b[pos + 1]);
			--cnt;
			++pos;
			if (stoll(bs) - y * cnt > cans) {
				cans = stoll(bs) - y * cnt;
				sans = bs;
			}
		}
	}
	assert(cnt == 0);
	return sans;
}

string solve3(string a, int y) {
	int n = sz(a);
	string aans = a;
	int deltaans = 0;
	while (true) {
		string anowans = aans;
		int deltanow = deltaans;
		bool flag = false;
		for (int i = 0; i < n - 1; ++i) {
			string anow = aans;
			swap(anow[i], anow[i + 1]);
			int c1 = stoll(anowans) - y * deltanow;
			int c2 = stoll(anow) - y * (deltaans + 1);
			if (c1 < c2 || (c1 == c2 && anow > anowans)) {
				anowans = anow;
				deltanow = deltaans + 1;
				flag = true;
			}
		}
		if (flag) {
			aans = anowans;
			assert(deltanow == deltaans + 1);
			deltaans++;
		}
		else {
			break;
		}
	}
	return aans;
}

pair<string, int> solve4(string a, int y) {
	if (a.empty()) return make_pair(string(), 0);
	pair<string, int> ans = make_pair("0", 100);
	for (int i = 0; i < sz(a); ++i) {
		char cc = a[i];
		string a2 = a;
		a2.erase(a2.begin() + i);
		pair<string, int> now = solve4(a2, y);
		now.first.insert(now.first.begin(), cc);
		now.second += i;
		int c1 = stoll(ans.first) - ans.second * y;
		int c2 = stoll(now.first) - now.second * y;
		if (c2 > c1 || (c2 == c1 && now.first > ans.first)) {
			ans = now;
		}
	}
	return ans;
}

signed main() {
	srand(39);
	/*while (true) {
		int ai = rand();
		string a = to_string(ai);
		int k = rand();
		if (solve1(a, k) != solve4(a, k).first) {
			cout << "\n!!!!\n";
			cout << a << "\n" << k % 100 * 100 << "\n";
			cout << solve1(a, k) << "\n" << solve4(a, k).first;
			exit(3);
		}
		cout << "?";
	}*/
	string a;
	int y;
	cin >> a >> y;
	vector<bool> res(sz(a), false);
	vector<int> id[10];
	for (int i = 0; i < sz(a); ++i) {
		id[a[i] - '0'].push_back(i);
	}
	for (int i = 0; i < 10; ++i) {
		reverse(all(id[i]));
	}
	int cnt = 0;
	int pos = 9;
	string ans;
	while (sz(a) - cnt > 12) {
		while (id[pos].empty()) --pos;
		ans.push_back('0' + pos);
		++cnt;
		res[id[pos].back()] = true;
		id[pos].pop_back();
	}
	string b;
	for (int i = 0; i < sz(a); ++i) {
		if (!res[i]) {
			b += a[i];
		}
	}
	cout << solve4(b, y).first;
}