#include <iostream>
#include <string>
#include <algorithm>
#include <vector>
#include <map>
#include <tuple>
#include <numeric>
#include <queue>

using namespace std;

using ll = long long;
template <typename T>
using v = vector<T>;

template <typename T>
istream& operator>> (istream& in, v<T>& a) {
	for (T& x : a) {
		in >> x;
	}
	return in;
}

ll n, m;
v<v<ll>> graph;
v<v<ll>> comps;

void dfs(ll vert, ll b, ll c) {
	if (vert != b && comps[b][vert] == -1) {
		comps[b][vert] = c;
		for (ll overt : graph[vert]) {
			dfs(overt, b, c);
		}
	}
}

void solve() {
	cin >> n >> m;
	graph = v<v<ll>>(n);
	for (ll i = 0; i < m; ++i) {
		ll ui, vi;
		cin >> ui >> vi;
		--ui;
		--vi;
		graph[ui].push_back(vi);
		graph[vi].push_back(ui);
	}
	comps = v<v<ll>>(n, v<ll>(n, -1));
	v<ll> comp_cnt(n);
	for (ll b = 0; b < n; ++b) {
		ll cc = 0;
		for (ll i = 0; i < n; ++i) {
			if (i != b && comps[b][i] == -1) {
				dfs(i, b, cc++);
			}
		}
		comp_cnt[b] = cc;
	}
	v<v<ll>> midist(n);
	for (ll i = 0; i < n; ++i) {
		midist[i] = v<ll>(comp_cnt[i] + 1, -1);
	}
	queue<tuple<ll, ll, ll>> q;
	q.push({ 0, comp_cnt[0], 0 });
	while (!q.empty()) {
		auto [vert, comp, dist] = q.front();
		q.pop();
		if (midist[vert][comp] == -1) {
			midist[vert][comp] = dist;
			for (ll overt : graph[vert]) {
				if (comp == comp_cnt[vert]) {
					q.push({ overt, comps[overt][vert], dist + 1 });
				}
				else if (comp == comps[vert][overt]) {
					q.push({ overt, comp_cnt[overt], dist + 1 });
				}
			}
		}
	}
	for (ll i = 1; i < n; ++i) {
		cout << midist[i][comp_cnt[i]] << ' ';
	}
	cout << '\n';
}

int main() {
	ll t;
	cin >> t;
	for (ll i = 0; i < t; ++i) {
		solve();
	}
}